#include <bits/stdc++.h>
using namespace std;

#define F first
#define S second

using ll = long long;
using pii = pair <int, int>;

const int oo = 1e9 + 4;
const int SZ = 2e5 + 4;

int n, m, p;
vector <pii> a, b;
vector <int> cs;
vector <pair <pii, int> > r;

void read() {
    cin >> n >> m >> p;
    vector <pii> cc;
    cc.resize(n);
    for (auto &t : cc) cin >> t.F >> t.S;
    sort(cc.begin(), cc.end(), [] (auto q ,auto w) { return (q.F == w.F ? q.S < w.S : q.F > w.F); });
    a.push_back(cc[0]);
    for (int i = 1; i < n; i++) {
        if (cc[i].S < a.back().S) a.push_back(cc[i]);
    }
    reverse(a.begin(), a.end());
    for (auto t : a) cout << t.F << "," << t.S << ' '; cout << endl;

    cc.resize(m);
    for (auto &t : cc) cin >> t.F >> t.S;
    sort(cc.begin(), cc.end(), [] (auto q ,auto w) { return (q.F == w.F ? q.S < w.S : q.F > w.F); });
    b.push_back(cc[0]);
    for (int i = 1; i < m; i++) {
        if (cc[i].S < b.back().S) b.push_back(cc[i]);
    }
    reverse(b.begin(), b.end());
   // for (auto t : b) cout << t.F << "," << t.S << ' '; cout << endl;
    cs.resize(p);

    for (int i = 0; i < p; i++) {
        int x, y;
        cin >> y >> x >> cs[i];
        x++, y++;
        if (x > b.back().F || y > a.back().F) continue;
        x = lower_bound(b.begin(), b.end(), make_pair(x, -oo))-b.begin();
        y = lower_bound(a.begin(), a.end(), make_pair(y, -oo))-a.begin();
      //  cout << x << ' ' << y << endl;
        r.push_back({{x,y}, i});
    }

}

struct st {
    int n, K;
    vector <ll> mx, nx;

    st(vector <pii> a) {
        n = a.size();
        K = 1;
        while (K < n) K *= 2;
        mx.resize(2 * K, -1ll * oo * oo);
        nx.resize(2 * K, 0);
        for (int i = 0; i < a.size(); i++)
            mx[i + K] = -a[i].S;
        for (int i = K - 1; i > 0; i--)
            mx[i] = max(mx[2 * i], mx[2 * i + 1]);

    //    for (auto t : mx) cout << t << ' ';cout << endl;
    }

    void U(int v) {
        mx[v] += nx[v];
        if (v < K) {
            nx[2 * v] += nx[v];
            nx[2 * v + 1] += nx[v];
        }
        nx[v] = 0;
    }

    void upd(ll val, int l, int r, int v = 1, int ll = 0, int rr = -1) {
        if (rr < 0) rr = K - 1;
        U(v);
        if (r < l || rr < l || r < ll) return;
        if (l <= ll && rr <= r) {
            nx[v] += val;
            U(v);
            return;
        }

        int m = (ll + rr) / 2;
        upd(val, l, r, 2*v, ll, m);
        upd(val, l, r, 2 * v + 1, m + 1, rr);
        mx[v] = max(mx[2 * v], mx[2 * v + 1]);
    }

    void add(int v, int val) {
        upd(val, v, n - 1);

        //for (auto t : mx) cout << t << ' '; cout << endl;
    }

    ll get_max(int l = 0, int r = oo, int v = 1, int ll = 0, int rr = -1) {
        if (rr < 0) rr = K - 1;
        U(v);
        if (r < l || rr < l || r < ll) return -1ll * oo * oo;
        if (l <= ll && rr <= r) return mx[v];

        int m = (ll + rr) / 2;
        return max(get_max(l, r, 2*v, ll, m), get_max(l, r, 2 * v + 1, m + 1, rr));
    }
};

void solve() {
    st d(a);
    ll ans = d.get_max();
   // cout << ans << endl;
    sort(r.begin(), r.end());

    for (auto t : r) {
        d.add(t.F.S, cs[t.S]);
        ans = max(ans, d.get_max() - b[t.F.F].S);
    }
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

  //  freopen("in.txt", "r", stdin);

    read();
    solve();
}
