#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <numeric>
#include <climits>
#include <random>
#include <chrono>
#include <cstring>
#include <cassert>
#include <ctime>
#include <string>
#include <deque>
#include <memory>
#include <tuple>
#include <bitset>
//#define int long long

using namespace std;
#define sz(x) int(x.size())
typedef long long ll;
typedef pair < int, int > pii;
typedef pair < ll, ll > pll;
const int inf = INT_MAX / 2;
const ll INF = LLONG_MAX / 3;
const int MOD = 1e9 + 7;
const int N = 1e2 + 7;

int dp[N][N][27][27];
int n;

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cout << fixed << setprecision(9);
    ios::sync_with_stdio(false), cin.tie(0), cout.tie(0);

    string s;
    cin >> n >> s;

    for (int l = 0; l < N; l++) {
        for (int r = 0; r < N; r++) {
            for (int i = 0; i < 26; i++) {
                for (int j = 0; j < 26; j++) {
                    if (s[l] - 'a' == i && s[r] - 'a' == j) {
                        dp[l][r][i][j] = r - l + 1;
                    }
                    else {
                        dp[l][r][i][j] = inf;
                    }
                }
            }
        }
    }

    for (int len = 1; len <= n; len++) {
        for (int l = 0; l + len - 1 < n; l++) {
            int r = l + len - 1;

            for (int i = 0; i < 26; i++) {
                for (int j = 0; j < 26; j++) {

                    //cout << l << " " << r << " " << i << " " << j << endl;

                    if (l - 1 >= 0 && s[l - 1] - 'a' == i - 1) {
                        if (dp[l][r][i][j] == 1) {
                            dp[l - 1][r][i - 1][i - 1] = min(dp[l - 1][r][i - 1][i - 1], dp[l][r][i][j]);
                        }
                        else {
                            dp[l - 1][r][i - 1][j] = min(dp[l - 1][r][i - 1][j], dp[l][r][i][j]);
                        }
                    }
                    
                    if (l - 1 >= 0 && s[l - 1] - 'a' == i + 1) {
                        if (dp[l][r][i][j] == 1) {
                            dp[l - 1][r][j][j] = min(dp[l - 1][r][j][j], dp[l][r][i][j]);
                        }
                        else {
                            dp[l - 1][r][i][j] = min(dp[l - 1][r][i][j], dp[l][r][i][j]);
                        }
                    }
                    if (r + 1 < n && s[r + 1] - 'a' == j - 1) {
                        if (dp[l][r][i][j] == 1) {
                            dp[l][r + 1][j - 1][j - 1] = min(dp[l][r + 1][j - 1][j - 1], dp[l][r][i][j]);
                        }
                        else {
                            dp[l][r + 1][i][j - 1] = min(dp[l][r + 1][i][j - 1], dp[l][r][i][j]);
                        }
                    }
                    
                    if (r + 1 < n && s[r + 1] - 'a' == j + 1) {
                        if (dp[l][r][i][j] == 1) {
                            dp[l][r + 1][i][i] = min(dp[l][r + 1][i][i], dp[l][r][i][j]);
                        }
                        else {
                            dp[l][r + 1][i][j] = min(dp[l][r + 1][i][j], dp[l][r][i][j]);
                        }
                    }
                }
            }
        }
        //return 0;
    }

    //cout << dp[0][2][1][1] << endl;

    int ans = inf;
    for (int i = 0; i < 26; i++) {
        for (int j = 0; j < 26; j++) {
            ans = min(ans, dp[0][n - 1][i][j]);

            //cout << i << " " << j << " " << dp[0][n - 1][i][j] << endl;
        }
    }


    cout << n - ans;

    return 0;
}