#include <iostream>
#include <fstream>
#include <iomanip>
#include <algorithm>
#include <cstdlib>
#include <cmath>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <vector>
#include <queue>
#include <stack>
#include <cstring>
#include <random>
#include <ctime>
#include <fstream>
#include <sstream>
using namespace std;
#define ld long double
#define ll long long
#define ull unsigned long long
#define all(x) x.begin(),x.end()
#define pii pair<int,int>
#define pll pair<ll,ll>
#define fast_io cout.tie(0),cin.tie(0),ios_base::sync_with_stdio(0)
ld eps = 1.0 / 1e15;
ll mod1 = 1e9 + 7, inf = 1e18;
ll gcd(ll a, ll b) { return b % a ? gcd(b % a, a) : a; }
ll sqr(ll a) { return a * a; }
ll binpow(ll a, ll b, ll mod)
{
    if (!b) return 1;
    return b > 1 ? ( b % 2 ? (a * (sqr(binpow(a, b / 2, mod) % mod))) % mod : sqr(binpow(a, b / 2, mod)) % mod) : a;
}
pll a[200001], b[200001];
struct str { ll x, y, z; };
str c[200001];
ll ST[4000004], d[1000004];
bool cmp(str a, str b) { return a.x != b.x ? a.x < b.x : a.y < b.y; }
void push(ll v)
{
    ll mx = max(ST[2 * v], ST[2 * v + 1]);
    if (ST[v] > mx)
    {
        ST[2 * v] += ST[v] - mx;
        ST[2 * v + 1] += ST[v] - mx;
    }
}
void build(ll l, ll r, ll v)
{
    if (l == r)
    {
        ST[v] = d[l];
        return;
    }
    ll m = (l + r) / 2;
    build(l, m, 2 * v);
    build(m + 1, r, 2 * v + 1);
}
void update(ll l, ll r, ll v, ll tl, ll tr, ll prb)
{
    if (tl > tr || l > r) return;
    if (l == tl && r == tr)
    {
        ST[v] += prb;
        return;
    }
    push(v);
    ll m = (l + r) / 2;
    if (tl > m) update(m + 1, r, 2 * v + 1, tl, tr, prb);
    else if (tr <= m) update(l, m, 2 * v, tl, tr, prb);
    else
    {
        update(l, m, 2 * v, tl, m, prb);
        update(m + 1, r, 2 * v + 1, m + 1, tr, prb);
    }
    ST[v] = max(ST[2 * v], ST[2 * v + 1]);
}

int main()
{
    fast_io;
    ll n, m, p, i, lm = 1, kr = 0, mx = 0, ans = 0, zp, tm;
    cin >> n >> m >> p;
    for (i = 1; i <= n; i++) cin >> a[i].first >> a[i].second;
    for (i = 1; i <= m; i++)
    {
        cin >> b[i].first >> b[i].second;
        if (!d[b[i].first]) d[b[i].first] = b[i].second;
        else d[b[i].first] = min(d[b[i].first], b[i].second);
        kr = max(kr, b[i].first);
    }
    for (i = 1; i <= p; i++) cin >> c[i].x >> c[i].y >> c[i].z;
    sort(a + 1, a + n + 1);
    sort(b + 1, b + m + 1);
    d[kr] = -d[kr], zp = -d[kr];
    for (i = kr - 1; i >= 1; i--)
    {
        if (!zp)
        {
            zp = d[i];
            d[i] = d[i + 1];
        }
        else
        {
            tm = zp;
            zp = d[i];
            d[i] = max(d[i + 1], -tm);
        }
    }
    sort(c + 1, c + p + 1, cmp);
    build(1, kr, 1);
    for (i = 1; i <= n; i++)
    {
        while (lm <= p && c[lm].x < a[i].first)
        {
            update(1, kr, 1, c[lm].y + 1, kr, c[lm].z);
            lm++;
        }
        mx = ST[1];
        ans = max(ans, mx - a[i].second);
    }
    cout << ans;
    return 0;
}