#include<bits/stdc++.h>
using namespace std;
#define ii pair <int, int>
#define app push_back
#define f first
#define s second
#define bp __builtin_popcount
#define all(a) a.begin(),a.end()
#define ll long long
#define mp make_pair
const int N = 5e5+7, LG = 20, K = 500;
//K!

int n;
vector <int> g[N];

int ans[N], dist[N];
queue <int> q[N];
void bfs(vector <int> &v, vector <int> &s) {
    for (int i = 1; i <= n; ++i)
        dist[i] = N;
    int k = v.size();
    set <int> t;
    for (int i = 0; i < k; ++i)
        t.insert(i);
    for (int i = 0; i < k; ++i) {
        q[i].push(v[i]);
        ans[v[i]] = i;
        dist[v[i]] = 0;
    }            
    for (int it = 1; t.size(); ++it) {
        vector <int> lv;
        for (int c : t) {
            while (q[c].size()) {
                int u = q[c].front(); 
                if (dist[u] == it * s[c])
                    break;
                q[c].pop();
                for (int v : g[u])
                    if (dist[v] == N) {
                        ans[v] = c;
                        dist[v] = dist[u] + 1;
                        q[c].push(v);
                    }   
            }   
            if (q[c].size())
                lv.app(c);
        }
        t.clear();
        for (int e : lv)
            t.insert(e);   
    }       
}   

vector <int> eu;
int l[N], r[N], h[N], ptr = 0;
void dfs(int u, int p) {
    l[u] = eu.size();
    eu.app(u);
    for (int v : g[u])
        if (v != p) {
            h[v] = h[u] + 1;
            dfs(v, u);
            eu.app(u);
        }
    r[u] = eu.size();
}
int sp[LG][N], pw[N];

int lca(int u, int v) {
    int tl = l[u], tr = l[v];
    if (tr < tl)
        swap(tl, tr);
    int p = pw[tr - tl + 1];
    return eu[min(sp[p][tl], sp[p][tr - (1 << p) + 1])];
}   
int getr(int u, int v) {
    return h[u] + h[v] - 2 * h[lca(u, v)];
}   

bool comp(int u, int v) {
    return l[u] < l[v];
}
int par[N];

bool virus[N];
vector <int> mem[N];
int num[N];

void upd(ii &ans, int i, int w, vector <int> &v, vector <int> &s) {
    if (v[i] == w) {
        ans = mp(0, i);
        return;
    }   
    int d = getr(w, v[i]);
    int t = (d + s[i] - 1) / s[i];
    ans = min(ans, mp(t, i));
}   

bool anc(int u, int v) {
    return l[u] <= l[v] && r[v] <= r[u];
}   
int getr(int u, int v, int d) {
    int t = getr(u, v);
    if (t == 0)
        return 0;
    else
        return (t + d - 1) / d;
}   

void solve() {
    int k, m;
    cin >> k >> m;
    vector <int> v(k), s(k);
    for (int i = 0; i < k; ++i)
        cin >> v[i] >> s[i];
    vector <int> u(m);
    for (int i = 0; i < m; ++i)
        cin >> u[i];

    if (v.size() > K) {
        bfs(v, s);
        for (int e : u)
            cout << ans[e] + 1 << ' ';
        cout << endl;
        return;
    }
    
    for (int i = 0; i  < v.size(); ++i)
        num[v[i]] = i;
    for (int e : u)
        virus[e] = 0;
    for (int e : v)
        virus[e] = 1;
    mem[0].clear();
    for (int e : v)
        mem[e].clear();

    vector <int> a;
    for (int e : v)
        a.app(e);
    for (int e : u)
        a.app(e);
    sort(all(a));
    a.resize(unique(all(a)) - a.begin());
    sort(all(a), comp);

    {
    vector <int> s;
    for (int e : a) {
        while (s.size() && r[s.back()] < l[e])
            s.pop_back();
        if (s.size())
            par[e] = s.back();
        else
            par[e] = 0;
        s.app(e);
    }
    }   

    for (int e : a) {
        if (virus[e]) {
            mem[par[par[e]]].app(e);
            par[e] = e;
        }
        else {
            par[e] = par[par[e]];                
        }
    }   

    for (int e : u) {   
        int ans = 0;
        for (int c = 0; c < k; ++c) {
            int l = lca(e, v[c]) ^ lca(e, v[ans]) ^ lca(v[ans], v[c]);
            if (getr(v[c], l, s[c]) < getr(v[ans], l, s[ans])) 
                ans = c;
        }   
        cout << ans + 1 << ' ';
    }
    cout << endl;

}   

signed main() {
    #ifdef HOME
    freopen("input.txt", "r", stdin);
    #else
    #define endl '\n'
    ios_base::sync_with_stdio(0); cin.tie(0);
    #endif

    int cur = 0;
    for (int i = 1; i < N; ++i) {
        while ((1 << (cur + 1)) < i)
            ++cur;
        pw[i] = cur;
    }   

    cin >> n;
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        g[u].app(v); g[v].app(u);
    }   
    dfs(1, 1);

    for (int i = 1; i <= n; ++i)    
        sort(all(g[i]), comp);

    for (int i = 0; i < eu.size(); ++i)
        sp[0][i] = l[eu[i]];
    for (int p = 1; p < LG; ++p)
        for (int i = 0; i + (1 << p) - 1 < eu.size(); ++i)
            sp[p][i] = min(sp[p - 1][i], sp[p - 1][i + (1 << (p - 1))]);

    int q;
    cin >> q;
    while (q--) 
        solve();
}   