#include <bits/stdc++.h>

using namespace std;

typedef long long int lo;
typedef pair<lo,lo> PII;
typedef pair<lo,PII> PIII;

#define FOR for(int i=1;i<=n;i++)
#define mp make_pair
#define pb push_back
#define fi first
#define int long long
#define fio() ios_base::sync_with_stdio(false);
#define se second
#define mid ((start+end)/2)
#define ort ((bas+son)/2)

const int li = 1000005;
const lo inf = 10000000000;

PIII p[li];
int n,m,a[li],b[li],k,flag,cev,tree[li*4],lazy[li*4],tree1[li*4],lazy1[li*4];

inline void build(int node,int start,int end){
	lazy[node]=inf;
	tree[node]=inf;
	if(start>=end)return ;
	build(node*2,start,mid),build(node*2+1,mid+1,end);
}

inline void push(int node,int start,int end){
	if(lazy[node]==inf)return ;
	//~ cout<<tree[node]<<" () "<<lazy[node]<<" () "<<start<<" () "<<end<<endl;
	tree[node]=min(tree[node],lazy[node]);
	//~ cout<<tree[node]<<" () "<<lazy[node]<<endl;
	if(start!=end){
		lazy[node*2]=min(lazy[node*2],lazy[node]);
		lazy[node*2+1]=min(lazy[node*2+1],lazy[node]);
	}
	lazy[node]=inf;
}

inline void update(int node,int start,int end,int l,int r,int val){
	push(node,start,end);
	if(start>end || start>r || end<l)return ;
	if(start>=l && end<=r){
		lazy[node]=min(lazy[node],val);
		push(node,start,end);
		return ;
	}
	update(node*2,start,mid,l,r,val),update(node*2+1,mid+1,end,l,r,val);
	tree[node]=min(tree[node*2],tree[node*2+1]);
}

inline int query(int node,int start,int end,int l,int r){
	if(start>end || start>r || end<l)return inf+1;
	push(node,start,end);
	if(start>=l && end<=r)return tree[node];
	return min(query(node*2,start,mid,l,r),query(node*2+1,mid+1,end,l,r));
}

////////////////////////////////////////////////////////////////////////

inline void build1(int node,int start,int end){
	lazy1[node]=inf;
	tree1[node]=inf;
	if(start>=end)return ;
	build1(node*2,start,mid),build1(node*2+1,mid+1,end);
}

inline void push1(int node,int start,int end){
	if(lazy1[node]==inf)return ;
	tree1[node]=min(tree1[node],lazy1[node]);
	if(start!=end){
		lazy1[node*2]=min(lazy1[node*2],lazy1[node]);
		lazy1[node*2+1]=min(lazy1[node*2+1],lazy1[node]);
	}
	lazy1[node]=inf;
}

inline void update1(int node,int start,int end,int l,int r,int val){
	push1(node,start,end);
	if(start>end || start>r || end<l)return ;
	if(start>=l && end<=r){
		lazy1[node]=min(lazy1[node],val);
		push1(node,start,end);
		return ;
	}
	update1(node*2,start,mid,l,r,val),update1(node*2+1,mid+1,end,l,r,val);
	tree1[node]=min(tree1[node*2],tree1[node*2+1]);
}

inline int query1(int node,int start,int end,int l,int r){
	if(start>end || start>r || end<l)return inf+1;
	push1(node,start,end);
	if(start>=l && end<=r)return tree1[node];
	return min(query1(node*2,start,mid,l,r),query1(node*2+1,mid+1,end,l,r));
}

main(){
	scanf("%lld %lld %lld",&n,&m,&k);
	build(1,1,1000000);
	build1(1,1,1000000);
	FOR{
		int x,y;
		scanf("%lld %lld",&x,&y);
		update(1,1,1000000,1,x-1,y);
	}
	//~ cout<<query(1,1,1000000,1,1)<<"bir\n";
	//~ cout<<query(1,1,1000000,2,2)<<"iki\n";
	//~ cout<<query(1,1,1000000,3,3)<<"uc\n";
	//~ cout<<query(1,1,1000000,4,4)<<"dort\n";
	//~ cout<<query(1,1,1000000,5,5)<<"bes\n";
	for(int i=1;i<=m;i++){
		int x,y;
		scanf("%lld %lld",&x,&y);
		update1(1,1,1000000,1,x-1,y);
	}
	int topl=0;
	int xx=0,yy=0;
	for(int i=1;i<=k;i++){
		//~ int x,y,z;
		scanf("%lld %lld %lld",&p[i].fi,&p[i].se.fi,&p[i].se.se);
		int x=p[i].fi;
		int y=p[i].se.fi;
		int z=p[i].se.se;
		topl+=z;
		xx=max(xx,x);
		yy=max(yy,y);
		int bir=query(1,1,1000000,xx,xx);
		int iki=query1(1,1,1000000,yy,yy);
		if(bir!=inf && iki!=inf){
			cev=max(cev,topl-bir-iki);
		}
	}
	sort(p+1,p+k+1);
	//~ int topl=0;
	topl=0;
	xx=0;
	yy=0;
	for(int i=1;i<=k;i++){
		//~ int x,y,z;
		//~ scanf("%lld %lld %lld",&p[i].fi,&p[i].se.fi,&p[i].se.se);
		int x=p[i].fi;
		int y=p[i].se.fi;
		int z=p[i].se.se;
		topl+=z;
		xx=max(xx,x);
		yy=max(yy,y);
		int bir=query(1,1,1000000,xx,xx);
		int iki=query1(1,1,1000000,yy,yy);
		if(bir!=inf && iki!=inf){
			cev=max(cev,topl-bir-iki);
		}
	}
	for(int i=1;i<=k;i++) swap(p[i].fi,p[i].se.fi);
	sort(p+1,p+k+1);
	//~ int topl=0;
	//~ cout<<cev<<endl;
	topl=0;
	xx=0;
	yy=0;
	for(int i=1;i<=k;i++){
		//~ int x,y,z;
		//~ scanf("%lld %lld %lld",&p[i].fi,&p[i].se.fi,&p[i].se.se);
		int y=p[i].fi;
		int x=p[i].se.fi;
		int z=p[i].se.se;
		topl+=z;
		xx=max(xx,x);
		yy=max(yy,y);
		int bir=query(1,1,1000000,xx,xx);
		int iki=query1(1,1,1000000,yy,yy);
		//~ cout<<bir<<" : : "<<iki<<endl;
		if(bir!=inf && iki!=inf){
			cev=max(cev,topl-bir-iki);
		}
	}
	////////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////////
	for(int i=1;i<=k;i++) swap(p[i].fi,p[i].se.se);
	sort(p+1,p+k+1);
	//~ int topl=0;
	//~ cout<<cev<<endl;
	topl=0;
	xx=0;
	yy=0;
	for(int i=1;i<=k;i++){
		//~ int x,y,z;
		//~ scanf("%lld %lld %lld",&p[i].fi,&p[i].se.fi,&p[i].se.se);
		int y=p[i].fi;
		int x=p[i].se.fi;
		int z=p[i].se.se;
		topl+=z;
		xx=max(xx,x);
		yy=max(yy,y);
		int bir=query(1,1,1000000,xx,xx);
		int iki=query1(1,1,1000000,yy,yy);
		//~ cout<<bir<<" : : "<<iki<<endl;
		if(bir!=inf && iki!=inf){
			cev=max(cev,topl-bir-iki);
		}
	}
	////////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////////
	//~ for(int i=1;i<=k;i++) swap(p[i].fi,p[i].se.se);
	sort(p+1,p+k+1);
	reverse(p+1,p+k+1);
	//~ int topl=0;
	//~ cout<<cev<<endl;
	topl=0;
	xx=0;
	yy=0;
	for(int i=1;i<=k;i++){
		//~ int x,y,z;
		//~ scanf("%lld %lld %lld",&p[i].fi,&p[i].se.fi,&p[i].se.se);
		int y=p[i].fi;
		int x=p[i].se.fi;
		int z=p[i].se.se;
		topl+=z;
		xx=max(xx,x);
		yy=max(yy,y);
		int bir=query(1,1,1000000,xx,xx);
		int iki=query1(1,1,1000000,yy,yy);
		//~ cout<<bir<<" : : "<<iki<<endl;
		if(bir!=inf && iki!=inf){
			cev=max(cev,topl-bir-iki);
		}
	}
	////////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////////
	for(int i=1;i<=k;i++) swap(p[i].se.fi,p[i].se.se);
	sort(p+1,p+k+1);
	//~ int topl=0;
	//~ cout<<cev<<endl;
	topl=0;
	xx=0;
	yy=0;
	for(int i=1;i<=k;i++){
		//~ int x,y,z;
		//~ scanf("%lld %lld %lld",&p[i].fi,&p[i].se.fi,&p[i].se.se);
		int y=p[i].fi;
		int x=p[i].se.fi;
		int z=p[i].se.se;
		topl+=z;
		xx=max(xx,x);
		yy=max(yy,y);
		int bir=query(1,1,1000000,xx,xx);
		int iki=query1(1,1,1000000,yy,yy);
		//~ cout<<bir<<" : : "<<iki<<endl;
		if(bir!=inf && iki!=inf){
			cev=max(cev,topl-bir-iki);
		}
	}
	////////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////////
	//~ for(int i=1;i<=k;i++) swap(p[i].se.fi,p[i].se.se);
	sort(p+1,p+k+1);
	reverse(p+1,p+k+1);
	//~ int topl=0;
	//~ cout<<cev<<endl;
	topl=0;
	xx=0;
	yy=0;
	for(int i=1;i<=k;i++){
		//~ int x,y,z;
		//~ scanf("%lld %lld %lld",&p[i].fi,&p[i].se.fi,&p[i].se.se);
		int y=p[i].fi;
		int x=p[i].se.fi;
		int z=p[i].se.se;
		topl+=z;
		xx=max(xx,x);
		yy=max(yy,y);
		int bir=query(1,1,1000000,xx,xx);
		int iki=query1(1,1,1000000,yy,yy);
		//~ cout<<bir<<" : : "<<iki<<endl;
		if(bir!=inf && iki!=inf){
			cev=max(cev,topl-bir-iki);
		}
	}
	printf("%lld\n",cev);
	return 0;
}
