#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <unordered_map>
#include <queue>

#define int long long

using namespace std;

int32_t main() {
#ifdef local
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    int n, m;
    cin >> n >> m;
    vector<vector<int>> g(n), gn(n);
    for (int i = 0; i < m; i++) {
        int x, y;
        cin >> x >> y;
        g[y - 1].push_back(x - 1);
        gn[x - 1].push_back(y - 1);
    }
    int k;
    cin >> k;
    vector<int> p(k);
    for (int i = 0; i < k; i++) {
        cin >> p[i];
        p[i]--;
    }
    vector<int> used(n), d(n, 1e9);
    queue<int> q;
    q.push(p.back());
    used[p.back()] = 1;
    d[p.back()] = 0;
    while (!q.empty()) {
        int v0 = q.front();
        q.pop();
        for (int to : g[v0]) {
            if (!used[to]) {
                q.push(to);
                d[to] = d[v0] + 1;
                used[to] = 1;
            }
        }
    }
    int mn = 0;
    for (int i = 0; i + 1 < k; i++) {
        if (d[p[i]] != d[p[i + 1]] + 1) {
            mn++;
        }
    }
    cout << mn;
    vector<pair<int, int>> df;
    for (int i = 0; i < n; i++) df.push_back({d[i], i});
    sort(df.begin(), df.end());
    vector<int> u(n);
    u[df[0].second] = 1;
    int INF = 1e9;
    for (auto v : df) {
        for (int to : gn[v.second]) {
            if (d[to] + 1 == d[v.second])
                u[v.second] = min(INF, u[v.second] + u[to]);
        }
    }
    int co = 1;
    int mx = k - 1;
    for (int i = 0; i + 1 <  k; i++) {
            if (u[p[i]] == 1 && u[p[i + 1]] == 1 && d[p[i]] - 1 == d[p[i + 1]]) {
                mx--;
            }
    }
    cout << " " << mx;
    return 0;
}
