#include <bits/stdc++.h>

#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/detail/standard_policies.hpp>
#include<ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template < typename T >
using ordered_set = tree<T, null_type, less < T > , rb_tree_tag, tree_order_statistics_node_update>;

#define F first
#define S second
#define ll long long
#define endl '\n'
#define ld long double
#define pii pair < int, int >
#define ull unsigned long long
#define pb push_back

map < int, set < int > > mp;

int32_t main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else

#endif
    int n;
    cin >> n;
    vector < pair < int, int >  > a(n);
    for (int i = 0;i < n; ++i){
        cin >> a[i].F;
        a[i].S = i;
        mp[a[i].F].insert(a[i].S);
    }
    sort(a.begin(), a.end());
    vector < ll > dp(n, -1);
    ll mx = 0;
    int pred = -1;
    for (int i = 0;i < n; ++i){
        dp[a[i].S] = a[i].F;
        if (pred == -1)pred = a[i].F - 1;
        else if (a[i - 1].F != a[i].F)pred = a[i - 1].F;
        if (i && mp[pred].count(-(a[i].F - pred- a[i].S)))dp[a[i].S] += dp[-(a[i].F - pred - a[i].S)];
        mx = max(mx, dp[a[i].S]);
    }
    cout << mx << endl;
    return 0;
}
