#include <bits/stdc++.h>

#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/detail/standard_policies.hpp>
#include<ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template < typename T >
using ordered_set = tree<T, null_type, less < T > , rb_tree_tag, tree_order_statistics_node_update>;

#define F first
#define S second
#define ll long long
#define endl '\n'
#define ld long double
#define pii pair < int, int >
#define ull unsigned long long
#define pb push_back

int n, m;
int k;


vector < int > p;

vector < int > dist;

vector < vector < int > > G;
vector < vector < int > > G1;

void go(){
    for (int i = 0;i < n; ++i)dist[i] = 1e9;
    dist[p[k - 1] - 1] = 0;
    priority_queue < pii > q;
    q.push({0, p[k - 1] - 1});
    while(!q.empty()){
        int v = q.top().S;
        int d = -q.top().F;
        q.pop();
        if (dist[v] < d)continue;
        for (auto to : G1[v]){
            if (dist[to] > dist[v] + 1)dist[to] = dist[v] + 1, q.push({-dist[to], to});
        }
    }
}




int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else

#endif
    cin >> n >> m;
    G.resize(n);
    G1.resize(n);
    dist.resize(n);
    for (int i = 0;i < m; ++i){
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        G[x].pb(y);
        G1[y].pb(x);
    }
    cin >> k;
    p.resize(k);
    for (int i = 0;i < k; ++i)cin >> p[i];
    go();
    int mn = 0, mx = 0;
    for (int i = 0;i < k - 1; ++i){
        int rast = dist[p[i] - 1];
        int R = dist[p[i + 1] - 1];
        if (rast - 1 != R)mn++, mx++;
        else{
            for (auto to : G[p[i] - 1]){
                if (to == p[i + 1] - 1)continue;
                int r = dist[to];
                if (r + 1 == rast){
                    mx++;
                    break;
                }
            }
        }

    }
    cout << mn << " " << mx << endl;
    return 0;
}
