#include<bits/stdc++.h>

using namespace std;

#define int long long
#define double long double
#define kek push_back
#define pii pair< int, int >
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define vi vector< int >
#define vvi vector< vi >
#define vpii vector< pii >

const int inf = 1e12;
const int ninf = -1e12;
const double EPS = 1e-8;

template< typename A, typename B >
    bool mini(A &x, const B &y) {
        if (y < x) {
            x = y;
            return true;
        }
        return false;
    }

template< typename A, typename B >
bool maxi(A &x, const B &y) {
    if (y > x) {
        x = y;
        return true;
    }
    return false;
}

int binpow(int a, int n) {
    int res = 1;
    while (n) {
        if (n & 1) {
            res *= a;
        }
        a *= a;
        n >>= 1;
    }
    return res;
}

int gcd(int a, int b) {
    return b ? gcd(b, a % b) : a;
}
/*
int gcd(int a, int b, int &x, int &y) {
    if (a == 0) {
        x = 0;
        y = 1;
        return b;
    }
    if (b == 0) {
        x = 1;
        y = 0;
        return a;
    }
    int x1, y1;
    int g = gcd(b % a, a, x1, y1);
    y = y1 - (b / a) * x1;
    x = y1;
    return g;
}*/

vvi g;
vvi rg;
vi colour;
int fin;
vi dist;

void run() {
    int n, m;
    cin >> n >> m;
    g.resize(n);
    rg.resize(n);
    for (int i = 0; i < m; ++i) {
       int v, to;
       cin >> v >> to;
       --v;
       --to;
       g[v].kek(to);
       rg[to].kek(v);
    }
    colour.assign(n, 0);
    vi path;
    int nk;
    cin >> nk;
    for (int i = 0; i < nk; ++i) {
        int t;
        cin >> t;
        --t;
        path.kek(t);
    }
    fin = path[nk - 1];
    dist.assign(n, inf);
    dist[fin] = 0;
    priority_queue< pii > que;
    que.push({0, fin});
    vector< char > used;
    used.assign(n, false);
    while (!que.empty()) {
        int v = que.top().second;
        que.pop();
        used[v] = true;
        for (auto to : rg[v]) {
            if (!used[to]) {
                if (dist[to] > dist[v] + 1) {
                    dist[to] = dist[v] + 1;
                    que.push({-dist[to], to});
                }
            }
        }
    }
    int min_ans = 0, max_ans = 0;
    for (int t = 0; t < path.size() - 1; ++t) {
        int v = path[t];
        int nxt = path[t + 1];
        if (dist[nxt] + 1 != dist[v]) {
            min_ans++;
            max_ans++;
            continue;
        }
        int f = 0;
        for (auto to : g[v]) {
            if (dist[to] == dist[nxt]) {
                if (to != nxt) {
                    f = 1;
                    break;
                }
            }
        }
        if (f) {
            max_ans++;
        }
    }
    cout << min_ans << " " << max_ans;
    return;
}

signed main() {
    //freopen("input.txt", "r", stdin);
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    srand(time(0));
    int que = 1;
    //cin >> que;
    for (int i = 0; i < que; ++i) {
        run();
    }
    return 0;
}