#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(a) a.begin(),a.end()
#define rall(a) a.rbegin(),a.rend()
#define loop(i, n) for(int i = 0; i<n; ++i)
#define FOR(i, n, m) for(int i = n; i<m; ++i)
#define fr first
#define sc second

struct node
{
    int l,r;
    int mx = -1e18;
    int ch = 0;
};

vector <node> tree;

void push(int v)
{
    if (tree[v].l == tree[v].r)
    {
        tree[v].ch = 0;
    } else
    {
        tree[v * 2].ch += tree[v].ch;
        tree[v * 2 + 1].ch += tree[v].ch;
        tree[v * 2].mx += tree[v].ch;
        tree[v * 2 + 1].mx += tree[v].ch;
        tree[v].ch = 0;
        tree[v].mx = max(tree[v * 2].mx, tree[v * 2 + 1].mx);
    }
}

vector <int> atc(1e6 + 2, 1e17);
vector <int> def(1e6 + 2, 1e17);

void build(int v, int l, int r)
{
    tree[v].l = l, tree[v].r = r;
    if (l == r)
    {
        tree[v].mx = def[l];
        return;
    }
    int mid = (r + l)/2;
    build(v * 2, l, mid);
    build(v * 2 + 1, mid + 1, r);
    tree[v].mx = max(tree[v * 2].mx, tree[v * 2 + 1].mx);
}

int get_max(int v, int l, int r)
{
    push(v);
    if (tree[v].l > r || tree[v].r < l) return -1e17;
    if (tree[v].l >= l && tree[v].r <= r)
    {
        return tree[v].mx;
    }
    return max(get_max(v * 2, l, r), get_max(v * 2 + 1, l, r));
}

void upd(int v, int l, int r, int val)
{
    push(v);
    if (tree[v].l > r || tree[v].r < l) return;
    if (tree[v].l >= l && tree[v].r <= r)
    {
        tree[v].ch += val;
        tree[v].mx += val;
        push(v);
        return;
    }
    upd(v * 2, l, r, val);
    upd(v * 2 + 1, l, r, val);
    tree[v].mx = max(tree[v * 2].mx, tree[v * 2 + 1].mx);
}


signed main()
{
    int mna = 1e9, mnb = 1e9;
    int n,m,k;
    cin >> n >> m >> k;
    tree.resize(1e6 * 4);
    loop(i, n)
    {
        int a,b;
        cin >> a >> b;
        mna = min(mna, a);
        atc[a - 1] = min(atc[a - 1], b);
    }
    for(int i = 1e6; i>=0; --i) atc[i] = min(atc[i + 1], atc[i]);
    loop(i, m)
    {
        int a,b;
        cin >> a >> b;
        mnb = min(mnb, a);
        def[a - 1] = min(def[a - 1], b);
    }
    for(int i = 1e6; i>=0; --i) def[i] = min(def[i + 1], def[i]);
    loop(i, 1e6 + 2) def[i] *= -1;
    vector <pair <int, pair <int,int> > > mnst;
    loop(i, k)
    {
        int d, a, cen;
        cin >> d >> a >> cen;
        mnst.push_back({d,{a, cen}});
    }
    build(1, 0, 1e6 + 1);
    sort(all(mnst));
    int j = 0;
    int ans = -(mnb + mna);
    loop(i, 1e6 + 1)
    {
        while(j < k && mnst[j].first < i)
        {
            int att = mnst[j].second.first, cen = mnst[j].second.second;
            upd(1, att, 1e6 + 1, cen);
            ++j;
        }
        int sum = get_max(1, 1ll, 1e6 + 1) - atc[i];
        ans = max(sum, ans);
    }
    cout << ans;
}
