#include <bits/stdc++.h>

using namespace std;

#define int long long

vector<vector<int> > gr;
vector<vector<int> > gr_r;
vector<int> dp;
vector<int> dist;
vector<bool> used;
vector<bool> was_s;


void bfs(int v)
{
    dp[v] = 0;
    deque<pair<int, int> > d;
    d.push_back({v, 0});
    used[v] = true;
    while (!(d.empty()))
    {
        pair<int, int> w = d.front();
        used[w.first] = true;
        d.pop_front();
        for (int i = 0; i < gr_r[w.first].size(); i++)
        {
            int u = gr_r[w.first][i];
            if (was_s[u] && dist[u] == w.second + 1)
                dp[u]++;
            else if (!used[u])
            {
                dist[u] = w.second + 1;
                dp[u] = 1;
                d.push_back({u, w.second + 1});
                was_s[u] = true;
            }
            else if (dist[u] == w.second + 1)
                dp[u]++;
        }
    }
}


int32_t main()
{
    int n, m; cin >> n >> m;
    gr.resize(n + 1);
    gr_r.resize(n + 1);
    dp.resize(n + 1);
    used.resize(n + 1);
    was_s.resize(n + 1);
    dist.resize(n + 1);
    for (int i = 0; i < m; i++)
    {
        int a, b; cin >> a >> b;
        gr[a].push_back(b);
        gr_r[b].push_back(a);
    }
    int k; cin >> k;
    vector<int> way(k);
    for (int i = 0; i < k; i++)
        cin >> way[i];
    bfs(way[way.size() - 1]);
    int mn_ch = 0, mx_ch = 0;
    for (int i = 0; i < k - 1; i++)
    {
        int cnt_ways = dp[way[i]];
        if (dist[way[i + 1]] == dist[way[i]] - 1)
        {
            if (dp[way[i]] > 1)
                mx_ch++;
        }
        else
        {
            mn_ch++;
            mx_ch++;
        }
    }
    cout << mn_ch << " " << mx_ch << "\n";
    return 0;
}
