
#include<bits/stdc++.h>
using namespace std;
#define int long long
typedef long long ll;
typedef pair<int, int> pii;
#define rep(a, b, c) for (int a = (b); a < (int)(c); ++a)
#define all(a) a.begin(), a.end()
#define put(x) cout << x << '\n'
#define sqr(a) (a) * (a)
#define chkmax(a, b) a = max(a, (b))
#define chkmin(a, b) a = min(a, (b))
/*
while (clock() / CLOCK_PER_SEC < t){}
*/
const int N = 2e5 + 3;
vector<int> graph[N];
vector<int> revg[N];
signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    //freopen("in.txt", "r", stdin);
    int n, m;
    cin >> n >> m;
    rep(i, 0, m) {
        int a, b;
        cin >> a >> b;
        --a;--b;
        graph[a].push_back(b);
        revg[b].push_back(a);
    }
    int k;
    cin >> k;
    vector<int> p(k);
    rep(i, 0, k) cin >> p[i];
    rep(i, 0, k) --p[i];
    const int INF = 1e8;
    vector<int> dist(n, INF);
    vector<int> cnt(n, 0);
    dist[p.back()] = 0;
    queue<int> q;
    q.push(p.back());
    while (q.size()) {
        int v = q.front();
        q.pop();
        for (int x: revg[v]) {
            if (dist[x] == INF) {
                dist[x] = dist[v] + 1;
                cnt[x] = 1;
                q.push(x);
            }
            else if (dist[x] == dist[v] + 1) ++cnt[x];
        }
    }
    int min_ans = 0;
    int max_ans = 0;
    rep(i, 0, k - 1) {
        if (dist[p[i]] != dist[p[i + 1]] + 1) {
            ++min_ans;
        }
    }
    max_ans = min_ans;
    rep(i, 0, k - 1) {
        if (dist[p[i]] == dist[p[i + 1]] + 1 && cnt[p[i]] > 1) {
            ++max_ans;
        }
    }
    cout << min_ans << " " << max_ans;
}
