
#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <utility>
#include <algorithm>
#include <unordered_map>
using namespace std;

#define FOR(i, a, b) for (int i = a; i <= b; ++i)
#define ROF(i, a, b) for (int i = b; i >= a; --i)

#define sz(a) (int)a.size()
#define mp make_pair

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pi;
typedef pair<ll, ll> pl;
typedef vector<int> vi;
typedef vector<ll> vl;
typedef vector<string> vs;

const int INT_INF = (int)2e9;
const ll LL_INF = (ll)1e18;

template <typename T> int ckmin(T &a, T b) {
	if (a > b){
		a = b;
		return 1;
	}
	return 0;
}

template <typename T> int ckmax(T &a, T b){
	if (a < b){
		a = b;
		return 1;
	}
	return 0;
}

void setIO(){
#ifndef ONLINE_JUDGE
	freopen("input.txt", "r", stdin);
#endif
	ios::sync_with_stdio(0);
	cin.tie(0);
}

int main (){
	setIO();

	int n;
	cin >> n;

	vl b(n);

	map<ll, ll> dp;

	for (int i = 0; i < n; ++i){
		cin >> b[i];
		ckmax(dp[b[i]-i],dp[b[i]-i]+b[i]);
	}

	ll res=  0;

	for (auto it = dp.begin(); it != dp.end(); ++it){
		ckmax(res, (*it).second);
	}

	cout << res;


	return 0;
}