
#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <utility>
#include <algorithm>
#include <unordered_map>
using namespace std;

#define FOR(i, a, b) for (int i = a; i <= b; ++i)
#define ROF(i, a, b) for (int i = b; i >= a; --i)

#define sz(a) (int)a.size()
#define mp make_pair

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pi;
typedef pair<ll, ll> pl;
typedef vector<int> vi;
typedef vector<ll> vl;
typedef vector<string> vs;

const int INT_INF = (int)2e9;
const ll LL_INF = (ll)1e18;

template <typename T> int ckmin(T &a, T b) {
	if (a > b){
		a = b;
		return 1;
	}
	return 0;
}

template <typename T> int ckmax(T &a, T b){
	if (a < b){
		a = b;
		return 1;
	}
	return 0;
}

void setIO(){
#ifndef ONLINE_JUDGE
	freopen("input.txt", "r", stdin);
#endif
	ios::sync_with_stdio(0);
	cin.tie(0);
}

int main (){
	setIO();

	string s;
	cin >> s >> s;

	int ans = 0;
	while (true){
		if (sz(s) == 1) break;
		bool del = 0;
		
		int lst = -1;
		for (int i = 0; i < sz(s); ++i){
			if (i == 0 && s[i+1]+1==s[i]) lst = i;
			else if (i == sz(s) -1 && s[i-1]+1==s[i]) lst = i;
			else if (i != 0 && i != sz(s) - 1 && (s[i+1]+1==s[i] || s[i-1]+1==s[i])) lst = i;
		}
		if (lst==-1) break;
		s.erase(s.begin() + lst);
		ans++;
	}

	cout << ans;

	return 0;
}