
#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <utility>
#include <algorithm>
#include <unordered_map>
using namespace std;

#define FOR(i, a, b) for (int i = a; i <= b; ++i)
#define ROF(i, a, b) for (int i = b; i >= a; --i)

#define sz(a) (int)a.size()
#define mp make_pair

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pi;
typedef pair<ll, ll> pl;
typedef vector<int> vi;
typedef vector<ll> vl;
typedef vector<string> vs;

const int INT_INF = (int)2e9;
const ll LL_INF = (ll)1e18;

template <typename T> int ckmin(T &a, T b) {
	if (a > b){
		a = b;
		return 1;
	}
	return 0;
}

template <typename T> int ckmax(T &a, T b){
	if (a < b){
		a = b;
		return 1;
	}
	return 0;
}

void setIO(){
#ifndef ONLINE_JUDGE
	freopen("input.txt", "r", stdin);
#endif
	ios::sync_with_stdio(0);
	cin.tie(0);
}

int smart(string s){

	string v = s;

	int ans = 0;
	while (true){
		if (sz(s) == 1) break;
		bool del = 0;
		
		int lst = -1;
		for (int i = 0; i < sz(s); ++i){
			if (i == 0 && s[i+1]+1==s[i]) lst = i;
			else if (i == sz(s) -1 && s[i-1]+1==s[i]) lst = i;
			else if (i != 0 && i != sz(s) - 1 && (s[i+1]+1==s[i] || s[i-1]+1==s[i])) lst = i;
		}
		if (lst==-1) break;
		s.erase(s.begin() + lst);
		ans++;
	}

	swap(s,v);

	int ans2 = 0;

	while (true){
		if (sz(s) == 1) break;
		bool del = 0;
		
		int lst = -1;
		for (int i = sz(s) - 1; i >= 0; --i){
			if (i == 0 && s[i+1]+1==s[i]) lst = i;
			else if (i == sz(s) -1 && s[i-1]+1==s[i]) lst = i;
			else if (i != 0 && i != sz(s) - 1 && (s[i+1]+1==s[i] || s[i-1]+1==s[i])) lst = i;
		}
		if (lst==-1) break;
		s.erase(s.begin() + lst);
		ans2++;
	}

	return max(ans, ans2);
}

int f;

void rec(string s, int was = 0){
	ckmax(f, was);
	if (sz(s) == 1) return;
	for (int i = 0; i < sz(s); ++i){
		bool val = 0;
		if (i == 0 && s[i+1]+1==s[i]) val = 1;
		else if (i == sz(s) -1 && s[i-1]+1==s[i]) val = 1;
		else if (i != 0 && i != sz(s) - 1 && (s[i+1]+1==s[i] || s[i-1]+1==s[i])) val =1 ;
		if (val){
			string x = s;
			x.erase(x.begin() + i);
			rec(x, was + 1);
		}
	}
}

int stupid(string s){
	f = 0;
	rec(s, 0);
	return f;
}

int main (){
	setIO();

	/*int q = 1000;
	
	while (q--){
		int n = rand() % 7 + 1;
		string s; s.resize(n);

		for (int i = 0; i < n; ++i) s[i] = 'a' + rand() % 26;
		int c1 = smart(s);
		int c2 = stupid(s);

		if (c1 != c2){
			cout << c1 << " " << c2 << " " << s << "\n";
			return 0;
		}

	}
*/

	string s;
	cin >> s >> s;
	cout << smart(s);
	return 0;
}