
#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <utility>
#include <algorithm>
#include <unordered_map>
using namespace std;

#define FOR(i, a, b) for (int i = a; i <= b; ++i)
#define ROF(i, a, b) for (int i = b; i >= a; --i)

#define sz(a) (int)a.size()
#define mp make_pair

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pi;
typedef pair<ll, ll> pl;
typedef vector<int> vi;
typedef vector<ll> vl;
typedef vector<string> vs;

const int INT_INF = (int)2e9;
const ll LL_INF = (ll)1e18;

template <typename T> int ckmin(T &a, T b) {
	if (a > b){
		a = b;
		return 1;
	}
	return 0;
}

template <typename T> int ckmax(T &a, T b){
	if (a < b){
		a = b;
		return 1;
	}
	return 0;
}

void setIO(){
#ifndef ONLINE_JUDGE
	freopen("input.txt", "r", stdin);
#endif
	ios::sync_with_stdio(0);
	cin.tie(0);
}

int n, ans;
map<int, int> del;
string s;

void solve(int pos){
	if (pos == sz(s) - 1) return;
	if (s[pos] + 1 == s[pos + 1]) {
		solve(pos + 1);
		if (!del[pos + 1]) ans++;
		del[pos + 1] = 1;
	}
	else if (s[pos] - 1 == s[pos + 1]){
		del[pos] = 1;
		ans++;
		solve(pos+1);
	}else{
		solve(pos+1);
	}
}

int main (){
	setIO();

	cin >> n >> s;

	while (true){
		string v;
		int now = s.size();
		for (int i = 0; i < sz(s); ){
			int ptr = i + 1;
			while (ptr < sz(s) && s[ptr] - 1 == s[ptr - 1]){
				ptr++;
			}
			int f = i + 1;
			while (f < sz(s) && s[f] + 1 == s[f - 1]){
				f++;
			}
			if (ptr > f){
				v += s[i];
				i = ptr;
			}else{
				v += s[f - 1];
				i = f;
			}
		}
		swap(v, s);
		if (sz(s) == now) break;
	}

	cout << n - sz(s);

	return 0;
}