#include <bits/stdc++.h>

using namespace std;


#define INF 1e9


unsigned N;
vector<vector<unsigned> > rto;
vector<vector<unsigned> > pr;

void BFS(unsigned s, unsigned t)
{
    vector<unsigned> cost(N, INF);

    queue<unsigned> q;
    q.push(t); cost[t] = 0;

    while (!q.empty())
    {
        unsigned v = q.front();
        q.pop();

        for (auto& u : rto[v])
        {
            if (cost[u] > cost[v] + 1)
            {
                cost[u] = cost[v] + 1;
                q.push(u);
            }

            if (cost[u] == cost[v] + 1)
                pr[u].push_back(v);
        }
    }
}


int main()
{
    cin.tie(0); cout.tie(0); cerr.tie(0);
    ios_base::sync_with_stdio(false);

    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);


    cin >> N;
    rto.resize(N);

    unsigned M; cin >> M;
    for (unsigned i = 0; i < M; i++)
    {
        unsigned v, u; cin >> v >> u; v--; u--;
        rto[u].push_back(v);
    }

    pr.resize(N);

    unsigned K; cin >> K;
    vector<unsigned> path(K);
    for (auto& v : path)
    {
        cin >> v; v--;
    }

    BFS(path.front(), path.back());

    unsigned ans1 = 0, ans2 = 0;

    for (unsigned i = 0; i + 1 < K; i++)
    {
        unsigned v = path[i];
        if (pr[v].size() == 1)
        {
            if (pr[v][0] != path[i + 1])
            {
                ans1++; ans2++;
            }
        }
        else
        {
            ans2++;
            if (find(pr[v].begin(), pr[v].end(), path[i + 1]) == pr[v].end())
                ans1++;
        }
    }

    cout << ans1 << " " << ans2;


    return 0;
}
