// chrono::system_clock::now().time_since_epoch().count()
#define DBG 1

//#include<ext/pb_ds/tree_policy.hpp>
//#include<ext/pb_ds/assoc_container.hpp>
#include<bits/stdc++.h>

#define pb push_back
#define eb emplace_back
#define mp make_pair
#define fi first
#define se second
#define all(x) (x).begin(), (x).end()
#define debug(x) if (DBG) cerr << #x << " = " << x << endl;

using namespace std;
//using namespace __gnu_pbds;

typedef long long ll;
typedef pair<int, int> pii;
//template<typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

const int MAXN = (int)2e5 + 5;
const int INF = (int)1e9;

int d[MAXN];
vector<int> adj[MAXN], radj[MAXN];
set<int> has[MAXN];
int path[MAXN];
int n, m, k;

void solve() {
    scanf("%d %d", &n, &m);

    for (int i = 1; i <= m; ++i) {
        int u, v;
        scanf("%d %d", &u, &v);
        adj[u].pb(v);
        radj[v].pb(u);
    }

    scanf("%d", &k);

    for (int i = 1; i <= k; ++i) {
        scanf("%d", &path[i]);
    }

    int st = path[1], en = path[k];

    for (int i = 1; i <= n; ++i) {
        d[i] = INF;
    }

    d[en] = 0;
    queue<int> q;
    q.push(en);

    while (!q.empty()) {
        int v = q.front();
        q.pop();

        for (int to : radj[v]) {
            if (d[v] + 1 < d[to]) {
                d[to] = d[v] + 1;
                has[to].insert(v);
                q.push(to);
            }
            else if (d[v] + 1 == d[to]) {
                has[to].insert(v);
            }
        }
    }

    int ans1 = 0, ans2 = 0;

    for (int i = 1; i < k; ++i) {
        int v = path[i];
        int nx = path[i + 1];
        bool ff = 0, ss = 0;

        if (d[nx] != d[v] - 1) {
            ss = 1;
        }

        for (auto it : has[v]) {
            if (it == nx) {
                ff = 1;
            }
            else {
                ss = 1;
            }
        }

        ans1 += !ff;
        ans2 += ss;
    }

    printf("%d %d\n", ans1, ans2);
}

int main() {
    int tt = 1;

    while (tt--) {
        solve();
    }

    return 0;
}
