#ifdef _DEV
#define DEV 1
#else
#define DEV 0
#endif // _DEV
#include <bits/stdc++.h>

#define $ if (DEV)

using namespace std;

void $main(int test_id);

int main() {
    int test_count = 1;
    $ {
        test_count = 100;
        freopen("input.txt", "r", stdin);
    } else {
        ios::sync_with_stdio(false);
        cin.tie(nullptr);
    }
    for (int t = 0; t < test_count; ++t) {
        $ printf("--- TEST %d ---\n", t);
        $main(t);
        int ch = -1;
        while (DEV) {
            ch = fgetc(stdin);
            if (ch == -1 || !isspace(ch)) {break;}
        }
        if(ch != -1) {
            ungetc(ch ,stdin);
        }

    }
}

template<typename T>
bool relmin(T& pl, T const v) {
    if (pl > v) {
        pl = v;
        return true;
    }
    return false;
}

int n, m;
vector<vector<int>> g;
vector<vector<int>> gr;
vector<set<int>> gs;
vector<int> dist;

int const INF = 1000000000;

void bfs(int s) {
    dist.resize(n, INF);
    dist[s] = 0;
    queue<int> q;
    q.push(s);
    while (!q.empty())  {
        int  v = q.front();
        q.pop();
        for(int w : gr[v]) {
            if (relmin(dist[w], dist[v] + 1)) {
                q.push(w);
            }
        }
    }
}

void $main(int test_id) {
    $ {
    g.clear();
    gr.clear();
    dist.clear();
    gs.clear();
    }

    cin >> n >> m;
    g.resize(n);
    gr.resize(n);
    for (int i = 0; i < m; ++i) {
        int u, v;
         cin >> u >> v;
     --u;
     --v;
     g[u].push_back(v);
     gr[v].push_back(u);
    }
    int k;cin >> k;
    vector<int> p(k);
    for (int& x : p) {cin >> x; --x;}
    bfs(p.back());
    gs.resize(n);
    for (int u = 0; u < n; ++u) {
        for (int v : g[u]) {
            if (dist[u] - dist[v] == 1) {
                $ printf("short: %d -> %d\n", u, v);
                gs[u].insert(v);
            }
        }
    }

    int ans_min, ans_max;
    ans_min = ans_max= 0;
    for (int i = 0; i < k-1; ++i) {
        int u = p[i];
        int v = p[i+1];
        if (gs[u].count(v) == 0) {
            ++ans_min;
            ++ans_max;
        } else if (gs[u].size()> 1){
            ++ans_max;
        }
    }
    cout << ans_min<< " " << ans_max << "\n";

}
