#include <bits/stdc++.h>

using namespace std;

#define fs first
#define sc second
#define pii pair < int, int >
#define pb push_back
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define fast_io ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define getfiles ifstream cin("input.txt"); ofstream cout("output.txt");

typedef long long ll;
typedef long double ld;

const int INF = 1e9;
const ll BIG_INF = 1e18;
const ll MOD = 1e9 + 7;

const int maxn = 2e5 + 5;
vector < int > g[maxn], gr[maxn];
int n, m, k, dist[maxn], s, f;
queue < int > q;
int path[maxn];

void bfs() {
    for (int i = 0; i < n; i++)
        dist[i] = INF;
    dist[f] = 0;
    q.push(f);

    while (!q.empty()) {
        int v = q.front();
        q.pop();

        for (int j = 0; j < sz(gr[v]); j++) {
            int to = gr[v][j];

            if (dist[to] == INF) {
                dist[to] = dist[v] + 1;
                q.push(to);
            }
        }
    }
}

int main() {
    fast_io
    cin >> n >> m;

    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;

        g[u].pb(v);
        gr[v].pb(u);
    }

    cin >> k;
    for (int i = 0; i < k; i++) {
        cin >> path[i];
        path[i]--;
    }
    s = path[0];
    f = path[k - 1];

    bfs();

    int mn_val = 0, mx_val = 0;
    for (int i = k - 2; i >= 0; i--) {
        int v = path[i];

        bool krat = false;
        int cnt_path = 0;
        for (int j = 0; j < sz(g[v]); j++) {
            int to = g[v][j];

            if (dist[to] == dist[v] - 1) {
                cnt_path++;
                if (to == path[i + 1]) krat = true;
            }
        }

        if (!krat) {
            mn_val++;
            mx_val++;
            continue;
        }

        if (cnt_path > 1) mx_val++;
    }

    cout << mn_val << " " << mx_val << "\n";
    return 0;
}
