#include <bits/stdc++.h>
#define fi first
#define se second
#define all(a) (a).begin(), (a).end()
#define pb push_back
#define len(a) ll((a).size())
#define pw(a) (1LL << (a))

using namespace std;
using ll = long long;
using ld = long double;

const int N = 5e5 + 5;
const ll INF = 4e18;

ll n, m, p, t1[N * 5], t2[N * 5];
vector <pair <ll, ll> > a, b, t[N * 5];
vector <ll> pref[N * 5];
vector <pair <pair <ll, ll>, ll> > x;
void build(int v, int tl, int tr) {
    if(tl == tr) {
        t[v].pb({x[tl].fi.se, x[tl].se});
        pref[v].resize(len(t[v]) + 1);
        for(int i = 0; i < len(t[v]); i++) {
            pref[v][i + 1] = pref[v][i] + t[v][i].se;
        }
    } else {
        int mid = (tl + tr) / 2;
        build(v * 2, tl, mid);
        build(v * 2 + 1, mid + 1, tr);
        merge(all(t[v * 2]), all(t[v * 2 + 1]), back_inserter(t[v]));
        pref[v].resize(len(t[v]) + 1);
        for(int i = 0; i < len(t[v]); i++) {
            pref[v][i + 1] = pref[v][i] + t[v][i].se;
        }
    }
}
ll get(int v, int tl, int tr, int l, int r, ll val) {
    if(l > r) {
        return 0;
    }
    if(tl == l && tr == r) {
        ll pos = upper_bound(all(t[v]), make_pair(val, INF)) - t[v].begin();
        return pref[v][pos];
    }
    int mid = (tl + tr) / 2;
    return get(v * 2, tl, mid, l, min(r, mid), val) +
            get(v * 2 + 1, mid + 1, tr, max(l, mid + 1), r, val);
}

void build1(int v, int tl, int tr) {
    if(tl == tr) {
        t1[v] = a[tl].se;
    } else {
        int mid = (tl + tr) / 2;
        build1(v * 2, tl, mid);
        build1(v * 2 + 1, mid + 1, tr);
        t1[v] = min(t1[v * 2], t1[v * 2 + 1]);
    }
}
ll get1(int v, int tl, int tr, int l, int r) {
    if(l > r) {
        return INF;
    }
    if(tl == l && tr == r) {
        return t1[v];
    }
    int mid = (tl + tr) / 2;
    return min(get1(v * 2, tl, mid, l, min(r, mid)),
            get1(v * 2 + 1, mid + 1, tr, max(l, mid + 1), r));
}


void build2(int v, int tl, int tr) {
    if(tl == tr) {
        t2[v] = b[tl].se;
    } else {
        int mid = (tl + tr) / 2;
        build2(v * 2, tl, mid);
        build2(v * 2 + 1, mid + 1, tr);
        t2[v] = min(t2[v * 2], t2[v * 2 + 1]);
    }
}
ll get2(int v, int tl, int tr, int l, int r) {
    if(l > r) {
        return INF;
    }
    if(tl == l && tr == r) {
        return t2[v];
    }
    int mid = (tl + tr) / 2;
    return min(get2(v * 2, tl, mid, l, min(r, mid)),
            get2(v * 2 + 1, mid + 1, tr, max(l, mid + 1), r));
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0);
    cin >> n >> m >> p;
    a.resize(n);
    b.resize(m);
    x.resize(p);
    for(int i = 0; i < n; i++) {
        cin >> a[i].fi >> a[i].se;
    }
    sort(all(a));
    for(int i = 0; i < m; i++) {
        cin >> b[i].fi >> b[i].se;
    }
    sort(all(b));
    for(int i = 0; i < p; i++) {
        cin >> x[i].fi.se >> x[i].fi.fi >> x[i].se;
    }
    sort(all(x));
    build(1, 0, p - 1);
    build1(1, 0, n - 1);
    build2(1, 0, m - 1);
    //return 0;
    ll mx = -INF;
    for(int i = 0; i < p; i++) {
        ll val = get(1, 0, p - 1, 0, i, x[i].fi.se);
        //cout << val << ' ';
        //return 0;
        ll pos1 = upper_bound(all(a), make_pair(x[i].fi.fi, INF)) - a.begin();
        ll pos2 = upper_bound(all(b), make_pair(x[i].fi.se, INF)) - b.begin();
        //cout << val - get1(1, 0, n - 1, pos1, n - 1) - get2(1, 0, m - 1, pos2, m - 1) << '\n';
        mx = max(val - get1(1, 0, n - 1, pos1, n - 1) - get2(1, 0, m - 1, pos2, m - 1), mx);
    }
    //cout << '\n';
    cout << mx << '\n';
}
