#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

const int inf = int(1e9) + 10;

int main() {
    cin.tie(0);
    ios::sync_with_stdio(0);

    int n, m;
    cin >> n >> m;

    vector <vector <int> > g(n);
    for(int i = 0; i < m; i++) {
        int v, to;
        cin >> v >> to;
        v--, to--;

        g[to].push_back(v);
    }

    int k;
    cin >> k;

    vector <int> way(k);
    for(int i = 0; i < k; i++) {
        cin >> way[i];
        way[i]--;
    }

    queue <int> que;
    vector <int> dp(n, inf);

    dp[way.back()] = 0;
    que.push(way.back());

    while(que.empty() == false) {
        int v = que.front();
        que.pop();

        for(auto to : g[v]) {
            if (dp[to] > dp[v] + 1) {
                dp[to] = dp[v] + 1;
                que.push(to);
            }
        }
    }

    vector <map <int, int> > p(n);

    vector <int> dp1(n, inf);
    dp1[way.back()] = 0;
    que.push(way.back());

    while(que.empty() == false) {
        int v = que.front();
        que.pop();

        for(auto to : g[v]) {
            if (dp1[v] + 1 == dp[to]) {
                p[to][v] = 1;
            }

            if (dp1[to] > dp1[v] + 1) {
                dp1[to] = dp1[v] + 1;
                que.push(to);
            }
        }
    }

    int mn = 0, mx = 0;
    for(int i = 0; i < k - 1; i++) {
        int to = way[i + 1], v = way[i];

        int x = p[v][to];
        if (!x) {
            mn++;
        }

        if (p[v].size() - x > 0) {
            mx++;
        }
    }

    cout << mn << " " << mx << "\n";
    return 0;
}
