#include <bits/stdc++.h>
using namespace std;
#define fs first
#define sc second
const int maxn = 2e5 + 100;
typedef pair<int,int> pii;
typedef long long ll;
#define dbg(x) cout<<#x<<": "<<x<<endl;
vector<int> g[maxn], gr[maxn];

struct segtree {
	int t[maxn*4], p[maxn*4];

	void push(int v) {
		t[v*2] += p[v];
		t[v*2+1] += p[v];
		p[v*2+1] += p[v];
		p[v*2] += p[v];
		p[v] = 0;
	}

	void update(int v, int tl, int tr, int l, int r, int add) {
		if (l > r) return;
		if (tl == l && tr == r) {
			t[v] += add;
			p[v] += add;
		}
		else {
			int tm = (tl+tr)/2;
			push(v);
			update(v*2,tl,tm,l,min(r,tm),add);
			update(v*2+1,tm+1,tr,max(l,tm+1),r,add);
			t[v] = max(t[v*2+1], t[v*2]);
		}

	}
} tt;


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int n,m,p;
	cin>>n>>m>>p;
	vector<pair<int,int> > a(n), b(m);
	for (int i = 0;i<n;++i) cin>>a[i].fs>>a[i].sc;
	for (int i = 0;i<m;++i) cin>>b[i].fs>>b[i].sc;
	sort(a.begin(), a.end());
	sort(b.begin(), b.end());
	for (int i = n-1;i>0;--i) a[i-1].sc = min(a[i-1].sc, a[i].sc);
	for (int i = m-1;i>0;--i) b[i-1].sc = min(b[i-1].sc, b[i].sc);
	vector<pair<int,int> > ts[n];
	for (int i = 0;i<p;++i) {
		int x,y,z;
		cin>>x>>y>>z;
		x = upper_bound(a.begin(), a.end(), make_pair(x, int(1e9))) - a.begin();
		y = upper_bound(b.begin(), b.end(), make_pair(y, int(1e9))) - b.begin();
		if (x == a.size() || y == b.size()) continue;
		ts[x].push_back({y,z});
	}
	int best = -1e9;
	for (int i = 0;i<m;++i) tt.update(1,0,m-1,i,i,-b[i].sc);
	for (int i = 0;i<n;++i) {
		for (auto j : ts[i]) {
			tt.update(1,0,m-1,j.fs,m-1,j.sc);
			//cur[j.fs] += j.sc;
		}

		best = max(best, tt.t[1]  - a[i].sc);
	}
	cout<<best;
	return 0;

}