#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;
#define f first
#define s second
#define pii pair<int, int>
#define vi vector<int>
#define int ll
#define pb push_back
using namespace std;

const int maxn = 1e6 + 50;
int t[4 * maxn];
int m[4 * maxn];
void push(int v) {
    if (m[v]) {
        if (2 * v + 1 < 4 * maxn) {
            t[2 * v] += m[v];
            t[2 * v + 1] += m[v];
            m[2 * v] += m[v];
            m[2 * v + 1] += m[v];
        }
        m[v] = 0;
    }
}
pii b[maxn];
void build(int v, int tl, int tr) {
    if (tl == tr) {
        t[v] = b[tl].s - b[0].s;
    } else {
        int tm = (tl + tr) / 2;
        build(2 * v, tl, tm);
        build(2 * v + 1, tm + 1, tr);
        t[v] = min(t[2 * v], t[2 * v + 1]);
    }
}

int get(int v, int tl, int tr, int l, int r) {
    if (r < tl || l > tr)
        return 1e18;
    push(v);
    if (tl >= l && tr <= r)
        return t[v];
    int tm = (tl + tr) / 2;
    return min(get(2 * v, tl, tm, l, r), get(2 * v + 1, tm + 1, tr, l, r));
}

void update(int v, int tl, int tr, int l, int r, int x) {
    if (r < tl || l > tr)
        return;
    push(v);
    if (tl >= l && tr <= r) {
        t[v] += x;
        m[v] += x;
        return;
    }
    int tm = (tl + tr) / 2;
    update(2 * v, tl, tm, l, r, x);
    update(2 * v + 1, tm + 1, tr, l, r, x);
    t[v] = min(t[2 * v], t[2 * v + 1]);
}

void solve() {
    int n, m, p;
    cin >> n >> m >> p;
    pii a[n];
    int ans = 1e18;
    for (int i = 0; i < n; ++i) {
        cin >> a[i].f >> a[i].s;
    }
    for (int j = 0; j < m; ++j) {
        cin >> b[j].f >> b[j].s;
    }
    sort(b, b + m);
    pair<pii, int> mst[p];
    for (int i = 0; i < p; ++i) {
        cin >> mst[i].f.f >> mst[i].f.s >> mst[i].s;
    }
    sort(mst, mst + p, [](pair<pii, int> a, pair<pii, int> b) {
        return a.f.f < b.f.s;
    });
    build(1, 0, m - 1);
    int uk = 0;
    for (int i = 0; i < n; ++i) {
        while (uk < p && mst[uk].f.f < a[i].f) {
            if (mst[uk].f.s < b[m - 1].f) {
                int l = -1, r = m - 1;
                while (r - l > 1) {
                    int mid = (l + r) / 2;
                    if (b[mid].f > mst[uk].f.s) {
                        r = mid;
                    } else {
                        l = mid;
                    }
                }
                update(1, 0, m - 1, r, m - 1, -mst[uk].s);
            }
            uk++;
        }
        ans = std::min(ans, a[i].s + b[0].s + get(1, 0, m - 1, 0, m - 1));
    }
    cout << -ans << endl;
}
signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    #ifndef ONLINE_JUDGE
    freopen("input.txt", "r", stdin);
    #endif
    int t = 1;
    while (t--) {
        solve();
    }
    return 0;
}
