#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;
#define f first
#define s second
#define pii pair<int, int>
#define vi vector<int>
#define int ll
#define pb push_back
using namespace std;

const int maxn = 2e5 + 50;

const int mod = 1e9 + 7;
const int mod2 = 1e9 + 9;
int p = 141;
int p2 = 131;

int fastpow(int a,int b) {
    if (b == 0)
        return 1;
    if (b & 1)
        return a * fastpow(a, b - 1) % mod;
    int t = fastpow(a, b / 2);
    return t * t % mod;
}

void solve() {
    int n;
    cin >> n;
    string s;
    cin >> s;
    int cntp[n];
    int cnts[n];
    for (int i = n - 1; i >= 0; --i) {
        cnts[i] = (s[i] == '1');
        if (cnts[i] && i != n - 1)
            cnts[i] += cnts[i + 1];
    }
    for (int i = 0; i < n; ++i) {
        cntp[i] = (s[i] == '1');
        if (cntp[i] && i)
            cntp[i] += cntp[i - 1];
    }
    vector<pair<char, int>> v;
    for (int i = 0; i < n; ++i) {
        v.pb({s[i], i});
        if (v.size() > 1 && v.back().f == '1' && v[v.size() - 2].f == '1') {
            v.pop_back();
            v.pop_back();
        }
    }
    int k = v.size();
    //int powp[k + 1];
    int pref[k + 1];
    //int powp2[k + 1];
    int pref2[k + 1];
    //powp[0] = 1;
    pref[0] = 0;
    pref2[0] = 0;
    for (int i = 0; i < k; ++i) {
        //powp[i + 1] = powp[i] * p % mod;
        pref[i + 1] = (pref[i] * p + v[i].f) % mod;
        //powp2[i + 1] = powp2[i] * p2 % mod2;
        pref2[i + 1] = (pref2[i] * p2 + v[i].f) % mod2;
    }
    int q;
    cin >> q;
    while (q--) {
        int a, b, ln;
        cin >> a >> b >> ln;
        a--;
        b--;
        int cnt1 = 0, cnt2 = 0;
        int h1 = 0, h2 = 0;
        int hh1 = 0, hh2 = 0;
        int l = -1, r = k;
        while (r - l > 1) {
            int mid = (l + r) / 2;
            if (v[mid].s >= b + ln) {
                r = mid;
            } else {
                l = mid;
            }
        }
        cnt2 += l + 1;
        if (l != -1) {
            h2 += pref[l];
            hh2 += pref[l];
        }
        l = -1, r = k;
        while (r - l > 1) {
            int mid = (l + r) / 2;
            if (v[mid].s >= b) {
                r = mid;
            } else {
                l = mid;
            }
        }
        cnt2 -= l + 1;
        if (l != -1) {
            h2 -= pref[l];
            hh2 -= pref2[l];
        }
        l = -1, r = k;
        while (r - l > 1) {
            int mid = (l + r) / 2;
            if (v[mid].s >= a + ln) {
                r = mid;
            } else {
                l = mid;
            }
        }
        cnt1 += l + 1;
        if (l != -1) {
            h1 += pref[l];
            hh1 += pref2[l];
        }
        l = -1, r = k;
        while (r - l > 1) {
            int mid = (l + r) / 2;
            if (v[mid].s >= a) {
                r = mid;
            } else {
                l = mid;
            }
        }
        cnt1 -= l + 1;
        if (l != -1) {
            h1 -= pref[l];
            hh1 -= pref2[l];
        }
        h2 = (h2 % mod + mod) % mod;
        h1 = (h1 % mod + mod) % mod;
        hh1 = (hh1 % mod2 + mod2) % mod2;
        hh2 = (hh2 % mod2 + mod2) % mod2;
        if (cntp[b + ln - 1] % 2) {
            h2 = (h2 * p + '1') % mod;
            hh2 = (hh2 * p + '1') % mod2;
        }
        if (cntp[a + ln - 1] % 2) {
            hh1 = (hh1 * p + '1') % mod2;
            h1 = (h1 * p + '1') % mod;
        }
        //cout << hh1 << ' ' << hh2 << endl;
        //cout << h1 << ' ' << h2 << endl;
        //cout << cnt1 << ' ' << cnt2 << endl;
        //cout << h1 << ' ' << h2 << endl;
        if (h1 == h2 && hh1 == hh2) {
            cout << "Yes" << endl;
        } else {
            cout << "No" << endl;
        }
    }
}
signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    #ifndef ONLINE_JUDGE
    freopen("input.txt", "r", stdin);
    #endif
    int t = 1;
    while (t--) {
        solve();
    }
    return 0;
}
