#include<bits/stdc++.h>

#define int long long
#define x first
#define y second
#define mp make_pair
#define pb push_back
#define all(v) v.begin(), v.end()
#define sz(v) (int) v.size()
#define TASK ""

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

signed main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
if (strlen(TASK) > 0)
	freopen(TASK".in", "r", stdin),
	freopen(TASK".out", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	
	int n;
	cin >> n;
	string s;
	cin >> s;
	auto get = [&](int i) {
		if (i < 0 || i >= n) {
			return '#';
		}
		return s[i];
	};
	set<pair<char, int>> can_erase;
	vector<int> l(n), r(n);
	auto update = [&](int i) {
		if (i < 0 || i >= n) return;
		if (get(l[i]) + 1 == s[i] || get(r[i]) + 1 == s[i]) {
			can_erase.insert(mp(s[i], i));
		}
	};
	for (int i = 0; i < n; ++i) {
		l[i] = i - 1, r[i] = i + 1;
		update(i);
	}
	int ans = 0;
	while (!can_erase.empty()) {
		int i = can_erase.rbegin()->y;
		can_erase.erase(*can_erase.rbegin());
		ans++;
		int l1 = l[i], r1 = r[i];
		if (l1 > -1) {
			r[l1] = r1;
		}
		if (r1 < n) {
			l[r1] = l1;
		}
		update(l1);
		update(r1);
	}
	cout << ans << "\n";
	
	return 0;
}
