#include<bits/stdc++.h>

#define int long long
#define x first
#define y second
#define mp make_pair
#define pb push_back
#define all(v) v.begin(), v.end()
#define sz(v) (int) v.size()
#define TASK ""

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

const int N = 2e5 + 5, inf = 1e9;

int n, q;
vector<int> g[N];

int dfs(int v, int p, int f) {
	if (v == f) {
		return 0;
	}
	for (int &u : g[v]) if (u != p) {
		int go = dfs(u, v, f);
		if (go != -1) {
			return go + 1;
		}
	}
	return -1;
}

int dist(int v, int u) {
	return dfs(v, v, u);
}

signed main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
if (strlen(TASK) > 0)
	freopen(TASK".in", "r", stdin),
	freopen(TASK".out", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	
	cin >> n;
	for (int i = 0; i < n - 1; ++i) {
		int v, u;
		cin >> v >> u;
		g[v].pb(u);
		g[u].pb(v);
	}
	cin >> q;
	while (q--) {
		int k, m;
		cin >> k >> m;
		vector<int> v(k), s(k);
		for (int j = 0; j < k; ++j) {
			cin >> v[j] >> s[j];
		}
		for (int j = 0; j < m; ++j) {
			int u;
			cin >> u;
			pii ans = mp(inf, 0);
			for (int f = 0; f < k; ++f) {
				ans = min(ans, mp((dist(u, v[f]) + s[f] - 1) / s[f], f + 1));
			}
			cout << ans.y << " ";
		}
		cout << "\n";
	}
		
	return 0;
}
