#include<bits/stdc++.h>

//#define int long long
#define x first
#define y second
#define mp make_pair
#define pb push_back
#define all(v) v.begin(), v.end()
#define sz(v) (int) v.size()
#define TASK ""

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

const int N = 2e5 + 5;

int n, q;
string s;

bool check(string &a, string &b) {
	int m = sz(a);
	deque<int> za, zb;
	for (int i = 0; i < m; ++i) {
		if (a[i] == '0') za.pb(i);
		if (b[i] == '0') zb.pb(i);
	}
	for (int i = 0; i < m; ++i) {
		while (!za.empty() && za.front() <= i) za.pop_front();
		while (!zb.empty() && zb.front() <= i) zb.pop_front();
		if (a[i] == b[i]) continue;
		if (a[i] == '0') {
			if (zb.empty()) return false;
			int pos = zb.front();
			if ((pos - i) % 2 == 0) {
				swap(b[i], b[pos]);
				zb.pop_front();
			}
		} else {
			if (za.empty()) return false;
			int pos = za.front();
			if ((pos - i) % 2 == 0) {
				swap(a[i], a[pos]);
				za.pop_front();
			}
		}
		if (a[i] != b[i]) {
			return false;
		}
	}
	return true;
}

signed main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
if (strlen(TASK) > 0)
	freopen(TASK".in", "r", stdin),
	freopen(TASK".out", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	
	cin >> n >> s >> q;
	while (q--) {
		int l1, l2, l;
		cin >> l1 >> l2 >> l;
		--l1, --l2;
		string a, b;
		for (int i = l1; i <= l1 + l - 1; ++i) a.pb(s[i]);
		for (int i = l2; i <= l2 + l - 1; ++i) b.pb(s[i]);
		cout << (check(a, b) ? "Yes\n" : "No\n");
	}
	
	return 0;
}
