//
// Created by DanGolov on 01.03.2020.
//
#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using pii = pair<int, int>;

inline void io_optimize() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
}

signed main() {
    io_optimize();
    int n;
    cin >> n;
    vector<int> r (n), b (n);
    for (int i = 0; i < n; i++) cin >> r[i];
    for (int i = 0; i < n; i++) cin >> b[i];

    int s1 = accumulate(r.begin(), r.end(), 0);
    int s2 = accumulate(b.begin(), b.end(), 0);

    int cnt1 = 0, cnt2 = 0;
    for (int i = 0; i < n; i++) {
        if (r[i] == 1 && b[i] == 0) {
            ++cnt1;
        } else if (r[i] == 0 && b[i] == 1) {
            ++cnt2;
        }
    }

    if (cnt1 == 0) {
        cout << -1 << '\n';
    } else {
        cout << cnt2 / cnt1 + 1 << '\n';
    }
    return 0;
}