#include <bits/stdc++.h>

#define llong long long

using namespace std;

const llong NUM = 1LL << 20;

const llong INF = 1e15;

vector<pair<llong, llong> > f(vector<pair<llong, llong> > &a)
{
    vector<pair<llong, llong> > b;
    llong c = INF, d = -1;
    sort(a.begin(), a.end());
    for (llong i = (llong)a.size() - 1; i >= 0; i--)
    {
        if (c > a[i].second)
        {
            c = a[i].second;
            if (d == a[i].first)
            {
                b.back().second = c;
            }
            else
            {
                d = a[i].first;
                b.push_back({d, c});
            }
        }
    }
    for (llong i = 0; 2 * i + 1 < b.size(); i++)
    {
        swap(b[i], b[(llong)b.size() - i - 1]);
    }
    return b;
}

void update(llong v, vector<pair<llong, llong> > &t)
{
    if (v * 2 + 1 < t.size())
    {
        t[v * 2].second += t[v].second;
        t[v * 2 + 1].second += t[v].second;
    }
    t[v].first += t[v].second;
    t[v].second = 0;
}

void add(llong v, llong L, llong R, llong x, llong y, llong k, vector<pair<llong, llong> > &t)
{
    update(v, t);
    if (x <= L && y >= R)
    {
        t[v].second += k;
        update(v, t);
        return;
    }
    if (y <= L || x >= R)
    {
        return;
    }
    add(v * 2, L, L + (R - L) / 2, x, y, k, t);
    add(v * 2 + 1, L + (R - L) / 2, R, x, y, k, t);
    t[v].first = max(t[v * 2].first, t[v * 2 + 1].first);
}

int main(void)
{
    llong n = 0, m = 0, p = 0, it = 0, ans = 0;
    cin >> n >> m >> p;
    vector<pair<llong, llong> > a(n, {0, 0});
    vector<pair<llong, llong> > b(m, {0, 0});
    vector<pair<pair<llong, llong>, llong> > c(p, {{0, 0}, 0});
    vector<pair<llong, llong> > d(2 * NUM, {0, 0});
    for (llong i = 0; i < n; i++)
    {
        cin >> a[i].first >> a[i].second;
    }
    vector<pair<llong, llong> > e = f(a);
    for (llong i = 0; i < m; i++)
    {
        cin >> b[i].first >> b[i].second;
    }
    vector<pair<llong, llong> > r = f(b);
    it = NUM - 1;
    r.push_back({0, INF});
    for (llong i = (llong)r.size() - 1; i >= 0; i--)
    {
        for (; it >= 0; it--)
        {
            if (it >= (i == 0?0:r[i - 1].first))
            {
                d[NUM + it].first = -r[i].second;
            }
            else
            {
                break;
            }
        }
    }
    for (llong i = NUM - 1; i > 0; i--)
    {
        d[i].first = max(d[2 * i].first, d[2 * i + 1].first);
    }
    for (llong i = 0; i < p; i++)
    {
        cin >> c[i].first.first >> c[i].first.second >> c[i].second;
    }
    sort(c.begin(), c.end());
    it = 0;
    ans = 0;
    for (llong i = 0; i < e.size(); i++)
    {
        for (; it < c.size(); it++)
        {
            if (c[it].first.first < e[i].first)
            {
                add(1, 0, NUM, c[it].first.second, NUM, c[it].second, d);
            }
            else
            {
                break;
            }
        }
        update(1, d);
        ans = max(ans, d[1].first - e[i].second);
    }
    cout << ans;
    return 0;
}
