#include <bits/stdc++.h>
#define int long long

// #pragma GCC optimize("O3")
// #pragma GCC optimize("unroll-loops")
// #pragma GCC optimize("unswitch-loops")
// #pragma GCC target("avx2")

using namespace std;

void solve();

void fast() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
}

signed main() {

	fast();

	#ifdef LOCAL 
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	#endif

	// int q;
	// cin >> q;

	// while (q--)
	// 	solve();

	solve();
}

const int maxn = 200001;
const int INF = 10000001;

vector <pair<int, int>> g[maxn];

void solve() {

	int n, m;
	cin >> n >> m;

	for (int i = 0; i < m; ++i) {
		int a, b;
		cin >> a >> b;

		g[b].push_back({a, 1});
	}

	int t;
	cin >> t;

	vector <int> kek(t);
	for (auto &d: kek) 
		cin >> d;

	set <pair<int, int>> ans;
	ans.insert({0, kek.back()});

	vector <pair<int, int>> d(n + 1, {INF, 0});

	d[kek.back()] = {0, 1};

	while (ans.size()) {
		int v = ans.begin() -> second;
		ans.erase(ans.begin());

		for (auto [x, len]: g[v]) {
			if (d[x].first == d[v].first + len) {
				ans.erase({d[x].first, x});
				if (d[x].second <= 1) 
						d[x].second++;
				ans.insert({d[x].first, x});
			}
			else if (d[x].first > d[v].first + len) {
				ans.erase({d[x].first, x});
				d[x] = {d[v].first + len, d[v].second};
				ans.insert({d[x].first, x});
			}
		}
	}

	// for (int i = 1; i <= n; ++i) {
	// 	cout << d[i].second << endl;
	// }

	int mn = 0;
	int mx = 0;

	for (int i = 0; i < kek.size(); ++i) {
		if (d[kek[i]].first != (int)kek.size() - i - 1)
			mn++; 
	}

	for (int i = 0; i < kek.size(); ++i) {
		if (d[kek[i]].second != 1 || d[kek[i]].first != (int)kek.size() - i - 1)
			mx++;
	}

	cout << mn << " " << mx << endl;
}