#include <bits/stdc++.h>

using namespace std;

//#include <ext/pb_ds/detail/standard_policies.hpp>
//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>

//using namespace __gnu_pbds;
//template <typename T> using ordered_set = tree <T, null_type, less <T>, rb_tree_tag, tree_order_statistics_node_update>;

#define F first
#define S second
#define pb push_back
#define endl '\n'
#define ld long double
#define ll long long
#define int long long

const int N = 2e5 + 100;
const int M = 100;
const ld eps = 0.0000001;
const ll inf = 1e18 + 7;

vector < int > t, add;
vector < pair <int, int> > a, b;
vector < pair < pair <int, int>, int > > z;
int pr = 1;

void push(int v)
{
    t[v * 2] += add[v];
    t[v * 2 + 1] += add[v];
    add[v * 2] += add[v];
    add[v * 2 + 1] += add[v];
    add[v] = 0;
}

void upd(int l, int r, int v, int cl, int cr, int zn)
{
    if (r < cl || cr < l) return;
    if (cl != cr) push(v);
    if (l <= cl && cr <= r)
    {
        t[v] += zn;
        add[v] += zn;
        return;
    }
    int mid = (cl + cr) / 2;
    upd(l, r, v * 2, cl, mid, zn);
    upd(l, r, v * 2 + 1, mid + 1, cr, zn);
    t[v] = max(t[v * 2], t[v * 2 + 1]);
}

int32_t main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    int n, m, p;
    cin >> n >> m >> p;
    a.resize(n);
    for(int i = 0; i < n; i++)
    {
        cin >> a[i].F >> a[i].S;
    }
    b.resize(m);
    for(int i = 0; i < m; i++)
    {
        cin >> b[i].F >> b[i].S;
    }
    z.resize(p);
    for(int i = 0; i < p; i++)
    {
        cin >> z[i].F.F >> z[i].F.S >> z[i].S;
    }
    sort(a.begin(), a.end());
    sort(b.begin(), b.end());
    sort(z.begin(), z.end());

    while (pr < m) pr *= 2;
    t.resize(2 * pr);
    add.resize(2 * pr);

    for(int i = 0; i < 2 * pr; i++)
    {
        t[i] = 0;
    }

    for(int i = 0; i < m; i++)
    {
        upd(i, i, 1, 0, pr - 1, -b[i].S);
    }

    int uk = 0;
    int ans = -inf;

    for(auto to: a)
    {
        while (uk < p && z[uk].F.F < to.F)
        {
            int l = 0, r = m - 1, e = m;
            while (l <= r)
            {
                int mid = (l + r) / 2;
                if (b[mid].F > z[uk].F.S)
                {
                    e = mid;
                    r = mid - 1;
                }
                else l = mid + 1;
            }
            if (e == m)
            {
                uk++;
                continue;
            }
            upd(e, m - 1, 1, 0, pr - 1, z[uk].S);
            uk++;
        }
        int c = t[1] - to.S;
        ans = max(ans, c);
    }

    cout << ans;



}
