/*DavitMarg*/
#include <cstdio>
#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <cstring>
#include <map>
#include <unordered_map>
#include <set>
#include <queue>
#include <iomanip>
#include <bitset>
#include <stack>
#include <cassert>
#include <iterator>
#include <fstream>
#define mod 1000000007ll
#define LL long long
#define LD long double
#define MP make_pair
#define PB push_back
#define all(v) v.begin(), v.end()
using namespace std;

const int N = 200005,K=1000006;

LL t[4*K],d[4*K];

void push(int v,int l,int r,int f=1)
{
    if(d[v]==0)
        return;
    if(l!=r)
    {
        d[v*2]+=d[v];
        d[v*2+1]+=d[v];
        if(f)
        {
            int m=(l+r)/2;
            push(v*2,l,m,0);
            push(v*2+1,m+1,r,0);
        }
    }
    t[v]+=d[v];
    d[v]=0;
}

void add(int v,int l,int r,int i,int j,LL val)
{
    push(v,l,r);
    if(i>j)
        return;
    if(l==i && r==j)
    {
        d[v]+=val;
        push(v,l,r);
        return;
    }
    int m=(l+r)/2;
    add(v*2,l,m,i,min(m,j),val);
    add(v*2+1,m+1,r,max(m+1,i),j,val);
    t[v]=max(t[v*2],t[v*2+1]);
}


LL get(int v,int l,int r,int i,int j)
{
    push(v,l,r);
    if(i>j)
        return -mod*mod;
    if(l==i && r==j)
        return t[v];
    int m=(l+r)/2;
    return max(
        get(v*2,l,m,i,min(m,j)),
        get(v*2+1,m+1,r,max(m+1,i),j));
}


int n,m,k;
LL ans=-mod*mod,sa[N],sb[N],val[N],pr[K],mx;
pair<LL,LL> a[N],b[N];
pair<pair<LL,LL>,LL>c[N];


int main()
{
    cin>>n>>m>>k;
    for(int i=1;i<=n;i++)
        scanf("%lld%lld",&a[i].first,&a[i].second);
    for(int i=1;i<=m;i++)
        scanf("%lld%lld",&b[i].first,&b[i].second);
    for(int i=1;i<=k;i++)
        scanf("%lld%lld%lld",&c[i].first.first,&c[i].first.second,&c[i].second);
    sort(a+1,a+1+n);
    sort(b+1,b+1+m);
    sort(c+1,c+1+k);
    sa[n+1]=sb[m+1]=mod*mod;
    for(int i=n;i>=1;i--)
        sa[i]=min(sa[i+1],a[i].second);
    for(int i=m;i>=1;i--)
        sb[i]=min(sb[i+1],b[i].second);
    for(int i=1;i<=k;i++)
    {
        int l,r,mid;
        l=1;
        r=n;
        val[i]=mod*mod;
        while(l<=r)
        {
            mid=(l+r)/2;
            if(a[mid].first>c[i].first.first)
            {
                val[i]=sa[mid];
                r=mid-1;
            }
            else
                l=mid+1;
        }
    }


    for(int i=1;i<=K-6;i++)
    {
        int l,r,mid;
        l=1;
        r=m;
        pr[i]=mod*mod;
        while(l<=r)
        {
            mid=(l+r)/2;
            if(b[mid].first>i)
            {
                pr[i]=sb[mid];
                r=mid-1;
            }
            else
                l=mid+1;
        }
        add(1,1,K-6,i,i,-pr[i]);
    }
    for(int i=1;i<=k;i++)
    {
        add(1,1,K-6,c[i].first.second,K-6,c[i].second);
        LL best=get(1,1,K-6,1,K-6);
        ans=max(ans,best-val[i]);
    }
    cout<<ans<<endl;
    return 0;
}

/*




*/
