#include <iostream>
#include <vector>

using namespace std;

typedef long long ll;
#define forn(i0, n0) for (int i0 = 0; i0 < n0; ++i0)
typedef vector<int> vi;

void init(){
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
}

int n;
vi r, b;

bool check(int x){
    int sum = 0;
    forn(i, n){
        if (r[i] != b[i]){
            if (b[i] == 1) sum--; else sum += x;
        }
    }
    return (sum > 0);
}

void solve(){
    cin >> n;
    r.resize(n);
    b.resize(n);
    forn(i, n) cin >> r[i];
    forn(i, n) cin >> b[i];
    if (!check(1000)){
        cout << "-1\n";
        return;
    }
    int l = 1, r = 1000;
    while (l < r){
        int m = (l + r) >> 1;
        if (check(m)) r = m; else l = m + 1;
    }
    cout << l << '\n';
}

bool multitest = false;

int main(){
    init();
    int t = 1;
    if (multitest) cin >> t;
    forn(i, t) solve();
    return 0;
}