#include <iostream>
#include <vector>
#include <map>

using namespace std;

typedef long long ll;
#define forn(i0, n0) for (int i0 = 0; i0 < n0; ++i0)
typedef vector<int> vi;
typedef pair<int, int> pii;
#define F first
#define S second
typedef vector<bool> vb;

void init(){
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
}

const int N = 4e5 + 1;

void solve(){
    int n;
    string s;
    cin >> n >> s;
    int ans = 0;
    for (int i0 = 25; i0 > 0; --i0){
        char c = 'a' + i0;
        char c1 = 'a' + i0 - 1;
        vb used(n);
        forn(i, n){
            if (s[i] == c){
                int j = i;
                while (j + 1 < n && s[j + 1] == c) j++;
                bool b = 0;
                if (i > 0 && s[i - 1] == c1) b = 1;
                if (j + 1 < n && s[j + 1] == c1) b = 1;
                if (b){
                    for (int z = i; z <= j; ++z){
                        ans++;
                        used[z] = 1;
                    }
                    i = j;
                }
            }
        }
        string s1;
        forn(i, s.length()){
            if (!used[i]) s1 += s[i];
        }
        s = s1;
        n = s.length();
    }
    cout << ans << '\n';
}

bool multitest = false;

int main(){
    init();
    int t = 1;
    if (multitest) cin >> t;
    forn(i, t) solve();
    return 0;
}
