#include <iostream>
#include <vector>
#include <map>
#include <queue>

using namespace std;

typedef long long ll;
#define forn(i0, n0) for (int i0 = 0; i0 < n0; ++i0)
typedef vector<int> vi;
typedef pair<int, int> pii;
#define F first
#define S second
typedef vector<bool> vb;
typedef vector<vi> vvi;
#define pb push_back

void init(){
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    //freopen("input.txt", "r", stdin);
}

void solve(){
    int n, m;
    cin >> n >> m;
    vvi g(n), g1(n);
    forn(i, m){
        int v, u;
        cin >> v >> u;
        v--, u--;
        g[v].pb(u);
        g1[u].pb(v);
    }
    int k;
    cin >> k;
    vi p(k);
    forn(i, k){
        cin >> p[i];
        p[i]--;
    }
    int s = p[0], t = p.back();
    vi d(n, -1);
    d[t] = 0;
    vvi pr(n);
    queue<int> q;
    q.push(t);
    vi ord;
    ord.pb(t);
    while (!q.empty()){
        int v = q.front();
        q.pop();
        forn(z, g1[v].size()){
            int u = g1[v][z];
            if (d[u] == -1){
                d[u] = d[v] + 1;
                q.push(u);
                ord.pb(u);
                pr[u].pb(v);
            } else {
                if (d[u] == d[v] + 1){
                    pr[u].pb(v);
                } else {
                    if (d[u] > d[v] + 1){
                        d[u] = d[v] + 1;
                        pr[u].clear();
                        pr[u].pb(v);
                    }
                }
            }
        }
    }
    vi dp1(k), dp2(k);
    for (int i = k - 2; i >= 0; --i){
        bool flag = 0;
        forn(z, pr[p[i]].size()){
            int j = pr[p[i]][z];
            if (j == p[i + 1]){
                flag = 1;
                break;
            }
        }
        if (!flag){
            dp1[i] = 1 + dp1[i + 1];
            dp2[i] = 1 + dp2[i + 1];
        } else {
            if (pr[p[i]].size() == 1){
                dp1[i] = dp1[i + 1];
                dp2[i] = dp2[i + 1];
            } else {
                dp1[i] = dp1[i + 1];
                dp2[i] = 1 + dp2[i + 1];
            }
        }
    }
    cout << dp1[0] << ' ' << dp2[0] << '\n';
}

bool multitest = false;

int main(){
    init();
    int t = 1;
    if (multitest) cin >> t;
    forn(i, t) solve();
    return 0;
}