#include <bits/stdc++.h>
#define fi first
#define se second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define out(t, a) copy(all(a), ostream_iterator<t>(cout, " ")); cout << "\n";
//#define DEBUG
#define int long long

using namespace std;

void set_program() {
	#ifdef DEBUG
		freopen("test.in", "r", stdin);
		freopen("test.out", "w", stdout);
	#endif // DEBUG
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
}

typedef long double ld;
typedef long long ll;

const int ALF = 26;
const int LOGN = 20;
const int MOD = 1e9 + 7;
const int MAXN = 2e5;
const int INF = 1e9 + 7;

void solve() {
    int n;
    cin >> n;
    int cnt1, cnt2;
    cnt1 = cnt2 = 0;
    vector <int> a(n), b(n);
    for (int& i : a) {
        cin >> i;
    }
    for (int& i : b) {
        cin >> i;
    }
    for (int i = 0; i < n; ++i) {
        cnt1 += a[i] == 1 && b[i] == 0;
        cnt2 += a[i] == 0 && b[i] == 1;
    }
    if (cnt1 == 0) {
        cout << "-1\n";
        return;
    }
    if (cnt2 == 0) {
        cout << "1\n";
        return;
    }
    int l = 0, r = INF;
    for (; r - l > 1; ) {
        int mid = (l + r) / 2;
        if (mid * cnt1 > cnt2) {
            r = mid;
        } else {
            l = mid;
        }
    }
    cout << r << "\n";
}

main() {
	set_program();
	int t;
	#ifdef DEBUG
        t = 4;
    #else
        t = 1;
	#endif // DEBUG
	for (; t--; ) {
        solve();
        cout << "\n";
	}
	return 0;
}
