#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
#include <map>
#include <algorithm>
#include <set>
#include <queue>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> pll;

const ll modd = 1e9 + 7, inff = 1e18;

#define pb push_back
#define mp make_pair
#define vi vector<ll>
#define vvi vector<vi>
#define vec vector
#define all(a) a.begin(), a.end()
#define x first
#define y second

void run() {
	ll n, m;
	cin >> n >> m;
	vvi g(n, vi(0, 0));
	vi sum(n, inff);
	vi pre(n, 0);
	vvi mass(n, {});
	ll a, b;
	for (ll i = 0; i < m; ++i) {
		cin >> a >> b;
		a--, b--;
		g[b].pb(a);
	}
	ll k;
	cin >> k;
	vi path(k);
	for (auto &p : path) {
		cin >> p;
		p--;
	}
	reverse(all(path));
	set <pll> s;
	sum[path[0]] = 0;
	s.insert({ 0, path[0] });
	pll t;
	while (!s.empty()) {
		t = *s.begin();
		s.erase(s.begin());
		for (auto u : g[t.y]) {
			if (sum[t.y] + 1 == sum[u])
				pre[u]++;
			else if (sum[t.y] + 1 < sum[u]) {
				s.erase({ sum[u], u });
				pre[u] = 1;
				sum[u] = sum[t.y] + 1;
				s.insert({ sum[u], u });
			}
		}
	}
	reverse(all(path));
	ll mn = 0, mx = 0;
	for (ll i = 0; i < k - 1; ++i) {
		if (sum[path[i]] != sum[path[i + 1]] + 1) {
			mn++;
			mx++;
		}
		else {
			if (pre[path[i]] > 1)
				mx++;
		}
	}
	cout << mn << " " << mx;
}

signed main() {
	//freopen("text.txt", "r", stdin);
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	run();
	//fclose(stdin);
	//system("pause");
	return 0;
}