#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
#include <map>
#include <algorithm>
#include <set>
#include <queue>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> pll;

const ll modd = 1e9 + 7, inff = 1e18;

#define pb push_back
#define mp make_pair
#define vi vector<ll>
#define vvi vector<vi>
#define vec vector
#define all(a) a.begin(), a.end()
#define x first
#define y second

void run() {
	ll n, m, p;
	cin >> n >> m >> p;
	vec <pll> gans(n), health(m), healmon, ganmon;
	vec <pair<pll, ll>> monsters(p);
	for (auto &v : gans)
		cin >> v.x >> v.y;
	for (auto &v : health)
		cin >> v.x >> v.y;
	ll ii = -1;
	for (auto &v : monsters) {
		ii++;
		cin >> v.x.x >> v.x.y >> v.y;
		healmon.pb({ v.x.x, ii });
		ganmon.pb({ v.x.y, ii });
	}
	sort(all(gans));
	sort(all(health));
	sort(all(healmon));
	sort(all(ganmon));
	vi prgan(n), prheal(m)/*, left(p), right(p)*/;
	prgan[n - 1] = gans[n - 1].y;
	prheal[m - 1] = health[m - 1].y;
	for (ll i = n - 2; i >= 0; i--)
		prgan[i] = min(gans[i].y, prgan[i + 1]);
	for (ll i = m - 2; i >= 0; i--)
		prheal[i] = min(health[i].y, prheal[i + 1]);
	vec <int> usedmon(p, 0);
	ll g = 0, h = 0, ans = -prgan[0] - prheal[0];
	ll cnt = 0;
	/*vi costlef(p, inff), costrig(p, inff);
	for (ll i = 0; i < p; ++i) {
		left[healmon[i].y] = i;
		right[ganmon[i].y] = i;
		while (g < n && gans[g].x <= healmon[i].x)
			g++;
		if (g != n)
			s
	}*/
	for (ll i = 0; i < p; ++i) {
		if (usedmon[healmon[i].y])
			cnt += monsters[healmon[i].y].y;
		else
			usedmon[healmon[i].y]++;
		if (usedmon[ganmon[i].y])
			cnt += monsters[ganmon[i].y].y;
		else
			usedmon[ganmon[i].y]++;
		while (g < n && gans[g].x <= healmon[i].x)
			g++;
		while (h < m && health[h].x <= ganmon[i].x)
			h++;
		if (g == n || h == m)
			break;
		ans = max(ans, cnt - prgan[g] - prheal[h]);
	}
	cout << ans;
}

signed main() {
	//freopen("text.txt", "r", stdin);
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	run();
	//fclose(stdin);
	system("pause");
	return 0;
}