#pragma GCC target("avx2")
#pragma GCC optimize("O3")
#include<x86intrin.h>
#include<bits/stdc++.h>

#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;

#define ll long long
#define ld long double
#define pb push_back
#define sz(x) (int)x.size()
#define every(x) x.begin(), x.end()
#define mp make_pair
#define F first
#define S second
#define lb lower_bound
#define ub upper_bound
#define SpeedForce ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0)
#define For(i,x,y) for(int i=x;i<=y;++i)
#define FOr(i,x,y) for(int i=x;i>=y;--i)

using pt = pair<int,int>;
template<typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

const int N = 6e5 + 32;
const int mod = 1e9 + 7;
const int inf = 1e9+123;
const int K = 2e5 + 5;
const double pi = acos(-1);

int n, m, k;         
int lg[N];
vector < int > g[N], ans[N], x[N], y[N], s[N];

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

struct Data {
	vector < pair<int, int> > ord;
	int d[N], tin[N], tout[N];
	pair <int,int> st[20][N];
	bool u[N];

	void clear () {
		ord.clear();
		for (int i = 1; i <= n; ++i) d[i] = 0, u[i] = 0;
	}

	void build () {
		int m = sz(ord);
		for (int i = 0; i < m; ++i) {
			st[0][i] = ord[i];
		}
		for (int j = 1; j <= lg[m]; ++j) {
			for (int i = 0; i + (1 << j) <= m; ++i) {
				st[j][i] = min(st[j-1][i], st[j-1][i+(1<<(j-1))]);
			}
		}
	}

	void dfs (int v, int par = 0) {
		u[v] = 1;
		tin[v] = sz(ord);
		ord.pb({d[v], v});

		for (auto to : g[v]) if (!u[to]) {
			d[to] = d[v] + 1;
			dfs(to, v);
			ord.pb({d[v], v});
		}
		tout[v] = sz(ord);
	}

	int lca (int l, int r) {
		l = tin[l], r = tin[r];
		if (l > r) swap(l, r);

		int len = r- l + 1;                  
		len = lg[len];
		return min(st[len][l], st[len][r - (1 << len) + 1]).second;
	}
	bool upper (int a, int b) {
		return tin[a] <= tin[b] && tout[b] <= tout[a];
	}

	int dist (int l, int r) {
		return d[l] + d[r] - 2 * d[lca(l, r)];
	}
} T;

int c[N];

struct vir {
	int id, s, d, vv;

};

inline void go (int id, int k, int m, vector<int> &x, vector <int>&s, vector<int> &y) {
	for (int i = 1; i <= n; ++i) {
		c[i] = 0;
	}	

	queue < vir > q;
	for (int i = 0; i < k; ++i) {
		vir cc;
		cc.id = i+1;
		cc.s = s[i];
		cc.d = 0;
		cc.vv = x[i];
		c[x[i]] = i+1;
		q.push(cc);
	}
	/*
	while(q.size()) {
		auto it = q.front();
		q.pop();
		if(c[it.vv] != it.id) continue;

		vector < int > nxt;
		queue < vir > o;
		o.push(it);
		while(o.size()) {
			auto v = o.front();
			o.pop();

			for (auto to : g[v]) if (!c[to]) {
				if(v.d+1 == v.s) {
					nxt.pb(to);
				}
			}
		}
		
	}  */
}

inline void solve () {
	scanf("%d", &n);
	for (int i = 1; i < n; i ++) {
		int l, r;
		scanf("%d %d", &l, &r);
		g[l].pb(r);
		g[r].pb(l);
	}
	for (int i = 2; i < N; ++i) lg[i] = lg[i/2] + 1;
	
	T.clear();
	T.dfs(1);
	T.build();


	int q;
	scanf("%d", &q);
	for (int i = 1; i <= q; ++i) {
		int k, m;
		scanf("%d %d", &k, &m);
		
		x[i].resize(k);
		s[i].resize(k);
		y[i].resize(m);
		ans[i].resize(m);
		for (int j = 0; j < k; ++j) {
			scanf("%d %d", &x[i][j], &s[i][j]);
		}
		for (int j = 0; j < m; ++j) {
		    scanf("%d", &y[i][j]);
		}
		if (k <= K) {
			
			for (int a = 0, vv; a < m; ++a) {
				int res = 0;
				vv = y[i][a];
				for (int b = 1; b < k; ++b) {
					int aa = T.lca(x[i][res], vv), bb = T.lca(x[i][b], vv);
					if(T.upper(aa, bb)) aa = bb;
						
					int da = (T.dist(bb, x[i][res]) - 1 + s[i][res]) / s[i][res];
					int db = (T.dist(bb, x[i][b]) - 1 + s[i][b]) / s[i][b];
					//cout << vv << ' ' << da << ' ' << db << '\n';
					if (db < da) res = b; 
				}
				ans[i][a] = res+1;
			}
		} else {
			go(i, k, m, x[i], s[i], y[i]);
		}				
	}

	for (int i = 1; i <= q; ++i) {
		for (auto j : ans[i]) printf("%d ", j);
		puts("");
	}

}

int32_t main () {
	int tt = 1;
	//scanf("%d", &tt);
	//cin >> tt;
	for (; tt > 0; --tt) {
		solve();
	}
}