#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <stack>
#include <queue>
#include <deque>
#include <iomanip>
#include <numeric>
#include <string>
#include <map>

#define all(a) a.begin(), a.end()
#define z(a) fixed << setprecision(a)
#define nl '\n'

using namespace std;

#define int long long

const int MAXN = 1e9 + 10;
const int MOD = 1e9+7;

void IO() {
#ifndef ONLINE_JUDGE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
}

inline void solve(){
	int n;
	cin >> n;
	vector<int> a(n);
	map<int, int> m;
	for (int i=0;i<n; i++){
		cin >> a[i];
		m[a[i] - i]+=a[i];
	}
	int ans = 0;
	while (m.size()){
		auto t = *m.begin();
		m.erase(m.begin());
		ans = max(ans, t.second);
	}
	cout << ans;
}

signed main() {
	IO();
	int t = 1;
	while (t--)
		solve();
	return 0;
}