#include <iostream>
#include <vector>
#include <set>
#include <queue>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    vector<vector<int> > g(n);
    vector<vector<int> > tg(n);
    for (int i = 0; i < m; i++){
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        g[u].push_back(v);
        tg[v].push_back(u);
    }
    int k;
    cin >> k;
    vector<int> p(k);
    for (int i = 0; i < k; i++){
        cin >> p[i];
        p[i]--;
    }
    int t = p[k - 1];
    vector<int> d(n, 1e9);
    d[t] = 0;
    queue<int> q;
    q.push(t);
    while (q.size()){
        int v = q.front();
        q.pop();
        for (auto i : tg[v]){
            if (d[i] > d[v] + 1){
                d[i] = d[v] + 1;
                q.push(i);
            }
        }
    }

    vector<set<int> > pos(n);
    for (int i = 0; i < n; i++){
        for (auto j : g[i]){
            if (d[j] == d[i] - 1){
                pos[i].insert(j);
            }
        }
    }

    int mn = 0;
    int mx = 0;

    for (int i = 0; i < k - 1; i++){
        int v = p[i];
        if (pos[v].find(p[i + 1]) == pos[v].end()){
            mn++;
            mx++;
        }else if (pos[v].size() >= 2){
            mx++;
        }
    }
    cout << mn << ' ' << mx << endl;
    return 0;
}
