#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <cstdio>
#include <cmath>
#include <set>
#include <map>

#define all(x) x.begin(), x.end()

using namespace std;

typedef long long ll;

const ll inf = ll(1e18) + 228;
const ll cst = 2e5 + 5;
const ll mod = 1e9 + 7;

ll n;

map<ll, ll> mp;

ll ans = 0;

int main(){
    cin >> n;
    for(int i = 1; i <= n; i++){
        ll x;
        cin >> x;
        mp[x - i] += x;
    }
    for(auto i : mp){
        ans = max(ans, i.second);
    }
    cout << ans;
    return 0;
}
