#include <bits/stdc++.h>

typedef int32_t i32;
typedef int64_t i64;

const i32 INF32 = 1000000000;
const i64 INF64 = 1000000000000000000;

using namespace std;

i32 main() {
  #ifdef DEBUG
  freopen("input.txt", "r", stdin);
  #endif
  ios_base::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);

  i32 count;
  cin >> count;

  string str;
  cin >> str;

  str.insert(0, 1, 'a' - 10);
  str.push_back('a' - 10);

  i32 start = 0;
  i32 ans = 0;
  for (i32 finish = 1; finish < (i32) str.size(); finish++) {
    if (str[finish] <= 'a') {
      if (start == 0 && finish == (i32) str.size() - 1) {
	continue;
      }
      
      pair<i32, i32> chars[finish - start + 1];
      chars[0] = { str[start] - 'a', 1 };
      i32 chars_count = 1;

      for (i32 i = start + 1; i < finish; i++) {
	if (str[i] - 'a' == chars[chars_count - 1].first) {
	  chars[chars_count - 1].second++;
	} else {
	  chars[chars_count].first = str[i] - 'a';
	  chars[chars_count].second = 1;
	  chars_count++;
	}
      }

      chars[chars_count] = { str[finish] - 'a', 1 };
      chars_count++;

      i32 last_min = 0;
      i32 last_max = 0;

      vector<i32> before_max;
      vector<i32> after_max;

      if (chars_count == 2) {
	start = finish;
	continue;
      }

      for (i32 curr_min = 1; curr_min < chars_count; curr_min++) {
	bool maximum = curr_min < chars_count - 1 && chars[curr_min].first > chars[curr_min - 1].first && chars[curr_min].first > chars[curr_min + 1].first;
	
	if (maximum) {
	  last_max = curr_min;
	  continue;
	}
	
	bool minimum = curr_min == chars_count - 1 || (chars[curr_min].first < chars[curr_min - 1].first && chars[curr_min].first < chars[curr_min + 1].first);

	if (minimum) {
	  i32 i1 = (i32) before_max.size() - 1;
	  i32 i2 = 0;

	  bool max_removed = false;
	  if (i1 >= 0 && chars[last_max].first - chars[before_max[i1]].first <= 1) {
	    ans += chars[last_max].second;
	    max_removed = true;
	  } else if (i2 < (i32) after_max.size() && chars[last_max].first - chars[after_max[i2]].first <= 1) {
	    ans += chars[last_max].second;
	    max_removed = true;
	  } else if (i1 < 0 && chars[last_max].first - chars[last_min].first == 1) {
	    ans += chars[last_max].second;
	    max_removed = true;
	  } else if (i2 >= (i32) after_max.size() && chars[last_max].first - chars[curr_min].first == 1) {
	    ans += chars[last_max].second;
	    max_removed = true;
	  }

	  if (max_removed) {
	    i32 removed1 = 0;
	    i32 removed2 = 0;
	    
	    while (i1 >= 0 || i2 < (i32) after_max.size()) {
	      if (i1 >= 0 && i2 < (i32) after_max.size()) {
		i32 diff = chars[before_max[i1]].first - chars[after_max[i2]].first;
		if (diff == 1) {
		  ans += chars[before_max[i1]].second;
		  i1--;
		  removed1++;
		  continue;
		} else if (diff == -1) {
		  ans += chars[after_max[i2]].second;
		  i2++;
		  removed2++;
		  continue;
		}
	      }

	      if (i1 >= 1) {
		i32 diff = chars[before_max[i1]].first - chars[before_max[i1 - 1]].first;
		if (diff == 1) {
		  ans += chars[before_max[i1]].second;
		  i1--;
		  removed1++;
		  continue;
		}
	      } else if (i1 == 0) {
		i32 diff = chars[before_max[i1]].first - chars[last_min].first;
		if (diff == 1) {
		  ans += chars[before_max[i1]].second;
		  i1--;
		  removed1++;
                  continue;
                }
	      }

	      if (removed2 == (i32) after_max.size() && (i32) before_max.size() - i1 - 1 == removed1) {
		i32 diff = chars[before_max[i1]].first - chars[curr_min].first;
		if (diff == 1) {
		  ans += chars[before_max[i1]].second;
		  i1--;
		  removed1++;
		  continue;
		}
	      }

	      if (i2 < (i32) after_max.size() - 1) {
		i32 diff = chars[after_max[i2]].first - chars[after_max[i2 + 1]].first;
		if (diff == 1) {
		  ans += chars[after_max[i2]].second;
		  i2++;
		  removed2++;
		  continue;
		}
	      } else if (i2 == (i32) after_max.size() - 1) {
		i32 diff = chars[after_max[i2]].first - chars[curr_min].first;
		if (diff == 1) {
		  ans += chars[after_max[i2]].second;
		  i2++;
		  removed2++;
		  continue;
		}
	      }

	      if (removed1 == (i32) before_max.size() && i2 == removed2) {
		i32 diff = chars[after_max[i2]].first - chars[last_min].first;
		if (diff == 1) {
		  ans += chars[after_max[i2]].second;
		  i2++;
		  removed2++;
		  continue;
		}
	      }

	      i1--;
	      i2++;
	    }

	    if (removed1 == (i32) before_max.size() && removed2 == (i32) after_max.size()) {
	      i32 diff = chars[last_min].first - chars[curr_min].first;
	      if (diff == 1) {
		ans += chars[last_min].second;
		str[finish] = chars[last_min].first + 'a';
	      } else if (diff == -1) {
		ans += chars[curr_min].second;
	      }
	    }
	  } else {
	    while (i1 >= 0) {
	      if (i1 >= 1) {
		i32 diff = chars[before_max[i1]].first - chars[before_max[i1 - 1]].first;
		if (diff == 1) {
		  ans += chars[before_max[i1]].second;
		  i1--;
		  continue;
		}
	      } else {
		i32 diff = chars[before_max[i1]].first - chars[last_min].first;
		if (diff == 1) {
		  ans += chars[before_max[i1]].second;
		  i1--;
		  continue;
		}
	      }
	      i1--;
	    }

	    while (i2 < (i32) after_max.size()) {
	      if (i2 < (i32) after_max.size() - 1) {
		i32 diff = chars[after_max[i2]].first - chars[after_max[i2 + 1]].first;
		if (diff == 1) {
		  ans += chars[after_max[i2]].second;
		  i2++;
		  continue;
		}
	      } else {
		i32 diff = chars[after_max[i2]].first - chars[curr_min].first;
		if (diff == 1) {
		  ans += chars[after_max[i2]].second;
		  i2++;
		  continue;
		}
	      }
	      i2++;
	    }
	  }

	  after_max.clear();
	  before_max.clear();

	  last_min = curr_min;
	  continue;
	}
	
	if (last_max > last_min) {
	  after_max.push_back(curr_min);
	} else {
	  before_max.push_back(curr_min);
	}
      }
      
      start = finish;
    }
  }

  cout << ans << "\n";

  return 0;
}
