#include <iostream>
#include <map>
#include <vector>
#include <queue>

using namespace std;

void solve();

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif
    solve();
    return 0;
}

#define int long long

const int maxN = 2e5 + 10, inf = 1e18;

int n, m, k, p[maxN], d[maxN];
vector < int > a[maxN], ra[maxN];
bool used[maxN];
queue < int > q;

void solve() {
    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int f, s;
        cin >> f >> s;
        a[f - 1].push_back(s - 1);
        ra[s - 1].push_back(f - 1);
    }
    cin >> k;
    for (int i = 0; i < k; i++) {
        cin >> p[i];
        p[i]--;
    }
    q.push(p[k - 1]);
    used[p[k - 1]] = true;
    while (!q.empty()) {
        int cur = q.front();
        q.pop();
        for (int i = 0; i < ra[cur].size(); i++) {
            int to = ra[cur][i];
            if (!used[to]) {
                used[to] = true;
                d[to] = d[cur] + 1;
                q.push(to);
            }
        }
    }
    int mn = 0, mx = 0;
    for (int i = 0; i < k - 1; i++) {
        int cur = p[i];

        int mnn = inf, cnt = 0;
        for (int j = 0; j < a[cur].size(); j++) {
            int to = a[cur][j];
            if (d[to] < mnn) {
                mnn = d[to];
                cnt = 1;
            } else if (d[to] == mnn) {
                cnt++;
            }
        }
        int nxt = p[i + 1];
        if (d[nxt] > mnn) {
            mn++;
            mx++;
        } else {
            if (cnt > 1) {
                mx++;
            }
        }
    }
    cout << mn << " " << mx;
}