#include <bits/stdc++.h>

using namespace std;

#define int long long

int n;
vector<int> b, dp;

void dfs(int index, int prev = 0) {
    dp[index] = b[index] + dp[prev];
    for(int i = index + 1; i <= n; ++i) {
        if(i - index == b[i] - b[index] and dp[index] + b[i] > dp[i]) {
            dfs(i, index);
        }
    }
}

signed main() {
    // freopen("input.txt", "r", stdin);
    // freopen("output.txt", "w", stdout);
    cin >> n;
    b.resize(n + 1);
    dp.resize(n + 1);
    for(int i = 1; i <= n; ++i) {
        cin >> b[i];
    }
    for(int i = 1; i <= n; ++i) {
        if(dp[i] == 0) {
            dfs(i);
        }
    }
    int answer = 0;
    for(int i = 1; i <= n; ++i) {
        answer = max(answer, dp[i]);
        answer = max(answer, b[i]);
    }
    cout << answer << endl;
}
