#include <bits/stdc++.h>

using namespace std;

#define int long long

int n;
vector<pair<int, int>> b;
vector<int> dp;

void dfs(int index, int prev = 0) {
    dp[index] = b[index].first + dp[prev];
    for (int i = index + 1; i <= n; ++i) {
        if (b[i].first - b[index].first == b[i].second - b[index].second and dp[index] + b[i].first > dp[i]) {
            dfs(i, index);
        }
    }
}

signed main() {
    // freopen("input.txt", "r", stdin);
    // freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> n;
    b.resize(n + 1);
    dp.resize(n + 1);
    for(int i = 1; i <= n; ++i) {
        int t; cin >> t;
        b[i] = {t, i};
    }
    sort(b.begin(), b.end());
    for(int i = 1; i <= n; ++i) {
        if(dp[i] == 0) {
            dfs(i);
        }
    }
    int answer = 0;
    for(int i = 1; i <= n; ++i) {
        answer = max(answer, dp[i]);
        answer = max(answer, b[i].first);
    }
    cout << answer << endl;
}
