#include <bits/stdc++.h>

using namespace std;

#define int long long

map<string, int> dp;

string cut(string s, int index) {
    string ret;
    for(int i = 0; i < s.size(); ++i) {
        if(i != index) ret += s[i];
    }
    return ret;
}

int dfs(string s) {
    if(s.size() == 1) return 0;
    if(dp.find(s) != dp.end()) {
        return dp[s];
    }
    int ret = 0;
    for(int i = 0; i < s.size(); ++i) {
        if(i == 0) {
            if(s[1] == s[0] - 1) {
                ret = max(ret, dfs(cut(s, 0)) + 1);
            }
        } else if(i == s.size() - 1) {
            if(s[i - 1] == s[i] - 1) {
                ret = max(ret, dfs(cut(s, i)) + 1);
            }
        } else {
            if(s[i - 1] == s[i] - 1 or s[i + 1] == s[i] - 1) {
                ret = max(ret, dfs(cut(s, i)) + 1);
            }
        }
    }
    dp[s] = ret;
    return dp[s];
}

signed main() {
    // freopen("input.txt", "r", stdin);
    // freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    string s;
    cin >> s;
    cout << dfs(s) << endl;
}
