#include <bits/stdc++.h>

using namespace std;

#define int long long

vector<set<int>> gr;

vector<pair<int, int>> dist;

vector<bool> used;

pair<int, int> dfs1(int v, int to, int p = -1) {
    if(v == to) {
        dist[v] = {0, 1};
        used[v] = true;
        return dist[v];
    }
    if(dist[v].first != 1e9 or used[v]) {
        used[v] = true;
        return dist[v];
    }
    int ret = 1e9, count = 0;
    for(int i: gr[v]) {
        if(i != p and i != v) {
            int tmp = dfs1(i, to, v).first + 1;
            if(tmp > ret) continue;
            if(tmp == ret) {
                ++count;
            } else {
                ret = tmp;
                count = 1;
            }
        }
    }
    dist[v] = {ret, count};
    used[v] = true;
    return dist[v];
}

signed main() {
    // freopen("input.txt", "r", stdin);
    // freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m, k;
    cin >> n >> m;
    dist.resize(n + 1, {1e9, 0});
    gr.resize(n + 1);
    used.resize(n + 1, false);
    for(int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        gr[u].insert(v);
    }
    cin >> k;
    vector<int> p(k);
    for(int i = 0; i < k; ++i) {
        cin >> p[i];
    }
    int s = p[0], t = p[k - 1];
    for(int i : p) {
        if(not used[i]) dfs1(i, t);
    }
    // a - min, b - max
    int a = 0, b = 0;
    for(int i = 0; i < k; ++i) {
        int v = p[i];
        if(dist[v].first < k - i - 1) {
            ++a, ++b;
        } else if(dist[v].second != 1) {
            ++b;
        }
    }
    cout << a << " " << b << endl;
}