#include <iostream>
#include <vector>
#include <algorithm>
#include <assert.h>
#include <set>
#include <map>
using namespace std;

#define ll long long
#define vll vector<ll>
#define pll pair<ll, ll>
#define vpll vector<pll >
#define vii vector<int>
#define vbb vector<bool>
#define pii pair<int, int>
#define vpii vector<pii >
#define pb push_back

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    ll n;
    cin >> n;
    vll b(n);
    for(int i = 0; i < n; i++)
        cin >> b[i];

    vll sufSum(n);
    map<ll, vll> mp;
    for(int i = n - 1; i >= 0; i--)
    {
        ll cur = i - b[i];
        if(i == n - 1)
        {
            sufSum[i] = b[n - 1];
        }
        else
        {
            vll temp = mp[cur];
            mp[cur] = {};
            sufSum[i] = b[i];
            for(int j = 0; j < temp.size(); j++)
                sufSum[i] = max(sufSum[i], sufSum[temp[j]] + b[i]);
        }

        if(mp.count(cur) == 0)
            mp[cur] = {i};
        else
            mp[cur].pb(i);
    }

    ll answ = 0;
    for(int i = 0; i < sufSum.size(); i++)
        answ = max(sufSum[i], answ);
    cout << answ << endl;
    return 0;
}