#include <iostream>
#include <vector>
#include <algorithm>
#include <assert.h>
#include <set>
#include <queue>
#include <map>
using namespace std;

#define ll long long
#define vll vector<ll>
#define pll pair<ll, ll>
#define vpll vector<pll >
#define vii vector<int>
#define vbb vector<bool>
#define pii pair<int, int>
#define vpii vector<pii >
#define pb push_back

ll n, m, k;
vll p;
vector<vll > nodesT;
vii ways;
vll len;
vector<vll > pr;

void bfs()
{
    queue<ll> q;
    q.push(p.back());
    ways[p.back()] = 1;
    while(q.size() > 0)
    {
        ll cur = q.front();
        q.pop();

        for(int i = 0; i < nodesT[cur].size(); i++)
        {
            ll to = nodesT[cur][i];

            if(to == p.back())
                continue;

            if(ways[to] == 0)
            {
                ways[to] = 1;
                len[to] = len[cur] + 1;
                pr[to].pb(cur);
                q.push(to);
            }
            else if(len[to] == len[cur] + 1)
            {
                ways[to] = 2;
            }
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    cin >> n >> m;
    nodesT.resize(n);
    len.resize(n);
    ways.resize(n);
    pr.resize(n);

    for(int i = 0; i < m; i++)
    {
        ll x, y;
        cin >> x >> y;
        x--;
        y--;
        nodesT[y].pb(x);
    }
    cin >> k;
    p.resize(k);
    for(int i = 0; i < k; i++)
    {
        cin >> p[i];
        p[i] -= 1;
    }
    bfs();

    ll mnAnsw = 0;
    ll mxAnsw = 0;
    for(int i = 0; i < k - 1; i++)
    {
       // cerr << "i " << i << " " << mnAnsw << " " << mxAnsw << endl;
        ll ostLen = k - i - 1;
        ll curLen = len[p[i]];

        //cerr << "curLen " << curLen << " " << ostLen << endl;
        if(curLen != ostLen)
        {
            bool flag = 0;
            for(int j = 0; j < pr[p[i]].size(); j++)
            {
                if(pr[p[i]][j] == p[i + 1])
                    flag = 1;
            }
            if(!flag)
                mnAnsw++;
            if(ways[p[i]] == 2 || !flag)
                mxAnsw++;
            continue;
        }
        if(ways[p[i]] == 2)
            mxAnsw++;
    }
    cout << mnAnsw << " " << mxAnsw << endl;
    return 0;
}