#include <bits/stdc++.h>

using namespace std;
#define ON_START ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);

#define int long long
#define double long double
#define endl "\n"

//#define MULTITEST

#ifdef LOCAL
ifstream fin; // NOLINT(cert-err58-cpp)
#define cin fin
#endif

inline void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> go[n];
    vector<int> gor[n];
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        go[u].push_back(v);
        gor[v].push_back(u);
    }
    int k;
    cin >> k;
    int p[k];
    for (int i = 0; i < k; i++) {
        cin >> p[i];
        p[i]--;
    }

    int dist[n];
    for (int i = 0; i < n; i++) {
        dist[i] = INT64_MAX;
    }
    dist[p[k - 1]] = 0;
    deque<int> q;
    q.push_back(p[k - 1]);
    while (!q.empty()) {
        int v = q.front();
        q.pop_front();

        for (int g : gor[v]) {
            if (dist[g] != INT64_MAX) {
                continue;
            }
            dist[g] = dist[v] + 1;
            q.push_back(g);
        }
    }

    int minr = 0;
    int maxr = 0;
    for (int i = 0; i < k - 1; i++) {
        int v = p[i];
        int u = p[i + 1];
        if (dist[v] != dist[u] + 1) {
            minr++;
            maxr++;
            continue;
        }


        int cntst = 0;
        for (int g : go[v]) {
            if (dist[g] == dist[v] - 1) {
                cntst++;
            }
        }
        if (cntst > 1) {
            maxr++;
        }
    }

    cout << minr << " " << maxr << endl;
}

int32_t main() {
#ifdef LOCAL
    cin.open("in.txt");
#endif
    ON_START
#ifdef MULTITEST
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
#endif
    solve();
#ifdef MULTITEST
    }
#endif
    return 0;
}
