#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <string>
#include <queue>
using namespace std;

typedef long long ll;

vector <vector <int> > g, grev;
vector <bool> used;
vector <int> d, cnt;

void bfs(int s){
	queue <int> q;
	q.push(s);
	cnt[s] = 1;
	used[s] = true;
	while(q.size()){
		int v = q.front();
		q.pop();
		for(int i = 0;i < grev[v].size();i++){
			if(used[grev[v][i]] && d[v] + 1 == d[grev[v][i]]) cnt[grev[v][i]]++;
			else if(!used[grev[v][i]]){
				q.push(grev[v][i]);
				used[grev[v][i]] = true;
				d[grev[v][i]] = d[v] + 1;
				cnt[grev[v][i]] = 1;
			}
		}
	}
}

int main(){

//	fstream cin("input.txt");
//	ofstream cout("output.txt");
	
	int n, m, k, a = 0, b = 0; cin >> n >> m;
	g.resize(n + 1); used.resize(n + 1);
	grev.resize(n + 1); d.resize(n + 1);
	cnt.resize(n + 1);

	for(int i = 0;i < m;i++){
		int a, b; cin >> a >> b;
		g[a].push_back(b);
		grev[b].push_back(a);
	}

	cin >> k;
	vector <int> val(k);

	for(int i = 0;i < k;i++)
		cin >> val[i];

	bfs(val.back());

	for(int i = 0;i < k - 1;i++){
		if(d[val[i]] != d[val[i + 1]] + 1)
			a++, b++;
		else if(cnt[val[i]] > 1) b++;
	}

	cout << a << ' ' << b;

}