#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;
using namespace std;

#define pii pair <int, int>
#define pll pair <long long, long long>
#define mp make_pair
#define f first
#define se second
#define ll long long
#define ull unsigned long long
#define cntbit(x) __builtin_popcount(x)
#define pb push_back
#define ppb pop_back
#define pf push_front
#define ld long double

template <typename T> Max(T &a, T b) {
	a = max(a, b);
}

template <typename T> Min(T &a, T b) {
	a = min(a, b);
}

ostream &operator << (ostream &cout, vector <int> &s) {
	cout << "{";
	for(auto &i : s)
		cout << i << ", ";
	cout << "}";
	return cout;
}

ostream &operator << (ostream &cout, set <int> &s) {
	cout << "{";
	for(auto &i : s)
		cout << i << ", ";
	cout << "}";
	return cout;
}

const int inf = 0x3f3f3f3f;
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
uniform_int_distribution <int> range(0, inf);

const int mod = 1e9 + 7;
const int N = 2e5 + 15;
int n, m, a[N];
vector <int> g[N], gr[N];
int d[2][N];
int q[N], ql, qr;
int k;

inline void bfs(int t, int start) {
	memset(d[t], 0x3f, sizeof(d[t]));
	q[ql = qr = 0] = start;
	d[t][start] = 0;
	while(ql <= qr) {
		int v = q[ql++];
		if(t == 0){
			for(int to : g[v]) {
			if(d[t][to] == inf) {
                d[t][to] = d[t][v] + 1;
                q[++qr] = to;
			}
		}
		}
		else {
			for(int to : gr[v]) {
			if(d[t][to] == inf) {
                d[t][to] = d[t][v] + 1;
                q[++qr] = to;
			}
		}
		}
	}
}
main() {
    ios_base::sync_with_stdio(0); cout.tie(0); cin.tie(0);
	cin >> n >> m;
	for(int i = 1; i <= m; ++i) {
		int u, v;
		cin >> u >> v;
		g[u].pb(v);
		gr[v].pb(u);
	}
	cin >> k;
	for(int i = 1; i <= k; ++i)
		cin >> a[i];
	bfs(0, a[1]);
	bfs(1, a[k]);
	pii ans(0, 0);
	for(int i = 2; i <= k; ++i) {
		int v = a[i];
		if(d[1][a[i]] != d[1][a[i-1]] - 1) {
			++ans.f;
		}
	}
	for(int i = 1; i < k; ++i) {
		int v = a[i];
		for(int to : g[v]) {
            if(d[1][to] == d[1][v] - 1 && to != a[i+1]) {
				++ans.se;
				break;
            }
		}
	}
//	for(int i = 1; i <= n; ++i)
//		cout << d[1][i] << ' ';
//	cout << endl;
	cout << ans.f << ' ' << ans.se << endl;
    return 0;
}
