#include <bits/stdc++.h>
#define fori(n) for (int i = 0; i < n; i++)
#define forj(n) for (int j = 0; j < n; j++)
#define ss second
#define ff first
#define pb push_back
#define all(v) v.begin(), v.end()
#pragma GCC optimize("Ofast", "unroll-loops", "no-stack-protector", "fast-math")
//#pragma GCC target("avx2")
using namespace std;
typedef long long ll;
struct segment_tree {
    vector < int > a;
    vector < int > t;
    int siz;
    void rebuild(int v, int l, int r) {
        if (l == r) {
            t[v] = a[l];
            return ;
        }
        int m = (l + r) / 2;
        rebuild(v * 2 + 1, l, m);
        rebuild(v * 2 + 2, m + 1, r);
        t[v] = t[v * 2 + 1] + t[v * 2 + 2];
    }
    void build(vector < int > aa) {
        a = aa;
        siz = a.size();
        t.resize(4 * siz);
        rebuild(0, 0, siz - 1);
    }
    ll ask(int v, int l, int r, int tl, int tr) {
        if (l == tl && r == tr) {
            return t[v];
        }
        ll ans = 0;
        int m = (l + r) / 2;
        if (tl <= m)
            ans += ask(v * 2 + 1, l, m, tl, min(tr, m));
        if (tr >= m + 1)
            ans += ask(v * 2 + 2, m + 1, r, max(m + 1, tl), tr);
        return ans;
    }
    void upd(int v, int l, int r, int pos, int val) {
        if (l == r) {
            t[v] = pos;
            return ;
        }
        int m = (l + r) / 2;
        if (pos <= m)
            upd(v * 2 + 1, l, m, pos, val);
        else
            upd(v * 2 + 2, m + 1, r, pos, val);
        return ;
    }
};
int main() {
    int n;
    cin >> n;
    vector < ll > a;
    a.resize(n);
    fori(n) cin >> a[i];
    vector < ll > ans;
    ans.resize(n);
    fori(n) ans[i] = a[i];
    ll r = 0;
    fori(n) ans[i] = a[i];
    vector < set < ll > > keks;
    keks.resize(1000000);
    fori(n) {
        int val = i - a[i] + 500000;
        if (keks[val].size() != 0) {
            ll kek = *(keks[val].rbegin());
            ans[i] = max(ans[i], kek + a[i]);
        }
        keks[i - a[i] + 500000].insert(ans[i]);
    }
    fori(n) r = max(r, ans[i]);
    cout << r;
}
