#include <bits/stdc++.h>
#define fori(n) for (int i = 0; i < n; i++)
#define forj(n) for (int j = 0; j < n; j++)
#define ss second
#define ff first
#define pb push_back
#define all(v) v.begin(), v.end()
#pragma GCC optimize("Ofast", "unroll-loops", "no-stack-protector", "fast-math")
//#pragma GCC target("avx2")
using namespace std;
typedef long long ll;
struct segment_tree {
    vector < int > a;
    vector < int > t;
    int siz;
    void rebuild(int v, int l, int r) {
        if (l == r) {
            t[v] = a[l];
            return ;
        }
        int m = (l + r) / 2;
        rebuild(v * 2 + 1, l, m);
        rebuild(v * 2 + 2, m + 1, r);
        t[v] = t[v * 2 + 1] + t[v * 2 + 2];
    }
    void build(vector < int > aa) {
        a = aa;
        siz = a.size();
        t.resize(4 * siz);
        rebuild(0, 0, siz - 1);
    }
    ll ask(int v, int l, int r, int tl, int tr) {
        if (l == tl && r == tr) {
            return t[v];
        }
        ll ans = 0;
        int m = (l + r) / 2;
        if (tl <= m)
            ans += ask(v * 2 + 1, l, m, tl, min(tr, m));
        if (tr >= m + 1)
            ans += ask(v * 2 + 2, m + 1, r, max(m + 1, tl), tr);
        return ans;
    }
    void upd(int v, int l, int r, int pos, int val) {
        if (l == r) {
            t[v] = pos;
            return ;
        }
        int m = (l + r) / 2;
        if (pos <= m)
            upd(v * 2 + 1, l, m, pos, val);
        else
            upd(v * 2 + 2, m + 1, r, pos, val);
        return ;
    }
};
int n, m;
vector < vector < int > > g;
vector < vector < int > > revg;
int s, t;
vector < bool > isUsed;
vector < int > dist;
void f(int x) {
    vector < int > old;
    vector < int > now;
    old.pb(x);
    isUsed[x] = 1;
    int cnt = 1;
    while(true) {
        if (old.size() == 0) break;
        for (auto v: old) {
            for (auto to: revg[v]) {
                if (isUsed[to]) continue;
                isUsed[to] = 1;
                now.pb(to);
            }
        }
        for (auto v: now) dist[v] = cnt;
        cnt++;
        old = now;
        now.clear();
    }
    return ;
}
int main() {
    cin >> n >> m;
    dist.resize(n);
    isUsed.resize(n);
    g.resize(n);
    revg.resize(n);
    fori(m) {
        int x, y;
        cin >> x >> y;
        x--; y--;
        g[x].pb(y);
        revg[y].pb(x);
    }
    int k;
    cin >> k;
    vector < int > way;
    way.resize(k);
    fori(k) cin >> way[i];
    fori(k) way[i]--;
    s = way[0];
    t = way.back();
    f(t);
    vector < map < int, int > > kek;
    vector < map < int, bool > > one;
    kek.resize(n);
    one.resize(n);
    fori(n) {
        for (auto to: g[i]) {
            kek[i][dist[to]]++;
        }
        for (auto to: g[i]) {
            if (kek[i][dist[to]] != 1) {
                one[i][to] = 0;
            } else {
                one[i][to] = 1;
            }
        }
    }
    int ans1 = 0, ans2 = 0;
    fori(k - 1) {
        int x = way[i];
        int y = way[i + 1];
        int d1 = dist[x];
        int d2 = dist[y];
        if (d2 == d1 + 1) {
            ans1++;
            ans2++;
        } else if (d2 == d1 - 1) {
            if (one[x][y] == 0) {
                ans2++;
            }
        } else {
            ans1++;
            ans2++;
        }
    }
    cout << ans1 << " " << ans2;
    return 0;
}
