#include <bits/stdc++.h>
#define fori(n) for (int i = 0; i < n; i++)
#define forj(n) for (int j = 0; j < n; j++)
#define ss second
#define ff first
#define pb push_back
#define all(v) v.begin(), v.end()
#pragma GCC optimize("Ofast", "unroll-loops", "no-stack-protector", "fast-math")
//#pragma GCC target("avx2")
using namespace std;
typedef long long ll;
vector < int > arr;
vector < ll > step;
ll mod = 1e9 + 7;
vector < ll > t;
vector < ll > invt;
void build(int v, int l, int r) {
    if (l == r) {
        t[v] = arr[l];
        invt[v] = 1 - arr[l];
        return ;
    }
    int m = (l + r) / 2;
    build(v * 2 + 1, l, m);
    build(v * 2 + 2, m + 1, r);
    t[v] = (step[r - (m + 1) + 1] * t[v * 2 + 1] + t[v * 2 + 2]) % mod;
    invt[v] = (step[r - (m + 1) + 1] * invt[v * 2 + 1] + invt[v * 2 + 2]) % mod;
    return ;
}
ll ask(int v, int l, int r, int tl, int tr) {
    if (l == tl && r == tr) {
        return t[v];
    }
    int m = (l + r) / 2;
    ll ans = 0;
    if (tr >= m + 1)
        ans += ask(v * 2 + 2, m + 1, r, max(m + 1, tl), tr);
    if (tl <= m) {
        if (tr >= m + 1)
            ans += step[tr - max(m + 1, tl) + 1] * ask(v * 2 + 1, l, m, tl, min(m, tr));
        else
            ans += ask(v * 2 + 1, l, m, tl, min(m, tr));
    }
    ans %= mod;
    return ans;
}
ll invask(int v, int l, int r, int tl, int tr) {
    if (l == tl && r == tr) {
        return invt[v];
    }
    int m = (l + r) / 2;
    ll ans = 0;
    if (tr >= m + 1)
        ans += ask(v * 2 + 2, m + 1, r, max(m + 1, tl), tr);
    if (tl <= m) {
        if (tr >= m + 1)
            ans += step[tr - max(m + 1, tl) + 1] * ask(v * 2 + 1, l, m, tl, min(m, tr));
        else
            ans += ask(v * 2 + 1, l, m, tl, min(m, tr));
    }
    ans %= mod;
    return ans;
}
void test() {
    srand(time(NULL));
    int n = 10;
    arr.resize(n);
    t.resize(4 * n);
    fori(n) arr[i] = rand() % 2;
    build(0, 0, n - 1);
    int q = 10000;
    while (q--) {
        int l1 = rand() % n;
        int l2 = rand() % n;
        if (l1 > l2) swap(l1, l2);
        int len = rand() % (n - l2);
        int r1 = l1 + len;
        int r2 = l2 + len;
        string s1, s2;
        for (int i = l1; i <= r1; i++) s1.pb(arr[i]);
        for (int i = l2; i <= r2; i++) s2.pb(arr[i]);
        if (s1 != s2) continue;
        ll h1 = ask(0, 0, n - 1, l1, r1);
        ll h2 = ask(0, 0, n - 1, l2, r2);
        if (h1 != h2) {
            fori(n) cout << arr[i];
            cout << endl;
            cout << "hah is " << h1 << " " << h2 << endl;
            cout << "quer is\n";
            cout << l1 << " " << r1 << " : ";
            for (int i = l1; i <= r1; i++) cout << arr[i];
            cout << endl;
            cout << l2 << " " << r2 << " : ";
            for (int i = l2; i <= r2; i++) cout << arr[i];
            cout << endl;
            return ;
        }
    }
}
int main() {
    step.resize(200001);
    step[0] = 1;
    fori(step.size() - 1) step[i + 1] = (step[i] * 2) % mod;
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector < int > pref;
    bitset < 200000 > kek;
    pref.resize(n);
    string s;
    cin >> s;
    fori(s.size()) s[i] -= '0';
    fori(pref.size()) {
        if (i) pref[i] = pref[i - 1];
        pref[i] += s[i];
    }
    int q;
    cin >> q;
    vector < int > tol, tor;
    tol.resize(n);
    tor.resize(n);
    int ind = -1;
    for (int i = 0; i < n; i++) {
        if (s[i] == 0) ind = i;
        tol[i] = ind;
    }
    ind = -1;
    for (int i = n - 1; i >= 0; i--) {
        if (s[i] == 0) ind = i;
        tor[i] = ind;
    }
    int cnt0 = 0;
    vector < int > keked;
    keked.resize(n - 1);
    fori(n) {
        if (s[i] == 0) {
            keked[i] = cnt0;
            cnt0++;
        }
    }
    ind = 0;
    fori(n) {
        if (s[i] == 1) ind = 1 - ind;
        else arr.pb(ind);
    }
    if (cnt0 == 0) {
        fori(q) cout << "Yes\n";
        return 0;
    }
    t.resize(4 * cnt0);
    invt.resize(4 * cnt0);
    build(0, 0, cnt0 - 1);

    while (q--) {
        int fl1, fl2;
        int l1, l2, len;
        cin >> l1 >> l2 >> len;
        l1--; l2--;
        fl1 = l1;
        fl2 = l2;
        len--;
        int kek1 = pref[l1 + len];
        if (l1) kek1 -= pref[l1 - 1];
        int kek2 = pref[l2 + len];
        if (l2) kek2 -= pref[l2 - 1];
        if (kek1 != kek2) {
            cout << "No\n";
            continue;
        }
        if (kek1 == len + 1) {
            cout << "Yes\n";
            continue;
        }
        int r1 = tol[l1 + len];
        int r2 = tol[l2 + len];
        l1 = tor[l1];
        l2 = tor[l2];
        l1 = keked[l1];
        r1 = keked[r1];
        l2 = keked[l2];
        r2 = keked[r2];
        ll h1 = ask(0, 0, cnt0 - 1, l1, r1);
        ll h2;
        int k1 = 0, k2 = 0;
        if (fl1) k1 = pref[fl1 - 1];
        if (fl2) k2 = pref[fl2 - 1];
        if (k1 % 2 != k2 % 2)
            h1 = invask(0, 0, cnt0 - 1, l2, r2);
        else
            h2 = ask(0, 0, cnt0 - 1, l2, r2);
        if (h1 == h2) {
            cout << "Yes\n";
        } else {
            cout << "No\n";
        }
    }
}
