#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <cmath>
#include <numeric>
#include <iomanip>
#include <utility>
#include <iterator>
#include <map>
#include <set>
#include <string>
#include <algorithm>
#include <climits>
#include <deque>
#include <queue>
#include <unordered_map>
#include <unordered_set>
using namespace std;
#define int long long
struct kek{
	int val;
	set<int> si;
	vector<int> vi;
};
struct fenwick{
	int n;
	vector<int> f;
	fenwick(int a){
		n = a;
		f.assign(n,0);
	};
	void add(int val, int i){
		for (; i < n; i |= (i + 1))
			f[i] += val;
	}
	int getsum(int i){
		int sum = 0;
		for (; i >= 0; i &= (i + 1), --i)
			sum += f[i];
		return sum;
	}
	int get(int L, int R){
		return getsum(R) - getsum(L - 1);
	}
};
void solve(){
	int n;
	cin >> n;
	vector<int> a(n);
	map<int,vector<int>> ma;
	vector<set<int>> b(5e5);
	vector<vector<int>> c(5e5);
	vector<int> d(n);
	for (int i = 0; i < n; ++i){ 
		cin >> a[i];
		d[i] = a[i];
		b[a[i]].insert(i);
		c[a[i]].push_back(i);
	}
	int L = 0;
	for (int i = 1; i <= b.size(); ++i){
		while (L <= i || b[L].size() == 0){ L++;
		if (L == b.size()) break;}
		if (L == b.size()) break;
		int dist = L - i;
		if (c[i].size() == 0) continue;
		for (int j = 0; j < c[i].size(); ++j){
			if (b[L].find(c[i][j] + dist) != b[L].end()){
				d[c[i][j] + dist] = max(d[c[i][j] + dist], d[c[i][j]] + L);
			}
		}
	}
	int ans = 0;
	for (int i = 0; i < n; ++i) ans = max(ans,d[i]);
	cout << ans;
}
signed main(){
#ifdef _DEBUG
	freopen("input.txt","r",stdin);
	freopen("output.txt","w",stdout);
#else
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#endif
	int t;
	t = 1;
	while(t--){
		solve();
	}
}