#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <cmath>
#include <numeric>
#include <iomanip>
#include <utility>
#include <iterator>
#include <map>
#include <set>
#include <string>
#include <algorithm>
#include <climits>
#include <deque>
#include <queue>
#include <unordered_map>
#include <unordered_set>
using namespace std;
#define int long long
struct fenwick{
	int n;
	vector<int> f;
	fenwick(int a){
		n = a;
		f.assign(n,0);
	};
	void add(int val, int i){
		for (; i < n; i |= (i + 1))
			f[i] += val;
	}
	int getsum(int i){
		int sum = 0;
		for (; i >= 0; i &= (i + 1), --i)
			sum += f[i];
		return sum;
	}
	int get(int L, int R){
		return getsum(R) - getsum(L - 1);
	}
};
void solve(){
	int m,n;
	cin >> m;
	string s;
	cin >> s;
	int f = true;
	for (int kek = 0; kek <= 1000; ++kek){
		string sl;
		n = s.size();
		f = -1;
		for (int i = 0; i < n; ++i){
			while(!sl.empty() && sl.back() == s[i] + 1) sl.pop_back();
			sl.push_back(s[i]);
		}
		s = sl;
		sl.clear();
		for (int i = s.size() - 1; i >= 0; --i){
			while(!sl.empty() && sl.back() == s[i] + 1) sl.pop_back();
			sl.push_back(s[i]);
		}
		s = sl;
	}
	for (int kek = 0; kek <= 1000; ++kek){
		string sl;
		n = s.size();
		for (int i = 0; i < n; ++i){
			if (i > 0 && s[i-1] - 1 == s[i]) continue;
			if (i < n - 1 && s[i+1] - 1 == s[i]) continue;
			sl.push_back(s[i]);
		}
		s = sl;
	}
	cout << m - s.size();
}
signed main(){
#ifdef _DEBUG
	freopen("input.txt","r",stdin);
	freopen("output.txt","w",stdout);
#else
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#endif
	int t;
	t = 1;
	while(t--){
		solve();
	}
}