#include <bits/stdc++.h>
#if ONLINE_JUDGE
#pragma GCC optimize("O3")
#pragma GCC target("avx2")
#endif
#define ll long long

using namespace std;

const int INF = 2e5 + 1;
vector<vector<int>> g;
vector<set<int>> prv;

void dfs(int v, int prev, int cd, vector<int> &d) {
    d[v] = cd;
    if (prev != -1)
        prv[v] = {prev};
    for (int u : g[v]) {
        if (d[u] > d[v] + 1) {
            dfs(u, v, d[v] + 1, d);
        } else if (d[u] == d[v] + 1)
            prv[u].emplace(v);
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n, m;
    cin >> n >> m;
    g.resize(n + 1);
    prv.resize(n + 1);
    int f, t;
    for (int i = 0; i < m; ++i) {
        cin >> f >> t;
        g[t].emplace_back(f);
    }

    int k;
    cin >> k;
    vector<int> path(k);
    for (auto &i : path) cin >> i;

    vector<int> d(n + 1, INF);

    dfs(path[k - 1], -1, 0, d);

    int mn = 0, mx = 0;
    for (int i = 0; i < k - 1; ++i) {
        if (prv[path[i]].count(path[i + 1]) == 0) {
            mn += 1;
            mx += 1;
        } else if (prv[path[i]].size() > 1)
            mx += 1;
    }

    cout << mn << ' ' << mx << endl;

    return 0;
}
