#include <iostream>
#include <cstdio>
#include <fstream>

#include <vector>
#include <set>
#include <map>
#include <string>
#include <unordered_map>
#include <queue>
#include <deque>
#include <stack>
#include <bitset>

#include <algorithm>
#include <utility>
#include <iomanip>
#include <functional>
#include <ctime>
#include <iterator>

#include <random>
#include <cassert>

#define ll long long
#define prll pair<ll,ll>
#define m_p make_pair
#define INF (ll)1e18

const ll q = 239017;
const ll mod = 1e9+7;
const ll mod2 = 1e9+13;
const ll MAXN = 2e5+100;
const ll MAXM = 1e3;
const ll L = 26;

using namespace std;

ll n,m,k; 

vector<ll> g1[MAXN],g2[MAXN];
ll d[MAXN][2];

vector<ll> ord;

void foo2(ll st)
{
	for(ll i=0;i<MAXN;++i)
		d[i][1]=INF;

	d[st][1]=0;
	set<prll> sit; sit.emplace(m_p(0ll,st));

	while(!sit.empty())
	{
		auto t = sit.begin();

		ll v = t->second, dst = t->first;

		sit.erase(t);
		if(d[v][1]<dst)
			continue;

		for(ll i=0;i<g2[v].size();++i)
		{
			ll to = g2[v][i];
			if(d[to][1] <= (dst+1))
				continue;

			d[to][1] = dst+1;
			sit.emplace(m_p(d[to][1],to));
		}
	}
}

ll fir=0,sec=0;

void dfs(ll v, ll it=1)
{
	if(it==k)
		return;

	ll mn = INF;
	for(ll i=0;i<g1[v].size();++i)
	{
		ll to = g1[v][i];

		if(to==ord[it])
			continue;

		mn = min(mn,d[to][1]);
	}

	ll our = k-it-1;


	if(mn<our)
		++fir,++sec;
	else if(mn==our)
		++sec;

	for(ll i=0;i<g1[v].size();++i)
	{
		ll to = g1[v][i];

		if(to!=ord[it])
			continue;

		dfs(to,it+1);
	}
}

void $main()
{
	cin>>n>>m;

	for(ll i=0;i<m;++i)
	{
		ll v,u; cin>>v>>u;
		--v;--u;

		g1[v].push_back(u);
		g2[u].push_back(v);
	}
	
	cin>>k;
	ord.resize(k);

	for(ll i=0;i<k;++i)
		cin>>ord[i];

	for(ll i=0;i<k;++i)
		--ord[i];

	foo2(ord[k-1]);

	dfs(ord[0]);

	cout<<fir<<" "<<sec;
}

int main()
{
#ifndef ONLINE_JUDGE
	freopen("input.txt","r",stdin);
#endif

	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	$main();

	return 0;
}