#include <bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define int long long
#define all(x) x.begin(), x.end()
#define fastio ios_base::sync_with_stdio(false), cin.tie(0), cout.tie(0)
#define fs first
#define sc second
#define MP make_pair
#define pb push_back
#define sz(x) (int)x.size()

const int N = 2e5 + 100;
vector<int> g[N], rg[N];
const int INF = 1e9 + 123;
int d[N], ok[N];
signed main(){
    fastio;

    int n,m;
    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--; b--;
        g[a].pb(b);
        rg[b].pb(a);
    }
    int k;
    cin >> k;
    vector<int> path(k);
    for (int i = 0; i < k; i++) {
        cin >> path[i];
        path[i]--;
    }
    for (int i = 0; i < n; i++) {
        d[i] = INF;
    }
    int s = path[0], t = path.back();
    d[t] = 0;
    queue<int> q;
    q.push(t);
    ok[t] = 1;
    while(!q.empty()) {
        int v = q.front();
        q.pop();
        for (auto u:rg[v]) {
            if (d[u] > d[v] + 1) {
                d[u] = d[v] + 1;
                q.push(u);
                ok[u] += ok[v];
            } else if (d[u] == d[v] + 1)
                ok[u]++;
        }
    }

    int mn = 0, mx = 0;

    for (int i = 0; i < k - 1; i++) {
        int a = path[i], b = path[i + 1];
        if (d[b] + 1 != d[a])
            mn++;
        if (ok[a] > 1 || d[b] + 1 != d[a] )
            mx++;
    }
    cout << mn << " " << mx << '\n';
}
