#include <bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

using namespace std;

#define int long long
#define all(x) x.begin(), x.end()
#define fastio ios_base::sync_with_stdio(false), cin.tie(0), cout.tie(0)
#define fs first
#define sc second
#define MP make_pair
#define pb push_back
#define sz(x) (int)x.size()

const int N = 1e6 + 100;
const int INF = 1e18;
int t[4 *  N], add[4 * N];
pair<int, int> a[N], b[N];

struct monster {
    int x;
    int y;
    int z;
    bool operator < (monster &o) {
        return x < o.x;
    }
};

monster c[N];
int tmp[N];

void build(int v, int l, int r) {
    if (l + 1 == r)
        t[v] = tmp[l];
    else {
        int mid = (l + r) / 2;
        build(v * 2 + 1, l, mid);
        build(v * 2 + 2, mid, r);
        t[v] = max(t[v * 2 + 1], t[v * 2 + 2]);
    }
}

inline void push(int v, int l, int r) {
    if (add[v]) {
        assert(add[v] > 0);
        t[v] += add[v];
        if (l + 1 != r){
            add[v * 2 + 1] += add[v];
            add[v * 2 + 2] += add[v];
        }
        add[v] = 0;
    }
}


void upd(int v, int l, int r, int ql, int qr, int x) {
    push(v, l, r);
    if (qr <= l || r <= ql)
        return;
    if (ql <= l && r <= qr) {
        add[v] += x;
        push(v, l, r);
        return ;
    }
    int mid = (l + r) / 2;
    upd(v * 2 + 1, l, mid, ql, qr, x);
    upd(v * 2 + 2, mid, r, ql, qr, x);
    t[v] = max(t[v * 2 + 1], t[v * 2 + 2]);
}

signed main(){
    fastio;

    int n, m, p;
    cin >> n >> m >> p;
    for (int i = 0; i < n; i++)
        cin >> a[i].fs >> a[i].sc;
    for (int i = 0; i < m; i++)
        cin >> b[i].fs >> b[i].sc;
    for (int i = 0; i < p; i++)
        cin >> c[i].x >> c[i].y >> c[i].z;
    sort(a, a + n);
    sort(b, b + m);
    sort(c, c + p);
    for (int i = 0; i < N; i++)
        tmp[i] = -INF;
    for (int i = 0; i < m; i++) {
        tmp[b[i].fs] = max(tmp[b[i].fs], -b[i].sc);
    }

    build(0, 0, N);
    int uk = 0;
    int ans = -INF;
    for (int i = 0; i < n; i++) {
        while (uk < p && c[uk].x < a[i].fs) {
            int y = c[uk].y;
            int z = c[uk].z;
            upd(0, 0, N, y + 1, N, z);
            uk++;
        }
        int tans = -a[i].sc + t[0];
        ans = max(ans, tans);
    }

    cout << ans << '\n';
}
