//#define _FORTIFY_SOURCE 0
//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("no-stack-protector")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("sse,sse2,sse3,sse4,popcnt,abm,mmx,avx,tune=native")
#include <bits/stdc++.h>

#define ll long long
#define pll pair<ll, ll>
#define ld long double
#define pb push_back
#define mp make_pair
#define all(x) x.begin(), x.end()


const ll inf = 1e18;


using namespace std;


mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());


ll rnd(ll l, ll r) {
    return uniform_int_distribution<ll>(l, r)(rng);
}


ld rnd_double(ld l, ld r) {
    return uniform_real_distribution<ld>(l, r)(rng);
}


template<class T>
istream& operator>>(istream &in, vector<T> &arr) {
    for (T &x : arr) {
        in >> x;
    }
    return in;
};


void solve() {
    ll n, m;
    cin >> n >> m;
    vector<vector<ll>> g(n), gr(n);
    for (int i = 0; i < m; i++) {
        ll a, b;
        cin >> a >> b;
        a--;
        b--;
        g[a].pb(b);
        gr[b].pb(a);
    }
    ll k;
    cin >> k;
    vector<ll> path(k);
    for (ll &x : path) {
        cin >> x;
        x--;
    }
    ll s = path[0], t = path[k - 1];
    vector<ll> dist(n, inf);
    dist[t] = 0;
    queue<ll> q;
    q.push(t);
    while (!q.empty()) {
        ll v = q.front();
        q.pop();
        for (ll u : gr[v]) {
            if (dist[u] == inf) {
                dist[u] = dist[v] + 1;
                q.push(u);
            }
        }
    }
    ll mn = 0, mx = 0;
    for (int i = 0; i < k - 1; i++) {
        ll pi = path[i], pnxt = path[i + 1];
        ll have = 0;
        for (auto u : g[pi]) {
            if (dist[u] + 1 == dist[pi]) {
                have++;
            }
        }
        if (dist[pnxt] + 1 != dist[pi]) {
            mn++;
        }
        if (dist[pnxt] + 1 != dist[pi] or have > 1) {
            mx++;
        }
    }
    cout << mn << " " << mx;
}


int main() {
    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    #endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout.precision(30);
    solve();
    return 0;
}