#include <bits/stdc++.h>
#define int long long
#define x first
#define y second
#define mp make_pair
#define pb emplace_back

using namespace std;

const int inf = 1e10;

struct node{
    int l, r, mx, add;
    node *cl, *cr;
};

node *build(int l, int r, vector<int> &a){
    node *root = new node;
    root->l = l;
    root->r = r;
    root->mx = -a[l];
    root->add = 0;
    root->cl = root->cr = nullptr;
    if(r > l){
        int m = (r + l) / 2;
        root->cl = build(l, m, a);
        root->cr = build(m + 1, r, a);
        root->mx = max(root->cl->mx, root->cr->mx);
    }
    return root;
}

void upd(node *root, int l, int r, int val){
    if(r < root->l || l > root->r)return;
    if(l <= root->l && root->r <= r){
        root->add += val;
        root->mx += val;
    }
    else{
        upd(root->cl, l, r, val);
        upd(root->cr, l, r, val);
        root->mx = max(root->cl->mx, root->cr->mx) + root->add;
    }
}

main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    int n, m, p;
    cin >> n >> m >> p;
    vector<pair<int, int>> a(n);
    vector<pair<pair<int, int>, int>> mon(p);
    vector<int> mn(1e6, inf);
    for(auto &e: a)cin >> e.x >> e.y;
    for(int i = 0; i < m; ++i){
        int v, c;
        cin >> v >> c;
        mn[v - 1] = min(mn[v - 1], c);
    }
    for(int i = 1e6 - 2; i >= 0; --i){
        mn[i] = min(mn[i], mn[i + 1]);
    }
    node *root = build(0, 1e6 - 1, mn);
    for(auto &e: mon)cin >> e.x.x >> e.x.y >> e.y;
    sort(a.begin(), a.end());
    sort(mon.begin(), mon.end());
    int unar = 0;
    int ans = -inf;
    for(int i = 0; i < n; ++i){
        while(unar < p && mon[unar].x.x < a[i].x){
            upd(root, mon[unar].x.y, 1e6, mon[unar].y);
            ++unar;
        }
        ans = max(ans, root->mx - a[i].y);
        //cout << root->mx << " " << a[i].y << endl;
    }
    cout << ans;
    return 0;
}
