#pragma GCC optimize("O3")
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <random>
#include <numeric>
#include <bitset>
#include <iomanip>
#include <deque>
using namespace std;
#define kekek ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
#define int long long
#define sp system("pause")

template <class T>
istream& operator >>(istream& s, vector<T>& v){
	for (int i = 0; i < v.size(); i++){
		cin >> v[i];
	}
	return s;
}

int ceil_(int a, int b){
	return (a - 1) / b + 1;
}

const int inf = 1e8;
int n, m;
vector<vector<int>> g, g1;

signed main(){
	kekek;
	cin >> n >> m;
	g.resize(n + 1);
	g1.resize(n + 1);
	for (int i = 0; i < m; i++){
		int a, b;
		cin >> a >> b;
		g[b].push_back(a);
		g1[a].push_back(b);
	}
	int k;
	cin >> k;
	vector<int> way(k);
	cin >> way;

	vector<int> dist(n + 1, inf);
	dist[way[k - 1]] = 0;
	deque<int> buf(1, way[k-1]);
	while (!buf.empty()){
		int now = buf.front();
		buf.pop_front();

		for (int u = 0; u < g[now].size(); u++){
			if (dist[g[now][u]] == inf){
				dist[g[now][u]] = dist[now] + 1;
				buf.push_back(g[now][u]);
			}
		}
	}

	int ans = 0;
	for (int i = 0; i < k - 1; i++){
		if (dist[way[i]] != dist[way[i + 1]] + 1){
			ans++;
		}
	}
	cout << ans << " ";

	ans = 0;
	for (int i = 0; i < k - 1; i++){
		int now = way[i], to = way[i + 1], cnt = 0;
		for (int j = 0; j < g1[now].size(); j++){
			if (dist[g1[now][j]] + 1 == dist[now]) cnt++;
		}

		if (dist[to] + 1 != dist[now] || cnt > 1){
			ans++;
		}
	}
	cout << ans;

	//sp;
	return 0;
}