#include <bits/stdc++.h>
#define int long long
#define x first
#define y second
#define pii pair<int, int>

using namespace std;

const int N = 1e6 + 10;

int n, m;
int k;
vector<int> way;
vector<int> g[N];
vector<int> invg[N];
int d[N];
int ans1 = 0;
int ans2 = 0;

void bfs()
{
   int qh = 0;
   int qt = 0;

   vector<int> q(n + 10, 0);
   fill(d, d + n + 10, -1);
   d[way.back()] = 0;
   q[qt++] = way.back();

   while(qh < qt)
   {
       int v = q[qh++];

       for(auto u : invg[v])
          if(d[u] == -1)
          {
              q[qt++] = u;
              d[u] = d[v] + 1;
          }
   }
}

void dfs(int pos)
{
    if(pos == k - 1)
        return;

    int v = way[pos];

    int mn = d[way[pos + 1]];
    bool was = false;

    for(auto u : g[v])
        mn = min(mn, d[u]);

    for(auto u : g[v])
        if(u != way[pos + 1] && d[u] == mn)
            was = true;

    if(d[way[pos + 1]] != mn)
    {
        ++ans1;
        ++ans2;
    }
    else if(was)
        ++ans2;

    dfs(pos + 1);
}

int32_t main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

   cin >> n >> m;

   for(int i = 0; i < m; ++i)
   {
       int v, u;

       cin >> v >> u;

       g[v].push_back(u);
       invg[u].push_back(v);
   }

   cin >> k;

   for(int i = 0; i < k; ++i)
   {
       int x;

       cin >> x;

       way.push_back(x);
   }

   bfs();
   dfs(0);

   cout << ans1 << " " << ans2 << endl;
}
