#include <bits/stdc++.h>
#define int long long
#define x first
#define y second
#define pii pair<int, int>

using namespace std;

const int N = 1e6 + 10;
const int inf = 1e17 + 10;

int n, m, p;
vector<pii> a;
vector<pii> b;
pair<pii, int> mons[N];

vector<pii> makeopt(vector<pii> v)
{
    sort(v.begin(), v.end());

    vector<pii> nv;
    vector<pii> tmp;

    int p = -1;

    for(int i = 0; i < v.size(); ++i)
        if(v[i].x != p)
        {
            p = v[i].x;
            tmp.push_back(v[i]);
        }

    nv = tmp;
    tmp.clear();
    int pcost = nv.back().y + 1;

    for(int i = (int)nv.size() - 1; i >= 0; --i)
        if(pcost > nv[i].y)
        {
            pcost = nv[i].y;
            tmp.push_back(nv[i]);
        }

    nv = tmp;

    reverse(nv.begin(), nv.end());

    return nv;
}

int getopt(int stn, int def)
{
    int cost = 0;

    auto it = lower_bound(b.begin(), b.end(), make_pair(stn + 1, 0ll));

    if(it == a.end())
        return -1;

    cost += (*it).y;

    it = lower_bound(a.begin(), a.end(), make_pair(def + 1, 0ll));

    if(it == b.end())
        return -1;

    cost += (*it).y;

    return cost;
}

int32_t main()
{
   // freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

   cin >> n >> m >> p;

   for(int i = 0; i < n; ++i)
   {
       int val, c;

       cin >> val >> c;

       a.emplace_back(val, c);
   }

   for(int i = 0; i < m; ++i)
   {
       int val, c;

       cin >> val >> c;

       b.emplace_back(val, c);
   }

   a = makeopt(a);
   b = makeopt(b);
   n = a.size();
   m = b.size();
   sort(a.begin(), a.end());
   sort(b.begin(), b.end());

    for(int i = 0; i < p; ++i)
    {
        int def, attack, cost;

        cin >> def >> attack >> cost;

        mons[i] = make_pair(make_pair(attack, def), cost);
    }

    int curmxdef = 0;
    int add = 0;
    int best = -getopt(-1, -1);

    sort(mons, mons + p);

    for(int i = 0; i < p; ++i)
    {
        curmxdef = max(curmxdef, mons[i].x.y);
        add += mons[i].y;
        int mxattack = mons[i].x.x;
        int equip = getopt(mxattack, curmxdef);

        if(equip == -1)
            break;

        best = max(best, add - equip);
    }

    int curmxattack = 0;
    add = 0;

    for(int i = 0; i < p; ++i)
        swap(mons[i].x.x, mons[i].x.y);

    sort(mons, mons + p);

    for(int i = 0; i < p; ++i)
    {
        curmxattack = max(curmxattack, mons[i].x.y);
        add += mons[i].y;
        int mxdef = mons[i].x.x;
        int equip = getopt(curmxattack, mxdef);

        if(equip == -1)
            break;

        best = max(best, add - equip);
    }

    cout << best << endl;
}
