#include <bits/stdc++.h>


using namespace std;
using ll = long long;
#define int ll
struct en{
    int x, y, z;
    bool operator<(const en& oth) const {
        return tie(x, y, z) < tie(oth.x, oth.y, oth.z);
    }
};
struct Node{
    int x, push = 0;
    Node (int a, int b) : x(a), push(b) {}
    Node () {}
};
const int MAXN = 2e5 + 7;
const int INF = 1e9;
pair<int, int> a[MAXN], b[MAXN];
en c[MAXN];
Node st[4 * MAXN];
int N = 1;
int n, m, p;
void push(int v){
    st[v].x += st[v].push;
    if (2 * v < MAXN){
        st[2 * v].push += st[v].push;
        st[2 * v + 1].push += st[v].push;
    }
    st[v].push = 0;
}
void ins_sum(int v, int tl, int tr, int l, int r, int x){
    push(v);
    if (r <= tl || tr <= l)
        return;
    if (l <= tl && tr <= r){
        st[v].push += x;
        push(v);
        return;
    }
    int tm = (tl + tr) / 2;
    ins_sum(v * 2, tl, tm, l, r, x);
    ins_sum(v * 2 + 1, tm, tr, l, r, x);
    st[v].x = max(st[2 * v].x, st[2 * v + 1].x); 
}
void build(){
    fill(st, st + 4 * MAXN, Node(-INF, 0));
    while (N < m)
        N *= 2;
    for (int i = 0; i < m; i++)
        st[i + N].x = -b[i].second;
    for (int i = N - 1; i >= 1; i--)
        st[i].x = max(st[2 * i].x, st[2 * i + 1].x);
}
void add(int x, int y){
    int pos = upper_bound(b, b + m, make_pair(x, -1LL)) - b;
    ins_sum(1, 0, N, pos, N, y);
}


signed main(){
    cin >> n >> m >> p;
    for (int i = 0; i < n; i++)
        cin >> a[i].first >> a[i].second;
    sort(a, a + n);
    for (int i = 0; i < m; i++)
        cin >> b[i].first >> b[i].second;
    sort(b, b + m);
    for (int i = 0; i < p; i++)
        cin >> c[i].x >> c[i].y >> c[i].z;
    sort(c, c + p);
    int pnt = 0;
    int best = 0;
    int may = 0;
    build();
    // cerr << st[1].x << '\n';
    for (int i = 0; i < n; i++){
        while (pnt < p && c[pnt].x < a[i].first){
            add(c[pnt].y, c[pnt].z);
            pnt++;
        }
        // cerr << i << ' ' << pnt << '\n';
        push(1);
        int now = -a[i].second + st[1].x;
        // cerr << st[1].x << '\n';
        if (!may)
            best = now;
        else
            best = max(best, now);
        may = 1;
    }
    cout << best << '\n';
}