#include <bits/stdc++.h>
using namespace std;

#define ios ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
using ll = long long;

vector<vector<int> > g;
vector<vector<int> > g_inv;

const int inf = 1e9 + 7;

signed main()
{
    ios;
    int n, m;
    cin >> n >> m;
    g.resize(n);
    g_inv.resize(n);
    for(int i = 0; i < m; ++i)
    {
        int v, u;
        cin >> v >> u;
        --v;
        --u;
        g[v].emplace_back(u);
        g_inv[u].emplace_back(v);
    }
    int k;
    cin >> k;
    int p[k];
    for(int i = 0; i < k; ++i)
    {
        cin >> p[i];
        --p[i];
    }
    vector<int> dist(n, inf);
    vector<int> cnt(n, 0);
    int st = p[k - 1];
    dist[st] = 0;
    queue<int> q;
    q.push(st);
    while(!q.empty())
    {
        int v = q.front();
        q.pop();
        for(auto u : g_inv[v])
        {
            if(dist[u] > dist[v] + 1)
            {
                dist[u] = dist[v] + 1;
                cnt[u] = 1;
                q.push(u);
            }
            else if(dist[u] == dist[v] + 1)
            {
                ++cnt[u];
            }
        }
    }
    int mn = 0;
    int mx = 0;
    for(int i = 1; i < k; ++i)
    {
        if(dist[p[i]] + 1 != dist[p[i - 1]])
        {
            ++mn;
            ++mx;
        }
        else if(cnt[p[i - 1]] > 1)
        {
            ++mx;
        }
    }
    cout << mn << " " << mx;
    return 0;
}
