#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <numeric>
#include <iomanip>
#include <stack>
#include <queue>
#include <deque>
#include <list>
#include <random>

using namespace std;
#pragma warning(disable : 4996)

#define nl '\n'
#define all(a) (a).begin(), (a).end()
#define allr(a) (a).rbegin(), (a).rend()
#define mineq(a, b) (a) = min(a, b)
#define maxeq(a, b) (a) = max(a, b)

typedef long long ll;
typedef double dl;

const int INF = numeric_limits<int>::max();
const ll LINF = numeric_limits<ll>::max();
const dl EPS = 1e-8;
mt19937 rnd(2345234);

void IO() {
#ifndef ONLINE_JUDGE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
	cout.setf(ios::fixed);
	cout.precision(10);
}

const int N = (int)2e5 + 10;

void solve() {
	int n;
	cin >> n;
	vector<int> a(n);
	for (int i = 0; i < n; i++)
		cin >> a[i];

	map<int, ll> mp;
	int u = 0;
	for (int i = 1; i < n; i++) {
		u += a[i - 1] - a[i] + 1;
		mp[u]+= a[i];
	}
	mp[0] += a[0];

	ll ans = mp[0];
	u = 0;
	for (int i = 1; i < n; i++) {
		u += a[i - 1] - a[i] + 1;
		maxeq(ans, mp[u]);
	}

	cout << ans << nl;

}

int main() {
	IO();
	//int t;
	//cin >> t;
	//while (t--)
	solve();
	return 0;
}
