#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <numeric>
#include <iomanip>
#include <stack>
#include <queue>
#include <deque>
#include <list>
#include <random>

using namespace std;
#pragma warning(disable : 4996)

#define nl '\n'
#define all(a) (a).begin(), (a).end()
#define allr(a) (a).rbegin(), (a).rend()
#define mineq(a, b) (a) = min(a, b)
#define maxeq(a, b) (a) = max(a, b)

typedef long long ll;
typedef double dl;

const int INF = numeric_limits<int>::max();
const ll LINF = numeric_limits<ll>::max();
const dl EPS = 1e-8;
mt19937 rnd(2345234);

void IO() {
#ifndef ONLINE_JUDGE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
	cout.setf(ios::fixed);
	cout.precision(10);
}

vector<list<char>::iterator> pos[300];

void solve() {
	int n;
	cin >> n;
	string s;
	cin >> s;
	list<char> v;
	for (int i = 0; i < n; i++) {
		v.push_back(s[i]);
		pos[s[i]].push_back(prev(v.end()));
	}

	int cnt = 0;
	for (char c = 'z'; c >= 'a'; c--) {
		for (int i = 0; i < (int)pos[c].size(); i++) {
			if (next(pos[c][i]) != v.end() && *next(pos[c][i]) == c - 1) {
				cnt++;
				v.erase(pos[c][i]);
			}
			else if (pos[c][i] != v.begin() && *prev(pos[c][i]) == c - 1) {
				cnt++;
				v.erase(pos[c][i]);
			}
		}
	}


	cout << cnt << nl;

}

int main() {
	IO();
	//int t;
	//cin >> t;
	//while (t--)
	solve();
	return 0;
}
