// #define LOCAL

#include <bits/stdc++.h>
using namespace std; 

#define f first
#define s second 
#define mp make_pair
#define pb push_back
#define ll long long 

#define MAXN 20005
#define INF 1000000009
#define MOD 1000000007

void solve(){
    int n, m; 
    cin >> n >> m;
    cerr << n << " " << m << endl; 
    vector < vector <int> > v, o; 
    v.resize(n+1);
    o.resize(n+1);

    for(int i = 0; i < m; i++){
        int from, to; 
        cin >> from >> to; 
        v[from].pb(to);
        o[to].pb(from);
    }
    
    int t; 
    cin >> t; 
    int way[t];
    for(int i = 0; i < t; i++) cin >> way[i];

    queue <int> q;
    set <int> st;
    vector < pair <int, set <int> > > dp(n); 

     
    for(int i = 0; i < (int)dp.size(); i++){
        dp[i].f = INF; 
        set <int> nw; 
        dp[i].s = nw;
        // cerr << i << " " << dp[i].f << endl; 
        // for(auto y: dp[i].s)
        //     cerr << y << " ";
        // cerr << endl;
    }

    q.push(way[t-1]);
    dp[way[t-1]].f = 0;
    while(!q.empty()){
		int w = q.front();
        q.pop();
		cerr << w << " ";

        for(int i = 0; i < (int)o[w].size(); i++){
            if(dp[o[w][i]].f > dp[w].f + 1){
                cerr << "{1} " << o[w][i] << " " << w << ", ";
                q.push(o[w][i]);
                dp[o[w][i]] = dp[w];
                dp[o[w][i]].f++;
                dp[o[w][i]].s.clear();
            }
            if(dp[o[w][i]].f == dp[w].f + 1){
                cerr << "{2} ";
                dp[o[w][i]].s.insert(w);
            }
        }
    }
    cerr << endl;
    
    for(int i = 0; i < (int)dp.size(); i++){
        cerr << i << " " << dp[i].f << endl; 
        for(auto y: dp[i].s)
            cerr << y << " ";
        cerr << endl;
    }

    int mx = 0, mn = 0;
    for(int i = 0; i < t-1; i++){
        if(dp[way[i]].s.find(way[i+1]) == dp[way[i]].s.end()){
            mx++;
            mn++;
        }
        else if(v[way[i]].size() != 1)
            mx++;
    }

	cerr << mn << " " << mx << endl;
    cout << mn << " " << mx << endl;
}


int main(){
    ios_base::sync_with_stdio();
    cin.tie(0);
    cout.tie(0);

    int tests = 1; 
#ifdef LOCAL 
    freopen("in.data", "r", stdin);
    freopen("out.data", "w", stdout);
    cin >> tests;
#endif

    for(int i = 1; i <= tests; i++){
        cerr << "TEST " << i << endl;
        solve();
    }
}

