
#include <iostream>
#include <cmath>
#include <vector>
#include <queue>
#include <set>
#include <algorithm>
#include <cstring>
#include<map>
#include <unordered_map>
#include <unordered_set>
#include <cassert>
#include <deque>
#include <cstdio>

using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
#define mp() make_pair()
#define pb() push_back()


const unsigned int p = 31;

struct pt {
    ll x, y;

    pt() {
        x = 0;
        y = 0;
    }

    pt(ll x, ll y) {
        this->x = x;
        this->y = y;
    }

    pt operator+(pt &other) {
        return pt(x + other.x, y + other.y);
    }

    pt operator-(pt &other) {
        return pt(x - other.x, y - other.y);
    }
};

ll scalar(pt p1, pt p2) {
    return p1.x * p2.x + p1.y * p2.y;
}

ll prod(pt p1, pt p2) {
    return p1.x * p2.y - p1.y * p2.x;
}


inline void SOLVE() {
    int n;
    cin >> n;
    map<int, vector<int>> d;
    vector<int> vec(n);
    for(int i = 0; i<n; ++i){
        cin >> vec[i];
        int dif = vec[i]-i;
        if(d.find(dif)==d.end())
            d[dif]={};
        d[dif].push_back(i);
    }
    vector<int> idx(n, -1);
    for(pair<int, vector<int>> elem : d){
        for(int i = 0; i<elem.second.size()-1; ++i)
            idx[elem.second[i]]=elem.second[i+1];
    }
    vector<bool> used(n, false);
    int maxima = 0;
    for(int i = 0; i<n; ++i){
        if(!used[i]){
            int cur = 0;
            int j = i;
            while(j!=-1){
                used[j]=true;
                cur+=vec[j];
                j=idx[j];
            }
            maxima = max(maxima, cur);
        }
    }
    cout << maxima;
}

inline void IQ() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

int main() {
    IQ();
    SOLVE();
}