#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <iomanip>
#include <cstring>
#include <numeric>
#include <cmath>
#include <cstdio>
#include <ctime>
#include <cassert>
#include <random>
#include <algorithm>
#include <queue>



/*#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("popcnt")*/


#define int long long
#define fi(a, b) for (int i = a; i < b; ++i)
#define fj(a, b) for (int j = a; j < b; ++j)
#define fk(a, b) for (int k = a; k < b; ++k)
#define fi1(a, b) for (int i = a - 1; i >= b; --i)
#define fj1(a, b) for (int j = a - 1; j >= b; --j)
#define fk1(a, b) for (int k = a - 1; k >= b; --k)
#define fx(x, a) for (auto &x : a)
#define rep(i, a, b) for (int i = a; i < b; ++i)
#define rep1(i, a, b) for (int i = a - 1; i >= b; --i)
#define siz(x) (int)x.size()
#define all(x) x.begin(), x.end()


using namespace std;


typedef vector<int> vi;
typedef vector<vi> vvi;
typedef string str;
typedef vector<str> vs;
typedef char ch;
typedef vector<char> vch;
typedef vector<vch> vvch;
typedef set<char> sch;
typedef set<int> st;
typedef long long ll;
typedef unsigned long long ull;


const int MOD = 1000000007;
const int MOD2 = 1000000009;
const int BASE = 257;
const int BASE2  = 239;

#ifdef LOCAL
const int INF = 200;
const ll BIG = 200;
const int MX = 15;
const int D = 5;
#else
const int INF  = (int)1e9 + 50;
    const int BIG = (int)2e18 + 228;
    const int MX = 200010;
    const int D = 320;
#endif

mt19937 rnd(228 + 1337 + 'N' + 'E' + ' ' + 'L' + 'O' + 'M' + 'A' + 'Y' + ' ' + 'H' + 'E' + 'S' + 'H' + 'I');


vi g[MX];
vi gt[MX];
int p[MX];
int dist[MX];
int32_t main() {
#ifdef LOCAL
    freopen("/home/olymp/CLionProjects/untitled/input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin >> n >> m;
    fi(0, m) {
        int a, b;
        cin >> a >> b;
        --a;
        --b;
        g[a].push_back(b);
        gt[b].push_back(a);
    }
    int k;
    cin >> k;
    fi(0, k) {
        cin >> p[i];
        --p[i];
    }
    fill(dist, dist + n, INF);
    queue<int> q;
    q.push(p[k - 1]);
    dist[q.front()] = 0;
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        fx(to, gt[v]) {
            if (dist[to] == INF) {
                dist[to] = dist[v] + 1;
                q.push(to);
            }
        }
    }
    int mn = 0;
    int mx = 0;
 /*   fi(0, n)
        cout << dist[i] << ' ';
    cout << '\n';*/
    fi(0, k - 1) {
        int v = p[i];
        if (dist[v] < k - i - 1) {
            ++mn;
            ++mx;
        } else {
            fx(to, g[v]) {
                if (dist[to] == dist[v] - 1 && to != p[i + 1]) {
                    ++mx;
                    break;
                }
            }
        }
    }
    cout << mn << ' ' << mx;
}
