#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    // freopen("input.txt", "r", stdin);
    int n, m;
    cin >> n >> m;
    vector<vector<int> > g(n + 1);
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        g[v].push_back(u);
    }
    int k;
    cin >> k;
    vector<int> p(k);
    for (int i = 0; i < k; i++) {
        cin >> p[i];
    }
    vector<int> d(n + 1, INF);
    d[p[k - 1]] = 0;
    queue<int> q;
    q.push(p[k - 1]);
    vector<vector<int> > pos(n + 1);
    while (!q.empty()) {
        int v = q.front();
        if (v == p[0]) {
            break;
        }
        q.pop();
        for (auto u : g[v]) {
            if (d[u] > d[v] + 1) {
                if (d[u] == INF) {
                    q.push(u);
                }
                d[u] = d[v] + 1;
            }
            if (d[u] == d[v] + 1) {
                pos[u].push_back(v);
            }
        }
    }
    int mn = 0, mx = 0;
    for (int i = 0; i + 1 < k; i++) {
        int v = p[i];
        bool flag1 = false, flag2 = false;
        for (auto u : pos[v]) {
            if (u == p[i + 1]) {
                flag1 = true;
            }
            if (u != p[i + 1]) {
                flag2 = true;
            }
        }
        if (!flag1) {
            mn++;
        }
        if (flag2) {
            mx++;
        }
    }
    cout << mn << ' ' << mx;
    return 0;
}
