#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

bool cmp(pair<int, ll> a, pair<int, ll> b) {
    if (a.first != b.first) {
        return a.first < b.first;
    }
    return a.second <= b.second;
}

bool cmp2(pair<pair<int, int>, ll> a, pair<pair<int, int>, ll> b) {
    if (a.first.first != b.first.first) {
        return a.first.first < b.first.first;
    }
    return a.second >= b.second;
}

vector<pair<ll, ll> > tr;

void build(int v, int l, int r, const vector<ll> &c) {
    if (l + 1 == r) {
        tr[v].first = c[l];
        return;
    }
    int m = (l + r) / 2;
    build(2 * v + 1, l, m, c);
    build(2 * v + 2, m, r, c);
    tr[v].first = max(tr[2 * v + 1].first, tr[2 * v + 2].first);
    return;
}

void upd(int v, int l, int r, int L, ll c) {
    if (L <= l) {
        tr[v].first += c;
        tr[v].second += c;
        return;
    }
    if (r <= L) {
        return;
    }
    int m = (l + r) / 2;
    upd(2 * v + 1, l, m, L, c);
    upd(2 * v + 2, m, r, L, c);
    tr[v].first = tr[v].second + max(tr[2 * v + 1].first, tr[2 * v + 2].first);
    return;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    // freopen("input.txt", "r", stdin);
    int n, m, p;
    cin >> n >> m >> p;
    vector<pair<int, ll> > a(n), b(m);
    for (int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
    }
    for (int i = 0; i < m; i++) {
        cin >> b[i].first >> b[i].second;
    }
    sort(a.begin(), a.end(), cmp);
    sort(b.begin(), b.end(), cmp);
    tr.resize(4 * m + 1);
    vector<ll> c(m);
    for (int i = 0; i < m; i++) {
        c[i] = -b[i].second;
    }
    build(0, 0, m, c);
    vector<pair<pair<int, int>, ll> > mon(p);
    for (int i = 0; i < p; i++) {
        cin >> mon[i].first.first >> mon[i].first.second >> mon[i].second;
    }
    sort(mon.begin(), mon.end(), cmp2);
    int uk = 0;
    ll ans = -1e15;
    for (int i = 0; i < n; i++) {
        while (uk < p && mon[uk].first.first < a[i].first) {
            int cur = mon[uk].first.second;
            int l = 0, r = m;
            if (b[0].first > cur) {
                r = 0;
            }
            while (r - l > 1) {
                int mm = (l + r) / 2;
                if (b[mm].first > cur) {
                    r = mm;
                } else {
                    l = mm;
                }
            }
            upd(0, 0, m, r, mon[uk].second);
            uk++;
        }
        ans = max(tr[0].first - a[i].second, ans);
    }
    cout << ans;
    return 0;
}
