#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

ll P, MOD;

vector<ll> pp;

ll get_hash(const vector<ll> &h, int l, int r) {
    return ((h[r] - h[l] * pp[r - l]) % MOD + MOD) % MOD;
}

mt19937 rnd(time(0));

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    // freopen("input.txt", "r", stdin);
    int n;
    cin >> n;
    string s;
    cin >> s;
    vector<ll> z;
    vector<int> kol(n);
    ll mods[10] = {999999937, 999999929, 999999893, 999999883, 999999797, 1000000007, 1000000009, 1000000021, 1000000033, 1000000087};
    ll ppp[10] = {97, 89, 83, 79, 73, 101, 103, 107, 109, 113};
    MOD = mods[rnd() % 10];
    P = ppp[rnd() % 10];
    for (int i = 0; i < n; i++) {
        if (i) {
            kol[i] = kol[i - 1];
        }
        if (s[i] == '0') {
            z.push_back(i % 2);
            kol[i]++;
        }
    }
    int sz = z.size();
    vector<ll> h1(sz + 1), h2(sz + 1);
    pp.resize(sz + 1);
    h1[0] = 0;
    h2[0] = 0;
    pp[0] = 1;
    for (int i = 0; i < sz; i++) {
        h1[i + 1] = (h1[i] * P + z[i]) % MOD;
        h2[i + 1] = (h2[i] * P + 1 - z[i]) % MOD;
        pp[i + 1] = (pp[i] * P) % MOD;
    }
    int q;
    cin >> q;
    for (int i = 0; i < q; i++) {
        int l1, l2, len;
        cin >> l1 >> l2 >> len;
        l1--;
        l2--;
        int kol1 = kol[l1 + len - 1], kol2 = kol[l2 + len - 1];
        int beg1, beg2;
        if (l1) {
            kol1 -= kol[l1 - 1];
            beg1 = kol[l1 - 1];
        } else {
            beg1 = 0;
        }
        if (l2) {
            kol2 -= kol[l2 - 1];
            beg2 = kol[l2 - 1];
        } else {
            beg2 = 0;
        }
        if (kol1 != kol2) {
            cout << "No\n";
            continue;
        }
        int en1 = kol[l1 + len - 1], en2 = kol[l2 + len - 1];
        if (l1 % 2 == l2 % 2) {
            if (get_hash(h1, beg1, en1) == get_hash(h1, beg2, en2)) {
                cout << "Yes\n";
            } else {
                cout << "No\n";
            }
        } else {
            if (get_hash(h1, beg1, en1) == get_hash(h2, beg2, en2)) {
                cout << "Yes\n";
            } else {
                cout << "No\n";
            }
        }
    }
    return 0;
}
