#define _CRT_SECURE_NO_WARNINGS

#include<iostream>
#include<cmath>
#include<algorithm>
#include<fstream>
#include<string>
#include<vector>
#include<map>
#include<queue>

using namespace std;

#define X first
#define Y second
#define len(a) (int)((a).size())
#define fori(n) for (int i=0;i<n;++i)
#define forj(n) for (int j=0;j<n;++j)
#define fork(n) for (int k=0;k<n;++k)
#define fora(a) for (auto i:a)
#define mp make_pair
#define vi vector<int>
#define vll vector<long long>
#define vvi vector<vector<int>>
#define vpii vector<pair<int, int>>
#define pii pair<int, int>
#define vvpii vector<vector<pair<int, int>>>

typedef unsigned int uint;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

const int inf = 1000000001;

void run();

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie();
	cout.tie();

	run();

	//freopen("in.txt", "r", stdin);
	//freopen("out.txt", "w+", stdout);

	//system("pause");
}

vpii dists;
vi used;

void dfs(int v, vvi &gr, int l) {
	if (dists[v].X > l) {
		dists[v] = mp(l, 1);
	}
	else if (dists[v].X == l) {
		dists[v].Y++;
	}

	used[v] = 1;
	fora(gr[v]) {
		if (!used[i]) {
			dfs(i, gr, l + 1);
		}
	}
	used[v] = 0;
}

void run() {
	int n, m; cin >> n >> m;
	vvi g(n, vi(0)), gr(n, vi(0));
	fori(m) {
		int f, t; cin >> f >> t;
		f--; t--;
		g[f].push_back(t);
		gr[t].push_back(f);
	}

	int k; cin >> k;
	vi p(k);
	fori(k) {
		cin >> p[i]; p[i]--;
	}

	dists.resize(n);
	dists.assign(n, mp(inf, 1));
	used.resize(n);
	used.assign(n, 0);

	dfs(p.back(), gr, 0);

	int min_ans = 0, max_ans = 0;

	forj(k - 1) {
		if (dists[p[j]].X != dists[p[j + 1]].X + 1) {
			min_ans++;
		}
	}

	forj(k - 1) {
		if(dists[p[j]].X != dists[p[j + 1]].X + 1) {
			max_ans++;
		}
		else if (dists[p[j]].Y > 1) {
			max_ans++;
		}
	}

	cout << min_ans << ' ' << max_ans;
}