#include <bits/stdc++.h>

using namespace std;

int n, m;

vector<vector<int>> v;

vector<set<int>> obn;
vector<int> dist;

void bfs(int st){
    dist[st] = 0;
    queue<int> q;
    q.push(st);
    while(q.size()){
        auto x = q.front();
        q.pop();
        for(auto f: v[x]){
            if(dist[f] == dist[x] + 1){
                obn[f].insert(x);
            }
            if(dist[f] == 1000000000){
                obn[f].insert(x);
                dist[f] = dist[x] + 1;
                q.push(f);
            }

        }

    }

}

int main() {

    ios_base::sync_with_stdio(0);


    cin >> n >> m;

    v.resize(n);
    obn.resize(n);
    dist.resize(n, 1e9);

    for(int i = 0;i < m;i++){
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        v[y].push_back(x);
    }
    int z;
    cin >> z;
    vector<int> way(z);
    for(int i = 0;i < z;i++) {
        cin >> way[i];
        way[i]--;
    }


    bfs(way.back());

 /*   for(int i = 0;i < n;i++){
        cout << i + 1 << ' ';
        for(auto f: obn[i])
            cout << f << ' ';

        cout << '\n';
    }*/

    int min_ans = 0;

    for(int i = 0;i < way.size() - 1;i++){
        if(obn[way[i]].find(way[i + 1]) == obn[way[i]].end())
            min_ans++;
    }

    cout << min_ans << ' ';

    int max_ans = 0;

    for(int i = 0;i < way.size() - 1;i++){
        if(obn[way[i]].find(way[i + 1]) != obn[way[i]].end() && obn[way[i]].size() >= 2)
            min_ans++;
    }
    cout << min_ans;

    return 0;
}