#include <bits/stdc++.h>
#define f  first
#define s second
#define pb push_back
#define mp make_pair
#define  all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

const ll INF = 1e9 + 7, MAXN = 1e5, pp = 32;
const ld EPS = 1e-9, PI = acos(-1);

using namespace std;

namespace in_out {
    template <typename T>
    istream & operator>> (istream & in, vector <T> & a) {
        for (auto & i : a)
            in >> i;
        return in;
    }

    template <typename T>
    ostream & operator<< (ostream & out, vector <T> & a) {
        for (auto & i : a)
            out << i << " ";
        return out;
    }

    template <typename T1, typename  T2>
    istream & operator>> (istream & in, pair <T1, T2> & a) {
        in >> a.f >> a.s;
        return in;
    }

    template <typename T1, typename  T2>
    ostream & operator<< (ostream & out, pair <T1, T2> & a) {
        out << a.f << ' ' << a.s << " ";
        return out;
    }
};

using namespace in_out;

/*vector <ll> zet(string & s) {
    ll n = s.size();
    vector <ll> z(n);
    ll l = 0, r = -1;
    for (ll i = 1; i < n; i++) {
        z[i] = max(0, min(z[i - l], r - i + 1));
        while (i + z[i] < n && s[i + z[i]] == s[z[i]])
            z[i]++;
        if (i + z[i] - 1 > r)
            r = i + z[i] - 1, l = i;
    }
    return z;
}*/

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    #ifdef DEBUG
        ifstream cin("in.txt");
        ofstream cout("out.txt");
    #endif

    ll n;
    cin >> n;
    vector <ll> a(n);
    cin >> a;

    if (n == 1)
        return cout << a[0], 0;

    vector <ll> dp(n);
    map <ll, ll> m;
    dp[0] = a[0];
    m[a[0]] = a[0];
    for (ll i = 1; i < n; i++) {
        dp[i] = max(dp[i], m[a[i] - i]) + a[i];
        m[a[i] - i] = max(m[a[i] - i], dp[i]);
    }

    cout << *max_element(all(dp));

    return 0;
}
