#include <bits/stdc++.h>
#define f  first
#define s second
#define pb push_back
#define mp make_pair
#define  all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

const ll INF = 1e9 + 7, MAXN = 1e5, pp = 32;
const ld EPS = 1e-9, PI = acos(-1);

using namespace std;

namespace in_out {
    template <typename T>
    istream & operator>> (istream & in, vector <T> & a) {
        for (auto & i : a)
            in >> i;
        return in;
    }

    template <typename T>
    ostream & operator<< (ostream & out, vector <T> & a) {
        for (auto & i : a)
            out << i << " ";
        return out;
    }

    template <typename T1, typename  T2>
    istream & operator>> (istream & in, pair <T1, T2> & a) {
        in >> a.f >> a.s;
        return in;
    }

    template <typename T1, typename  T2>
    ostream & operator<< (ostream & out, pair <T1, T2> & a) {
        out << a.f << ' ' << a.s << " ";
        return out;
    }
};

using namespace in_out;

/*vector <ll> zet(string & s) {
    ll n = s.size();
    vector <ll> z(n);
    ll l = 0, r = -1;
    for (ll i = 1; i < n; i++) {
        z[i] = max(0, min(z[i - l], r - i + 1));
        while (i + z[i] < n && s[i + z[i]] == s[z[i]])
            z[i]++;
        if (i + z[i] - 1 > r)
            r = i + z[i] - 1, l = i;
    }
    return z;
}*/

struct st {
    ll a, d, c;
};

vector <st> c;
vector <ll> s1, s2;
vector <pair <ll, ll>> a, b;

ll check(ll m) {
    ll tans = -s1[m] - s2[0];
    ll cost = s1[m];//a[m].s;

    vector <pair <ll, ll>> tk;
    for (auto & i : c)
        if (i.d < a[m].f)
            tk.pb(mp(i.a, i.c));

    sort(all(tk));
    ll l = 0, sum = 0;
    for (int i = 0; i < tk.size(); i++) {
        while (l < b.size() && b[l].f <= tk[i].f)
            l++;

        if (l == b.size())
            break;

        sum += tk[i].s;
        tans = max(tans, sum - cost - s2[l]);
    }

    return tans;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    #ifdef DEBUG
        ifstream cin("in.txt");
        ofstream cout("out.txt");
    #endif

    ll n, m, p;
    cin >> n >> m >> p;

    a.resize(n);
    b.resize(m);

    cin >> a >> b;

    sort(all(a));
    sort(all(b));

    s1.resize(n);
    s2.resize(m);

    s1[n - 1] = a[n - 1].s;
    for (ll i = n - 2; i >= 0; i--)
        s1[i] = min(a[i].s, s1[i + 1]);

    s2[m - 1] = b[m - 1].s;
    for (ll i = m - 2; i >= 0; i--)
        s2[i] = min(b[i].s, s2[i + 1]);

    c.resize(p);
    for (auto & i : c)
        cin >> i.d >> i.a >> i.c;

    sort(all(c), [&](st a, st b) {
        if (a.a != b.a)
            return a.a < b.a;
        if (a.d != b.d)
            return a.d < b.d;
        return a.c < b.c;
    });

    ll l = 0, r = n - 1;
    while (r - l > 2) {
        ll m1 = (l + l + r) / 3;
        ll m2 = (l + r + r) / 3;

        if (check(m1) < check(m2))
            l = m1;
        else
            r = m2;
    }

    /*ll ans = -INF;
    for (ll i = 0; i < n; i++)
        ans = max(ans, check(i));*/

    //cerr << l << " " << r << endl;
    ll ans = max({check(l), check(r), check((l + r) / 2)});
    cout << ans;
    return 0;
}
