#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES

#pragma GCC optimize("Ofast")

#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <iomanip>
#include <math.h>
#include <algorithm>
#include <bitset>
#include <bitset>
//#include <clock>
#include <random>
#include <unordered_set>
#include <unordered_map>
#include <deque>

#define pb push_back
#define mp make_pair
#define all(x) x.begin(), x.end()
#define nn '\n'
#define pp ' '

using namespace std;

typedef long long ll;
typedef long double ld;

template<typename T>
bool uax(T &a, T b){
	if (b > a){
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool uin(T &a, T b){
	if (b < a){
		a = b;
		return true;
	}
	return false;
}

template <typename T>
void debug(string name, T val){
	cout << name << " = " << val << nn;
}
#define value(x) debug(#x, x);

mt19937 rnd(1928);

const ll N = 2e5 + 7;
const ll INF = 1e18 + 7;

int n, q;
string s;
int pc[N], pn[N];

int psumc(int l ,int r){
	if (!l) return pc[r];
	return pc[r] - pc[l - 1];
}

int psumn(int l ,int r){
	if (!l) return pn[r];
	return pn[r] - pn[l - 1];
}

int main(){
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else 
	ios_base::sync_with_stdio(false);
	cin.tie(0);
#endif
	cout << fixed << setprecision(15);
	cin >> n;
	cin >> s;
	if (s[0] == '0'){
		pc[0]++;
	}
	for (int i = 1; i < n; i++){
		pc[i] = pc[i - 1];
		pn[i] = pn[i - 1];
		if (s[i] == '0'){
			if (i % 2 == 0) pc[i]++;
			else pn[i]++;
		}
	}
	cin >> q;
	int l1, l2, len;
	while (q--){
		cin >> l1 >> l2 >> len;
		l1--; l2--;
		int r1 = l1 + len - 1;
		int r2 = l2 + len - 1;
		if (l1 % 2 == l2 % 2){
			if (psumc(l1, r1) == psumc(l2, r2) && psumn(l1, r1) == psumn(l2, r2)){
				cout << "Yes" << nn;
			}
			else {
				cout << "No" << nn;
			}
		}
		else {
			if (psumc(l1, r1) == psumn(l2, r2) && psumn(l1, r1) == psumc(l2, r2)){
				cout << "Yes" << nn;
			}
			else {
				cout << "No" << nn;
			}
		}
	}
}