#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

#define f first
#define s second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define len(x) ((int)x.size())

using namespace std;

namespace IOF {
    #define UNIT template <typename T>
    UNIT istream &operator >>(istream &inp, vector <T> &a) {
        for (auto &el : a)
            inp >> el;
        return inp;
    }
    UNIT ostream &operator <<(ostream &out, vector <T> &a) {
        for (auto &el : a)
            out << el << ' ';
        return out;
    }
}

using namespace IOF;

/**void my_file_in_out() {
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
}*/

const int INF = 1e9 + 7;

vector <vector <int>> g;
vector <int> way;
vector <vector <int>> up;

signed main()
{
    ios::sync_with_stdio(0);
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int n, m;
    cin >> n >> m;

    g.resize(n);
    up.resize(n);
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        //g[u].push_back(v);
        g[v].push_back(u);
    }

    int k;
    cin >> k;
    way.resize(k);
    for (int i = 0; i < k; i++) {
        cin >> way[i];
        way[i]--;
    }

    int start = way[k - 1];
    int finish = way[0];

    vector <int> dist(n, INF);
    dist[start] = 0;
    queue <int> q;
    q.push(start);

    while (!q.empty()) {
        int u = q.front();
        q.pop();
        for (auto v : g[u]) {
            if (dist[v] > dist[u] + 1) {
                dist[v] = dist[u] + 1;
                q.push(v);
            }
            if (dist[v] == dist[u] + 1)
                up[v].push_back(u);
        }
    }

    /*for (auto v : up[1])
        cout << v + 1 << ' ';
    cout << endl << endl;*/

    int MX = 0;
    int MN = 0;

    for (int i = 0; i < k - 1; i++) {
        int v = way[i];
        bool flag = 0;
        for (auto j : up[v])
            if (j == way[i + 1])
                flag = 1;
        //cout << flag << endl;
        if (flag) {
            if (len(up[v]) > 1) {
                MX++;
            }
        } else {
            MX++;
            MN++;
        }
    }

    cout << MN << ' ' << MX;

    return 0;
}
