#include "bits/stdc++.h"

#define pb push_back
#define mp make_pair
#define mt make_tuple
#define le(v) ((int)v.size())
#define x first
#define y second

using namespace std;

template<class T>
istream &operator>>(istream &is, vector<T> &v) {
	for (T &x : v) is >> x;
	return is;
}

template<class A, class B>
istream &operator>>(istream &is, pair<A, B> &pp) {
	is >> pp.x >> pp.y;
	return is;
}

template<class T>
ostream &operator<<(ostream &os, const vector<T> &v) {
	for (const T &x : v) os << x << " ";
	os << "\n";
	return os;
}

template<class A, class B>
ostream &operator<<(ostream &os, const pair<A, B> &pp) {
	os << pp.x << " " << pp.y;
	return os;
}

typedef long long ll;
typedef pair<int, int> pii;
typedef long double ld;

int n, m;
vector<vector<int>> g, reg;
vector<int> dist;

void run() {
	cin >> n >> m;
	g.resize(n); reg.resize(n);
	for (int i = 0; i < m; i++) {
		int a, b; cin >> a >> b; a--;b--;
		g[a].pb(b); reg[b].pb(a);
	}
	int k; cin >> k;
	vector<int> path(k);
	cin >> path;
	for (int i = 0; i < k; i++)
		path[i]--;
	{
		dist.resize(n, 1e9);
		deque<int> deq{path.back()};
		dist[path.back()] = 0;
		while (!deq.empty()) {
			int v = deq[0]; deq.pop_front();
			for (int sub : reg[v]) {
				if (dist[sub] > dist[v] + 1) {
					dist[sub] = dist[v] + 1;
					deq.pb(sub);
				}
			}
		}
	}
	int mx = 0; int mn = 0;
	for (int i = 0; i < le(path) - 1; i++) {
		int x = path[i];

		bool alt = false;
		for (int y : g[x]) {
			if (y == path[i + 1]) continue;
			if (dist[x] == dist[y] + 1) {
				alt = true;
				break;
			}
		}
		bool ok = false;
		for (int y : g[x]) {
			if (y == path[i + 1] && dist[x] == dist[y] + 1) {
				ok = true;
			}
		}
		if (alt) {
			mx++;
		}
		if (!ok) mn++;
	}
	cout << mn << " " << mx << endl;
}

signed main() {
	ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
	// freopen("test.in", "r", stdin);
	run();
}