#include "bits/stdc++.h"

#define pb push_back
#define mp make_pair
#define mt make_tuple
#define le(v) ((int)v.size())
#define x first
#define y second

using namespace std;

template<class T>
istream &operator>>(istream &is, vector<T> &v) {
	for (T &x : v) is >> x;
	return is;
}

template<class A, class B>
istream &operator>>(istream &is, pair<A, B> &pp) {
	is >> pp.x >> pp.y;
	return is;
}

template<class T>
ostream &operator<<(ostream &os, const vector<T> &v) {
	for (const T &x : v) os << x << " ";
	os << "\n";
	return os;
}

template<class A, class B>
ostream &operator<<(ostream &os, const pair<A, B> &pp) {
	os << pp.x << " " << pp.y;
	return os;
}

#define int long long

typedef long long ll;
typedef pair<int, int> pii;
typedef long double ld;

int n, m, p;

const int N = (1 << 20);
int T[2 * N + 1];
int D[2 * N + 1];
void update(int i, int tl, int tr, int ql, int qr, int d) {
	if (tr <= ql || qr <= tl) return;
	if (ql <= tl && tr <= qr) {
		D[i] += d;
	} else {
		int m = (tl + tr) / 2;
		update(i * 2 + 1, tl, m, ql, qr, d);
		update(i * 2 + 2, m, tr, ql, qr, d);
		T[i] = max(T[i * 2 + 1] + D[i * 2 + 1]
			, T[i * 2 + 2] + D[i * 2 + 2]);
	}
}
struct E {
	int x;
	bool is_weapon;
	int cost;
	int y;
	int prior;
};
void run() {
	cin >> n >> m >> p;
	vector<pii> att(n);
	cin >> att;
	vector<pii> def(m);
	cin >> def;
	sort(def.rbegin(), def.rend());
	int pref = 1e13;
	update(0, 0, N, 0, N, -pref);
	vector<int> val(N, -pref);
	for (pii pp : def) {
		val[pp.x] = max(val[pp.x], -pp.y);
	}
	for (int i = 0; i < N; i++) {
		// if (pp.y >= pref) continue;
		// cout << "+" << " " << 0 << " " << pp.x << " " << -pp.y + pref << endl;
		update(0, 0, N, i, i + 1, val[i]);
		// pref = pp.y;
	}
	vector<E> es;
	for (pii pp : att) {
		es.pb({pp.x, true, pp.y, -1, 0});
	}
	for (int i = 0; i < p; i++) {
		int x, y, z;
		cin >> x >> y >> z;
		es.pb({x, false, z, y, 1});
	}
	sort(es.begin(), es.end(), [](E a, E b) {
		return mp(a.x, a.prior) < mp(b.x, b.prior);
	});
	int rez = -1e18;
	for (E e : es) {
		if (e.is_weapon) {
			// cout << e.cost << " " << T[0] + D[0] << endl;
			rez = max(rez, -e.cost + T[0] + D[0]);
		} else {
			// cout << "+" << " " << e.y << " " << e.cost << endl;
			update(0, 0, N, e.y + 1, N, e.cost);
		}
	}
	cout << rez;
}

signed main() {
	ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
	// freopen("test.in", "r", stdin);
	run();
}