#include "bits/stdc++.h"

#define pb push_back
#define mp make_pair
#define mt make_tuple
#define le(v) ((int)v.size())
#define x first
#define y second

using namespace std;

template<class T>
istream &operator>>(istream &is, vector<T> &v) {
	for (T &x : v) is >> x;
	return is;
}

template<class A, class B>
istream &operator>>(istream &is, pair<A, B> &pp) {
	is >> pp.x >> pp.y;
	return is;
}

template<class T>
ostream &operator<<(ostream &os, const vector<T> &v) {
	for (const T &x : v) os << x << " ";
	os << "\n";
	return os;
}

template<class A, class B>
ostream &operator<<(ostream &os, const pair<A, B> &pp) {
	os << pp.x << " " << pp.y;
	return os;
}

typedef long long ll;
typedef pair<int, int> pii;
typedef long double ld;
typedef pair<ll, ll> pll;


mt19937 rng(1337);

const ll MOD0 = 1e9 + 7;
const ll MOD1 = 998244353;

const ll B0 = 18362;
const ll B1 = 1337;

// pair<string, string> gen() {
// 	int n = rng() % 5 + 1;
// 	string s(n, '0');
// 	f(i, n) s[i] = rng() % 2 + '0';
// 	int test = rng() % 20 + 1;
// 	string s0 = s;
// 	f(t, test) {
// 		int i = rng() % n, j = rng() % n;
// 		swap(s[i], s[j]);
// 	}
// 	return mp(s, s0);
// }

// string uni(string s) {
// 	while (true) {
// 		bool upd = false;
// 		for (int i = 0; i < le(s) - 2; i++) {
// 			if (s[i] == '0' && s[i + 1] == '1' && s[i + 1]`)
// 		}
// 	}
// }

// bool gred(string s, string t) {

// }

string s;
void run() {
	int _; cin >> _;
	cin >> s;
	vector<int> pr(le(s));
	pr[0] = (s[0] == '1');
	for (int i = 1; i < le(s); i++) {
		pr[i] = pr[i - 1] + (s[i] == '1');
	}
	auto get_sum = [&](int l, int r) {
		int s = pr[r - 1];
		if (l - 1 >= 0) s -= pr[l - 1];
		return s;
	};
	vector<pll> hs(le(s));
	pll h = mp(0, 0);
	int ones = 0;
	for (int i = 0; i < le(s); i++) {
		if (s[i] == '1') {
			ones++;
		}
		hs[i] = mp((h.x * B0 + ((ones % 2) + 1)),
			h.y * B1 + ((ones % 2) + 1)
		);
		hs[i].x %= MOD0; hs[i].y %= MOD1;
		if (s[i] == '0') {
			ones = 0;
			h = hs[i];
		}
	}
	vector<int> R0(le(s), le(s));
	vector<int> L0(le(s), -1);
	for (int i = 0; i < le(s); i++) {
		if (s[i] == '0') L0[i] = i;
		else if (i > 0) L0[i] = L0[i - 1];
	}
	for (int i = le(s) - 1; ~i; i--) {
		if (s[i] == '0') R0[i] = i;
		else if (i + 1 < le(s)) R0[i] = R0[i + 1];
	}
	// cout <\< L0 << endl;
	// cout << R0 << endl;
	// return;

	vector<ll> pow0{1};
	vector<ll> pow1{1};
	while (le(pow0) < le(s) + 100) {
		pow0.pb((pow0.back() * B0) % MOD0);
		pow1.pb((pow1.back() * B1) % MOD1);
	}
	auto get_hash = [&](int l, int r) {
		int lp = (R0[l] + l) % 2;
		int rp = (L0[r - 1] + r - 1) % 2;
		r = L0[r - 1];
		l = R0[l];
		pll h = hs[r];
		int cnt0 = r - l - get_sum(l, r + 1);
		h.x -= pow0[cnt0] * hs[l].x;
		h.y -= pow1[cnt0] * hs[l].y;
		h.x %= MOD0; if (h.x < 0) h.x += MOD0;
		h.y %= MOD1; if (h.y < 0) h.y += MOD1;
		return mt(h, lp, rp);
	};
	int q; cin >> q;
	for (int i = 0; i < q; i++) {
		int l, r, k; cin >> l >> r >> k;
		l--; r--;
		if (get_sum(l, l + k) != get_sum(r, r + k)) {
			cout << "No" << "\n";
			continue;
		}
		if (get_sum(l, l + k) == k) {
			cout << "Yes" << "\n";
			continue;
		}
		if (get_hash(l, l + k) == get_hash(r, r + k)) {
			cout << "Yes" << "\n";
		} else {
			cout << "No" << "\n";
		}
	}
}

signed main() {
	ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
	// freopen("test.in", "r", stdin);
	run();
}