#include <iostream>
#include <iomanip>
#include <fstream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <unordered_map>
#include <map>
#include <queue>
#include <stack>
#include <type_traits>
#include <cstdlib>
#include <random>
#include <deque>
using namespace std;
typedef long long ll;

struct abc
{
	ll val;
	int ind;
	ll sum;
	abc() : sum(0){};
};

int main()
{
#ifndef ONLINE_JUDGE
	freopen("input.txt","r",stdin);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int n;
	cin >> n;
	vector<abc> a(n);
	ll maxs = 0;
	for(int i = 0;i < n; i++)
	{
		cin >> a[i].val;
		maxs = max(maxs,a[i].val);
		a[i].ind = i + 1;
	}
	sort(a.begin(),a.end(),[](abc a, abc b){return a.val < b.val || a.val == b.val && a.ind < b.ind;});
	if(n == 1)
	{	
		cout << a.front().val;
		return 0;
	}
	unordered_multimap<ll,pair<int,ll>> b;
	for(int i = 0;i < n; i++)
	{
		bool done = false;
		for(unordered_multimap<ll,pair<int,ll>>::iterator it = b.begin(); it != b.end();it++)
		{
			if(a[i].val	- it->second.first == a[i].ind - it->second.second)
			{
				done = true;
				ll s = it->first;
				b.erase(it);
				b.insert(make_pair(s+a[i].val,make_pair(a[i].val,a[i].ind)));
				break;
			}
		}
		if(!done)
			b.insert(make_pair(a[i].val,make_pair(a[i].val,a[i].ind)));
	}
	ll sums = 0;
	for(unordered_multimap<ll,pair<int,ll>>::iterator it = b.begin(); it != b.end();it++)
	{
		sums = max(sums,it->first);
	}
	cout << sums;
	return 0;
}