#include <iostream>
#include <vector>
#include <random>
#include <chrono>

using namespace std;

#ifdef LOCAL
mt19937 rnd(23);
#else
mt19937 rnd(chrono::steady_clock().now().time_since_epoch().count());
#endif

int main() {
#ifdef LOCAL
    freopen("A.in", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    int a[n];
    int b[n];
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < n ; i++) {
        cin >> b[i];
    }
    int remCnt = 1;
    int distrCnt = 0;
    for (int i = 0; i < n; i++) {
        if (a[i] == 0 && b[i] == 1) {
            remCnt++;
        }
        if (a[i] == 1 && b[i] == 0) {
            distrCnt++;
        }
    }
    if (distrCnt == 0) {
        cout << -1 << "\n";
    } else {
        cout << (remCnt + distrCnt - 1) / distrCnt << "\n";
    }

    return 0;
}
