#include <iostream>
#include <vector>


using namespace std;

const char NO_CHAR = 'a' - 3;

const int ALPHA_SIZE = 33;

string s;

// a prev of b
bool isPrev(char a, char b) {
    int aN = a;
    int bN = b;
    return bN- aN == 1;
}


int main() {
#ifdef LOCAL
    freopen("C.in", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    string s;
    cin >> s;
    string cp = s;
    while (!s.empty()) {
        bool was = false;

        int start = 0;
        vector<pair<int, int>> v;
        for (int i = 1; i < s.size(); i++) {
            if (!isPrev(s[i - 1], s[i])) {
                int len = i - start;
                v.emplace_back(start, len);
                start =  i;
            }
        }
        int len = s.size() - start;
        v.emplace_back(start, len);
        bool allow[s.size()];
        fill(allow, allow + s.size(), true);
        for (auto [start, len] : v) {
            for (int j = start + 1; j < start + len; j++) {
                allow[j] = false;
                was = true;
            }
        }
        string newS;
        for (int j = 0; j < s.size(); j++) {
            if (allow[j]) {
                newS += s[j];
            }
        }
        for (int i = 0; i < newS.size(); i++) {
            char prev = NO_CHAR;
            char next = NO_CHAR;
            if (i > 0) {
                prev = newS[i - 1];
            }
            if (i < newS.size() - 1) {
                next = newS[i + 1];
            }
            if (isPrev(prev, newS[i]) || isPrev(next, newS[i])) {
                newS.erase(newS.begin() + i);
                was = true;
                break;
            }
        }
        s = newS;
        if (!was) {
            break;
        }
    }
    cout << (int) cp.size() - (int) s.size() << "\n";

    return 0;
}