#include <bits/stdc++.h>

using namespace std;
#pragma GCC optimize("Ofast")
#define get(x) cout << #x << " : " << x << endl;
#define int long long
const int MAX = (int)2e5 + 10;
const int INF = (int)1e9 + 9;

void fast() {
    ios::sync_with_stdio(false);
    cin.tie(0);
}

/*const int MAXT = (int)2e5;
int t[8 * MAXT], b[MAXT];

void build(int v, int lv, int rv) {
    if (lv == rv) {
        t[v] = b[lv];
        return;
    }
    int m = (lv + rv) >> 1;
    build((v << 1) + 1, lv, m);
    build((v << 1) + 2, m + 1, rv);
    t[v] = t[(v << 1) + 1] + t[(v << 1) + 2];
}*/

int gcd(int a, int b) {
    return b ? gcd(b, a % b) : a;
}

int lcm(int a, int b) {
    return a / gcd(a, b) * b;
}

int f(int x) {
    return x;
}

int binSearch(int l, int r, int x) {
    while (l + 1 != r) {
        int m = r - ((r - l) >> 1);
        if (f(m) > x) l = m;
        else r = x;
    }
    return x;
}

vector<int> graph[MAX];
vector<int> rgraph[MAX];
int dist[MAX];

void djk(int v) {
    for (int i = 0; i < MAX; ++i) dist[i] = INF;
    dist[v] = 0;
    set<pair<int, int>> st;
    st.insert({0, v});
    while (!st.empty()) {
        pair<int, int> now = *st.begin();
        st.erase(st.begin());
        for (int to : rgraph[now.second]) {
            if (dist[to] > dist[now.second] + 1) {
                st.erase({dist[to], to});
                dist[to] = dist[now.second] + 1;
                st.insert({dist[to], to});
            }
        }
    }
}

signed main() {
    fast();
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int from, to;
        cin >> from >> to;
        --from, --to;
        graph[from].push_back(to);
        rgraph[to].push_back(from);
    }
    int k;
    cin >> k;
    int path[k];
    for (int i = 0; i < k; ++i) {
        cin >> path[i];
        --path[i];
    }
    djk(path[k - 1]);
    int minimum = 0, maximum = 0;
    for (int i = 1; i < k; ++i) {
        int cnt = 0;
        for (int to : graph[path[i - 1]]) {
            if (dist[to] == dist[path[i - 1]] - 1) ++cnt;
        }
        minimum += dist[path[i]] != (dist[path[i - 1]] - 1);
        maximum += dist[path[i]] != (dist[path[i - 1]] - 1);
        maximum += cnt >= 2;
    }
    cout << minimum << ' ' << maximum << endl;
    return 0;
}
