#include "bits/stdc++.h"
using namespace std;
#define ll long long
#define w while
#define elif else if
#define con continue
#define br break
#define ld long double
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define forn(a) for (ll i = 0; i < a; i++)
#define prec(a) fixed << setprecision(a)
#define INF 1000000000000000000
#define inf 1000000000
#define eps 1e-4
#define EPS 1e-8
#define MOD 1000000007

const ll hp1 = 359657;
const ll hm1 = 1000000007;
const ll hp2 = 307;
const ll hm2 = 1000000009;

pair <vector <ll>, vector <ll>> phash(const string &s, ll p, ll m) {
    vector <ll> ans(s.size() + 1, 0);
    vector <ll> ppow(s.size() + 1, 1);
    for (ll i = 0; i < s.size(); i++) {
        ans[i + 1] = (s[i] + ans[i] * p) % m;
        ppow[i + 1] = (ppow[i] * p) % m;
    }
    return {ans , ppow};
}

ll substrhash(pair <vector <ll>, vector <ll>> hash, ll fi, ll la, ll m) {
    return (hash.first[la + 1] - hash.first[fi] * hash.second[la - fi] + m * m) % m;
}

vector <ll> zfu(const string &s) {
    vector <ll> z(s.size(), 0);
    ll l = 0, r = 0;
    for (ll i = 1; i < s.size(); i++) {
        z[i] = max(0ll, min(r - i, z[i - l]));
        w(i + z[i] < s.size() && s[z[i]] == s[z[i] + i])
            z[i]++;
        if (i + z[i] > r) {
            l = i;
            r = i + z[i];
        }
    }
    z[0] = s.size();
    return z;
}

ll binpow(ll a, ll n, ll m) {
    if (n == 0)
        return 1;
    if (n % 2) {
        return (binpow(a, n - 1, m) * a) % m;
    } else {
        ll b = binpow(a, n / 2, m);
        return (b * b) % m;
    }
}

ll binpow(ll a, ll n) {
    if (n == 0)
        return 1;
    if (n % 2) {
        return (binpow(a, n - 1) * a);
    } else {
        ll b = binpow(a, n / 2);
        return (b * b);
    }
}

ll gcd(ll a, ll b) {
    return a ? gcd(b % a, a) : b;
}

signed main() {
    ll n, q;
    cin >> n;
    string inn;
    cin >> inn;
    cin >> q;
    vector <ll> ps(n);
    if (n == 1) {
        ps[0] = (inn[0] == '1');
    } else {
        ps[0] = (inn[0] == '1');
        ps[1] = (inn[1] == '1');
    }
    for (ll i = 2; i < n; i++) {
        ps[i] = ps[i - 2] + (inn[i] == '1');
    }
    ll s1, s2, l;
    for (ll i = 0; i < q; i++) {
        cin >> s1 >> s2 >> l;
        s1--;
        s2--;
        if (l % 2) {
            if (l == 1) {
                if (inn[s1] == inn[s2]) {
                    cout << "YES\n";
                } else {
                    cout << "NO\n";
                }
            } else {
                if (ps[s1 + l - 1] - ps[s1] + (inn[s1] - '0') == ps[s2 + l - 1] - ps[s2] + (inn[s2] - '0') &&
                ps[s1 + l - 2] - ps[s1 + 1] + (inn[s1 + 1] - '0') == ps[s2 + l - 2] - ps[s2 + 1] + (inn[s2 + 1] - '0'))
                    cout << "YES\n";
                else
                    cout << "NO\n";
            }
        } else {
            if (l == 2) {
                if (inn[s1] == inn[s2] && inn[s1 + 1] == inn[s2 + 1]) {
                    cout << "YES\n";
                } else {
                    cout << "NO\n";
                }
            } else {
                if (ps[s1 + l - 2] - ps[s1] + (inn[s1] - '0') == ps[s2 + l - 2] - ps[s2] + (inn[s2] - '0') &&
                    ps[s1 + l - 1] - ps[s1 + 1] + (inn[s1 + 1] - '0') == ps[s2 + l - 1] - ps[s2 + 1] + (inn[s2 + 1] - '0'))
                    cout << "YES\n";
                else
                    cout << "NO\n";
            }
        }
    }
    return 0;
}
