#include <bits/stdc++.h>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int n, m;
    cin >> n >> m;
    vector<int> g[n];
    vector<int> revg[n];
    for (int i = 0; i < m; i++)
    {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        g[x].push_back(y);
        revg[y].push_back(x);
    }
    int k;
    cin >> k;
    vector<int> path(k);
    for (int i = 0; i < k; i++)
    {
        cin >> path[i];
        path[i]--;
    }
    queue<int> q;
    q.push(path[k - 1]);
    vector<int> dist(n, 1e9);
    dist[q.front()] = 0;
    vector<int> a[n];
    while (!q.empty())
    {
        int cur = q.front();
        q.pop();
//        cout << cur << " " ;
        for (int i = 0; i < revg[cur].size(); i++)
        {
            int u = revg[cur][i];
            if (dist[u] > dist[cur] + 1)
            {
                dist[u] = dist[cur] + 1;
                q.push(u);
            }
            if (dist[u] == dist[cur] + 1)
            {
                a[u].push_back(cur);
            }
        }
    }
//    for (int i = 0; i < n; i++)
//    {
//        cout << dist[i] << " ";
//    }
//    cout << endl;

    int minans = 0;
    int maxans = 0;
    for (int i = 0; i < k - 1; i++)
    {
        int cur = path[i];
        int next = path[i + 1];
        if (dist[cur] > dist[next])
        {
            if (a[cur].size() > 1)
            {
                maxans++;
            }
        }
        else
        {
//            cout << i << endl;
            minans++;
            maxans++;
        }
    }
    cout << minans << " " << maxans;

}
