#include <bits/stdc++.h>

using namespace std;
struct monster
{
    int def, off, money;
    monster(int def, int off, int money) : def(def), off(off), money(money) {}
};

bool operator < (monster a, monster b)
{
    return (a.off < b.off) || (a.off == b.off && a.def < b.def) || (a.off == b.off && a.def == b.def && a.money > b.money);
}
vector<pair<int, int> > def;
int first_def(int x)
{
    int l = -1;
    int r = def.size();
    while (r - l > 1)
    {
        int m = (l + r) / 2;
        if (def[m].first >= x)
            r = m;
        else
            l = m;
    }
    return r;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int n, m, p;
    cin >> n >> m >> p;
    vector<pair<int, int> > weapon;
    for (int i = 0; i < n; i++)
    {
        long long x, y;
        cin >> x >> y;
        weapon.push_back({x, y});
    }
    sort(weapon.begin(), weapon.end());

    for (int i = 0; i < m; i++)
    {
        long long x, y;
        cin >> x >> y;
        def.push_back({x, y});
    }
    sort(def.begin(), def.end());
    vector<monster> monsters;
    for (int i = 0; i < p; i++)
    {
        long long x, y, z;
        cin >> x >> y >> z;
        monsters.push_back(monster(x, y, z));
    }
    sort(monsters.begin(), monsters.end());
    long long atk = 0;
    long long answer = -1e18;
    vector<long long> pref(1000010, 0);
    long long cur_pref = 0;
    for (int mon = 0; mon < p; mon++)
    {
        long long oldatk = atk;
        while ((atk < n) && (weapon[atk].first <= monsters[mon].off)) atk++;
        if (oldatk == atk)
        {
            cur_pref += monsters[mon].money;
        }
        else
        {
            cur_pref = monsters[mon].money;
        }
        if (atk == n) break;
        long long deff = first_def(monsters[mon].def + 1);
        pref[deff] += cur_pref;
//        cout << atk << " " << deff << " " << pref[deff] - def[deff].second - weapon[atk].second << endl;
        answer = max(answer, pref[deff] - def[deff].second - weapon[atk].second);
    }
    cout << answer;
}
