#include <bits/stdc++.h>

using namespace std;
inline void fastio() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
}

const int maxN = 2e5 + 123;
vector <int> g[maxN], g2[maxN];
vector <int> usd;
vector <int> d;
int n, m;

void bfs(int s) {
	queue <int> Q;
	usd.assign(n, 0);
	d.assign(n, maxN + 123);
	d[s] = 0;
	usd[s] = 1;
	Q.push(s);
	while(!Q.empty()) {
		int from = Q.front();
		Q.pop();
		for(int i = 0; i < g[from].size(); ++i) {
			int to = g[from][i];
			if(usd[to]) continue;
			usd[to] = 1;
			d[to] = d[from] + 1;
			Q.push(to);
		}
	}
}

void solve() {
	cin >> n >> m;
	for(int i = 0; i < m; ++i) {
		int a, b;
		cin >> a >> b;
		a--; b--;
		g[b].push_back(a);
		g2[a].push_back(b);
	}
	int num;
	cin >> num;
	vector <int> path(num);
	for(int i = 0; i < num; ++i) {
		cin >> path[i];
		path[i]--;
	}
	int s = path.back();
	bfs(s);
	/*for(int i = 0; i < d.size(); ++i) {
		cout << d[i] << ' ';
	} cout << '\n';*/
	int minimum = num - 1, maximum = num - 1;
	for(int i = 0; i < num - 1; ++i) {
		int V = path[i];
		int cnt = 0;
		int minimalV = g2[V][0];
		cnt++;
		for(int j = 1; j < g2[V].size(); ++j) {
			if(d[g2[V][j]] < d[minimalV]) {
				minimalV = g2[V][j];
				cnt = 1;
			} else if(d[g2[V][j]] == d[minimalV]) {
				cnt++;
			}
		}
		// cout << "minimalV = " << minimalV + 1 << '\n';
		if(d[minimalV] == d[path[i + 1]]) {
			minimum--;
			// cout << "max++\n";
			if(cnt == 1) {
				maximum--;
				// cout << "min++\n";
			}
		}
		// cout << '\n';
	}
	cout << minimum << " " << maximum << '\n';
}

// #define lolipop

signed main() {
#ifdef lolipop
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	fastio();
	solve();
	return 0;
}