#include <bits/stdc++.h>

using namespace std;

int main()
{
    //freopen("D.in", "r", stdin);
    int n, m;
    cin >> n >> m;
    vector<vector<int>> g(n), rg(n);
    for (int i = 0; i < m; i++)
    {
        int u, w;
        cin >> u >> w;
        u--, w--;
        g[u].emplace_back(w);
        rg[w].emplace_back(u);
    }
    int k;
    cin >> k;
    vector<int> p(k);
    for (int i = 0; i < k; i++)
        cin >> p[i], p[i]--;
    int st = p[k - 1];
    queue<int> q;
    q.emplace(st);
    vector<int> dist(n, -1);
    dist[st] = 0;
    while (!q.empty())
    {
        int curr = q.front();
        q.pop();
        for (int next : rg[curr])
        {
            if (dist[next] != -1)
                continue;
            dist[next] = dist[curr] + 1;
            q.emplace(next);
        }
    }
    vector<set<int>> bst(n);
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < g[i].size(); j++)
        {
            if (dist[g[i][j]] == dist[i] - 1)
                bst[i].emplace(g[i][j]);
        }
    }
//    for (int i = 0; i < n; i++)
//    {
//        cerr << i << ":\n";
//        for (auto j : bst[i])
//            cerr << j << ' ';
//        cerr << endl;
//    }
    int mi = 0, ma = 0;
    for (int i = 0; i < k - 1; i++)
    {
        if (bst[p[i]].count(p[i + 1]) == 0)
            mi++, ma++;
        else
            if (bst[p[i]].size() > 1)
                ma++;
    }
    cout << mi << ' ' << ma << endl;
    return 0;
}

