#include <bits/stdc++.h>

#define ll long long
#define ld long double
#define all(v) v.begin(), v.end()
#define trace(x) cout << #x"=" << x << endl

using namespace std;

const ll inf = 1e9 + 9;
const ll mod = 1e9 + 7;
const ll e = 1e-9;

#define int long long


const int maxn = 2e5 + 10;

vector<int> graph[maxn];
vector<int> rgraph[maxn];

int dist_s[maxn];
int dist_t[maxn];

bool was[maxn];

void bfs(int from, int dist[], bool type) {
    queue<int> x;
    x.push(from);
    dist[from] = 0;
    while(!x.empty()){
        int v = x.front();
        trace(v);
        x.pop();
        was[v] = true;
        if(type){
            for(int u: graph[v]){
                trace(u);
                if(!was[u]){
                    was[u] = true;
                    dist[u] = dist[v] + 1;
                    x.push(u);
                }
            }
        }else{
            for(int u: rgraph[v]){
                if(!was[u]){
                    was[u] = true;
                    dist[u] = dist[v] + 1;
                    x.push(u);
                }
            }
        }
    }
}

int p[maxn];


signed main(){
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    int n, m;
    cin >> n >> m;
    for(int i = 0; i < m; ++i){
        int u, v;
        cin >> u >> v;
        --u, --v;
        graph[u].push_back(v);
        rgraph[v].push_back(u);
    }
    int k;
    cin >> k;
    for(int i = 0; i < k; ++i){
        cin >> p[i];
        --p[i];
    }
    int s = p[0];
    int t = p[k - 1];
    bfs(s, dist_s, true);
    bfs(t, dist_t, false);
    int shortest = dist_s[t];
    int good = 0;
    int bad = 0;
    for(int i = 0; i < k - 1; ++i){
        if(dist_s[p[i]] + dist_t[p[i + 1]] + 1 != shortest){
            good++;
            bad++;
        }else{
            for(int u: graph[p[i]]) {
                if(dist_s[p[i]] + dist_t[u] + 1 == shortest){
                    ++bad;
                    break;
                }
            }
        }
    }
    cout << good << " " << bad;
    return 0;
}
