#include <bits/stdc++.h>

#define ll long long
#define ld long double
#define all(v) v.begin(), v.end()
#define trace(x) cout << #x"=" << x << endl

using namespace std;

const ll inf = 1e9 + 9;
const ll mod = 1e9 + 7;
const ll e = 1e-9;

#define int long long


const int maxn = 2e5 + 10;
const int maxb = 1e6 + 10;


struct node {
    int max_pref_len, max_pref_sum, len, sum;
};

node combine(const node &l, const node &r) {
    pair<int, int> left = {l.max_pref_sum, l.max_pref_len};
    pair<int, int> right = {l.sum + r.max_pref_sum, l.len + r.max_pref_len};
    auto first = max(left, right);
    return {first.second, first.first, l.len + r.len, l.sum + r.sum};
}

node t[maxb * 4];

void build(int v = 1, int tl = 0, int tr = maxn) {
    if (tr - tl == 1) {
        t[v] = {0, 0, 1, 0};
        return;
    }
    int m = (tl + tr) / 2;
    build(v * 2, tl, m);
    build(v * 2 + 1, m, tr);
    t[v] = combine(t[v * 2], t[v * 2 + 1]);
}

void update(int i, int val, int v = 1, int tl = 0, int tr = maxn) {
    if (tr - tl == 1) {
        t[v].sum += val;
        if (t[v].sum > 0) {
            t[v].max_pref_len = 1;
            t[v].max_pref_sum = t[v].sum;
        }
        return;
    }
    int m = (tl + tr) / 2;
    if (i < m) {
        update(i, val, v * 2, tl, m);
    } else {
        update(i, val, v * 2 + 1, m, tr);
    }
    t[v] = combine(t[v * 2], t[v * 2 + 1]);
}

struct monster {
    int x, y, z;
};

bool operator<(const monster &lhs, const monster &rhs) {
    return lhs.x < rhs.x;
}

monster mon[maxn];
int a[maxn];
int ca[maxn];
int cb[maxn];
int b[maxn];


signed main() {
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    int n, m, p;
    cin >> n >> m >> p;
    int mnca = 0, mncb = 0;
    for (int i = 0; i < n; ++i) {
        cin >> a[i] >> ca[i];
        mnca = min(mnca, ca[i]);
    }
    build();
    vector<int> bs;
    for (int i = 0; i < m; ++i) {
        cin >> b[i] >> cb[i];
        mncb = min(mncb, cb[i]);
        bs.push_back(b[i]);
        update(b[i], -cb[i]);
    }
    sort(all(bs));
    for (int i = 0; i < p; ++i) {
        cin >> mon[i].x >> mon[i].y >> mon[i].z;
    }
    sort(mon, mon + p);
    int pointer = 0;
    int mx = -mnca - mncb;
    for (int i = 0; i < n; ++i) {
        while (pointer < p && mon[p].x < a[i]) {
            int min_need = *upper_bound(all(bs), mon[pointer].y);
            update(min_need, mon[pointer].z);
            ++pointer;
        }
        mx = max(mx, t[1].max_pref_sum - ca[i]);
    }
    cout << mx;
    return 0;
}
