#include <iostream>
#include <string>
#include <vector>

using namespace std;

typedef long long ll;
typedef vector<ll> lvec;
typedef pair<ll, ll> lpair;

#ifdef LOCAL
#define TEST "A"
#endif

#pragma GCC optimize("-Ofast")
#pragma GCC optimize("unroll-loops")
const ll INF = 1e9;

int main() {
#ifdef LOCAL
    if (!freopen(TEST ".in", "r", stdin)) cerr << "Test opening error";
    freopen("Out", "w", stdout);
#endif
    cin.tie(0);
    cout.tie(0);
    ios::sync_with_stdio(false);
    ll n;
    cin >> n;
    lvec balance(n);
    for(ll i = 0 ; i < n ; i ++) {
        ll x;
        cin >> x;
        balance[i] += x;
    }
    for(ll i = 0 ; i < n ; i ++) {
        ll x;
        cin >> x;
        balance[i] -= x;
    }
    ll dif = 1, space = 0;
    for(auto el : balance) {
        if(el == -1) dif++;
        if(el == 1) space++;
    }
    if(space == 0) {
        cout << -1;
        return 0;
    }
    cout << (dif + space - 1) / space;
    return 0;
}
