#include <bits/stdc++.h>
#define endl '\n'
#define forn (i, n) for (int (i) = 0; (i) < (n); ++(i))
#define all(a) (a).begin(), (a).end()
#define len(a) (int) (a).size()
using namespace std;
void solve();
signed main(){
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    solve();
    return 0;
}


const int maxn = (int) 1e6 + 7;
const int inf =  (int) 1e9 + 7;


struct node {
    int l, r;
    node* left, *right;

    int add;
    int min_val;
};

node* build(vector<int>& a, int l, int r){
    node *v = new node();
    v->l = l, v->r = r; v->add = 0;
    if (l == r){
        v->left = v->right = nullptr;
        v->min_val = a[l];
        return v;
    }
    int m = (l + r) / 2;
    v->left = build(a, l, m);
    v->right = build(a, m + 1, r);
    v->min_val = min(v->left->min_val, v->right->min_val);
    return v;
}

int add(node* v, int l, int r, int val){
    if (l > v->r || r < v->l){
        return v->min_val + v->add;
    }
    if (l <= v->l && v->r <= r){
        v->add += val;
        return v->min_val + v->add;
    }
    v->min_val = min(add(v->left, l, r, val), add(v->right, l, r, val));
    return v->min_val + v->add;
}



int get(node* v){
    return v->min_val + v->add;
}
struct monster{
    int at, df;
    int cst;
};


bool operator < (const monster& a, const monster& b){
    return make_pair(a.at, a.df) < make_pair(b.at, b.df);
}


int at[maxn];
vector<int> df;



void solve(){
    int n, m, p; cin >> n >> m >> p;
    df.resize(maxn);
    for (int i = 0; i < maxn; ++i) at[i] = df[i] =  inf;
    for (int i = 0; i < n; ++i){
        int a, c; cin >> a >> c;
        at[a] = min(at[a], c);
    }


    for (int i = maxn - 2; i >= 0; --i)
        at[i] = min(at[i], at[i + 1]);

    for (int i = 0; i < m; ++i){
        int a, c; cin >> a >> c;
        df[a] = min(df[a], c);
    }
    for (int i = maxn - 2; i >= 0; --i)
        df[i] = min(df[i], df[i + 1]);


    vector<monster> mn(p);
    for (int i = 0; i < p; ++i){
        cin >> mn[i].at >> mn[i].df >> mn[i].cst;
    }
    sort(all(mn));
    int bst = inf * 2;
    int cur = 0;


    node* tree = build(df, 0, maxn - 1);

    for (int atval = 0; atval < maxn; ++atval){
        if (atval != 0 && at[atval] == at[atval - 1]) continue;



        while (cur < p && mn[cur].at < atval){
            add(tree, mn[cur].df + 1, maxn - 1, -mn[cur].cst);
            cur++;
        }
        bst = min(bst, get(tree) + at[atval]);
    }


    cout << -bst << endl;
}