#include <bits/stdc++.h>

#define sq(x) ((x)*(x))
#define err(x) cerr << "["#x"]  " << (x) << "\n";
#define errv(x) {cerr << "["#x"]  [";for (const auto& iii : (x)) cerr << (iii) << ", "; cerr << "]\n";}
#define errvn(x, n) {cerr << "["#x"]  [";for (int iii = 0; iii < (n); ++iii) cerr << ((x)[iii]) << ", "; cerr << "]\n";}
#define errf() cerr << "\n\n";

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

mt19937 rng(chrono::steady_clock().now().time_since_epoch().count());

int getrnd(int a, int b) {
    return uniform_int_distribution<int>(a, b)(rng);
}

template<typename T1, typename T2>
bool relax(T1& a, const T2& b) {
    if (a > b) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T1, typename T2>
bool strain(T1& a, const T2& b) {
    if (a < b) {
        a = b;
        return 1;
    }
    return 0;
}

///////////////////////////////////////////////

const int N = 2e5 + 3;

int n, m, p[N];

void bfs(int st, vector<int>& d, vector<vector<int>>& graph) {
    d.assign(n, N + 1);

    queue<int> scope;
    scope.push(st);
    d[st] = 0;
    while (!scope.empty()) {
        int v = scope.front();
        scope.pop();

        for (int to : graph[v]) {
            if (relax(d[to], d[v] + 1)) {
                d[to] = d[v] + 1;
                scope.push(to);
            }
        }
    }
}

void solve() {
    cin >> n >> m;

    vector<vector<int>> gr(n), ginv(n);
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        --a; --b;
        gr[a].emplace_back(b);
        ginv[b].emplace_back(a);
    }

    int k; cin >> k;
    for (int i = 0; i < k; ++i)
        cin >> p[i], --p[i];

    vector<int> to(n), from(n);
    //bfs(p[0],to, gr);
    bfs(p[k - 1], from, ginv);

    //errv(to);
    errv(from);

    int mn = 0, mx = 0;
    for (int i = 0; i < k - 1; ++i) {
        if (from[p[i + 1]] == from[p[i]] - 1) {
            int cnt = 0;
            for (int to : gr[p[i]]) {
                if (from[to] == from[p[i]] - 1)
                    ++cnt;
            }
            if (cnt > 1)
                ++mx;
        }
        else {
            ++mn; ++mx;
        }
    }
    cout << mn << ' ' << mx << '\n';
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(nullptr); cout.tie(nullptr);

    int t = 1;
    //cin >> t;
    while (t--)
        solve();

    return 0;
}
