#include <bits/stdc++.h>

using namespace std;
int n, m, p, a[200001], ca[200001], b[200001], cb[200001], x[200001], y[200001], z[200001], id[200001], id2[200001], t[1600001], add[1600001];
void push(int v, int tl, int tr){
    if(add[v]){
        if(tl != tr){
            add[v + v] += add[v];
            add[v + 1 + v] += add[v];
        }
        t[v] += add[v];
        add[v] = 0;
    }
}
void build(int v, int tl, int tr){
    if(tl == tr){
        t[v] = -2e9;
        return;
    }
    int mid = (tl + tr) / 2;
    build(v + v, tl, mid);
    build(v + 1 + v, mid + 1, tr);
    t[v] = min(t[v + v], t[v + 1 + v]);
}
void update(int v, int tl, int tr, int l, int r, int val){
    push(v, tl, tr);
    if(l > r){
        return;
    }
    if(tl == l && tr == r){
        add[v] += val;
        push(v, tl, tr);
        return;
    }
    int mid = (tl + tr) / 2;
    update(v + v, tl, mid, l, min(r, mid), val);
    update(v + 1 + v, mid + 1, tr, max(l, mid + 1), r, val);
    t[v] = max(t[v + v], t[v + 1 + v]);
}
void update2(int v, int tl, int tr, int pos, int val){
    if(tl == tr){
        t[v] = max(t[v], val);
        return;
    }
    int mid = (tl + tr) / 2;
    if(mid >= pos){
        update2(v + v, tl, mid, pos, val);
    }
    else{
        update2(v + 1 + v, mid + 1, tr, pos, val);
    }
    t[v] = max(t[v + v], t[v + 1 + v]);
}
int get(int v, int tl, int tr, int l, int r){
    push(v, tl, tr);
    if(l > r){
        return -2e9;
    }
    if(tl == l && tr == r){
        return t[v];
    }
    int mid = (tl + tr) / 2;
    return max(get(v + v, tl, mid, l, min(r, mid)), get(v + 1 + v, mid + 1, tr, max(l, mid + 1), r));
}
vector < int > v;
bool cmp(int c, int b){
    return a[c] < a[b];
}
bool cmp2(int c, int b){
    return x[c] < x[b];
}
int main(){
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n >> m >> p;
    for(int i = 1; i <= n; i++){
        cin >> a[i] >> ca[i];
        id[i] = i;
    }
    for(int i = 1; i <= m; i++){
        cin >> b[i] >> cb[i];
        v.push_back(b[i]);
    }
    for(int i = 1; i <= p; i++){
        cin >> x[i] >> y[i] >> z[i];
        v.push_back(y[i]);
        id2[i] = i;
    }
    sort(id + 1, id + 1 + n, &cmp);
    sort(id2 + 1, id2 + 1 + p, &cmp2);
    sort(v.begin(), v.end());
    int sz = (int)v.size() - 1;
    build(1, 0, sz);
    for(int i = 1; i <= m; i++){
        b[i] = (int)(lower_bound(v.begin(), v.end(), b[i]) - v.begin());
        update2(1, 0, sz, b[i], -cb[i]);
    }
    for(int i = 1; i <= p; i++){
        y[i] = (int)(lower_bound(v.begin(), v.end(), y[i]) - v.begin());
    }
    int pos = 1;
    int ans = -2e9;
    for(int i = 1; i <= n; i++){
        while(pos <= p && x[id2[pos]] < a[id[i]]){
            update(1, 0, sz, y[id2[pos]] + 1, sz, z[id2[pos]]);
            pos++;
        }
        ans = max(ans, get(1, 0, sz, 0, sz) - ca[id[i]]);
    }
    cout << ans;
}
