#include <bits/stdc++.h>

using namespace std;

#define REP(a,b,c) for(ll a=ll(b); a<ll(c); a++)
#define RE(a,b) REP(a,0,b)
#define INF (1e9+1e8)
#define pb push_back
#define fi first
#define se second
typedef long long ll;
typedef pair<ll, ll> ii;
typedef vector<ll> vi;
typedef vector<ii> vii;
typedef vector<ll> vll;

const ll MX = 3e5, MOD=1e9+7;
ll n, m, p, a[MX], ca[MX], b[MX], cb[MX], x[MX], y[MX], z[MX];
ll SA[MX], SB[MX], SC[MX], SD[MX], SDREV[MX];
ll SEG[MX*4], LAZY[MX*4];

void buildSeg(ll P=0, ll l=0, ll r=p-1) {
    SEG [P] = 0;
    LAZY[P] = 0;
    if(l == r) return;
    ll m=(l+r)/2;
    buildSeg(P*2+1,l,m);
    buildSeg(P*2+2,m+1,r);
}
void addSeg(ll i, ll j, ll v, ll lazy=0, ll P=0, ll l=0, ll r=p-1) {
    SEG [P] += lazy;
    LAZY[P] += lazy;
    if(j < l || i > r) return;
    if(i <= l && j >= r) {
        SEG [P] += v;
        LAZY[P] += v;
        return;
    }
    ll m=(l+r)/2;
    addSeg(i,j,v,LAZY[P],P*2+1,l,m);
    addSeg(i,j,v,LAZY[P],P*2+2,m+1,r);
    LAZY[P] = 0;
    SEG[P] = max(SEG[P*2+1], SEG[P*2+2]);
}
ll firstMonsterStrongerThen(ll i) {
    ll lb=0, ub=p-1;
    while(lb != ub) {
        ll mid=(lb+ub)/2;
        if(y[SD[mid]] >= i) ub = mid;
        else lb = mid+1;
    }
    return lb;
}

int main() {
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    cin>>n>>m>>p;
    RE(i,n) cin>>a[i]>>ca[i];
    RE(i,m) cin>>b[i]>>cb[i];
    RE(i,p) cin>>x[i]>>y[i]>>z[i];
    RE(i,n) SA[i] = i;
    RE(i,m) SB[i] = i;
    RE(i,p) SC[i] = i;
    RE(i,p) SD[i] = i;
    sort(SA, SA+n, [](ll i, ll j) {
        return a[i]<a[j];
    });
    sort(SB, SB+m, [](int i, ll j) {
        return b[i]<b[j];
    });
    sort(SC, SC+p, [](ll i, ll j) {
        return x[i]<x[j];
    });
    sort(SD, SD+p, [](ll i, ll j) {
        return y[i]<y[j];
    });
    RE(i,p) SDREV[SD[i]] = i;

    // armor price
    ll maxPrice = INF;
    for(ll i=m-1; i>=0; i--) {
        if(cb[SB[i]] > maxPrice) continue;
        if(maxPrice != INF) {
            ll firstMonst = firstMonsterStrongerThen(b[SB[i]]);
            if(y[SD[firstMonst]] >= b[SB[i]]) { // check if current armor is strong enough to survive all
                addSeg(firstMonst, p-1, cb[SB[i]]-maxPrice);
            }
        }
        maxPrice = cb[SB[i]];
    }
    addSeg(0, p-1, 0-maxPrice);

    ll ans = -1e18; ll curMonst=0;
    RE(i,n) {
        ll profit = -ca[SA[i]];
        while(curMonst != p && x[SC[curMonst]] < a[SA[i]]) {
            addSeg(SDREV[SC[curMonst]],p-1,z[SC[curMonst]]);
            curMonst++;
        }
        profit += SEG[0];
        ans = max(ans, profit);
    }

    cout<<ans<<endl;

    return 0;
}
