#include <bits/stdc++.h>

#define f first
#define s second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define ll long long
#define db double
#define ld long double
#define pii pair<int, int>
#define mp make_pair
#define pb push_back
#define eb emplace_back
#define output(a) cout << '!' << #a << ' '; for (int& el : a) cout << el << ' '; cout << '\n'; cout.flush();
#define sz(el) int(el.size())
#define xmin(a,b) a = min(a, b)
#define xmax(a,b) a = max(a, b)

using namespace std;

const int INF = 1000000017;

struct mz {
    int x, y, z;
};

bool operator<(const mz& a, const mz& b) {
    return a.x < b.x;
}

vector<int> bx;
vector<pii> a, b;
vector<mz> c;

struct tree {
    vector<pii> t;
    int sz = 1;

    tree() {}

    tree(vector<pii>& b) {
        int n = sz(b);
        //cout << n << endl;
        while (sz < n) {
            sz <<= 1;
        }
        t.resize(sz << 1, mp(-INF, 0));
        for (int i = sz; i < sz + n; ++i) {
            t[i].f = -b[i - sz].s;
        }
        for (int i = sz - 1; i >= 1; --i) {
            t[i].f = max(t[i << 1].f, t[i << 1 | 1].f);
        }
    }

    void print() {
        cout << sz(t) << endl;
        /*for (pii& el : t) {
            cout << el.f << ' ';
        }
        cout << endl;*/
    }

    void push(int v) {
        t[v].f += t[v].s;
        if (v < sz) {
            t[v << 1].s += t[v].s;
            t[v << 1 | 1].s += t[v].s;
        }
        t[v].s = 0;
    }

    void add(int v, int l, int r, int L, int R, int x) {
        push(v);
        if (l > R || r < L) {
            return;
        }
        if (l >= L && r <= R) {
            t[v].s += x;
            push(v);
            return;
        }
        int m = (l + r) >> 1;
        add(v << 1, l, m, L, R, x);
        add(v << 1 | 1, m + 1, r, L, R, x);
        t[v].f = max(t[v << 1].f, t[v << 1 | 1].f);
    }

    int get() {
        return t[1].f;
    }
};

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    //freopen("input.txt", "r", stdin);

    int n, m, p;
    cin >> n >> m >> p;
    a.resize(n);
    b.resize(m);
    bx.resize(m);
    c.resize(p);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].f >> a[i].s;
    }
    for (int i = 0; i < m; ++i) {
        cin >> b[i].f >> b[i].s;
    }
    for (int i = 0; i < p; ++i) {
        cin >> c[i].x >> c[i].y >> c[i].z;
    }
    sort(all(a));
    sort(all(b));
    sort(all(c));
    tree t = tree(b);
    for (int i = 0; i < m; ++i) {
        bx[i] = b[i].f;
    }
    int it = 0;
    int ans = -INF * 2;
    for (int i = 0; i < n; ++i) {
        //t.print();
        while (it < p && c[it].x < a[i].f) {
            //cout << c[it].y << endl;
            //output(bx);
            //cout << (int(upper_bound(all(bx), c[it].y) - bx.begin()) + 1) << '\n';
            t.add(1, 1, t.sz, int(upper_bound(all(bx), c[it].y) - bx.begin()) + 1, m, c[it].z);
            ++it;
        }
        xmax(ans, -a[i].s + t.get());
    }
    cout << ans;
    return 0;
}
