#include <bits/stdc++.h>

#define fi first
#define se second

typedef long long ll;

using namespace std;

const int INF = 2e5 + 7;

vector<vector<int> > arr(2e5);
vector<vector<int> > rev_arr(2e5);
vector<int> way(2e5);
vector<int> dist(2e5, INF);

void bfs(int s) {
    queue<int> q;
    q.push(s);
    dist[s] = 0;
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (int i = 0; i < rev_arr[v].size(); i++) {
            int u = rev_arr[v][i];
            //cout << v << " " << u << endl;
            if (dist[u] == INF) {
                dist[u] = dist[v] + 1;
                q.push(u);
            }
        }
    }
}

main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    //freopen("file.in", "r", stdin);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        arr[u].push_back(v);
        rev_arr[v].push_back(u);
    }
    int k;
    cin >> k;
    for (int i = 0; i < k; i++) {
        cin >> way[i];
        way[i]--;
    }
    bfs(way[k - 1]);
    //return 0;
    int best_ans = 0, worst_ans = 0;\
    for (int i = 0; i < k - 1; i++) {
        int cur = way[i];
        int next = way[i + 1];
        if (dist[next] + 1 == dist[cur]) {
            bool fl = 0;
            for (int i = 0; i < arr[cur].size(); i++) {
                int u = arr[cur][i];
                if (u != next && dist[u] == dist[next]) {
                    fl = 1;
                    break;
                }
            }
            //cout << cur << " " << fl << endl;
            if (fl)
                worst_ans++;
        }
        else {
            best_ans++;
            worst_ans++;
        }
    }
    cout << best_ans << " " << worst_ans;
}
