#include <bits/stdc++.h>

#define fi first
#define se second

typedef long long ll;

const long long INF = 1e18;

using namespace std;

int upper_bound(vector<pair<int, int> >& crr, int need) {
    int l = -1;
    int r = crr.size() - 1;
    while (r - l > 1) {
        int m = (l + r) / 2;
        if (crr[m].first >= need)
            r = m;
        else
            l = m;
    }
    return r;
}

main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    //freopen("file.in", "r", stdin);
    int n, m, p;
    cin >> n >> m >> p;
    vector<pair<int, int> > arr;
    for (int i = 0; i < n; i++) {
        int val1, val2;
        cin >> val1 >> val2;
        arr.push_back({val1, val2});
    }
    sort(arr.begin(), arr.end());
    vector<int> get_min1(n);
    for (int i = n - 1; i >= 0; i--) {
        if (i == n - 1)
            get_min1[i] = arr[i].second;
        else
            get_min1[i] = min(get_min1[i + 1], arr[i].second);
    }
    vector<pair<int, int> > brr;
    for (int i = 0; i < m; i++) {
        int val1, val2;
        cin >> val1 >> val2;
        brr.push_back({val1, val2});
    }
    sort(brr.begin(), brr.end());
    vector<int> get_min2(m);
    for (int i = m - 1; i >= 0; i--) {
        if (i == m - 1)
            get_min2[i] = brr[i].second;
        else
            get_min2[i] = min(get_min2[i + 1], brr[i].second);
    }
    vector<pair<pair<int, int>, int> > a1, a2;
    for (int i = 0; i < p; i++) {
        int x, y, z;
        cin >> x >> y >> z;
        a1.push_back({{x, y}, z});
        a2.push_back({{y, x}, z});
    }
    long long ans = -INF;
    long long cur_cost = 0;
    int max_d = 0;
    sort(a1.begin(), a1.end());
    for (int i = 0; i < p; i++) {
        cur_cost += a1[i].second;
        max_d = max(max_d, a1[i].first.second);
        int cur = a1[i].first.first;
        int ind1 = upper_bound(arr, cur + 1);
        int val1 = get_min1[ind1];
        int ind2 = upper_bound(brr, max_d + 1);
        int val2 = get_min2[ind2];
        //cout << cur_cost << " " << max_d << " " << val1 << " " << val2 << endl;
        //cout << -val1 - val2 + cur_cost << endl;
        ans = max(ans, -val1 - val2 + cur_cost);
    }
    sort(a2.begin(), a2.end());
    cur_cost = 0;
    for (int i = 0; i < p; i++) {
        cur_cost += a2[i].second;
        max_d = max(max_d, a2[i].first.second);
        int cur = a2[i].first.first;
        int ind1 = upper_bound(brr, cur + 1);
        int val1 = get_min2[ind1];
        int ind2 = upper_bound(arr, max_d + 1);
        int val2 = get_min1[ind2];
        ans = max(ans, -val1 - val2 + cur_cost);
    }
    cout << ans;
    return 0;
}
