#include <bits/stdc++.h>

#define ll long long
#define int ll
#define pb push_back
#define pii pair<int, int>
#define all(a) (a).begin(), (a).end()
#define files(in, out) freopen(in, "r", stdin); freopen(out, "w", stdout)
#define rep(i, n) for (int i = 0; i < (n); ++i)
#define ss second

using namespace std;

const int max_n = 1e6 + 5;
const int mod = 1e9 + 7;
vector< vector<int> > g, g_rev;
vector<bool> used;

void solve(){
    int n;
    cin >> n;
    int m;
    cin >> m;
    g.resize(n);
    g_rev.resize(n);
    rep(i, m){
        int v, to;
        cin >> v >> to;
        v--;
        to--;
        g[to].pb(v);
        g_rev[v].pb(to);
    }
    int k;
    cin >> k;
    vector<int> p;
    rep(i, k){
        int el;
        cin >> el;
        el--;
        p.pb(el);
    }
    int s = p[0];
    int t = p.back();
    queue<int> q;
    vector<int> d(n, 0);
    used.resize(n, 0);
    used[t] = 1;
    q.push(t);
    while (!q.empty()){
        int v = q.front();
        q.pop();
        rep(i, g[v].size()){
            int to = g[v][i];
            if (used[to]) continue;
            d[to] = d[v] + 1;
            q.push(to);
            used[to] = 1;
        }
    }
    int mn = 0, mx = 0;
    rep(i, k - 1){
        if (d[p[i + 1]] + 1 != d[p[i]]){
            mn++;
            mx++;
            continue;
        }
        int v = p[i];
        rep(j, g_rev[v].size()){
            int to = g_rev[v][j];
            if (to == p[i + 1]) continue;
            if (d[p[i]] == d[to] + 1){
                mx++;
                //cout << v << ' ' << to << endl;
                break;
            }
        }
    }
    cout << mn << ' ' << mx;
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //files("input.txt", "output.txt");
    int t = 1;
    //cin >> t;
    while (t--) solve();
    return 0;
}
