#include <bits/stdc++.h>

#define ll long long
#define int ll
#define pb push_back
#define pii pair<int, int>
#define all(a) (a).begin(), (a).end()
#define files(in, out) freopen(in, "r", stdin); freopen(out, "w", stdout)
#define rep(i, n) for (int i = 0; i < (n); ++i)
#define ss second
#define ff first

using namespace std;

const int max_n = 1e6 + 5;
const int mod = 1e9 + 7;
vector< vector<int> > g, g_rev;
vector<bool> used;

vector<int> t;

void update(int pos, int val){
    for(int i = pos; i < max_n; i = (i | (i + 1))) t[i] += val;
}

int sum(int pos){
    int res = 0;
    for (int i = pos; i >= 0; i = (i & (i + 1)) - 1) res += t[i];
    return res;
}

int sum(int l, int r){
    if (l == 0) return sum(r);
    return sum(r) - sum(l);
}

struct Event{
    int x, y, z;

    Event(){}

    Event(int x, int y, int z) : x(x), y(y), z(z){}
};

bool operator < (const Event &e1, const Event &e2){
    if (e1.x == e2.x) return e1.y < e2.y;
    return e1.x < e2.x;
}

void solve(){
    int n, m, p;
    cin >> n >> m >> p;
    vector<pii> a(n), b(m);
    vector<int> pa(n), pb(m);
    rep(i, n){
        cin >> a[i].ff >> a[i].ss;
    }
    rep(i, m){
        cin >> b[i].ff >> b[i].ss;
    }
    vector<Event> events;
    rep(i, p){
        int x, y, z;
        cin >> x >> y >> z;
        events.pb(Event(x, y, z));
    }
    sort(all(events));
    sort(all(a));
    sort(all(b));
    rep(i, n) pa[i] = a[i].ff;
    rep(i, m) pb[i] = b[i].ff;
    vector<int> pref_a(m), pref_b(m);
    for (int i = n - 1; i >= 0; --i){
        if (i == n - 1) pref_a[i] = a[i].ss;
        else pref_a[i] = min(pref_a[i - 1], a[i].ss);
    }
    for (int i = m - 1; i >= 0; --i){
        if (i == m - 1) pref_b[i] = b[i].ss;
        else pref_b[i] = min(pref_b[i - 1], b[i].ss);
    }
    t.resize(max_n);
    int ans = -1e9;
    rep(k, events.size()){
        Event event = events[k];
        int x = event.x;
        int y = event.y;
        int z = event.z;
        int res = 0;
        res += sum(y) + z;
        //cout << res << ' ';
        int i = upper_bound(all(pa), x) - pa.begin();
        if (i >= n) continue;
        int j = upper_bound(all(pb), y) - pb.begin();
        if (j >= m) continue;
        res -= pref_a[i] + pref_b[j];
        //cout << i + 1 << ' ' << j + 1 << ' ' << res << endl;
        ans = max(ans, res);
        update(y, z);
    }
    cout << ans;
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //files("input.txt", "output.txt");
    int t = 1;
    //cin >> t;
    while (t--) solve();
    return 0;
}
