#include <bits/stdc++.h>

using namespace std;

const int inf = 1e9;

int main()
{
    //freopen("input.txt", "r", stdin);
    int n, m;
    cin >> n >> m;
    vector<vector<int>> gr(n + 1);
    for (int i = 0; i < m; ++i) {
        int x, y;
        cin >> x >> y;
        gr[y].push_back(x);
    }
    int k;
    cin >> k;
    vector<int> a(k);
    for (int i = 0; i < k; ++i) {
        cin >> a[i];
    }
    queue<int> q;
    vector<pair<int, int>> dist(n + 1, {inf, inf});
    dist[a.back()] = {0, 0};
    q.push(a.back());
    while (!q.empty()) {
        int now = q.front();
        q.pop();
        for (auto next : gr[now]) {
            if (dist[next].first == dist[now].first + 1) {
                dist[next].second++;
            } else if (dist[next].first > dist[now].first + 1) {
                dist[next] = {dist[now].first + 1, 1};
                q.push(next);
            }
        }
    }
    int l = 0, r = 0;
    for (int i = k - 2; i > 0; i--) {
        if (dist[a[i]].first == dist[a[i - 1]].first - 1) {
            if (dist[a[i - 1]].second > 1) {
                r++;
            }

        } else {
            l++;
            r++;
        }
    }
    cout << l << " " << r;
    return 0;
}
