#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <math.h>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>
using namespace std;

#define int long long

signed main() {
	ios_base::sync_with_stdio();
	cin.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int n, m;
	cin >> n >> m;
	vector <vector <int>> g(n), gr(n);
	for (int i = 0; i < m; ++i) {
		int a, b;
		cin >> a >> b;
		g[a - 1].push_back(b - 1);
		gr[b - 1].push_back(a - 1);
	}
	int k;
	cin >> k;
	vector <int> p(k);
	for (int i = 0; i < k; ++i) {
		cin >> p[i];
		p[i]--;
	}
	queue <int> q;
	q.push(p[0]);
	vector <int> d(n, -1);
	d[p[0]] = 0;


	while (q.size()) {
		int v = q.front();
		q.pop();
		for (int i = 0; i < g[v].size(); ++i) {
			int u = g[v][i];
			if (d[u] == -1) {
				d[u] = d[v] + 1;
				q.push(u);
			}
		}
	}
	int mn = 0;
	for (int i = k - 2; i >= 0; --i) {
		if (d[p[i]] + 1 != d[p[i + 1]]) {
			mn++;
		}
	}
	cout << mn;
	
	q.push(p.back());
	fill(d.begin(), d.end(), -1);
	d[p.back()] = 0;
	while (q.size()) {
		int v = q.front();
		q.pop();
		for (int i = 0; i < gr[v].size(); ++i) {
			int u = gr[v][i];
			if (d[u] == -1) {
				d[u] = d[v] + 1;
				q.push(u);
			}
		}
	}

	int mx = 0;
	for (int i = 0; i < k - 1; ++i) {
		for (int l = 0; l < g[p[i]].size(); ++l) {
			int j = g[p[i]][l];
			if (d[p[i]] - 1 == d[j] && j != p[i + 1]) {
				mx++;
				break;
			}
		}
	}
	cout << ' ' << mx;
}