#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef pair <ll, ll> pll;
//#define endl '\n';

const ll INF = INT_MAX;
const ll N = 2e5 + 8;

ll n, m, k;
vector <vector <ll>> g(N);
vector <vector <ll>> g1(N);
vector <ll> p(N);
vector <bool> was(N, false);
vector <ll> dist(N, INF);

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    cin >> n >> m;
    for (ll i = 0; i < m; ++i) {
        ll v, u;
        cin >> v >> u;
        --v, --u;
        g[v].push_back(u);
        g1[u].push_back(v);
    }
    cin >> k;
    for (ll i = 0; i < k; ++i) {
        cin >> p[i];
        --p[i];
    }
    queue <ll> q;
    ll s = p[k - 1];
    dist[s] = 0;
    q.push(s);
    while (!q.empty()) {
        ll v = q.front();
        q.pop();
        if (was[v]) {
            continue;
        }
        was[v] = true;
        for (ll u : g1[v]) {
            dist[u] = min(dist[u], dist[v] + 1);
            q.push(u);
        }
    }
    /*
    for (ll i = 0; i < n; ++i) {
        cout << dist[i] << ' ';
    }
    cout << endl;
    */
    ll mn = 0, mx = 0;
    for (ll i = 0; i < k - 1; ++i) {
        bool addmn = false, addmx = false;
        ll v = p[i];
        ll nxt = p[i + 1];
        ll now = 0;
        for (ll j = 0; j < g[v].size(); ++j) {
            if (g[v][j] == nxt) {
                now = g[v][j];
                break;
            }
        }
        ///cout << v << ' ' << nxt << ' ' << now << endl;
        for (ll j = 0; j < g[v].size(); ++j) {
            ll to = g[v][j];
            if (to == now) {
                continue;
            }
            ///cout << to << ' ' << now << ' ' << dist[to] << ' ' << dist[now] << endl;
            if (dist[to] < dist[now]) {
                addmn = true;
            }
            if (dist[to] <= dist[now]) {
                addmx = true;
            }
        }
        ///cout << addmn << ' ' << addmx << endl;
        mn += addmn;
        mx += addmx;
    }
    cout << mn << ' ' << mx << endl;
    return 0;
}

/**


**/

