#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair <ll, ll> pll;
typedef pair <int, int> pii;

#define pb push_back
#define eb emplace_back
#define print(a) { for (auto xxxxxx : (a)) cout << xxxxxx << ' '; cout << '\n'; }
#define fi first
#define se second
#define all(x) (x).begin() , (x).end()
#define mp make_pair

const ll inf = 2e18 , mod = 1e9 + 7;
const int intf = 2e9 , maxn = 2e5;

int n , m , k;
vector < vector <int> > g , gr , lst;
vector <int> p , cnt , d;

void bfs(){
    int st = p[k - 1];
    d[st] = 0;

    vector <bool> was(n , false);
    vector <int> lt = {st};
    was[st] = true;

    for (int i = 0; i < lt.size(); i ++){
        int u = lt[i];
        for (auto to : gr[u]){
            if (was[to]) continue;
            was[to] = true;
            d[to] = d[u] + 1;
            lt.pb(to);
        }
    }

    for (int i = 0; i < n; i ++){
        lst[d[i]].pb(i);
    }
}

void solve(){
    cin >> n >> m;
    g.resize(n); gr.resize(n); lst.resize(n + 2); cnt.resize(n , 0); d.resize(n , n + 1);
    for (int i = 0; i < m; i ++){
        int u , v; cin >> u >> v; u-- , v--;
        g[u].pb(v);
        gr[v].pb(u);
    }
    cin >> k;
    p.resize(k);
    for (int i = 0; i < k; i ++) {
        cin >> p[i];
        p[i]--;
    }

    bfs();
    cnt[p[k - 1]] = 1;
    for (int i = 0; i < lst.size(); i ++){
        for (auto x : lst[i]){
            for (auto to : g[x]){
                if (d[to] + 1 == d[x]){
                    cnt[x] += cnt[to];
                }
            }
        }
    }

    int ansmin = 0 , ansmax = 0;
    for (int i = 0; i + 1 < k; i ++){
        if (d[p[i]] - 1 != d[p[i + 1]]){
            ansmin++ , ansmax++;
        } else {
            ansmax += (cnt[p[i]] > 1 && cnt[p[i]] != cnt[p[i + 1]]);
        }
    }
    //print(d);
    cout << ansmin << ' ' << ansmax << '\n';
}


int main(){
	ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0); cout.precision(20);

	int t = 1;
	//cin >> t;
	while(t-->0){
        solve();
	}

	return 0;
}
/*


*/
