#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair <ll, ll> pll;
typedef pair <int, int> pii;

#define pb push_back
#define eb emplace_back
#define print(a) { for (auto xxxxxx : (a)) cout << xxxxxx << ' '; cout << '\n'; }
#define fi first
#define se second
#define all(x) (x).begin() , (x).end()
#define mp make_pair

const ll inf = 2e18 , mod = 1e9 + 7;
const int intf = 2e9 , maxn = 2e5 + 2;

const ll X = 533 , MOD = 1e9 + 9;

int n;
string s;
vector <int> id;
vector <ll> h , x;

ll get_hash(int l , int r){
    if (r < l) return 0;
    ll ans = h[r];
    if (l > 0){
        l--;
        ans -= h[l]*x[r - l] % MOD;
        ans %= MOD;
        while(ans < 0) ans += MOD;
    }
    return ans;
}

ll calc(int l , int r){
    int L = lower_bound(all(id) , l) - id.begin();
    int R = upper_bound(all(id) , r) - id.begin() - 1;

    ll ans = get_hash(L , R);


    if ((id[L] - l) % 2 == 1){
        ans += ('1')*x[R - L + 1] % MOD;
    }
    if ((R - id[r]) % 2 == 1){
        ans = (ans*X + '1') % MOD;
    }
    return ans;
}

void solve(){
    cin >> n;
    s = "";
    for (int i = 0; i < n; i ++){
        char c;
        cin >> c;
        if (c == '0'){
            id.pb(i);
            s += c;
        } else {
            if (s.empty() || s.back() == '0'){
                s += c;
                id.pb(i);
            } else {
                id.pop_back();
                s.pop_back();
            }
        }
    }

    n = s.size();
    h.resize(n);
    x.resize(n + 4);
    x[0] = 1;
    for (int i = 1; i < n + 4; i ++){
        x[i] = x[i - 1]*X % MOD;
    }
    h[0] = s[0];
    for (int i = 1; i < n; i ++){
        h[i] = (h[i - 1]*X + s[i]) % MOD;
    }



    int q; cin >> q;
    while(q-->0){
        int l1 , l2 , len;
        cin >> l1 >> l2 >> len;
        int r1 , r2;
        l1-- , l2--;
        r1 = l1 + len - 1 , r2 = l2 + len - 1;

        if (calc(l1 , r1) != calc(l2 , r2)){
            cout << "No\n";
        } else {
            cout << "Yes\n";
        }
    }
}
/*
5
11011
1
1 4 2

5
11011
3
1 3 3
1 4 2
1 2 3

*/


int main(){
	ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0); cout.precision(20);

	int t = 1;
	//cin >> t;
	while(t-->0){
        solve();
	}

	return 0;
}
/*


*/
