#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <set>
#include <queue>
#include <stack>
#include <algorithm>
#include <map>
#include <cmath>
#include <math.h>

using namespace std;

void files(){
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
}

#define all(a) a.begin(), a.end()
#define ll long long
#define rt return
#define mp make_pair
#define pii pair<int, int>
#define pll pair<ll, ll>

const int MAX_SIZE = 1e6, INF = 2e9;
const double eps = 1e-6;
const long long SuperINF = 1e18, MOD = 1e9 + 7;

/*
const int MAX_BASE = 1e6;
ll BASES[MAX_BASE], BASE =  97;
void precalc(){
	BASES[0] = 1;
	for(int i = 1; i < MAX_BASE; i++){
		BASES[i] = (BASES[i - 1] * BASE) % MOD;
	}
}
struct MyHash{
	vector<ll> pref;
	string str;

	MyHash(string s){
		str = s;
		this->precalc();
	}

	void precalc(){
		pref.push_back(0);
		for(int i = 0; i < str.size(); i++){
			pref.push_back( ((pref.back()) % MOD + (str[i] - '0' + 1)) % MOD);
			pref[pref.size() - 1] *= BASE;
			pref[pref.size() - 1] %= MOD;
		}
	}
	// section
	long long get(ll l, ll r){
		r++;
		l++;
		ll h = ((pref[r]- ((pref[l - 1] * BASES[r - l + 1]) % MOD)) % MOD + MOD)% MOD;
		return h;
	}

};
*/
/*
vector<int> z_func(string &s){
	int sz = s.size();
	vector<int> z(sz);
	z[0] = sz;
	int l = 0, r = 0;
	for(int i = 1; i < sz; i++){
		if(i <= r){
			z[i] = min(z[i - l], r - i + 1);
		}
		
		while(i + z[i] < sz && s[z[i]] == s[i + z[i]]){
			z[i]++;
		}
		if(i + z[i] > r){
			l = i;
			r = i + z[i] - 1;
		}
	}

	return z;
}
*/




int main(){
	std::ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	//files();
	
	ll n;
	cin >> n;
	vector<ll> arr;
	vector<ll> ba;
	for(int i = 0; i <n; i++){
		ll c;
		cin >> c;
		arr.push_back(c);
		ba.push_back(c - i - 1);
	}

	map<ll, ll> anses;
	for(int i = 0; i < n; i++){
		ll bi = ba[i];
		if(bi + i + 1 > 0)
			anses[bi] += bi + i + 1;
	}
	ll ans = 0;
	for(auto p = anses.begin(); p != anses.end(); p++)
		ans = max(ans, (*p).second);
	cout << ans;

}