#include <algorithm>
#include <iostream>
#include <vector>
#include <cmath>
#include <ctime>
#include <queue>
#include <set>
#include <map>
using namespace std;

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    string s;
    cin >> s;
    vector<int> p1(n+1), p0(n+1), p11(n+1), p12(n+1), jij(n+1);
    p0[0] = 0;
    p1[0] = 0;
    p11[0] = 0;
    p12[0] = 0;
    jij[0] = 0;
    const int k = 3;
    vector<unsigned long long> hs(n+1), pow_k(n+1);
    pow_k[0] = 1;
    for(int i = 0; i<n; i++)
        pow_k[i+1] = pow_k[i]*k;
    hs[0] = 0;
    for(int i = 0; i<n; i++){
        hs[i+1] = hs[i]*k+(s[i]-'0'+1);
        p0[i+1] = p0[i]+(s[i]=='0');
        p1[i+1] = p1[i]+(s[i]=='1');
        p11[i+1] = p11[i];
        p12[i+1] = p12[i];
        jij[i+1] = jij[i];
        if(s[i]=='1'){
            if(i&1)
                p11[i+1]++;
            else
                p12[i+1]++;
        }
        if(i&&s[i]=='1'&&s[i-1]=='1')
            jij[i+1]++;
    }
    int q;
    cin >> q;
    for(int i = 0; i<q; i++){
        int l1, l2, ln;
        cin >> l1 >> l2 >> ln;
        l1--;
        l2--;
        long long hsh = hs[l2+ln]-hs[l2]*pow_k[ln];
        long long hsh1 = hs[l1+ln]-hs[l1]*pow_k[ln];
        if(hsh==hsh1){
            cout << "Yes\n";
            continue;
        }
        if(p0[l1+ln]-p0[l1]!=p0[l2+ln]-p0[l2]||p1[l1+ln]-p1[l1]!=p1[l2+ln]-p1[l2]){
            cout << "No\n";
            continue;
        }
        int a1 = p11[l1+ln]-p11[l1], a2 = p12[l1+ln]-p12[l1];
        int b1 = p11[l2+ln]-p11[l2], b2 = p12[l2+ln]-p12[l2];
        if((l1&1)!=(l2&1))
            swap(b1, b2);
        if(b1!=a1||a2!=b2||jij[l1+ln]==jij[l1+1]||jij[l2+ln]==jij[l2+1]){
            cout << "No\n";
            continue;
        }
        cout << "Yes\n";
    }

    return 0;
}
