//#pragma GCC optimize("O3")
//#pragma GCC optimize("unroll-loops")

#include<bits/stdc++.h>

#define LL long long
#define el '\n'
#define pb push_back
#define ff first
#define ss second
#define _sz(x) (LL)x.size()
#define _all(x) x.begin(),x.end()

using namespace std;
const LL N = 2e5+10 , INF = 1e18, mod = 1e9+7;
LL n, m;
vector<LL> g[2][N], dist[2];
LL s[N];

void bfs(LL s, LL k, LL t)
{
    dist[k].resize(n+5, INF);
    queue<LL> q;
    q.push(s);
    dist[k][s] = 0;
    while(!q.empty())
    {
        LL v = q.front();
        q.pop();
        for(auto u : g[t][v])
        {
            if(dist[k][u] == INF)
            {
                dist[k][u] = dist[k][v]+1;
                q.push(u);
            }
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin >> n >> m;
    for(LL i = 0; i < m; i++)
    {
        LL u, v;
        cin >> u >> v;
        g[0][u].pb(v);
        g[1][v].pb(u);
    }
    map<LL, LL> mpp;
    LL k, in;
    vector<LL> v;
    cin >> k >> in;
    v.pb(in);
    for(LL i = 1; i < k; i++)
    {
        cin >> in;
        s[v.back()] = in;
        v.pb(in);
    }
    bfs(v[0], 0, 0);
    bfs(v[k-1], 1, 1);
    LL mn = 0;
    if(dist[0][v[k-1]] != k-1)
    {
        LL pos = 1;
        for(LL i = k-2; i >= 0; i--)
        {
            //cout << v[i] << " " << dist[1][v[i]] << " " << pos << el;
            if(dist[1][v[i]] == pos)
                pos++;
            else
                mn++, pos = dist[1][v[i]]+1;
        }
    }
    cout << mn << " ";
    LL mx = 0;
    for(LL i = 0; i < k-1; i++)
    {
        if(dist[1][v[i]] != k-1-i)
        {
            mx++;
            continue;
        }
        LL cnt = 0;
        for(auto u : g[0][v[i]])
        {
            if(dist[1][u] == k-2-i)
                cnt++;
        }
        if(cnt > 1)
            mx++;
    }
    cout << max(mx,mn) << el;
    return 0;
}
