#include <iostream>
#include <vector>
#include <cmath>
#include <set>
#include <map>
#include <queue>
#include <bitset>
#include <algorithm>

using namespace std;

#define X first
#define Y second
#define vi vector<int>
#define vvi vector<vi>
#define vb vector<char>
#define pii pair<int, int>
#define vpii vector<pii>
#define len(V) (int)V.size()
#define all(V) V.begin(), V.end()
#define pb push_back
#define mp make_pair

//#define int ll
#define ever ;;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

const int inf = 1e9 + 7, mod = 1e9 + 7;
const ll INF = 1e18 +7;

int n;
string s;
vb U;

int str(int v, int f) {
    if (f == 1) {
        for (int i = v; i < n; ++i) {
            if (U[i])
                continue;
            return s[i] - 'a';
        }
        return -1;
    }
    for (int i = v; i > -1; --i) {
        if (U[i])
            continue;
        return s[i] - 'a';
    }
    return -1;
}

void run() {
    cin >> n;
    U.resize(n);
    cin >> s;
    if (n == 1) {
        cout << 0;
        return;
    }

    int ans = 0, l = 0, r = n;
    for (int i = 0; i + 1 < n; ++i) {
        if (s[i] - s[i + 1] != 1)
            break;
        ++ans;
        ++l;
        U[i] = true;
    }
    for (int i = n - 1; i > 0; --i) {
        if (s[i] - s[i - 1] != 1)
            break;
        ++ans;
        --r;
        U[i] = true;
    }

    vpii V;
    int c;
    for (int i = l; i < r; ++i)
        V.pb(mp(s[i] - 'a', i));
    sort(all(V));
    for (int z = 0; z < len(V); ++z) {
        for (int i = len(V) - 1; i > -1; --i) {
            if (U[V[i].Y])
                continue;
            if (V[i].Y > l) {
                c = str(V[i].Y - 1, -1);
                if (c > -1 && V[i].X - c == 1) {
                    ++ans;
                    U[V[i].Y] = true;
                    continue;
                }
            }
            if (V[i].Y < r - 1) {
                c = str(V[i].Y + 1, 1);
                if (c > -1 && V[i].X - c == 1) {
                    ++ans;
                    U[V[i].Y] = true;
                    continue;
                }
            }
        }
    }

    cout << ans;
}

int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);

    int t = 1;
    //cin >> t;
    for (int i = 0; i < t; ++i) {
        run();
        cout << '\n';
    }
    return 0;
}