#include <iostream>
#include <vector>
#include <cmath>
#include <set>
#include <map>
#include <queue>
#include <bitset>
#include <algorithm>

using namespace std;

#define X first
#define Y second
#define vi vector<int>
#define vvi vector<vi>
#define vb vector<char>
#define pii pair<int, int>
#define vpii vector<pii>
#define len(V) (int)V.size()
#define all(V) V.begin(), V.end()
#define pb push_back
#define mp make_pair

#define int ll
#define ever ;;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

const int inf = 1e9 + 7, mod = 1e9 + 7;
const ll INF = 1e18 +7;

struct monster {
    int x, y, z, ind;
};

bool comp(monster &a, monster &b) {
    if (a.x == b.x) {
        if (a.y == b.y) {
            if (a.z == b.z)
                return a.ind < b.ind;
            return a.z > b.z;
        }
        return a.y < b.y;
    }
    return a.x < b.x;
}

bool comp2 (pii &a, pii &b) {
    if (a.X == b.X)
        a.Y < b.Y;
    a.X > b.X;
}

void run() {
    int n, m, p;
    cin >> n >> m >> p;
    vpii A0(n), B0(m), A, B;
    vector<monster> V(p);
    for (auto &it : A0)
        cin >> it.X >> it.Y;
    for (auto &it : B0)
        cin >> it.X >> it.Y;
    for (int i = 0; i < p; ++i) {
        cin >> V[i].x >> V[i].y >> V[i].z;
        V[i].ind = i;
    }
    sort(all(V), comp);
    sort(all(A0), comp2);
    sort(all(B0), comp2);

    for (int i = 0; i < n; ++i) {
        int cc = A0[i].Y, j = i + 1;
        for (; j < n; ++j) {
            if (A0[j].X != A0[i].X)
                break;
            cc = min(cc, A0[i].Y);
        }
        if (!len(A) || cc < A.back().Y)
            A.pb(mp(A0[i].X, cc));
        if (j == n)
            break;
        i = j - 1;
    }
    reverse(all(A));
    for (int i = 0; i < m; ++i) {
        int cc = B0[i].Y, j = i + 1;
        for (; j < m; ++j) {
            if (B0[j].X != B0[i].X)
                break;
            cc = min(cc, B0[i].Y);
        }
        if (!len(B) || cc < B.back().Y)
            B.pb(mp(B0[i].X, cc));
        if (j == n)
            break;
        i = j - 1;
    }
    reverse(all(B));
    for (int i = 0; i < n; ++i) {
        int cc = A0[i].Y, j = i + 1;
        for (; j < n; ++j) {
            if (A0[j].X != A0[i].X)
                break;
            cc = min(cc, A0[i].Y);
        }
        if (!len(A) || cc < A.back().Y)
            A.pb(mp(A0[i].X, cc));
        if (j == n)
            break;
        i = j - 1;
    }
    reverse(all(A));

    int ans = -INF, res = 0, a = 0, b = 0;
    for (int i = 0; i < p; ++i) {
        while (a < n && A[a].X <= V[i].x)
            ++a;
        if (a == n)
            break;
        int bS = b;
        while (b < m && B[b].X <= V[i].y)
            ++b;
        if (b == m) {
            b = bS;
            continue;
        }
        res += V[i].z;
        if (res - A[a].Y - B[b].Y > ans) {
            ans = res - A[a].Y - B[b].Y;
            continue;
        }
        b = bS;
    }
    cout << ans;
}

signed main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);

    int t = 1;
    //cin >> t;
    for (int i = 0; i < t; ++i) {
        run();
        cout << '\n';
    }
    return 0;
}