#include <iostream>
#include <time.h>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <vector>
#include <string>
#include <algorithm>
#include <ostream>
#include <istream>
#include <iomanip>
#include <random>
#include <stack>
#include <queue>
#include <deque>

using namespace std;

#define int long long
#define ld long double
#define pb push_back
#define all(a) (a).begin(), (a).end()
#define pii pair<int, int>

ostream& operator<<(ostream& a, vector<int>& b) {
    for (auto k : b) cout << k << " ";
    return a;
}

#ifdef LOCAL
    #define dbg(x) cout << #x << " : " << x << "\n";
#else
    #define dbg(x)
#endif

const int INF = 1e9;


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    vector<vector<int>> g(n), gr(n);
    int u, v;
    for (int i =0 ; i < m; i++) {
        cin >> u >> v;
        u--, v--;
        g[v].pb(u);
        gr[u].pb(v);
    }
    int k;
    cin >> k;
    vector<int> p(k);
    for (int i = 0; i < k; i++) {
        cin >> p[i];
        p[i]--;
    }
    int t = p[k - 1];
    int s = p[0];

    set<pii> q;
    vector<int> d(n, INF);
    d[t] = 0;
    q.insert({0, t});
    while (!q.empty()) {
        v = (*q.begin()).second;
        q.erase(q.begin());
        for (auto u : g[v]) {
            if (d[u] > d[v] + 1) {
                d[u] = d[v] + 1;
                q.insert({d[u], u});
            }
        }
    }
    map<int, int> cnt[n + 1];
    for (int i = 0; i < n; i++) {
        for (auto u : gr[i]) {
            cnt[i][d[u]]++;
        }
    }
    int mn = 0, mx = 0;
    for (int i = 1; i < k; i++) {
        if (d[p[i]] == d[p[i - 1]] - 1) {
            if (cnt[p[i - 1]][d[p[i]]] > 1) mx++;
        } else {
            mn++;
            mx++;
        }
    }
    cout << mn << " " << mx;
}

/*

*/
