#include <bits/stdc++.h>

using namespace std;

#define int long long

struct line {
    int pr, h, s;
    bool iszl;
};

const int maxn = 2e5, mod = 1e9 + 7;
int st[maxn + 1];
string a;
line t[4 * maxn + 5];

line merge(line l1, line l2) {
    int l1s = l1.s;
    int l2s = l2.s;
    line ans;
    ans.s = l1s + l2s;
    if (!l1.iszl && l2.pr % 2) {
        ans.pr = l1.pr + l2.pr + 1;
        ans.h = (l1.h + st[max(0ll, l1s - l1.pr - 1)] * l2.h) % mod;
        ans.iszl = l2.iszl;
        if (ans.pr == l1s + l2s) ans.iszl = 0;
        else if (l2.pr == l2s) ans.iszl = 1;
    }
    else {
        ans.pr = l1.pr + l2.pr;
        if (l2s == l2.pr) ans.iszl = l1.iszl;
        else ans.iszl = l2.iszl;
        ans.h = (l1.h + l2.h * st[l1s - l1.pr]) % mod;
    }
    return ans;
}

void build(int v, int l, int r) {
    if (l == r - 1) {
        t[v].h = 0;
        t[v].pr = (a[l] - '0');
        t[v].iszl = (t[v].pr == 0);
        t[v].s = 1;
        return;
    }
    int m = (l + r) / 2;
    build(2 * v, l, m);
    build(2 * v + 1, m, r);
    t[v] = merge(t[2 * v], t[2 * v + 1]);
}

line get(int v, int l, int r, int tl, int tr) {
    //cout << l << ' ' << r << ' ' << tl << ' ' << tr << endl;
    if (l <= tl && tr <= r) return t[v];
    int tm = (tl + tr) / 2;
    if (tm >= r) return get(2 * v, l, r, tl, tm);
    if (tm <= l) return get(2 * v + 1, l, r, tm, tr);
    return merge(get(2 * v,l , r, tl, tm), get(2 * v + 1, l, r, tm, tr));
}

void solve() {
    int n;
    cin >> n;
    cin >> a;
    st[0] = 1;
    for (int i = 0; i < a.size(); ++i) st[i] = (st[i - 1] * 2) % mod;
    build(1, 0, a.size());
    int q;
    cin >> q;
    while (q) {
        --q;
        int l1, l2, len;
        cin >> l1 >> l2 >> len;
        --l1;
        --l2;
        line li1 = get(1, l1, l1 + len, 0, a.size()), li2 = get(1, l2, l2 + len, 0, a.size());
        if (li1.pr != li2.pr || li1.h != li2.h || li1.iszl != li2.iszl) cout << "No" << endl;
        else cout << "Yes\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    /*freopen("input.in", "r", stdin);
    freopen("output.out", "w", stdout);*/
    solve();
    return 0;
}
