#include<bits/stdc++.h>
using namespace std;

#define pb push_back
#define mp make_pair
#define fi first
#define se second
#define ent '\n'
#define v1 v*2+1
#define v2 v1+1
typedef long long ll;
typedef pair<ll,ll> pll;

const int N = 1e6;
const int oo = 2e9;

ll t[3*N], sa[N], sb[N];
pll a[N], b[N];
pair<ll, pll> x[N];
ll ans, sum;
int l, r, n, m, p, val;

void add(int v, int tl, int tr, int pos, int val) {
    if (tl == tr) {
        t[v] += val;
        return;
    }
    int tm = (tl + tr) / 2;
    if (pos <= tm) add(v1, tl, tm, pos, val);
    else add(v2, tm + 1, tr, pos, val);
    t[v] = t[v1] + t[v2];
}

ll get(int v, int tl, int tr, int l, int r) {
    if (l > r) return 0;
    if (tl == l && tr == r)
        return t[v];
    int tm = (tl + tr) / 2;
    return get(v1, tl, tm, l, min(tm, r)) +
            get(v2, tm + 1, tr, max(tm + 1, l), r);
}

int main() {
    ios::sync_with_stdio(false);
    //freopen("input.txt", "r", stdin);
    val = 1e6;
    cin >> n >> m >> p;
    for (int i = 0; i < n; ++i)
        cin >> a[i].fi >> a[i].se;
    for (int i = 0; i < m; ++i)
        cin >> b[i].fi >> b[i].se;
    sort(a, a + n);
    sort(b, b + m);
    for (int i = 0; i < p; ++i)
        cin >> x[i].fi >> x[i].se.fi >> x[i].se.se;
    sort(x, x + p);

    for (int i = n - 1; i >= 0; --i)
        sa[i] = min(a[i].se, (i < n - 1? sa[i+1] : oo));

    for (int i = m - 1; i >= 0; --i)
        sb[i] = min(b[i].se, (i < m - 1? sb[i+1] : oo));


    for (int i = 0; i < p; ++i) {
        add(0, 1, val, x[i].se.fi, x[i].se.se);
        sum = get(0, 1, val, 1, x[i].se.fi);
        l = 0;
        r = n - 1;
        while (l < r) {
            int mid = (l + r) / 2;
            if (a[mid].fi > x[i].fi) r = mid;
            else l = mid + 1;
        }
        sum -= sa[l];
        l = 0;
        r = m - 1;
        while (l < r) {
            int mid = (l + r) / 2;
            if (b[mid].fi > x[i].se.fi) r = mid;
            else l = mid + 1;
        }
        if (b[l].fi < x[i].se.fi || a[l].fi < x[i].fi)
            continue;
        sum -= sb[l];
        ans = max(ans, sum);
    }

    for (int i = 0; i < 3 * val; ++i)
        t[i] = 0;

    for (int i = 0; i < p; ++i)
        swap(x[i].fi, x[i].se.fi);

    for (int i = 0; i < p; ++i) {
        add(0, 1, val, x[i].se.fi, x[i].se.se);
        sum = get(0, 1, val, 1, x[i].se.fi);
        l = 0;
        r = n - 1;
        while (l < r) {
            int mid = (l + r) / 2;
            if (b[mid].fi > x[i].fi) r = mid;
            else l = mid + 1;
        }
        sum -= sb[l];
        l = 0;
        r = m - 1;
        while (l < r) {
            int mid = (l + r) / 2;
            if (a[mid].fi > x[i].se.fi) r = mid;
            else l = mid + 1;
        }
        if (a[l].fi < x[i].se.fi || b[l].fi < x[i].fi)
            continue;
        sum -= sa[l];
        ans = max(ans, sum);
    }

    cout << ans;
}
