//#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

#define all(a) a.begin(), a.end()
#define rall(a) a.end(), a.begin()

#define yes "YES"
#define no "NO"

#define INTMX (int)1e8
#define LLMX (ll)1e18

#define INF (ll)1e8
#define MOD 1000000000 + 7

#define pb push_back
#define eb emplace_back

using namespace std;

const int TREE_SIZE = 4 * 100000;

#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")


//                 ________
//    | |         /        \  | |
//    | |         |        |  | |
//    | |         |        |  | |
//    | |         |        |  | |
//    | |         |        |  | |
//    | |         |        |  | |
//    | |_______  |        |  | |_______
//    \_________| \________/  \_________|


void solve(){
    ll n;
    cin >> n;
    vector < ll > a(n), b(n);
    for(int i = 0; i < n; ++i)
        cin >> a[i];
    for(int i = 0; i < n; ++i)
        cin >> b[i];
    bool flag = true;
    for(int i = 0; i < n; ++i){
        if(a[i] != b[i]){
            flag = false;
        }
    }
    if(flag){
        cout << -1;
        return;
    }


    ll sm1 = 0;
    ll sm2 = 0;
    for(int i = 0; i < n; ++i){
        sm1 += a[i];
        sm2 += b[i];
    }

    if(sm1 > sm2){
        cout << 1;
        return;
    }

    ll ne = 0;
    for(int i = 0; i < n; ++i){
        if(a[i] == 1 and b[i] == 0)
            ne += 1;
    }
    ll r = sm2 - sm1 + 1;
    if(ne == 0)
        cout << 0;
    else{
        ll cnt = r / ne;
        ll ost = r % ne;
        cout << cnt + (ost > 1) + 1;
    }
    return;
}


int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll t = 1;
//    cin >> t;
    while(t--)
        solve();
    return 0;
}