#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define ll long long
#define ld long double
#define pii pair<int, int>
#define fs first
#define sc second
#define pb push_back
#define mp make_pair
#define fast_io ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define endl '\n'

typedef tree<int,null_type,less<int>,rb_tree_tag,tree_order_statistics_node_update> ordered_set;


const int N = 105;
int dp[N][N], can[N][N], n;
string s;

void init() {
    for (int i = 0; i < N; i++) {
        for (int j = 0; j < N; j++) {
            dp[i][j] = can[i][j] = -1;
        }
    }
}

int cn(int l, int r) {
    if (r < l)
        return 1;
    if (can[l][r] != -1)
        return can[l][r];

    can[l][r] = 0;

    for (int i = l; i < r; i++) {
        if (cn(l, i) == 1 && cn(i + 1, r) == 1)
            can[l][r] = 1;
    }

    for (int i = l; i <= r && can[l][r] == 0; i++) {
        for (int j = l - 1; j <= l - 1 && can[l][r] == 0; j++) {
            if (j < 0 || j >= n)
                continue;
            if (s[j] != s[i] - 1)
                continue;
            if (cn(j + 1, i - 1) == 0)
                continue;
            if (cn(i + 1, r) == 0)
                continue;
            can[l][r] = 1;
        }
    }

    for (int i = l; i <= r && can[l][r] == 0; i++) {
        for (int j = r + 1; j <= r + 1 && can[l][r] == 0; j++) {
            if (j < 0 || j >= n)
                continue;
            if (s[j] != s[i] - 1)
                continue;
            if (cn(i + 1, j - 1) == 0)
                continue;
            if (cn(l, i - 1) == 0)
                continue;
            can[l][r] = 1;
        }
    }

    return can[l][r];
}

int f(int l, int r) {
    if (r < l)
        return 0;
    if (dp[l][r] != -1)
        return dp[l][r];

    dp[l][r] = 0;
    if (cn(l, r) == 1)
        dp[l][r] = r - l + 1;
    for (int i = l; i < r; i++) {
        dp[l][r] = max(dp[l][r], f(l, i) + f(i + 1, r));
    }

    return dp[l][r];
}

signed main()
{
    fast_io;

    init();

    cin >> n >> s;

    cout << f(0, n - 1);

    return 0;
}
