#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define ll long long
#define ld long double
#define pii pair<int, int>
#define fs first
#define sc second
#define pb push_back
#define mp make_pair
#define fast_io ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define endl '\n'

typedef tree<int,null_type,less<int>,rb_tree_tag,tree_order_statistics_node_update> ordered_set;

const ll N = 300000 + 50, mod[2] = {1000000000 + 7, 1999999973}, P[2] = {31, 17};

ll n, q, h[N][2], p[N][2], val[N], pref[N], is[N], isPref[N];
string s;

void init() {
    for (int i = 0; i < n; i++) {
        val[i + 1] = s[i] - '0';
    }
    for (int i = 1; i <= n; i++) {
        pref[i] = pref[i - 1] + val[i];
    }
    for (int i = 1; i <= n; i++) {
        if (val[i] == 0 || val[i - 1] == 1 || val[i + 1] == 1)
            continue;
        is[i] = 1;
    }
    for (int i = 1; i <= n; i++) {
        isPref[i] = isPref[i - 1] + is[i];
    }

    for (int t = 0; t < 2; t++) {
        p[0][t] = 1;
        for (int i = 1; i < N; i++)
            p[i][t] = ((ll)p[i - 1][t] * (ll)P[t]) % mod[t];

        for (int i = 1; i <= n; i++) {
            h[i][t] = (h[i - 1][t] + (ll)(val[i] + 1) * (ll)p[i - 1][t]) % mod[t];
        }
    }
}

inline bool same(int l1, int r1, int l2, int r2) {
    if (l1 > l2) {
        swap(l1, l2);
        swap(r1, r2);
    }

    for (int t = 0; t < 2; t++) {
        if (((ll)h[r2][t] - (ll)h[l2 - 1][t] + (ll)mod[t]) % (ll)mod[t] != ((((ll)h[r1][t] - (ll)h[l1 - 1][t] + (ll)mod[t]) % (ll)mod[t]) * (ll)p[l2 - l1][t]) % (ll)mod[t])
            return false;
    }
    return true;
}

signed main()
{
    fast_io;

    cin >> n >> s;
    init();

    cin >> q;
    while(q--) {
        int l1, l2, len, r1, r2;
        cin >> l1 >> l2 >> len;
        r1 = l1 + len - 1;
        r2 = l2 + len - 1;

        if (pref[r1] - pref[l1 - 1] != pref[r2] - pref[l2 - 1]) {
            cout << "No" << endl;
            continue;
        }

        int sum1 = 0, sum2 = 0;
        sum1 = isPref[r1] - isPref[l1 - 1];
        sum2 = isPref[r2] - isPref[l2 - 1];

        if (val[l1] == 1 && val[l1 + 1] == 0 && is[l1] == 0)
            sum1++;
        if (val[r1] == 1 && val[r1 - 1] == 0 && is[r1] == 0 && len > 1)
            sum1++;

        if (val[l2] == 1 && val[l2 + 1] == 0 && is[l2] == 0)
            sum2++;
        if (val[r2] == 1 && val[r2 - 1] == 0 && is[r2] == 0 && len > 1)
            sum2++;

        if (sum1 == pref[r1] - pref[l1 - 1] || sum2 == pref[r2] - pref[l2 - 1]) {
            if (same(l1, r1, l2, r2))
                cout << "Yes" << endl;
            else
                cout << "No" << endl;
            continue;
        }

        cout << "Yes" << endl;
    }

    return 0;
}
