#include <bits/stdc++.h>
#define int long long 

#define ff first 
#define ss second

#define pb push_back 
#define eb emplace_back 

#define mp make_pair 

#define all(x) (x).begin(), (x).end()

#define pii pair<int, int>

#define debug(x) cout << #x << ": " << x << endl; 
#define TIME clock() / (ld)CLOCKS_PER_SEC

using namespace std; 
mt19937 rnd(time(0)); 
typedef long long ll;
typedef long double ld; 
const int maxn = 3e5 + 7, mod = 1e9 + 7, MAXN = 1e6 + 7;
const ll inf = 1e18; 
int n, m, k; 
vector<int> gr[maxn]; 
vector<int> rgr[maxn]; 
int dist[maxn]; 
vector<int> path; 

void bfs(int lst) {
    deque<int> q;
    q.pb(lst);
    for (int i = 0; i < n; ++i) dist[i] = inf; 
    dist[lst] = 0;
    while (q.size()) {
        int u = q.front();
        q.pop_front();
        for (auto v : rgr[u]) {
            if (dist[v] > dist[u] + 1) {
                q.pb(v);
                dist[v] = dist[u] + 1; 
            }
        }
    }    
}

void solve() {
    cin >> n >> m;          
    for (int i = 0; i < m; ++i) {
        int a, b; cin >> a >> b, --a, --b; 
        gr[a].pb(b);
        rgr[b].pb(a);
    }
    cin >> k;
    for (int i = 0; i < k; ++i) {
        int x; cin >> x, --x; 
        path.pb(x); 
    }
    bfs(path.back());
    int ans1 = 0, ans2 = 0;
    for (int i = 0; i < k - 1; ++i) {
        int u = path[i];
        int v = path[i + 1];
        vector<int> can; 
        for (auto v1 : gr[u]) {
            if (dist[v1] + 1 == dist[u]) {
                can.pb(v1);
            }            
        }        
        bool ok = false;
        for (auto v1 : can) {    
            if (v1 == v) ok = true; 
        }
        ans1 += !ok;
        ok = false; 
        for (auto v1 : can) {
            if (v1 != v) ok = true; 
        }
        ans2 += ok;
    } 
    cout << ans1 << " " << ans2;
}

signed main() {
#ifdef LOCAL
  freopen("TASK.in", "r", stdin);
  freopen("TASK.out", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t = 1;
    for (int i = 0; i < t; ++i) solve();
    return 0;     
}