#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define len(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define int long long
typedef long double lld;
typedef long long ll;

const int maxn = 1e6 + 228;

int bc[maxn], ac[maxn], pr[maxn];

const int sz = (1 << 20);

struct node {
    int val = 0, add = 0;
};

node tree[sz * 2];

void push(int v) {
    tree[v].val += tree[v].add;
    if (v >= sz) {
        tree[v].add = 0;
        return;
    }
    tree[v * 2].add += tree[v].add;
    tree[v * 2 + 1].add += tree[v].add;
    tree[v].add = 0;
    return;
}

void upd(int v, int tl, int tr, int l, int r, int add) {
    if (l > r)
        return;
    if (tl == l && tr == r) {
        tree[v].add += add;
        return;
    }
    int tm = (tl + tr) / 2;
    upd(v * 2, tl, tm, l, min(r, tm), add);
    upd(v * 2 + 1, tm + 1, tr, max(tm + 1, l), r, add);
    push(v * 2);
    push(v * 2 + 1);
    tree[v].val = max(tree[v*2].val, tree[v * 2 + 1].val);
}

int get(int v, int tl, int tr, int l, int r) {
    if (l > r)
        return -1e18;
    if (tl == l && tr == r) {
        push(v);
        return tree[v].val;
    }
    push(v);
    int tm = (tl + tr) / 2;
    return max(get(v * 2, tl, tm, l, min(r, tm)),  get(v * 2 + 1, tm + 1, tr, max(tm + 1, l), r));

}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    int n, m, p;
    cin >>  n >> m >> p;
    int mx1 = 1e18, mx2 = 1e18;
    fill(ac, ac + maxn, 1e18);
    fill(bc, bc + maxn, 1e18);
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        ac[x] = min(ac[x], y);
        mx1 = min(mx1, y);
    }
    for (int i = 0; i < m; i++) {
        int x, y;
        cin >> x >> y;
        bc[x] = min(bc[x], y);
        mx2 = min(mx2, y);
    }
    for (int i = maxn - 2; i >= 0; i--) {
        bc[i] = min(bc[i], bc[i + 1]);
        ac[i] = min(ac[i], ac[i + 1]);
    }
    vector <pair<int, pair<int, int>> > v;
    for (int i = 0; i < p; i++) {
        int x, y, z;
        cin >> x >> y >> z;
        v.pb({x, {y, z}});
    }
    sort(all(v));
    for (int i = 1; i < maxn; i++)
        upd(1, 1, sz, i, i, -bc[i + 1]);
        int ans = -mx1 - mx2; //check �� ���
    for (auto it : v) {
        int c = -ac[it.first + 1];
        upd(1, 1, sz, it.second.first, maxn - 2, it.second.second);
        //cout << c << endl;
        c += get(1, 1, sz, it.second.first, maxn - 2);
        //cout << it.first << " " << c << endl;
        ans = max(ans, c);
    }
    cout << ans;

}
