#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

/*
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("-O3")
#pragma target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
*/
#define pb push_back
#define all(x) (x).begin() , (x).end()
#define rall(x) (x).rbegin() , (x).rend()
#define fi first
#define se second
#define len(x) (int)(x).size()
#define fast_io ios_base::sync_with_stdio(0) , cin.tie(0) , cout.tie(0)

using namespace __gnu_pbds;
using namespace std;
typedef long long ll;
typedef tree<int,null_type,less<int>,rb_tree_tag,tree_order_statistics_node_update> ordered_set;
//mt19937 rng(NULL);
const int inf = 2e9;
struct triple{
    int x,  y ,  z;
};
bool cmp(const triple &a , const triple &b){
    return a.x < b.x;
}
const int maxn = (int)2e5 + 1000;
int f[maxn];
int A[4*maxn] , p[4*maxn];
void build(int v , int tl , int tr){
    if(tl == tr){
        A[v] = f[tl-1];
        return ;
    }
    int v1 = v << 1 , mid = (tl + tr) >> 1;
    build(v1 , tl , mid);
    build(v1|1 , mid + 1 ,tr);
    A[v] = max(A[v1|1] , A[v1]);
}
void push(int v){
    if(p[v]){
        int v1 = v << 1;
        p[v1] += p[v] , p[v1|1] += p[v];
        A[v1] += p[v] , A[v1|1] += p[v];
        p[v] = 0;
    }
}
void upd(int v, int tl,  int tr,  int l ,  int r , int x){
    if(tl == l && tr == r){
        p[v] += x;
        A[v] += x;
        return;
    }
    push(v);
    int v1 = v << 1 , mid = (tl + tr) >> 1;
    if(r > mid)upd(v1|1 , mid + 1 , tr , max(l , mid + 1) , r , x);
    if(l <= mid)upd(v1 , tl , mid , l , min(r , mid) , x);
    A[v] = max(A[v1] , A[v1|1]);
}
int get(int v , int tl , int tr , int l , int r){
    if(tl == l && tr == r){
        return A[v];
    }
    push(v);
    int v1 = v << 1 , mid = (tl + tr) >> 1;
    int ans = -inf;
    if(r > mid)ans = max(ans , get(v1|1 , mid + 1 , tr , max(l , mid + 1) , r));
    if(l <= mid)ans = max(ans , get(v1 , tl , mid , l , min(r , mid)));
    return ans;
}
int main()
{
    fast_io;
    int n , m , p;
    cin >> n >> m >> p;
    vector < pair < int , int > > a(n) , b(m);
    for(int i = 0; i < n; ++i){
        cin >> a[i].fi >> a[i].se;
    }
    for(int i = 0; i < m; ++i){
        cin >> b[i].fi >> b[i].se;
    }
    vector < triple > mon(p);
    for(int i = 0 ; i  < p ; ++i){
        cin >> mon[i].x >> mon[i].y >> mon[i].z;
    }
    sort(all(a));
    sort(all(mon) , cmp);
    sort(all(b));
    fill(f , f + maxn , -inf);
    for(int i = 0 ;  i < m; ++i)
        f[i] = -b[i].se;
    build(1 , 1,  maxn);
    int ans = -inf;
    int j = 0;



    for(int i = 0 ; i < n; ++i){
        while(j < p  && mon[j].x < a[i].fi){
            /// we need to add
            int ind = upper_bound(all(b) , make_pair(mon[j].y , inf)) - b.begin();
            upd(1 , 1,  maxn , ind + 1 , maxn , mon[j].z);
            ++j;
        }
        int mx = A[1];
        ans = max(ans , mx - a[i].se);
    }
    cout << ans;
    return 0;
}
