#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <string>

#define pr pair
#define pii pair<int, int>
#define mp make_pair
#define ft first
#define sd second
#define ll long long

using namespace std;

int main() {
	cin.tie(NULL);
	cout.tie(NULL);
	ios_base::sync_with_stdio(false);
	int n;
	cin >> n;
	string s;
	cin >> s;
	vector<vector<bool>> candelete(n + 1, vector<bool>(n + 1, false));
	for (int i = 0; i <= n; i++)
		candelete[i][i] = true;
	for (int len = 1; len <= n; len++)
		for (int l = 0; l + len <= n; l++) {
			int r = l + len;
			for (int m = l; m < r; m++)
				if (candelete[l][m] && candelete[m + 1][r])
					if (l > 0 && (s[m] - s[l - 1] == 1))
						candelete[l][r] = true;
					else if (r < n && (s[m] - s[r] == 1))
						candelete[l][r] = true;
		}
	vector<int> ans(n + 1);
	for (int i = 1; i <= n; i++) {
		ans[i] = ans[i - 1];
		for (int prev = 0; prev < i; prev++)
			if (candelete[prev][i])
				ans[i] = max(ans[i], ans[prev] + i - prev);
	}
	cout << ans[n];
	int zero = 0;
}