#define _CRT_SECURE_NO_WARNINGS
#define USE_MATH_DEFINES
#define REL
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <stack>
#include <queue>
#include <deque>
#include <memory>
#include <bitset>
#include <cmath>
#include <iomanip>
#include <string>
#include <cassert>
#include <complex>
#include <ctime>
#include <forward_list>
#include <list>
#include <hash_map>
#include <hash_set>
#include <tuple>

//#pragma GCC optimize ("Ofast")
//#pragma GCC target ("sse")

#define mp make_pair
#define pb push_back
using namespace std;
typedef long long ll;
typedef long double ld;

struct monster
{
	int at, he, rew;
	monster(){}
	monster(int _at, int _he, int _rew)
	{
		at = _at;
		he = _he;
		rew = _rew;
	}
};

const int N = 2e5;
const int E = (1 << 18);
pair <ll, ll> d[E << 1];
monster mon[N];
int n, m, p;
pair <int, int> w[N], a[N];

bool cmp(const monster& a, const monster& b)
{
	if(a.at != b.at)
		return a.at < b.at;
	return a.he < b.he;
}

void build(int v, int l, int r)
{
	if(v >= E)
	{
		if(l >= m)
			d[v] = mp(-1e18, 0);
		else
			d[v] = mp(-a[l].second, 0);
		return;
	}
	int mid = (l + r) / 2;
	build(v * 2, l, mid);
	build(v * 2 + 1, mid+ 1, r);
	d[v].first = max(d[v * 2].first, d[v * 2 + 1].first);
	d[v].second = 0;
}

void push(int v)
{
	d[v].first += d[v].second;
	if(v >= E)
		goto lol;
	d[v * 2].second += d[v].second;
	d[v * 2 + 1].second += d[v].second;
lol:;
	d[v].second = 0;
}

ll get_val(int v)
{
	push(v);
	return d[v].first;
}

void update(int v, int cl, int cr, int nl, int nr, ll val)
{
	push(v);
	if(cl > nr || cr < nl)
		return;
	if(nl <= cl && cr <= nr)
	{
		d[v].second += val;
		return;
	}
	int mid = (cl + cr) / 2;
	update(v * 2, cl, mid, nl, nr, val);
	update(v * 2 + 1, mid + 1, cr, nl, nr, val);
	d[v].first = max(get_val(v * 2), get_val(v * 2 + 1));
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> n >> m >> p;
	for(int i = 0; i < n; i++)
		cin >> w[i].first >> w[i].second;
	sort(w, w + n);
	for(int i = 0; i < m; i++)
		cin >> a[i].first >> a[i].second;
	sort(a, a + m);
	for(int i = 0; i < p; i++)
		cin >> mon[i].at >> mon[i].he >> mon[i].rew;
	sort(mon, mon + p, cmp);
	build(1, 0, E - 1);
	int uk = -1;
	ll ans = -1e18;
	for(int i = 0; i < n; i++)
	{
		int cur_at = w[i].first;
		while(uk + 1 < p && cur_at > mon[uk + 1].at)
		{
			uk++;
			int pos = lower_bound(a, a + m, mp(mon[uk].he, 0)) - a;
			update(1, 0, E - 1, pos, E - 1, mon[uk].rew);
		}
		ll res = get_val(1) - w[i].second;
		ans = max(ans, res);
	}
	cout << ans;
	return 0;
}