#include <bits/stdc++.h>

//#pragma GCC optimize("-O3")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("-Ofast")

#define fr(i, a, b) for(int i = (a); i <= (b); ++i)
#define rf(i, a, b) for(int i = (a); i >= (b); --i)
#define fe(x, y) for(auto& x : y)

#define fi first
#define se second
#define pb push_back
#define ve vector
#define y1 stanislavpolyn

#define sz(x) (ll)(x).size()
#define all(x) (x).begin(), (x).end()
#define pw(x) (1ll << (x))

using namespace std;

mt19937_64 rng(chrono::system_clock::now().time_since_epoch().count());

#include <ext/rope>
using namespace __gnu_cxx;

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
#define fbo find_by_order
#define ook order_of_key

template<typename T>
bool umx(T& a, T b) { return (a < b ? (a = b, 1) : 0); }
template<typename T>
bool umn(T& a, T b) { return (a > b ? (a = b, 1) : 0); }

using ll = long long;
using ld = long double;

const ll oo = 1e18;
const ll mod = 1e9 + 7;
const ll maxn = 1e6;

ll n, m, p;
ve<pair<ll, ll>> a, b;
ve<tuple<ll, ll, ll>> v;
ll suff_a[maxn], suff_b[maxn];

struct Fenwick {
    ve<ll> F;
    int n;
    void init(int _n) {
        n = _n;
        F.resize(n);
    }
    Fenwick() {

    }
    Fenwick(int _n) {
        init(_n);
    }
    void update(int pos, ll val) {
        while(pos < n) {
            F[pos] += val;
            pos = pos | (pos + 1);
        }
    }
    ll get(int pos) {
        ll sum = 0;
        while(pos >= 0) {
            sum += F[pos];
            pos = (pos & (pos + 1)) - 1;
        }
        return sum;
    }
    ll get(int l, int r) {
        return get(r) - get(l - 1);
    }
};

Fenwick F(1e6 + 5);

int main() {
//    freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
    ios::sync_with_stdio(0); cin.tie(0);
    cin >> n >> m >> p;
    a.resize(n);
    b.resize(m);
    ll mn_a = oo, mn_b = oo;
    fr(i, 0, n - 1) {
        cin >> a[i].fi >> a[i].se;
        umn(mn_a, a[i].se);
    }
    fr(i, 0, m - 1) {
        cin >> b[i].fi >> b[i].se;
        umn(mn_b, b[i].se);
    }
    sort(all(a));
    sort(all(b));
    rf(i, n - 1, 0) {
        suff_a[i] = a[i].se;
        if(i + 1 < n) {
            umn(suff_a[i], suff_a[i + 1]);
        }
    }
    rf(i, m - 1, 0) {
        suff_b[i] = b[i].se;
        if(i + 1 < m) {
            umn(suff_b[i], suff_b[i + 1]);
        }
    }
    fr(i, 0, p - 1) {
        ll x, y, z;
        cin >> x >> y >> z;
        v.pb(make_tuple(x, y, z));
    }
    sort(all(v));
    ll best = -(mn_a + mn_b);
//    cout << best << "\n";
    fr(i, 0, p - 1) {
        ll x, y, z;
        tie(x, y, z) = v[i];
        F.update(y, z);
        ll pos_a = lower_bound(all(a), make_pair(x + 1, -oo)) - a.begin();
        ll pos_b = lower_bound(all(b), make_pair(y + 1, -oo)) - b.begin();
        if(pos_a == sz(a) || pos_b == sz(b)) continue;
        ll mn_a = suff_a[pos_a];
        ll mn_b = suff_b[pos_b];
        ll got = F.get(y) - mn_a - mn_b;
//        cout << x << " " << y << " " << z << " " << got << " " << mn_a << " " << mn_b << " " << pos_a << " " << pos_b << "\n";
        umx(best, got);
    }
    cout << best << "\n";
}
