#include <bits/stdc++.h>

using namespace std;

queue<int> q;

void bfs(int x, vector<vector<int> > &b, vector<int> &used)
{
    q.pop();
    for (int i = 0; i < b[x].size(); ++i)
    {
        if (used[b[x][i]] == -1)
        {
            q.push(b[x][i]);
            used[b[x][i]] = used[x] + 1;
        }
    }
    if (!q.empty())
    {
        bfs(q.front(), b, used);
    }
}

int main()
{
    int n, m;
    cin >> n >> m;
    vector<vector<int> > a(n, vector<int> (0));
    vector<vector<int> > b(n, vector<int> (0));
    for (int i = 0; i < m; ++i)
    {
        int u, v;
        cin >> u >> v;
        u -= 1;
        v -= 1;
        a[u].push_back(v);
        b[v].push_back(u);
    }
    int k;
    cin >> k;
    vector<int> p(k);
    for (int i = 0; i < k; ++i)
    {
        cin >> p[i];
        p[i] -= 1;
    }
    vector<int> used(n, -1);
    used[p[k - 1]] = 0;
    q.push(p[k - 1]);
    bfs(p[k - 1], b, used);
    int minn = 0;
    int maxx = 0;
    for (int i = 0; i < k - 1; ++i)
    {
        bool self = false;
        bool other = false;
        for (int j = 0; j < a[p[i]].size(); ++j)
        {
            if (used[a[p[i]][j]] == used[p[i]] - 1)
            {
                if (a[p[i]][j] == p[i + 1])
                {
                    self = true;
                }
                else
                {
                    other = true;
                }
            }
        }
        if (other)
        {
            maxx += 1;
        }
        if (!self)
        {
            minn += 1;
        }
    }
    cout << minn << " " << maxx;
}
