#include <bits/stdc++.h>
#define x first
#define y second
#define deb if(debug)
using namespace std;

const bool debug = 0;
typedef long long ll;
typedef long double ld;

struct monstr
{
    int x,y;
    ll s;
    monstr(int x,int y,ll s):x(x),y(y),s(s){}
    monstr(){}
};

bool operator <(const monstr &a,const monstr &b)
{
    if(a.x == b.x)
    {
        if(a.y == b.y)
        {
            return a.s < b.s;
        }
        return a.y < b.y;
    }
    return a.x < b.x;
}

void pop_v(vector<pair<int,ll>> &a)
{
    vector<bool> b(a.size(),1);
    for(int i=0;i+1<a.size();i++)
    {
        if(a[i].x == a[i+1].x)
            b[i+1] = 0;
    }
    vector<pair<int,ll>> c;
    for(int i=0;i<a.size();i++)
    {
        if(b[i] == 1)
            c.push_back(a[i]);
    }
    a = c;
    b.resize(a.size(),1);
    c.clear();
    int j = ((int)(a.size()))-1;
    for(int i=((int)(a.size()))-2;i>=0;i--)
    {
        if(a[j].y <= a[i].y)
            b[i] = 0;
        else
            j = i;
    }
    for(int i=0;i<a.size();i++)
    {
        if(b[i] == 1)
            c.push_back(a[i]);
    }
    a = c;
}

vector<pair<ll,ll>> tree;
vector<ll> stree;


void create(int n)
{
    stree.resize(n,0);

    int k = 1;
    while(k<n)
        k*=2;
    tree.resize(2*k,{0,0});
}
void upd(int v)
{
    tree[v].x += tree[v].y;
    if(2*v < tree.size())
    {
        tree[2*v].y = tree[v].y;
        tree[2*v+1].y = tree[v].y;
    }
    tree[v].y = 0;
}
void add_s(int v,int l,int r,int sl,int sr,ll k)
{
    for(int i=l;i<=r;i++)
        stree[i] += k;

    return;

    if(l>r)
        return;
    upd(v);
    if(l == sl && r == sr)
    {
        tree[v].y += k;
        return;
    }
    int sm = (sr + sl)/2;
    add_s(v*2,l,min(sm,r),sl,sm,k);
    add_s(v*2+1,max(l,sm+1),r,sm+1,sr,k);
    tree[v].x = max(tree[2*v].x + tree[2*v].y,tree[2*v+1].x + tree[2*v+1].y);
}



ll get_max(int v,int l,int r,int sl,int sr)
{
    ll out = -(1<<60);
    for(int i=l;i<=r;i++)
        out = max(out, stree[i]);
    return out;

    if(l>r)
        return -1LL<<60;
    upd(v);
    if(l == sl && r == sr)
        return tree[v].x;
    int sm = (sr + sl)/2;
    return max(get_max(v*2,l,min(sm,r),sl,sm),get_max(v*2+1,max(l,sm+1),r,sm+1,sr));
}




int main()
{
    ifstream cin("in.txt");
    if(!debug)
    {
        cin.tie(0);
        cout.tie(0);
        ios::sync_with_stdio(0);
    }
    int n,m,p;
    cin >> n >> m >> p;
    vector<pair<int,ll> > x(n);
    vector<pair<int,ll> > y(m);
    //cout << "ok";
    for(int i=0;i<n;i++)
        cin >> x[i].x >> x[i].y;
    for(int i=0;i<m;i++)
        cin >> y[i].x >> y[i].y;
    vector<monstr> mstr(p);
    for(int i=0;i<p;i++)
        cin >> mstr[i].x >> mstr[i].y >> mstr[i].s;
    sort(x.begin(),x.end());
    sort(y.begin(),y.end());
    sort(mstr.begin(),mstr.end());
    pop_v(x);
    pop_v(y);
    //cout << "ok";
    m = y.size();
    n = x.size();
    vector<int> msy(p);
    for(int i=0;i<p;i++)
    {
        msy[i] = mstr[i].y;
    }
    sort(msy.begin(),msy.end());

    create(p);
    ll out = -x[0].y - y[0].y;
    {
        int j1 = 0;
        for(int i=0;i+1<y.size();i++)
        {
            int j2 = j1;
            while(j2<msy.size() && msy[j2] < y[i].x)
            {
                j2++;
            }
            j2--;
            add_s(1,j1+1,j2,0,tree.size()/2-1,-y[i].y);
            j1 = j2;
        }
        add_s(1,j1+1,p-1,0,tree.size()/2-1,-(1LL<<60));
    }

    for(int i=0;i<p;i++)
    {
        int yi = lower_bound(msy.begin(),msy.end(),mstr[i].y) - msy.begin();
        add_s(1,yi,p-1,0,tree.size()/2-1,mstr[i].s);
        ll out1 = get_max(1,0,p-1,0,tree.size()/2-1);
        //cout << out1 << '\n';
        int xi1 = upper_bound(x.begin(),x.end(),pair<int,ll>(mstr[i].x,1LL<<30)) - x.begin();
        if(xi1 < x.size() )
        {
           // cout << "ok " << x[xi1].y << '\n';
             out1 -= x[xi1].y;
        }

        out = max(out,out1);
    }
    cout << out;
    return 0;
}
