#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

#define x first
#define y second
#define pb push_back
#define mp make_pair
#define up_b upper_bound
#define low_b lower_bound
#define sz(v) (int)v.size()
#define all(v) v.begin(),v.end()

using namespace std;
using namespace __gnu_pbds;

typedef tree<int,null_type,less<int>,rb_tree_tag,tree_order_statistics_node_update>ordered_set;

typedef long long ll;
typedef long double ld;
typedef pair<int,int> pii;
typedef pair<ll,int> pli;
typedef pair<int,ll> pil;
typedef pair<ll,ll> pll;

const int N=2e5+11;
const int inf=1e9;
const ll INF=1e18;

vector<int>g[N];
int p[N];
vector<int>dist[N];
set<int>adj[N];
int d[N];

int main(){
  ios_base::sync_with_stdio(0);
  cin.tie(0),cout.tie(0);
  int n,m;
  cin>>n>>m;
  for(int i=1;i<=m;i++){
    int u,v;
    cin>>u>>v;
    g[v].pb(u);
    adj[u].insert(v);
  }
  int k;
  cin>>k;
  for(int i=1;i<=k;i++){
    cin>>p[i];
  }
  int t=p[k];
  for(int i=1;i<=n;i++){
    d[i]=inf;
  }
  set<pair<int,int>>q;
  q.insert(mp(0,t));
  d[t]=0;
  while(!q.empty()){
    pair<int,int>pr=*q.begin();
    q.erase(pr);
    int v=pr.y;
    for(int to:g[v]){
      if(d[to]>d[v]+1){
        q.erase(mp(d[to],to));
        d[to]=d[v]+1;
        q.insert(mp(d[to],to));
      }
    }
  }
  for(int i=1;i<=n;i++){
    if(i==t)continue;
    dist[d[i]].pb(i);
  }
  int mn=0,mx=0;
  for(int i=1;i<=k-1;i++){
    int len=k-i;
    int u=p[i];
    if(d[u]<len){
      mn++;
      mx++;
    }
    else{
      for(int v:dist[len-1]){
        if(v==p[i+1])continue;
        if(adj[u].find(v)!=adj[u].end()){
          mx++;
          break;
        }
      }
    }
  }
  cout<<mn<<" "<<mx;
}
