import java.io.*;
import java.util.*;

import static java.lang.Math.*;

public class Main {
    public static void main(String[] args) throws IOException {
        br = new BufferedReader(new InputStreamReader(System.in));
        pw = new PrintWriter(System.out);
        int n = nextInt();
        int[] p = new int[n];
        int[] b = new int[n];
        for (int i = 0; i < n; i++) {
            p[i] = nextInt();
        }
        for (int i = 0; i < n; i++) {
            b[i] = nextInt();
        }
        int cnt = 0;
        int cntForP = 0;
        for (int i = 0; i < n; i++) {
            if (p[i] == 0 && b[i] == 1) cnt++;
            else if (p[i] == 1 && b[i] == 0) cntForP++;
        }
        cnt += 1;
        if (cntForP == 0) pw.println(-1);
        else if(cnt % cntForP == 0)pw.println(cnt / cntForP);
        else pw.println(cnt / cntForP + 1);
        pw.close();
    }

    static BufferedReader br;
    static StringTokenizer st = new StringTokenizer("");
    static PrintWriter pw;

    static String next() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            st = new StringTokenizer(br.readLine());
        }
        return st.nextToken();
    }

    static int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    static long nextLong() throws IOException {
        return Long.parseLong(next());
    }
}
