#include <bits/stdc++.h>

using namespace std;

/*int gcd(int a, int b, int& x, int& y) {
    if (a == 0) {
        x = 0;
        y = 1;
        return b;
    }

    int x1, y1;
    int g = gcd(b % a, a, x1, y1);

    y = x1;
    x = -(b / a) * x1 + y1;

    return g;
}

const int NN = 23;

int rev(int a) {
    int x, y;
    int g = gcd(a, NN, x, y);

    x = (x + NN) % NN;
    return x;
}

map<string, int> m;

int dfs(string& s) {
    if (m.find(s) != m.end())
        return m[s];

    int ans = 0;
    if (int(s[0] - 'a') == int(s[1] - 'a') + 1)
        ans = max(ans, dfs(s.substr(1, s.size() - 1)) + 1);
    if (int(s[s.size() - 1] - 'a') == int(s[s.size() - 2] - 'a') + 1)
        ans = max(ans, dfs(s.substr(0, s.size() - 1)) + 1);

    for (int i = 1; i < s.size() - 1; ++i) {
        if (s[i] - 'a' == s[i - 1] - 'a' + 1 || s[i] - 'a' == s[i + 1] - 'a' + 1)
            ans = max(ans, dfs(s.substr(0, i) + s.substr(i + 1, s.size() - i - 1)) + 1);
    }


    m[s] = ans;

    return ans;
}
 */

 const int NN = 2 * 1e5 + 3;
 vector<vector<int> > g(NN);
 vector<vector<int> > rev(NN);

 vector<set<int> > nxt(NN);
 vector<int> dist(NN, NN + 2);

 void bfs(int v) {
    queue<int> q;
    q.push(v);
    dist[v] = 0;

    while (!q.empty()) {
        int cur = q.front();
        q.pop();

        for (int to : rev[cur])
            if (dist[to] > dist[cur] + 1) {
                dist[to] = dist[cur] + 1;
                nxt[to].insert(cur);
                q.push(to);
            } else if (dist[to] == dist[cur] + 1)
                nxt[to].insert(cur);
    }
    return;
 }

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, m;
    cin >> n >> m;

    for (int i = 0; i < m; ++i) {
        int x, y;
        cin >> x >> y;

        x--;
        y--;
        g[x].push_back(y);
        rev[y].push_back(x);
    }

    int k;
    cin >> k;

    vector<int> v(k);
    for (int i = 0; i < k; ++i) {
        cin >> v[i];
        v[i]--;
    }

    bfs(v[k - 1]);

    int mn = 0, mx = 0;
    for (int i = k - 1; i > 0; --i) {
        int x = v[i], y = v[i - 1];

        if (nxt[y].find(x) != nxt[y].end() && nxt[y].size() > 1)
            mx++;

        if (nxt[y].find(x) == nxt[y].end()) {
            mn++;
            mx++;
        }

    }

    cout << mn << ' ' << mx << endl;


    return 0;
}