#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;

#define all(x) x.begin(), x.end()

template <typename T1, typename T2> inline void chkmin(T1 & x, const T2 & y) {if (y < x) x = y;}
template <typename T1, typename T2> inline void chkmax(T1 & x, const T2 & y) {if (x < y) x = y;}

int n;
string s;

void read() {
    cin >> n >> s;
}

string get(int l, int r) {
    string ans = "";
    for (int i = l; i <= r; i++) {
        ans += s[i];
    }
    return ans;
}

void relax(int x) {
    for (int i = 0; i < (int)s.size(); i++) {
        if (s[i] != 'a' + x) continue;
        if (i > 0) {
            if (s[i - 1] == 'a' + x - 1) {
                s = get(0, i - 1) + get(i + 1, s.size() - 1);
                return;
            }
        } 
        if (i < s.size() - 1) {
            if (s[i + 1] == 'a' + x - 1) {
                s = get(0, i - 1) + get(i + 1, s.size() - 1);
                return;
            }
        }
    }
}

void run() {
    for (int i = 0; i < n - 1; i++) {
        for (int j = 25; j >= 1; j--) {
            relax(j);
        }
    }
}

void write() {
    cout << n - s.size() << endl;
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0), cout.precision(20), cout.setf(ios::fixed);
    read();
    run();
    write();
    return 0;
}