#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

//#define int ll
#define sz(a) (int)a.size()
#define ALL(a) a.begin(), a.end()
#define RALL(a) a.rbegin(), a.rend()
#define F first
#define S second
#define pb push_back
#define eb emplace_back

typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef vector<int> vi;
typedef vector<ll> vll;
typedef vector<double> vd;
typedef vector<char> vc;
typedef vector<bool> vb;
typedef vector<pii> vpii;
typedef vector<pll> vpll;
typedef tuple<int, int, int> tiii;
typedef vector<tiii> vtiii;

const int INF = 1e9;
const ll INFLL = 1e18;
//const int M = 1e9 + 7;

vector<vi> g, gt;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif

    int n, m;
    cin >> n >> m;
    g.resize(n);
    gt.resize(n);
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        --a, --b;
        g[a].pb(b);
        gt[b].pb(a);
    }

    int k;
    cin >> k;
    vi p(k);
    for (int &t : p)
        cin >> t, --t;
    int s = p.front(), f = p.back();

    queue<int> q;
    vi d(n);
    vb used(n);
    q.push(f);
    d[f] = 0;
    used[f] = true;
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (int to : gt[v])
            if (!used[to]) {
                d[to] = d[v] + 1;
                used[to] = true;
                q.push(to);
            }
    }
    int mi = 0, ma = 0;
    for (int i = 0; i < k - 1; ++i) {
        int v = p[i];
        int ne = p[i + 1];
        int h = INF;
        for (int to : g[v])
            h = min(h, d[to]);
        int c = 0;
        for (int to : g[v])
            if (d[to] == h)
                ++c;
        if (d[ne] != h)
            ++mi, ++ma;
        else if (c > 1)
            ++ma;
    }
    cout << mi << " " << ma << "\n";
}
