#include <bits/stdc++.h>

typedef long double ld;
typedef long long ll;

using namespace std;

mt19937 rnd(228);
#define rall(x) (x).rbegin(), (x).rend()
#define all(x) (x).begin(), (x).end()
#define pNN pair <Node *, Node *>
#define pii pair <int, int>
#define pb push_back
#define SZ(x) (int)(x).size()
#define ins insert
#define ers erase
#define S second
#define F first
const int N = 2e5 + 10, INF = 1e9 + 10;

vector <int> g[N], rev_g[N];
int dist[N];
int path[N];
int cnt[N];
bool used[N];

void solve() {
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; ++i) {
		int u, v;
		cin >> u >> v;
		g[u].pb(v);
		rev_g[v].pb(u);
	}
	int k;
	cin >> k;
	for (int i = 0; i < k; ++i) {
		cin >> path[i];
	}
	int t = path[k - 1];
	queue <int> q;
	q.push(t);
	used[t] = 1;
	while (!q.empty()) {
		int v = q.front();
		q.pop();
		used[v] = 1;
		for (auto to : rev_g[v]) {
			if (!used[to]) {
				dist[to] = dist[v] + 1;
				q.push(to);
				used[to] = 1;
			}
		}
	}

	for (int v = 1; v <= n; ++v) {
		for (auto to : g[v]) {
			if (dist[v] == dist[to] + 1) {
				++cnt[v];
			}
		}
	}

	int mn = 0;
	for (int i = 0; i < k - 1; ++i) {
		if (dist[path[i]] != dist[path[i + 1]] + 1) {
			++mn;
		}
	}
	int mx = 0;
	for (int i = 0; i < k - 1; ++i) {
		if (dist[path[i]] != dist[path[i + 1]] + 1) {
			++mx;
		} else {
			if (cnt[path[i]] > 1) {
				++mx;
			}
		}
	}
	cout << mn << " " << mx;
}


signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	#ifdef Solenoid555
		freopen ("input.txt", "r", stdin);
	#endif
	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}
	#ifdef Solenoid555
		cout << endl;
	#endif
	return 0;
}