#include <bits/stdc++.h>

typedef long double ld;
typedef long long ll;

using namespace std;

mt19937 rnd(228);
#define rall(x) (x).rbegin(), (x).rend()
#define all(x) (x).begin(), (x).end()
#define pNN pair <Node *, Node *>
#define pii pair <int, int>
#define pb push_back
#define SZ(x) (int)(x).size()
#define ins insert
#define ers erase
#define S second
#define F first
#define int ll
const int INF = 1e18 + 10, Q = 1e6 + 10;

struct SegmentTree {
	int t[Q * 4];
	int psh[Q * 4];

	SegmentTree () {
		fill(t, t + Q * 4, -INF);
		fill(psh, psh + Q * 4, 0);
	}

	void set(int v, int l, int r, int ind, int x) {
		if (r == l + 1) {
			t[v] = max(t[v], x);
			return;
		}
		int m = (r + l) >> 1;
		if (m > ind) {
			set(v * 2 + 1, l, m, ind, x);
		} else {
			set(v * 2 + 2, m, r, ind, x);
		}
		t[v] = max(t[v * 2 + 1], t[v * 2 + 2]);
	}

	void push(int v, int l, int r) {
		if (psh[v] != 0) {
			t[v] += psh[v];
			if (r != l + 1) {
				psh[v * 2 + 1] += psh[v];
				psh[v * 2 + 2] += psh[v];
			}
			psh[v] = 0;
		} 
	}

	void add(int v, int l, int r, int L, int R, int delta) {
		push(v, l, r);
		if (l >= R || r <= L) {
			return;
		}
		if (l >= L && r <= R) {
			psh[v] += delta;
			push(v, l, r);
			return;
		}
		int m = (r + l) >> 1;
		add(v * 2 + 1, l, m, L, R, delta);
		add(v * 2 + 2, m, r, L, R, delta);
		t[v] = max(t[v * 2 + 1], t[v * 2 + 2]);
	}

	int get() {
		return t[0];
	}

};

SegmentTree t;

const int N = 2e5 + 10;

pii a[N], b[N];

struct Kek {
	int x, y, c;
	Kek () {
		x = y = c = 0;
	}
	Kek(int x, int y, int c) {
		this->x = x;
		this->y = y;
		this->c = c;
	}
};

Kek c[N];

bool cmp(Kek a, Kek b) {
	return a.x < b.x;
}

void solve() {
	int n, m, p;
	cin >> n >> m >> p;
	for (int i = 0; i < n; ++i) {
		cin >> a[i].F >> a[i].S;
	}
	for (int i = 0; i < m; ++i) {
		cin >> b[i].F >> b[i].S;
		t.set(0, 0, Q, b[i].F, -b[i].S);
	}

	for (int i = 0; i < p; ++i) {
		cin >> c[i].x >> c[i].y >> c[i].c;
	}
	sort(a, a + n);
	sort(c, c + p, cmp);
	int ptr = 0;
	int ans = -INF;
	for (int i = 0; i < n; ++i) {
		while (ptr < p && c[ptr].x < a[i].F) {
			t.add(0, 0, Q, c[ptr].y + 1, Q, c[ptr].c);
			++ptr;
		}
		ans = max(ans, t.get() - a[i].S);
	}
	cout << ans;
}


signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	#ifdef Solenoid555
		freopen ("input.txt", "r", stdin);
	#endif
	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}
	#ifdef Solenoid555
		cout << endl;
	#endif
	return 0;
}