//#pragma GCC optimize("Ofast,fast-math,unroll-loops,no-stack-protector")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4.1,sse4.2,popcnt")
//#pragma GCC target("avx,avx2")
#include <iostream>
#include <vector>
#include <math.h>
#include <algorithm>
#include <unordered_set>
#include <unordered_map>

using namespace std;
typedef long long ll;

struct Node {
    ll colvo = 1000000000;
    ll dlina = 1000000000;
    Node (){}
};

vector<vector<ll>> g;
vector<vector<ll>> g_rev;

int main() {
    ll n, m;
    cin >> n >> m;
    vector<Node> a(n, Node());
    g.resize(n);
    g_rev.resize(n);
    for(ll i = 0; i < m; ++i){
        ll x, y;
        cin >> x >> y;
        x--;
        y--;
        g[x].push_back(y);
        g_rev[y].push_back(x);
    }
    ll path_size;
    vector<ll> path(path_size);
    cin >> path_size;
    for(ll i = 0; i < path_size; ++i){
        cin >> path[i];
        --path[i];
    }
    ll f = path[path_size - 1];
    vector<ll> queue;
    queue.reserve(n + 100000);
    queue.push_back(f);
    a[f].colvo = 1;
    a[f].dlina = 0;
    ll qstart = 0;
    vector<bool> used(n, false);
    used[f] = true;
    while (qstart < queue.size()){
        ll v = queue[qstart++];
        for(auto u : g_rev[v]){
            if (!used[u]){
                queue.push_back(u);
                used[u] = true;
            }
            if (a[u].dlina > a[v].dlina + 1){
                a[u].dlina = a[v].dlina + 1;
                a[u].colvo = 1;
            } else if (a[u].dlina == a[v].dlina + 1){
                a[u].colvo++;
            }
            //cout << u + 1 << " " << a[u].dlina << " " << a[u].colvo << " " << v + 1 << endl;
        }
    }
    ll ansmin = 0;
    ll ansmax = 0;
    //cout << endl;
//    for(ll i = 0; i < n; ++i){
//        cout << i + 1 << " " << a[i].dlina << " " << a[i].colvo << endl;
//    }
    ll cur_min = 0;
    for(ll i = 0; i < path_size; ++i){
        if (i == 0) {
            cur_min = a[path[i]].dlina;
        } else {
            if (cur_min - 1 == a[path[i]].dlina){
                if (a[path[i - 1]].colvo > 1){
                    ansmax++;
                }
                cur_min--;
            } else {
                cur_min = a[path[i]].dlina;
                ansmax++;
                ansmin++;
                //cout << path[i] + 1 << endl;
            }
        }
        //cout << cur_min << " yee" << endl;
    }
    cout << ansmin << " " << ansmax << endl;
    return 0;
}