//#pragma GCC optimize("O3")
//#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define stop system("pause")
#define int long long
using namespace std;
using namespace __gnu_pbds;

typedef tree<int,null_type,less<int>,rb_tree_tag,tree_order_statistics_node_update> ordered_set;

const int maxn = 3e5;
vector<vector<int> > v;
vector<vector<int> > e;
int mda[maxn];

struct st{
    int u;
    int d;
    bool operator<(st c)const{
        return d > c.d;
    }
};

void dijkstra(int s){
    priority_queue<st> q;
    mda[s] = 0;
    q.push({s,0});
    while(q.size()){
        //cout << now << endl;
        int now = q.top().u;
        int dist = q.top().d;
        q.pop();
        if(dist > mda[now])continue;
        for(int i(0); i < e[now].size();i++){
            int to = e[now][i];
            if(dist+1 < mda[to]){
                mda[to] = dist+1;
                q.push({to,mda[to]});
            }
        }
    }
}

main()
{
    ios_base::sync_with_stdio(0);
    int n,m; cin >> n >> m;
    for(int i(0); i < maxn;i++){
        mda[i] = 1e16;
    }
    v.resize(n+2);
    e.resize(n+2);
    for(int i(0); i < m;i++){
        int a,b; cin >> a >> b;
        a--;b--;
        v[a].push_back(b);
        e[b].push_back(a);

    }
    int k; cin >> k;
    vector<int> qwe;
    for(int i(0); i < k;i++){
        int x; cin >> x;
        x--;
        qwe.push_back(x);
    }
    dijkstra(qwe.back());
    int mx = 0;
    int mn = 0;
    for(int i(0); i < qwe.size()-1;i++){
        bool f1,f2;
        f1 = f2 = 0;
        for(int j(0); j < v[qwe[i]].size();j++){
            int to = v[qwe[i]][j];
            int now = qwe[i];
            if(to == qwe[i+1]){
                if(mda[now] == mda[to]+1)f1 = 1;
            }else{
                if(mda[now] == mda[to]+1)f2 = 1;
            }
        }
        if(f2)mx++;
        if(!f1)mn++;
    }
    cout << mn << ' ' << mx;
    return 0;
}
