#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>

using namespace std;

#define fastInp cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);
typedef long long ll;
typedef long double ld;

const ll SIZE = 1e5 * 8;

vector<ll> vec;
ll q, dp[SIZE], bal[SIZE], sumBal[SIZE];

ll gcd(ll a, ll b) {
	if(a == 0) {
		return b;
	} else {
		return gcd(b % a, a);
	}
}

int main() {
	fastInp;

	ll n;
	cin >> n;

	vec.resize(n);

	for(int i = 0; i < n; i++) cin >> vec[i];

	for(int i = 0; i < n; i++) {
		dp[i] += vec[i];
		dp[i + vec[i]] = max(dp[i + vec[i]], dp[i]);
	}

	for(int i = 0; i < n; i++) {
		bal[i] = vec[i] - i;
		sumBal[bal[i]] += vec[i];
	}

	ll ans = 0;
	for(int i = 0; i < SIZE; i++) {
		ans = max(ans, sumBal[i]);
	}

	cout << ans;
	return 0;
}