#include <bits/stdc++.h>
#define ll long long
#define ld long double
#define pll pair<ll, ll>
#define pii pair<int, int>
#define f first
#define se second
#define pb push_back
#define max3(a, b, c) max(a, max(b, c))
#define min3(a, b, c) min(a, min(b, c))


using namespace std;


const ll N = 3e5 + 19;
const int inf = 2e9;
const ll mod = 1e9 + 7;
const ll INF = 1e18;

struct monster{
    int a, b, cost;
} mon[N];


bool cmp(monster x, monster y) {
    return x.a < y.a;
}


bool cmp1(pll x, pll y) {
    if (x.f != y.f)
        return x.f < y.f;
    return x.se > y.se;
}


int n, m, p, t[4 * N], add[4 * N], ans = -inf - 1, sz = 0, maxb;
pii a[N], b[N], goodb[N];
bool is[N];


void case0() {
    int mn1 = inf, mn2 = inf;
    for (int i = 1; i <= n; i++)
        mn1 = min(mn1, a[i].se);
    for (int i = 1; i <= m; i++)
        mn2 = min(mn2, b[i].se);
    printf("%d", -mn1 - mn2);
}


bool check() {
    int ma1 = 0, mb1 = 0;
    for (int i = 1; i <= n; i++)
        ma1 = max(ma1, a[i].f);
    for (int i = 1; i <= m; i++)
        mb1 = max(mb1, b[i].f);
    for (int i = 1; i <= p; i++) {
        if (ma1 > mon[i].a && mb1 > mon[i].b)
            return 0;
    }
    return 1;
}


void build(int v, int tl, int tr) {
    add[v] = inf;
    t[v] = 0;
    if (tl == tr)
        return;
    int tm = (tl + tr)>>1;
    build((v << 1), tl, tm);
    build(((v << 1)|1), tm + 1, tr);
}


void push(int v, int tl, int tr) {
    if (tl == tr || add[v] == inf)
        return;
    t[(v << 1)] += add[v];
    t[((v << 1)|1)] += add[v];
    if (add[(v << 1)] == inf)
        add[(v << 1)] = add[v];
    else
        add[(v << 1)] += add[v];
    if (add[((v << 1)|1)] == inf)
        add[((v << 1)|1)] = add[v];
    else
        add[((v << 1)|1)] += add[v];
    
    add[v] = inf;
}


void upd(int v, int tl, int tr, int l, int r, int val) {
    if (r < tl || tr < l)
        return;
    if (l <= tl && tr <= r) {
        t[v] += val;
        if (add[v] == inf)
            add[v] = val;
        else
            add[v] += val;
        return;
    }
    push(v, tl, tr);
    int tm = (tl + tr)>>1;
    upd((v << 1), tl, tm, l, r, val);
    upd(((v << 1)|1), tm + 1, tr, l, r, val);
    t[v] = max(t[(v << 1)], t[((v << 1)|1)]);
}


int get(int v, int tl, int tr, int l, int r) {
    if (r < tl || tr < l)
        return -inf;
    push(v, tl, tr);
    if (l <= tl && tr <= r)
        return t[v];
    int tm = (tl + tr)>>1;
    return max(get((v << 1), tl, tm, l, r), get(((v << 1)|1), tm + 1, tr, l, r));
}


int main() {
    // ios_base::sync_with_stdio(NULL); cin.tie(NULL); cout.tie(NULL);
    scanf("%d %d %d", &n, &m, &p);
    for (int i = 1; i <= n; i++)
        scanf("%d %d", &a[i].f, &a[i].se);
    for (int i = 1; i <= m; i++)
        scanf("%d %d", &b[i].f, &b[i].se);
    for (int i = 1; i <= p; i++)
        scanf("%d %d %d", &mon[i].a, &mon[i].b, &mon[i].cost);
    sort(b + 1, b + m + 1, cmp1);
    sort(mon + 1, mon + p + 1, cmp);
    sort(a + 1, a + n + 1);
    
    if (check()) {
        case0();
        return 0;
    }
    
    int ptr = 1, mincost = inf + 1;
    
    for (int i = m; i >= 1; i--) {
        if (mincost < b[i].se)
            is[i] = 0;
        else
            is[i] = 1;
        mincost = min(mincost, b[i].se);
    }

    for (int i = 1; i <= m; i++)
        if (is[i])
            goodb[++sz] = b[i];
    
    maxb = goodb[sz].f - 1;
    
    // for (int i = 1; i <= sz; i++)
    //     cout << goodb[i].f << " " << goodb[i].se << endl;
    
    // return 0;
    
    upd(1, 1, maxb, 1, goodb[1].f - 1, -goodb[1].se);
    for (int i = 2; i <= sz; i++)
        upd(1, 1, maxb, goodb[i - 1].f, goodb[i].f - 1, -goodb[i].se);
    
    for (int i = 1; i <= n; i++) {
        while (ptr != p + 1 && mon[ptr].a < a[i].f) {
            upd(1, 1, maxb, mon[ptr].b, maxb, mon[ptr].cost);
            ptr++;
        }
        ans = max(ans, -a[i].se + get(1, 1, maxb, 1, maxb));
    }
    printf("%d", ans);
}
