#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <queue>
#include <deque>
#include <stack>
#include <string>
#include <bitset>
#include <unordered_map>
#include <unordered_set>

using namespace std;

#define en '\n'
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

typedef long long ll;

#define int ll

typedef pair<int, int> pii;
typedef double db;
typedef long double ld;

const int INF = 1e9 + 7;
const ll LINF = 1e18;
const db EPS = 1e-9;

void solve() {
	int n;
	cin >> n;
	vector<int> a(n), s(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		s[i] = a[i];
	}
	if (n == 1) {
		cout << a[0];
		return;
	}
	set<pii> b;
	b.insert(make_pair(a[0], 0));
	int mx = a[0];
	for (int i = 1; i < n; ++i) {
		pii x = make_pair(a[i], i);
		auto it = lower_bound(all(b), x);
		if (it == b.end()) --it;
		pii c = *it;
		while (it != b.begin()) {
			if (x.second - c.second == x.first - c.first) {
				s[i] = max(s[i], (x.first + s[c.second]));
			}
			--it;
			c = *it;
		}
		if (x.second - c.second == x.first - c.first) {
				s[i] = max(s[i], (x.first + s[c.second]));
		}
		mx = max(mx, s[i]);
		b.insert(x);
	}
	cout << mx << en;
}

signed main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
#endif
	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}