/*
#pragma GCC optimize("Ofast,no-stack-protector,fast-math,unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4.1,sse4.2,avx,avx2,popcnt,abm,mmx,tune=native")
*/
#include <bits/stdc++.h>
#include <immintrin.h>
using namespace std;
#define x first
#define y second
#define int long long
/*
int ptr = 0;
const int MAX_MEM = 1e8;
char mem[MAX_MEM];
void* operator new(size_t n) {
	ptr += n;
	return mem + ptr - n;
}
void operator delete(void*) {}
void operator delete(void*, std::size_t) {}
*/
/*
template<int MAXN>
struct fenwick {
	int f[MAXN];
	void add(int p, int x) {
		for (; p < MAXN; p = p | (p + 1))
			f[p] += x;
	}
	int get(int p) {
		int ans = 0;
		for (; p >= 0; p = (p & (p + 1)) - 1)
			ans += f[p];
		return ans;
	}
	fenwick() {
		fill(f, f + MAXN, 0);
	}
};
*/
const int MAXN = 2e5 + 7, MAXC = 1e6 + 7;
int a[MAXN], ca[MAXN], b[MAXN], cb[MAXN], x[MAXN], y[MAXN], c[MAXN];
struct q {
	int t, x, p, c;
};
bool cmp(q &a, q &b) {
	if (a.x != b.x)
		return a.x < b.x;
	else
		return a.t < b.t;
}
const int INF = 1e12;
int psh[4 * MAXC], t[4 * MAXC];
void build(int v, int tl, int tr) {
	t[v] = -INF;
	psh[v] = 0;
	if (tl != tr) {
		int tm = (tl + tr) / 2;
		build(v * 2, tl, tm);
		build(v * 2 + 1, tm + 1, tr);
	}
}
inline void push(int v, int tl, int tr) {
	if (tl != tr)
		psh[v * 2] += psh[v], psh[v * 2 + 1] += psh[v];
	t[v] += psh[v];
	psh[v] = 0;
}
inline void add(int v, int tl, int tr, int l, int r, int x) {
	if (tl > r || l > tr)
		return;
	if (l <= tl && tr <= r) {
		psh[v] += x;
		push(v, tl, tr);
		return;
	}
	push(v, tl, tr);
	int tm = (tl + tr) / 2;
	add(v * 2, tl, tm, l, r, x);
	add(v * 2 + 1, tm + 1, tr, l, r, x);
	t[v] = max(t[v * 2], t[v * 2 + 1]);
}
inline int get(int v, int tl, int tr, int l, int r) {
	if (tl > r || l > tr)
		return -INF;
	push(v, tl, tr);
	if (l <= tl && tr <= r) 
		return t[v];
	int tm = (tl + tr) / 2;
	return max(get(v * 2, tl, tm, l, r), get(v * 2 + 1, tm + 1, tr, l, r));
}
void solve() {
	int n, m, p;
	cin >> n >> m >> p;
	build(1, 0, MAXC - 1);
	vector<q> qs;
	build(1, 0, MAXC - 1);
	for (int i = 0; i < n; ++i) {
		cin >> a[i] >> ca[i];
		--a[i];
		qs.push_back({1, a[i], 0, ca[i]});
	}
	for (int i = 0; i < m; ++i) {
		cin >> b[i] >> cb[i];
		--b[i];
		int nv = -cb[i];
		int cv = get(1, 0, MAXC - 1, b[i], b[i]);
		if (nv > cv) 
			add(1, 0, MAXC - 1, b[i], b[i], nv - cv);
	}
	for (int i = 0; i < p; ++i) {
		cin >> x[i] >> y[i] >> c[i];
		qs.push_back({0, x[i], y[i], c[i]});
	}
	sort(qs.begin(), qs.end(), cmp);
	int ans = -INF;
	for (q x : qs) {
		if (x.t == 0) 
			add(1, 0, MAXC - 1, x.p, MAXC - 1, x.c);
		else 
			ans = max(ans, -x.c + t[1]);
	}
	cout << ans;
	return;
}
signed main() {
	//freopen("E.in", "r", stdin);
	ios_base::sync_with_stdio(false);

	solve();

	return 0;
}
