#include <algorithm>
#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
#include <queue>
#include <map>
using namespace std;
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    int n, m, a, b;
    cin >> n >> m;
    vector<vector<int> > g(n);
    vector<int> path(n), length(n, -1), numb(n, 0), used(n, 0);
    for(int i = 0; i < m; ++i) {
        cin >> a >> b;
        a--; b--;
        g[b].push_back(a);
    }
    cin >> m;
    for(int i = 0; i < m; ++i) {
        cin >> path[i];
        path[i] --;
    }
    length[path[m - 1]] = 0;
    numb[path[m - 1]] = 1;
    queue <int> bfs;
    bfs.push(path[m - 1]);
    while(!bfs.empty()) {
        int x = bfs.front();
        bfs.pop();
        if(used[x])
            continue;
        for(int i = 0; i < g[x].size(); ++i) {
            if(length[g[x][i]] == -1) {
                bfs.push(g[x][i]);
                numb[g[x][i]]++;
                length[g[x][i]] = length[x] + 1;
            }
            else if(length[g[x][i]] == length[x] + 1) {
                numb[g[x][i]]++;
            }
        }
        used[x] = 1;
    }
    int s = path[0], mn = 0, mx = 0;
    for(int i = 1; i < m; ++i) {
        if(length[s] - length[path[i]] != 1) {
            mn++; mx++;
        }
        else if(numb[s] > 1)
            mx++;
        s = path[i];
    }
    cout << mn << ' '<< mx;
    return 0;
}
