#include <bits/stdc++.h>
using namespace std;
#define mp make_pair
#define all(vv) vv.begin(), vv.end()
#define pb push_back
#define F first
#define S second
#define sh cin.tie(0); cout.tie(0); cin.sync_with_stdio(0); cout.sync_with_stdio(0);
#define print1(a) cout << "{ " << #a << ' ' << a << " }" << endl;
#define print2(a, b) cout << "{ " << #a << ' ' << a << ", " << #b << ' ' << b << " }" << endl;
#define int long long
const int MAXN = 2e5 + 228;
const int INF = 1e18;
struct node {
    int val;
    bool flag;
    int ps;
};
node t[MAXN * 4];
vector<pair<int, int>> a, b;
vector<int> best;

void push(int v) {
    if (!t[v].flag)
        return;
    t[v].flag = 0;
    t[v * 2].flag = t[v * 2 + 1].flag = 1;
    t[v * 2].val += t[v].ps;
    t[v * 2 + 1].val += t[v].ps;
    t[v * 2].ps += t[v].ps;
    t[v * 2 + 1].ps += t[v].ps;
    t[v].ps = 1;
}

void build(int l, int r, int v) {
    if (l == r) {
        t[v].val = -b[l].S;
        return;
    }
    int mid = (l + r) / 2;
    build(l, mid, 2 * v);
    build(mid + 1, r, 2 * v + 1);
    t[v].val = max(t[v * 2].val, t[v  * 2 + 1].val);
}

void add(int v, int l, int r, int tl, int tr, int x) {
    if (tl > tr)
        return;
    if (tl == l && tr == r) {
        t[v].flag = 1;
        t[v].ps += x;
        t[v].val += x;
        return;
    }
    push(v);
    int mid = (l + r) / 2;
    add(2 * v, l, mid, tl, min(tr, mid), x);
    add(2 * v + 1, mid + 1, r, max(tl, mid + 1),tr, x);
    t[v].val = max(t[v * 2].val, t[v  * 2 + 1].val);
}

signed main() {
    #ifdef LOCAL
    freopen("test.in", "r", stdin);
    #endif // LOCAL
    sh;
    int n, m, p;
    cin >> n >> m >> p;
    for (int i = 0; i < n; i++) {
        int aa, bb;
        cin >> aa >> bb;
        a.pb({aa, bb});
    }
    for (int i = 0; i < m; i++) {
        int aa, bb;
        cin >> aa >> bb;
        b.pb({aa, bb});
    }
    sort(all(a));
    sort(all(b));
    build(0, m - 1, 1);
    vector<pair<int, pair<int, int>>> v;
    for (int i = 0; i < p; i++) {
        int aa, bb, cc;
        cin >> aa >> bb >> cc;
        v.pb({aa, {bb, cc}});
    }
    sort(all(v));
    int id = 0;
    int ans = -INF;
    for (int i = 0; i < n; i++) {
        int now = a[i].F;
        while (id < p && v[id].F < now) {
            int y = v[id].S.F;
            int need = lower_bound(all(b), mp(y, INF)) - b.begin();
            //print2(y,need);
            add(1, 0, m - 1, need, m - 1, v[id].S.S);
            id++;
        }
        ans = max(ans, -a[i].S + t[1].val);
        //print2(i, ans);
    }
    cout << ans << endl;
    return 0;
}

