#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <queue>

using namespace std;

int n, m, k;
vector <vector <int> > g1(200000 + 1);
vector <vector <int> > g2(200000 + 1);
vector <int> p(200000 + 1);
vector <int> x(200000 + 1, 0);
vector <int> d(200000 + 1, -1);

void F() {
    queue <int> q;
    q.push(p[k - 1]);
    d[p[k - 1]] = 0;
    x[p[k - 1]] = 1;
    while (int(q.size()) != 0) {
        int v = q.front();
        q.pop();
        for (int i = 0; i < int(g2[v].size()); i++) {
            int to = g2[v][i];
            if (d[to] == -1) {
                x[to]++;
                d[to] = d[v] + 1;
                q.push(to);
            }
            else {
                if (d[to] == d[v] + 1)
                    x[to]++;
            }
        }
    }
}


int main() {
    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        g1[u - 1].push_back(v - 1);
        g2[v - 1].push_back(u - 1);
    }
    cin >> k;
    for (int i = 0; i < k; i++) {
        cin >> p[i];
        p[i]--;
    }
    F();
    int ans1 = 0, ans2 = 0;
    for (int i = 1; i < k; i++) {
        if (d[p[i - 1]] - 1 != d[p[i]]) {
            ans1 += 1;
            ans2 += 1;
        }
        else {
            if (x[p[i - 1]] > 1) ans2++;
        }
    }
    cout << ans1 << " " << ans2;
}


