#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define inf 1000000000
#define ff first
#define ss second
#define pb push_back
#define all(v) v.begin(), v.end()

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;
typedef pair <int, int> pii;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const int N = 200000 + 5;
int n, m, k, s, t, d[N];
vector <vector <int> > v, rv;
vector <int> way;

void bfs(int x){
    queue <int> q;
    for (int i = 0; i < n; i++) d[i] = inf;
    d[x] = 0;
    q.push(x);
    while (!q.empty()){
        int x = q.front();
        q.pop();
        for (auto u: rv[x]){
            if (d[u] > d[x] + 1){
                d[u] = d[x] + 1;
                q.push(u);
            }
        }
    }
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> m;
    v.resize(n);
    rv.resize(n);
    for (int i = 0; i < m; i++){
        int x, y;
        cin >> x >> y;
        --x; --y;
        v[x].push_back(y);
        rv[y].push_back(x);
    }
    cin >> k;
    way.resize(k);
    for (auto &u: way) cin >> u;
    s = way[0]; t = way.back();
    bfs(t - 1);
//    for (int i = 0; i < n; i++){
//        cout << d[i] << " ";
//    }
//    cout << "\n";
    int ans_mn = 0, ans_mx = 0;
    for (int i = 1; i < way.size(); i++){
        int x = way[i - 1], y = way[i];
        --x; --y;
        if (d[x] <= d[y]) ans_mn++, ans_mx++;
        else {
            int cnt = 0;
            for (auto u: v[x]){
                if (d[u] < d[x]) cnt++;
            }
            if (cnt > 1) ans_mx++;
        }
    }
    cout << ans_mn << " " << ans_mx;
    return 0;
}
