#include <iostream>
#include <map>
#include <set>
using namespace std;

typedef unsigned long long ull;

int main()
{
    int n;
    cin >> n;

    map <int, ull> sum;
    set <int> diff;

    ull b = 0;
    for (int i = 0; i < n; i++)
    {
        cin >> b;
        diff.insert(b - i);
        sum[b - i] += b;
    }

    ull best_sum = 0;
    for (set<int>::iterator it = diff.begin(); it != diff.end(); it++)
    {
        if (sum[*it] > best_sum)
        {
            best_sum = sum[*it];
        }
    }
    cout << best_sum << "\n";

    return 0;
}
