#include<iostream>
#include<iomanip>
#include<vector>
#include<algorithm>
#include<cmath>
#include<set>
#include<unordered_set>
#include<map>
#include<unordered_map>
#include<ctime>
#include<random>

using namespace std;

#define int long long

mt19937_64 rnd(time(NULL));

struct armor
{
    int l;
    int r;
};

bool operator < (armor a, armor b)
{
    if (a.l!=b.l) return a.l<b.l;
    return a.r>b.r;
}

struct monster
{
    int l;
    int r;
    int q;
};

bool operator < (monster a, monster b)
{
    if (a.l!=b.l) return a.l<b.l;
    if (a.r!=b.r) return a.r<b.r;
    return a.q<b.q;
}

armor a[1000000+5];

armor a0[1000000+5];

armor b0[1000000+5];

armor b[1000000+5];

monster c[1000000+5];

int a1[1000000+5];

int b1[1000000+5];

int t[4000000+5];

int psh[4000000+5];

inline void push(int v, int tl, int tr)
{
    if (psh[v]!=0)
    {
        t[v]+=psh[v];
        if (tl!=tr)
        {
            psh[v*2]+=psh[v];
            psh[v*2+1]+=psh[v];
        }
        psh[v]=0;
    }
}

void update(int v, int tl, int tr, int l, int r, int q)
{
    push(v,tl,tr);
    if (l>r) return;
    if (tl==l&&tr==r)
    {
        psh[v]+=q;
        push(v,tl,tr);
        return;
    }
    int tm=(tl+tr)/2;
    update(v*2,tl,tm,l,min(r,tm),q);
    update(v*2+1,tm+1,tr,max(l,tm+1),r,q);
    t[v]=max(t[v*2],t[v*2+1]);
}

int sum(int v, int tl, int tr, int l, int r)
{
    push(v,tl,tr);
    if (l>r) return -1e18;
    if (tl==l&&tr==r)
    {
        return t[v];
    }
    int tm=(tl+tr)/2;
    return max(sum(v*2,tl,tm,l,min(r,tm)),sum(v*2+1,tm+1,tr,max(l,tm+1),r));
}

int ans[1000000+5];

int32_t main()
{
    ios_base::sync_with_stdio(false);
    int n,m,p;
    cin>>n>>m>>p;
    for (int i=1; i<=n; i++)
    {
        cin>>a0[i].l>>a0[i].r;
    }
    for (int i=1; i<=m; i++)
    {
        cin>>b0[i].l>>b0[i].r;
    }
    sort(a0+1,a0+n+1);
    sort(b0+1,b0+m+1);
    int siz=1;
    a[1]=a0[n];
    for (int i=n-1; i>=1; i--)
    {
        if (a0[i].r>=a[siz].r) continue;
        siz++;
        a[siz]=a0[i];
    }
    n=siz;
    siz=1;
    b[1]=b0[m];
    for (int i=m-1; i>=1; i--)
    {
        if (b0[i].r>=b[siz].r) continue;
        siz++;
        b[siz]=b0[i];
    }
    m=siz;
    sort(a+1,a+n+1);
    sort(b+1,b+m+1);
    /*cout<<endl;
    for (int i=1; i<=n; i++)
    {
        cout<<a[i].l<<" "<<a[i].r<<endl;
    }
    cout<<endl;
    for (int i=1; i<=m; i++)
    {
        cout<<b[i].l<<" "<<b[i].r<<endl;
    }
    cout<<endl;*/
    for (int i=1; i<=n; i++)
    {
        ans[i]=-1e18;
    }
    for (int i=1; i<=m; i++)
    {
        update(1,1,m,i,i,-b[i].r);
    }
    for (int i=1; i<=p; i++)
    {
        cin>>c[i].l>>c[i].r>>c[i].q;
    }
    sort(c+1,c+p+1);
    for (int i=1; i<=n; i++)
    {
        a1[i]=a[i].l;
    }
    for (int i=1; i<=m; i++)
    {
        b1[i]=b[i].l;
    }
    int fans=-1e18;
    for (int i=1; i<=p; i++)
    {
        int cur=upper_bound(a1+1,a1+n+1,c[i].l)-a1;
        if (cur==n+1) continue;
        int pos=upper_bound(b1+1,b1+m+1,c[i].r)-b1;
        if (pos==m+1) continue;
        update(1,1,m,pos,m,c[i].q);
        ans[cur]=max(ans[cur],sum(1,1,m,1,m)-a[cur].r);
    }
    for (int i=1; i<=n; i++)
    {
        fans=max(fans,ans[i]);
    }
    cout<<fans;
}

