#include <bits/stdc++.h>
#define forn(i, n) for (int i = 0; i < n; ++i)
using namespace std;

typedef long long ll;


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    //freopen("input.txt", "r", stdin);


    int n, m;
    cin >> n >> m;
    vector<vector<int> > ginv(n, vector<int>());
    int inp1, inp2;
    forn(i, m) {
        cin >> inp1 >> inp2;
        inp1--, inp2--;
        ginv[inp2].push_back(inp1);
    }

    int k;
    cin >> k;
    vector<int> p(k);
    forn(i, k) {
        cin >> p[i];
        p[i]--;
    }
    int t = p.back();

    vector<ll> dist(n, 1e9), used(n, 0);
    deque<int> deq;
    deq.push_back(t);
    used[t] = 1;
    dist[t] = 0;
    while (!deq.empty()) {
        int v = deq.front();
        deq.pop_front();
        for (int u : ginv[v]) {
            if (used[u] == 0) {
                used[u] = used[v];
                dist[u] = dist[v] + 1;
                deq.push_back(u);
            } else if (dist[u] == dist[v] + 1) used[u] += used[v];
        }
    }

    int ctr1 = 0, ctr2 = 0;
    for (int i = k - 1; i >= 0; --i) {
        int v = p[i];
        if (used[v] > 1) ctr1++;
        if (i + 1 < k && dist[v] < dist[p[i + 1]] + 1) ctr2++;
    }

    cout << ctr2 << " " << ctr1 + ctr2;
}
