#define CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <cmath>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <assert.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
const ll INF = 1e18;
const double PI = acos(-1.0);

const int MAX_N = 105;
bool A[MAX_N], B[MAX_N];

int main()
{
	ios::sync_with_stdio(false);

	int n;
	cin >> n;
	for (int i=0; i<n; i++)
	{
		cin >> A[i];
	}
	for (int i=0; i<n; i++)
	{
		cin >> B[i];
	}

	int cnt1 = 0, cnt0 = 0;
	for (int i=0; i<n; i++)
	{
		if (A[i] && !B[i])
		{
			cnt1++;
		}
		if (!A[i] && B[i])
		{
			cnt0++;
		}
	}

	if (cnt1 == 0)
	{
		cout << -1;
		return 0;
	}

	int res = 1;
	int k = cnt0 / cnt1 + 1;
	res = max(res, k);
	cout << res;

	//system("pause");
	return 0;
}