#define CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <cmath>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <assert.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
const ll INF = 1e18;
const double PI = acos(-1.0);

const int MAX_N = 200005;
int n, m, k;
vector<int> g[MAX_N], gr[MAX_N];
queue<int> q;
int d[MAX_N];
vector<int> p;
bool vis[MAX_N];

int main()
{
	ios::sync_with_stdio(false);

	cin >> n >> m;
	int a, b;
	for (int i=0; i<m; i++)
	{
		cin >> a >> b;
		g[a].push_back(b);
		gr[b].push_back(a);
	}
	cin >> k;
	for (int i=0; i<k; i++)
	{
		cin >> a;
		p.push_back(a);
	}

	vis[p[k - 1]] = 1;
	q.push(p[k - 1]);
	while (!q.empty())
	{
		int v = q.front();
		q.pop();

		for (int i=0; i<gr[v].size(); i++)
		{
			int nxt = gr[v][i];
			if (!vis[nxt])
			{
				vis[nxt] = 1;
				d[nxt] = d[v] + 1;
				q.push(nxt);
			}
		}
	}

	/*for (int i=1; i<=n; i++)
	{
		cout << d[i] << endl;
	}*/

	int mini = 0, maxi = 0;
	for (int i=0; i<k-1; i++)
	{
		int v = p[i];
		int cnt = 0;
		for (int j=0; j<g[v].size(); j++)
		{
			int nxt = g[v][j];
			if (d[nxt] == d[v] - 1)
			{
				cnt++;
			}
		}
		if (d[p[i + 1]] != d[v] - 1)
		{
			mini++;
			maxi++;
		}
		else if (cnt > 1)
		{
			maxi++;
		}
	}

	cout << mini << " " << maxi;

	//system("pause");
	return 0;
}