#include<iostream>
#include<string>
#include<vector>
#include<set>
#include<map>
#include<unordered_map>
#include<unordered_set>
#include<stack>
#include<iomanip>
#include<queue>

using namespace std;

vector<vector<int>> gr, tgr;
vector<bool> used;
vector<int> dist;
int n, m;

inline void bfs_t(int v) {
    used.assign(n, false);
    dist.assign(n, 1e9);
    queue<int> q;
    q.push(v);
    dist[v] = 0;
    used[v] = true;
    while (!q.empty()) {
        int u = q.front();
        q.pop();
        for (int i : tgr[u]) {
            if (!used[i]) {
                dist[i] = dist[u] + 1;
                used[i] = true;
                q.push(i);
            }
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int _ = 1;
    //cin >> _;
    while (_--) {
        cin >>  n >> m;
        gr.resize(n);
        tgr.resize(n);
        for (int i =0 ; i < m; i++) {
            int a, b;
            cin >> a >> b;
            gr[--a].push_back(--b);
            tgr[b].push_back(a);
        }
        int k;
        cin >> k;
        vector<int> a(k);
        for (int i =0 ; i < k; i++) {
            cin >> a[i];
            --a[i];
        }
        bfs_t(a[k - 1]);
        int mn = 0, mx = 0;
        for (int u =0 ; u < k - 1; u++) {
            int cur_mn = 1e9;
            for (int i : gr[a[u]]) {
                if (i != a[u + 1]) {
                    cur_mn = min(cur_mn, dist[i]);
                }
            }
            if (cur_mn < dist[a[u + 1]]) {
                mn++;
                mx++;
            }
            else if (cur_mn == dist[a[u + 1]]) {
                mx++;
            }
        }
        cout << mn << " " << mx << endl;
    }
}

