#include <bits/stdc++.h>
#define FI(n) for (int i = 0; i < n; ++i)
#define FJ(n) for (int j = 0; j < n; ++j)
#define mp make_pair
#define mt make_tuple
#define pb push_back
#define eb emplace_back
#define endl '\n'
#define g0(x) get<0>(x)
#define g1(x) get<1>(x)
#define g2(x) get<2>(x)
#define g3(x) get<3>(x)

#ifndef LOCAL
    #define LOCAL 0
#endif
#define dbg(...) LOCAL && fprintf(stderr, __VA_ARGS__)
#define cerr LOCAL && std::cerr
#define watch(x) cerr << #x << " = " << x << endl
#define separator cerr << "================" << endl

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using namespace std;

int main()
{
#if !LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
//    ifstream cin("input.txt");
//    ofstream cout("output.txt");
#endif

    int n, m;
    cin >> n >> m;
    vector<vector<int>> g(n);
    vector<vector<int>> gr(n);
    FI(m)
    {
        int v, u;
        cin >> v >> u;
        v--, u--;
        g[v].pb(u);
        gr[u].pb(v);
    }
    int k;
    cin >> k;
    vector<int> a(k);
    FI(k)
    {
        cin >> a[i];
        a[i]--;
    }
    int s = a.front();
    int f = a.back();
    vector<int> dist(n, INT_MAX);
    dist[f] = 0;
    queue<int> q;
    q.push(f);
    while (!q.empty())
    {
        int v = q.front();
        q.pop();
        for (auto it : gr[v])
            if (dist[v] + 1 < dist[it])
            {
                dist[it] = dist[v] + 1;
                q.push(it);
            }
    }
    int ans1 = 0, ans2 = 0;
    FI(k - 1)
    {
        int from = a[i];
        int to = a[i + 1];
        int mindist = INT_MAX;
        int mindistk = 0;
        for (auto it : g[from])
        {
            if (dist[it] < mindist)
            {
                mindist = dist[it];
                mindistk = 1;
            }
            else if (dist[it] == mindist)
                mindistk++;
        }
        if (dist[to] > mindist)
            ans1++, ans2++;
        else if (mindistk > 1)
            ans2++;
    }
    cout << ans1 << ' ' << ans2;

    return 0;
}
