// ~maqsat~

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define x first
#define y second
#define in insert
#define pb push_back
#define eb emplace_back
#define sz(x) (int)x.size()

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ull = unsigned long long;
using db = double;
using ld = long double;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

template<class T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<class T>
inline void cmax(T& a, const T b) { a = max(a, b); }
template<class T>
inline void cmin(T& a, const T b) { a = min(a, b); }

const int N = 1e5 + 123;
const int MOD = 1e9 + 7;
const int oo = INT_MAX;
const ll INF = LLONG_MAX;
const db PI = acos(-1);
const db EPS = 1e-9;

map <string, int> dp;

inline int calc(string s) {
    int n = sz(s);

    if (n == 1) return 0;
    if (n == 2) {
        if (s[0] == s[1]) return 0;
        return 1;
    }
    if (dp.count(s)) return dp[s];

    int res = 0;
    for (int i = 0; i < n; i++) {
        if (!i) {
            if (s[i] > s[i + 1]) cmax(res, calc(s.substr(1)) + 1);
        } else if (i == n - 1) {
            if (s[i] > s[i - 1]) cmax(res, calc(s.substr(0, n - 1)) + 1);
        } else {
            if (s[i] > s[i + 1]) cmax(res, calc(s.substr(0, i) + s.substr(i + 1, n - i - 1)) + 1);
            else if (s[i] > s[i - 1]) cmax(res, calc(s.substr(0, i) + s.substr(i + 1, n - i - 1)) + 1);
        }
    }

    return dp[s] = res;
}

inline void solve() {
    int n;
    cin >> n;

    string s;
    cin >> s;

    cout << calc(s);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int tt = 1;
//    cin >> tt;
    while (tt--) solve();

    return 0;
}
