#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

long long bpow (long long a, long long n) {
	if (n == 0)
		return 1;
	if (n % 2 == 1)
		return bpow(a, n - 1) * a;
	long long ans = bpow(a, n / 2);
	return ans * ans;
}

int main() {
	int n, m;
	cin >> n >> m;
	vector<vector<int> > g(n);
	for (int i = 0; i < m; i++) {
		int a, b;
		cin >> a >> b;
		g[b - 1].push_back(a - 1);
	}
	int k;
	cin >> k;
	vector<int> p(k);
	for (int i = 0; i < k; i++) {
		cin >> p[i];
		p[i]--;
	}
	queue<int> q;
	vector<pair<int, int> > d(n, {INT_MAX, 0});
	q.push(p[k - 1]);
	d[p[k - 1]].fi = 0;
	d[p[k - 1]].se = 1;
	while (!q.empty()) {
		int cur = q.front();
		q.pop();
		for (auto to : g[cur]) {
			if (d[to].fi == INT_MAX) {
				d[to].fi = d[cur].fi + 1;
				d[to].se = 1;
				q.push(to);
			} else {
				if (d[to].fi == d[cur].fi + 1) {
					d[to].se++;
				}
			}
		}
	}
	int a1 = 0, a2 = 0;
	for (int i = 0; i < k - 1; i++) {
		int p1 = p[i], p2 = p[i + 1];
		if (d[p2].fi >= d[p1].fi) {
			a1++;
			a2++;
		} else {
			if (d[p1].se >= 2) {
				a2++;
			}
		}
	}
	cout << a1 << " " << a2 << '\n';
    return 0;
}
