#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;
typedef pair<ll,ll> pll;
typedef pair<pll,ll> plll;
typedef pair<pll,pll> ppll;

#define all(x) (x).begin(),(x).end()
#define rall(x) (x).rbegin(),(x).rend()
#define ins insert
#define pb push_back
#define fst first
#define snd second
///#define mp make_pair

template< class T>
using ordered_set = tree<T,null_type,less<T>,rb_tree_tag,tree_order_statistics_node_update>;
const ll N = 1e6 + 5;
const ll INF = 1e18 + 5;
struct node{
    ll hsh[2][2];
    bool lf,rg;
    ll cnt = 0;
    ll sz = 0;
}t[4 * N];
ll pw[N];
node merge(node a,node b){
    node ret;
    ret.lf = a.lf;
    ret.rg = b.rg;
    ret.cnt = a.cnt + b.cnt;
    ret.sz = a.sz + b.sz;
    if(a.rg && b.lf){
        ret.cnt += 2;
        ret.sz -= 2;
        for(ll i = 0;i < 2; ++i){
            for(ll j = 0;j < 2; ++j){
                ret.hsh[i][j] = a.hsh[i][1] + b.hsh[1][j] * pw[a.sz - 1];
            }
        }
    }else{
        for(ll i = 0;i < 2; ++i){
            for(ll j = 0;j < 2; ++j){
                ret.hsh[i][j] = a.hsh[i][0] + b.hsh[0][j] * pw[a.sz];
            }
        }
    }
    return ret;
}
string s;
void build(ll v,ll l,ll r){
    if(l == r){
        t[v].cnt = 0;
        t[v].sz = 1;
        t[v].lf = t[v].rg = (s[l] == '1');
        ll x;
        if(s[l] == '0')x = 7;else x = 17;
        t[v].hsh[0][0] = x;
        t[v].hsh[0][1] = 0;
        t[v].hsh[1][0] = 0;
        t[v].hsh[1][1] = 0;
        return;
    }
    ll m = (l + r) >> 1;
    build(2 * v,l,m);
    build(2 * v + 1,m + 1,r);
    t[v] = merge(t[2 * v],t[2 * v + 1]);
}
node get(ll v,ll tl,ll tr,ll l,ll r){
    if(l <= tl && tr <= r){
        return t[v];
    }
    ll tm = (tl + tr) >> 1;
    if(r <= tm)return get(2 * v,tl,tm,l,r);
    if(l > tm)return get(2 * v + 1,tm + 1,tr,l,r);
    return merge(get(2 * v,tl,tm,l,r),get(2 * v + 1,tm + 1,tr,l,r));
}
main(){
    ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
    pw[0] = 1;
    for(ll i = 1;i < N; ++i){
        pw[i] = pw[i - 1] * 37;
    }
    ll n;
    cin >> n;
    cin >> s;
    build(1,0,n - 1);
    ll q;
    cin >> q;
    for(ll i = 0;i < q; ++i){
        ll l1,l2,len;
        cin >> l1 >> l2 >> len;
        node x = get(1,0,n - 1,l1,l1 + len - 1);
        node y = get(1,0,n - 1,l2,l2 + len - 1);
        bool eq = true;
        if(x.cnt != y.cnt)eq = false;
        if(x.sz != y.sz)eq = false;
        if(x.lf != y.lf)eq = false;
        if(x.rg != y.rg)eq = false;
        if(x.hsh[0][0] != y.hsh[0][0])eq = false;
        if(eq){
            cout << "Yes\n";
        }else{
            cout << "No\n";
        }
    }
    return 0;
}
