#include <bits/stdc++.h>
#define F first
#define S second
#define ALL(x) (x).begin(),(x).end()
#define RALL(x) (x).rbegin(),(x).rend()
#define pb push_back
#define eb emplace_back

using namespace std;

using ll = long long;
using ld = long double;

const int INF = 1e9, N = 5e5+5;
const ld PI = acosl(-1), eps = 1e-8;
const bool debug = 0;

mt19937 rnd(time(0));

int n, m, a, b, d[N], k, path[N];
int64_t pk[N], Min, Max;
vector<int> g[N];

inline void read(){
    cin >> n >> m;
    for(int i = 0; i < m; ++i){
        cin >> a >> b;
        g[b].pb(a);
    }
    cin >> k;
    for(int i = 0; i < k; ++i){
        cin >> path[i];
    }
}

inline void bfs(int start){
    queue<int> q;
    d[start] = 1;
    pk[start] = 1;
    q.push(start);
    while(!q.empty()){
        int v = q.front();
        q.pop();
        for(int to: g[v]){
            if(!d[to]||d[to] == d[v]+1) ++pk[to];
            if(!d[to]) d[to] = d[v]+1, q.push(to);
        }
    }
}

inline void solve(){
    bfs(path[k-1]);
    /*for(int i = 1; i <= n; ++i){
        cout << d[i] << " " << pk[i] << endl;
    }
    cout << endl;*/
    for(int i = 0; i < k-1; ++i){
        a = path[i]; b = path[i+1];
        if(pk[a]==1 && d[b]==d[a]-1){
            continue;
        }
        if(pk[a]==1){
            ++Max; ++Min;
        }
        if(pk[a]>1 && d[b]==d[a]-1){
            ++Max;
        }
        if(pk[a]>1 && d[b]!=d[a]-1){
            ++Max; ++Min;
        }
    }
}

inline void print(){
    cout << Min << " " << Max;
}

int main(){
    if(debug){
        freopen("input.txt","r",stdin);
        freopen("output.txt","w",stdout);
    }
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    read();
    solve();
    print();


    return 0;
}
