#include <bits/stdc++.h>

#define len(a) (int)(a.size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define endl '\n'
#define dbg(a) cout << #a << ' ' << a << '\n'

using namespace std;
typedef long long ll;
typedef long double ld;

const int MAX = (int)(2e5) + 7;
const int INF_INT = (int)(1e9) + 7;
const int MOD = (int)(1e9) + 7;
const ll INF_LL = (ll)(1e18) + 7;

void solve();
void boot_up() {
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // LOCAL
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios::sync_with_stdio(false);
}

template<typename T> inline void info(T & v) { for (const auto & it : v) { cout << it << ' '; } cout << endl; }

template<typename T1, typename T2> inline bool chkmin(T1 & a, T2 & b) { if (a > b) { a = b; return true; } return false; }

template<typename T1, typename T2> inline bool chkmax(T1 & a, T2 & b) { if (a < b) { a = b; return true; } return false; }

template<typename T> inline void init(vector<T> & v, size_t _size, T value = 0) { v.assign(_size, value); }



int n;
vector<int> r, b;

signed main() {
    boot_up();

    while (cin >> n) {
        solve();
    }
}

void solve() {

    init(r, n);
    for (auto & it : r) {
        cin >> it;
    }

    init(b, n);
    for (auto & it : b) {
        cin >> it;
    }

    int good = 0, bad = 0;
    for (int i = 0; i < n; ++i) {
        if (r[i] && !b[i]) {
            ++good;
        }

        if (!r[i] && b[i]) {
            ++bad;
        }
    }

    if (!good) {
        cout << -1 << endl;
    }
    else {
        if (good == bad) {
            cout << 2 << endl;
        }
        else if (good > bad) {
            cout << 1 << endl;
        }
        else {
            int k = (bad + good - 1) / good;

            if (k * good <= bad) {
                cout << k + 1 << endl;
            }
            else {
                cout << k << endl;
            }
        }
    }
}
