#include <bits/stdc++.h>

#define len(a) (int)(a.size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define endl '\n'
#define dbg(a) cout << #a << ' ' << a << '\n'

using namespace std;
typedef long long ll;
typedef long double ld;

const int MAX = (int)(2e5) + 7;
const int INF_INT = (int)(1e9) + 7;
const int MOD = (int)(1e9) + 7;
const ll INF_LL = (ll)(1e18) + 7;

void solve();
void boot_up() {
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // LOCAL
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios::sync_with_stdio(false);
}

template<typename T> inline void info(T & v) { for (const auto & it : v) { cout << it << ' '; } cout << endl; }

template<typename T1, typename T2> inline bool chkmin(T1 & a, T2 & b) { if (a > b) { a = b; return true; } return false; }

template<typename T1, typename T2> inline bool chkmax(T1 & a, T2 & b) { if (a < b) { a = b; return true; } return false; }

template<typename T> inline void init(vector<T> & v, size_t _size, T value = 0) { v.assign(_size, value); }



int n;

signed main() {
    boot_up();

    while (cin >> n) {
        solve();
    }
}

void solve() {
    map<ll, ll> func;
    ll mx = -INF_LL;
    for (int i = 1; i <= n; ++i) {
        ll x;
        cin >> x;

        func[x - i] += x;

        chkmax(mx, func[x - i]);
    }

    cout << mx << endl;
}
