#include <bits/stdc++.h>
#include <ctime>

typedef long long ll;
typedef long double ld;

using namespace std;

const ll INF = 1e9 + 7;
const long double EPS = 1e-5;
const long double PI = atan2(0, -1);

void fast() {
    ios::sync_with_stdio(0);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

istream& operator >> (istream& cin, vector<ll>& m1) {
    for (auto& el : m1) {
        cin >> el;
    }
    return cin;
}


signed main() {
    fast();

    ll n;
    cin >> n;
    vector<ll> m1(n);
    vector<ll> m2;
    cin >> m1;
    m2 = m1;
    for (ll i = 0; i < n; i++) {
        m2[i] = i + 1 - m2[i];
    }
    map<ll, ll> cur;
    ll ans = *max_element(m1.begin(), m1.end());

    for (ll i = 0; i < n; i++) {
        ll ch = m2[i];
        ll res = -INF;
        if (cur.count(ch)) {
            res = max(res, cur[ch] + m1[i]);
        }
        else {
            res = max(res, m1[i]);
        }
        if (cur.count(ch)) {
            cur[ch] = max(cur[ch], res);
        }
        else {
            cur[ch] = res;
        }
        ans = max(ans, res);
    }
    cout << ans;
    return 0;
}
