#include <bits/stdc++.h>
#define F first
#define S second
#define pb push_back

using namespace std;
using ll = long long;
using ld = long double;

vector<vector<int>> gt;
vector<int> d, cnt;
int n, m;

void Dijkstra(int s){
    set<pair<int, int>> st;
    d[s] = 0;
    cnt[s] = 1;
    st.insert({0, s});
    while(!st.empty()){
        int v = st.begin() -> S;
        st.erase(st.begin());
        for(auto u:gt[v]){
            if(d[u] == d[v] + 1)cnt[u] += cnt[v];
            if(d[u] > d[v] + 1){
                st.erase({d[u], u});
                d[u] = d[v] + 1;
                cnt[u] = cnt[v];
                st.insert({d[u], u});
            }
        }
    }
    //for(auto x:d)cout << x << " ";cout << endl;
    //for(auto x:cnt)cout << x << " ";cout << endl;
}

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0);
    cin >> n >> m;
    gt.resize(n + 1);
    cnt.resize(n + 1);
    d.assign(n + 1, 1e9);
    for(int i = 0; i < m; ++i){
        int u, v; cin >> u >> v;
        gt[v].pb(u);
    }
    int p; cin >> p;
    vector<int> a(p);
    for(auto &x:a)cin >> x;
    Dijkstra(a.back());
    int ansmin = 0, ansmax = 0;
    for(int i = 0; i < p - 1; ++i){
        if(p - i - 1 > d[a[i]]){
            ansmin++;
            ansmax++;
            continue;
        }
        if(p - i - 1 == d[a[i]] && cnt[a[i]] > 1 || (i && p - i - 2 == d[a[i - 1]] && cnt[a[i - 1]] > 1)){
            //if(i && p - i - 2 == d[a[i - 1]])continue;
            ansmax++;
        }
    }
    cout << ansmin << " " << ansmax;
    return 0;
}
/*
6 6
1 2
2 3
3 4
3 5
5 6
4 6
5
1 2 3 5 6
*/
