#include <bits/stdc++.h>
#define int long long
/*
#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("no-stack-protector")
#pragma GCC target("avx,avx2,sse,sse2,sse3,sse4")
*/
using namespace std;

void fast() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

const int maxn = 1000006;
pair <int, int> mas[maxn];
pair <int, int> br[maxn];
int inf = (int)(2e18);

struct der {
    int a, b, c;
};

der mon[maxn];

bool cmp(der a, der b) {
    return a.b < b.b;
}

int tree[4 * maxn];
int ad[4 * maxn];

void push(int v) {
    tree[v * 2] += ad[v];
    tree[v * 2 + 1] += ad[v];
    ad[v * 2] += ad[v];
    ad[v * 2 + 1] += ad[v];
    ad[v] = 0;
}

void add(int l, int r, int tl, int tr, int v, int val) {
    if (l == tl && r == tr) {
        tree[v] += val;
        ad[v] += val;
    } else {
        int m = (r + l) / 2;
        push(v);
        if (tr <= m) {
            add(l, m, tl, tr, v * 2, val);
        } else if (tl > m) {
            add(m + 1, r, tl, tr, v * 2 + 1, val);
        } else {
            add(l, m, tl, m, v * 2, val);
            add(m + 1, r, m + 1, tr, v * 2 + 1, val);
        }
        tree[v] = max(tree[v * 2], tree[v * 2 + 1]);
    }
}

void fun(int l, int r, int v, int pos, int val) {
    if (l == r) {
        tree[v] = max(tree[v], val);
    } else {
        int m = (r + l) / 2;
        if (pos <= m) {
            fun(l, m, v * 2, pos, val);
        } else {
            fun(m + 1, r, v * 2 + 1, pos, val);
        }
        tree[v] = max(tree[v * 2], tree[v * 2 + 1]);
    }
}

signed main() {
    fast();
    int n, m, p, i, j, a, b, c, k;
    cin >> n >> m >> p;
    int mx = 1000002;
    for (i = 0; i < n; i++) {
        cin >> a >> b;
        mas[i] = {a, b};
    }
    for (i = 0; i < m; i++) {
        cin >> a >> b;
        br[i] = {a, b};
    }
    sort(br, br + m);
    for (i = 0; i < p; i++) {
        cin >> a >> b >> c;
        mon[i] = {a, b, c};
    }
    sort(mon, mon + p, cmp);
    j = 0;
    for (i = 0; i < 4 * maxn; i++) {
        tree[i] = -inf;
    }
    for (i = 0; i < n; i++) {
        fun(1, mx, 1, mas[i].first, -mas[i].second);
    }
    int ans = -inf;
    for (i = 0; i < m; i++) {
        while (j < p && mon[j].b < br[i].first) {
            add(1, mx, mon[j].a + 1, mx, 1, mon[j].c);
            j++;
        }
        ans = max(ans, tree[1] - br[i].second);
    }
    cout << ans;
    return 0;
}
