#include<bits/stdc++.h>

using namespace std;

#define int long long

const int INF = 1e18 + 239;
const int N = 1e6 + 7;

namespace ST {
    int t[4 * N + 10];
    int mod[4 * N + 10];

    void apply(int v, int x) {
        t[v] += x;
        mod[v] += x;
    }

    void push(int v) {
        if (mod[v]) {
            apply(2 * v + 1, mod[v]);
            apply(2 * v + 2, mod[v]);
            mod[v] = 0;
        }    
    }

    void pull(int v) {
        t[v] = max(t[2 * v + 1], t[2 * v + 2]);
    }

    void add(int v, int l, int r, int ql, int qr, int x) {
        if (r <= ql || qr <= l) {
            return;
        } else if (ql <= l && r <= qr) {
            apply(v, x);
        } else {
            assert(r - l > 1);
            push(v);
            int m = (r + l) >> 1;
            add(2 * v + 1, l, m, ql, qr, x);
            add(2 * v + 2, m, r, ql, qr, x);
            pull(v);
        }    
    }

    void add(int l, int r, int x) {
        add(0, 0, N, l, r, x);
    }

    int mx() {
        return t[0];
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    
    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    #endif

    int n, m, p;
    cin >> n >> m >> p;
    vector<pair<int, int>> a(n);
    for (auto &t : a) cin >> t.first >> t.second;
    sort(a.begin(), a.end());
    vector<pair<int, int>> b(m);
    for (auto &t : b) cin >> t.first >> t.second;
    {
           map<int, int> rc;
           for (auto t : b) {
                if (rc.count(t.first)) {
                    rc[t.first] = min(rc[t.first], t.second);
                } else {
                    rc[t.first] = t.second;
                }
           }
           vector<pair<int, int>> v;
           for (auto t : rc) {
                v.push_back(t);
           }
           reverse(v.begin(), v.end());
           int mn = INF;
           b.clear();
           for (auto t : v) {
                if (mn > t.second) {
                    b.push_back(t);
                    mn = t.second;
                }
           }
           reverse(b.begin(), b.end());
    }    
    {
        int to = b.back().first;
        ST::add(to + 1, N, -INF);
        for (int i = (int)b.size() - 2; i >= 0; i--) {
            ST::add(b[i].first + 1, b[i + 1].first + 1, -b[i + 1].second);
        }
        ST::add(0, b[0].first + 1, -b[0].second);
        //for (int i = 0; i < N)
    }
    vector<tuple<int, int, int>> mn(p);
    for (int i = 0; i < p; i++) {
        int x, y, c;
        cin >> x >> y >> c;
        mn[i] = make_tuple(x, y, c);
    }
    sort(mn.begin(), mn.end());
    int pnt = -1;
    int ans = -INF;
    for (auto t : a) {
        int x = t.first;
        int cost = t.second;
        while (pnt + 1 < p && get<0>(mn[pnt + 1]) < x) {
            ST::add(get<1>(mn[pnt + 1]) + 1, N, get<2>(mn[pnt + 1]));
            pnt++;
        }
        ans = max(ans, ST::mx() - cost);
    }
    cout << ans << endl;
    //ST::add(0, 3, 1);
}
