#include <bits/stdc++.h>

using namespace std;

#define int long long

vector<int> z_func(string s)
{
    int n = s.size();
    vector<int> pi(n);
    for (int i = 1, l = 0, r = 0; i < n; ++i)
    {
        cout << r << endl;
        if (i <= r)
        {
            pi[i] = min(r - i + 1, pi[i - l]);
        }
        while (i + pi[i] < n && s[i + pi[i]] == s[pi[i]])
        {
            pi[i]++;
        }
        if (i + pi[i] > r)
        {
            r = i + pi[i] - 1;
            l = i;
        }
    }
    return pi;
}

signed main()
{
    int n, m;
    cin >> n >> m;
    vector<vector<int> > graph(n);
    vector<vector<int> > graph2(n);
    for (int i = 0; i < m; ++i)
    {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        graph[y].push_back(x);
        graph2[x].push_back(y);
    }
    int k;
    cin >> k;
    vector<int> path(k);
    for (int i = 0; i < k; ++i)
    {
        cin >> path[i];
        path[i]--;
    }
    int t = path[k - 1];
    vector<int> d(n, 1e9);
    set<pair<int, int> > dj;
    d[t] = 0;
    for (int i = 0; i < graph[t].size(); ++i)
    {
        int to = graph[t][i];
        d[to] = 1;
        dj.insert({1, to});
    }
    while (!dj.empty())
    {
        int v = (*(dj.begin())).second;
        dj.erase(dj.begin());
        for (int i = 0; i < graph[v].size(); ++i)
        {
            if (d[v] + 1 < d[graph[v][i]])
            {
                dj.erase({d[graph[v][i]], graph[v][i]});
                dj.insert({d[v] + 1, graph[v][i]});
                d[graph[v][i]] = d[v] + 1;
            }
        }
    }
    int cnt1 = 0;
    int cnt2 = 0;
    for (int i = 0; i < k - 1; ++i)
    {
        int v = path[i];
        int cnt4 = 0;
        for (int j = 0; j < graph2[v].size(); ++j)
        {
            int to = graph2[v][j];
            if (d[to] == d[v] - 1)
            {
                //cout << v << ' ' << to << ' ' << cnt4 << endl;
                cnt4++;
            }
        }
        if (d[path[i + 1]] != d[v] - 1)
        {
            cnt1++;
            cnt2++;
        }
        else
        {
            if (cnt4 > 1)
            {
                cnt2++;
            }
        }
    }
    cout << cnt1 << ' ' << cnt2;
}
