#include <bits/stdc++.h>

using namespace std;

const int INF = INT_MAX / 2;

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.tie(nullptr);
  int n, m;
  cin >> n >> m;
  vector<vector<int>> graph(n);
  vector<vector<int>> rgraph(n);
  for (int i = 0; i < m; i++) {
    int v, u;
    cin >> v >> u;
    v--;
    u--;
    graph[v].emplace_back(u);
    rgraph[u].emplace_back(v);
  }
  int k;
  cin >> k;
  vector<int> path(k);
  for (auto &e : path) {
    cin >> e;
    e--;
  }
  int s = path[0];
  int f = path.back();
  vector<int> dist(n, INF);
  vector<int> cnt(n, 0);
  dist[f] = 0;
  cnt[f] = 0;
  set<pair<int, int>> q;
  q.emplace(0, f);
  while (!q.empty()) {
    auto v = q.begin()->second;
    q.erase(q.begin());
    for (auto u : rgraph[v]) {
      if (dist[u] > dist[v] + 1) {
        dist[u] = dist[v] + 1;
        cnt[u] = 0;
        q.emplace(dist[u], u);
      } else if (dist[u] == dist[v] + 1 && cnt[u] == 0) {
        cnt[u] ++;
        q.emplace(dist[u], u);
      }
    }
  }
  int ans_mn = 0;
  int ans_mx = 0;
  for (int i = 0; i < k - 1; i++) {
    if (dist[path[i]] < (k - i - 1) || (dist[path[i]] == (k - i - 1) && cnt[path[i]] > 0))
      ans_mx++;
  }
  for (int i = 0; i < k - 1; i++) {
    if (dist[path[i]] != dist[path[i + 1]] + 1)
      ans_mn++;
  }
  assert(ans_mn <= ans_mx);
  cout << ans_mn << ' ' << ans_mx;
  return 0;
}