#include <iostream>
#include <vector>
#include <queue>
#include <set>
#define pb push_back
#define F first
#define S second
using namespace std;

vector < vector <int> > g;
vector <int> d, cc, v1;
vector <bool> w;
int n;

void dj(int vv){
	queue <int> q;
	cc.resize(n, 0);
	d.resize(n, 0);
	w.resize(n, false);

	q.push(vv);
	w[vv] = true;
	d[vv] = 1;
	while(!q.empty()){
		int v = q.front();
		for(int i = 0; i < g[v].size(); ++i){
			if(!w[g[v][i]]){
				int rr = g[v][i];
				q.push(rr);
				w[rr] = true;
				d[rr] = d[v] + 1;
			}else{
				int rr = g[v][i];
				if(d[rr] > d[v] + 1){
					d[rr] = d[v] + 1;
					cc[rr] = 0;
				}else if(d[v] + 1 == d[rr]){
					cc[rr]++;
				}
			}
		}
		q.pop();
	}
}


int main(){
	cin.tie(0);
	ios_base::sync_with_stdio(false);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);	freopen("output.txt", "w", stdout);
#endif
	#pragma warning (disable:4996);
	
	int m, a, b, k;
	cin >> n >> m;
	g.resize(n);
	for(int i = 0; i < m; i++){
		cin >> a >> b; a--; b--;
		g[b].pb(a);
	}
	
	cin >> k;
	v1.resize(k);
	for(int i = 0; i < k; ++i){
		cin >> v1[i]; v1[i]--;
	}
	dj(v1[k - 1]);

	for(int i = 0; i < n; ++i)
		cout << d[i] << " ";
	cout << endl;
	for(int i = 0; i < n; ++i)
		cout << cc[i] << " ";
	cout << endl;

	int h1 = 0, h2 = 0, prev = 0;
	for(int i = 1; i < k; ++i){
		if(d[v1[i - 1]] != k - i + 1){
			h1++;
		}else{
			if(cc[v1[i - 1]])
				h2++;

		}
	}
	cout << h1 << " " << h2 + h1;
	return 0;
}