#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <functional>
#include <tuple>
#include <numeric>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef tree<ll, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> os_tree;

int main() {
    ll n;
    cin >> n;
    vector<ll> r(n), b(n);
    for (ll i = 0; i < n; i++) {
        cin >> r[i];
    }
    for (ll i = 0; i < n; i++) {
        cin >> b[i];
    }
    ll f = 0;
    for (ll i = 0; i < n; i++) {
        if (r[i] > b[i]) {
            f++;
        }
    }
    if (f == 0) {
        cout << -1 << endl;
        return 0;
    }
    ll x = accumulate(r.begin(), r.end(), (ll) 0), y = accumulate(b.begin(), b.end(), (ll) 0);
    cout << 1 + (max(y - x + 1, (ll) 0) + f - 1) / f << endl;
    return 0;
}
