#include <queue>
#include <cstring>
#include <iostream>
using namespace std;

vector < long long > nqraf[200021], qraf[200021];
long long p[200021], w[200021];
queue < long long > Q;

int main() 
{
            memset(w, 63, sizeof(w));
            memset(p, 0, sizeof(p));
            
                long long n, m; cin >> n >> m;
                
                for(int i = 0; i < m; i++) 
                {
                        long long a, b; cin >> a >> b;
                        
                        qraf[a].push_back(b);
                        nqraf[b].push_back(a);
                }
                
                long long k; cin >> k;
                
                for(int i = 0 ; i < k ; i++) 
                {
                    cin >> p[i];
                }
                    
                    
                long long t = p[k - 1];
                
                Q.push(t);
                
                w[t] = 0;
                
	while(!Q.empty()) 
	{
                long long u = Q.front();
                
                Q.pop();
                
                for(int i = 0; i < nqraf[u].size(); i++)
                {
                        long long o = nqraf[u][i];
                        
                        if(w[o] > w[u] + 1) 
                        {
                                w[o] = w[u] + 1;
                                
                                Q.push(o);
                        }
                }
        }
	
	long long res = 0, ans = 0;
	
	for(int i = 0; i < k - 1; i++) 
	{
                long long x = p[i], z = p[i + 1], t = -1;
                
                if(w[z] >= w[x])
                {
                    res += 1; ans += 1;
                }
                
                if(w[z] < w[x])
                {
                        for(int i = 0; i < qraf[x].size(); ++i)
                        {
                                long long o = qraf[x][i];
                                
                                if(w[o] == w[z]) 
                                {
                                        t += 1;
                                }
                        }
                        
                        ans += min((long long)1, t);
                }
        }
	
	cout << res << " " <<  ans << endl;
}