#include <bits/stdc++.h>
#define ll long long
#define db long double
#define pb push_back
#define ppb pop_back
#define fi first
#define se second
#define mp make_pair
#define all(x) (x).begin(), (x).end()
//#define cerr if(false)cerr
using namespace std;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

const int N = 2e5 + 123;
int n, m, k, p[N], dist[N], used[N];
vector <int> q[N], r[N];

void bfs() {
    queue <int> qu;
    qu.push(p[k]);
    used[p[k]] = 1;
    while (!qu.empty()) {
        int v = qu.front();
        qu.pop();
        for (auto to : r[v]) {
            if (!used[to]) {
                used[to] = 1;
                dist[to] = dist[v] + 1;
                qu.push(to);
            }
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false), cin.tie(NULL);
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
    #endif

    cin >> n >> m;
    int x, y;
    for (int i = 1; i <= m; i++) {
        cin >> x >> y;
        q[x].pb(y);
        r[y].pb(x);
    }
    cin >> k;
    for (int i = 1; i <= k; i++) {
        cin >> p[i];
    }
    bfs();
    int mn = 0, mx = 0;
    for (int i = 1; i < k; i++) {
        if (dist[p[i]] != dist[p[i + 1]] + 1) {
            mn++;
        }
        for (auto to : q[p[i]]) {
            if (to == p[i + 1]) {
                continue;
            }
            if (dist[to] <= dist[p[i + 1]]) {
                mx++;
                break;
            }
        }
    }
    cout << mn << ' ' << mx;
}
