#include <bits/stdc++.h>
#define ll long long
#define db long double
#define pb push_back
#define ppb pop_back
#define fi first
#define se second
#define mp make_pair
#define all(x) (x).begin(), (x).end()
#define cerr if(false)cerr
using namespace std;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

const int N = 2e5 + 123, inf = 1e9, K = 4e5 + 123;
int n, m, p, a[N], ca[N], b[N], cb[N], cost[K];
int x[N], y[N], z[N];

int A, B;

struct ev {
    int tp = 0, x = 0, y = 0, z = 0;
    bool operator < (const ev & e) const {
        if (x == e.x) {
            return tp < e.tp;
        }
        return x < e.x;
    }
};

struct node {
    int l = 0, r = 0, mx = 0, lazy = 0;
    void upd(int val) {
        mx += val;
        lazy += val;
    }
};

node t[(1 << 20) + 1];

void push(int v) {
    if (t[v].lazy) {
        t[v << 1].upd(t[v].lazy);
        t[v << 1 | 1].upd(t[v].lazy);
        t[v].lazy = 0;
    }
}

void build(int v, int tl, int tr) {
    t[v].l = tl, t[v].r = tr;
    if (tl == tr) {
        if (cost[tl] == 0) {
            t[v].mx = -inf;
        }   else {
            t[v].mx = -cost[tl];
        }
        return;
    }
    int tm = tl + tr >> 1;
    build(v << 1, tl, tm);
    build(v << 1 | 1, tm + 1, tr);
    t[v].mx = max(t[v << 1].mx, t[v << 1 | 1].mx);
}

void update(int v, int l, int r, int val) {
    if (t[v].l > r || t[v].r < l) {
        return;
    }
    if (t[v].l >= l && t[v].r <= r) {
        t[v].upd(val);
        return;
    }
    push(v);
    update(v << 1, l, r, val);
    update(v << 1 | 1, l, r, val);
    t[v].mx = max(t[v << 1].mx, t[v << 1 | 1].mx);
}

int getmax(int v, int l, int r) {
    if (t[v].l > r || t[v].r < l) {
        return -inf;
    }
    if (t[v].l >= l && t[v].r <= r) {
        return t[v].mx;
    }
    push(v);
    return max(getmax(v << 1, l, r), getmax(v << 1 | 1, l, r));
}

int main() {
    ios_base::sync_with_stdio(false), cin.tie(NULL);
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
    #endif

    cin >> n >> m >> p;
    vector <int> vec1, vec2;
    for (int i = 1; i <= n; i++) {
        cin >> a[i] >> ca[i];
        vec1.pb(-a[i]);
    }
    for (int i = 1; i <= m; i++) {
        cin >> b[i] >> cb[i];
        vec2.pb(-b[i]);
    }
    for (int i = 1; i <= p; i++) {
        cin >> x[i] >> y[i] >> z[i];
        vec1.pb(-x[i]);
        vec2.pb(-y[i]);
    }
    sort(all(vec1));
    vec1.erase(unique(all(vec1)), vec1.end());
    sort(all(vec2));
    vec2.erase(unique(all(vec2)), vec2.end());

    vector <ev> vec;
    ev tmp;
    tmp.tp = 1;
    A = vec1.size(), B = vec2.size();
    for (int i = 1; i <= n; i++) {
        a[i] = lower_bound(all(vec1), -a[i]) - vec1.begin() + 1;
        tmp.x = a[i], tmp.y = ca[i];
        vec.pb(tmp);

        cerr << a[i] << ' ' << ca[i] << '\n';
    }
    cerr << '\n';
    for (int i = 1; i <= m; i++) {
        b[i] = lower_bound(all(vec2), -b[i]) - vec2.begin() + 1;
        cost[b[i]] = cb[i];

        cerr << b[i] << ' ' << cb[i] << '\n';
    }
    cerr << '\n';
    tmp.tp = 0;
    build(1, 1, B);
    for (int i = 1; i <= p; i++) {
        x[i] = lower_bound(all(vec1), -x[i]) - vec1.begin() + 1;
        y[i] = lower_bound(all(vec2), -y[i]) - vec2.begin() + 1;
        tmp.x = x[i], tmp.y = y[i] - 1, tmp.z = z[i];
        cerr << x[i] << ' ' << y[i] << ' ' << z[i] << '\n';
        update(1, 1, y[i] - 1, z[i]);
        vec.pb(tmp);
        cerr << "update " << y[i] - 1 << ' ' << z[i] << '\n';
    }
    sort(all(vec));
    int ans = -inf;
    for (auto i : vec) {
        for (int j = 1; j <= B; j++) {
            cerr << getmax(1, j, j) << ' ';
        }
        cerr << '\n';

        if (i.tp == 0) {
            cerr << 0 << ' ' << i.y << ' ' << -i.z << '\n';
            update(1, 1, i.y, -i.z);
        }   else {
            cerr << 1 << ' ' << i.x << ' ' << i.y << '\n';
            ans = max(ans, getmax(1, 1, B) - i.y);
        }
    }
    cout << ans;
}
