#include <bits/stdc++.h>
#define ll long long
#define db long double
#define pb push_back
#define ppb pop_back
#define fi first
#define se second
#define mp make_pair
#define all(x) (x).begin(), (x).end()
//#define cerr if(false)cerr
using namespace std;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
typedef pair <int, int> pii;

const int N = 2e5 + 123;
pii MOD = mp((int)1e9 + 7, (int)1e9 + 9);
pii pref_st[N], pref_fin[N];
int n, st[N], fin[N], pr[N], nxt[N], num[N];
string s;

int binpow(int x, int y, int mod) {
    int res = 1;
    while (y > 0) {
        if (y & 1) {
            res = (ll)res * x % mod;
        }
        x = (ll)x * x % mod;
        y /= 2;
    }
    return res;
}

int main() {
    ios_base::sync_with_stdio(false), cin.tie(NULL);
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
    #endif

    cin >> n >> s;
    int cur = 0;
    for (int i = 1; i <= n; i++) {
        if (s[i - 1] == '0') {
            if (cur > 0) {
                if (cur & 1) {
                    fin[i] = 1;
                    st[i - cur + 1] = 1;
                }
                cur = 0;
            }
        }   else {
            cur++;
        }
    }
    if (cur > 0) {
        if (cur & 1) {
            fin[n] = 1;
            st[n - cur + 1] = 1;
        }
    }
    int last = -1;
    for (int i = n; i >= 1; i--) {
        if (s[i - 1] == '0') {
            last = i;
        }
        nxt[i] = last;
    }
    last = -1;
    for (int i = 1; i <= n; i++) {
        if (s[i - 1] == '0') {
            last = i;
        }
        pr[i] = last;
    }
    for (int i = 1; i <= n; i++) {
        pref_st[i].fi = (pref_st[i - 1].fi + (st[i] == 1) * binpow(31, i, MOD.fi)) % MOD.fi;
        pref_st[i].se = (pref_st[i - 1].se + (st[i] == 1) * binpow(31, i, MOD.se)) % MOD.se;

        pref_fin[i].fi = (pref_fin[i - 1].fi + (fin[i] == 1) * binpow(31, i, MOD.fi)) % MOD.fi;
        pref_fin[i].se = (pref_fin[i - 1].se + (fin[i] == 1) * binpow(31, i, MOD.se)) % MOD.se;
        num[i] = num[i - 1] + (s[i - 1] == '1');
    }

    int q;
    cin >> q;
    int l, l2, x;
    for (int i = 0; i < q; i++) {
        cin >> l >> l2 >> x;
        if (num[l + x - 1] - num[l - 1] != num[l2 + x - 1] - num[l2 - 1]) {
            cout << "No\n";
            continue;
        }

        pii tmp_st1, tmp_st2, tmp_fin1, tmp_fin2;
        tmp_st1.fi = (pref_st[l + x - 1].fi - pref_st[l - 1].fi + MOD.fi) % MOD.fi;
        tmp_st1.se = (pref_st[l + x - 1].se - pref_st[l - 1].se + MOD.se) % MOD.se;

        tmp_fin1.fi = (pref_fin[l + x - 1].fi - pref_fin[l - 1].fi + MOD.fi) % MOD.fi;
        tmp_fin1.se = (pref_fin[l + x - 1].se - pref_fin[l - 1].se + MOD.se) % MOD.se;

        tmp_st2.fi = (pref_st[l2 + x - 1].fi - pref_st[l2 - 1].fi + MOD.fi) % MOD.fi;
        tmp_st2.se = (pref_st[l2 + x - 1].se - pref_st[l2 - 1].se + MOD.se) % MOD.se;

        tmp_fin2.fi = (pref_fin[l2 + x - 1].fi - pref_fin[l2 - 1].fi + MOD.fi) % MOD.fi;
        tmp_fin2.se = (pref_fin[l2 + x - 1].se - pref_fin[l2 - 1].se + MOD.se) % MOD.se;

        int dif = l2 - l;
        if (nxt[l] != -1 && (nxt[l] - l) & 1) {
            tmp_fin1.fi = (tmp_fin1.fi + binpow(31, nxt[l] - 1, MOD.fi)) % MOD.fi;
            tmp_fin1.se = (tmp_fin1.se + binpow(31, nxt[l] - 1, MOD.se)) % MOD.se;
            tmp_st1.fi = (tmp_st1.fi + binpow(31, l, MOD.fi)) % MOD.fi;
            tmp_st1.se = (tmp_st1.se + binpow(31, l, MOD.se)) % MOD.se;
        }
        if (pr[l + x - 1] != -1 && (l + x - 1 - pr[l + x - 1]) & 1) {
            tmp_fin1.fi = (tmp_fin1.fi + binpow(31, l + x - 1, MOD.fi)) % MOD.fi;
            tmp_fin1.se = (tmp_fin1.se + binpow(31, l + x - 1, MOD.se)) % MOD.se;
            tmp_st1.fi = (tmp_st1.fi + binpow(31, pr[l + x - 1], MOD.fi)) % MOD.fi;
            tmp_st1.se = (tmp_st1.se + binpow(31, pr[l + x - 1], MOD.se)) % MOD.se;
        }
        if (nxt[l2] != -1 && (nxt[l2] - l2) & 1) {
            tmp_fin2.fi = (tmp_fin2.fi + binpow(31, nxt[l2] - 1, MOD.fi)) % MOD.fi;
            tmp_fin2.se = (tmp_fin2.se + binpow(31, nxt[l2] - 1, MOD.se)) % MOD.se;
            tmp_st2.fi = (tmp_st2.fi + binpow(31, l2, MOD.fi)) % MOD.fi;
            tmp_st2.se = (tmp_st2.se + binpow(31, l2, MOD.se)) % MOD.se;
        }
        if (pr[l2 + x - 1] != -1 && (l2 + x - 1 - pr[l2 + x - 1]) & 1) {
            tmp_fin2.fi = (tmp_fin2.fi + binpow(31, l2 + x - 1, MOD.fi)) % MOD.fi;
            tmp_fin2.se = (tmp_fin2.se + binpow(31, l2 + x - 1, MOD.se)) % MOD.se;
            tmp_st2.fi = (tmp_st2.fi + binpow(31, pr[l2 + x - 1], MOD.fi)) % MOD.fi;
            tmp_st2.se = (tmp_st2.se + binpow(31, pr[l2 + x - 1], MOD.se)) % MOD.se;
        }
        bool A = ((ll)tmp_fin1.fi * binpow(31, dif, MOD.fi) % MOD.fi == tmp_fin2.fi) &&
                ((ll)tmp_fin1.se * binpow(31, dif, MOD.se) % MOD.se == tmp_fin2.se);
        bool B = ((ll)tmp_st1.fi * binpow(31, dif, MOD.fi) % MOD.fi == tmp_st2.fi) &&
                ((ll)tmp_st1.se * binpow(31, dif, MOD.se) % MOD.se == tmp_st2.se);
        if (A || B) {
            cout << "Yes\n";
        }   else {
            cout << "No\n";
        }
    }
}
