#pragma GCC target("avx2")
#pragma GCC optimize("O3")

#include <bits/stdc++.h>

#define int long long
#define S second 
#define F first
#define pb push_back
#define sz(x) (int)(x.size())
#define ll long long
#define all(x) x.begin(), x.end()
#define make make_pair

typedef unsigned long long ull;

using namespace std;

const int N = (int)1e6 + 222;
const int MOD = (int)1e9 + 7;
const ll INF = (ll)1e18;
    
int dp[N];
int n, m, l, r, p[N], k;
vector <int> g[N], g1[N];

void bfs (int s) {
	queue <int> q;
	q.push(s);
	for (int i = 1; i <= n; ++i) dp[i] = INF;
	dp[s] = 0;
	while (!q.empty()) {
		int x = q.front();
		q.pop();
		for (auto to : g1[x]) {
			if (dp[x] + 1 < dp[to]) {
				dp[to] = dp[x] + 1;
				q.push(to);
			}
		}
	}
}
    
inline void solve () {
	cin >> n >> m;
	for (int i = 1; i <= m; ++i) {
		cin >> l >> r;
		g[l].pb(r);
		g1[r].pb(l);
	}	    
	cin >> k;
	for (int i = 1; i <= k; ++i) cin >> p[i];
	bfs(p[k]);
	int mn = 0, mx = 0;
	for (int i = 1; i < k; ++i) {
		if (dp[p[i + 1]] + 1 != dp[p[i]]) mn ++;	
	   	for (auto to : g[p[i]]) {
	   		if (to == p[i + 1]) continue;
	   		if (dp[to] + 1 == dp[p[i]]) {
	   			mx ++;
	   			break;
	   		}
	   	}
	}
	cout << mn << " " << mx;
}

main () {
	#ifdef Maga
		freopen("input.in", "r", stdin);
	#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int t = 1;
	while (t --) {
		solve();
	}
	
	return 0;
}