#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

using namespace std;

const int N = 2e5 + 2;

int n, m, k;
vector< vector<int> > G(N), ok = G;
vector<int> p;
vector<int> dist(N, N);

void bfs(int from) {
    dist[from] = 0;
    queue<int> Q;
    Q.push(from);
    vector<bool> used(N, 0);
    used[from] = 1;
    while (!Q.empty()) {
        int v = Q.front();
        Q.pop();
        for (int i = 0; i < G[v].size(); ++i) {
            int u = G[v][i];
            if (!used[u]) {
                used[u] = 1;
                dist[u] = dist[v] + 1;
                Q.push(u);
            }
        }
    }
}

int main()
{   //freopen("in.txt", "r", stdin);
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int v, u;
        cin >> v >> u;
        --v, --u;
        G[u].push_back(v);
        ok[v].push_back(u);
    }
    cin >> k;
    for (int i = 0; i < k; ++i) {
        int v;
        cin >> v;
        --v;
        p.push_back(v);
    }
    bfs(p[k - 1]);
    int ans1 = 0, ans2 = 0;
    /*for (int i = 0; i < n; ++i)
        cout << dist[i] << " ";
    cout << endl;*/
    for (int i = 0; i < k - 1; ++i) {
        if (!(dist[p[i]] == dist[p[i + 1]] + 1)) {
            ++ans2, ++ans1;
        } else {
            //cout << i << " ";
            for (int j = 0; j < ok[p[i]].size(); ++j) {
                int u = ok[p[i]][j];
                if (u == p[i + 1])
                    continue;
                //cout << u << " " << p[i + 1] << endl;
                if (dist[u] == dist[p[i + 1]]) {
                    ++ans2;
                    break;
                }
            }
            //cout << endl << endl;
        }
    }
    cout << ans1 << " " << ans2;
    return 0;
}
