#include <bits/stdc++.h>

using namespace std;

typedef int ll;
typedef long double ld;

#define fori(i, n) for(ll i = 0; i < (n); ++i)
#define forI(i, n) for(ll i = 1; i <= (n); ++i)

#define pll pair<ll, ll>
#define ff first
#define ss second

#pragma GCC optimize(Ofast)
#pragma GCC optimize(fast-math)
#pragma GCC optimize(unroll-loops)
#pragma GCC target(sse,sse2,sse3,ssse3,sse4,abm,mmx,popcnt,tune=native)

struct Fenwick{
    vector<ll> t;

    Fenwick(ll n){
        t.resize(n);
    }

    void setv(ll i, ll val){
        for(; i < t.size(); i |= i + 1){
            t[i] += val;
        }
    }

    ll sum(ll r){
        ll res = 0;
        for(; r >= 0; r = (r & (r + 1)) - 1){
            res += t[r];
        }
        return res;
    }
};


ll n, m;

map<ll, ll> last, ans;

void solve(){
    cin >> n;
    ll l;
    fori(i, n){
        cin >> l;
        if(last.find(l - i) == last.end()){
            last[l - i] = l;
        }else last[l - i] += l;
    }
    ll ans = 0;
    for(pll p: last){
        ans = max(ans, p.ss);
    }
    cout << ans;
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    #define DEBUG0
    #ifdef DEBUG
        freopen("input.txt", "r", stdin);
    #endif

    solve();
}
