#include <iostream>
#include <math.h>
#include <cmath>
#include <set>
#include <map>
#include <algorithm>
#include <alg.h>
#include <vector>
#include <cstring>
#include <string.h>
#include <string>
using namespace std;
#define ll long long
#define pii pair<int, int>
#define m_p make_pair
#define pb push_back
#define all(x) x.begin(), x.end()
#define forn(from, to, i) for (int i = from; i < to; i++)
const int SZ = 200010;
const int INF = 1000000007;
const ll MOD = 1468622371;
ll p[SZ],f[SZ], ar[SZ],cnt[SZ], pr, a, b, res, res1, q, t, l, r, n, m, k, k1, k2, v, v1;
void init(int a) {
	p[a] = a;
}
int parent(int a) {
	if (p[a] == a) return a;
	return p[a] = parent(p[a]);
}
bool connect(int a, int b) {
	return parent(a) == parent(b);
}
void merge(int a, int b) {
	int p1 = parent(a), p2 = parent(b);
	if (p1 == p2) return;
	if (p1 > p2) p[p1] = p2;
	else p[p2] = p1;
}

ll query(int r) {
	ll su = 0;
	for (int i = r; i >= 0; i = (i & (i + 1)) - 1) {
		su += f[i];
	}
	return su;
}
ll query(int l, int r) {
	return query(r) - query(l - 1);
}
void inc(int ind, ll val) {
	for (int i = ind; i < n; i |= i + 1) {
		f[i] += val;
	}
}
void set_(int ind, ll val) {
	ll delt = val - f[ind];
	inc(ind, delt);
}

bool isprime(ll a) {
	for(int i = 2; i*i<=a;i++) {
		if (a % i == 0) return 0;
	}
	return 1;
}
ll dist[SZ];
set<ll> st;
string s;
bool fl;
vector<int> g[SZ], way;
int main() {
	cin.tie(0);cout.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	cin >> n >> m;
	forn(0, m, i) {
		cin >> v >> v1;
		v--;v1--;
		g[v1].pb(v);
	}
	cin >> k;
	forn(0, k, i) {
		cin >> ar[i];ar[i]--;
	}
	fill(dist, dist + n, INF);
	st.insert(ar[k-1]);
	dist[ar[k-1]] = 0;
	cnt[ar[k-1]] = 1;
	p[ar[k-1]] = -1;
	while(!st.empty()) {
		v = *st.begin();
		st.erase(st.begin());
		forn(0, g[v].size(), i) {
			int to = g[v][i];
			if (dist[to] > dist[v] + 1) {
				dist[to] = dist[v] + 1;
				p[to] = v;
				cnt[to] = 1;
				st.insert(to);
			}
			else if (dist[to] == dist[v] + 1) {
				cnt[to]++;
			}
		}
	}
	forn(0, k, i) {
		//cout << dist[ar[i]] << " " << ar[i] + 1 << endl;
		if (dist[ar[i]] == k - i - 1) {
			if (cnt[ar[i]] > 1) res1++;
		}
		else if (pr-1 != dist[ar[i]]) {
			res++;
			res1++;
		}
		pr = dist[ar[i]];
	}
	cout << res << " " << res1;
	return 0;
}
