#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <deque>
#define ll long long
#define ld long double

using namespace std;

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    vector<vector<int> > graph(n);
    vector<vector<int> > trans(n);
    for (int i = 0; i < m; i++){
        int u, v;
        cin >> u >> v;
        u--; v--;
        graph[u].push_back(v);
        trans[v].push_back(u);
    }
    int k;
    cin >> k;
    vector<int> p(k);
    for (int i = 0; i < k; i++){
        cin >> p[i];
        p[i]--;
    }
    int S = p[0];
    int T = p[k - 1];
    vector<int> dist(n);
    for (int i = 0; i < n; i++){
        dist[i] = n + 1;
    }
    dist[T] = 0;
    deque<int> d;
    d.push_back(T);
    while (d.size() > 0){
        int u = d[0];
        d.pop_front();
        for (int v : trans[u]){
            if (dist[v] == n + 1){
                dist[v] = dist[u] + 1;
                d.push_back(v);
            }
        }
    }
    vector<int> coun(n);
    for (int u = 0; u < n; u++){
        for (int v : graph[u]){
            if (dist[u] == dist[v] + 1)
                coun[u]++;
        }
    }
    int mn = 0;
    int mx = 0;
    for (int i = 0; i < k - 1; i++){
        int u = p[i];
        int v = p[i + 1];
        if (dist[u] != dist[v] + 1){
            mn++;
            mx++;
            continue;
        }
        if (coun[u] >= 2)
            mx++;
    }
    cout << mn << " " << mx << endl;
}
