#include<bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
#define PB push_back
#define MP make_pair
#define MT make_tuple
#define RS resize
#define F(i, a, b) for(int i = int(a); i <= int(b); i++)
#define f(i, a, b) for(int i = int(a); i >= int(b); i--)
#define fi first
#define se second


int const N = 2e5 + 47;
ll const inf = 2e9 + 7;
pii at[N], de[N];  
tuple<int, int, int> mon[N];

int tree[4*N], push[4*N];

void upd(int v, int tl, int tr, int ql, int qr, ll x){
    if(ql > qr)
        return;
    if(ql == tl && qr == tr){
        push[v] += x;
        if(ql == qr)
            tree[v] = push[v] + de[ql].se;
        else
            tree[v] = max(tree[2*v], tree[2*v+1]) + push[v];
        return;
    }
    int tm = (tl + tr)/2;
    upd(2*v, tl, tm, ql, min(qr, tm), x);
    upd(2*v+1, tm+1, tr, max(tm+1, ql), qr, x);
    tree[v] = max(tree[2*v], tree[2*v+1]) + push[v];
}


bool cmpde(pii a, pii b){
    return a.fi > b.fi;
}


int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    #ifdef LOCAL 
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    #endif
    int n, m, p;
    cin >> n >> m >> p;
    F(i, 0, n-1){
        int a, b;
        cin >> a >> b;
        at[i] = MP(a, -b);
    }
    F(i, 0, m-1){
        int a, b;
        cin >> a >> b;
        de[i] = MP(a, -b);
    }
    F(i, 0, p-1){
        int a, b, c;
        cin >> a >> b >> c;
        mon[i] = MT(a, b, c);
    }
    sort(at, at + n);
    sort(de, de + m, cmpde);
    sort(mon, mon + p);
    int tr = 1;
    while(tr < m)
        tr *= 2;
    F(i, 1, 2*tr - 1)
        tree[i] = -inf;
    F(i, 0, m-1)
        tree[tr + i] = de[i].se; 
    f(i, tr-1, 1)
        tree[i] = max(tree[2*i], tree[2*i+1]);
    /*F(i, 0, n-1)
        cerr << at[i].fi << ' ' << at[i].se << '\n';
    cerr << endl;
    F(i, 0, m-1)
        cerr << de[i].fi << ' ' << de[i].se << '\n';
    cerr << endl;
    F(i, 0, p-1)
        cerr << get<0>(mon[i]) << ' ' << get<1>(mon[i]) << ' ' << get<2>(mon[i]) << '\n';
    cerr << endl;      */
    ll ans = -inf;
    int itm = 0;
    F(i, 0, n-1){
        while(itm < p && get<0>(mon[itm]) < at[i].fi){
            tuple<int, int, int> cur = mon[itm];
            int need = get<1>(cur), cost = get<2>(cur);
            int l = -1, r = m-1;
            f(j, 17, 0){
                int mid = l + (1 << j);
                if(mid <= r && de[mid].fi > need)
                    l = mid; 
            }
            upd(1, 0, tr-1, 0, l, cost);
            itm++;
        }
        //cerr << at[i].se << ' ' << tree[1] << ' ' << itm << '\n';
        ans = max(ans, ll(tree[1]) + ll(at[i].se));
    }
    cout << ans;
    return 0;
}
