#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define pb push_back
#define fr first
#define sc second

const int inf = (int)1e9 + 7;
const ll linf = (ll)1e18 + 7;

const int N = (int)2e5 + 7;

vector <int> gr[N], rgr[N];
int n, m, k;
int p[N], d[N], dp[N];
vector<int> vec;

void bfs(int v) {
	queue<int> q;
	q.push(v);
	d[v] = 1;
	while (!q.empty()) {
		v = q.front();
		q.pop();
		vec.push_back(v);
		for (int to : rgr[v]) {
			if (!d[to]) {
				d[to] = d[v] + 1;
				q.push(to);
			}
		}
	}
}

pair<int, int> ans;

main() {
	scanf("%d %d", &n, &m);
	for (int i = 1; i <= m; i++) {
		int u, v;
		scanf("%d %d", &u, &v);
		gr[u].push_back(v);
		rgr[v].push_back(u);
	}
	scanf("%d", &k);
	for (int i = 1; i <= k; i++) {
		scanf("%d", &p[i]);
	}
	bfs(p[k]);
	for (int i = 1; i < k - 1; i++) {
		int x = p[i];
		int nxt = p[i + 1];
		sort(gr[x].begin(), gr[x].end(), [&](const int &A, const int &B) {
			return d[A] < d[B];
		});
		int cnt = 0;
		while (cnt < gr[x].size() && d[gr[x][cnt]] == d[gr[x][0]]) {
			cnt++;
		}
		if (d[nxt] != d[gr[x][0]]) {
			ans.fr++;
			ans.sc++;
		} else {
			if (cnt > 1)
				ans.sc++;
		}
	}
	cout << ans.fr << ' ' << ans.sc << endl;
}
