#define _CRT_SECURE_NO_WARNINGS
#include <cstdio>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <deque>
#include <queue>
#include <stack>
#include <cstring>
#include <cmath>
#include <cassert>
#include <iostream>
#include <string>

#define inf (1000000000)
#define mod (1000000000 + 7)
#define N (200000 + 19)
typedef long long ll;

std::vector<int> ng[N];
std::vector<int> g[N];
int p[N];
int d[N];

int main() {
	int n,m;
	scanf("%d%d", &n, &m);
	for(int i = 0; i < m; i++) {
		int a,b;
		scanf("%d%d", &a, &b);
		g[a].push_back(b);
		ng[b].push_back(a);
	}
	memset(d, 63,sizeof(d));
	int k;
	scanf("%d", &k);
	for(int i=0;i<k;i++) scanf("%d", p+i);
	int t=p[k-1];
	std::queue<int>q;
	q.push(t);
	d[t] = 0;
	while(!q.empty()) {
		int v=q.front();
		q.pop();
		for(int i=0;i<ng[v].size();i++) {
			int u =ng[v][i];
			if(d[u] > d[v] + 1) {
				d[u] = d[v] + 1;
				q.push(u);
			}
		}
	}
	int min_ans=0;
	int max_ans=0;
	for(int i=0;i<k - 1;i++) {
		int cur=p[i];
		int nxt=p[i+1];
		if(d[nxt]>=d[cur]){
			min_ans++;
			max_ans++;
		}
		if(d[nxt] < d[cur]){
			int add=-1;
			for(int i=0;i<g[cur].size();i++){
				int u=g[cur][i];
				if(d[u] == d[nxt]) {
					add++;
				}
			}
			max_ans+=std::min(1,add);
		}
	}
	printf("%d %d\n",min_ans,max_ans);
	return 0;
}