#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <string>
#include <iomanip>

using namespace std;

#define FOR(i, l, r) for(int i = l; i < r; i++)
#define DFOR(i, r, l) for(int i = r; i > l; i--)
#define ASKS(t) for(cin >> t; t; t--)
#define fi first
#define se second

typedef long long ll;
typedef long double ld;
typedef vector<int> vi;
typedef vector<ll> vll;
typedef set<int> si;
typedef set<ll> sll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

struct segtree{
    int mn;
    int lb, rb;
    segtree *l = 0, *r = 0;

    segtree(int lq, int rq){
        lb = lq;
        rb = rq;
        if(rb - lb > 1){
            int t = (lb + rb) / 2;
            l = new segtree(lb, t);
            r = new segtree(t, rb);
        }
        else{
            // TODO
        }
    }

    int get(int lq, int rq){
        if(lq <= lb && rb <= rq)
            return mn;
        else if(max(lb, lq) >= min(rb, rq))
            return 1000000000;
        else
            return min(l->get(lq, rq), r->get(lq, rq));
    }

    void set(int p, int x){
        if(l){
            if(p < l->rb)
                l->set(p, x);
            else
                r->set(p, x);
            mn = min(l->mn, r->mn);
        }
        else
            mn = x;
    }
};


int main()
{
    cin.tie(0); cout.tie(0); ios::sync_with_stdio(0);

    map<ll, ll> mp;
    ll n, b, mx = 0;
    cin >> n;
    FOR(c, 1, n + 1){
        cin >> b;
        if(mp.count(c - b))
            mp[c - b] += b;
        else
            mp[c - b] = b;
        mx = max(mp[c-b], mx);
    }
    cout << mx;

    return 0;
}




















