#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <string>
#include <iomanip>

using namespace std;

#define FOR(i, l, r) for(int i = l; i < r; i++)
#define DFOR(i, r, l) for(int i = r; i > l; i--)
#define ASKS(t) for(cin >> t; t; t--)
#define fi first
#define se second

typedef long long ll;
typedef long double ld;
typedef vector<int> vi;
typedef vector<ll> vll;
typedef set<int> si;
typedef set<ll> sll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

struct segtree{
    int mn;
    int lb, rb;
    segtree *l = 0, *r = 0;

    segtree(int lq, int rq){
        lb = lq;
        rb = rq;
        if(rb - lb > 1){
            int t = (lb + rb) / 2;
            l = new segtree(lb, t);
            r = new segtree(t, rb);
        }
        else{
            // TODO
        }
    }

    int get(int lq, int rq){
        if(lq <= lb && rb <= rq)
            return mn;
        else if(max(lb, lq) >= min(rb, rq))
            return 1000000000;
        else
            return min(l->get(lq, rq), r->get(lq, rq));
    }

    void set(int p, int x){
        if(l){
            if(p < l->rb)
                l->set(p, x);
            else
                r->set(p, x);
            mn = min(l->mn, r->mn);
        }
        else
            mn = x;
    }
};


int main()
{
    cin.tie(0); cout.tie(0); ios::sync_with_stdio(0);

    int n;
    string s;
    cin >> n >> s;
    int m = n;
    for(char c = 'z'; c > 'a'; c--){
        bool flag = true;
        while(flag){
            flag = false;
            if(m >= 2 && s[0] == c && s[1] == c-1){
                flag = true;
                s.erase(0, 1);
                m--;
                continue;
            }
            if(m >= 2 && s[m-1] == c && s[m-2] == c-1){
                flag = true;
                s.erase(m-1, 1);
                m--;
                continue;
            }
            FOR(j, 1, m-1){
                if(m >= 3 && s[j] == c && (s[j-1] == c-1 || s[j+1] == c-1)){
                    flag = true;
                    s.erase(j, 1);
                    m--;
                    break;
                }
            }
        }
    }
    cout << n - m;

    return 0;
}




















