#include <bits/stdc++.h>

using namespace std;

typedef int64_t ll;

const int MOD = 1e9 + 7;
const int MAXN = 1e6 + 15;
const int INF = 2139062143;
const int nINF = -2139062144;
const ll LINF = 9187201950435737471LL;
const ll nLINF = -9187201950435737472LL;

#define all(_x) _x.begin(), _x.end()
#define rall(_x) _x.rbegin(), _x.rend()
#define sz(_x) ((int)_x.size())
#define eb emplace_back
#define pb push_back
#define sqr(_x) ((_x) * (_x))

inline void IO() {
#ifdef buyolitsez
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif
}

#define int int64_t
int t[MAXN];

void update(int pos, int val) {
    for (pos; pos < MAXN; pos = (pos | (pos + 1))) {
        t[pos] += val;
    }
}

int get_sum(int pos) {
    int ans = 0;
    for (pos; pos >= 0; pos = (pos & (pos + 1)) - 1) {
        ans += t[pos];
    }
    return ans;
}

int check(int pos, vector <pair <int, int> >& a) {
    int ans = -a[pos].second;
    ans += get_sum(a[pos].first - 1);
    return ans;
}

inline void solve() {
    int n, m, p;
    cin >> n >> m >> p;
    vector <pair <int, int >> fake(n), a;
    int min1 = INF, min2 = INF;
    for (auto &[x, y] : fake) {
        cin >> x >> y;
        min1 = min(min1, y);
    }
    sort(rall(fake));
    int minim = INF;
    for (auto &[x, y] : fake) {
        if (minim > y) {
            a.eb(x, y);
            minim = y;
        }
    }
    vector <pair <int, int >> b;
    fake.resize(m);
    for (auto &[x, y] : fake) {
        cin >> x >> y;
        min2 = min(min2, y);
    }
    minim = INF;
    sort(all(fake));
    int ans = -(min1 + min2);
    sort(all(a));
    vector <tuple <int, int, int> > monsters(p);
    for (auto &[attack, defense, cost] : monsters) {
        cin >> attack >> defense >> cost;
        update(defense, cost);
    }
    b.eb(fake.back());
    for (int i = sz(fake) - 2; i >= 0; --i) {
        int sum = get_sum(fake[i + 1].first - 1) - get_sum(fake[i].first - 1);
        int raz = fake[i + 1].second - fake[i].second;
        if (sum < raz) {
            b.eb(fake[i]);
        }
    }
    sort(all(b));
    memset(t, 0, sizeof(t));
    sort(all(monsters));
    int pos = 0;
    int last = 0;
    for (auto [x, y] : a) {
        int now = -y;
        while (pos != sz(monsters)) {
            int attack, defense, cost;
            tie(attack, defense, cost) = monsters[pos];
            if (attack < x) {
                update(defense, cost);
                pos++;
            }
            else {
                break;
            }
        }
        if (pos != last) {
            last = pos;
            int l = 0, r = sz(b) - 1;
            int kek = nINF;
            while (r - l > 5) {
                int m1 = l + (r - l) / 3;
                int m2 = r - (r - l) / 3;
                int first = check(m1, b);
                int second = check(m2, b);
                if (first == second) {
                    assert(false);
                    kek = max(kek, check(l, b));
                    l++;
                } else if (first > second) {
                    r = m2;
                } else {
                    l = m1;
                }
            }
            kek = max(check(l, b), kek);
            for (int i = l + 1; i <= r; ++i) {
                kek = max(kek, check(i, b));
            }
            ans = max(ans, now + kek);
        }
    }
    cout << ans;
}

signed main() {
    IO();
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
