#include <bits/stdc++.h>

#pragma GCC optimize("-O3")

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;

#define int long long
#define double long double
#define For(i,z) for(int i=0;i<(z);i++)
#define _ <<' '<<
#define sqr(a) ((a)*(a))
#define pii pair<int,int>
#define f first
#define s second

template<typename T> using orset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<typename T, typename K> using ormap = tree<T, K, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<typename T, typename K> inline void umin(T &a, const K b) {a = min(a, (T)b);}
template<typename T, typename K> inline void umax(T &a, const K b) {a = max(a, (T)b);}

const int N = 5e5+10;
const double EPS = 1e-7;
const int64_t INF = 1e15;
const pair<int64_t,int64_t> PINF = make_pair(INF, INF);
const int64_t MOD = 1e9+123;
const int64_t AMOD = 99194853094755497;

bool used[N];
pii dst[N];
vector <int> gr[N];

int32_t main()
{
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int n, m; cin >> n >> m;
    For (i, m) {
        int a, b; cin >> a >> b; a--; b--;
        gr[b].push_back(a);
    }
    int k; cin >> k;
    vector <int> way(k);
    for (int &i : way) {
        cin >> i; i--;
    }
    queue<int> q;
    q.emplace(way.back());
    dst[way.back()] = make_pair(0, 1);
    while (q.size()) {
        int v = q.front(); q.pop();
        if (used[v]) continue;
        used[v] = true;
        for (int &i : gr[v]) {
            if (i == way.back()) continue;

            if (!dst[i].f) {
                dst[i].f = dst[v].f + 1;
                q.emplace(i);
            }
            if (dst[i].f == dst[v].f + 1)
                dst[i].s += dst[v].s;
        }
    }
    int ans1 = 0, ans2 = 0;
    For (i, k-1) {
        if (dst[way[i]].f != dst[way[i+1]].f+1)
            ans1++;
        if (dst[way[i]].f < dst[way[i+1]].f+1 || dst[way[i]].s > dst[way[i+1]].s)
            ans2++;
        else
        if (i == k-2 && dst[way[i]].s != 1)
            ans2++;
    }
    cout << ans1 _ ans2 << endl;
}
