#include <bits/stdc++.h>

#pragma GCC optimize("-O3")

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;

#define int long long
#define double long double
#define For(i,z) for(int i=0;i<(z);i++)
#define _ <<' '<<
#define sqr(a) ((a)*(a))
#define pii pair<int,int>
#define f first
#define s second

template<typename T> using orset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<typename T, typename K> using ormap = tree<T, K, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<typename T, typename K> inline void umin(T &a, const K b) {a = min(a, (T)b);}
template<typename T, typename K> inline void umax(T &a, const K b) {a = max(a, (T)b);}

const int N = 1e6+10;
const double EPS = 1e-7;
const int64_t INF = 1e17;
const pair<int64_t,int64_t> PINF = make_pair(INF, INF);
const int64_t MOD = 1e9+123;
const int64_t AMOD = 99194853094755497;

int fen[N];
void add(int v, int val) {
    for ( ; v < N; v += (v&(-v)))
        fen[v] += val;
}
int getat(int v) {
    if (v == 0) return 0;
    int cur = 0;
    for ( ; v ; v -= (v & (-v)))
        cur += fen[v];
    return cur;
}

int32_t main()
{
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int n, m, p; cin >> n >> m >> p;
    vector <pii> wea(n), arm(m);
    vector <pair<pii, int> > monst(p);
    for (auto &i : wea) cin >> i.f >> i.s;
    for (auto &i : arm) cin >> i.f >> i.s;
    sort(wea.begin(), wea.end());
    sort(arm.begin(), arm.end());
    vector <pii> cc;
    for (auto &i : wea) {
        while (cc.size() && i.s <= cc.back().s)
            cc.pop_back();
        cc.push_back(i);
    }
    wea = cc;
    cc.clear();
    for (auto &i : arm) {
        while (cc.size() && i.s <= cc.back().s)
            cc.pop_back();
        cc.push_back(i);
    }
    arm = cc;
    n = wea.size(); m = arm.size();
    for (auto &i : monst)
        cin >> i.f.f >> i.f.s >> i.s;
/*
    for (auto &i : wea)
        cout << "wea " << i.f _ i.s << endl;
    for (auto &i : arm)
        cout << "arm " << i.f _ i.s << endl;
    for (auto &i : monst)
        cout << "monst " << i.f.f _ i.f.s _ i.s << endl;
*/
    sort(monst.begin(), monst.end(), [](pair<pii, int> a, pair<pii, int> b) {
        return (a.f.s < b.f.s || (a.f.s == b.f.s && a.f.f < b.f.f));
    });
    int ans = -INF;
    int weaidx = 0;
    For (i, p) {
        int newea = monst[i].f.s, nearm = monst[i].f.f, cost = monst[i].s;
        add(nearm, cost);

        //cout << "here " << newea _ nearm _ cost << endl;
        while (weaidx < n && newea >= wea[weaidx].f) weaidx++;
        if (weaidx == n) continue;

        int armidx = (lower_bound(arm.begin(), arm.end(), make_pair(nearm, 0LL)) - arm.begin());
        if (armidx == m) continue;
        int cur = getat(arm[armidx].f-1) - wea[weaidx].s - arm[armidx].s;
        //cout << "needed" _ wea[weaidx].f _ arm[armidx].f  _ cur << endl;
        //cout << getat(arm[armidx].f-1) _ wea[weaidx].s _ arm[armidx].s << endl;
        umax(ans, cur);
        //cout << cur << endl;
        //cout << endl;
    }

    cout << ans << endl;
}
