#include <bits/stdc++.h>
using namespace std;

#define all(x) (x).begin(), (x).end()

const int N = 2e5 + 1;
const int INF = 1e9;

vector<int> g[N];
set<int> good[N];

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        g[b].emplace_back(a);
    }
    int k;
    cin >> k;
    vector<int> v(k);
    for (int i = 0; i < k; ++i) {
        cin >> v[i];
    }

    int s = v.back();
    queue<int> q;
    vector<int> d(n + 1, INF);
    d[s] = 0;
    q.push(s);
    vector<int> dp(n + 1);
    dp[s] = 1;
    while (!q.empty()) {
        int x = q.front();
        q.pop();
        for (auto i : g[x]) {
            if (d[i] == INF) {
                d[i] = d[x] + 1;
                q.push(i);
                good[i].insert(x);
                dp[i] += dp[x];
            } else if (d[i] == d[x] + 1) {
                good[i].insert(x);
                dp[i] += dp[x];
            }
        }
    }

    int cur = v[0];
    int x = 0, y = 0;
    for (int i = 1; i < k; ++i) {
        int nxt = v[i];
        if (good[cur].find(nxt) == good[cur].end()) {
            ++x; ++y;
        } else if (good[cur].size() > 1) {
            ++y;
        }
        cur = nxt;
    }
    cout << x << " " << y;
}