#include <bits/stdc++.h>
using namespace std;

#define all(x) (x).begin(), (x).end()
#define int long long

const int INF = 1e18;


vector<int> t;
vector<int> p;



void build(int v, int l, int r, vector<pair<int, int>> &a) {
    if (l + 1 == r) {
        t[v] = -a[l].second;
        return;
    }
    build(v * 2, l, (l + r) / 2, a);
    build(v * 2 + 1, (l + r) / 2, r, a);
    t[v] = max(t[v * 2], t[v * 2 + 1]);
}
void push(int v, int l, int r) {
    if (p[v] == 0) return;
    if (r - l > 1) {
        p[v * 2] += p[v];
        p[v * 2 + 1] += p[v];
    }
    t[v] += p[v];
    p[v] = 0;
}
void upd(int v, int l, int r, int L, int R, int x) {
    push(v, l, r);
    if (l >= R || L >= r) {
        return;
    }
    if (L <= l && r <= R) {
        p[v] += x;
        push(v, l, r);
        return;
    }
    upd(v * 2, l, (l + r) / 2, L, R, x);
    upd(v * 2 + 1, (l + r) / 2, r, L, R, x);
    t[v] = max(t[v * 2], t[v * 2 + 1]);
}
int get(int v, int l, int r, int L, int R) {
    push(v, l, r);
    if (l >= R || L >= r) {
        return -INF;
    }
    if (L <= l && r <= R) {
        return t[v];
    }
    return max(get(v * 2, l, (l + r)  / 2, L, R), get(v * 2 + 1, (l + r) / 2, r, L, R));
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n, m, l;
    int ans = -INF;
    cin >> n >> m >> l;
    vector<pair<int, int>> a(n), b(m);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first >> a[i].second;
    }
    for (int i = 0; i < m; ++i) {
        cin >> b[i].first >> b[i].second;
    }
    sort(all(a));
    sort(all(b));
    t.resize(4 * m);
    p.resize(4 * m);
    build(1, 0, m, b);
    vector<pair<int, pair<int, int>>> bad(l);
    int left = 0;
    for (int i = 0; i < l; ++i) {
        cin >> bad[i].first >> bad[i].second.first >> bad[i].second.second;
    }
    sort(all(bad));
    for (int kk = 0; kk < n; ++kk) {
        int cur_ans = -a[kk].second;
        while (left < l && bad[left].first < a[kk].first) {
            int cost = bad[left].second.second;
            int need = bad[left].second.first;
            if (need >= b.back().first) continue;
            upd(1, 0, m, lower_bound(all(b), make_pair(need, INF)) - b.begin(), m, cost);
            ++left;
        }
        cur_ans += get(1, 0, m, 0, m);


        ans = max(ans, cur_ans);
    }
    cout << ans;

}