#include <bits/stdc++.h>
using namespace std;

#define all(x) (x).begin(), (x).end()
#define int long long

const int INF = 1e18;
const int N = 2e5 + 1;
const int L = 20;
vector<pair<int, int>> nw_g[N];
long double d[N];
int ans[N];
void del(set<pair<long double, int>> &st, int i) {
    for (auto it = st.begin(); it != st.end(); ++it) {
        if (it->second == i) {
            st.erase(it);
            break;
        }
    }
}
void solve(vector<int> &start, vector<int> &speed, vector<int> &in) {
    vector<pair<int, pair<int, int>>> q;
    set<pair<long double, int>> st;
    for (int i = 0; i < start.size(); ++i) {
        ans[start[i]] = i;
        d[start[i]] = 0;
        st.insert({0, start[i]});
    }
    while (!st.empty()) {
        int v = st.begin()->second;
        st.erase(st.begin());
        for (auto & lll : nw_g[v]) {
            int to = lll.first, cost = lll.second;
            long double tim = ((long double)(cost)) / (long double)speed[ans[v]];
            if (ceil(d[to]) > ceil(d[v] + tim) || (ceil(d[to]) == ceil(d[v] + tim) && ans[to] > ans[v])) {
                del(st, to);
                d[to] = d[v] + tim;
                ans[to] = ans[v];
                st.insert({d[to], to});
            }
        }
    }
    for (auto i : in) {
        cout << ans[i] + 1 << " ";
    }
    cout << '\n';
}

vector<int> g[N];
int tin[N];
int dist[N];
int tim = 1;
int p[N][L];

void dfsCalc(int v, int pr) {
    dist[v] = dist[pr] + 1;
    p[v][0] = pr;
    tin[v] = tim++;
    for (int i = 1; i < L; ++i) {
        p[v][i] = p[p[v][i - 1]][i - 1];
    }
    for (auto i : g[v]) {
        if (i != pr) {
            dfsCalc(i, v);
        }
    }
}

int lca(int a, int b) {
    if (dist[a] < dist[b]) {
        swap(a, b);
    }
    int x = dist[a] - dist[b];
    for (int i = 0; i < L; ++i) {
        if ((x >> i) & 1) {
            a = p[a][i];
        }
    }
    if (a == b) {
        return a;
    }
    for (int i = L - 1; i >= 0; --i) {
        if (p[a][i] != p[b][i]) {
            a = p[a][i];
            b = p[b][i];
        }
    }
    return p[a][0];
}

void solve(int nn) {
    int k, m;
    cin >> k >> m;
    vector<int> a(k), speed(k);
    vector<int> al;
    for (int i = 1; i <= nn; ++i) {
        al.push_back(i);
    }
    for (int i = 0; i < k; ++i) {
        cin >> a[i] >> speed[i];
    }
    vector<int> in(m);
    for (int i = 0; i < m; ++i) {
        cin >> in[i];
        al.push_back(in[i]);
    }
    sort(all(al), [&](int a, int b) {
        return tin[a] < tin[b];
    });

    solve(a, speed, in);
    for (int i = 1; i <= nn; ++i) {
        ans[i] = d[i] = INF;
    }
}
signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n;
    cin >> n;
    for (auto &i : d) i = INF;
    for (auto &i : ans) i = INF;


    for (int i = 1; i < n; ++i) {
        int a, b;
        cin >> a >> b;
        nw_g[a].emplace_back(b, 1);
        nw_g[b].emplace_back(a, 1);
    }
    //dfsCalc(1, 0);
    int q;
    cin >> q;
    while (q--) {
        solve(n);
    }

}