#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <set>
#include <cmath>
#include <algorithm>
#include <map>
#include <queue>
#include <random>
#include <ctime>
#include <cstring>
#include <string>

using namespace std;

#define mp make_pair
#define all(x) x.begin(), x.end()
#define multi_test 0
#define int ll

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef pair<ll, int> pli;

void solve();

const int MAXN = 3e5 + 7;
const int MOD = 1e9 + 9;
const int INF = 2e9 + 11;
const ll INF1 = 9e18;
const ld EPS = 1e-8;

signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int q = 1;
	if (multi_test) cin >> q;
	while (q--) solve();
}

/*----------------------------------------------------------------------------------------*/

void solve() {
	int n;
    cin >> n;
    vector<int> v1(n), v2(n);
    int s1 = 0, s2 = 0, cnt = 0;
    for (int i = 0; i < n; ++i) {
        cin >> v1[i];
        s1 += v1[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> v2[i];
        s2 += v2[i];
        if (v1[i] == 1 && v2[i] == 0)
            ++cnt;
    }
    if (s1 > s2) {
        cout << "1\n";
        exit(0);
    } else if (cnt == 0) {
        cout << "-1\n";
        exit(0);
    }
    int ans = (s2 - s1 + cnt - 1) / cnt + 2;
    cout << ans << '\n';
}