#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <set>
#include <cmath>
#include <algorithm>
#include <map>
#include <queue>
#include <random>
#include <ctime>
#include <cstring>
#include <string>

using namespace std;

#define mp make_pair
#define all(x) x.begin(), x.end()
#define multi_test 0

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef pair<ll, int> pli;

void solve();

const int MAXN = 3e5 + 7;
const int MOD = 1e9 + 9;
const int INF = 2e9 + 11;
const ll INF1 = 9e18;
const ld EPS = 1e-8;

signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int q = 1;
	if (multi_test) cin >> q;
	while (q--) solve();
}

/*----------------------------------------------------------------------------------------*/

void solve() {
	int n;
    cin >> n;
    vector<int> v(n);
    for (int i = 0; i < n; ++i) {
        cin >> v[i];
    }
    vector<int> dp(n);
    for (int i = 0; i < n; ++i) {
        dp[i] = v[i];
        for (int j = 0; j < i; ++j) {
            if (v[i] - v[j] == i - j) {
                dp[i] = max(dp[i], dp[j] + v[i]);
            }
        }
    }
    cout << *max_element(all(v)) << '\n';
}
