#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <set>
#include <cmath>
#include <algorithm>
#include <map>
#include <queue>
#include <random>
#include <ctime>
#include <cstring>
#include <string>

using namespace std;

#define mp make_pair
#define all(x) x.begin(), x.end()
#define multi_test 0

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef pair<ll, int> pli;

void solve();

const int MAXN = 3e5 + 7;
const int MOD = 1e9 + 9;
const int INF = 2e9 + 11;
const ll INF1 = 9e18;
const ld EPS = 1e-8;

signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int q = 1;
	if (multi_test) cin >> q;
	while (q--) solve();
}

/*----------------------------------------------------------------------------------------*/

void solve() {
	int n;
    cin >> n;
    string s;
    cin >> s;
    for (int i = 25; i >= 0; --i) {
        set<pii> st;
        for (int j = 0; j < s.size(); ++j) {
            if (s[j] != (char)(i + 'a'))
                continue;
            if (j > 0 && s[j - 1] == s[j] - 1) {
                int k = j;
                while (k + 1 < s.size() && s[k + 1] == s[k])
                    ++k;
                st.insert(mp(-j, -k));
            }
            if (j + 1 < s.size() && s[j + 1] == s[j] - 1) {
                int k = j;
                while (k - 1 >= 0 && s[k - 1] == s[k])
                    --k;
                st.insert(mp(-k, -j));
            }
        }
        //cout << "ok " << (char)(i + 'a') << "\ns st : " << endl;
        for (auto it = st.begin(); it != st.end(); ++it) {
            //cout << -it->first << ' ' << -it->second << endl;
            s.erase(-it->first, -it->second + it->first + 1);
        }
        //cout << s << endl;
    }
    cout << n - s.size() << '\n';
}
