#include <iostream>
#include <vector>
#include <algorithm>
#include <utility>
#include <string>
#include <cmath>
#include <set>
#include <map>
#include <stack>
#include <iomanip>
#include <queue>
#define pb push_back
#define mp make_pair
#define all(a) (a).begin(), (a).end()

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int,int> pii;
typedef pair<ll,ll> pll;
const ll mod = 1e9+7;
const ll biginf = 1e18;
const int inf = 2e9;
const ld pi = acosl(-1);
const ld eps = 1e-9;

vector<vector<int> > g, tg;
vector<int> p;

void solve()
{
	int n, m;
	cin >> n >> m;
	g.resize(n);
	tg.resize(n);
	for(int i = 0; i < m; i++)
	{
		int f, t;
		cin >> f >> t;
		f--, t--;
		g[f].pb(t);
		tg[t].pb(f);
	}
	int k;
	cin >> k;
	p.resize(k);
	for(int i = 0; i < k; i++)
	{
		cin >> p[i];
		p[i]--;
	}
	set<pll> s;
	vector<ll> d(n, biginf), used(n, false);
	d[p.back()] = 0;
	s.insert(mp(0, p.back()));
	while(!s.empty())
	{
		pll cur = *s.begin();
		s.erase(s.begin());
		if(used[cur.second])
			continue;
		used[cur.second] = true;
		int c = cur.second;
		for(int i = 0; i < tg[c].size(); i++)
		{
			int to = tg[c][i];
			if(d[to] > cur.first + 1)
			{
				d[to] = cur.first + 1;
				s.insert(mp(d[to], to));
			}
		}
	}
	int anss = 0, ansb = 0;
	for(int i = 0; i < k; i++)
	{
		ll mind = biginf, ms = 0;
		for(int j = 0; j < g[p[i]].size(); j++)
		{
			if(d[g[p[i]][j]] == mind)
				ms++;
			if(d[g[p[i]][j]] < mind)
			{
				mind = d[g[p[i]][j]];
				ms = 1;
			}
		}
		if(i + 1 < k && d[p[i+1]] == mind && ms > 1)
			ansb++;
		if(i + 1 < k && d[p[i+1]] != mind)
		{
			anss++;
			ansb++;
		}
	}
	cout << anss << " " << ansb;
}

void multisolve()
{
	int t;
	cin >> t;
	while(t--)
		solve();
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	solve();
	//multisolve();
}