#include <iostream>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <limits>
#include <map>
#include <vector>
#include <set>
#include <string>
#include <cstdio>
#include <cstring>
#include <cassert>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
#define rep(i, n) for (int i = 0; i < (n); ++i)
#define all(x) (x).begin(), (x).end()
#define f first
#define s second
#define FAST_IO() ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

namespace __gnu_pbds {
    template<typename T>
    using pbds_tree = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
}
template<typename T>
using pbds_tree = __gnu_pbds::pbds_tree<T>;
// order_of_key
// find_by_order

const int MAXN = 2e5 + 5;
int n;
int a[MAXN];
map<ll, ll> dp;

int main() {
    FAST_IO();
    cin >> n;
    rep(i, n) {
        cin >> a[i];
    }

    rep(i, n) {
        ll p = i - a[i];
        dp[p] += a[i];
    }

    ll res = 0;
    for (auto it : dp) {
        res = max(res, it.s);
    }
    cout << res << endl;
}

