
#include <bits/stdc++.h>
#include <ext/pb_ds/detail/standard_policies.hpp>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>


#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")

#define F first
#define S second
#define llong long long
#define int long long
#define ld long double
#define pb push_back
#define endl '\n'

using namespace std;
using namespace __gnu_pbds;


template <typename T> using ordered_set = tree <T, null_type, less <T>, rb_tree_tag, tree_order_statistics_node_update>;


const int N = 2e5 + 7;
const int M = 1e9 + 7;
const int inf = 2e9;

vector <int> g[N];
vector <int> e[N];


unordered_map <int, int> prec;
main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

#endif // LOCAL

    int n, m;
    cin >> n >> m;
    for(int i = 0; i < m; i++){
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        g[x].pb(y);
        e[y].pb(x);
    }

    vector <int> d(n, inf);
    vector <int> way;
    int k;
    cin >> k;
    for(int i = 0; i < k; i++){
        int x;
        cin >> x;
        x--;
        way.pb(x);
    }

    queue <int> q;
    q.push(way.back());
    d[way.back()] = 0;
    while(q.size()){
        int v = q.front();
        q.pop();
        for(int to : e[v]){
            if (d[to] > d[v] + 1){
                d[to] = d[v] + 1;
                q.push(to);
            }
        }
    }

//    for(int to : d)

    int bad = 0, good = 0;
    int nw = way[0];
    for(int to : way){
        if (nw == to) continue;
        int war = 0;
        for(int to : g[nw]){
            if (d[to] == d[nw] - 1) war++;
        }

        if (war < 2 && d[to] == d[nw] - 1){
            nw = to;
            continue;
        }
         if (war < 2 && d[to] != d[nw] - 1){
            nw = to;
            good++;
            bad++;
            continue;
        }
        if (d[to] == d[nw] - 1){
            bad++;
        }
        else{
            good++;
            bad++;
        }
        nw = to;
    }

    cout << good << ' ' << bad << endl;






    return 0;
}
