
#include <bits/stdc++.h>
#include <ext/pb_ds/detail/standard_policies.hpp>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>


#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")

#define F first
#define S second
#define llong long long
#define int long long
#define ld long double
#define pb push_back
#define pii pair <int, int>
#define endl '\n'

using namespace std;
using namespace __gnu_pbds;


template <typename T> using ordered_set = tree <T, null_type, less <T>, rb_tree_tag, tree_order_statistics_node_update>;


const int N = 2e5 + 7;
const int M = 1e9 + 7;
const int inf = 2e9;

vector <int> g[N];
vector <int> e[N];

int add[4 * N];
int t[4 * N];


struct eto{
    int x, y, z;
};

bool comp(eto a, eto b){
    if (a.x != b.x) return a.x < b.x;
    return a.y < b.y;
}


void push(int v){
    if (add[v]){
        t[v * 2] += add[v];
        t[v * 2 + 1] += add[v];
        add[v * 2] += add[v];
        add[v * 2 + 1] += add[v];
        add[v] = 0;
    }
}


int get(int v, int cl, int cr, int l, int r){
    if (cl > r || cr < l) return -1e18;
    if (l <= cl && cr <= r){
        return t[v];
    }


    push(v);
    int mid = (cl + cr) / 2;
    return max(get(v * 2, cl, mid, l, r), get(v * 2 + 1, mid + 1, cr, l, r));
//    t[v] = max(t[v * 2], t[v * 2 + 1]);
}



void upd(int v, int cl, int cr, int l, int r, int x){

//    cerr << v << endl;
//    cerr << cl << ' ' << cr << endl;
//    cerr << l << ' ' << r << endl;
    if (cl > r || cr < l) return;
    if (l <= cl && cr <= r){
        t[v] += x;
        add[v] += x;
        return;
    }

    push(v);
    int mid = (cl + cr) / 2;
    upd(v * 2, cl, mid, l, r, x);
    upd(v * 2 + 1, mid + 1, cr, l, r, x);
    t[v] = max(t[v * 2], t[v * 2 + 1]);
}


main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

#endif // LOCAL

    int n, m, k;
    cin >> n >> m >> k;
    vector <pii> a, b;

    for(int i = 0; i < n; i++){
        int x, y;
        cin >> x >> y;
        a.pb({x, y});
    }

    sort(a.begin(), a.end());



    for(int i = 0; i < m; i++){
        int x, y;
        cin >> x >> y;
        b.pb({x, y});
    }

    sort(b.begin(), b.end());


    vector <eto> c;

    for(int i = 0; i < k; i++){
        eto it;
        cin >> it.x >> it.y >> it.z;
        c.pb(it);
    }

    sort(c.rbegin(), c.rend(), comp);

    int p = 1;
    while(p < m){
        p *= 2;
    }

    for(int i = 0; i < m; i++){
        upd(1, 0, p - 1, i, i, -b[i].S);
    }




    int ot = -1e18;
    for(int i = 0; i < n; i++){
//        cout << "power " << a[i].F << ' ' << "cost " << a[i].S << endl;
        while(c.size()){
            eto pp = c.back();
            if (pp.x < a[i].F){
                int y = pp.y;
                int l = 0, r = m - 1;
                int R = m;
//                cout << "monster " << pp.x << ' ' << pp.y << ' ' << pp.z << endl;
                while(l <= r){
                    int mid = (l + r) / 2;
                    if (b[mid].F > y){
                        R = mid;
                        r = mid - 1;
                    }
                    else{
                        l = mid + 1;
                    }
                }

                int z = pp.z;
                upd(1, 0, p - 1, R, m - 1, z);
//                cout << "last can " << R + 1 << endl;
//                cout << "best " << get(1, 0, p - 1, 0, m - 1) << endl;;
                c.pop_back();
            }
            else{
                break;
            }
        }

        ot = max(ot, -a[i].S + get(1, 0, p - 1, 0, m - 1));
    }


    cout << ot << endl;












    return 0;
}
