//#define LOCAL_DEBUG
//#define TESTNUM

//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

#include <bits/stdc++.h>

#define ll long long
#define pii pair<int, int>
#define all(x) (x).begin(),(x).end()

using namespace std;

#define int ll

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> g(n), r(n);
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--; b--;
        g[a].push_back(b);
        r[b].push_back(a);
    }
    int k;
    cin >> k;
    vector<int> p(k);
    for (auto &i : p) {
        cin >> i;
        i--;
    }
    int t = p.back();
    vector<int> d(n, -1);
    d[t] = 0;
    queue<int> q;
    q.push(t);
    while(q.size()) {
        int v = q.front();
        q.pop();
        for (auto u : r[v]) {
            if (d[u] == -1) {
                d[u] = d[v] + 1;
                q.push(u);
            }
        }
    }
    vector<bool> w(n, 0);
    for (int v = 0; v < n; v++) {
        int q = 0;
        for (auto u : g[v])
            if (d[u] == d[v] - 1)
                q++;
        w[v] = (q >= 2);
    }
    int a1 = 0, a2 = 0;
    for (int i = 0; i < k - 1; i++) {
        int v = p[i], u = p[i + 1];
        if (d[u] != d[v] - 1) {
            a1++;
            a2++;
            continue;
        }
        if (w[v])
            a2++;
    }
    cout << a1 << " " << a2;
}


signed main() {
    srand(time(0));
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
#ifdef LOCAL_DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = 1;
#ifdef TESTNUM
    cin >> t;
#endif
    while (t--)
        solve();
    return 0;
}
