//#define LOCAL_DEBUG
//#define TESTNUM

//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

#include <bits/stdc++.h>

#define ll long long
#define pii pair<int, int>
#define all(x) (x).begin(),(x).end()

using namespace std;

#define int ll

int p = rand() % 10000000+100000;
int m = 1e9 + 9;
vector<int> h;

int sub(int a, int b) {
    if (a > b)
        return a - b;
    else
        return a - b + m;
}

int subHash(int l, int r) {
    return sub(h[r], h[l] * (r - l) % m);
}

void solve() {
    int n;
    cin >> n;
    string s, t;
    cin >> s;
    s += '#';
    vector<int> pos(n + 1, -1);
    for (int i = 0; i <= n; i++) {
        if (s[i] == '#') {
            while (pos[i] == -1 && i >= 0) {
                pos[i] = t.size();
                i--;
            }
            break;
        }
        if (s[i] == '1' && s[i + 1] == '1') {
            i++;
        }
        else {
            t += s[i];
            int j = i;
            while (j >= 0 && pos[j] == -1) {
                pos[j] = t.size() - 1;
                j--;
            }
        }
    }
    n = t.size();
    h.resize(n + 1);
    h[0] = 0;
    for (int i = 0; i < n; i++) {
        h[i + 1] = (h[i] * p + t[i] + 7) % m;
    }
    int q;
    cin >> q;
    while (q--) {
        int a, b, d;
        cin >> a >> b >> d;
        a--; b--;
        int l1 = pos[a], r1 = pos[a + d], l2 = pos[b], r2 = pos[b + d];
        if (subHash(l1, r1) == subHash(l2, r2) && pos[r1] - pos[l1] == pos[r2] - pos[l2])
            cout << "Yes" << endl;
        else
            cout << "No" << endl;
    }
}


signed main() {
    srand(time(0));
    //.tie(0);
    //cout.tie(0);
    //ios_base::sync_with_stdio(0);
#ifdef LOCAL_DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = 1;
#ifdef TESTNUM
    cin >> t;
#endif
    while (t--)
        solve();
    return 0;
}
