#include <iostream>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <deque>
#include <algorithm>
#include <iomanip>
#include <string>

using namespace std;
typedef long long ll;
typedef long double ld;
ll n;
string s;
ll ans = 0;

bool near(char a, char b)
{
    return a - b == 1;
}

bool can_del(ll i)
{
    if (i == 0) return near(s[0], s[1]);
    if (i == s.size() - 1) return near(s[s.size() - 1], s[s.size() - 2]);
    return near(s[i], s[i + 1]) || near(s[i], s[i - 1]);
}

void del(ll i)
{
    s.erase(s.begin() + i);
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);

    cin >> n >> s;

    while (true)
    {
        if (s.size() == 1) break;
        ll pos = 0;
        bool ok = false;
        for (ll i = 0; i < s.size(); ++i)
        {
            if (can_del(i) && s[i] > s[pos])
            {
                pos = i;
            }
            if (can_del(i)) ok = true;
        }

        if (!ok) break;
        ++ans;
        del(pos);

    }

    cout << ans;
    return 0;
}