#include <iostream>
#include <map>
#include <cmath>

#define ll long long

using namespace std;

const int max_n = 3e5;

ll b[max_n];
map<int, ll> m;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int n;
    cin >> n;
    ll ans = 0;
    for(int i = 1; i <= n; i++) {
        cin >> b[i];
        ans = max(ans, b[i]);
    }
    for(int i = 1; i <= n; i++) {
        int num = b[i] - i;
        m[num] += b[i];
        ans = max(ans, m[num]);
    }
    cout << ans;
    return 0;
}
