#include <bits/stdc++.h>

using namespace std;



const int MAX_N = 101;
int d[MAX_N][MAX_N];
string p[MAX_N][MAX_N];


pair<string, int> solve_mid(string a, string b)
{
	//cout << a << ' ' << b << ' ';
	int ans = 0;
	bool del = 1;
	while (del)
	{
		del = 0;
		while (!a.empty() && !b.empty() && a.back() - 1 == b[0])
		{
			del = 1;
			++ans;
			a.pop_back();
		}
		while (!a.empty() && !b.empty() && b[0] - 1 == a.back())
		{
			b = b.substr(1);
			++ans;
			del = 1;
		}
	}
	
	for (auto ch: b)
	{
		a.push_back(ch);
	}
	//cout << a << '\n';
	return {a, ans};
}


int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	int n;
	string s;
	cin >> n >> s;

	for (int i = 0; i < n; ++i)
	{
		d[i][i] = 0;
		p[i][i] = s[i];
	}
	
	for (int len = 2; len <= n; ++len)
	{
		for (int l = 0; l + len - 1 < n; ++l)
		{
			int r = l + len - 1;
			
			d[l][r] = 0;	
			p[l][r] = s.substr(l, len);
			
			for (int i = l + 1; i <= r; ++i)
			{
				auto mid_solved = solve_mid(p[l][i - 1], p[i][r]);
				if (d[l][i - 1] + d[i][r] + mid_solved.second > d[l][r])
				{
					d[l][r] = d[l][i - 1] + d[i][r] + mid_solved.second;
					p[l][r] = mid_solved.first;
				}
			}
			//cout << l << ' ' << r << ' ' << d[l][r] << ' ' << p[l][r] << '\n';
		}
	}

	/*
	for (int i = 0; i < n; ++i)
	{
		for (int j = i + 1; j < n; ++j)
		{
			cout << i << ' ' << j << ' ' << d[i][j] << ' ' << p[i][j] << '\n';
		}
	}
	*/
	cout << d[0][n - 1];

	return 0;
}
	
