#include <bits/stdc++.h>

using namespace std;

//#pragma GCC optimize("O3")

#ifdef FAIRLY_LOCAL
#define io freopen("in.txt", "r", stdin); freopen("out.txt", "w", stdout)
#else
#define io ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#endif

#define forn(i, n) for (int i = 0; i < n; i++)
#define all(a) a.begin(), a.end()

typedef long long ll;
typedef long double ld;

//#define int ll

vector<int> s;
vector<bool> gone;
int n;

void check(int pos, int l, int r) {
    if (l < 0 || r >= n) return;

    while (l > 0 && gone[l]) l--;
    while (r < n - 1 && gone[r]) r++;

    if (!gone[l] && !gone[r]) {
        if (s[l] + 1 == s[r]) {
            gone[r] = true;
            check(r, l, r);
            return;
        }
        if (s[l] - 1 == s[r]) {
            gone[l] = true;
            check(l, l, r);
        }
    }

}

signed main() {
    io;

    cin >> n;

    if (n == 1) {
        cout << 0;
        return 0;
    }

    s.resize(n);
    gone.assign(n, false);

    vector<pair<int, int>> p(n);
    forn(i, n) {
        char c;
        cin >> c;
        s[i] = int(c - 'a');
        p[i] = {s[i], i};
    }
    sort(all(p));
    reverse(all(p));

    forn(i, n) {
        int a = p[i].first, pos = p[i].second;
        if (gone[pos]) continue;

        int l = pos - 1, r = pos + 1;

        while (l > 0 && gone[l]) l--;
        if (l >= 0 && !gone[l] && s[l] + 1 == a) {
            gone[pos] = true;
            check(pos, l, pos);
            continue;
        }

        while (r < n - 1 && gone[r]) r++;
        if (r < n && !gone[r] && s[r] + 1 == a) {
            gone[pos] = true;
            check(pos, l, r);
        }
    }
    int ans = 0;
    forn(i, n) ans += gone[i];
    cout << ans;

}