#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
#define pb push_back
#define pll pair<ll, ll>

const ll inf = ll(1e9) + 5;
const ll maxn = ll(2e5) + 5;

ll gcd(ll x, ll y) {
    while(y) {
        ll tmp = x % y;
        x = y;
        y = tmp;
    }
    return x;
}

ll n, m;
vector<ll> gr[maxn];
vector<ll> rgr[maxn];
ll k;
vector<ll> way;
set<ll> from[maxn];

void solve() {
    cin >> n >> m;
    for(ll i = 0; i < m; i++) {
        ll v, u;
        cin >> v >> u;
        v--;
        u--;
        gr[v].pb(u);
        rgr[u].pb(v);
    }

    cin >> k;
    for(ll i = 0; i < k; i++) {
        ll cur;
        cin >> cur;
        cur--;
        way.pb(cur);
    }

    ll s = way[0];
    ll t = way.back();

    vector<ll> dist(n, inf);
    dist[t] = 0;
    queue<ll> q;
    q.push(t);

    while(q.size() > 0) {
        ll v = q.front();
        q.pop();
        for(auto u : rgr[v]) {
            ll nw = dist[v] + 1;
            if(nw < dist[u]) {
                dist[u] = nw;
                from[u].clear();
                from[u].insert(v);
                q.push(u);
            } else if(nw == dist[u]) {
                from[u].insert(v);
            }
        }
    }

    ll mn = 0;
    ll mx = 0;
    for(ll i = 0; i < k - 1; i++) {
        if(from[way[i]].size() > 1 ||
           (from[way[i]].find(way[i + 1]) == from[way[i]].end())) {
            mx++;
        }

        if(from[way[i]].find(way[i + 1]) == from[way[i]].end()) {
            mn++;
        }
    }

    cout << mn << " " << mx << endl;
}

int main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    ios::sync_with_stdio();
    cin.tie(0);
    cout.tie(0);

    solve();

    return 0;
}
