#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;
typedef long long ll;
#define fi first
#define se second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin, x.rend()
#define range(i, n) for(int i = 0; i < n; ++i)


ll mod(ll a, ll b) {
    a = a % b;
    if (a < 0) {
        return b - a;
    } else {
        return a;
    }
}

ll bin_pow(ll base, ll a){
    if (a == 1){
        return base;
    } else if (a & 1){
        return base * bin_pow(base, a - 1);
    } else{
        ll x = bin_pow(base, a / 2);
        return x * x;
    }
}

template< class RandomAccessIterator >
void pri( RandomAccessIterator first, RandomAccessIterator last ){
    for (; first != last; ++first){
        cout << *first << ' ';
    }
    cout << '\n';
}


int main() {
    cin.tie(0);
    cout.tie(0);
    ll n; cin >> n;
    vector<bool> r(n);
    vector<bool> b(n);
    range(i, n){
        bool x; cin >> x;
        r[i] = x;
    }
    range(i, n){
        bool x; cin >> x;
        b[i] = x;
    }
    vector<ll> answers(n, 1);
    ll cnt = 0;
    vector<ll> good;
    range(i, n){
        if (r[i] && b[i]){ continue;}
        if (b[i]){cnt +=1;}
        else if (r[i]){
            good.push_back(i);
        }
    }
    if (good.size() == 0){
        cout << -1;
        return 0;
    }
    ll per = (cnt) / good.size() + 1;
    for (auto el:good){
        answers[el] = per;
    }
    if (per <= 0){cout << 1;
        return 0;}
    cout << per;
    return 0;
}