#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <map>

using namespace std;
typedef long long ll;
#define fi first
#define se second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin, x.rend()
#define range(i, n) for(int i = 0; i < n; ++i)


ll mod(ll a, ll b) {
    a = a % b;
    if (a < 0) {
        return b - a;
    } else {
        return a;
    }
}

ll bin_pow(ll base, ll a){
    if (a == 1){
        return base;
    } else if (a & 1){
        return base * bin_pow(base, a - 1);
    } else{
        ll x = bin_pow(base, a / 2);
        return x * x;
    }
}

template< class RandomAccessIterator >
void pri( RandomAccessIterator first, RandomAccessIterator last ){
    for (; first != last; ++first){
        cout << *first << ' ';
    }
    cout << '\n';
}

const ll MAXN = 2e5 + 10;
ll b[MAXN];
int main() {
    cin.tie(0);
    cout.tie(0);
    ll n; scanf("%lld", &n);
    map<ll, ll> br;
    ll max_s;
    scanf("%lld", &max_s);
    b[0] = max_s;
    br[-max_s] = max_s;
    for (int i = 1; i < n; ++i) {
        ll bx; scanf("%lld", &bx);
        ll brx = i - bx;
        if (br.find(brx) != br.end()){
            ll v = br[brx];
            b[i] = v + bx;
            br[brx] += bx;
        } else {
            b[i] = bx;
            br[brx] = bx;
        }
        max_s = max(max_s, b[i]);
    }
    printf("%lld", max_s);
    return 0;
}