#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <map>
#include <list>
#include <queue>

using namespace std;
typedef long long ll;
#define fi first
#define se second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin, x.rend()
#define range(i, n) for(int i = 0; i < n; ++i)


ll mod(ll a, ll b) {
    a = a % b;
    if (a < 0) {
        return b - a;
    } else {
        return a;
    }
}

ll bin_pow(ll base, ll a){
    if (a == 1){
        return base;
    } else if (a & 1){
        return base * bin_pow(base, a - 1);
    } else{
        ll x = bin_pow(base, a / 2);
        return x * x;
    }
}

template< class RandomAccessIterator >
void pri( RandomAccessIterator first, RandomAccessIterator last ){
    for (; first != last; ++first){
        cout << *first << ' ';
    }
    cout << '\n';
}




const int MAXN = 2e5 + 10;
int c[MAXN][3];
int n, m, p;
vector<pair<int, int>> na;
vector<pair<int, int>> nb;


ll fb(int dam, int i){
    ll cnt = 0;
    for (int j = 0; j < p; ++j) {
        if (c[j][0] < dam && c[j][1] < nb[i].se){
            cnt += c[j][2];
        }
    }
    return cnt - nb[i].fi;
}

bool okb(int dam, int i){
    return fb(dam, i) - fb(dam, i - 1) <= 0;
}

ll fa(int i){
    int l, r = 0, nb.size();
    while (r - l > 1){
        int m = (r + ) / 2;
        if (okb(na[i].se, m)){
            r = m;
        } else {
            l = m;
        }
    }
    if (r != nb.size()){
        return max(fb(na[i].fi, l) - na[i].se, fb(na[i].fi, r) - na[i].se)}
    else {
        return fb(na[i].fi, l) - na[i].se;
    }
}

bool oka(int i){
    return fa(i) - fb(i - 1) <= 0;
}



int main() {
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m >> p;
    vector<pair<int, int>> a(n);
    vector<pair<int, int>> b(n);
    range(i, n){
        int v, ca; cin >> v >> ca;
        v[i] = {ca, v};
    }
    range(i, m){
        int v, ca; cin >> v >> ca;
        b[i] = {ca, v};
    }
    range(i, p){
        int x, y, z; cin >> x >> y >> z;
        c[i][0] = x;
        c[i][1] = y;
        c[i][2] = z;
    }
    sort(all(a));
    sort(all(b));

    int max_d = 0;
    for (auto el: a){
        if (max_d < el.se){
            max_d = el.se;
            na.push_back(el);
        }
    }
    max_d = 0;
    for (auto el: b){
        if (max_d < el.se){
            max_d = el.se;
            nb.push_back(el);
        }
    }
    int l, r = 0, na.size();
    while (r - l > 1){
        int m = (r + ) / 2;
        if (oka(m)){
            r = m;
        } else {
            l = m;
        }
    }
    if (r != na.size()){
        cout << max(fa(l), fa(r))}
    else {
        cout << fa(l);
    }
    return 0;
}