#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <stdio.h>
#include <string>
#include <cmath>
#include <algorithm>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <tuple>

#define forn(i, n) for(int i=0; i<n; i++)
#define pii pair<int,int>
#define mp make_pair
#define ld long double
#define ll long long

#pragma GCC optimize("Ofast,inline,unroll-loops,no-stack-protector")

using namespace std;

const int N = 4e5+100;
ll ans[2*N];

struct node{
	int x, id;
	node*l, *n;
	node():l(NULL), n(NULL), id(-1), x(-100){};
	node(int x, int id):l(NULL), n(NULL), x(x), id(id){};
};

int safe(node*n){
	return n == NULL ? -100 : n->x;
}

void add_node(node*t, node*n){
	t->n = n;
	n->l = t;
}

bool check_node(node*n){
	if(safe(n->l) == n->x-1)return 1;
	if(safe(n->n) == n->x-1)return 1;
	return 0;
}

void del(node*n){
	n->n->l = n->l;
	n->l->n = n->n;
}

int main(){
//	freopen("input.txt", "r", stdin);
//	freopen("output.txt", "w", stdout);
	ios_base::sync_with_stdio(0);

	int n, m;
	cin >> n >> m;
	vector<vector<int>>g(n), back(n);
	forn(i,m){
		int a,b;
		cin>>a>>b;
		--a;
		--b;
		g[a].push_back(b);
		back[b].push_back(a);
	}
	vector<int>dist(n, n+100);
	int k;
	cin>>k;
	vector<int>way(k);
	forn(i, k){
		cin>>way[i];
		way[i]--;
	}
	int t = way.back();
	queue<int>q;
	dist[t] = 0;
	q.push(t);
	while(q.size()){
		int a = q.front();
		q.pop();
		forn(i, back[a].size()){
			int b = back[a][i];
			if(dist[b] == n+100){
				dist[b] = dist[a]+1;
				q.push(b);
			}
		}
	}
	int mn=0, mx=0;
	forn(i, k-1){
		if(dist[way[i]] - 1 != dist[way[i+1]])mn++;
		else{
			int cnt = 0;
			forn(j, g[way[i]].size()){
				int id = g[way[i]][j];
				if(dist[id] == dist[way[i]] - 1)cnt++;
			}
			if(cnt>1)mx++;
		}
	}
	mx+=mn;
	cout<<mn<<' '<<mx;
}