#pragma GCC optimize("Ofast")
#pragma GCC target("tune=native,sse,sse2,sse3,ssse3,avx,mmx,popcnt")
#pragma GCC optimize("unroll-loops,no-stack-protector,btr-bb-exclusive,fast-math")

#include <bits/stdc++.h>

using namespace std;

#define int long long


signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n, m, p;
	cin >> n >> m >> p;

	vector< pair<int, int> > a(n);
	for(int i = 0; i < n; i++) {
		cin >> a[i].first >> a[i].second;
	}
	sort(a.begin(), a.end());
	int sufmin = 1000000000LL;
	for(int i = n - 1; i >= 0; i--) {
		sufmin = min(sufmin, a[i].second);
		a[i].second = sufmin;
	}

	vector< pair<int, int> > b(m);
	for(int i = 0; i < m; i++) {
		cin >> b[i].first >> b[i].second;
	}
	sort(b.begin(), b.end());
	sufmin = 1000000000LL;
	for(int i = m - 1; i >= 0; i--) {
		sufmin = min(sufmin, b[i].second);
		b[i].second = sufmin;
	}

	vector< tuple<int, int, int> > xyz(p);
	for(int i = 0; i < p; i++) {
		cin >> get<0>(xyz[i]) >> get<1>(xyz[i]) >> get<2>(xyz[i]);
	}
	sort(xyz.begin(), xyz.end());

	vector<int> revenue(1000001);
	for(int i = 0; i < revenue.size(); i++) {
		auto it = upper_bound(b.begin(), b.end(), make_pair(i, 10000000000LL));
		int cost = it == b.end() ? 1000000000000000LL : it->second;
		revenue[i] -= cost;
	}

	int ans = -1000000000000000LL;
	for(int i = 0; i < xyz.size(); i++) {
		auto it = upper_bound(a.begin(), a.end(), make_pair(get<0>(xyz[i]), 10000000000LL));
		if(it == a.end()) {
			continue;
		}
		int cx = it->second;
		for(int j = get<1>(xyz[i]); j < revenue.size(); j++) {
			revenue[j] += get<2>(xyz[i]);
		}
		int cur = -1000000000000000LL;
		for(int i = 0; i < revenue.size(); i++) {
			cur = max(cur, revenue[i]);
		}
		cur -= cx;
		ans = max(ans, cur);
	}
	cout << ans << endl;

	return 0;
}