#include <bits/stdc++.h>
#define int long long
#define all(v) v.begin(), v.end()

using namespace std;

bool IS_LOCAL = false;

int n;
vector<int> beauty;

int solve() {
    map<int, int> shift_to_res;
    for (int i = 0; i < n; ++i) {
        int now_shift = beauty[i] - i;
        shift_to_res[now_shift] += beauty[i];
    }
    int max_ans = 0;
    for (auto e : shift_to_res) {
        max_ans = max(max_ans, e.second);
    }
    return max_ans;
}

int stupid() {
    vector<int> dp(n, 0);
    for (int i = 0; i < n; ++i) {
        dp[i] = beauty[i];
    }
    for (int i = 1; i < n; ++i) {
        for (int j = 0; j < i; ++j) {
            if (i - j == beauty[i] - beauty[j]) {
                dp[i] = max(dp[i], dp[j] + beauty[i]);
            }
        }
    }
    int max_ans = 0;
    for (int i = 0; i < n; ++i) {
        max_ans = max(max_ans, dp[i]);
    }
    return max_ans;
}

bool check() {
    return true;
}

int gen() {
    return 0;
}

bool iterate() {
    return true;
}

void read() {
    cin >> n;
    beauty.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> beauty[i];
    }
}

int32_t main()
{
    if (!IS_LOCAL) {
        cin.tie(0);
        cout.tie(0);
        iostream::sync_with_stdio(false);
    }
    read();
    cout << solve() << '\n';
}
