#define _USE_MATH_DEFINES
#include <iostream>
#include <vector>
#include <algorithm>
#include <ctime>
#include <cmath>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <random>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <cstring>
#include <iomanip>
using namespace std;

//#define int long long
#define double long double
#define mp make_pair
#define debug(x) cerr << #x << ": " << x << '\n';
#define fi first
#define se second
#define pb push_back
typedef long long ll;
typedef pair<int, int> pii;

void fast() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
}

const int N = 101;
string s;
set<pair<char, int>> se;
bool used[N];
int n;

int left(int i) {
    i--;
    while (i >= 0 && used[i]) i--;
    return i;
}

int right(int i) {
    i++;
    while (i < n && used[i]) i++;
    return i;
}

bool check(int i) {
    if (i == -1 || i == n) return false;
    int j = left(i);
    if (j != -1 && s[j] + 1 == s[i]) return true;
    j = right(i);
    if (j != n && s[j] + 1 == s[i]) return true;
    return false;
}

signed main() {
    fast();
    cin >> n >> s;

    for (int i = 0; i < n; i++) {
        //debug(check(1))
        if (check(i)) {

            se.insert(mp(s[i], i));
        }
    }
    int ans = 0;
    while (!se.empty()) {
        auto it = se.end();
        --it;
        int i = it->second;
        se.erase(it);
        ans++;
        used[i] = true;
        int l = left(i), r = right(i);
        if (check(l)) se.insert(mp(s[l], l));
        if (check(r)) se.insert(mp(s[r], r));
    }
    cout << ans;
    return 0;
}
