#define _USE_MATH_DEFINES
#include <iostream>
#include <vector>
#include <algorithm>
#include <ctime>
#include <cmath>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <random>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <cstring>
#include <iomanip>
using namespace std;

//#define int long long
#define double long double
#define mp make_pair
#define debug(x) cerr << #x << ": " << x << '\n';
#define fi first
#define se second
#define pb push_back
typedef long long ll;
typedef pair<int, int> pii;

void fast() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
}

struct monstr {
    int x, y, z;
};

const int N = 2e5 + 10;
int t[4 * N], ps[4 * N];
pii a[N], b[N];
monstr c[N];
int n, m, p;

void insert(int v, int tl, int tr, int i, int x) {
    if (tl > i) return;
    if (tr < i) return;
    if (tl == tr) {
        t[v] = x;
        return;
    }
    int tm = (tl + tr) / 2;
    insert(2 * v, tl, tm, i, x);
    insert(2 * v + 1, tm + 1, tr, i, x);
    t[v] = max(t[2 * v], t[2 * v + 1]);
}

void push(int v, int tl, int tr) {
    t[v] += ps[v];
    if (tl == tr) {
        ps[v] = 0;
        return;
    }
    ps[2 * v] += ps[v];
    ps[2 * v + 1] += ps[v];
    ps[v] = 0;
}

void update(int v, int tl, int tr, int l, int r, int x) {
    push(v, tl, tr);
    if (tl > r || tr < l) return;
    if (tl >= l && tr <= r) {
        ps[v] += x;
        push(v, tl, tr);
        return;
    }
    int tm = (tl + tr) / 2;
    update(2 * v, tl, tm, l, r, x);
    update(2 * v + 1, tm + 1, tr, l, r, x);
    t[v] = max(t[2 * v], t[2 * v + 1]);
}

const int inf = 1e9 + 10;

bool comp(monstr a, monstr b) {
    return a.y < b.y;
}

signed main() {
    fast();
    cin >> n >> m >> p;
    for (int i = 0; i < n; i++) {
        cin >> a[i].fi >> a[i].se;
    }
    for (int i = 0; i < m; i++) {
        cin >> b[i].fi >> b[i].se;
    }
    sort(a, a + n);
    sort(b, b + m);
    for (int i = 0; i < p; i++) {
        cin >> c[i].x >> c[i].y >> c[i].z;
    }
    sort(c, c + p, comp);
    int ii = 0;
    int ans = -2 * inf;
    for (int i = 0; i < n; i++) {
        insert(1, 0, n - 1, i, -a[i].se);
    }
    for (int i = 0; i < m; i++) {
        while (ii < p && c[ii].y < b[i].fi) {
            int it = upper_bound(a, a + n, mp(c[ii].x, inf)) - a;
            update(1, 0, n - 1, it, n - 1, c[ii].z);
            ii++;
        }
        push(1, 0, n - 1);
        ans = max(ans, t[1] - b[i].se);
    }
    cout << ans;
    return 0;
}
