//#pragma GCC optimize("Ofast,unroll-loops,fast-math,no-stack-protector")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,abm,mmx,avx,avx2,popcnt,tune=native")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

//#define int long long

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef pair<ld, ld> pld;

template<typename T>
using kawaii_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define all(x) (x).begin(), (x).end()

void FAST_IO() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	//cout.setf(ios::fixed);
	//cout.precision(20);
	#ifndef _offline
		//freopen("input.txt", "r", stdin);
		//freopen("output.txt", "w", stdout);
	#endif
}

const int INF = 1e9 + 7;
const int MAXN = 2e5 + 100;
vector<int> g[MAXN], gt[MAXN];
set<int> gc[MAXN];
int d1[MAXN], dn[MAXN];

signed main() {
	FAST_IO();
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; ++i) {
		int u, v;
		cin >> u >> v;
		u--;
		v--;
		g[u].push_back(v);
		gt[v].push_back(u);
	}
	int k;
	cin >> k;
	vector<int> p(k);
	for (int i = 0; i < k; ++i) {
		cin >> p[i];
		p[i]--;
	}
	fill(d1, d1 + n, INF);
	fill(dn, dn + n, INF);
	queue<int> q;
	d1[p[0]] = 0;
	q.push(p[0]);
	while (q.size()) {
		int u = q.front();
		q.pop();
		for (int to : g[u]) {
			if (d1[to] > d1[u] + 1) {
				d1[to] = d1[u] + 1;
				q.push(to);
			}
		}
	}
	dn[p[k - 1]] = 0;
	q.push(p[k - 1]);
	while (q.size()) {
		int u = q.front();
		q.pop();
		for (int to : gt[u]) {
			if (dn[to] > dn[u] + 1) {
				dn[to] = dn[u] + 1;
				q.push(to);
			}
		}
	}
	for (int i = 0; i < n; ++i) {
		int mn = INF;
		for (int to : g[i]) {
			mn = min(mn, dn[to]);
		}
		if (mn == INF) {
			continue;
		}
		for (int to : g[i]) {
			if (dn[to] == mn) {
				gc[i].insert(to);
			}
		}
	}
	int mn = 0, mx = 0;
	for (int i = 0; i < k - 1; ++i) {
		if (!gc[p[i]].count(p[i + 1])) {
			mn++;
			mx++;
		}
		else if ((int)gc[p[i]].size() > 1) {
			mx++;
		}
	}
	cout << mn << ' ' << mx << '\n';
}