#include <bits/stdc++.h>

#pragma GCC target("avx,avx2")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("Ofast")

using namespace std;

#define int long long
#define sz(a) (int) (a).size()
#define all(a) (a).begin(), (a).end()
#define x first
#define y second

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

const int maxn = 2e5 + 100;
const int inf = 1e9;
const int maxd = 1e6 + 1;

vector<pair<int, int>> a, b;
vector<pair<pair<int, int>, int>> d;
int f[maxd];

void update(int x, int dt) {
    for (; x < maxd; x = (x | (x + 1))) {
        f[x] += dt;
    }
}

int get_sum(int x) {
    int res = 0;
    for (; x >= 0; x = (x & (x + 1)) - 1) {
        res += f[x];
    }
    return res;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);

    int n, m, p;
    cin >> n >> m >> p;
    a.resize(n);
    b.resize(m);
    d.resize(p);
    for (int i = 0; i < n; i++) {
        cin >> a[i].x >> a[i].y;
    }
    for (int i = 0; i < m; i++) {
        cin >> b[i].x >> b[i].y;
    }
    for (int i = 0; i < p; i++) {
        cin >> d[i].x.x >> d[i].x.y >> d[i].y;
    }
    sort(all(d));
    sort(all(a));
    sort(all(b));
    int cur = 0;
    for (int i = 0; i < m; i++) {
        if (b[i].y < b[cur].y) {
            cur = i;
        }
    }
    int ans = 0;
    int j = 0;
    for (int i = 0; i < n; i++) {
        while (j < n && d[j].x.x < a[i].x) {
            update(d[j].x.y, d[j].y);
            j++;
        }
        int val = get_sum(b[cur].x - 1) - b[cur].y;
        for (int k = 0; k < m; k++) {
            int tmp = get_sum(b[k].x - 1) - b[k].y;
            if (val <= tmp) {
                val = tmp;
                cur = k;
            }
        }
        //cout << i << " " << cur << " " << get_sum(b[cur].x - 1) << "\n";
        ans = max(ans, val - a[i].y);
    }
    cout << ans << "\n";
    return 0;
}
