#include <bits/stdc++.h>

using namespace std;

#define mp make_pair
#define ff first
#define ss second
#define eb emplace_back

using itn = int;

const int MAXN = 200000;
//#define int long long
const int INF = INT_MAX;

int t[MAXN * 4];
int md[MAXN * 4];

void pull(int v){
    t[v] = min(t[v * 2], t[v * 2 + 1]);
}

void push(int v){
    if (md[v] != 0){
        t[2 * v] += md[v];
        md[2 * v] += md[v];

        t[2 * v + 1] += md[v];
        md[2 * v + 1] += md[v];

        md[v] = 0;
    }
}

void build(int v, int l, int r, vector<pair<int, int>>& a){
    if (r - 1 == l){
        t[v] = a[l].ss;
        return;
    }
    int m = (l + r) >> 1;
    build(v << 1, l, m, a);
    build((v << 1) + 1, m, r, a);
    pull(v);
}

void add(int v, int l, int r, int tl, int tr, int x){
    if (r <= tl || l >= tr){
        return;
    }
    if (l >= tl && r <= tr){
        t[v] += x;
        md[v] += x;
        return;
    }
    push(v);
    int m = (l + r) >> 1;
    add(v * 2, l, m, tl, tr, x);
    add(v * 2 + 1, m, r, tl, tr, x);
    pull(v);
}

//min
int get(int v, int l, int r, int tl, int tr){
    if (r <= tl || l >= tr){
        return INF;
    }
    if (l >= tl && r <= tr){
        return t[v];
    }
    push(v);
    int m = (l + r) >> 1;

    int r1 = get(v * 2, l, m, tl, tr);
    int r2 = get(v * 2 + 1, m, r, tl, tr);
    pull(v);
    return min(r1, r2);
}


signed main() {
    //cerr << INF << '\n';
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, m, p;
    cin >> n >> m >> p;
    vector<pair<int, int>> a(n), b(m);

    for (int i =0 ; i < n; i++) cin >> a[i].ff >> a[i].ss;
    for (int j = 0; j < m; j++) cin >> b[j].ff >> b[j].ss;

    vector<pair<pair<int, int>, int>> z(p);
    for (int k = 0; k < p; k++) cin >> z[k].ff.ff >> z[k].ff.ss >> z[k].ss;

    stable_sort(a.begin(), a.end());
    stable_sort(b.begin(), b.end());
    stable_sort(z.begin(), z.end());

    memset(md, 0, sizeof md);
    build(1, 0, m, b);

    int chel = 0;
    int ans = -INF;
    for (int i = 0; i < n; i++){
        while(chel < p && z[chel].ff.ff < a[i].ff){
            int pos = (int)(lower_bound(b.begin(), b.end(), mp(z[chel].ff.ss + 1, -1)) - b.begin());
            add(1, 0, n, pos, n, -z[chel].ss);
            chel++;
        }
        int res = get(1, 0, n, 0, n);
        ans = max(ans, -a[i].ss - res);
        //cerr << ans << '\n';
    }

    cout << ans << '\n';

    return 0;
}