#define FASTIO ios::sync_with_stdio(false), cin.tie(0), cout.tie(0);

#ifndef BZ
#pragma GCC optimize ("Ofast")
#pragma GCC optimize ("unroll-loops")
#pragma target ("sse,sse2,sse3,ssse3,sse4,avx,abm,mmx,popcnt")
#endif

#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using pll = pair<ll, ll>;

#define F first
#define S second
#define pb push_back
#define mp make_pair
#define mt make_tuple
#define forEach(c) for (auto &it : c)
#define all(c) c.begin(), c.end()
#define rall(c) c.rbegin(), c.rend()

#ifdef LOCAL
#define LOG(v) cout << #v << ": " << v << "\n";
#else
#define LOG(v) ;
#endif

template <class T>
void chMin(T &a, T b) {
	if (b < a) a = b;
}

template <class T>
void chMax(T &a, T b) {
	if (a < b) a = b;
}

inline ll divUp(ll a, ll b) {
	return (a + b - 1) / b;
}

void solve() {
	ll n;
	cin >> n;
	vector<ll> a(n);
	vector<ll> b(n);
	forEach(a) cin >> it;
	forEach(b) cin >> it;
	ll cntA = 0;
	ll cntB = 0;
	for (ll i = 0; i < n; i++) {
		if (a[i] > b[i]) cntA++;
		if (b[i] > a[i]) cntB++;
	}
	if (cntA == 0) {
		cout << "-1\n";
		return;
	}
	ll p = 0;
	while (p * cntA <= cntB) p++;
	cout << p << "\n";
}

int main() {
	FASTIO
	solve();
	return 0;
}