#define FASTIO ios::sync_with_stdio(false), cin.tie(0), cout.tie(0);

#ifndef BZ
#pragma GCC optimize ("Ofast")
#pragma GCC optimize ("unroll-loops")
#pragma target ("sse,sse2,sse3,ssse3,sse4,avx,abm,mmx,popcnt")
#endif

#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using pll = pair<ll, ll>;

#define F first
#define S second
#define pb push_back
#define mp make_pair
#define mt make_tuple
#define forEach(c) for (auto &it : c)
#define all(c) c.begin(), c.end()
#define rall(c) c.rbegin(), c.rend()

#ifdef LOCAL
#define LOG(v) cout << #v << ": " << v << "\n";
#else
#define LOG(v) ;
#endif

template <class T>
void chMin(T &a, T b) {
	if (b < a) a = b;
}

template <class T>
void chMax(T &a, T b) {
	if (a < b) a = b;
}

inline ll divUp(ll a, ll b) {
	return (a + b - 1) / b;
}

void solve() {
	ll n; cin >> n;
	string s;
	cin >> s;
	for (char c = 'z'; c >= 'a'; c--) {
		bool flAll = true;
		while (flAll) {
			flAll = false;
			for (ll i = 0; i < s.size(); i++) {
				if (s[i] != c) continue;
				bool flag = false;
				if (i > 0) if (s[i - 1] == s[i] - 1) flag = true;
				if (i < s.size() - 1) if (s[i + 1] == s[i] - 1) flag = true;
				if (flag) {
					flAll = true;
					s[i] = '#';
				}
			}
			string ns;
			forEach(s) if (it != '#') ns.pb(it);
			s = move(ns);
		}
	}
	cout << n - s.size() << "\n";
}

int main() {
	FASTIO
	solve();
	return 0;
}