#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <cmath>
#include <string>
#include <sstream>
#include <set>
#include <map>
using namespace std;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n = 0, x;
    cin>>n;
    vector<long long> krasota(n);
    set<pair<long long, pair<long long, long long> >  > ans;
    for (int i = 0; i<n; i++){
        cin>>x;
        krasota[i]=x;
    }

    for (int j = n-1; j>=0; j--){

        set<pair<long long, pair<long long, long long> >   >::iterator it = ans.upper_bound({krasota[j], {0,0}});
        bool len = true;
        while(it!=ans.end()){
            if (krasota[(*it).second.second]-krasota[j]==(*it).second.second - j and (*it).second.second!=j){
                pair<long long, pair<long long, long long> >  p = *it;
                ans.erase(it);
                ans.insert({krasota[j], {p.second.first+krasota[j], j}});
                len = false;
                break;
            }
            it++;
        }
        if (len)
        ans.insert({krasota[j],{krasota[j], j} });

    }
    long long maxx = 0;
    for (set<pair<long long, pair<long long, long long> >   >::iterator it = ans.begin(); it!=ans.end(); it++){
        maxx = max(maxx, it->second.first);

    }
    cout<<maxx;
    return 0;

}
