#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <cmath>
#include <string>
#include <sstream>
#include <set>
#include <map>
using namespace std;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n = 0, m = 0, l = 0, r = 0;
    cin>>n>>m;
    vector<vector<int> > graph(n);
    for (int i = 0; i<m; i++){
        cin>>l>>r;
        l--, r--;
        graph[r].push_back(l);
    }
    int k = 0;
    cin>>k;
    vector<int> path(k);
    for (int i = 0; i<k; i++){
        cin>>path[i];
        path[i]--;
    }
    vector<int> d(n, n+2);
    set<pair<int, int> > ss;
    vector<int > kol(n);
    d[path.back()]=0;
    ss.insert({0,path.back()});
    while(ss.size()){
        int p = ss.begin()->second;
        ss.erase(ss.begin());
        for (int i: graph[p]){
            if (d[i]>d[p]+1){
                if (ss.find({d[i], i})!=ss.end()){
                    ss.erase({d[i], i});
                }
                d[i]=d[p]+1;
                kol[i]=1;
                ss.insert({d[i], i});
            }else{
                if (d[i]==d[p]+1){
                    kol[i]++;
                }
            }
        }
    }
    int mil = 0, maxr = 0;

    for (int i = 1; i<k-1; i++){
        if (d[path[i-1]]-d[path[i]]==1){
            if (kol[path[i-1]]>1){
                maxr++;
            }
        }else{
            mil++;
            maxr++;
        }
    }
    cout<<mil<<" "<<maxr;
    return 0;

}
