#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ld long double
#define INF32 2000000000
#define INF64 2e18
#define endl '\n'

int n, m;
vector<ll> a, t, ft;

void build(int v, int tl, int tr)
{
    if(tl == tr)
        t[v] = a[tl];
    else
    {
        int tm = (tl + tr) / 2;
        build(v * 2, tl, tm);
        build(v * 2 + 1, tm + 1, tr);
        t[v] = t[v * 2] + t[v * 2 + 1];
    }
}

ll get(int v, int tl, int tr, int l, int r)
{
    if(l > r)
        return 0;

    if(l == tl && r == tr)
        return t[v];

    int tm = (tl + tr) / 2;
    return (get(v * 2, tl, tm, l, min(r, tm)) +
            get(v * 2 + 1, tm + 1, tr, max(l, tm + 1), r));
}

void update(int v, int tl, int tr, int pos, ll val)
{
    if(tl == tr)
        t[v] = val;
    else
    {
        int tm = (tl + tr) / 2;
        if(pos <= tm)
            update(v * 2, tl, tm, pos, val);
        else
            update(v * 2 + 1, tm + 1, tr, pos, val);

        t[v] = t[v * 2] + t[v * 2 + 1];
    }
}

int main()
{
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    cin >> n;

    vector<int> a(n), b(n);
    for(int i = 0; i < n; i++)
        cin >> a[i];
    for(int i = 0; i < n; i++)
        cin >> b[i];

    int c1 = 0, c2 = 0;
    for(int i = 0; i < n; i++)
        if(a[i] && b[i] == 0)
            c1++;
        else if(b[i] && a[i] == 0)
            c2++;

    if(c1 == 0)
        cout << -1;
    else
        cout << ((c2 + 1) / c1) + ((c2 + 1) % c1 ? 1 : 0);

    /*cin >> n;
    a.resize(n);
    //t.resize(4 * n);

    for(int i = 0; i < n; i++)
        cin >> a[i];

    build(1, 0, n - 1);
    */
    return 0;
}
