#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ld long double
#define INF32 2000000000
#define INF64 2e18
#define endl '\n'

int n, m, s, f;
vector<ll> a, t, ft;
vector< pair<int, int> > d;
vector< vector<int> > g;

void build(int v, int tl, int tr)
{
    if(tl == tr)
        t[v] = a[tl];
    else
    {
        int tm = (tl + tr) / 2;
        build(v * 2, tl, tm);
        build(v * 2 + 1, tm + 1, tr);
        t[v] = t[v * 2] + t[v * 2 + 1];
    }
}

ll get(int v, int tl, int tr, int l, int r)
{
    if(l > r)
        return 0;

    if(l == tl && r == tr)
        return t[v];

    int tm = (tl + tr) / 2;
    return (get(v * 2, tl, tm, l, min(r, tm)) +
            get(v * 2 + 1, tm + 1, tr, max(l, tm + 1), r));
}

void update(int v, int tl, int tr, int pos, ll val)
{
    if(tl == tr)
        t[v] = val;
    else
    {
        int tm = (tl + tr) / 2;
        if(pos <= tm)
            update(v * 2, tl, tm, pos, val);
        else
            update(v * 2 + 1, tm + 1, tr, pos, val);

        t[v] = t[v * 2] + t[v * 2 + 1];
    }
}

void bfs(int s)
{
    vector<bool> used(n, 0);
    d.resize(n, make_pair(INF32, 0));
    d[s] = make_pair(0, 0);
    used[s] = true;
    queue<int> q;
    q.push(s);
    while(!q.empty())
    {
        int v = q.front();
        q.pop();
        for(int i = 0; i < g[v].size(); i++)
        {
            int to = g[v][i];
            //cout << v << ' ' << to << endl;
            if(!used[to])
            {
                d[to].first = d[v].first + 1;
                d[to].second = 1;
                q.push(to);
                used[to] = true;
            }
            else if(d[to].first == (d[v].first + 1))
            {
                d[to].second++;
            }
            //else
                //cout << v << ' ' << to << ' ' << d[to].first << ' ' << d[v].first << endl;
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    cin >> n >> m;
    g.resize(n, vector<int>(0));

    for(int i = 0; i < m; i++)
    {
        int u, v;
        cin >> u >> v;
        u--; v--;

        g[v].push_back(u);
    }
    int k;
    cin >> k;
    vector<int> p(k);
    for(int i = 0; i < k; i++)
    {
        cin >> p[i];
        p[i]--;
    }
    s = p[0];
    f = p[k - 1];
    bfs(f);

//    for(int i = 0; i < n; i++)
//        cout << d[i].first << ' ' << d[i].second << endl;

    int mn = 0, mx = 0, cmn = d[ p[0] ].first;
    for(int i = 0; i < k - 1; i++)
    {
        if(d[ p[i] ].first == cmn)
        {
            cmn--;
            if(i - 1 >= 0 && d[ p[i - 1] ].second > 1)
                mx++;
        }
        else
        {
            cmn = d[  p[i]  ].first - 1;
            mn++; mx++;
        }
    }

    cout << mn << ' ' << mx;

    /*cin >> n;
    a.resize(n);
    //t.resize(4 * n);

    for(int i = 0; i < n; i++)
        cin >> a[i];

    build(1, 0, n - 1);
    */
    return 0;
}
