#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ld long double
#define INF32 2000000228
#define INF64 2e18
#define endl '\n'

int n, m, p;
vector<int> a, t, d;

void push(int v)
{
    if(d[v])
    {
        //cout << v << ' ' << d[v] << endl;
        t[v * 2] += d[v];
        d[v * 2] += d[v];
        t[v * 2 + 1] += d[v];
        d[v * 2 + 1] += d[v];
        t[v] -= d[v];
        d[v] = 0;
    }
}

void build(int v, int tl, int tr)
{
    if(tl == tr)
        t[v] = a[tl];
    else
    {
        int tm = (tl + tr) / 2;
        build(v * 2, tl, tm);
        build(v * 2 + 1, tm + 1, tr);
        t[v] = max(t[v * 2], t[v * 2 + 1]);
    }
}

int get(int v, int tl, int tr, int l, int r)
{
    if(l > r)
        return -INF32;

    if(l == tl && r == tr)
        return t[v];

    //push(v);
    int tm = (tl + tr) / 2;
    return max(get(v * 2, tl, tm, l, min(r, tm)),
            get(v * 2 + 1, tm + 1, tr, max(l, tm + 1), r)) + d[v];
}

void add(int v, int tl, int tr, int l, int r, int z)
{
//    if(v == 1)
//        cout << v << ' ' << tl << ' ' << tr << ' ' << l << ' ' << r << ' ' << z << endl;
    if(l > r)
    {
        //NOTHING
    }
    else if(tl == l && r == tr)
    {
        t[v] += z;
        d[v] += z;
    }
    else
    {
        int tm = (tl + tr) / 2;

        //push(v);
        add(v * 2, tl, tm, l, min(r, tm), z);
        add(v * 2 + 1, tm + 1, tr, max(l, tm + 1), r, z);

        t[v] = max(t[v * 2], t[v * 2 + 1]) + d[v];
    }
}

int main()
{
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    cin >> n >> m >> p;

    vector< pair<int, int> > ca(n);
    vector< pair<int, int> > cb(m);
    a.resize(m);
    t.resize(4 * m);
    d.resize(4 * m, 0);

    for(int i = 0; i < n; i++)
        cin >> ca[i].first >> ca[i].second;

    sort(ca.begin(), ca.end());

    for(int i = 0; i < m; i++)
        cin >> cb[i].first >> cb[i].second;

    sort(cb.begin(), cb.end());
    for(int i = 0; i < m; i++)
        a[i] = (0 - cb[i].second);

    build(1, 0, m - 1);

    vector< pair< pair<int, int>, int> > cp(p);
    for(int i = 0; i < p; i++)
        cin >> cp[i].first.first >> cp[i].first.second >> cp[i].second;
    sort(cp.begin(), cp.end());

//    for(int i = 0; i < m; i++)
//        cout << get(1, 0, m - 1, i, i) << ' ';
//    cout << endl;

    int best = -INF32, pos = 0;
    for(int i = 0; i < n; i++)
    {
        while(pos < p && cp[pos].first.first < ca[i].first)
        {
            int l = upper_bound(cb.begin(), cb.end(), make_pair(cp[pos].first.second + 1, 0)) - cb.begin();
            //cout << l << endl;
            add(1, 0, m - 1, l, m - 1, cp[pos].second);
            pos++;
        }

//        for(int i = 0; i < m; i++)
//            cout << get(1, 0, m - 1, i, i) << ' ';
//        cout << endl;

        //cout << get(1, 0, m - 1, 0, m - 1) - ca[i].second << endl;
        best = max(best, get(1, 0, m - 1, 0, m - 1) - ca[i].second);
    }

    cout << best;

    return 0;
}
