#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/detail/standard_policies.hpp>
#define pb push_back
#define fst first
#define snd second
#define all(c) c.begin(), c.end()
using namespace std;
using namespace __gnu_pbds;
typedef long long ll;
typedef long double ld;
const ll INF64 = 2e18 + 228;
const int INF32 = 1e9 + 228;
template <typename T>
using ordered_set = tree <T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
///find_by_order
///lower_bound
mt19937_64 rng(42);
uniform_int_distribution<ll> nxt(0, 5);
ll n, m, p;
vector<pair<ll, ll> > a;
vector<pair<ll, ll> > c;
struct dragon
{
    ll f, s, m;
};
vector<dragon> g;
vector<ll> t;
vector<ll> ta;
void build(ll v, ll vl, ll vr)
{
    if(vl == vr)
    {
        t[v] = 0;
        ta[v] = 0;
        return;
    }
    ll vm = (vl + vr) / 2;
    build(2 * v, vl, vm);
    build(2 * v + 1, vm + 1, vr);
    t[v] = t[2 * v] + t[2 * v + 1];
}
void push(ll v, ll vl, ll vr)
{
    if(ta[v] != 0)
    {
        t[v] += ta[v];
        if(vl != vr)
            ta[2 * v] = ta[2 * v + 1] = ta[v];
        ta[v] = 0;
    }
}
void update(ll v, ll vl, ll vr, ll l, ll r, ll x)
{
    if(l > r) return;
    push(v, vl, vr);
    if(vl == l && vr == r)
    {
        ta[v] = x;
        push(v, vl, vr);
        return;
    }
    ll vm = (vl + vr) / 2;
    update(2 * v, vl, vm, l, min(vm, r), x);
    update(2 * v + 1, vm + 1, vr, max(vm + 1, l), r, x);
    t[v] = t[2 * v] + t[2 * v + 1];
}
ll sum(ll v, ll vl, ll vr, ll l, ll r)
{
    if(l > r) return 0;
//    cout << v << " " << vl << " " << vr << " " << l << " " << r << "\n";
    push(v, vl, vr);
    if(vl == l && vr == r)
        return t[v];
    ll vm = (vl + vr) / 2;
    return sum(2 * v, vl, vm, l, min(vm, r)) + sum(2 * v + 1, vm + 1, vr, max(vm + 1, l), r);
}
ll sz = 1e6 + 5;
ll get(ll y, ll x)
{
    ll pr = -(*lower_bound(all(c), make_pair(x, -INF64))).snd;
//    cout << x - 1 << "\n";
//    cout << sum(1, 0, sz - 1, 0, x - 1) << "\n";
    pr += sum(1, 0, sz - 1, 0, x - 1);
    return pr;
}
int main()
{
//    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    cin >> n >> m >> p;
    t.resize(sz * 4);
    ta.resize(sz * 4);
    a.resize(n);
    for(auto& it : a)
        cin >> it.fst >> it.snd;
    sort(all(a));
    vector<pair<ll, ll> > b;
    b.push_back(a[0]);
    for(int i = 1; i < n; i++)
    {
        while(b.size() && a[i].snd <= b.back().snd)
            b.pop_back();
        b.push_back(a[i]);
    }
    a.clear();
    a = b;
    c.resize(m);
    for(auto &it : c)
        cin >> it.fst >> it.snd;
    sort(all(c));
    vector< pair<ll, ll> > d;
    d.push_back(c[0]);
    for(int i = 1; i < m; i++)
    {
        while(d.size() && c[i].snd <= d.back().snd)
            d.pop_back();
        d.push_back(c[i]);
    }
    c.clear();
    c = d;
    g.resize(p);
    for(int i = 0; i < p; i++)
    {
        cin >> g[i].f >> g[i].s >> g[i].m;
    }
    sort(all(g), [](const dragon &a, const dragon &b)
         {
            return a.f == b.f ? (a.s == b.s ? a.m < b.m : a.s < b.s) : a.f < b.f;
         });
    n = a.size();
    m = c.size();
    ll ans = 0;
    for(int i = 0; i < p; i++)
    {
        update(1, 0, sz - 1, g[i].s, g[i].s, g[i].m);

        ll price = -(*lower_bound(all(a), make_pair(g[i].f + 1, -INF64))).snd;
//        cout << price << "\n";
        ll l = 0, r = sz - 1;
        while(r - l > 2)
        {
            ll m1 = l + (r - l) / 3;
            ll res1 = get(i, m1);
            ll m2 = r - (r - l) / 3;
            ll res2 = get(i, m2);
            if(res1 < res2)
                l = m1;
            else
                r = m2;
        }
//        cout << i << " " << l << " " << r << "\n";
        for(ll j = l; j <= r; j++)
        {
            ll cur = price + get(i, j);
//            cout << j << " - " << price << " " << cur << "\n";
            ans = max(cur, ans);
        }
    }
    cout << ans;
    return 0;
}
