#include <bits/stdc++.h>
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
#define int long long

using namespace std;

mt19937 rnd(time(nullptr));

const int MAXN = 1e6 + 7;

vector <int> tree(MAXN);

void upd(int pos, int x) {
    for (int i = pos; i < MAXN; i = (i | (i + 1)))
        tree[i] += x;
}

int get(int pos) {
    int res = 0;
    for (int i = pos; i >= 0; i = (i & (i + 1)) - 1)
        res += tree[i];
    return res;
}

int32_t main() {
    srand(time(nullptr));
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m, p;
    cin >> n >> m >> p;
    vector <pair <int, int> > a(n), b(m);
    for (int i = 0; i < n; i++)
        cin >> a[i].first >> a[i].second;
    map <int, int> smth;
    for (int i = 0; i < m; i++) {
        cin >> b[i].first >> b[i].second;
        if (smth.find(b[i].first) == smth.end())
            smth[b[i].first] = b[i].second;
        else
            smth[b[i].first] = min(smth[b[i].first], b[i].second);
    }
    vector <pair <int, int> > kek;
    for (auto el : smth)
        kek.push_back(el);
    vector <pair <int, int> > min_kek((int)kek.size());
    min_kek.back() = kek.back();
    for (int i = (int)kek.size() - 2; i >= 0; i--) {
        if (kek[i].second >= min_kek[i + 1].second)
            min_kek[i] = min_kek[i + 1];
        else
            min_kek[i] = kek[i];
    }
    vector <vector <int> > num(p, vector <int>(3));
    for (int i = 0; i < p; i++)
        cin >> num[i][0] >> num[i][1] >> num[i][2];
    sort(a.begin(), a.end());
    sort(b.begin(), b.end());
    sort(num.begin(), num.end());
    int ans = -1e18;
    if (a[0].first > num[0][0] && b[0].first > num[0][1])
        ans = num[0][2] - (a[0].second + b[0].second);
    else
        ans = -(a[0].second + b[0].second);
    int now = 0;
    for (int i = 0; i < n; i++) {
        set <int> all;
        while (now < p && num[now][0] < a[i].first) {
            upd(num[now][1], num[now][2]);
            all.insert(num[now][0]);
            now++;
        }
        for (auto el : all) {
            pair <int, int> need = {el, -1};
            if (upper_bound(kek.begin(), kek.end(), need) != kek.end()) {
                int ind = upper_bound(kek.begin(), kek.end(), need) - kek.begin();
                auto lol = min_kek[ind];
                int sum = get(lol.first - 1);
                ans = max(ans, sum - lol.second - a[i].second);
            }
        }
    }
    cout << ans << "\n";
    return 0;
}
