#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define all(a) (a).begin(), (a).end()
#define vc vector
//#define int long long

using namespace std;
//typedef tree<null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> rtree;

istream &operator >> (istream &in, vector<int> &v) {
    for (int &u : v) {
        in >> u;
    }
    return in;
}

ostream &operator << (ostream &out, vector<int> &v) {
    for (int &u : v) {
        out << u << ' ';
    }
    return out;
}

typedef unsigned long long ull;
const ull MOD = (1ull << 61) - 1;
ull red(ull a) {
    return (a & MOD) + (a >> 61);
}
ull mod(const ull a) {
    return red(red(a) + 1) - 1;
}
ull add(ull a, ull b) {
    return (a += b) >= MOD ? (a -= MOD) : a;
}
ull sub(ull a, const ull b) {
    return (a -= b) >= MOD ? (a += b) : a;
}
ull mul(const ull a, const ull b) {
    const ull a0 = a & ~0u, a1 = a >> 32;
    const ull b0 = b & ~0u, b1 = b >> 32;
    ull mid = a0 * b1 + a1* b0;
    return mod(red(a0 * b0) + (a1 * b1 << 3) + (mid >> 29) + (mid << 32 & MOD));
}

void add(int v, int l, int r, int pos, int val) {
    if (l + 1 == r) {
//        t[v] += val;
        return;
    }
    int m = (l + r) >> 1;
    int nxt = (v + ((m - l) << 1));
    if (pos < m) {
        add(v + 1, l, m, pos, val);
    } else {
        add(nxt, m, r, pos, val);
    }
}

const int N = 3e5;
vector<int> g[N];
vector<int> gr[N];
vector<int> p;
int used[N];
int d[N], cnt[N];

void bfs() {
    queue<int> q;
    q.push(p.back());
    cnt[q.front()] = 1;
    d[q.front()] = 1;
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        used[v] = 1;
        for (int u : gr[v]) {
            if (!used[u]) {
                used[u] = 1;
                d[u] = d[v] + 1;
                q.push(u);
            }
            if (d[u] == d[v] + 1) {
                cnt[u] += cnt[v];
            }
        }
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        --u;
        --v;
        g[u].push_back(v);
        gr[v].push_back(u);
    }
    int k;
    cin >> k;
    p.resize(k);
    cin >> p;
    for (int i = 0; i < k; ++i) {
        p[i]--;
    }
    bfs();
    int r = cnt[p[0]], mx = 0, mn = 0;
    for (int i = 1; i < k; ++i) {
        if (d[p[i]] + 1 != d[p[i - 1]]) {
            mn++;
            mx++;
        } else {
            if (cnt[p[i - 1]] != cnt[p[i]]) {
                mx++;
            }
        }
    }
    cout << mn << ' ' << mx;
}

signed main() {
#ifndef ONLINE_JUDGE
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif
    solve();
    return 0;
}