#include<iostream>
#include<vector>
#include<algorithm>
#include<iomanip>
#include<cmath>
#include<set>
#include<string>
#include<map>
#include<random>
#include<queue>

using namespace std;

typedef long long ll;
const ll INF=1e9;

int main(){
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int n, m;
	cin>>n>>m;
	vector<vector<int>> g(n);
	vector<vector<int>> gt(n);
	for(int i=0; i<m; i++){
		int x, y;
		cin>>x>>y;
		x--;
		y--;
		g[x].push_back(y);
		gt[y].push_back(x);
	}
	vector<int> d(n, INF);
	int k;
	cin>>k;
	vector<int> p(n);
	for(int i=0; i<k; i++){
		cin>>p[i];
		p[i]--;
	}
	int s=p[0];
	int f=p[k-1];
	d[f]=0;
	queue<int> q;
	q.push(f);
	while(!q.empty()){
		int v=q.front();
		q.pop();
		for(int j=0; j<gt[v].size(); j++){
			int to=gt[v][j];
			if(d[to]==INF){
				d[to]=d[v]+1;
				
				q.push(to);
			}
		}
	}
	int minans=0, maxans=0;
	map<int, int> cnt;
	bool flag=0;
	//int md=d[s];
	int prev=s;
	for(int j=0; j<g[s].size(); j++){
			int to=g[s][j];
			cnt[d[to]]++;
	}
	for(int i=1; i<k; i++){
		int v=p[i];
		int dist=k-i-1;
		int md=d[prev]-1;
		if(dist!=md){
			/*if(!flag){*/
			if(d[v]!=md){
				minans++;
			}
				maxans++;
			/*}*/
			/*else{
				if(cnt[md]>1){
					maxans++;
				}
			}
			flag=1;*/
			
		}
		else{
			if(cnt[dist]>1){
				maxans++;
			}
			flag=0;
		}
		cnt.clear();
		for(int j=0; j<g[v].size(); j++){
			int to=g[v][j];
			cnt[d[to]]++;
		}
		prev=v;
	}
	cout<<minans<< ' '<<maxans;
	return 0;
}