#include <bits/stdc++.h>

using namespace std;

#define int long long

typedef long long ll;
typedef pair<int, int> pii;


struct mon{
    int a;
    int b;
    int z;
};

vector<mon> str;

bool operator<(mon a, mon b) {
    if (a.a == b.a) {
        return a.b < b.b;
    }
    return a.a < b.a;
}

vector<int> tree;

void add(int v, int l, int r, int x, int s) {
    if (r - l == 1) {
        tree[v] += s;
        return;
    }
    int m =  l + (r - l) / 2;
    if (x < m) {
        add(2 * v, l, m, x, s);
    } else {
        add(2 * v + 1, m, r, x, s);
    }
    tree[v] = tree[2 * v] + tree[2 * v + 1];
}

int get(int v, int l, int r, int nl, int nr) {
    if (r <= nl || nr <= l) {
        return 0;
    }
    if (nl <= l && r <= nr) {
        return tree[v];
    }
    int m =  l + (r - l) / 2;
    int a = get(2 * v, l, m, nl, nr);
    int b = get(2 * v + 1, m, r, nl, nr);
    return a + b;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, m, p;
    cin >> n >> m >> p;
    vector<pii> a, b;
    a.resize(n);
    b.resize(m);
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        a[i] = {x, y};
    }
    for (int i = 0; i < m; i++) {
        int x, y;
        cin >> x >> y;
        b[i] = {x, y};
    }
    str.resize(p);
    vector<int> arm;
    for (int i = 0; i < p; i++) {
        int x, y, z;
        cin >> x >> y >> z;
        str[i] = {x, y, z};
        arm.push_back(y);
    }
    map<int, int> sec;
    int c = 0;
    /*
    for (int i : bron) {
        fir[i] = c;
        c++;
    }
    */

    sort(arm.begin(), arm.end());
    c = 1;
    sec[arm[0]] = 0;
    for (int j = 0; j < p; j++) {
        if (arm[j] == arm[0]) {
            continue;
        }
        if (sec[arm[j]] == 0) {
            sec[arm[j]] = c;
            c++;
        }
    }

    //sec[1] = 0;
    //sec[2] = 1;
    //sec[4] = 2;

    tree.resize(2 * c + 10);

    sort(str.begin(), str.end());
    vector<mon> str2 = str;
    for (int i = 0; i < p; i++) {
        str[i].b = sec[str[i].b];
    }
    vector<int> ans(p);
    for (int i = 0; i < p; i++) {
        mon now = str[i];
        //cout << now.a << " " << now.b << "\n";
        add(1, 0, c, now.b, now.z);
        ans[i] = get(1, 0, c, 0, now.b + 1);
        //cout << ans[i] << " ";
    }

    sort(a.begin(), a.end());
    sort(b.begin(), b.end());
    vector<pii> a1;
    pii last = a[n - 1];
    a1.push_back(last);
    for (int i = n - 2; i >= 0; i--) {
        if (a[i].second > last.second) {
            continue;
        } else {
            last = a[i];
            a1.push_back(last);
        }
    }
    vector<pii> b1;
    last = b[m - 1];
    b1.push_back(last);
    for (int i = m - 2; i >= 0; i--) {
        if (b[i].second > last.second) {
            continue;
        } else {
            last = b[i];
            b1.push_back(last);
        }
    }
    sort(a1.begin(), a1.end());
    sort(b1.begin(), b1.end());
    int answer = 0;
    for (int i = 0; i < p; i++) {
        pii wer = make_pair(str2[i].a, 0);
        int res = lower_bound(a1.begin(), a1.end(), wer) - a1.begin();
        if (res < a1.size()) {
            ans[i] -= a1[res].second;
        }
        wer = make_pair(str2[i].b, 0);
        int res2 = lower_bound(b1.begin(), b1.end(), wer) - b1.begin();
        if (res2 < b1.size()) {
            ans[i] -= b1[res2].second;
        }
        answer = max(ans[i], answer);
    }
    cout << answer;






    return 0;
}
