#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    cin >> n >> m;

    vector<vector<int>> g(n);
    vector<vector<int>> rev(n);
    for (int i = 0; i < m; i++)
    {
        int a, b;
        cin >> a >> b;
        a--;
        b--;

        g[a].push_back(b);
        rev[b].push_back(a);
    }

    int k;
    cin >> k;

    vector<int> path(k - 1);
    for (int i = 0; i < k - 1; i++)
    {
        cin >> path[i];
        path[i]--;
    }

    int f;
    cin >> f;
    f--;

    vector<int> dist(n, 1e9);
    vector<int> cnt(n, 0);
    queue<int> q;
    q.push(f);
    dist[f] = 0;
    cnt[f] = 1;

    while (!q.empty())
    {
        int u = q.front();
        q.pop();

        for (int v : rev[u])
        {
            if (dist[v] > dist[u] + 1)
            {
                dist[v] = dist[u] + 1;
                cnt[v] = 1;
                q.push(v);
            }
            else if (dist[v] == dist[u] + 1)
                cnt[v]++;
        }
    }

    int minv = 0;
    int maxv = 0;
    for (int i = 0; i < k - 2; i++)
    {
        if (dist[path[i]] == k - i - 1)
        {
            if (cnt[path[i]] > 1)
                maxv++;
        }
        else
        {
            minv++;
            maxv++;
        }
    }

    cout << minv << " " << maxv << endl;

    return 0;
}
