#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

vector<int> dist;
vector<vector<int>> g;
vector<vector<int>> rev;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    cin >> n >> m;

    g.resize(n);
    rev.resize(n);
    for (int i = 0; i < m; i++)
    {
        int a, b;
        cin >> a >> b;
        a--;
        b--;

        g[a].push_back(b);
        rev[b].push_back(a);
    }

    int k;
    cin >> k;

    vector<int> path(k - 1);
    for (int i = 0; i < k - 1; i++)
    {
        cin >> path[i];
        path[i]--;
    }

    int f;
    cin >> f;
    f--;

    dist.resize(n, 1e9);
    queue<int> q;
    q.push(f);
    dist[f] = 0;

    while (!q.empty())
    {
        int u = q.front();
        q.pop();

        for (int v : rev[u])
        {
            if (dist[v] > dist[u] + 1)
            {
                dist[v] = dist[u] + 1;
                q.push(v);
            }
        }
    }

    int minv = 0;
    int maxv = 0;
    for (int i = 0; i < k - 2; i++)
    {
        if (dist[path[i]] == k - i - 1)
        {
            for (int v : g[path[i]])
            {
                if (v != path[i + 1] && dist[v] == dist[path[i]] - 1)
                {
                    maxv++;
                    break;
                }
            }
        }
        else
        {
            minv++;
            maxv++;
        }
    }

    cout << minv << " " << maxv << endl;

    return 0;
}
