#include <bits/stdc++.h>

#define ll long long
#define pb push_back
#define ld long double
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define mp make_pair

using namespace std;

const int maxn = 2e5 + 100;
const ll maxv = 1e6 + 100;
const int inf = 1e9 + 7;


void init(){
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

ll dp[maxn];
int ax[maxn];
int ay[maxn];


int main(){
    init();

    int n, m, k;
    cin >> n >> m >> k;

    vector<pair<int,int > > a(n);
    vector<pair<int,int > > b(m);
    vector<pair<int, pair<int,int> > > mon(k);


    for (int i = 0 ; i < n; i++){
        cin >> a[i].ff >> a[i].ss;
    }
    for (int i = 0;i < m; i++){
        cin >> b[i].ff >> b[i].ss;
    }
    for (int i = 0 ;i < k;i++){
        cin >> mon[i].ss.ff >> mon[i].ss.ss >> mon[i].ff;
    }

    sort(all(a));
    sort(all(b));

    vector<pair<int,int> > ansa(maxv);

    for (int i = 0 ;i< maxv; i++){
        ansa[i] = mp(-1, inf);
    }

    int cur = a.size() - 1;



    for (int i = maxv - 2; i >= 0; i--){
        ansa[i] = ansa[i + 1];
        while(cur >= 0 && a[cur].ff > i){
            if (ansa[i].ss > a[cur].ss){
                ansa[i] = a[cur];
            }
            cur--;
        }
    }

    vector<pair<int,int> > ansb(maxv);
    for (int i = 0 ;i< maxv; i++)
        ansb[i] = mp(-1, inf);

    cur = b.size() - 1;
    for (int i = maxv - 2; i >= 0; i--){
        ansb[i] = ansb[i+ 1];
        while(cur >= 0 && b[cur].ff > i){
            if (ansb[i].ss > b[cur].ss){
                ansb[i] = b[cur];
            }
            cur--;
        }
    }


    dp[0] = mon[0].ff - (ansa[mon[0].ss.ff].ss + ansb[mon[0].ss.ss].ss);
    ax[0] = ansa[mon[0].ss.ff].ff;
    ay[0] = ansb[mon[0].ss.ss].ff;

    for (int i = 1; i< k; i++){
        dp[i] = dp[i - 1];
        ax[i] = ax[i - 1];
        ay[i] = ay[i - 1];
        if (mon[i].ss.ff < ax[i] && mon[i].ss.ss < ay[i]){
            dp[i] += mon[i].ff;
            continue;
        }

        ll add = 0;
        add += mon[i].ff;

        int nax = ansa[mon[i].ss.ff].ff;
        int nay = ansb[mon[i].ss.ss].ff;

        for (int j = 0; j < i; j++){
            if (mon[j].ss.ff < ax[i] && mon[j].ss.ss < ay[i])
                continue;
            if (mon[j].ss.ff < nax && mon[j].ss.ss < nay)
                add  += mon[j].ff;
        }

        if (ansa[mon[i].ss.ff].ff > ax[i])
            add -= (ansa[mon[i].ss.ff].ss - ansa[ax[i] - 1].ss);

        if (ansb[mon[i].ss.ss].ff > ay[i])
            add -= (ansb[mon[i].ss.ss].ss - ansb[ay[i] - 1].ss);

        //cout << "! " <<  i << endl;
        //cout << ax[i] << " " << ay[i] << endl;
        //cout << add << endl;

        if (add > 0){
            dp[i] += add;
            ax[i] = ansa[mon[i].ss.ff].ff;
            ay[i] = ansb[mon[i].ss.ss].ff;
        }

        ll res1 = mon[i].ff - (ansa[mon[i].ss.ff].ss + ansb[mon[i].ss.ss].ss);
        if (res1 > dp[i]){
            dp[i] = res1;
            ax[i] = ansa[mon[i].ss.ff].ff;
            ay[i] = ansb[mon[i].ss.ff].ff;
        }



    }

    cout << dp[k - 1] << endl;


    cout << endl;
#ifndef ONLINE_JUDGE
    system("pause");
#endif
    return 0;
}

