#include <bits/stdc++.h>

#define ll long long
#define pb push_back
#define ld long double
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define mp make_pair

using namespace std;

const int maxn = 2e5 + 100;
const ll maxv = 1e6 + 100;
const int inf = 1e9 + 7;


void init(){
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

struct node{
    ll mx;
    ll toadd;
    node(){}
};


node tree[4*maxn];
vector<pair<int,int> > resa;
vector<pair<int,int> > resb;
ll mas[maxn];


void add2(int pt, ll val){
    for (int i = pt; i < resb.size(); i++)
        mas[i] += val;
}

ll getmax2(){
    ll ans = -inf;
    for (int i = 0; i< resb.size(); i++){
        ans = max(ans, mas[i]);
    }
    return ans;
}

void build2(){
    for (int i = 0; i < resb.size(); i++){
        mas[i] = -resb[i].ss;
    }
}

inline int c1(int v){
    return 2*v + 1;
}

inline int c2(int v){
    return 2*v + 2;
}

void push(int v){
    tree[v].mx += tree[v].toadd;
    if (c2(v) < 4*maxn){
        tree[c1(v)].toadd += tree[v].toadd;
        tree[c2(v)].toadd += tree[v].toadd;
    }
    tree[v].toadd = 0;
}

ll getmax(int v){
    return tree[v].mx + tree[v].toadd;
}

void add(int v, int lcur, int rcur, int pt, ll val){
    push(v);
    if (lcur == rcur - 1){
        tree[v].mx += val;
        return;
    }
    if (lcur <= pt){
        tree[v].toadd += val;
        return;
    }
    int mcur = (lcur + rcur) / 2;
    if (mcur > pt){
        add(c1(v), lcur, mcur, pt, val);
    }
    add(c2(v), mcur, rcur, pt, val);
    tree[v].mx = max(getmax(c1(v)), getmax(c2(v)));
}

void build(int v, int lcur, int rcur){
    tree[v].toadd = 0;
    if (rcur == lcur + 1){
        tree[v].mx = -resa[lcur].ss;
        return;
    }
    int mcur = (lcur + rcur) / 2;
    build(c1(v), lcur, mcur);
    build(c2(v), mcur, rcur);
    tree[v].mx = max(tree[c1(v)].mx, tree[c2(v)].mx);
}



bool cmp(pair<int, pair<int,int> > &a, pair<int, pair<int,int> > &b){
    return a.ss.ff < b.ss.ff;
}


int main(){
    init();

    int n, m, k;
    cin >> n >> m >> k;

    vector<pair<int,int > > a(n);
    vector<pair<int,int > > b(m);
    vector<pair<int, pair<int,int> > > mon(k);


    for (int i = 0 ; i < n; i++){
        cin >> a[i].ff >> a[i].ss;
    }
    for (int i = 0;i < m; i++){
        cin >> b[i].ff >> b[i].ss;
    }
    for (int i = 0 ;i < k;i++){
        cin >> mon[i].ss.ff >> mon[i].ss.ss >> mon[i].ff;
    }

    sort(all(a));
    sort(all(b));
    sort(all(mon), cmp);

    resa.pb(a[0]);
    for (int i =1; i < a.size(); i++){
        while(resa.size() > 0 && resa.back().ss >= a[i].ss)
            resa.pop_back();
        resa.pb(a[i]);
    }

    resb.pb(b[0]);
    for (int i = 1; i< b.size(); i++){
        while(resb.size() > 0 && resb.back().ss >= b[i].ss)
            resb.pop_back();
        resb.pb(b[i]);
    }

    //for (int i = 0; i< resa.size(); i++){
        //cout <<resa[i].ff << " " << resa[i].ss << endl;
    //}
    //cout << endl;
    //for (int i = 0; i < resb.size(); i++){
        //cout << resb[i].ff << " " << resb[i].ss << endl;
    //}


    build(0, 0, resb.size());
    build2();

    int cur = 0;
    ll ans = -inf;

    for (int i = 0; i < resa.size(); i++){
        ll curans = -resa[i].ss;
        int str = resa[i].ff;
        for (;cur < mon.size() && mon[cur].ss.ff < str; cur++){
            int l = 0;
            int r = resb.size();
            while(l < r){
                int mcur = (l + r) / 2;
                if (resb[mcur].ff <= mon[cur].ss.ss)
                    l = mcur + 1;
                else
                    r = mcur;
            }
            add2(l, mon[i].ff);
            //add(0, 0, resb.size(), l, mon[cur].ff);
        }
        curans += getmax2();
        ans = max(ans, curans);
    }
    cout << ans;
    cout << endl;
#ifndef ONLINE_JUDGE
    system("pause");
#endif
    return 0;
}

