#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

// #define int long long

/*
struct Fen {
    int n;
    int *t;
    Fen (int _n) {
        n = _n;
        t = new int[n];
        memset(t, 0, sizeof(t[0]) * n);
    }
    void add(int i, int x) {
        for (;i < n; i = i | (i + 1))
            t[i] += x;
    }
    int get(int r) {
        r--;
        int res = 0;
        for (;r >= 0; r = (r & (r + 1)) - 1)
            res += t[r];
        return res;
    }
};
 */

/*

struct SegTree {
    int n;
    int *t, *d;

    SegTree(int _n) {
        n = _n;

        int sz = 1;
        while (sz < n * 2) sz *= 2;

        t = new int[sz];
        d = new int[sz];

        for (int i = 0; i < sz; ++i)
            t[i] = d[i] = 0;
    }

    int merge(int x, int y) {
        return max(x, y);
    }
    void push(int v) {
        t[v] += d[v];
        d[2 * v + 1] += d[v];
        d[2 * v + 2] += d[v];
        d[v] = 0;
    }
    int getV(int v) {
        return t[v] + d[v];
    }

    void upd(int v, int vl, int vr, int l, int r, int x) {
        if (vl == l && vr == r) {
            d[v] += x;
        } else {
            int m = (vl + vr) / 2;
            push(v);

            if (r <= m)
                upd(2 * v + 1, vl, m, l, r, x);
            else if (m <= l)
                upd(2 * v + 2, m, vr, l, r, x);
            else
                upd(2 * v + 1, vl, m, l, m, x), upd(2 * v + 2, m, vr, m, r, x);

            t[v] = merge(getV(2 * v + 1), getV(2 * v + 2));
        }
    }
    int get(int v, int vl, int vr, int l, int r) {
        if (vl == l && vr == r) {
            return getV(v);
        } else {
            int m = (vl + vr) / 2;
            push(v);

            if (r <= m)
                return get(2 * v + 1, vl, m, l, r);
            else if (m <= l)
                return get(2 * v + 2, m, vr, l, r);
            else
                return merge(get(2 * v + 1, vl, m, l, m), get(2 * v + 2, m, vr, m, r));
        }
    }

    void upd(int l, int r, int x) {
        if (l < r)
            upd(0, 0, n, l, r, x);
    }
    int get(int l, int r) {
        return get(0, 0, n, l, r);
    }
};

 */

/*
struct PrefSums {
    ll *t;

    PrefSums(int n, int *a) {
        t = new ll[n + 1];

        t[0] = 0;
        for (int i = 1; i <= n; ++i)
            t[i] = t[i - 1] + a[i - 1];
    }

    ll get(int l, int r) {
        return t[r] - t[l];
    }
};

 */

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    int n;
    cin >> n;

    string s;
    cin >> s;

    if (n >= 2) {
        int p_sums[n];

        p_sums[0] = s[0] - '0';
        p_sums[1] = s[1] - '0';

        for (int i = 2; i < n; ++i) {
            p_sums[i] = p_sums[i - 2] + s[i] - '0';
        }

        int q;
        cin >> q;

        auto func = [&](int l, int len) {
            int a = p_sums[l + len - 1] - ((l - 1 - (len % 2)) >= 0 ? p_sums[l - 1 - (len % 2)] : 0);
            int b = p_sums[l + len - 2] - ((l - 2 + (len % 2)) >= 0 ? p_sums[l - 2 + (len % 2)] : 0);

            return make_pair(a, b);
        };

        while (q--) {
            int l1, l2, len;
            cin >> l1 >> l2 >> len;
            l1--, l2--;

            if (len == 1) {
                cout << (s[l1] == s[l2] ? "Yes\n" : "No\n");
            } else {
                cout << (func(l1, len) == func(l2, len) ? "Yes\n" : "No\n");
            }

        }
    } else if (n == 1) {
        int q;
        cin >> q;

        while (q--)
            cout << "Yes\n";
    }

    return 0;
}