#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll INF = 1e18;

int main(){
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);

    ll n, m;
    cin >> n >> m;
    vector< vector<ll> > g(n), rev_g(n);
    for (ll i = 0; i < m; i++) {
        ll u, v;
        cin >> u >> v;
        u--;
        v--;
        g[u].push_back(v);
        rev_g[v].push_back(u);
    }
    ll k;
    cin >> k;
    vector<ll> path(k);
    for (ll i = 0; i < k; i++) {
        cin >> path[i];
        path[i]--;
    }

    queue<ll> q;
    vector<ll> dist(n, INF);
    dist[path[k - 1]] = 0;
    q.push(path[k - 1]);
    while (!q.empty()) {
        ll v = q.front();
        q.pop();
        for (ll i = 0; i < rev_g[v].size(); i++) {
            ll u = rev_g[v][i];
            if (dist[u] > dist[v] + 1) {
                dist[u] = dist[v] + 1;
                q.push(u);
            }
        }
    }

    ll res_max = 0, res_min = 0;
    for (ll i = 0; i + 1 < k; i++) {
        if (dist[path[i]] < k - i - 1) {
            ll dop = 0;
            for (ll j = 0; j < g[path[i]].size(); j++) {
                ll u = g[path[i]][j];
                if (dist[u] == dist[path[i]] - 1)
                    dop++;
            }
            if (dop == 1 && dist[path[i + 1]] == dist[path[i]] - 1) {
                continue;
            }
            else if (dist[path[i + 1]] != dist[path[i]] - 1) {
                res_max++;
                res_min++;
            }
            else {
                res_max++;
            }
        }
        else if (dist[path[i]] == k - i - 1) {
            ll dop = 0;
            for (ll j = 0; j < g[path[i]].size(); j++) {
                ll u = g[path[i]][j];
                if (dist[u] == k - i - 2)
                    dop++;
            }
            if (dop > 1) {
                res_max++;
            }
        }
    }
    cout << res_min << " " << res_max << '\n';
    return 0;
}
