#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <iomanip>
#include <string>
#include <algorithm>
#include <cmath>
#include <cassert>


using namespace std;


#define FAST_IO ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define ff first
#define ss second
#define int long long


typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;


const int MAXN = 2e5 + 5;
const ll INF = 1e18;
const ll MOD = 1e9 + 7;


signed main() {
    int n;
    cin >> n;
    vector<int> r(n);
    vector<int> b(n);
    for (int i = 0; i < n; i++) {
        cin >> r[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> b[i];
    }
    int cnt = 0;
    int same = 0;
    int have = 0;
    for (int i = 0; i < n; i++) {
        if (r[i] && !b[i]) {
            have++;
        }
        if (b[i] && !r[i]) {
            cnt++;
        }
        if (b[i] && r[i]) {
            same++;
        }
    }
    if (same == n || cnt == n || have == 0) {
        cout << "-1\n";
        return 0;
    }
    if (have > cnt) {
        cout << "1\n";
        return 0;
    }
    int need = have + cnt - have + 1;
    int ans = need / have;
    if (need % have != 0) {
        ans++;
    }
    cout << ans << "\n";
    return 0;
}
