//#pragma GCC optimize("-Ofast")
//#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define ll long long
#define ld long double
#define pb push_back
#define F first
#define S second
#define sqr(x) (x) * (x)

using namespace std;
using namespace __gnu_pbds;

mt19937 gen(time(0));

typedef tree<
int,
null_type,
less<int>,
rb_tree_tag,
tree_order_statistics_node_update>
ordered_set;

const int maxn = 2e5 + 555;
int d[maxn];
int cnt[maxn];
bool super[maxn];
vector <int> g[maxn];
int pos[maxn];

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    int n, m;
    cin >> n >> m;
    fill(d, d + n, -1);
    fill(pos, pos + n, -1);
    for(int i = 0; i < m; ++i)
    {
        int u, v;
        cin >> u >> v;
        --u;
        --v;
        g[v].pb(u);
    }
    int k;
    cin >> k;
    vector <int> path(k);
    for(int i = 0; i < k; ++i)
    {
        cin >> path[i];
        --path[i];
        pos[path[i]] = i;
    }
    queue <int> q;
    q.push(path.back());
    d[path.back()] = k - 1;
    while(!q.empty())
    {
        int v = q.front();
        if (d[v] == 0) break;
        q.pop();
        for(int to : g[v])
        {
            if (d[to] == -1)
            {
                d[to] = d[v] - 1;
                if (pos[to] > -1)
                    ++cnt[pos[to]];
                q.push(to);
                if (pos[v] > -1 && pos[to] > -1 && pos[to] + 1 == pos[v])
                    super[pos[to]] = true;
            }
            else
            if (d[to] == d[v] - 1)
            {
                if (pos[to] > -1)
                    ++cnt[pos[to]];
                if (pos[v] > -1 && pos[to] > -1 && pos[to] + 1 == pos[v])
                    super[pos[to]] = true;
            }
        }
    }
    int mn = 0, mx = 0;
    for(int i = 0; i < k - 1; ++i)
    {
        int to = path[i];
        if (!super[pos[to]])
        {
            ++mn;
            ++mx;
        }
        else
        if (cnt[pos[to]] > 1)
        {
            ++mx;
        }

    }
    cout << mn << ' ' << mx;
    return 0;
}
