//#pragma GCC optimize("-Ofast")
//#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define ll long long
#define ld long double
#define pb push_back
#define F first
#define S second
#define sqr(x) (x) * (x)

using namespace std;
using namespace __gnu_pbds;

mt19937 gen(time(0));

typedef tree<
int,
null_type,
less<int>,
rb_tree_tag,
tree_order_statistics_node_update>
ordered_set;

//const int maxn = 7e5 + 555;

const int inf = 2e9 + 66666;
const int maxm = 1000005;

struct fenwick
{
    int T[maxm + 5];
    int query(int i)
    {
        int ans = 0;
        for(i; i >= 0; i = (i & (i + 1)) - 1)
            ans += T[i];
        return ans;
    }

    void update(int i, int x)
    {
        int v = i;
        for(i; i < maxm; i = i | (i + 1))
        {
            T[i] += x;
        }
        return;
    }
};

fenwick ft;

const int maxn = 2e5 + 4;

pair <int, int> a[maxn];
int sufa[maxn];
pair <int, int> b[maxn];
int sufb[maxn];
pair <pair <int, int>, int> mon[maxn];

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    int n, m, p;
    cin >> n >> m >> p;
    for(int i = 0; i < n; ++i)
        cin >> a[i].F >> a[i].S;
    for(int i = 0; i < m; ++i)
        cin >> b[i].F >> b[i].S;
    for(int i = 0; i < p; ++i)
    {
        cin >> mon[i].F.F >> mon[i].F.S >> mon[i].S;
    }
    sort(a, a + n);
    sort(b, b + m);
    sort(mon, mon + p);
    sufa[n - 1] = a[n - 1].S;
    for(int i = n - 2; i >= 0; --i)
        sufa[i] = min(sufa[i + 1], a[i].S);
    sufb[m - 1] = b[m - 1].S;
    for(int i = m - 2; i >= 0; --i)
        sufb[i] = min(sufb[i + 1], b[i].S);
    int ans = -sufa[0] - sufb[0];
    int uk = 0;
    for(int i = 0; i < n; ++i)
    {
        while(uk < p && mon[uk].F.F < a[i].F)
        {
            ft.update(mon[uk].F.S, mon[uk].S);
            ++uk;
        }
        int mx = -inf;
        //dobavit b[0]
        int l = 0, r = m - 1;
        while(l <= r)
        {
            int m1 = (l + r) / 2;
            int m2 = m1 + 1;
            //
            if (m2 == m)
                m2 = m - 1;
            int ot1 = -sufb[m1] + ft.query(b[m1].F - 1);
            int ot2 = -sufb[m2] + ft.query(b[m2].F - 1);
            if (ot1 < ot2)
            {
                mx = max(mx, ot2);
                l = m1 + 1;
            }
            else
            {
                mx = max(mx, ot1);
                r = m1 - 1;
            }
        }
        mx -= sufa[i];
        ans = max(ans, mx);
    }
    cout << ans;
    return 0;
}

//1003067
