#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;

template <typename T>
using sset = __gnu_pbds::tree <
    T,
    __gnu_pbds::null_type,
    less <T>,
    __gnu_pbds::rb_tree_tag,
    __gnu_pbds::tree_order_statistics_node_update>;

typedef long long ll;

int n, m, k;
vector <vector <int> > g;
vector <int> p;

vector <int> d;
vector <set <int> > pr;

priority_queue <pair <int, int> > q;

int main() {
    ios_base::sync_with_stdio(false);

    cin >> n >> m;
    g.assign(n, vector <int>());

    for (int i = 0; i < m; i++) {
        int from, to;
        cin >> from >> to;
        from--; to--;

        g[to].push_back(from);
    }

    d.assign(n, 1e9);
    pr.assign(n, set <int>());

    cin >> k;
    p.assign(k, 0);
    for (int& x: p) {
        cin >> x;
        x--;
    }

    d[p.back()] = 0;

    q.push(make_pair(0, p.back()));

    while (!q.empty()) {
        int w, x;
        tie(w, x) = q.top();
        q.pop();

        for (int to: g[x]) {
            if (d[to] > w + 1) {
                d[to] = w + 1;
                q.push(make_pair(w + 1, to));
            }
        }
    }

    q.push(make_pair(0, p.back()));

    while (!q.empty()) {
        int w, x;
        tie(w, x) = q.top();
        q.pop();

        for (int to: g[x]) {
            if (w + 1 != d[to])
                continue;
            if (pr[to].empty())
                q.push(make_pair(w + 1, to));
            pr[to].insert(x);
        }
    }



    int ansmi = 0, ansma = 0;

    for (int i = 0; i < k - 1; i++) {
        if (pr[p[i]].size() == 1u) {
            if (*pr[p[i]].begin() != p[i + 1]) {
                ansmi++;
                ansma++;
            }
        }
        else {
            if (pr[p[i]].find(p[i + 1]) == pr[p[i]].end()) {
                ansmi++;
                ansma++;
            }
            else
                ansma++;
        }
    }

    cout << ansmi << ' ' << ansma;

    return 0;
}
