#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;

template <typename T>
using sset = __gnu_pbds::tree <
    T,
    __gnu_pbds::null_type,
    less <T>,
    __gnu_pbds::rb_tree_tag,
    __gnu_pbds::tree_order_statistics_node_update>;

typedef long long ll;

int n, m, k;
vector <vector <int> > g;
vector <int> in;
vector <int> p;

vector <int> d;
vector <int> kbest;

queue <int> q;

int main() {
    ios_base::sync_with_stdio(false);

    cin >> n >> m;
    g.assign(n, vector <int>());
    in.assign(n, 0);

    for (int i = 0; i < m; i++) {
        int from, to;
        cin >> from >> to;
        from--; to--;

        g[to].push_back(from);
        in[from]++;
    }

    d.assign(n, 1e9);
    kbest.assign(n, 0);

    cin >> k;
    p.assign(k, 0);
    for (int& x: p) {
        cin >> x;
        x--;
    }

    d[p.back()] = 0;
    q.push(p.back());

    while (!q.empty()) {
        int x = q.front();
        q.pop();

        for (int to: g[x]) {
            if (d[to] > d[x] + 1)
                d[to] = d[x] + 1;
            in[to]--;
            if (in[to] == 0)
                q.push(to);
        }
    }

    for (int i = 0; i < n; i++) {
        for (int to: g[i]) {
            if (d[to] == d[i] + 1) {
                kbest[to]++;
            }
        }
    }

    int ansmi = 0, ansma = 0;

    for (int i = 0; i < k - 1; i++) {
        if (kbest[p[i]] == 1) {
            if (d[p[i + 1]] + 1 != d[p[i]]) {
                ansmi++;
                ansma++;
            }
        }
        else {
            if (d[p[i + 1]] + 1 != d[p[i]]) {
                ansmi++;
                ansma++;
            }
            else
                ansma++;
        }
    }

    cout << ansmi << ' ' << ansma;

    return 0;
}
