#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;

const int N = 1e6 + 10;

template <typename T>
using sset = __gnu_pbds::tree <
    T,
    __gnu_pbds::null_type,
    less <T>,
    __gnu_pbds::rb_tree_tag,
    __gnu_pbds::tree_order_statistics_node_update>;

typedef long long ll;

int n, m, p;
vector <int> a, b;
vector <ll> ca, cb;
ll ans = -2e18;
vector <tuple <int, int, ll> > mon;
vector <ll> t, u;
vector <ll> pc;

void inp() {
    vector <pair <int, int> > ta;
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        ta.push_back(make_pair(y, x));
    }
    sort(ta.begin(), ta.end());

    a.push_back(ta[0].second);
    ca.push_back(ta[0].first);

    for (int i = 1; i < n; i++) {
        if (ta[i].second > a.back()) {
            if (ca.back() == ta[i].first) {
                ca.pop_back();
                a.pop_back();
            }
            a.push_back(ta[i].second);
            ca.push_back(ta[i].first);
        }
    }
    n = a.size();

    vector <pair <int, int> > tb;
    for (int i = 0; i < m; i++) {
        int x, y;
        cin >> x >> y;
        tb.push_back(make_pair(y, x));
    }
    sort(tb.begin(), tb.end());

    b.push_back(tb[0].second);
    cb.push_back(tb[0].first);

    for (int i = 1; i < m; i++) {
        if (tb[i].second > b.back()) {
            if (cb.back() == tb[i].first) {
                cb.pop_back();
                b.pop_back();
            }
            b.push_back(tb[i].second);
            cb.push_back(tb[i].first);
        }
    }
    m = b.size();

}

void build(int v, int tl, int tr) {
    if (tl == tr)
        t[v] = -pc[tl];
    else {
        int tm = (tl + tr) >> 1;
        build(v << 1, tl, tm);
        build((v << 1) + 1, tm + 1, tr);

        t[v] = max(t[v << 1], t[(v << 1) + 1]);
    }
}

void push(int v, int tl, int tr) {
    t[v] += u[v];
    if (tl != tr) {
        u[v << 1] += u[v];
        u[(v << 1) + 1] += u[v];
    }
    u[v] = 0;
}

void update(int v, int tl, int tr, int l, int r, ll add) {
    if (l > r)
        return;
    push(v, tl, tr);
    if (l > tr || tl > r)
        return;

    if (l <= tl && tr <= r) {
        u[v] += add;
        push(v, tl, tr);
    }
    else {
        int tm = (tl + tr) >> 1;
        update(v << 1, tl, tm, l, r, add);
        update((v << 1) + 1, tm + 1, tr, l, r, add);

        t[v] = max(t[v << 1], t[(v << 1) + 1]);
    }
}

ll rmq(int v, int tl, int tr, int l, int r) {
    if (l > r)
        return -2e18;
    push(v, tl, tr);
    if (l > tr || tl > r)
        return -2e18;
    if (l <= tl && tr <= r)
        return t[v];

    int tm = (tl + tr) >> 1;
    return max(
               rmq(v << 1, tl, tm, l, r),
               rmq((v << 1) + 1, tm + 1, tr, l, r)
                );
}

int main() {
    ios_base::sync_with_stdio(false);

    cin >> n >> m >> p;
    inp();

    for (int i = 0; i < p; i++) {
        int x, y;
        ll z;
        cin >> x >> y >> z;
        mon.push_back(make_tuple(x, y, z));
    }

    sort(mon.begin(), mon.end());

    pc.assign(N, 2e18);
    for (int i = 0; i < m; i++) {
        for (int j = b[i]; j >= 0 && pc[j] == 2e18; j--)
            pc[j] = cb[i];
    }

    t.assign(4 * N, 0);
    u.assign(4 * N, 0);
    build(1, 0, N - 1);

    int ptr = -1;
    for (int we = 0; we < n; we++) {
        while (ptr + 1 < p && get<0>(mon[ptr + 1]) < a[we]) {
            ptr++;
            int x, y;
            ll z;
            tie(x, y, z) = mon[ptr];
            update(1, 0, N - 1, y + 1, N - 1, z);
        }
        ans = max(ans, rmq(1, 0, N - 1, 0, N - 1) - ca[we]);
    }

    cout << ans;

    return 0;
}
