#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <string>
#include <map>


using namespace std;

#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define inf 1000000000ll;
#define x first
#define y second
#define ll long long

vector<ll> zfunc(string s)
{
	int n = s.length();
	vector<ll> z(n);
	z[0] = 0;
	ll l = 0, r = 0;
	for(int i = 1; i < n; i++)
	{
		if(i <= r)
		{
			z[i] = min(r - i + 1, z[l - i]);
		}
		while(i + z[i] < n && s[z[i]] == s[i + z[i]]) z[i]++;
	}
	return z;
}

int main()
{
	//---------------------------------------------
	#define int long long
	cin.tie(NULL);
	cout.tie(NULL);
	ios::sync_with_stdio(false);
	//---------------------------------------------
	
	int n;
	cin >> n;
	map<int, int> mp;
	int ans = 0;
	for(int i = 0; i < n; i++)
	{
		int t;
		cin >> t;
		mp[t - i] += t;
		ans = max(ans, mp[t - i]);
	}
	cout << ans;
#ifdef _DEBUG
	system("pause");
#endif
	return 0;
}