#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <string>
#include <map>


using namespace std;

#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define inf 1000000000ll;
#define x first
#define y second
#define ll long long

vector<ll> zfunc(string s)
{
	int n = s.length();
	vector<ll> z(n);
	z[0] = 0;
	ll l = 0, r = 0;
	for(int i = 1; i < n; i++)
	{
		if(i <= r)
		{
			z[i] = min(r - i + 1, z[l - i]);
		}
		while(i + z[i] < n && s[z[i]] == s[i + z[i]]) z[i]++;
	}
	return z;
}

int main()
{
	//---------------------------------------------
	#define int long long
	cin.tie(NULL);
	cout.tie(NULL);
	ios::sync_with_stdio(false);
	//---------------------------------------------
	int n;
	cin >> n;
	string s;
	cin >> s;
	vector<vector<int>> ind(300, vector<int>(0));

	int ans = 0;
	for(int i = 0; i < n; i++) 
	{
		ind[s[i]].push_back(i);
	}
	vector<int> prev(n + 1), next(n + 1);
	for(int i = 0; i < n; i++)
	{
		prev[i] = i - 1;
		next[i] = i + 1;
	}
	vector<char> active(n, true);
	for(int ttt = 0; ttt < 100; ttt++)
	{
		for(int now = 'z'; now >= 'b'; now--)
		{
			for(int ii = 0; ii < ind[now].size(); ii++)
			{
				auto i = ind[now][ii];
				if(!active[i]) continue;
				if(!((prev[i] >= 0 && s[prev[i]] == now - 1) || (next[i] < n && s[next[i]] == now - 1))) continue;
				active[i] = false;
				ans++;
				auto x = prev[i];
				auto y = next[i];
				if(x >= 0 && y < n)
				{
					prev[y] = x;
					next[x] = y;
					continue;
				}
				else if(x < 0 && y < n)
				{
					prev[y] = -1;
					continue;
				}
				else if(x >= 0 && y >= n)
				{
					next[x] = n;
					continue;
				}
			}
		}
	}
	cout << ans;
#ifdef _DEBUG
	system("pause");
#endif
	return 0;
}