#include <bits/stdc++.h>

#define ll long long
#define pb push_back
#define pii pair<int,int>
#define fi first
#define se second
#define mt make_tuple
#define ld long double
#define all(v) v.begin(),v.end()
#define rall(v) v.rbegin(),v.rend()
#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx2")
#define int long long

using namespace std;
mt19937 rnd(time(0));

const int mx = 2*1e5+10;
int t[4*mx];
int psh[4*mx];
vector<pii> A;

void push(int v){
    psh[v*2]+=psh[v];
    psh[v*2+1]+=psh[v];
    t[v*2]+=psh[v];
    t[v*2+1]+=psh[v];
    psh[v] = 0;
}

void build(int v, int tl, int tr){
    if(tl==tr){
        t[v] = A[tl].se;
        return;
    }
    int tm = (tl+tr)/2;
    build(v*2,tl,tm);
    build(v*2+1,tm+1,tr);
    t[v] = max(t[v*2],t[v*2+1]);
}

int get(int v, int tl, int tr, int l, int r){
    if(l>r) return -1e18;
    if(tl==l && tr==r){
        return t[v];
    }
    push(v);
    int tm = (tl+tr)/2;
    return max(get(v*2,tl,tm,l,min(r,tm)),get(v*2+1,tm+1,tr,max(tm+1,l),r));
}

void upd(int v, int tl, int tr, int l, int r, int wh){
    if(l>r) return;
    if(tl==l && tr==r){
        psh[v]+=wh;
        t[v]+=wh;
        return;
    }
    push(v);
    int tm = (tl+tr)/2;
    upd(v*2,tl,tm,l,min(tm,r),wh);
    upd(v*2+1,tm+1,tr,max(tm+1,l),r,wh);
    t[v] = max(t[v*2],t[v*2+1]);
}

main(){
    ios::sync_with_stdio(false);
    cin.tie(0);
    //freopen("in","r",stdin);
    int n,m,p;
    cin>>n>>m>>p;
    A.resize(n);
    for(int i = 0; i < n; i++){
        cin>>A[i].fi>>A[i].se;
        A[i].se=-A[i].se;
    }
    sort(all(A));
    vector<int> a(n);
    for(int i = 0; i < n; i++) a[i] = A[i].fi;
    build(1,0,n-1);


    vector<pii> b(m);
    for(auto &t:b) cin>>t.fi>>t.se;
    sort(all(b));



    vector< tuple<int,int,int> > mon(p);
    for(auto &t:mon){
        int a,b,c;
        cin>>a>>b>>c;
        t = mt(b,a,c);
    }
    sort(all(mon));

    int ptr = -1;
    int ans = -1e18-10;
    for(int i = 0; i < m; i++){
        while(ptr+1<n && get<0>(mon[ptr+1])<b[i].fi){
            ptr++;
            int id = lower_bound(all(a),get<1>(mon[ptr])) - a.begin();
            id++;
            upd(1,0,n-1,id,n-1,get<2>(mon[ptr]));
        }
        ans = max(ans,get(1,0,n-1,0,n-1)-b[i].se);
    }
    cout<<ans;
}
