#include <bits/stdc++.h>

#define pb push_back
#define F first
#define S second
#define bit __builtin_popcount
#define all(x) x.begin(),x.end()
#define lb lower_bound
#define ub upper_bound

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef pair<int,int> pii;
typedef pair<ll,ll> pll;
typedef long double ld;

const ll maxn=5e5+123;
const ll inf=1e9+123;
const ll linf=1e18+123;
const ll mod=1e9+7;
const ll pi=acos(-1);

vector<int> z_function(string s){
    int n=s.size();
    vector<int>z(n);
    for(int i=1,l=0,r=0;i<n;i++){
        if(i<=r){
            z[i]=min(r-i+1,z[i-l]);
        }
        while(i+z[i]<n && s[z[i]]==s[i+z[i]]){
            z[i]++;
        }
        if(i+z[i]-1>r){
            l=i;
            r=i+z[i]-1;
        }
    }
    return z;
}

vector<int> prefix_function(string s){
    int n=s.size();
    vector<int>v(n);
    for(int i=1;i<n;i++){
        int j=v[i-1];
        while(j>0 && s[i]!=s[j]){
            j=v[j-1];
        }
        if(s[i]==s[j]){
            j++;
        }
        v[i]=j;
    }
    return v;
}
int a[maxn],b[maxn],ans[maxn];
int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin>>n;
    for(int i=1;i<=n;i++){
        cin>>a[i];
    }
    bool ok=0;
    for(int i=1;i<=n;i++){
        cin>>b[i];
        if(a[i]!=b[i]){
            ok=1;
        }
    }
    if(ok==0){
        cout<<"-1";
        return 0;
    }
    for(int i=1;i<=n;i++){
        ans[i]=1;
    }
    int cntr=0,cntr1=0;
    for(int i=1;i<=n;i++){
        if(a[i]==1 && b[i]==0){
            cntr++;
        }
        if(a[i]==0 && b[i]==1){
            cntr1++;
        }
    }
    if(cntr==0 && cntr1>=1){
        cout<<"-1";
        return 0;
    }
    cntr1/=cntr;
    cntr=cntr1%cntr;
    cntr++;
    for(int i=1;i<=n;i++){
        if(a[i]==1 && b[i]==0){
            if(cntr>=1){
                cntr--;
                ans[i]=cntr1+1;
            }
            else{
                ans[i]=cntr1;
            }
        }
    }
    int mx=0;
    for(int i=1;i<=n;i++){
        mx=max(mx,ans[i]);
    }
    cout<<mx;
    exit(0);
}
