#include <bits/stdc++.h>

#define pb push_back
#define F first
#define S second
#define bit __builtin_popcount
#define all(x) x.begin(),x.end()
#define lb lower_bound
#define ub upper_bound

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef pair<int,int> pii;
typedef pair<ll,ll> pll;
typedef long double ld;

const ll maxn=5e5+123;
const ll inf=1e9+123;
const ll linf=1e18+123;
const ll mod=1e9+7;
const ll pi=acos(-1);

vector<int> z_function(string s){
    int n=s.size();
    vector<int>z(n);
    for(int i=1,l=0,r=0;i<n;i++){
        if(i<=r){
            z[i]=min(r-i+1,z[i-l]);
        }
        while(i+z[i]<n && s[z[i]]==s[i+z[i]]){
            z[i]++;
        }
        if(i+z[i]-1>r){
            l=i;
            r=i+z[i]-1;
        }
    }
    return z;
}

vector<int> prefix_function(string s){
    int n=s.size();
    vector<int>v(n);
    for(int i=1;i<n;i++){
        int j=v[i-1];
        while(j>0 && s[i]!=s[j]){
            j=v[j-1];
        }
        if(s[i]==s[j]){
            j++;
        }
        v[i]=j;
    }
    return v;
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin>>n;
    string s;
    cin>>s;
    for(int k=26;k>=2;k--){
        string t="";
        for(int i=0;i<s.size();i++){
            if((s[i]-'a'+1)!=k){
                t+=s[i];
                continue;
            }
            else{
                if(t.size()>=1 && t.back()==s[i]-1){
                    continue;
                }
                t+=s[i];
            }
        }
        s=t;
        t="";
        for(int i=s.size()-1;i>=0;i--){
            if((s[i]-'a'+1)!=k){
                t+=s[i];
                continue;
            }
            else{
                if(t.size()>=1 && t.back()==s[i]-1){
                    continue;
                }
                t+=s[i];
            }
        }
        s=t;
    }
    cout<<n-s.size();
    exit(0);
}
