#include <bits/stdc++.h>

using namespace std;

#define int long long
#define left left228
#define right right228
#define next next228
#define y1 y1228
#define y2 y2228

template<typename T> void uin(T &a, T b) {
	if (b < a) a = b;
}
template<typename T> void uax(T &a, T b) {
	if (b > a) a = b;
}

const int N = 228228;
const int INF = 1e9 + 228;

int n, m;
vector<int> g[N];
int p[N], dist[N];

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> n >> m;
	vector< pair<int, int> > edges;
	for (int i = 0; i < m; ++i){
		int u, v;
		cin >> u >> v;
		edges.emplace_back(u, v);
		g[v].push_back(u);
	}
	int k;
	cin >> k;
	for (int i = 1; i <= k; ++i){
		cin >> p[i];
	}
	for (int i = 1; i <= n; ++i) {
		dist[i] = INF;
	}
	dist[p[k]] = 0;
	priority_queue< pair<int, int> > q;
	q.push({0, p[k]});
	while (!q.empty()) {
		pair<int, int> p = q.top();
		q.pop();
		int v = p.second;
		for (int to : g[v]) {
			if (dist[v] + 1 < dist[to]) {
				dist[to] = dist[v] + 1;
				q.push({-dist[to], to});
			}
		}
	}
	for (int i = 1; i <= n; ++i) {
		g[i].clear();
	}
	for (auto p : edges) {
		g[p.first].push_back(p.second);
	}
	int minim = k - 1;
	int maxim = k - 1;
	for (int i = 1; i < k; ++i) {
		int v = p[i];
		int to = p[i + 1];
		if (dist[v] - 1 == dist[to]) {
			--minim;
			bool BAD = 0;
			for (int go : g[v]) {
				if (go != to && dist[v] - 1 == dist[to]) {
					BAD = 1;
					break;
				}
			}
			if (!BAD) --maxim;
		}
	}
	cout << minim << " " << maxim << endl;
	return 0;
}