
#include <iostream>
#include "vector"
#include "algorithm"
#include "unordered_map"

#define int long long
using namespace std;

signed main() {
    int n;
    cin >> n;
    vector<int> b(n);
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
        b[i] -= i;
    }
    unordered_map<int, int> cnt;
    for (int i = 0; i < n; ++i) {
        cnt[b[i]] += b[i] + i;
    }
    int ans = 0;
    for (auto elem: b) {
        ans = max(ans, cnt[elem]);
    }
    cout << ans;
    return 0;
}
