#include <bits/stdc++.h>
using namespace std;

#define fi first
#define se second
#define mp make_pair
#define pb push_back
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()
#define pii pair<int, int>
#define vi vector<int>

typedef long long ll;
typedef long double ld;
typedef short inth;

const int N = 2e5;
const int M = N + 7;
const int MOD = 1e9 + 7;
const ll INF = 1e16 + 17;
const double EPS = 1e-10;

int n, m;

vi gR[M];
int a[M];

int d[M];

bool sec[M];

void bfs(int v) {
    queue<int> q;
    q.push(v);

    for (int i = 0; i < M; ++i)
        d[i] = MOD;
    d[v] = 0;

    while (!q.empty()) {
        v = q.front();
        q.pop();
        for (auto to : gR[v]) {
            if (d[to] > d[v] + 1) {
                d[to] = d[v] + 1;
                q.push(to);
            } else if (d[to] == d[v] + 1) {
                sec[to] = 1;
            }
        }
    }
}

int main() {
    scanf("%d %d", &n, &m);
    for (int i = 1; i <= m; ++i) {
        int v, u;
        scanf("%d %d", &v, &u);
        gR[u].pb(v);
    }

    int k;
    scanf("%d", &k);
    for (int i = 1; i <= k; ++i)
        scanf("%d", &a[i]);
    
    bfs(a[k]);

    int mn = 0, mx = 0;
    for (int i = k - 1; i >= 1; --i) {
        if (d[a[i + 1]] != d[a[i]] - 1) {
            mn++;
            mx++;
        } else {
            if (sec[a[i]])
                ++mx;
        }
    }

    printf("%d %d\n", mn, mx);
    return 0;
}