#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

const int MAXN = 1e5 + 5;
const ll INF = 1e18;

int n;
int r1[MAXN],r2[MAXN];

bool check(ll mid) {
	ll res1 = 0, res2 = 0;
	for (int i = 0; i < n; ++i) {
		if (r1[i] == 0) {
			if (r2[i] == 1) ++res2;
			continue;
		}
		res1 += mid;
		if (r2[i] != 0) res2 += mid;
	}
	return (res1 > res2);
}

void solve() {
	ll l = 0, r = INF;
	while (r - l > 1) {
		ll mid = (l + r) / 2;
		if (check(mid)) r = mid;
		else l = mid;
	}
	if (r == INF) cout << -1 << endl;
	else cout << r << endl;
}

int main() {
	cin >> n;
	for (int i = 0; i < n; ++i) cin >> r1[i];
		for (int i = 0; i < n; ++i) cin >> r2[i];
		solve();
	return 0;
}
