#include<bits/stdc++.h>

using namespace std;

const int MAXN = 2e5 + 5;
const int INF = 1e9;

int n, m;
vector<int> g[MAXN];
vector<int> rev_g[MAXN];
int k;
int way[MAXN];
int nextv[MAXN];
bool can[MAXN];
int counter[MAXN];

void dijkstra(int st) {
	set<pair<int, int>> q;
	vector<bool> used(n);
	vector<int> dist(n, INF);
	dist[st] = 0;
	q.insert({0, st});
	while (!q.empty()) {
		auto top = *q.begin();
		q.erase(q.begin());
		int curv = top.second;
		//cout << "curv: " << curv << endl;
		if (used[curv]) continue;
		dist[curv] = top.first;
		used[curv] = true;
		//cout << "curv: " << curv << ' ' << counter[curv] << ' ' << can[curv] << endl;
		for (auto to : rev_g[curv]) {
			if (used[to]) continue;
			if (dist[to] == dist[curv] + 1) {
				++counter[to];
				if (nextv[to] == curv) can[to] = true;
			}
			if (dist[to] > dist[curv] + 1) {
				counter[to] = 1;
				if (nextv[to] == curv) can[to] = true;
				else can[to] = false;
				dist[to] = dist[curv] + 1;
				q.insert({dist[to], to});
			}	
		}
	}
}	

void solve() {
	memset(nextv, -1, sizeof nextv);
	for (int i = 0; i < k - 1; ++i) {
		nextv[way[i]] = way[i + 1];
	}
	dijkstra(way[k - 1]);
	int maxi = 0;
	int mini = 0;
	for (int i = 0; i < k - 1; ++i) {
		if (!can[way[i]] || counter[way[i]] > 1) ++maxi;
		if (!can[way[i]]) ++mini;
	}
	cout << mini << ' ' << maxi << endl;
}

int main() {
	cin >> n >> m;
	for (int i = 0; i < m; ++i) {
		int u, v;
		cin >> u >> v; --u; --v;
		g[u].push_back(v);
		rev_g[v].push_back(u);
	}
	cin >> k;
	for (int i = 0; i < k; ++i) {
		cin >> way[i];
		--way[i];
	}
	solve();
	return 0;
}