#include<bits/stdc++.h>

using namespace std;

const int MAXN = 2e5 + 5;

int n;
string s;
int pref[MAXN];
int segs[MAXN];
int ss[MAXN];

bool check(int l1, int r1, int l2, int r2) {
	int len = r1 - l1 + 1;
	if (r1 - l1 + 1 < 3) {
		for (int i = 0; i < len; ++i) if (s[l1 + i] != s[l2 + i]) return false;
		return true;
	}
	int sum1 = pref[r1], sum2 = pref[r2];
	if (l1 != 0) sum1 -= pref[l1 - 1];
	if (l2 != 0) sum2 -= pref[l2 - 1];
	if (sum1 != sum2) return false;
	int segs1 = segs[r1];
	if (l1 != 0) {
		segs1 -= segs[l1 - 1];
		if (s[l1] == '1') ++segs1;
	}
	int segs2 = segs[r2];
	if (l2 != 0) {
		segs2 -= segs[l2 - 1];
		if (s[l2] == '1') ++segs2;
	}
	int s1 = ss[r1], s2 = ss[r2];
	if (l1 != 0) s1 -= ss[l1 - 1];
	if (l2 != 0) s2 -= ss[l2 - 1];
	if (s[l1 + 1] == '0' && s[l1] == '1') ++s1;
	if (s[l2 + 1] == '0' && s[l2] == '1') ++s2;
	if (s[r1] == '1' && s[r1 - 1] == '0') ++s1;
	if (s[r2] == '1' && s[r2 - 1] == '0') ++s2;
	//cout << "s: " << s1 << ' ' << s2 << endl;
	return (s1 <= s2 && segs2 - (s2 - s1) == segs1);
}

void solve() {
	for (int i = 0; i < n; ++i) {
		if (s[i] == '1') pref[i] = 1;
		else pref[i] = 0;
		if (i != 0) pref[i] += pref[i - 1];
	}
	int counter = 0;
	bool ok = false;
	for (int i = 0; i < n; ++i) {
		if (s[i] == '1') {
			if (!ok) {
				ok = true;
				++counter;
			}
		} else {
			if (ok) {
				ok = false;
			}
		}
		
		bool left = false, right = false;
		if (i == 0) left = true;
		if (i == n - 1) right = true;
		if (i != 0 && s[i - 1] == '0') left = true;
		if (i != n - 1 && s[i + 1] == '0') right = true;
		if (s[i] == '1' && right && left) ss[i] = 1;
		if (i != 0) ss[i] += ss[i - 1];
		//cout << "i: " << i << ' ' << ss[i] << endl;
		segs[i] = counter;
	}

	int q;
	cin >> q;
	while (q--) {
		int l1, l2, len;
		cin >> l1 >> l2 >> len; --l1; --l2;
		int r1 = l1 + len - 1, r2 = l2 + len - 1;
		if (check(l1, r1, l2, r2)) cout << "Yes\n";
		else cout << "No\n";
	}
}

int main() {
	cin >> n;
	cin >> s;
	solve();
	return 0;
}