#include <bits/stdc++.h>

using namespace std;

#define int long long

const int MAXN = 2e5 + 75;

int a[MAXN];
int pr[MAXN];

const int mod = 2e9 + 179;
const int p = 3;

int p1[MAXN];
int h[MAXN];

int get_hash(int l, int r)
{
    int ans = h[r] - h[l] * p1[r - l];
    ans %= mod;
    if (ans < 0)
    {
        ans += mod;
    }
    return ans;
}

int t[4 * MAXN];

void update(int v, int tl, int tr, int pos, int val)
{
    if (tr - tl == 1 && tl == pos)
    {
        t[v] += val;
        return;
    }
    if (tl > pos || pos >= tr)
    {
        return;
    }
    update(2 * v + 1, tl, (tl + tr) / 2, pos, val);
    update(2 * v + 2, (tl + tr) / 2, tr, pos, val);
    t[v] = t[2 * v + 1] + t[2 * v + 2];
    return;
}

int get(int v, int tl, int tr, int l, int r)
{
    if (l <= tl && tr <= r)
    {
        return t[v];
    }
    if (l >= tr || tl >= r)
    {
        return 0;
    }
    int ans = get(2 * v + 1, tl, (tl + tr) / 2, l, r) + get(2 * v + 2, (tl + tr) / 2, tr, l, r);
    t[v] = t[2 * v + 1] + t[2 * v + 2];
    return ans;
}

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n;
    cin >> n;
    string s;
    cin >> s;
    p1[0] = 1;
    for (int i = 1; i < MAXN; ++i)
    {
        p1[i] = (p1[i - 1] * p) % mod;
    }
    pr[0] = 0;
    for (int i = 0; i < n; ++i)
    {
        pr[i + 1] = pr[i];
        if (s[i] == '1')
        {
            pr[i + 1]++;
        }
    }
    h[0] = 0;
    for (int i = 0; i < n; ++i)
    {
        h[i + 1] = ((h[i] * p + (s[i] - '0' + 1)) % mod + mod) % mod;
    }
    for (int i = 1; i < n; ++i)
    {
        if (s[i] == '1' && s[i - 1] == '1')
        {
            update(0, 0, MAXN, i, 1);
        }
    }
    int q;
    cin >> q;
    for (int _ = 0; _ < q; ++_)
    {
        int l1, l2, len;
        cin >> l1 >> l2 >> len;
        --l1; --l2;
        if (l1 > l2)
        {
            swap(l1, l2);
        }
        vector<int> a;
        vector<int> b;
        int cur = 0;
        for (int i = l1; i < l1 + len; ++i)
        {
            cur += (s[i] - '0');
            if (s[i] == '0')
            {
                a.push_back(cur % 2);
            }
        }
        cur = 0;
        for (int i = l2; i < l2 + len; ++i)
        {
            cur += (s[i] - '0');
            if (s[i] == '0')
            {
                b.push_back(cur % 2);
            }
        }
        if (a == b)
        {
            cout << "Yes" << endl;
        }
        else
        {
            cout << "No" << endl;
        }
    }
    return 0;
}
