#include <bits/stdc++.h>

#define int long long
#define x first
#define y second
#define pb push_back
#define endl '\n'
#define pp pair<int, int>
#define ld long double
#define ull unsigned long long

using namespace std;

const int N = 3e5 + 100, K = 1e6 + 100, P = 13, LOG = 20;

int h[N]{}, k[N], m[N], tin[N], tout[N], timer = 1, up[N][LOG];
vector<int> g[N], ans[N], st[N], s[N];
map<int, vector<int> > virus[N];
map<int, int> tmp[N];
vector<pp> query[N];
vector<pair<int, pp> > his[N];

void dfs0(int v, int p = 1) {
    tin[v] = ++timer;
    up[v][0] = p;
    for(int i = 1; i < LOG; ++i) {
        up[v][i] = up[up[v][i - 1]][i - 1];
    }

    for(auto i : g[v]) {
        if(i == p) continue;

        h[i] = h[v] + 1;
        dfs0(i, v);
    }
    tout[v] = ++timer;
}

int d1, d2, from1, from2;

void add(int v, int qu, int tt) {
    if(!tmp[v].count(qu)) {
        tmp[v][qu] = tt;
    }
    else {
        from1 = st[qu][tt];
        d1 = (abs(h[from1] - h[v]) + s[qu][tt] - 1) / s[qu][tt];
        from2 = st[qu][tmp[v][qu]];
        d2 = (abs(h[from2] - h[v]) + s[qu][tmp[v][qu]] - 1) / s[qu][tmp[v][qu]];
        if(d1 < d2) {
            tmp[v][qu] = tt;
        }
        else if(d1 == d2 && tt < tmp[v][qu]) {
            tmp[v][qu] = tt;
        }
    }
}

void dfs(int v, int p = 1) {
    int from1, from2, d1, d2;
    for(auto p : virus[v]) {
        for(auto tt : p.y) {
            add(v, p.x, tt);
        }
    }
    for(auto i : g[v]) {
        if(i == p) continue;

        dfs(i, v);
        if(tmp[i].size() > tmp[v].size()) {
            swap(tmp[i], tmp[v]);
        }
        for(auto P : tmp[i]) {
            add(v, P.x, P.y);
        }
    }

}

bool upper(int a, int b) {
    if(tin[a] <= tin[b] && tout[b] <= tout[a]) return 1;
    return 0;
}

int lca(int a, int b) {
    if(upper(a, b)) return a;
    if(upper(b, a)) return b;
    for(int i = LOG - 1; i >= 0; --i) {
        if(!upper(up[a][i], b)) {
            a = up[a][i];
        }
    }
    return up[a][0];
}

int d(int a, int b) {
    return h[a] + h[b] - 2 * h[lca(a, b)];
}

void add2(int v, int qu, int tt) {
    if(tt == -1) return;

    if(!tmp[v].count(qu) || tmp[v][qu] == -1) {
        his[v].pb({1, {-1, qu}});
        tmp[v][qu] = tt;
    }
    else {
        from1 = st[qu][tt];
        d1 = (d(v, from1) + s[qu][tt] - 1) / s[qu][tt];
        from2 = st[qu][tmp[v][qu]];
        d2 = (d(v, from2) + s[qu][tmp[v][qu]] - 1) / s[qu][tmp[v][qu]];
        if(d1 < d2) {
            his[v].pb({1, {tmp[v][qu], qu}});
            tmp[v][qu] = tt;
        }
        else if(d1 == d2 && tt < tmp[v][qu]) {
            his[v].pb({1, {tmp[v][qu], qu}});
            tmp[v][qu] = tt;
        }
    }
}

void dfs2(int v, int p = 1) {
    for(auto P : query[v]) {
        ans[P.x][P.y] = tmp[v][P.x];
    }

    for(auto i : g[v]) {
        if(i == p) continue;
        if(tmp[v].size() > tmp[i].size()) {
            swap(tmp[i], tmp[v]);
            his[i].pb({0, {v, 0}});
        }
        for(auto P : tmp[v]) {
            add2(i, P.x, P.y);
        }
        dfs2(i, v);
    }

    reverse(his[v].begin(), his[v].end());
    for(auto P : his[v]) {
        if(P.x == 0) {
            swap(tmp[v], tmp[P.y.x]);
        }
        else {
            tmp[v][P.y.y] = P.y.x;
        }
    }


}

main()
{
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    int n, x, y, q;
    cin >> n;
    for(int i = 0; i < n - 1; ++i) {
        cin >> x >> y;
        g[x].pb(y);
        g[y].pb(x);
    }
    h[1] = 0;
    dfs0(1);
    cin >> q;
    for(int i = 0; i < q; ++i) {
        cin >> k[i] >> m[i];
        st[i].resize(k[i]);
        s[i].resize(k[i]);
        for(int j = 0; j < k[i]; ++j) {
            cin >> st[i][j] >> s[i][j];
            virus[st[i][j]][i].pb(j);
        }
        ans[i].resize(m[i]);
        for(int j = 0; j < m[i]; ++j) {
            cin >> x;
            query[x].pb({i, j});
        }
    }
    dfs(1);

    dfs2(1);

    for(int i = 0; i < q; ++i) {
        for(int j = 0; j < m[i]; ++j) {
            cout << ans[i][j] + 1 << " ";
        }
        cout << endl;
    }
}
