#include <bits/stdc++.h>
using namespace std;

#define F first
#define S second
#define pb push_back
#define int long long
#define sz(x) (int)x.size()
#define mp make_pair
#define all(x) x.begin(), x.end()

#ifndef MY
    #define endl '\n'
#endif

typedef pair <int,int> pii;
typedef long double db;

const int N = 2e5 + 5;
const int inf = 1e9 + 7;
int lst[N];
int n, m;
vector < int > gr[2][N];
int len[N];
int dist[N];

void dij(int st) {
    fill(dist, dist + n, inf);
    dist[st] = 0;
    queue < int > q;
    q.push(st);
    while (sz(q)) {
        int v = q.front();
        q.pop();
        for (auto u : gr[1][v]) {
            if (dist[u] > dist[v] + 1) {
                dist[u] = dist[v] + 1;
                q.push(u);
            }
        }
    }
}

signed main() {
#ifdef MY
    freopen("f.in", "r", stdin);
#endif // MY
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int v, u;
        cin >> v >> u;
        v--, u--;
        gr[0][v].pb(u);
        gr[1][u].pb(v);
    }
    int p;
    cin >> p;
    for (int i = 0; i < p; i++) {
        cin >> lst[i];
        lst[i]--;
    }
    dij(lst[p - 1]);
    int mn = 0, mx = 0;
    for (int i = 0; i < p - 1; i++) {
        int v = lst[i];
        int d = inf;
        for (auto w : gr[0][v]) {
            d = min(d, dist[w]);
        }
        int u = lst[i + 1];
        bool fl = 0;
        int cnt = 0;
        for (auto w : gr[0][v]) {
            if (dist[w] == d) {
                cnt++;
                if (w == u) {
                    fl = 1;
                }
            }
        }
        mn += !fl;
        cnt -= fl;
        mx += bool(cnt);
    }
    cout << mn << ' ' << mx;
}
