import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.StringTokenizer;

import static java.lang.Math.*;

public class Main {
    void run() throws IOException {
        int n = nextInt();
        int[] r = new int[n];
        int[] b = new int[n];
        for (int i = 0; i < r.length; i++) {
            r[i] = nextInt();
        }
        for (int i = 0; i < b.length; i++) {
            b[i] = nextInt();
        }
        int[] x = new int[n];
        int cnt = 0;
        int sum = 0;
        for (int i = 0; i < x.length; i++) {
            if(r[i] ==0 && b[i] == 0)continue;
            if (r[i] == 1 && b[i] == 1) x[i] = 1;
            else if (b[i] == 1 && r[i] == 0) {
                x[i] = 1;
                sum++;
            } else cnt++;
        }
        sum++;
        if (cnt == 0) {
            pw.println(-1);
        } else {
            int need = sum / cnt;
            if (sum % cnt == 0) {
                pw.print(need);
            } else pw.print(need + 1);
        }
        pw.close();
    }

    static BufferedReader br;
    static StringTokenizer st = new StringTokenizer("");
    static PrintWriter pw;

    public static String next() throws IOException {
        while (!st.hasMoreTokens()) st = new StringTokenizer(br.readLine());
        return st.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(next());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(next());
    }

    public static void main(String[] args) throws IOException {
        br = new BufferedReader(new InputStreamReader(System.in));
        pw = new PrintWriter(System.out);
        new Main().run();
    }

}
