#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ld long double

ll INF = (ll) 1e20;
ll iINF = (int) 1e20;
ll mod = (ll) 1e9 + 7;

#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("no-stack-protector")

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie();
    cout.tie();
    ll n, m;
    cin >> n >> m;
    vector<vector<ll>> nodes(n);
    vector<vector<ll>> bnodes(n);
    for (int i = 0; i < m; ++i) {
        ll u, v;
        cin >> u >> v;
        nodes[u - 1].push_back(v - 1);
        bnodes[v - 1].push_back(u - 1);
    }
    ll k;
    cin >> k;
    vector <ll> p(k);
    for(int i = 0; i < k; ++i) {
        cin >> p[i];
        --p[i];
    }
    vector <ll> d(n, iINF);
    d[p[k - 1]] = 0;
    queue <ll> q;
    q.push(p[k - 1]);
    vector <bool> used(n, false);
    while(!q.empty()) {
        ll v = q.front();
        q.pop();
     //   cout << v << '\n';
        used[v] = true;
        for(auto i : bnodes[v]) {
            if(d[i] > d[v] + 1 && !used[i]) {
                used[i] = true;
                q.push(i);
                d[i] = d[v] + 1;
            }
        }
    }
    vector <ll> num(n, 0);
    for(int i = 0; i < n; ++i) {
        ll mi = INF;
        for(auto j : nodes[i]) {
            mi = min(mi, d[j]);
        }
        for(auto j : nodes[i]) {
            num[i] += (d[j] == mi);
        }
    }
    ll minim = 0;
    for(int i = 1; i < k; ++i) {
        //cout << p[i] << ' ' << d[p[i]] << ' ' << p[i - 1] << ' ' << d[p[i - 1]] << '\n';
        if(d[p[i]] + 1 != d[p[i - 1]]) {
            ++minim;
        }
    }
    ll maxim = 0;
    for(int i = 0; i < k - 1; ++i) {
        if(num[p[i]] > 1 || d[p[i + 1]] + 1 != d[p[i]])
            ++maxim;
    }
    cout << minim << ' ' << maxim;
}
