#include <bits/stdc++.h>

using namespace std;

#define int long long

struct fenv{
    vector <int> dt;
    void upd(int pos, int x){
        for(; pos < dt.size(); pos = (pos | (pos + 1)))
            dt[pos] += x;
    }
    int get(int r){
        int ans = 0;
        for(; r >= 0; r = (r & (r + 1)) - 1)
            ans += dt[r];
        return ans;
    }
    int get(int l, int r){
        int ans = get(r);
        if(l)
            ans -= get(l - 1);
        return ans;
    }
};

fenv ff;



signed main()
{
    int n, m, p;
    cin >> n >> m >> p;
    vector <pair <int, int> > v1(n), v2(m);
    vector <pair <pair <int, int>, int> > v3(p);
    for(int i = 0; i < n; i++)
        cin >> v1[i].first >> v1[i].second;
    for(int i = 0; i < m; i++)
        cin >> v2[i].second >> v2[i].first;
    for(int i = 0; i < p; i++)
        cin >> v3[i].first.first >> v3[i].first.second >> v3[i].second;
    sort(v1.begin(), v1.end());
    sort(v2.begin(), v2.end());
    sort(v3.begin(), v3.end());
    int ma = -1;
    vector <int> nn(m, 1);
    for(int i = 0; i < m; i++){
        if(ma >= v2[i].second)
            nn[i] = 0;
        ma = max(ma, v2[i].second);
    }
    vector <pair <int, int> > v2n;
    for(int i = 0; i < m; i++)
        if(nn[i])
            v2n.push_back(v2[i]);

    int ans = 0;
    ff.dt.resize((int)1e6 + 10);
    int yk = 0;
    for(auto me: v1){
        swap(me.first, me.second);
        while(yk < p && v3[yk].first.first < me.second){
            ff.upd(v3[yk].first.second, v3[yk].second);
            yk++;
        }

        int l = 0, r = v2n.size() - 1;
        while(r - l > 2){
            int m1 = l + (l + r) / 3;
            int m2 = r - (l + r) / 3;
            int g1 = ff.get(v2n[m1].second);
            int g2 = ff.get(v2n[m2].second);

            if(g1 - v2n[m1].first < g2 - v2n[m2].first)
                l = m1;
            else
                r = m2;
        }
        int now = 0;
        for(int m1 = l; m1 <= r; m1++){
            int g1 = ff.get(v2n[m1].second);
            int nnn = g1 - v2n[m1].first;
            now = max(now, nnn);
        }
        ans = max(ans, now - me.first);
    }
    cout << ans;
}
