#include <bits/stdc++.h>

using namespace std;

long long n, m, k;
vector<vector<long long> > g;
vector<pair<long long, long long> > v;
vector<long long> p;

void bfs(long long t){
    queue<long long> q; q.push(t);
    v[t].second = 1;
    v[t].first = 0;
    while(!q.empty()){
        long long w = q.front(); q.pop();
        for(long long i = 0; i < g[w].size(); ++i){
            long long u = g[w][i];
            if(v[u].first > v[w].first){
                v[u].first = v[w].first + 1, v[u].second = min(v[w].second + v[u].second, 3ll);
                q.push(u);
            }
        }
    }
}

int main()
{
    cin >> n >> m;
    g.resize(n);
    v.resize(n, {m + 1, 0});
    for(long long i = 0; i < m; ++i){
        long long a, b; cin >> a >> b; --a, --b;
        g[b].push_back(a);
    }
    cin >> k;
    p.resize(k);
    for(long long i = 0; i < k; ++i){
        cin >> p[i];
        --p[i];
    }
    if(k == 2){
        cout << 0 << ' ' << 0 << '\n';
        return 0;
    }
    bfs(p[k - 1]);
    long long cnt1 = k - 1, cnt2 = 0;
    for(long long i = 0; i < k - 2; ++i){
        long long u = p[i], w = p[i + 1];
        if(v[u].first == v[w].first + 1)
            --cnt1;
        if(v[u].second > 1 || v[u].first < v[w].first + 1)
            ++cnt2;
    }
    cout << cnt1 << ' ' << cnt2 << '\n';
    return 0;
}
