#include <iostream>
#include <string>
#include <map>
#include <vector>
#include <set>
#include <queue>
#include <algorithm>
#include <cmath>
using namespace std;

#define int long long

int pop_count(int a)
{
    int z = 0;
    for(;a;a >>= 1)
    {
        z += a&1;
    }
    return z;
}

void dlt(string& s, vector<int>& pk, vector<int>& nk, int i)
{
    s[i] = '#';
    if(pk[i] != -1)
    {
        nk[pk[i]] = nk[i];
    }
    if(nk[i] != -1)
    {
        pk[nk[i]] = pk[i];
    }
}

int getzn(string& s, int i, vector<int>& nk)
{
    if(nk[i] == -1)
        return -20;
    return s[nk[i]] - 'a';

}


int getzp(string& s, int i, vector<int>& pk)
{
    if(pk[i] == -1)
        return -20;
    return s[pk[i]] - 'a';

}

signed main()
{
    int n;
    string s;
    cin >> n >> s;
    vector<vector<int> > c(26);
    vector<int> pk(n, -1), nk(n, -1);
    for(int i = 1; i < n; i++)
        pk[i] = i - 1;
    for(int i = 0; i < n - 1; i++)
        nk[i] = i + 1;
    for(int i = 0; i < n; i++)
    {
        c[s[i] - 'a'].push_back(i);
    }
    int sm = 0;
    for(int z = 25; z > 0; z--)
    {
        for(int i = 0; i < c[z].size(); i++)
        {
            if(getzn(s, c[z][i], nk) == z - 1 || getzp(s, c[z][i], pk) == z - 1 )
            {
                dlt(s, pk, nk, c[z][i]);
                sm++;
            }
        }
    }
    cout << sm;
    return 0;
}
