#include <iostream>
#include <string>
#include <map>
#include <vector>
#include <set>
#include <queue>
#include <algorithm>
#include <cmath>
using namespace std;

#define int long long

int pop_count(int a)
{
    int z = 0;
    for(;a;a >>= 1)
    {
        z += a&1;
    }
    return z;
}

void dlt(string& s, vector<int>& pk, vector<int>& nk, int i)
{
    s[i] = '#';
    if(pk[i] != -1)
    {
        nk[pk[i]] = nk[i];
    }
    if(nk[i] != -1)
    {
        pk[nk[i]] = pk[i];
    }
}

int getzn(string& s, int i, vector<int>& nk)
{
    if(nk[i] == -1)
        return -20;
    return s[nk[i]] - 'a';

}


int getzp(string& s, int i, vector<int>& pk)
{
    if(pk[i] == -1)
        return -20;
    return s[pk[i]] - 'a';

}

signed main()
{
    int n, m;
    cin >> n >> m;
    vector<vector<int> > u(n);
    vector<pair<int, int> > mn(n, {1000000000, 0});
    for(int i = 0; i < m; i++)
    {
        int a, b;
        cin >> a >> b;
        a--, b--;
        u[b].push_back(a);
    }

    int k;
    cin >> k;
    vector<int> w(k);
    for(int i = 0; i < k; i++)
    {
        cin >> w[i];
        w[i]--;
    }
    int t = w[k - 1];
    mn[t] = {0, 1};
    queue<int> q;
    q.push(t);
    vector<bool> bl(n, false);
    while(q.size())
    {
        int h = q.front();
        q.pop();
        for(int i = 0; i < u[h].size(); i++)
        {
            int z = u[h][i];
            if(mn[z].first == 1000000000)
            {
                mn[z] = {mn[h].first + 1, 1};
                q.push(z);
            }
            else
            {
                if(mn[z].first == mn[h].first + 1)
                {
                    mn[z] = {mn[h].first + 1, 2};
                }
            }
        }
        bl[h] = true;
    }
    int mna = 0, mxa = 0;
    for(int i = 0; i < k - 1; i++)
    {
        if(mn[w[i]].first < mn[w[i + 1]].first + 1)
            mna++, mxa++;
        else
        {
            if(mn[w[i]].second == 2)
                mxa++;
        }
    }
    cout << mna << ' ' << mxa;
    return 0;
}
