#include <bits/stdc++.h>
#define int long long
#pragma GCC optimize("O3,Ofast,no-stack-protector,fast-math,unroll-loops")
using namespace std;

int n, m, p;
vector<pair<int, int>> attack;
vector<pair<int, int>> defend;
vector<pair<int, int>> realattack;
vector<pair<int, int>> realdefend;
vector<vector<int>> monstersa;
vector<vector<int>> monstersb;
int ap = 0;
int dp = 0;

struct nor {
    bool operator()(vector<int> const &a, vector<int> const &b) {
        if (a[0] < b[0]) {
            return true;
        } else if (a[0] > b[0]) {
            return true;
        } else {
            return a[1] < b[1];
        }
    }
};

struct rev {
    bool operator()(vector<int> const &a, vector<int> const &b) {
        if (a[1] < b[1]) {
            return true;
        } else if (a[1] > b[1]) {
            return true;
        } else {
            return a[0] < b[0];
        }
    }
};

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m >> p;
    for (int i = 0; i < n; i++) {
        int a, b;
        cin >> a >> b;
        attack.push_back({a, b});
    }
    sort(attack.begin(), attack.end());
    realattack.resize(n);
    for (pair<int, int> pr : attack) {
        realattack[ap] = pr;
        while (ap > 0 && ((realattack[ap - 1].second > realattack[ap].second) || (realattack[ap - 1].second == realattack[ap].second && realattack[ap - 1].first <= realattack[ap].first))) {
            realattack[ap - 1] = realattack[ap];
            ap--;
        }
        ap++;
    }
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        defend.push_back({a, b});
    }
    sort(defend.begin(), defend.end());
    realdefend.resize(m);
    for (pair<int, int> pr : defend) {
        realdefend[dp] = pr;
        while (dp > 0 && ((realdefend[dp - 1].second > realdefend[dp].second) || (realdefend[dp - 1].second == realdefend[dp].second && realdefend[dp - 1].first <= realdefend[dp].first))) {
            realdefend[dp - 1] = realdefend[dp];
            dp--;
        }
        dp++;
    }
    for (int i = 0; i < p; i++) {
        vector<int> kek(4);
        cin >> kek[0] >> kek[1] >> kek[2];
        kek[3] = i;
        monstersa.push_back(kek);
        monstersb.push_back(kek);
    }
    sort(monstersa.begin(), monstersa.end(), nor());
    sort(monstersb.begin(), monstersb.end(), rev());
    int best = -2e9;
    int total = 0;
    set<int> has;
    int attackpos = 0;
    int defendpos = 0;
    int ma = 0;
    int mb = 0;
    for (int i = 0; i <= (n + m + p) * 2; i++) {
        bool flag = false;
        if (ma < monstersa.size()) {
            vector<int> va = monstersa[ma];
            if (va[0] < realattack[attackpos].first && va[1] < realdefend[defendpos].first) {
                if (has.find(va[3]) == has.end()) {
                    has.insert(va[3]);
                    total += va[2];
                    if (attackpos > 0 && va[0] < realattack[attackpos - 1].first) {
                        best = max(best, total - realattack[attackpos - 1].second - realdefend[defendpos].second);
                    }
                    if (defendpos > 0 && va[1] < realdefend[defendpos - 1].first) {
                        best = max(best, total - realattack[attackpos].second - realdefend[defendpos - 1].second);
                    }
                }
                best = max(best, total - realattack[attackpos].second - realdefend[defendpos].second);
                flag = true;
                ma++;
            }
        }
        if (mb < monstersb.size()) {
            vector<int> vb = monstersb[mb];
            if (vb[0] < realattack[attackpos].first && vb[1] < realdefend[defendpos].first) {
                if (has.find(vb[3]) == has.end()) {
                    has.insert(vb[3]);
                    total += vb[2];
                    if (attackpos > 0 && vb[0] < realattack[attackpos - 1].first) {
                        best = max(best, total - realattack[attackpos - 1].second - realdefend[defendpos].second);
                    }
                    if (defendpos > 0 && vb[1] < realdefend[defendpos - 1].first) {
                        best = max(best, total - realattack[attackpos].second - realdefend[defendpos - 1].second);
                    }
                }
                best = max(best, total - realattack[attackpos].second - realdefend[defendpos].second);
                flag = true;
                mb++;
            }
        }
        if (!flag) {
            if (attackpos < realattack.size() - 1) {
                attackpos++;
            }
            if (defendpos < realattack.size() - 1) {
                defendpos++;
            }
        }
    }
    cout << best << '\n';
    fflush(stdout);
}
