#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")
#define l first
#define r second
#define pb push_back
#define all(x) x.begin(), x.end()
#define pi pair<int, int>
#define ll long long
#define double long double

using namespace std;

const int maxn = 1e6 + 1, mod = 1e9 + 7, inf = 2e9 + 1;

struct tri {
    int x, y, z;

    tri() {}

    tri(int x, int y, int z) : x(x), y(y), z(z) {}
};

pi a[maxn], b[maxn];
tri v[maxn];

int t[4 * maxn], add[4 * maxn];

void build(int x, int cl, int cr) {
    t[x] = -inf;
    if (cr - cl > 1) {
        build(2 * x, cl, (cl + cr) / 2);
        build(2 * x + 1, (cl + cr) / 2, cr);
    }
}

void push(int x, int cl, int cr) {
    if (cr - cl > 1) {
        add[2 * x] += add[x];
        add[2 * x + 1] += add[x];
    }
    t[x] += add[x]; add[x] = 0;
}

void upd(int x, int cl, int cr, int l, int r, int vl) {
    push(x, cl, cr);
    if (cr <= l || r <= cl) return;
    if (l <= cl && cr <= r) {
        add[x] += vl; push(x, cl, cr);
        return;
    }
    upd(2 * x, cl, (cl + cr) / 2, l, r, vl);
    upd(2 * x + 1, (cl + cr) / 2, cr, l, r, vl);
    t[x] = max(t[2 * x], t[2 * x + 1]);
}

int get(int x, int cl, int cr, int l, int r) {
    push(x, cl, cr);
    if (r <= cl || cr <= l) return -inf;
    if (l <= cl && cr <= r) return t[x];
    return max(get(2 * x, cl, (cl + cr) / 2, l, r),
               get(2 * x + 1, (cl + cr) / 2, cr, l, r));
}

int cmn[maxn];

bool cmp(tri x, tri y) {
    return x.x < y.x;
}

signed main() {
    int n, m, p;
    cin >> n >> m >> p;
    for (int i = 0; i < n; i++)
        cin >> a[i].l >> a[i].r;
    for (int i = 0; i < m; i++)
        cin >> b[i].l >> b[i].r;
    for (int i = 0; i < p; i++)
        cin >> v[i].x >> v[i].y >> v[i].z;
    for (int i = 0; i < maxn; i++)
        cmn[i] = inf;
    build(1, 0, maxn);
    for (int i = 0; i < m; i++) {
        if (cmn[b[i].l] > b[i].r) {
            upd(1, 0, maxn, b[i].l, b[i].l + 1, cmn[b[i].l] - b[i].r);
            cmn[b[i].l] = b[i].r;
        }
    }
    sort(a, a + n);
    sort(v, v + p, cmp);
    int pt = 0, ans = -inf;
    for (int i = 0; i < n; i++) {
        while (pt < p && v[pt].x < a[i].l) {
            upd(1, 0, maxn, v[pt].y + 1, maxn, v[pt].z);
            ++pt;
        }
        push(1, 0, maxn);
        ans = max(ans, t[1] - a[i].r);
    }
    cout << ans;
    return 0;
}
