#include <iostream>
#include <vector>
#include <string>
#include <fstream>
#include <set>
#include <map>

typedef long long ll;

using namespace std;

/*vector<ll> t;

ll get(int v, int tl, int tr, int l, int r){
    if(l > r) return 0;
    if(tl == l && tr == r){
        return t[v];
    }
    int m = (tr + tl)/2;
    return get(v*2, tl, m, l, min(m, r)) + get(v*2 + 1, m + 1, tr, max(l, m + 1), r);
}

ll upd(int v, int tl, int tr, int pos, int val){
    if(tl == tm){
        t[v] = val;
        return
    }
    int m = (tr + tm)/2;
    if(val <= m){
        upd(v * 2, tl, m, pos, val);
    } else {
        upd(v*2 + 1, tm + 1, tr, pos, val);
    }
}*/

int main() {
    //fstream cin("input.txt");
    //ofstream cout("output.txt");
    int n; cin >> n;
    vector<vector<bool>> can(n, vector<bool>(n));
    string s; cin >> s;
    for(int i = 0; i < n; i++){
        for(int j = 0; j + i < n; j++){
            int l = j, r = j + i;
            if(l > 0){
                if(s[l - 1] == s[l] - 1 && l + 1 <= r) {
                    can[l][r] = can[l][r] | can[l + 1][r];
                } else if(s[l - 1] == s[l] - 1){
                    can[l][r] = true;
                }
                if(s[l - 1] == s[r] - 1 && r - 1 >= l){
                    can[l][r] = can[l][r] | can[l][r - 1];
                } else if(s[l - 1] == s[r] - 1){
                    can[l][r] = true;
                }
            }
            if(r + 1 < n){
                if(s[r + 1] == s[l] - 1 && l + 1 <= r) {
                    can[l][r] = can[l][r] | can[l + 1][r];
                } else if(s[r + 1] == s[l] - 1){
                    can[l][r] = true;
                }
                if(s[r + 1] == s[r] - 1 && r - 1 >= l){
                    can[l][r] = can[l][r] | can[l][r - 1];
                } else if(s[r + 1] == s[r] - 1){
                    can[l][r] = true;
                }
            }

        }
    }

    vector<vector<int>> dp(n, vector<int>(n));
    for(int i = 0; i < n; i++) {
        for (int j = 0; j + i < n; j++) {
            int l = j, r = j + i;
            for(int k = l + 1; k < r; k++){
                if(s[l] == s[k] - 1){
                    if(k - l > 1 && can[l + 1][k - 1]) {
                        dp[l][r] = max(dp[l][r], dp[k][r] + k - l);
                    } else if(k - l == 1){
                        dp[l][r] = max(dp[l][r], dp[k][r] + k - l);
                    }
                } else {
                    dp[l][r] = max(dp[l][r], dp[k][r]);
                }
            }
            for(int k = r - 1; k > l; k--){
                if(s[r] == s[k] - 1){
                    if(r - k > 1 && can[k + 1][r - 1]) {
                        dp[l][r] = max(dp[l][r], dp[l][k] + r - k);
                    } else if(r - k == 1){
                        dp[l][r] = max(dp[l][r], dp[l][k] + r - k);
                    }
                } else {
                    dp[l][r] = max(dp[l][r], dp[l][k]);
                }
            }
        }
    }
    int ans = 0;
    for(int i = 0; i < n; i++){
        for(int j = 0; j + i < n; j++){
            int l = j, r = j + i;
            bool cd = true;
            if(l > 0 && !can[0][l - 1]){
                cd = false;
            }
            if(r + 1 < n && !can[r + 1][n - 1]){
                cd = false;
            }
            if(cd){
                ans = max(ans, dp[l][r] + l + n - 1 - r);
            }
        }
    }
    cout << ans;
    return 0;
}