#include <bits/stdc++.h>

#define int long long
#define double long double
#define ff first
#define ss second
#define pb push_back
#define pf push_front
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()

using namespace std;

const int inf = 1e18;
const double eps = 1e-6;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count() + 2003);

const int maxn = 2e5 + 100;

vector<int> g[maxn], gr[maxn], used, d;
int dp[maxn];
int n, m;

void bfs(int s)
{
    queue<int> q;
    q.push(s);
    d.assign(n, inf);
    used.assign(n, 0);
    used[s] = 1;
    d[s] = 0;
    while (sz(q))
    {
        int v = q.front();
        q.pop();
        for (int u : gr[v])
        {
            if (used[u]) continue;
            used[u] = 1;
            d[u] = d[v] + 1;
            q.push(u);
        }
    }
}


void dfs(int v)
{
    used[v] = 1;
    for (int u : gr[v])
    {
        if (d[u] != d[v] + 1) continue;
        dp[u] += dp[v];
        if (!used[u])
        {
            dfs(u);
        }
    }
}

signed main()
{
    ios_base::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr);
    cin >> n >> m;
    for (int i = 0; i < m; ++i)
    {
        int a, b;
        cin >> a >> b, --a, --b;
        g[a].pb(b);
        gr[b].pb(a);
    }
    int k;
    cin >> k;
    vector<int> path(k);
    for (int i = 0; i < k; ++i) cin >> path[i], --path[i];
    int vs = path[0], vt = path.back();
    bfs(vt);
    dp[vt] = 1;
    used.assign(n, 0);
    dfs(vt);
    int ans1 = 0, ans2 = 0;
    int bd = d[vs];
    if (bd < k - 1) ++ans1;
    for (int i = 0; i < k; ++i)
    {
        int add = dp[path[i]];
        if (d[path[i]] == k - i - 1) --add;
        ans2 += add;
    }
    cout << ans1 << " " << ans2 << "\n";
    return 0;
}
