#include <bits/stdc++.h>

#define int long long
#define double long double
#define ff first
#define ss second
#define pb push_back
#define pf push_front
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()

using namespace std;

const int inf = 1e18;
const double eps = 1e-6;
const int maxw = 1e6 + 10;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count() + 2003);

int val[maxw];

int fen[maxw + 10];

void upd(int i, int x)
{
    for (; i < maxw; i = (i | (i + 1))) fen[i] += x;
}

int sum(int r)
{
    int res = 0;
    for (; r >= 0; r = (r & (r + 1)) - 1) res += fen[r];
    return res;
}

signed main()
{
    ios_base::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr);
    int n, m, p;
    cin >> n >> m >> p;
    for (int i = 0; i < maxw; ++i) val[i] = -inf;
    vector<pair<int, int>> v;
    for (int i = 0; i < n; ++i)
    {
        int x, c;
        cin >> x >> c;
        v.pb({x, c});
    }
    sort(all(v));
    for (int i = n - 2; i >= 0; --i) v[i].ss = min(v[i].ss, v[i + 1].ss);
    for (int i = 0; i < m; ++i)
    {
        int y, c;
        cin >> y >> c;
        val[y] = -c;
    }
    int ans = -inf;
    for (int i = maxw - 2; i >= 0; --i)
    {
        val[i] = max(val[i - 1], val[i]);
        ans = max(ans, val[i] - v[0].ss);
    }
    vector<pair<pair<int, int>, int>> t;
    for (int i = 0; i < p; ++i)
    {

        int x, y, z;
        cin >> x >> y >> z;
        t.pb({{x, y}, z});
    }
    sort(all(t));
    int pos = 0;
    for (auto vi : v)
    {
        int x, c;
        tie(x, c) = vi;
        while (pos < sz(t) && t[pos].ff.ff < x)
        {
            upd(t[pos].ff.ss, t[pos].ss);
            ans = max(ans, val[t[pos].ff.ss] + sum(t[pos].ff.ss - 1) - c);
            ++pos;
        }
    }
    cout << ans;
    return 0;
}
