// max krasava

#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
using namespace __gnu_pbds;
typedef long long ll;
typedef long double ld;
#define f first
#define s second
#define add push_back
#define del pop_back
#define ins insert
#define ers erase
#define int ll
#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
const ll INF = (ll)1e9 + 182;
template <typename T> using dd = tree <T, null_type, less <T>, rb_tree_tag, tree_order_statistics_node_update>;
// dd::*find_by_order; dd::order_of_key

const int N = 1e6 + 10;
ll a[N], ca[N], b[N], cb[N], x[N], y[N], z[N], suf[N], pref[N];
pair <ll, ll> t[N * 4];
vector <int> res[N];

void relax(int v) {
	t[v].f = max(t[v * 2].f, t[v * 2 + 1].f);
}

void full(int v, int l, int r, ll x) {
	t[v].f += x; t[v].s += x;
}

void push(int v, int l, int r) {
	int m = (l + r) / 2;
	full(v * 2, l, m, t[v].s); full(v * 2 + 1, m + 1, r, t[v].s);
	t[v].s = 0;
	relax(v);
}

ll query(int v, int l, int r, int a, int b) {
	if (a > r || l > b) {
		return -INF * INF;
	}
	if (a <= l && r <= b) {
		return t[v].f;
	}
	push(v, l, r);
	int m = (l + r) / 2;
	return max(query(v * 2, l, m, a, b), query(v * 2 + 1, m + 1, r, a, b));
}

void update(int v, int l, int r, int a, int b, ll x) {
	if (a > r || l > b) {
		return;
	}
	if (a <= l && r <= b) {
		full(v, l, r, x);
		return;
	}
	push(v, l, r);
	int m = (l + r) / 2;
	update(v * 2, l, m, a, b, x); update(v * 2 + 1, m + 1, r, a, b, x);
	relax(v);
}

void mane() {
	int n, m, k;
	cin >> n >> m >> k;
	for (int i = 0; i < n; i++) {
		cin >> a[i] >> ca[i];
	}
	for (int i = 0; i < m; i++) {
		cin >> b[i] >> cb[i];
	}
	for (int i = 0; i < k; i++) {
		cin >> x[i] >> y[i] >> z[i];
		res[x[i]].add(i);
	}
	fill(suf, suf + N, INF * INF);
	for (int i = 0; i < m; i++) {
		suf[b[i]] = min(suf[b[i]], cb[i]);
	}
	for (int i = N - 3; i >= 0; i--) {
		suf[i] = min(suf[i + 1], suf[i]);
	}
	for (int i = 0; i < k; i++) {
		pref[y[i]] += z[i];
	}
	for (int i = 1; i < N; i++) {
		pref[i] = pref[i - 1] + pref[i];
	}
	for (int i = 0; i < N - 2; i++) {
		update(1, 0, N - 3, i, i, pref[i] - suf[i + 1]);
	}
	fill(suf, suf + N, INF * INF);
	for (int i = 0; i < n; i++) {
		suf[a[i]] = min(suf[a[i]], ca[i]);
	}
	for (int i = N - 3; i >= 0; i--) {
		suf[i] = min(suf[i + 1], suf[i]);
	}
	ll ans = -INF * INF;
	for (int i = N - 2; i >= 0; i--) {
		ans = max(ans, query(1, 0, N - 3, 0, N - 3) - suf[i + 1]);
		for (int j : res[i]) {
			update(1, 0, N - 3, y[j], N - 3, -z[j]);
		}
	}
	cout << ans;
}

int32_t main() {
	ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	mane();
#ifdef osss
	cout << endl; cerr << endl << "\t" << fixed << setprecision(12) << (ld)clock() / CLOCKS_PER_SEC << endl;
#endif
}