#include<iostream>
#include<algorithm>
#include<vector>
#include<string>
#include<set>
#include<map>
#include<assert.h>
#include<cmath>
#include<queue>

using namespace std;

struct node {
	int num, dist;
};

bool operator<(node a, node b) {
	if(a.dist == b.dist) {
		return a.num < b.num;
	}
	return a.dist < b.dist;
}

vector<vector<int>> g;

signed main() {
	int n, m;
	cin >> n >> m;
	g.resize(n + 1);
	for(int i = 0; i < m; i++) {
		int u, v;
		cin >> u >> v;
		g[v].push_back(u);
	}
	int k;
	cin >> k;
	vector<int> p(k);
	for(int i = 0; i < k; i++) {
		cin >> p[i];
	}
	vector<int> dist(n + 1, 1e9);
	vector<int> cnt(n + 1, 0);
	cnt[p.back()] = 1;
	dist[p.back()] = 0;
	set<node> s;
	node nod;
	nod.num = p.back();
	nod.dist = 0;
	s.insert(nod);
	while(s.size()) {
		int v = s.begin()->num;
		s.erase(s.begin());
		for(int i = 0; i < g[v].size(); i++) {
			int u = g[v][i];
			if(dist[u] < dist[v] + 1) {
				continue;
			}
			else if(dist[u] > dist[v] + 1) {
				node nod1;
				nod1.num = u;
				nod1.dist = dist[u];
				s.erase(nod1);
				dist[u] = dist[v] + 1;
				cnt[u] = 1;
				nod1.dist = dist[u];
				s.insert(nod1);
			}
			else if(dist[u] == dist[v] + 1) {
				cnt[u]++;
			}
		}
	}
	int vnow = p[0];
	int mn = 0;
	int mx = 0;
	for(int i = 1; i < p.size(); i++) {
		if(dist[vnow] == dist[p[i]] + 1) {
			if(cnt[vnow] > 1) {
				mx++;
			}
		}
		else {
			mn++;
			mx++;
		}
		vnow = p[i];
	}
	cout << mn << " " << mx;
}