#include <bits/stdc++.h>
using namespace std;
//#pragma GCC optimize("Ofast")

typedef long long ll;

const ll big = 2e15 + 7;

struct seg_tree {
private:
	vector <ll> a, b;
	ll n;

	void push(ll v) {
        a[v] += b[v];
        b[v*2] += b[v];
        b[v*2+1] += b[v];
        b[v] = 0;
	}

    void add(ll v, ll l, ll r, ll L, ll R, ll x) {
        push(v);
        if (L >= R) return ;
        if (l == L && r == R) {
            b[v] += x;
            push(v);
            return ;
        }
        ll mid = (l + r) / 2;
        add(v*2,   l, mid, L, min(mid, R), x);
        add(v*2+1, mid, r, max(mid, L), R, x);
        a[v] = max(a[v*2], a[v*2+1]);
    }

public:
	void build(ll N) {
		n = N + 5;
        a.resize(n * 8 + 5);
        b.resize(n * 8 + 5);
	}

    void baff(ll l, ll x) {
        add(1, 0, n, l, n, x);
    }

    ll best() {
        push(1);
        return a[1];
    }
} tree;

ll n, m, q;
pair <ll, ll> a[1000000], b[1000000];
vector <pair <ll, ll>> poll[1100000];

int main()
{
	ios_base :: sync_with_stdio(0);
	cin.tie();
	cout.tie();

	cin >> n >> m >> q;
    for (ll i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
    }
    for (ll i = 0; i < m; i++) {
		cin >> b[i].first >> b[i].second;
    }
    tree.build(1e6+5);
    sort(a, a+n);
    sort(b, b+m);
    /*for (ll i = n-2; i >= 0; i--) {
        if (a[i].second >= a[i+1].second) {
            a[i].second = a[i+1].second;
        }
    }
    for (ll i = n-1; i >= 0; i--) a[i].second -= a[i-1].second;*/
	for (ll i = m-2; i >= 0; i--) {
        if (b[i].second >= b[i+1].second) {
            b[i].second = b[i+1].second;
        }
    }
    for (ll i = m-1; i >= 0; i--) b[i].second -= b[i-1].second;

    ll p = 0;
    for (ll i = 0; i < m; i++) {
        tree.baff(p, -b[i].second);
        p = b[i].first;
    }
    tree.baff(p, -big);

	for (ll i = 0; i < q; i++) {
        ll x, y, z;
        cin >> x >> y >> z;
        poll[x].push_back({y, z});
	}

	p = 0;
	ll ans = -big;
    for (ll i = 0; i < n; i++) {
        while (p < a[i].first) {
			for (auto j : poll[p]) tree.baff(j.first, j.second);
			p++;
        }
        ans = max(ans, tree.best() - a[i].second);
    }
    cout << ans << endl;

	return 0;
}
