#include <bits/stdc++.h>
using namespace std;

#define fi first
#define se second
#define ll long long
#define mp make_pair
#define pb emplace_back
#define all(x) x.begin(), x.end()
#define rall(x) x.begin(), x.end()
#define int long long

struct C {
    int d;
    bool good, bad;
    C (int a, bool b, bool c) {
        d = a;
        good = b;
        bad = c;
    }
    C () {
        d = 1e9;
        good = 0;
        bad = 0;
    }
};

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    vector<vector<int>> g(n), r(n);
    for (int i = 0; i < m; ++i) {
        int v, u;
        cin >> v >> u;
        --v; --u;
        g[v].pb(u);
        r[u].pb(v);
    }
    int k;
    cin >> k;
    vector<int> path(k), p(n);
    for (int i = 0; i < k; ++i) {
        cin >> path[i];
        --path[i];
    }
    for (int i = 0; i < k; ++i) {
        p[path[i]] = 1;
    }
    vector<C> dist(n);
    dist[path[k - 1]].d = 0;
    set<pair<int, int>> s;
    s.emplace(0, path[k - 1]);
    while (!s.empty()) {
        int v = s.begin()->second;
        s.erase(s.begin());
        for (auto to : r[v]) {
            if (dist[to].d > dist[v].d + 1) {
                if (p[v]) dist[to] = {dist[v].d + 1, 1, 0};
                else dist[to] = {dist[v].d + 1, 0, 1};
                s.insert({dist[to].d, to});
            } else if (dist[to].d == dist[v].d + 1) {
                if (p[v]) dist[to].good = 1;
                else dist[to].bad = 1;
            }
        }
    }
    int ans1 = 0, ans2 = 0;
    for (int i = 0; i < k - 1; ++i) {
        if (dist[path[i]].good == 0 && dist[path[i]].bad == 1) {
            ++ans1;
            ++ans2;
        }
        if (dist[path[i]].good == 1 && dist[path[i]].bad == 0) {
            continue;
        }
        if (dist[path[i]].good == 1 && dist[path[i]].bad == 1) {
            ++ans2;
        }
    }
    cout << ans1 << " " << ans2;
    return 0;
}
