#include <bits/stdc++.h>
using namespace std;

#define int long long
#define float long double
#define deb(x) cout<<#x" = "<<x<<endl;
#define debv(x) cout<<#x" = ";for(const auto& _i:x)cout<<_i<<' ';cout<<endl;
#define _ << ' ' <<
#define ind(d) for(int _i=d;_i--;)cout<<"  ";

constexpr int inf = (int) 1e10;
template<class T> void umin (T& a, const T& b) { a = min(a, b); }
template<class T> void umax (T& a, const T& b) { a = max(a, b); }

typedef pair<int, int> xy;
#define x first
#define y second
xy operator+ (const xy& a, const xy& b) { return { a.x + b.x, a.y + b.y }; }
xy operator- (const xy& a, const xy& b) { return { a.x - b.x, a.y - b.y }; }

int n, m;
vector<int> dist;
vector<int> v;
vector<vector<int>> g;
vector<vector<int>> gg;

void bfs ()
{
	dist.resize(n, inf);
	queue<int> q;
	q.push(v.back());
	dist[v.back()] = 0;

	while (!q.empty()) {
		int c = q.front();
		q.pop();
		for (int i: gg[c]) {
			if (dist[i] > dist[c] + 1) {
				dist[i] = dist[c] + 1;
				q.push(i);
			}
		}
	}
}

signed main ()
{
	cin >> n >> m;

	g.resize(n);
	gg.resize(n);

	for (int i = 0; i < m; i++) {
		int a, b;
		cin >> a >> b;
		a--; b--;
		g[a].push_back(b);
		gg[b].push_back(a);
	}

	int k;
	cin >> k;
	v.resize(k);
	for (int& i: v) {
		cin >> i;
		i--;
	}

	bfs();

	int amin = 0;
	int amax = 0;

	for (int i = 0; i < k-1; i++) {
		int N = g[v[i]].size();

		vector<int> d(N);
		int mn = -1;
		for (int j = 0; j < N; j++) {
			d[i] = dist[g[v[i]][j]];
			if (mn == -1 || mn > d[i])
				mn = d[i];
		}
		int mins = 0;
		for (int j = 0; j < N; j++) {
			if (d[i] == mn)
				mins++;
		}

		if (mins == 0)
			continue;

		if (dist[v[i+1]] == mn) {
			if (mins > 1)
				amax++;
		} else {
			amin++;
			amax++;
		}
	}

	cout << amin << ' ' << amax << endl;
	return 0;
}
