#include <iostream>
#include <iomanip>
#include <string>
#include <map>
#include <set>
#include <vector>
#include <queue>
#include <cassert>
#include <cmath>
#include <algorithm>
#include <random>
#include <memory>
#include <chrono>

using namespace std;

random_device rd;
mt19937 rnd(rd());

//#pragma GCC optimize("O3")
//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx,avx2")

#define ll long long
#define ull unsigned long long
#define int ll
#define F first
#define S second
const int inf = 2e9;
const int mod = 1e9 + 7;
const int SZ = 2e5 + 4;

int n;
int b[SZ];

void read() {
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
    }
}

void solve() {
    map<int, int> s;
    int res = -1;
    for (int i = 0; i < n; ++i) {
        s[b[i] - i - 1] += b[i];
        res = max(res, s[b[i] - i - 1]);
    }
    cout << res;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    read();
    solve();

    return 0;
}