#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cmath>
#include <set>
#include <map>
#include <climits>
#include <queue>

using namespace std;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	//freopen("text.txt", "r", stdin);
	int n;
	cin >> n;
	vector<int> d(n, -1);
	vector<vector<int>> gr(n);
	int m;
	cin >> m;
	for (int i = 0; i < m; i++) {
		int x, y;
		cin >> x >> y;
		x--;
		y--;
		gr[y].push_back(x);
	}
	queue<int> q;
	int k;
	cin >> k;
	vector<int> p(k);
	for (int i = 0; i < k; i++) {
		cin >> p[i];
		p[i]--;
	}
	q.push(p.back());
	d[p.back()] = 0;
	while (!q.empty()) {
		int v = q.front();
		q.pop();
		for (int i = 0; i < gr[v].size(); i++) {
			int to = gr[v][i];
			if (d[to] == -1) {
				d[to] = d[v] + 1;
				q.push(to);
			}
		}
	}
	vector<int> count(1e7, 0);
	for (int i = 0; i < n; i++)
		count[d[i]]++;
	int mn = 0, mx = 0;
	for (int i = 0; i < k; i++) {
		int v = p[i];
		if (d[v] != k - i - 1) {
			mn++;
			if (i)
				mx++;
		}
		else if (count[d[v]] > 1  && i != 0)
			mx++;
	}
	cout << mn << " " << mx;
	return 0;
}