//--------------------------------------------------
//#pragma Gcc target("sse,sse2,sse3,ssse3,sse4,abm,mmx,avx,avx2,popcnt,fma")
//#pragma Gcc optimize("fast-math")
//#pragma Gcc optimize("unroll-loops")
//#pragma Gcc optimize("Ofast")
//--------------------------------------------------
#include <bits/stdc++.h>
#include <chrono>
#include <set>
#include <map>
#include <deque>
#include <cmath>
#include <queue>
#include <cassert>
#include <random>
#include <bitset>
#include <iomanip>
#include <numeric>
#include <time.h>
#include <ctime>
#include <string>
#include <cstdio>
#include <vector>
#include <cstdlib>
#include <iostream>
#include <algorithm>
#include <unordered_map>
#include <unordered_set>
#include <fstream>
#include <stack>
#include <cstring>
//--------------------------------------------------
#define forn(i, n) for(int i = 0; i < n; i++)
#define forw(i, n) for(int i = n-1; i >= 0; --i)
#define forns(i, n, s) for(int i = s; i < n; i++)
#define x first
#define y second
#define pb push_back
#define mp make_pair
#define all(v) v.begin(),v.end()
#define allr(v) v.rbegin(),v.rend()
//----------------------------------------------------
using namespace std;
//----------------------------------------------------
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef vector<ll> lnum;
typedef complex<ld> comp;
//----------------------------------------------------
const ll mod = 1e9 + 7, mod2 = 998244353;
const ld eps = 1e-6;
const ll inf = 1e18;
const int base = 1e9;
const ld PI = 3.1415926;
//----------------------------------------------------
#define endl '\n';
#ifdef MY_DEBUG
void deb(ld x) { cerr << x << endl; };
#else
void deb(ld x){};
#endif
//----------------------------------------------------
//----------------------------------------------------
int n, m, k, mn = 0, mx = 0;
vector<int> edges[2*100*1000];
map<int, int> dd[2*100*1000];
vector<int> v;
//----------------------------------------------------
unsigned int bitcount(ull val) { return __builtin_popcount(val) + __builtin_popcount(val >> 32); }

void local() {
    freopen("test.in", "r", stdin);
}

void remote() {
}

void read() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> n >> m;
    forn(i, m){
        int u, vv;
        cin >> u >> vv;
        edges[vv-1].pb(u-1);
    }
    cin >> k;
    v.resize(k);
    forn(i, k){
        cin >> v[i];
        v[i]--;
    }
}

void bfs(){

    queue<pair<int, int>> q;
    q.push({v.back(), 0});
    while(!q.empty()){
        const pair<int, int> &p = q.front();
        q.pop();
        for(const int &e: edges[p.x]){
            if(dd[e].begin()->x > p.y+1){
                q.push({e, p.y+1});
            }
            if(dd[e].begin()->x >= p.y+1){
                dd[e][p.y+1]++;
            }
        }
    }

}

int main() {
#ifdef MY_DEBUG
    local();
#else
    remote();
#endif
    read();

    forn(i, n) dd[i][base]++;
    dd[v.back()][0]++;

    bfs();

    forn(i, k-1){
        if(dd[v[i]].begin()->y > 1 || (dd[v[i]].begin()->x != dd[v[i+1]].begin()->x+1)) mx++;
        if(dd[v[i]].begin()->x != dd[v[i+1]].begin()->x+1) mn++;
    }

    cout << mn << " " << mx << endl;
}
 