//--------------------------------------------------
//#pragma Gcc target("sse,sse2,sse3,ssse3,sse4,abm,mmx,avx,avx2,popcnt,fma")
//#pragma Gcc optimize("fast-math")
//#pragma Gcc optimize("unroll-loops")
//#pragma Gcc optimize("Ofast")
//--------------------------------------------------
#include <bits/stdc++.h>
#include <chrono>
#include <set>
#include <map>
#include <deque>
#include <cmath>
#include <queue>
#include <cassert>
#include <random>
#include <bitset>
#include <iomanip>
#include <numeric>
#include <time.h>
#include <ctime>
#include <string>
#include <cstdio>
#include <vector>
#include <cstdlib>
#include <iostream>
#include <algorithm>
#include <unordered_map>
#include <unordered_set>
#include <fstream>
#include <stack>
#include <cstring>
//--------------------------------------------------
#define forn(i, n) for(int i = 0; i < n; i++)
#define forw(i, n) for(int i = n-1; i >= 0; --i)
#define forns(i, n, s) for(int i = s; i < n; i++)
#define x first
#define y second
#define pb push_back
#define mp make_pair
#define all(v) v.begin(),v.end()
#define allr(v) v.rbegin(),v.rend()
//----------------------------------------------------
using namespace std;
//----------------------------------------------------
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef vector<ll> lnum;
typedef complex<ld> comp;
//----------------------------------------------------
const ll mod = 1e9 + 7, mod2 = 998244353;
const ld eps = 1e-6;
const ll inf = 1e18;
const int base = 1e9;
const ld PI = 3.1415926;
//----------------------------------------------------
#define endl '\n';
#ifdef MY_DEBUG
void deb(ld x) { cerr << x << endl; };
#else
void deb(ld x){};
#endif
//----------------------------------------------------
struct el{
    int x, y, z;
    el() = default;
    el(int x, int y, int z): x(x), y(y), z(z) {};
};
//----------------------------------------------------
int n, m, p;
vector<pair<int, int>> a, b;
vector<el> v;
ll ans = 0;
priority_queue<pair<int, int>> q;
//----------------------------------------------------
unsigned int bitcount(ull val) { return __builtin_popcount(val) + __builtin_popcount(val >> 32); }

void local() {
    freopen("test.in", "r", stdin);
}

void remote() {
}

void read() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> n >> m >> p;
    a.resize(n);
    forn(i, n){
        int aa, ca;
        cin >> aa >> ca;
        a[i] = {aa, ca};
    }
    b.resize(m);
    forn(i, m){
        int bb, cb;
        cin >> bb >> cb;
        b[i] = {bb, cb};
    }
    v.resize(p);
    forn(i, p){
        int x, y, z;
        cin >> x >> y >> z;
        v[i] = {x, y, z};
    }
}

bool compa(const el &e1, const el &e2){
    return e1.x == e2.x ? e1.y < e2.y : e1.x < e2.x;
}
bool compb(const el &e1, const el &e2){
    return e1.y == e2.y ? e1.x < e2.x : e1.y < e2.y;
}

int main() {
#ifdef MY_DEBUG
    local();
#else
    remote();
#endif
    read();

    sort(all(a));
    sort(all(b));
    sort(all(v), compa);

    ll sum = 0;ans = - (b[0].y + a[0].y);
    int ii = 0, jj = 0;
    forn(i, p){
        while(ii < n && a[ii].x <= v[i].x){
            ii++;
        }
        while(jj < m && b[jj].x <= v[i].y){
            jj++;
        }
        if(ii == n || jj == m){
            break;
        }
        ll cost = a[ii].y + b[jj].y;
        sum += v[i].z;
        ans = max(ans, sum - cost);
    }

    sum = 0;
    ii = 0, jj = 0;
    sort(all(v), compb);
    forn(i, p){
        while(ii < n && a[ii].x <= v[i].x){
            ii++;
        }
        while(jj < m && b[jj].x <= v[i].y){
            jj++;
        }
        if(ii == n || jj == m){
            break;
        }
        ll cost = a[ii].y + b[jj].y;
        sum += v[i].z;
        ans = max(ans, sum - cost);
    }

    cout << ans << endl;
}
 