#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll INF = 1e9 + 1;
const ll MOD = 1e9 + 7;
const ll ALPH = 26;
const ld EPS = 1e-9;

#define size(x) (int)(x).size()
#define all(x) (x).begin(),(x).end()

void bye() {
    cout << "\n";
    exit(0);
}

struct Solution {

    void solve() {
        ll n;
        cin >> n;
        vector<ll> b(n);
        for (int i = 0; i < n; i++) {
            cin >> b[i];
        }
        unordered_map<ll, ll> sum;
        for (int i = 0; i < n; i++) {
            sum[i - b[i]] += b[i];
        }
        ll ans = 0;
        for (auto v : sum) {
            ans = max(ans, v.second);
        }
        cout << ans;
    }
};

signed main() {
    #ifdef _TIM
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // _TIM
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    ll TEST_COUNT = 1;
//    cin >> TEST_COUNT;
    while (TEST_COUNT--) {
        Solution now;
        now.solve();
    }
    bye();
}
