#include <bits/stdc++.h>

using namespace std;

#pragma GCC optimize("Ofast")
#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")

#define int long long
#define pb push_back
#define x first
#define y second
#define all(a) (a).begin(),(a).end()

typedef long double ld;
typedef long long ll;

const int N = 2e5 + 10;
const int INFINT = 1e9 + 9;
const int INFLL = 1e18 + 9;
const ld EPS = 1e-9;

mt19937 rnd(time(nullptr));

vector<int> g[N], gg[N];

void solve(){
    int n, m;
    cin >> n >> m;
    for(int i = 0; i < m; i++){
        int a, b;
        cin >> a >> b;
        a--,b--;
        g[a].pb(b);
        gg[b].pb(a);
    }
    vector<int> p;
    vector<int> d(n, INFINT);
    int k;
    cin >> k;
    p.resize(k);
    for(int i = 0; i < k; i++){
        cin >> p[i];
        p[i]--;
    }
    queue<int> q;
    q.push(p.back());
    d[q.front()] = 0;
    while(!(q.empty())){
        int cur = q.front();
        q.pop();
        for(int i = 0; i < gg[cur].size(); i++){
            if(d[gg[cur][i]] == INFINT){
                d[gg[cur][i]] = d[cur] + 1;
                q.push(gg[cur][i]);
            }
        }
    }
    int ans1 = 0, ans2 = 0;
    for(int i = 1; i < k; i++){
        if(d[p[i]] != d[p[i - 1]] - 1){
            ans1++,ans2++;
        } else {
            int cnt = 0, v = p[i - 1];
            for(int j = 0; j < g[v].size(); j++){
                if(d[g[v][j]] == (d[v] - 1))
                    cnt++;
            }
            if(cnt > 1)
                ans2++;
        }
    }
    cout << ans1 << " " << ans2 << endl;
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int q = 1;
    while(q--)
        solve();
}
