#include <bits/stdc++.h>
#pragma GCC optimize(04,fast-math)
#pragma GCC target(popcnt,sse,sse2,ssse3)

using namespace std;

#define int long long

const int MAXN = 3e5 + 1;
vector <int> gr[MAXN];
vector <int> dp(MAXN, 0), d(MAXN, 1e9);

void bfs(int t){
    queue<int> q;
    q.push(t);
    vector <bool> used(MAXN, 0);
    dp[t] = 0;
    while (!q.empty()){
        int v = q.front(); q.pop();
        used[v] = 1;
        for (int i = 0; i < gr[v].size(); i++)
        if (!used[gr[v][i]]){
            used[gr[v][i]] = 1;
            d[gr[v][i]] = 1 + d[v];
            q.push(gr[v][i]);
        }
        else{
            if (d[gr[v][i]] == 1 + d[v])
                dp[gr[v][i]]++;
        }
    }
}



signed main(){
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0), cerr.tie(0);

    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; i++){
        int a, b;
        cin >> a >> b;
        gr[b - 1].push_back(a - 1);
    }
    int k;
    cin >> k;
    vector <int> p(k);
    for (int i = 0; i < k; i++)
        cin >> p[i];
    bfs(p.back() - 1);
    int l = 0, r = 0;
    for (int i = 1; i < k; i++){
        int pr = p[i - 1] - 1, v = p[i] - 1;
        cerr << '!' << d[pr] << ' ' << d[v] << '\n';
        if (d[pr] <= d[v])
            l++, r++;
        else{
            r += dp[pr];
        }
    }
    cout << l << ' ' << r;
    return 0;
}
