#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define mp make_pair
#define pb push_back
#define all(a) (a).begin() (a).end()
#define debug(x) cerr << #x << ": " << x << endl

typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef long double ld;

template<typename T1, typename T2> bool chkmin(T1 &x, T2 y) { return y < x ? (x = y, true) : false; };
template<typename T1, typename T2> bool chkmax(T1 &x, T2 y) { return y > x ? (x = y, true) : false; };

bool dp[27][27][102][102];
int dq[102];

signed main()
{
#ifdef DEBUG
    freopen("in", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n;
    string s;
    cin >> n >> s;
    for (auto &e : s) e = e - 'a' + 1;
    for (int c1 = 0; c1 <= 26; ++c1)
    {
        for (int c2 = 0; c2 <= 26; ++c2)
        {
            for (int i = 0; i < n; ++i)
            {
                if (c1 != 0 && c1 + 1 == s[i] || c2 != 0 && c2 + 1 == s[i])
                {
                    dp[c1][c2][i][i] = 1;
                } 
            }
        }
    }
    for (int len = 2; len <= n; ++len)
    {
        for (int c1 = 0; c1 <= 26; ++c1)
        {
            for (int c2 = 0; c2 <= 26; ++c2)
            {
                for (int l = 0; l + len - 1 < n; ++l)
                {
                    int r = l + len - 1;
                    dp[c1][c2][l][r] |= (c1 != 0 && c1 + 1 == s[l] || c2 != 0 && c2 + 1 == s[l]) && dp[s[l]][c2][l + 1][r];
                    dp[c1][c2][l][r] |= (c1 != 0 && c1 + 1 == s[r] || c2 != 0 && c2 + 1 == s[r]) && dp[c1][s[r]][l][r - 1];
                    for (int i = l + 1; i < r; ++i)
                    {   
                        dp[c1][c2][l][r] |= dp[c1][s[i]][l][i - 1] && dp[s[i]][c2][i + 1][r] && (c1 != 0 && c1 + 1 == s[i] || c2 != 0 && c2 + 1 == s[i]);
                    }
                }
            }
        }
    }
    dq[0] = 0;
    dq[1] = 1;
    for (int i = 2; i <= n; ++i)
    {
        dq[i] = i;
        if (dp[0][s[i - 1]][0][i - 2])
        {
            dq[i] = 1;
            continue;
        }
        for (int j = i - 1; j >= 1; --j)
        {
            if (j == i - 1 || dp[s[j - 1]][s[i - 1]][j][i - 2])
            {
                chkmin(dq[i], dq[j] + 1);
            }
        }
    }
    int ans = dq[n];
    for (int i = 1; i < n; ++i)
    {
        if (dp[s[i - 1]][0][i][n - 1])
        {
            chkmin(ans, dq[i]);
        }
    }
    cout << n - ans << '\n';

    return 0;
}