#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define mp make_pair
#define pb push_back
#define all(a) (a).begin(), (a).end()
#define debug(x) cerr << #x << ": " << x << endl

typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef long double ld;

template<typename T1, typename T2> bool chkmin(T1 &x, T2 y) { return y < x ? (x = y, true) : false; };
template<typename T1, typename T2> bool chkmax(T1 &x, T2 y) { return y > x ? (x = y, true) : false; };

const int maxN = 200005;
vector<int> G[maxN], R[maxN];
int dist[maxN];
bool used[maxN];
vector<int> par[maxN];
int mn[maxN];
int mx[maxN];

signed main()
{
#ifdef DEBUG
    freopen("in", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n, m;
    cin >> n >> m;
    while (m--)
    {
        int a, b;
        cin >> a >> b;
        G[a].pb(b);
        R[b].pb(a);
    }
    int k;
    cin >> k;
    vector<int> p(k);
    for (auto &v : p) cin >> v;
    memset(dist, 0x3f, sizeof(dist));
    dist[p.back()] = 0;
    queue<int> q;
    q.push(p.back());
    while (!q.empty())
    {
        int v = q.front();
        q.pop();
        if (used[v]) continue;
        used[v] = true;
        for (int &u : R[v])
        {
            if (dist[u] == dist[v] + 1)
                par[u].pb(v);
            else if (chkmin(dist[u], dist[v] + 1))
            {
                par[u] = {v};
                q.push(u);
            }
        }
    }
    /*vector<int> ord(n);
    iota(all(ord), 1);
    sort(all(ord), [&](int a, int b) -> bool
    {
        return dist[a] < dist[b];
    });
    for (int v : ord)
    {
        for (int &u : par[v])
        {
            
        }
    }*/
    int mn = 0, mx = 0;
    for (int i = 0; i + 1 < k; ++i)
    {
        int a = p[i];
        int b = p[i + 1];
        if (find(all(par[a]), b) != par[a].end())
        {
            if (par[a].size() > 1)
                ++mx;
        }
        else
        {
            ++mn;
            ++mx;
        }
    }
    cout << mn << ' ' << mx << '\n';
    
    return 0;
}