#include <bits/stdc++.h>
#define int long long
#define pb push_back

using namespace std;

const int MOD = 1e9+7;
const int INF = 1e18;
const int MAXN = 3e5;

void fast_io(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int t[MAXN*4];
int cnt[MAXN*4];
int kek[MAXN*4];


void push(int v, int l, int r){
    if(cnt[v]!=0){
        t[v] += cnt[v];
        if(l!=r){
            cnt[v*2] += cnt[v];
            cnt[v*2+1] += cnt[v];
        }
        cnt[v] = 0;
    }
}


void build(int v, int l, int r){
    if(l==r){
        t[v] = kek[l];
    } else{
        int mid = (l+r)/2;
        build(v*2, l, mid);
        build(v*2+1, mid+1, r);
        t[v] = max(t[v*2], t[v*2+1]);
    }
}

void update(int v, int l, int r, int ql, int qr, int k){
    push(v, l, r);
    if(ql<=l && r<=qr){
        cnt[v] += k;
    } else if(ql > r || l>qr){
        return;
    } else{
        int mid = (l+r)/2;
        update(v*2, l, mid, ql, qr, k);
        update(v*2+1, mid+1, r, ql, qr, k);
        push(v*2, l, mid);
        push(v*2+1, mid+1, r);
        t[v] = max(t[v*2], t[v*2+1]);
    }
}

int get(int v, int l, int r, int ql, int qr){
    push(v, l, r);
    if(ql<=l && r<=qr){
        return t[v];
    } else if(ql>r || l>qr){
        return -INF;
    } else{
        int mid = (l+r)/2;
        return max(get(v*2, l, mid, ql, qr), get(v*2+1, mid+1, r, ql, qr));
    }
}


signed main() {
    fast_io();
    int n, m, p;
    cin >> n >> m >> p;
    vector<pair<int, int> > weapon(n);
    for(pair<int, int> &i:weapon)
        cin >> i.first >> i.second;
    vector<pair<int, int> > armor(m);
    for(pair<int, int> &i:armor)
        cin >> i.first >> i.second;
    vector<vector<int> > monsters(p, vector<int>(3));
    for(int i=0; i<p; i++){
        int a, b, c;
        cin >> b >> a >> c;
        monsters[i] = {a, b, c};
    }
    sort(armor.begin(), armor.end());
    sort(weapon.begin(), weapon.end());
    sort(monsters.begin(), monsters.end());
    vector<int> keklol = {INF, INF, 0};
    monsters.pb(keklol);
    for(int i=0; i<MAXN; i++)
        kek[i] = -INF;
    for(int i=0; i<MAXN*4; i++)
        t[i] = -INF;
    for(int i=0; i<m; i++){
        kek[i] = -armor[i].second;
    }
    build(1, 0, MAXN-1);
    int pointer = 0;
    int kek = 0;
    int ans = -INF;
//    cout << t[1] << endl;
    for(int i=0; i<n; i++){
        while(monsters[pointer][0]<=weapon[i].first){
            int l = 0, r = m-1;
            int ans = -1;
            while(l<=r){
                int mid = (l+r)/2;
                if(armor[mid].first<=monsters[pointer][1]){
                    ans = mid;
                    l = mid+1;
                } else{
                    r = mid-1;
                }
            }
            if(ans!=-1)
                update(1, 0, MAXN-1, 0, ans, monsters[pointer][2]);
            pointer++;
        }
//        cout << t[1] - weapon[i].second << endl;
        ans = max(ans, get(1, 0, MAXN-1, 0, m-1) - weapon[i].second);
    }
    cout << ans;
    return 0;
}

/*
8 9
1 2
2 3
3 4
4 5
5 6
6 7
7 8
2 4
5 7
8
1 2 3 4 5 6 7 8
 */