#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

int n, m, k;
vector<vector<int>> g, neg;
vector<vector<int>> sh;
vector<int> path;
vector<int> dist;

void bfs() {
    int s = path.back();
    dist.resize(n, 1e7);
    dist[s] = 0;
    queue<int> q;
    q.push(s);
    while (!q.empty()) {
        int cv = q.front();
        q.pop();
        for (int nv : neg[cv]) {
            if (dist[nv] > dist[cv] + 1) {
                dist[nv] = dist[cv] + 1;
                q.push(nv);
            }
        }
    }
}

int main() {
    cin >> n >> m;
    g.resize(n);
    neg.resize(n);
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        g[a - 1].push_back(b - 1);
        neg[b - 1].push_back(a - 1);
    }
    cin >> k;
    path.resize(k);
    for (int i = 0; i < k; ++i) {
        cin >> path[i];
        path[i]--;
    }
    bfs();
    int ansmax = 0, ansmin = 0;
    for (int i = 0; i < k - 1; ++i) {
        int cv = path[i];
        int nd = dist[cv] - 1;
        if (dist[path[i + 1]] != nd) {
            ansmax++;
            ansmin++;
        } else {
            for (int nv : g[path[i]]) {
                if (nv != path[i + 1] && dist[nv] == nd) {
                    ansmax++;
                    break;
                }
            }
        }
    }
    cout << ansmin << " " << ansmax << endl;
}