#include <bits/stdc++.h>

using namespace std;

#define endl '\n'
#define debug(x) cerr<<#x<<"="<<(x)<<'\n'
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define print(x, T) copy(all(x), ostream_iterator<T>(cout, " ")); cout << endl
#define mp make_pair
#define mt make_tuple
#define pb push_back
#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define for1(i, n) for (int i = 1; i <= (int)(n); ++i)
#define ford(i, n) for (int i = (int)(n); i >= 0; --i)
#define fore(i, a, b) for (int i = (int)(a); i <= (int)(b); ++i)

typedef pair<int, int> pii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<pii> vpi;
typedef long long ll;
typedef long double ld;
typedef vector<ll> vll;

template<class T> bool smin(T &a, T b) { return a > b ? (a = b, true) : false; }
template<class T> bool smax(T &a, T b) { return a < b ? (a = b, true) : false; }

const int MAXN = 5000;
const int MAXW = 5000;
const int MAXM = MAXN * MAXW;
vector<char> dp(MAXM + 10, 0);

int main()
{
    ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cout.precision(10);
	cout << fixed;
#ifndef ONLINE_JUDGE
	freopen("input.txt", "rt", stdin);
#endif

    int n;
    cin >> n;
    vector<pair<ll, ll>> a(n);
    forn(i, n) {
        cin >> a[i].first;
        a[i].second = -i;
    }
    sort(all(a));
    forn(i, n) a[i].second *= -1;
    ll ans = -1;
    forn(i, n) {
        int last = -1;
        ll cur_ans = 0;
        while (i < n - 1 && a[i + 1].second > last && a[i + 1].first - a[i].first == a[i + 1].second - a[i].second) {
            cur_ans += a[i].first;
            last = i + 1;
            i++;
        }
        if (last != -1) cur_ans += a[last].first;
        smax(ans, cur_ans);
    }
    smax(ans, a.back().first);
    cout << ans << endl;




#ifndef ONLINE_JUDGE;
	cerr << "Time elapsed: " << 1.0 * clock() / CLOCKS_PER_SEC << " s.\n";
#endif
    return 0;
}
