#include <bits/stdc++.h>
#pragma GCC optimize ("O3")
//#define int long long
using namespace std;
typedef vector<int> vi;
typedef pair<int,int> pii;
const int inf = 1e6;
inline void fastio()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
}

vector<vector<int>> E;
vector<vector<int>> R;
vi rdist;
vi p;


inline void bfs_r(int st, vi& dist)
{
    dist[st] = 0;
    queue<int> q;
    q.push(st);
    int depth = 0;
    while (!q.empty())
    {
        queue<int> q2;
        //cout << depth << ":\n";
        while (!q.empty())
        {
            int v = q.front();
            //cout << v << ' ';
            dist[v] = min(dist[v], depth);
            q.pop();
            for (int u : R[v])
                if (dist[u] == inf)
                    q2.push(u);
        }
        swap(q, q2);
        depth++;
        //cout << '\n';
    }
}


signed main()
{
    fastio();
    //freopen("kek.txt", "r", stdin);

    int n, m;
    cin >> n >> m;
    E.resize(n, vector<int>());
    R.resize(n, vector<int>());
    for (int i = 0; i < m; i++)
    {
        int x, y;
        cin >> x >> y;
        x--; y--;
        E[x].push_back(y);
        R[y].push_back(x);
    }

    int k;
    cin >> k;
    p.resize(k);
    for (int i = 0; i < k; i++)
    {
        cin >> p[i];
        p[i]--;
    }

    rdist.resize(n, inf);
    bfs_r(p[k-1], rdist);

    /*for (int i = 0; i < n; i++)
        cout << rdist[i] << ' ';
    cout << '\n';
    for (int i = 0; i < k; i++)
        cout << rdist[p[i]] << ' ';
    cout << '\n';*/

    // COUNTING THE MIN
    int mincnt = 0;
    int last_d = rdist[p[0]];
    for (int i = 1; i < k; i++)
    {
        int d = rdist[p[i]];
        if (d != last_d - 1)
            mincnt++;
        last_d = d;
    }
    cout << mincnt << ' ';

    // COUNTING THE MAX
    int maxcnt = 0;
    for (int i = 0; i < k-1; i++)
    {
        int v = p[i];
        if (rdist[p[i+1]] != rdist[v] - 1)
        {
            maxcnt++;
            continue;
        }
        int waycnt = 0;
        for (int u : E[v])
        {
            if (rdist[u] == rdist[v]-1)
                waycnt++;
            if (waycnt == 2)
                break;
        }
        if (waycnt >= 2)
            maxcnt++;
    }
    cout << maxcnt;

    return 0;
}
