#include <bits/stdc++.h>

#define int long long
#define SOLVE int t; cin >> t; while(t--) solve();

using namespace std;

void setup() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}
const int N = 2e5 + 228;

int d[N];
int tin[N];

vector<int> _g[N];
vector<int> g[N];
set<pair<int, int>> e;

int used[N];

int dfs(int v, int &k, int p) {
    tin[v] = ++k;
    used[v] = 1;
    int mx = tin[v];
    for(auto i: g[v]) {
        if (!used[i])
            mx = max(dfs(i, k, v), mx);
    }
    if (p != -1 && mx < tin[p]) {
        e.insert({p, v});
    }
    return mx;
}

signed main() {
    setup();
    // SOLVE();

    int n, m;
    fill(used, used + N, 0);
    cin >> n >> m;
    for(int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        _g[b - 1].push_back(a - 1);
        g[a - 1].push_back(b - 1);
    }
    int p = 0;
    int k;
    cin >> k;
    vector<int> z(k);
    for(int i = 0; i <k; ++i) {
        cin >> z[i];
        --z[i];
    }
    fill(d, d + N, -1);
    int f = z.back();
    queue<int> q;
    dfs(f, p, -1);
    d[f] = 0;
    q.push(f);
    //cout << f << '\n';
    while(q.size()) {
        int now = q.front();
        q.pop();
        for(auto i: _g[now]) {
            if (d[i] == -1) {
                d[i] = d[now] + 1;
                q.push(i);
            }
        }
    }
   // for(int i = 0; i < n; ++i)
    //    cout << d[i] << ' ';
   // cout << '\n';
    int kol = 0, res = 0;
    int last = z[0];
    for(int i = 1; i < k - 1; ++i) {
        if (d[z[i]] > d[last] - 1) {
            ++kol;
            //cout << z[i] << '\n';
        }
        if (d[z[i]] == d[last] - 1 && !e.count({z[i], z[i + 1]}))
            ++res;
        last = z[i];
    }
    cout << kol << ' ' << kol + res;
}
