// antihype.cpp : Defines the entry point for the console application.
//

// hype.cpp : Defines the entry point for the console application.
//

//#include "stdafx.h"
#include<iostream>
#include<string>
#include<cassert>
#include<vector>
#include<map>
#include<queue>
#include<deque>
#include<set>
#include<cmath>
#include<bitset>
#include<random>
#include<tuple>
#include<algorithm>

//#pragma GCC optimize("O3")
//#pragma GCC target("avx2")
//#pragma GCC optimize("unroll-loops")

using namespace std;

typedef long long ll;

#define int ll
#define double long double
#define loop(i, n) for (int i = 0; i < n; ++i)
#define loop1(i, n) for (int i = 1; i <= n; ++i)
#define pb push_back
#define pi pair <int, int>
#define F first
#define S second
#define ti tuple <int, int, int>
#define all(x) x.begin(), x.end()

const int N = 2e5 + 7, INF = 1e9 + 7;

vector <int> g[N], ag[N], path;
int d[N];
pi ask[N];
queue <int> q;

void bfs() {
	while(!q.empty()) {
		int v = q.front();
		q.pop();
	    loop(i, g[v].size()) {
			int u = g[v][i];
			if (d[u] == INF) {
				d[u] = d[v] + 1;
				q.push(u);
			}
		}
	}
}

void solve() {
	loop(i, N) d[i] = ask[i].F = INF;
    int n, m; cin >> n >> m;
	loop(i, m) {
		int u, v; cin >> u >> v;
		g[v].pb(u); ag[u].pb(v);
	}
	int k; cin >> k;
	path.resize(k);
	loop(i, k) cin >> path[i];
	reverse(all(path));
	q.push(path[0]); d[path[0]] = 0;
	bfs();
	loop1(v, n)
		loop(i, ag[v].size()) {
			int u = ag[v][i];
			if (d[u] < ask[v].F) 
				ask[v] = make_pair(d[u], 1);
			else if (d[u] == ask[v].F)
				++ask[v].S;
		}
	int ans1 = 0, ans2 = 0;
	loop1(i, k - 1) {
		int u = path[i], pu = path[i - 1];
		if (d[pu] > ask[u].F) {
			++ans1; ++ans2;
		}
		else if (ask[u].S > 1) ++ans2;
	}
	cout << ans1 << " " << ans2;
}

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
    solve();
    return 0;
}

