#include <bits/stdc++.h>
using namespace std;

#define F first
#define S second

using ll = long long;
using pii = pair <int, int>;

const int oo = 1e9 + 4;
const int SZ = 2e5 + 4;

int n, m, k;
vector <int> g[SZ], rg[SZ], w;

void read() {
    cin >> n >> m;
    while (m--) {
        int f, t;
        cin >> f >> t;
        f--; t--;
        g[f].push_back(t);
        rg[t].push_back(f);
    }
    cin >> k;
    w.resize(k);
    for (auto &t : w) {
        cin >> t;
        t--;
    }
}

vector <int> dp;
bool us[SZ];

int dfs(int v) {
    if (us[v]) return dp[v];
    us[v] = 1;

    int m = oo;
    for (auto to : g[v]) {
        m = min(m, dfs(to));
    }
    return dp[v] = m + 1;
}

void solve() {
    int fin = w.back();
    dp.resize(n, oo);
    dp[fin] = 0;
    us[fin] = 1;
    for (int i = 0; i < n; i++)
        dfs(i);

    int mn = 0, mx = 0;
    for (int i = 1; i < k; i++) {
        if (dp[w[i]] != dp[w[i - 1]] - 1) {
            mn++;
            mx++;
        } else {
            for (auto to : g[w[i-1]])
                if (to != w[i] && dp[to] == dp[w[i]]) {
                    mx++;
                    break;
                }
        }
    }
    cout << mn << ' ' << mx;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

  //  freopen("in.txt", "r", stdin);

    read();
    solve();
}
