#include <bits/stdc++.h>
using namespace std;

#define F first
#define S second

using ll = long long;
using pii = pair <int, int>;

const int oo = 1e9 + 4;
const int SZ = 2e5 + 4;

int n, m, k;
vector <int> g[SZ], rg[SZ], w;

void read() {
    cin >> n >> m;
    while (m--) {
        int f, t;
        cin >> f >> t;
        f--; t--;
        g[f].push_back(t);
        rg[t].push_back(f);
    }
    cin >> k;
    w.resize(k);
    for (auto &t : w) {
        cin >> t;
        t--;
    }
}

vector <int> dp, ts;
bool us[SZ], us1[SZ];

void dft(int v) {
    if (us[v]) return;
    us[v] = 1;

    for (auto to : rg[v])
        dft(to);

    ts.push_back(v);
}

int dfs(int v) {
    if (us[v] || !us1[v]) return dp[v];
    us[v] = 1;
    int m = oo;
    for (auto to : g[v]) {
     //   cout << "! " << v << ' ' << to << endl;
        m = min(m, dfs(to));
    }
    return dp[v] = m + 1;
}

void solve() {
    int fin = w.back();
    dft(fin);
    fill(us, us + n, 0);
    dp.resize(n, oo);
    dp[fin] = 0;

    queue <int> q;
    q.push(fin);

    while (!q.empty()) {
        int v = q.front();
        q.pop();

        for (auto to : rg[v]) {
            if (dp[to] > dp[v] + 1) {
                dp[to] = dp[v] + 1;
                q.push(to);
            }
        }
    }


    //for (auto t : dp) cout << t << ' ' ; cout << endl;

    int mn = 0, mx = 0;
    int r = 0;
    for (int i = 1; i < k; i++) {
        if (dp[w[i]] + 1 != dp[w[i - 1]]) {
            mn++;
        } else {
            r++;
            for (auto to : g[w[i-1]])
                if (to != w[i] && dp[to] == dp[w[i]]) {
                    mx += 1;
                    r = 0;
                    break;
                }
        }
    }
    cout << mn << ' ' << mn + mx;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    //freopen("in.txt", "r", stdin);

    read();
    solve();
}
