#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

vector<vector<ll> > g;
vector<vector<ll> > g1;

ll inf = 1e10;

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll n, m;
    cin >> n >> m;
    g.resize(n);
    g1.resize(n);
    for (int i = 0; i < m; i++)
    {
        ll a, b;
        cin >> a >> b;
        a--;
        b--;
        g[a].push_back(b);
        g1[b].push_back(a);
    }
    ll k;
    cin >> k;
    vector<ll> path(k);
    for (int i = 0; i < k; i++)
    {
        cin >> path[i];
        path[i]--;
    }

    queue<ll> q;
    vector<ll> d(n, inf);
    vector<ll> z(n, 0);
    vector<bool> used(n, false);
    ll f = path.back();
    d[f] = 0;
    z[f] = 1;
    used[f] = true;
    q.push(f);
    while (!q.empty())
    {
        ll v = q.front();
        used[v] = true;
        q.pop();
        for (int i = 0; i < g1[v].size(); i++)
        {
            ll to = g1[v][i];
            if (used[to])
            {
                if (d[to] == d[v])
                    continue;
                if (d[to] == d[v] + 1)
                {
                    z[to] += z[v];
                    continue;
                }
            }
            else
            {
                used[to] = true;
                d[to] = d[v] + 1;
                z[to] += z[v];
                q.push(to);
            }
        }
    }
    /**for (int i = 0; i < n; i++)
    {
        cout << "z[" << i + 1 << "] = " << z[i] << "\n";
    }
*/
    ll minn = 0, maxx = 0;
    ll v = path[0];
    for (int i = 1; i < path.size(); i++)
    {
        ll to = path[i];
        if (d[v] - 1 == d[to])
        {
            if (z[v] > 1)
                maxx++;
        }
        else
        {
           // cout << "v = " << v + 1 << "\n";
            minn++;
            maxx++;
        }
        v = to;
    }
    cout << minn << " " << maxx;
}
