#include<bits/stdc++.h>

#define pii pair<int, int>
#define all(x) begin(x), end(x)
#define ld long double
#define int long long
#define x first
#define y second

using namespace std;

void fast() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    #ifdef _offline
        freopen("input.txt", "r", stdin);
//        freopen("output.txt", "w", stdout);
    #endif // _offline
}

struct pt {
    int c, x, y;
};

struct node {
    int val, op;
};

const int INF = 1e18;

vector<node> t;

void push(int v) {
    t[v * 2 + 1].op += t[v].op;
    t[v * 2 + 2].op += t[v].op;
    t[v].val += t[v].op;
    t[v].op = 0;
}

int get(int v, int tl, int tr, int l, int r) {
    push(v);
    if(tl > r || tr < l) {
        return 0;
    }
    if(tl >= l && tr <= r) {
        return t[v].val;
    }
    int tm = (tl + tr) >> 1;
    int left = get(v * 2 + 1, tl, tm, l, r);
    int right = get(v * 2 + 2, tm + 1, tr, l, r);
    return max(left, right);
}

void update(int v, int tl, int tr, int l, int r, int val) {
    push(v);
    if(tl > r || tr < l) {
        return;
    }
    if(tl >= l && tr <= r) {
        t[v].op += val;
        push(v);
        return;
    }
    int tm = (tl + tr) >> 1;
    update(v * 2 + 1, tl, tm, l, r, val);
    update(v * 2 + 2, tm + 1, tr, l, r, val);
    t[v].val = max(t[v * 2 + 1].val, t[v * 2 + 2].val);
}

signed main() {
    fast();
    int n, m, p;
    cin >> n >> m >> p;
    vector<pair<int, int>> a(n), b(m);
    vector<pt> c(p);
    for(int i = 0; i < n; i++) {
        cin >> a[i].x >> a[i].y;
    }
    for(int i=  0; i < m; i++) {
        cin >> b[i].x >> b[i].y;
    }
    for(int i = 0; i < p; i++) {
        cin >> c[i].x >> c[i].y >> c[i].c;
    }
    sort(all(a));
    sort(all(b));
    sort(all(c), [&](pt a, pt b) {
        return a.x < b.x;
    });
    t.resize(8 * m);
    for(int i = 0; i < m; i++) {
        update(0, 0, m - 1, i, i, -b[i].y);
    }
    int pos = 0, ans = -INF;
    for(int i = 0; i < n; i++) {
        while(pos < c.size() && c[pos].x < a[i].x) {
            int nd = upper_bound(all(b), pair<int, int>{c[pos].y, INF}) - b.begin();
//            cerr << c[pos].y << " " << nd << '\n';
            if(nd <= m - 1) update(0, 0, m - 1, nd, m - 1, c[pos].c);
            pos++;
        }
        int sum = -a[i].y + get(0, 0, m - 1, 0, m - 1);
        ans = max(ans, sum);
    }
    cout << ans;
//    int n;
//    cin >> n;
//    string s;
//    cin >> s;
//    for(int i = 'z'; i > 'a'; i--) {
//        for(int j = 0; j < s.size(); j++) {
//            if(s[j] == i && ((j > 0 && s[j - 1] == s[j] - 1) || (j < n - 1 && s[j + 1] == s[j] - 1))) {
//                s.erase(s.begin() + j);
//                j--;
//            }
//        }
//    }
//    cout << n - s.size();
    return 0;
}
