#include <bits/stdc++.h>
#define int long long
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)((x).size())
#define f first
#define s second
#define pii pair<int, int>

using namespace std;

void solve(){
    int n, m;
    cin >> n >> m;
    vector<vector<int>> grt(n), grr(n);
    for(int i = 0; i < m; ++i){
        int a, b;
        cin >> a >> b;
        a--; b--;
        grt[a].push_back(b);
        grr[b].push_back(a);
    }
    int k;
    cin>> k;
    vector<int> p(k);
    for(int i = 0; i < k; ++i) {cin >> p[i]; p[i]--;}
    reverse(all(p));
    vector<int> dist(n, 1e9);
    queue<int> q;
    q.push(p[0]);
    dist[p[0]] = 0;
    while(!q.empty()){
        int v = q.front();
        q.pop();
        for(int u : grr[v]) {
            if(dist[u] == 1e9){
                dist[u] = dist[v] + 1;
                q.push(u);
            }
        }
    }
    int minans = 0, maxans = 0;
    for(int i = 1; i < k; ++i){
        int md = 1e9;
        for(int j : grt[p[i]]){
            if(j == p[i - 1]) continue;
            md = min(md, dist[j] + 1);
        }
        int d = dist[p[i - 1]] + 1;
        if(md < d) minans++, maxans++;
        if(md == d) maxans++;

    }
    cout << minans << ' ' << maxans;
}

signed main(){
    ios::sync_with_stdio(0); cin.tie(0);
    //freopen("input.txt", "r", stdin);
    int t;
    t = 1;
    while(t--) solve();
    return 0;
}
