#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <ext/pb_ds/assoc_container.hpp>
#include <unordered_map>

#define int long long

using namespace std;
using namespace __gnu_pbds;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> derevo;

int32_t main() {
    #ifdef local
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    #endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    for (int i = 0; i < n; i++) cin >> b[i];
    int cnt1, cnt2 = 0;
    for (int i = 0; i < n; i++) {
        if (a[i]) cnt1++;
        if (b[i]) cnt2++;
        if (a[i] & b[i]) cnt1--, cnt2--;
    }
    if (cnt1 == 0) {
        cout << -1;
    } else {
        int ans = 1;
        while (cnt1 * ans <= cnt2) ans++;
        cout << ans;
    }
    return 0;
}
