#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define x first
#define y second

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

vector<int> g[200009];
vector<int> e[200009];

int dist[200009];
int dists[200009];
int cnt[200009];

signed main() {
    ios :: sync_with_stdio(0);
    cin.tie(0);

    int n, m;
    cin >> n >> m;

    for (int i = 0; i < m; i ++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;

        g[a].push_back(b);
        e[b].push_back(a);
    }

    int k;
    cin >> k;
    vector<int> way(k);

    for (int i = 0; i < k; i ++) {
        cin >> way[i];
        way[i]--;
    }

    int s = way[0], t = way.back();
    int mn = 0, mx = 0;

    const int inf = 1e9;
    for (int i = 0; i < n; i ++) {
        dist[i] = inf;
        dists[i] = inf;
    }

    dist[t] = 0;
    queue<int> q;
    q.push(t);

    while (q.size()) {
        auto v = q.front();
        q.pop();

        for (auto u : e[v]) {
            if (dist[u] > dist[v] + 1) {
                dist[u] = dist[v] + 1;
                cnt[u] = 1;
                q.push(u);
            }

            else if (dist[u] == dist[v] + 1) {
                cnt[u]++;
            }
        }
    }

    dists[s] = 0;
    q.push(s);

    while (q.size()) {
        auto v = q.front();
        q.pop();

        for (auto u : g[v]) {
            if (dists[u] > dists[v] + 1) {
                dists[u] = dists[v] + 1;
                q.push(u);
            }
        }
    }

    for (int i = 0; i < k - 1; i++) {
        //cout << way[i] + 1 << ' ' << cnt[way[i]] << endl;
        if (dist[way[i + 1]] + 1 == dist[way[i]]) {
            //cout << "cool" << endl;
            if (cnt[way[i]] >= 2) {
                mx++;
            }
        }

        else {
            mn++;
            mx++;
        }
    }

    cout << mn << ' ' << mx;

    return 0;
}
