#include <bits/stdc++.h>

using namespace std;

#define int long long
#define x first
#define y second

#define left (v << 1), tl, tm
#define right (v << 1) + 1, tm, tr
#define vert int v, int tl, int tr

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

int tree[4000009];
int add[4000009];

int minc[1000009];
const int inf = 1e12;

void build(vert) {
    add[v] = 0;
    if (tr - tl == 1) {
        tree[v] = -minc[tl];
        return;
    }

    int tm = (tl + tr) >> 1;
    build(left);
    build(right);
    tree[v] = max(tree[v << 1], tree[(v << 1) + 1]);
}

void push(vert) {
    tree[v] += add[v];
    if (tr - tl != 1) {
        add[v << 1] += add[v];
        add[(v << 1) + 1] += add[v];
    }

    add[v] = 0;
}

void upd(vert, int l, int r, int x) {
    push(v, tl, tr);
    if (tl >= r || l >= tr) return;
    if (tl >= l && tr <= r) {add[v] += x; push(v, tl, tr); return;}
    int tm = (tl + tr) >> 1;
    upd(left, l, r, x);
    upd(right, l, r, x);
    tree[v] = max(tree[v << 1], tree[(v << 1) + 1]);
}

int getmax(vert) {
    push(v, tl, tr);
    return tree[v];
}

struct monster {
    int w, a, cost;
    monster() {};
    monster(int _w, int _a, int _cost) {
        w = _w;
        a = _a;
        cost = _cost;
    }

    bool operator < (monster oth) {
        if (oth.w != w) return w < oth.w;
        if (oth.a != a) return a < oth.a;
        return cost < oth.cost;
    }
};

signed main() {
    ios :: sync_with_stdio(0);
    cin.tie(0);

    int n, m, p;
    cin >> n >> m >> p;

    vector<pii> weap(n);
    vector<pii> arm(m);
    vector<monster> mons(p);
    for (int i = 0; i < n; i ++) {
        cin >> weap[i].x >> weap[i].y;
    }

    sort(weap.begin(), weap.end());

    for (int i = 0; i < m; i ++) {
        cin >> arm[i].x >> arm[i].y;
    }

    sort(arm.begin(), arm.end());
    vector<int> suffmn(m + 1);
    suffmn[m] = inf;
    for (int i = m - 1; i > -1; i--) {
        suffmn[i] = min(suffmn[i + 1], arm[i].y);
    }

    for (int i = 0; i <p; i ++) {
        cin >> mons[i].w >> mons[i].a >> mons[i].cost;
    }

    sort(mons.begin(), mons.end());

    for (int i = 0; i <= 1000000; i++) {
        auto ret = upper_bound(arm.begin(), arm.end(), make_pair(i, inf)) - arm.begin();
        minc[i] = suffmn[ret];

        //if (i <= 10) {
         //   cout << "GET: " << i << ' ' << minc[i] << endl;
        //}
    }

    build(1, 0, 1000001);

    int pntm = 0;
    int answ = -inf;
    for (int i = 0; i < n; i ++) {
        while (pntm < p && mons[pntm].w < weap[i].x) {
            upd(1, 0, 1000001, mons[pntm].a, 1000001, mons[pntm].cost);
            pntm++;
        }

        auto ret = getmax(1, 0, 1000001);
        //cout << "\t" << i + 1 << ' ' << ret << ' ' << pntm + 1 << endl;
        answ = max(answ, -weap[i].y + ret);
    }

    cout << answ;

    return 0;
}
