#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define x first
#define y second

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

const int mod = (1e9) + 9, p = 3;
const int modsq = mod * mod;

int powp[200009];
int pref[200009];
int psum[200009][2];
vector<int> meet;
int n;
string s;

void build() {
    powp[0] = 1;
    for (int i = 0; i < n; i ++) {
        powp[i + 1] = (powp[i] * p) % mod;
    }

    for (int i = 0; i < n; i ++) {
        pref[i + 1] = (pref[i] * p + s[i]) % mod;
    }

    for (int i = 0; i < n; i ++) {
        psum[i + 1][0] = psum[i][0];
        psum[i + 1][1] = psum[i][1];
        psum[i + 1][i & 1] += s[i];
    }

    string s1 = "011", s2 = "110";
    for (int i = 0; i < n - 2; i ++) {
        bool ok1 = 1, ok2 = 1;
        for (int j = i; j < i + 3; j++) {
            if (s[j] != s1[j - i] - '0') ok1 = 0;
            if (s[j] != s2[j - i] - '0') ok2 = 0;
        }

        if (ok1 || ok2) {
            meet.push_back(i);
        }
    }
}

int geth(int l, int r) {
    r++;
    return (pref[r] - pref[l] * powp[r - l] + modsq) % mod;
}

bool canch(int l, int r) {
    auto ret1 = lower_bound(meet.begin(), meet.end(), l);
    if (ret1 == meet.end() || *ret1 > r - 2) return 0;
    return 1;
}

signed main() {
    ios :: sync_with_stdio(0);
    cin.tie(0);

    cin >> n;
    cin >> s;

    for (auto &u : s) {
        u -= '0';
    }

    build();

    int qqq;
    cin >> qqq;

    while (qqq--) {
        int l1, l2, len;
        cin >> l1 >> l2 >> len;
        l1--;
        l2--;

        int r1 = l1 + len - 1, r2 = l2 + len - 1;

        if (geth(l1, r1) == geth(l2, r2)) {
            cout << "Yes\n";
            continue;
        }

        if (psum[r1 + 1][l1&1] - psum[l1][l1&1] != psum[r2 + 1][l2&1] - psum[l2][l2&1] || psum[r1 + 1][1 - (l1&1)] - psum[l1][1 - (l1&1)] != psum[r2 + 1][1 - (l2&1)] - psum[l2][1 - (l2&1)]) {
            cout << "No\n";
            continue;
        }

        if (!canch(l1, r1) || !canch(l2, r2)) {
            cout << "No\n";
            continue;
        }

        cout << "Yes\n";
    }

    return 0;
}

