#include <bits/stdc++.h>

using namespace std;

const int INF = 1e9;

void bfs(int s, vector<vector<int>>& graph, vector<int>& dist, vector<set<int>>& par) {
    queue<int> q;
    q.push(s);
    dist[s] = 0;
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (int u : graph[v]) {
            if (dist[u] == dist[v] + 1) {
                par[u].insert(v);
            } else if (dist[u] > dist[v] + 1) {
                dist[u] = dist[v] + 1;
                par[u] = {v};
                q.push(u);
            }

        }
    }
}

int main() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> graph(n);
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        graph[v - 1].push_back(u - 1);
    }
    int k;
    cin >> k;
    vector<int> path(k);
    for (int i = 0; i < k; i++) {
        cin >> path[i];
        path[i]--;
    }
    vector<int> dist(n, INF);
    vector<int> cnt(n, 0);
    vector<set<int>> par(n);
    bfs(path[k - 1], graph, dist, par);
    int ans_min = 0, ans_max = 0;
    for (int i = 0; i < k - 1; i++) {
        if (par[path[i]].count(path[i + 1]) == 0) {
            ans_max++;
            ans_min++;
        }
        ans_max += par[path[i]].size() - 1;
    }
    cout << ans_min << ' ' << ans_max;
    return 0;
}

