#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(a) a.begin(),a.end()
#define rall(a) a.rbegin(),a.rend()
#define loop(i, n) for(int i = 0; i<n; ++i)
#define FOR(i, n, m) for(int i = n; i<m; ++i)
#define fr first
#define sc second

const int pivo = 1e9 + 7;
const int INF = 1e18;

struct pol_hash
{
    vector <int> st1, st2, hash1, hash2;
    const int MOD1 = 1e9 + 7, MOD2 = 1e9 + 53;
    const int P1 = 31, P2 = 53;
    pol_hash(string s)
    {
        int n = s.size();
        st1.resize(n + 1, 1), st2.resize(n + 1, 1), hash1.resize(n + 1, 0), hash2.resize(n + 1, 0);
        FOR(i, 1, n + 1) st1[i] = (st1[i - 1] * P1)%MOD1;
        FOR(i, 1, n + 1) st2[i] = (st2[i - 1] * P2)%MOD2;

        FOR(i, 1, n + 1) hash1[i] = ((hash1[i - 1] * P1)%MOD1 + s[i] - 'a' + 1 + MOD1)%MOD1;
        FOR(i, 1, n + 1) hash2[i] = ((hash2[i - 1] * P2)%MOD2 + s[i] - 'a' + 1 + MOD2)%MOD2;
    }
    int get_hash(int l, int r)
    {
        int res1 = (hash1[r + 1] - (hash1[l] * st1[r - l + 1]) % MOD1 + 10 * MOD1)%MOD1;
        int res2 = (hash2[r + 1] - (hash2[l] * st2[r - l + 1]) % MOD2 + 10 * MOD2)%MOD2;
        int f = res1 * MOD2 + res2;
        return f;
    }
};

vector <int> prefix(string s)
{
    int n = s.size();
    vector <int> pi(n, 0);
    FOR(i, 1, n)
    {
        int j = pi[i - 1];
        while(j > 0 && s[i] != s[j])
            j = pi[j - 1];
        if (s[i] == s[j]) ++j;
        pi[i] = j;
    }
    return pi;
}

vector <vector <int> > g;

signed main()
{
    int n;
    cin >> n;
    vector <int> vec(n);
    loop(i, n) cin >> vec[i];
    vector <pair <int, int> > kek(n);
    loop(i, n) kek[i].first = vec[i] - (i + 1), kek[i].second = vec[i];
    sort(all(kek));
    int ans = 0;
    int i = 0;
    while(i < n)
    {
        int fans = 0;
        int j = i;
        while(kek[i].first == kek[j].first && j < n)
        {
            fans += kek[j].second;
            ++j;
            ans = max(ans, fans);
        }
        ans = max(ans, fans);
        i = j;
    }
    cout << ans;
}
