#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define all(v) v.begin(), v.end()
#define sz(v) int(v.size())
#define fi first
#define se second

using namespace __gnu_cxx;
using namespace __gnu_pbds;
using namespace std;
using ll = long long;
using ld = long double;
using pii = pair <int, int>;
using pll = pair <ll, ll>;

typedef tree <int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update> indexed_set;

const int L = 1e5 + 1;
const ll MOD = 1e9 + 7;
const ll INF = (1LL << 61);

int n, m, k;
vector <int> p;

void bfs(vector <vector <int>> &g, vector <int> &d, vector <bool> &used) {
    queue <int> q;
    d[p[k - 1]] = 0;
    q.push(p[k - 1]);
    used[p[k - 1]] = true;

    while (!q.empty()) {
        int cur = q.front();
        q.pop();

        for (auto i : g[cur]) {
            if (!used[i]) {
                used[i] = true;
                d[i] = d[cur] + 1;
                q.push(i);
            }
        }
    }
}

vector <vector <int>> g, anti_g;

int main() {
    ios_base :: sync_with_stdio(0);
    cin.tie(nullptr); cout.tie(nullptr);

    cin >> n >> m;
    g.resize(n);
    anti_g.resize(n);

    for (int i = 0; i < m; ++i) {
        int v, u;
        cin >> v >> u;
        --v, --u;

        g[v].push_back(u);
        anti_g[u].push_back(v);
    }

    cin >> k;
    p.resize(k);
    for (int &i : p) {
        cin >> i;
        --i;
    }

    vector <int> d(n, -1);
    vector <bool> used(n);
    bfs(anti_g, d, used);

    int mx = 0, mn = 0;

    for (int i = 1; i < k; ++i) {
        if (d[p[i]] == d[p[i - 1]]) {
            ++mn;
            ++mx;
        }

        else {
            int cnt = 0;
            for (auto j : g[p[i - 1]]) {
                if (d[j] == d[p[i]]) ++cnt;

                if (cnt == 2) {
                    ++mx;
                    break;
                }
            }
        }
    }

    cout << mn << ' ' << mx;

    return 0;
}
