#pragma GCC optimize("Ofast,no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse4")

#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <string>
#include <iomanip>
#include <chrono>
#include <random>
#include <unordered_map>
#include <numeric>
#include <cmath>
#include <ctime>

using namespace std;
using ll = long long;
using ld = long double;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

bool maxi(ll &a, ll b) {
    if (b > a) {
        a = b;
        return true;
    }
    return false;
}

bool mini(ll &a, ll b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

ll mmax(ll a, ll b) {
    if (a > b) {
        return a;
    }
    return b;
}

ll mmin(ll a, ll b) {
    if (a < b) {
        return a;
    }
    return b;
}

ll n, m, k;
vector <bool> used;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n;
    vector <ll> a(n), b(n);
    for (auto &x : a) {
        cin >> x;
    }
    for (auto &x : b) {
        cin >> x;
    }
    ll onlyme = 0, onlyhe = 0;
    for (int i = 0; i < n; ++i) {
        if (a[i] && !b[i]) onlyme++;
        if (!a[i] && b[i]) onlyhe++;
    }
    ll target = onlyhe + 1;
    if (onlyme == 0) {
        cout << -1;
    }
    else {
        cout << (target + onlyme - 1) / onlyme;
    }
    return 0;
}
