// chrono::system_clock::now().time_since_epoch().count()
#define DBG 1

//#include<ext/pb_ds/tree_policy.hpp>
//#include<ext/pb_ds/assoc_container.hpp>
#include<bits/stdc++.h>

#define pb push_back
#define eb emplace_back
#define mp make_pair
#define fi first
#define se second
#define all(x) (x).begin(), (x).end()
#define debug(x) if (DBG) cerr << #x << " = " << x << endl;

using namespace std;
//using namespace __gnu_pbds;

typedef long long ll;
typedef pair<int, int> pii;
//template<typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

const int MAXN = (int)2e5 + 5;

pair<pii, int> enemy[MAXN];
pii weapon[MAXN], armor[MAXN];
ll t[MAXN << 2], ext[MAXN << 2];
int n, m, p;

void build(int v, int tl, int tr) {
    if (tl == tr) {
        t[v] = -armor[tl].se;
        return;
    }

    int mid = (tl + tr) >> 1;
    int c1 = (v << 1), c2 = (c1 | 1);

    build(c1, tl, mid);
    build(c2, mid + 1, tr);

    t[v] = max(t[c1], t[c2]);
}

void push(int v, int tl, int tr) {
    t[v] += ext[v];

    if (tl != tr) {
        int c1 = (v << 1), c2 = (c1 | 1);
        ext[c1] += ext[v];
        ext[c2] += ext[v];
    }

    ext[v] = 0;
}

void update(int v, int tl, int tr, int l, int r, int x) {
    push(v, tl, tr);

    if (l > r || tl > r || tr < l) {
        return;
    }

    if (l <= tl && tr <= r) {
        ext[v] += x;
        push(v, tl, tr);
        return;
    }

    int mid = (tl + tr) >> 1;
    int c1 = (v << 1), c2 = (c1 | 1);

    update(c1, tl, mid, l, r, x);
    update(c2, mid + 1, tr, l, r, x);

    t[v] = max(t[c1], t[c2]);
}

ll totMax() {
    push(1, 1, m);
    return t[1];
}

void solve() {
    scanf("%d %d %d", &n, &m, &p);

    for (int i = 1; i <= n; ++i) {
        scanf("%d %d", &weapon[i].fi, &weapon[i].se);
    }

    for (int i = 1; i <= m; ++i) {
        scanf("%d %d", &armor[i].fi, &armor[i].se);
    }

    for (int i = 1; i <= p; ++i) {
        scanf("%d %d %d", &enemy[i].fi.fi, &enemy[i].fi.se, &enemy[i].se);
    }

    sort(weapon + 1, weapon + n + 1);
    sort(armor + 1, armor + m + 1);
    sort(enemy + 1, enemy + p + 1);
    build(1, 1, m);
    int ptr = 1;
    ll ans = 0;

    for (int i = 1; i <= n; ++i) {
        while (ptr <= p && enemy[ptr].fi.fi < weapon[i].fi) {
            int idx = lower_bound(armor + 1, armor + m + 1, mp(enemy[ptr].fi.se + 1, 0)) - armor;
            update(1, 1, m, idx, m, enemy[ptr].se);
            ++ptr;
        }

        ans = max(ans, -weapon[i].se + totMax());
    }

    printf("%lld\n", ans);
}

int main() {
    int tt = 1;

    while (tt--) {
        solve();
    }

    return 0;
}
