// chrono::system_clock::now().time_since_epoch().count()
#define DBG 1

//#include<ext/pb_ds/tree_policy.hpp>
//#include<ext/pb_ds/assoc_container.hpp>
#include<bits/stdc++.h>

#define pb push_back
#define eb emplace_back
#define mp make_pair
#define fi first
#define se second
#define all(x) (x).begin(), (x).end()
#define debug(x) if (DBG) cerr << #x << " = " << x << endl;

using namespace std;
//using namespace __gnu_pbds;

typedef long long ll;
typedef pair<int, int> pii;
typedef vector<int> vi;
typedef pair<vi, int> pvi;
//template<typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

const int MAXN = (int)2e5 + 5;
const int MOD[] = {(int)1e9 + 7, (int)1e9 + 9};
const int P[] = {7, 13};
const int K = 2;

struct Node {
    pvi hsh1, hsh2;
    int len;
    int fr;

    Node() {
        hsh1 = mp(vi(K, 0), 0);
        hsh2 = mp(vi(K, 0), 0);
        hsh2.se = 0;
        len = fr = 0;
    }
};

int pw[2][MAXN], revp[2];
Node t[MAXN << 2];
char s[MAXN];
int n, q;

int addMod(int a, int b, int m) {
    a += b;

    if (m <= a) {
        a -= m;
    }

    return a;
}

int mulMod(int a, int b, int m) {
    return a * 1ll * b % m;
}

int binPow(int a, int b, int m) {
    int ret = 1;

    while (b > 0) {
        if (b & 1) {
            ret = mulMod(ret, a, m);
        }

        a = mulMod(a, a, m);
        b >>= 1;
    }

    return ret;
}

void pre() {
    for (int i = 0; i < K; ++i) {
        pw[i][0] = 1;

        for (int j = 1; j < MAXN; ++j) {
            pw[i][j] = mulMod(pw[i][j - 1], P[i], MOD[i]);
        }

        revp[i] = binPow(P[i], MOD[i] - 2, MOD[i]);
    }
}

pvi operator + (pvi a, pvi b) {
    for (int i = 0; i < K; ++i) {
        a.fi[i] = addMod(a.fi[i], mulMod(b.fi[i], pw[i][a.se], MOD[i]), MOD[i]);
    }

    a.se += b.se;
    return a;
}

Node comb(Node a, Node b) {
    Node ret;
    ret.len = a.len + b.len;

    if (a.fr == a.len) {
        ret.fr = a.len + b.fr;
    }
    else {
        ret.fr = a.fr + b.fr / 2 * 2;
    }

    if (a.fr == a.len && a.len % 2 && b.fr % 2) {
        ret.hsh1 = a.hsh1 + a.hsh2;
        ret.hsh1 = ret.hsh1 + b.hsh1;
        ret.hsh1 = ret.hsh1 + mp(vi(K, 2), 1);
        ret.hsh2 = b.hsh2;
        ret.hsh2.se--;

        for (int i = 0; i < K; ++i) {
            ret.hsh2.fi[i] = addMod(ret.hsh2.fi[i], MOD[i] - 2, MOD[i]);
            ret.hsh2.fi[i] = mulMod(ret.hsh2.fi[i], revp[i], MOD[i]);
        }
    }
    else {
        ret.hsh1 = a.hsh1 + b.hsh1;
        ret.hsh2 = a.hsh2 + b.hsh2;
    }

    return ret;
}

void build(int v, int tl, int tr) {
    if (tl == tr) {
        if (s[tl]) {
            t[v].hsh1 = mp(vi(K, 0), 0);
            t[v].hsh2 = mp(vi(K, 2), 1);
            t[v].len = 1;
            t[v].fr = 1;
        }
        else {
            t[v].hsh1 = mp(vi(K, 0), 0);
            t[v].hsh2 = mp(vi(K, 1), 1);
            t[v].len = 1;
            t[v].fr = 0;
        }

        return;
    }

    int mid = (tl + tr) >> 1;
    int c1 = (v << 1), c2 = (c1 | 1);
    build(c1, tl, mid);
    build(c2, mid + 1, tr);
    t[v] = comb(t[c1], t[c2]);
}

Node func(int v, int tl, int tr, int l, int r) {
    if (l > r || tl > r || tr < l) {
        return Node();
    }

    if (l <= tl && tr <= r) {
        return t[v];
    }

    int mid = (tl + tr) >> 1;
    int c1 = (v << 1), c2 = (c1 | 1);

    return comb(func(c1, tl, mid, l, r), func(c2, mid + 1, tr, l, r));
}

void solve() {
    scanf("%d", &n);
    scanf("%s", s + 1);
    scanf("%d", &q);

    for (int i = 1; i <= n; ++i) {
        s[i] -= '0';
    }

    build(1, 1, n);

    for (int i = 1; i <= q; ++i) {
        int l1, l2, len;
        scanf("%d %d %d", &l1, &l2, &len);
        Node f = func(1, 1, n, l1, l1 + len - 1);
        Node s = func(1, 1, n, l2, l2 + len - 1);
        assert(f.len == len);
        assert(s.len == len);
        printf(f.hsh1 + f.hsh2 == s.hsh1 + s.hsh2 ? "Yes\n" : "No\n");
    }
}

int main() {
    int tt = 1;
    pre();

    while (tt--) {
        solve();
    }

    return 0;
}
