#ifdef _DEV
#define DEV 1
#else
#define DEV 0
#pragma GCC optimize("O3")
#endif
#define $ if (DEV)

#include <algorithm>
#include <cstdio>
#include <iostream>
#include <iomanip>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <cassert>
#include <random>
#include <chrono>
#include <string>
#include <utility>

//#include <bits/stdc++.h>
using namespace std;

void $main(int test_id);


mt19937_64 rng(123'864'534);

int main() {
    int test_count = 1;
    $ {
        test_count = 1000;
        freopen("input.txt", "r", stdin);
    } else {
        ios::sync_with_stdio(false);
    }

    cout << fixed << setprecision(10);

    for (int t = 0; t < test_count; ++t) {
        $main(t);
        int ch = -1;
        while (DEV) {
            ch = fgetc(stdin);
            if (ch == -1 || !isspace(ch)) {
                break;
            }
        }
        if (ch == -1) { break; }
        ungetc(ch, stdin);
    }

    return 0;
}

template<typename T>
bool relmax(T &place, T const &val) {
    if (place < val) {
        place = val;
        return true;
    } else {
        return false;
    }
}

template<typename T>
bool relmin(T &place, T const &val) {
    if (place > val) {
        place = val;
        return true;
    } else {
        return false;
    }
}

using ll = long long;

void $main(int test_id) {
    int n;
    string s;
    cin >> n >> s;
    int ans = 0;
    bool ok =true;
    while (ok) {
        ok = false;
        if (s.empty()) {break;}
        for (char c = 'z'; c > 'a'; --c) {
            for (int i = 0; i < s.size(); ++i) {
                if (s[i] != c) {continue;}
                if ((i > 0 && s[i - 1] + 1 == s[i]) || (i + 1 < s.size() && s[i + 1] + 1 == s[i])) {
                    ok = true;
                    s.erase(s.begin() + i);
                    ans++;
                    $ printf("del: %s\n", s.c_str());
                    break;
                }
            }
            if (ok) {break;}
        }
    }
    $ printf("res: %s\n", s.c_str());
    cout << ans << "\n";
}