#include <bits/stdc++.h>

using namespace std;

#define fs first
#define sc second
#define pii pair < int, int >
#define pb push_back
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define fast_io ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define getfiles ifstream cin("input.txt"); ofstream cout("output.txt");

typedef long long ll;
typedef long double ld;

const int INF = 1e9;
const ll BIG_INF = 1e18;
const ll MOD = 1e9 + 7;

const int maxn = 100 + 5, maxw = 28;
vector < pii > dict[maxw];
int n, delta[maxn];
string s;

void upd() {
    for (int i = 0; i < maxw; i++)
        dict[i].clear();

    int len = 1, last = 0;
    for (int i = 1; i < sz(s); i++) {
        if (s[i] != s[last]) {
            dict[s[last] - 'a'].pb({last, len});
            last = i;
            len = 1;
        } else
            len++;
    }
    dict[s[last] - 'a'].pb({last, len});
}

bool can(int ind) {
    if (ind > 0 && (s[ind - 1] - 'a') + 1 == (s[ind] - 'a'))
        return true;
    if (ind < sz(s) - 1 && (s[ind + 1] - 'a') + 1 == (s[ind] - 'a'))
        return true;

    return false;
}

int main() {
    fast_io
    cin >> n;
    cin >> s;

    upd();

    int ans = 0;
    for (int i = maxw - 1; i >= 0; i--) {
        for (int j = 0; j < sz(dict[i]); j++) {
            int l = dict[i][j].fs, r = l + dict[i][j].sc - 1;

            if (!can(l) && !can(r)) continue;

            int len = r - l + 1;
            ans += len;
            s.erase(l, len);

            upd();
            j = -1;
        }
    }

    cout << ans << "\n";
    return 0;
}

