#include <bits/stdc++.h>

using namespace std;

#define fs first
#define sc second
#define pii pair < int, int >
#define pb push_back
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define fast_io ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define getfiles ifstream cin("input.txt"); ofstream cout("output.txt");

typedef long long ll;
typedef long double ld;

const int INF = 1e9;
const ll BIG_INF = 1e18;
const ll MOD = 1e9 + 7;

const int maxn = 2e5 + 5;
int x[maxn], y[maxn], z[maxn], inds[maxn], pos[maxn];
pii a[maxn], b[maxn];
bool can[maxn];
int n, m, p;
ll res[maxn], t[4 * maxn], mx[4 * maxn];

bool comp(int _x, int _y) {
    return x[_x] < x[_y];
}

bool comp2(pii _x, pii _y) {
    return _x.sc < _y.sc;
}

bool comp3(int _x, int _y) {
    return y[_x] < y[_y];
}

int bin_search(int val) {
    int l = -1, r = p;
    while (r - l > 1) {
        int m = (l + r) / 2;
        if (x[inds[m]] < val)
            l = m;
        else
            r = m;
    }

    return l;
}

int bin_search1(int val) {
    int l = -1, r = n;
    while (r - l > 1) {
        int m = (l + r) / 2;
        if (a[m].fs >= val)
            r = m;
        else
            l = m;
    }

    return r;
}

int bin_search2(int val) {
    int l = -1, r = p;
    while (r - l > 1) {
        int m = (l + r) / 2;
        if (y[inds[m]] < val)
            l = m;
        else
            r = m;
    }

    return l;
}

void upd_pos(int v, int tl, int tr, int ind, ll val) {
    if (tl == tr) {
        t[v] = val;
        return;
    }

    int tm = (tl + tr) / 2;
    if (ind <= tm)
        upd_pos(2 * v, tl, tm, ind, val);
    else
        upd_pos(2 * v + 1, tm + 1, tr, ind, val);

    t[v] = t[2 * v] + t[2 * v + 1];
}

ll sum_on_segm(int v, int tl, int tr, int l, int r) {
    if (l > r) return 0LL;
    if (tl == l && tr == r) return t[v];

    int tm = (tl + tr) / 2;
    return sum_on_segm(2 * v, tl, tm, l, min(tm, r)) + sum_on_segm(2 * v + 1, tm + 1, tr, max(tm + 1, l), r);
}

void upd_pos2(int v, int tl, int tr, int ind, ll val) {
    if (tl == tr) {
        mx[v] = val;
        return;
    }

    int tm = (tl + tr) / 2;
    if (ind <= tm)
        upd_pos2(2 * v, tl, tm, ind, val);
    else
        upd_pos2(2 * v + 1, tm + 1, tr, ind, val);

    mx[v] = max(mx[2 * v], mx[2 * v + 1]);
}

ll mx_on_segm(int v, int tl, int tr, int l, int r) {
    if (l > r) return -BIG_INF;
    if (tl == l && tr == r) return mx[v];

    int tm = (tl + tr) / 2;
    return max(mx_on_segm(2 * v, tl, tm, l, min(tm, r)), mx_on_segm(2 * v + 1, tm + 1, tr, max(tm + 1, l), r));
}

int main() {
    fast_io
    cin >> n >> m >> p;

    for (int i = 0; i < 4 * maxn; i++)
        mx[i] = -BIG_INF;

    for (int i = 0; i < n; i++)
        cin >> a[i].fs >> a[i].sc;
    for (int i = 0; i < m; i++)
        cin >> b[i].fs >> b[i].sc;
    for (int i = 0; i < p; i++) {
        cin >> x[i] >> y[i] >> z[i];
        inds[i] = i;
    }
    sort(inds, inds + p, comp);
    for (int i = 0; i < p; i++)
        pos[inds[i]] = i;

    for (int i = 0; i < n; i++)
        a[i].fs = bin_search(a[i].fs);
    sort(a, a + n, comp2);
    int mx_len = -INF;
    for (int i = 0; i < n; i++) {
        int len = a[i].fs;
        if (len <= mx_len) continue;

        can[i] = true;
        mx_len = max(len, mx_len);
    }

    int ind = 0;
    for (int i = 0; i < n; i++)
        if (can[i])
            a[ind++] = a[i];
    n = ind;

    ll mx_ans = -BIG_INF;
    sort(inds, inds + p, comp3);
    for (int i = 0; i < p; i++) {
        ind = inds[i];
        upd_pos(1, 0, p - 1, pos[ind], (ll)z[ind]);

        int some_ind = bin_search1(pos[ind]);
        if (some_ind < n)
            upd_pos2(1, 0, p - 1, pos[ind], sum_on_segm(1, 0, p - 1, 0, a[some_ind].fs) - (ll)a[some_ind].sc);

        mx_ans = max(mx_ans, mx_on_segm(1, 0, p - 1, 0, pos[ind]));
        mx_ans = max(mx_ans, mx_on_segm(1, 0, p - 1, pos[ind] + 1, p - 1) + (ll)z[ind]);

        res[i] = mx_ans;
    }

    ll ans = -BIG_INF;
    for (int i = 0; i < m; i++) {
        ind = bin_search2(b[i].fs);
        if (ind >= 0)
            ans = max(ans, res[ind] - (ll)b[i].sc);
    }

    cout << max(0LL, ans) << "\n";
    return 0;
}
