/*#pragma optimization "avx2"
#pragma target ("O2")
#pragma target ("unroll-loops")
#include <bits/stdc++.h>*/
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <queue>
#include <cassert>
//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
//using namespace _gnu_pbds;
//#define ordered_set tree <int, null_type, less<int>, rb_tree_tag, ...>
#define sz(a) (int)a.size()
#define all(a) a.begin(), a.end()
#define pb push_back
#define ppb pop_back
#define F first
#define S second
#define show(a) cerr << #a <<" -> "<< a <<"\n"

const int N = 2e5 + 5;
const int INF = 1e9 + 5;

int n, m, p[N], d[N];
bool two[N];
vector <int> g[N], rg[N];
queue <int> q;

void solve () {
    int n, m;
    cin >> n >> m;
    for (int i = 1; i <= m; ++i) {
        int a, b;
        cin >> a >> b;
        g[a].pb(b);
        rg[b].pb(a);
    }
    int k;
    cin >> k;
    for (int i = 1; i <= k; ++i) {
        cin >> p[i];
    }
    for (int i = 1; i <= n; ++i) {
        d[i] = INF;
    }
    d[p[k]] = 0;
    q.push(p[k]);
    while(sz(q)) {
        int v = q.front();
        q.pop();
        for (int i = 0; i < sz(rg[v]); ++i) {
            int to = rg[v][i];
            if (d[to] == d[v] + 1) {
                two[to] = 1;
            }
            if (d[to] > d[v] + 1) {
                d[to] = d[v] + 1;
                two[to] = max(two[to], two[v]);
                q.push(to);
            }
        }
    }
    /*for (int i = 1; i <= n; ++i)
        cout << two[i] <<' ';
    return;*/
    int mn = 0, mx = 0;
    //cout << "d[i] - >";
    for (int i = 1; i < k; ++i) {
        //cout << d[p[i]] <<' ';
        if (d[p[i]] - 1 != d[p[i + 1]]) {
            //cout << "! "<< d[p[i]] <<" "<< d[p[i + 1]] <<"\n";
            ++mn;
            ++mx;
        }
        else if (two[p[i]]) {
            ++mx;
        }
    }
    cout << mn <<' '<< mx;
}

int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int tt = 1;
    while (tt--) {
        solve();
    }
    return 0;
}
