#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <algorithm>
#include <iomanip>

using namespace std;

void task_a()
{
    int n; cin >> n;
    vector<int> r(n);
    for (int i = 0; i < n; i++)
    {
        cin >> r[i];
    }

    vector<int> b(n);
    for (int i = 0; i < n; i++)
    {
        cin >> b[i];
    }

    int r_cnt = 0, b_cnt = 0;
    bool same = true;
    for (int i = 0; i < n; i++)
    {
        same = same && (r[i] == b[i]);
        if (r[i] > b[i])
            r_cnt += r[i];
        if (b[i] > r[i])
            b_cnt += b[i];
    }

    if (same || r_cnt == 0)
    {
        cout << -1;
    }
    else
    {
        if (b_cnt % r_cnt == 0)
            cout << b_cnt / r_cnt + 1;
        else
            cout << (r_cnt + b_cnt - 1) / r_cnt;
    }
}

void task_b()
{
    int n; cin >> n;
    map<int,int> cnt; // d b
    for (int i = 0; i < n; i++)
    {
        int x; cin >> x;
        cnt.insert(pair<int,int>(i-x, 0)).first->second += x;
    }
    int res = 0;
    for(map<int,int>::iterator it = cnt.begin(); it != cnt.end(); it++)
    {
        res = max(res, it->second);
    }
    cout << res;
}

void task_c()
{
    //cout << fixed << setprecision(6);
}

int main()
{
    //ifstream cin("i.txt");
    task_b();
    return 0;
}
