#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <algorithm>
#include <iomanip>

using namespace std;

void task_a()
{
    int n; cin >> n;
    vector<int> r(n);
    for (int i = 0; i < n; i++)
    {
        cin >> r[i];
    }

    vector<int> b(n);
    for (int i = 0; i < n; i++)
    {
        cin >> b[i];
    }

    int r_cnt = 0, b_cnt = 0;
    bool same = true;
    for (int i = 0; i < n; i++)
    {
        same = same && (r[i] == b[i]);
        if (r[i] > b[i])
            r_cnt += r[i];
        if (b[i] > r[i])
            b_cnt += b[i];
    }

    if (same || r_cnt == 0)
    {
        cout << -1;
    }
    else
    {
        if (b_cnt % r_cnt == 0)
            cout << b_cnt / r_cnt + 1;
        else
            cout << (r_cnt + b_cnt - 1) / r_cnt;
    }
}

void task_b()
{
    int n; cin >> n;
    map<int,long long> cnt; // d b
    for (int i = 0; i < n; i++)
    {
        int x; cin >> x;
        cnt.insert(pair<int,long long>(i-x, 0)).first->second += x;
    }
    long long res = 0;
    for(map<int,long long>::iterator it = cnt.begin(); it != cnt.end(); it++)
    {
        res = max(res, it->second);
    }
    cout << res;
}

void print(const vector<int>& vec);

string er(const string& s, const vector<int>& ind)
{
    if (ind.size() == 0) return s;
    string res(s.length()-ind.size(), ' ');
    for (int i = 0, j = 0, k = 0; i < s.length(); i++, j++)
    {
        if (k < ind.size() && ind[k] == i)
        {
            k++; j--;
            continue;
        }

        res[j] = s[i];

    }
    return res;
}

vector<int> find2d(const string& s, char c)
{
    vector<int> res;
    if (s.length() == 0) return res;
    if (s[0] == c && s[1] == c - 1)
    {
        res.push_back(0);
    }
    int n = s.length() - 1;
    for (int i = 1; i < n; i++)
    {
        if(s[i] == c)
        {
            if (s[i-1] == c - 1 || s[i+1] == c - 1)
            {
                res.push_back(i++);
            }
        }
    }
    if (s[n] == c && s[n - 1] == c - 1)
    {
        res.push_back(0);
    }
    return res;
}

void print(const vector<int>& vec)
{
    for (int i = 0; i < vec.size(); i++)
    {
        cout << vec[i] << " ";
    }
    cout << endl;
}

void task_c()
{
    //ifstream cin("i.txt");
    int n; cin >> n;
    string s; cin >> s;
    for (char c = 'z'; c > 'a'; c--)
    {

        vector<int> v2d;
        do
        {
            v2d = find2d(s,c);
            s = er(s, v2d);
        } while(v2d.size() > 0);
        //cout << c << ":\t" << s << endl;
    }
    cout << n - s.length();
}

int main()
{
    //cout << fixed << setprecision(6);
    //
    task_c();
    return 0;
}
