#include <bits/stdc++.h>
#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <queue>
#include <assert.h>
#include <cmath>
#include <iomanip>
#include <random>
#include <utility>

#define all(a) a.begin(), a.end()
#define int long long
#define pii pair<int, int>

using namespace std;

typedef long long ll;
typedef long double ld;

void speedup(){
    ios_base::sync_with_stdio(0);
    cin.tie();
    cout.tie();
}

vector <vector <int> > g, ag;
vector <int> d;
int n, m;
void bfsa(int start) {
    queue <int> q;
    d[start] = 0;
    q.push(start);
    while (!q.empty()) {
        int u = q.front();
        q.pop();
        for (auto to: ag[u]) {
            if (d[to] == -1) {
                d[to] = d[u] + 1;
                q.push(to);
            }
        }
    }
}

void solve() {
    cin >> n >> m;
    g.resize(n);
    ag.resize(n);
    d.resize(n, -1);
    for (int i = 0; i < m; ++i) {
        int x, y;
        cin >> x >> y;
        ag[y - 1].push_back(x - 1);
        g[x - 1].push_back(y - 1);
    }
    int k;
    cin >> k;
    vector <int> path(k);
    for (int i = 0; i < k; ++i) {
        int x;
        cin >> x;
        path[i] = x - 1;
    }
    int ansmi = 0, ansma = 0;
    bfsa(path[k - 1]);
    for (int i = 0; i < k - 1; ++i) {
        bool fl1 = false;
        int mn = d[path[i + 1]] + 1;
        for (auto x: g[path[i]]) {
            if (x == path[i + 1])
                continue;
            mn = min(d[x], mn);
        }
        if (mn < d[path[i + 1]]) {
            ansma++;
            ansmi++;
        }
        else if (mn == d[path[i + 1]]) {
            ansma++;
        }
    }
    cout << ansmi << " " << ansma;
}

signed main() {
    speedup();
    solve();
    return 0;
}
