#include <iostream>
#include <vector>
#include <algorithm>
#include <cstdlib>
#include <iomanip>
#include <set>
#include <climits>
#include <cmath>
#include <map>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

#define pb push_back
#define mp make_pair
#define len(v) int(v.size())
#define all(v) v.begin(), v.end()
#define ff first
#define ss second
#define pi pair<int, int>
#define vi vector<int>
#define vvi vector<vi>
#define vpi vector<pi>
#define vvpi vector<vpi>
#define forn(i, n) for(int i = 0; i < int(n); ++i)

/*
int tree[max_n] = { 0 };
int arr[max_n] = { 0 };
void build(int v, int ql, int qr) {
	if(ql >= qr)
		return;
	if(ql == qr - 1) {
		tree[v] = arr[ql];
		return;
	}
	int mid = (ql + qr) / 2;
	build(v * 2 + 1, ql, mid);
	build(v * 2 + 2, mid, qr);
}
int query(int l, int r, int v, int ql, int qr) {
	if(ql >= qr)
		return 0;
	if(l >= r)
		return 0;
	if(ql == l && qr == r) {
		return tree[v];
	}
	int mid = (ql + qr) / 2;
	int rl = query(l, min(mid, r), v * 2 + 1, ql, mid);
	int rr = query(max(l, mid), r, v * 2 + 2, mid, qr);
}
void update(int v, int ql, int qr, int pos, int val) {
	if(ql >= qr)
		return;
	if(ql == qr - 1) {
		tree[v] = val;
		return;
	}
	int mid = (ql + qr) / 2;
	if(pos < mid)
		update(v * 2 + 1, ql, mid, pos, val);
	else
		update(v * 2 + 2, mid, qr, pos, val);
}
//*/
const int inf = INT_MAX / 2;
const int max_n = 1e5 + 7;

void run() {
	int n;
	cin >> n;
	vi arr1(n);
	vi arr2(n);
	vi res(n, 1);
	int sum = 0;
	forn(i, n) {
		cin >> arr1[i];
		sum += arr1[i];
	}
	int count2 = 0;
	forn(i, n) {
		cin >> arr2[i];
		count2 += arr2[i];
	}
	vi ob(n, 0);
	int cc = 0;
	forn(i, n) {
		if(arr1[i] && !arr2[i]) {
			ob[i] = 1;
			++cc;
		}
	}
	if(sum > count2) {
		cout << 1;
		return;
	}
	if(!cc) {
		cout << -1;
		return;
	}
	int l = 0;
	while (sum <= count2) {
		
		if(ob[l]) {
			++sum;
			++res[l];
		}
		++l;
		l %= len(ob);
	}
	int maximum = 1;
	forn(i, len(ob)) {
		maximum = max(maximum, res[i]);
	}
	cout << maximum;
}

signed main() {
	/*
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	//*/
	run();
	return 0;
}