#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int N = 500'000;
const int INF = 1'000'000'007;
const ll LINF = static_cast<const ll>(3e18);

//const int SZ = 4 * N + 100;
//int t[SZ];
//int later[SZ];
//
//void Update(int ndx) {}
//
//int GetTree(int l, int r, int ndx = 0, int L = 0, int R = N - 1) {
//    Update(ndx);
//    if (l <= L && R <= r)
//        return t[ndx];
//    if (r < L || R < l)
//        return 0;
//    return GetTree(l, r, 2 * ndx + 1, L, (L + R) / 2) + GetTree(l, r, 2 * ndx + 2, (L + R) / 2 + 1, R);
//}
//
//void SetTree(int l, int r, int value, int ndx = 0, int L = 0, int R = N - 1) {
//    if (l <= L && R <= r)
//        t[ndx] = value;
//    if (r < L || R < l)
//        return;
//    SetTree(l, r, value, 2 * ndx + 1, L, (L + R) / 2);
//    SetTree(l, r, value, 2 * ndx + 2, (L + R) / 2 + 1, R);
//}

vector <vector <int>> g;

void Solve() {
    list <int> l;
    int n, m;
    cin >> n >> m;
    g.resize(n);
    for (int i = 0; i < m; ++i) {
        int a,b;
        cin >> a>> b;
        a--, b--;
        g[b].push_back(a);
    }
    int p;
    cin >> p;
    vector <int> perm(p);
    for (int i = 0; i < p; ++i) {
        cin >> perm[i];
        perm[i]--;
    }

    vector <int> d(n, INF);
    d[perm[p-1]] = 0;
    vector <int> best(n);
    deque <int> q = {perm[p-1]};
    int mn = 0, mx =0;
    while (!q.empty()) {
        int v = q.front();
        q.pop_front();
        for (auto i : g[v]) {
            if (d[i] > d[v] + 1) {
                q.push_back(i);
            }
            if (d[i] >= d[v] + 1) {
                d[i] = d[v] + 1;
                best[i]++;
            }
        }
    }
    for (int i=1;i < p;i++) {
        if (best[perm[i-1]] > 1 || d[perm[i-1]] <= d[perm[i]])
            mx++;
        if (d[perm[i-1]] <= d[perm[i]])
            mn++;
    }
    cout << mn << " " << mx;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    Solve();
}