#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;
#define f first
#define s second
#define pii pair<int, int>
#define vi vector<int>
#define int ll
#define pb push_back
using namespace std;

const int maxn = 2e5 + 50;

const int mod = 1e9 + 7;
const int mod2 = 1e9 + 9;
int p = 141;
int p2 = 131;

int fastpow(int a,int b, int mod) {
    if (b == 0)
        return 1;
    if (b & 1)
        return a * fastpow(a, b - 1, mod) % mod;
    int t = fastpow(a, b / 2, mod);
    return t * t % mod;
}

int cntp[maxn], cnts[maxn], pref[maxn], pref2[maxn], powp2[maxn], powp[maxn];

int get(int a, int mod) {
    return (a % mod + mod) % mod;
}

vector<pair<char, int>> v;
int k;
pair<pii, int> getq(int a, int b) {
//cout << a << ' ' << b << endl;
    int h1 = 0, h2 = 0;
    int l = -1, r = k;
    int cnt = 0;
    while (r - l > 1) {
        int mid = (l + r) / 2;
        if (v[mid].s >= b + 1) {
            r = mid;
        } else {
            l = mid;
        }
    }
    cnt += l + 1;
    if (l != -1) {
        h1 += pref[l + 1];
        h2 += pref2[l + 1];
    }
    l = -1, r = k;
    while (r - l > 1) {
        int mid = (l + r) / 2;
        if (v[mid].s >= a) {
            r = mid;
        } else {
            l = mid;
        }
    }
    cnt -= l + 1;
    if (l != 1) {
        h1 -= pref[l + 1] * powp[cnt];
        h2 -= pref2[l + 1] * powp2[cnt];
    }
  //  cout << get(h1, mod) << ' ' << get(h2, mod2) << 'X' << endl;
    return {{get(h1, mod), get(h2, mod2)}, cnt};
}

void solve() {
    int n;
    cin >> n;
    string s;
    cin >> s;

    for (int i = n - 1; i >= 0; --i) {
        cnts[i] = (s[i] == '1');
        if (cnts[i] && i != n - 1)
            cnts[i] += cnts[i + 1];
    }
    for (int i = 0; i < n; ++i) {
        cntp[i] = (s[i] == '1');
        if (cntp[i] && i)
            cntp[i] += cntp[i - 1];
    }
    for (int i = 0; i < n; ++i) {
        v.pb({s[i], i});
        if (v.size() > 1 && v.back().f == '1' && v[v.size() - 2].f == '1') {
            v.pop_back();
            v.pop_back();
        }
    }
    k = v.size();
    //int powp[k + 1];
    powp[0] = 1;
    powp2[0] = 1;
    for (int i = 0; i < k; ++i) {
        powp[i + 1] = powp[i] * p % mod;
        pref[i + 1] = (pref[i] * p + v[i].f) % mod;
        powp2[i + 1] = powp2[i] * p2 % mod2;
        pref2[i + 1] = (pref2[i] * p2 + v[i].f) % mod2;
    }
    int q;
    cin >> q;
    while (q--) {
        int a, b, ln;
        cin >> a >> b >> ln;
        a--;
        b--;
        if (cntp[a + ln - 1] >= ln && cntp[b + ln - 1] >= ln) {
            cout << "Yes" << endl;
            continue;
        } else if (cntp[a + ln - 1] >= ln || cntp[b + ln - 1] >= ln) {
            cout << "No" << endl;
            continue;
        }
        auto x = getq(a + cnts[a], a + ln - 1 - cntp[a + ln - 1]);
        auto y = getq(b + cnts[b], b + ln - 1 - cntp[b + ln - 1]);
        //cout << x.f.f << ' ' << y.f.f << endl;
        if (cnts[a] % 2) {
            x.f.f += powp[x.s] * '1';
            x.f.s += powp2[x.s] * '1';
        }
        if (cnts[b] % 2) {
            y.f.f += powp[y.s] * '1';
            y.f.s += powp2[y.s] * '1';
        }
        x.f.f = get(x.f.f, mod);
        x.f.s = get(x.f.s, mod2);
        y.f.f = get(y.f.f, mod);
        y.f.s = get(y.f.s, mod2);
        if (cntp[a + ln - 1] % 2) {
            x.f.f = (x.f.f * p + '1') % mod;
            x.f.s = (x.f.s * p2 + '1') % mod2;
        }
        if (cntp[b + ln - 1] % 2) {
            y.f.f = (y.f.f * p + '1') % mod;
            y.f.s = (y.f.s * p2 + '1') % mod2;
        }
        if (x.f.f == y.f.f && x.f.s == y.f.s) {
            cout << "Yes" << endl;
        } else {
            cout << "No" << endl;
        }
    }
}
signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    #ifndef ONLINE_JUDGE
    freopen("input.txt", "r", stdin);
    #endif
    int t = 1;
    while (t--) {
        solve();
    }
    return 0;
}
