#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/detail/standard_policies.hpp>

#define ll long long
#define pii pair <int , int>
#define fi first
#define se second
#define pb push_back
#define ld lond double


using namespace std;
using namespace __gnu_pbds;

template <typename T>
    using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

mt19937 gen(chrono::high_resolution_clock::now().time_since_epoch().count());
const int N = 2e6;
int main(){
    #ifdef Estb_probitie
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif

    int n, m;
    cin >> n >> m;
    vector < int > g[n];
    vector < int > gr[n];
    for (int i = 0; i < m; ++i){
        int x, y;
        cin >> x >> y;
        --x, --y;
        g[x].pb(y);
        gr[y].pb(x);
    }
    int k;
    cin >> k;
    int b[k];
    for (int i = 0; i < k; ++i)
        cin >> b[i], --b[i];
    int s = b[0], t = b[k - 1];
    priority_queue < pii, vector < pii >, greater < pii > > q;
    int dist[n] = {};
    fill(dist, dist + n, 1e9);
    dist[t] = 0;
    q.push({0, t});
    while(q.size()){
        int nm = q.top().se;
        int ds = q.top().fi;
        q.pop();
        if (dist[nm] > ds) continue;
        for (int to : gr[nm]){
            if (ds + 1 < dist[to]){
                dist[to] = ds + 1;
                q.push({ds + 1, to});
            }
        }
    }
    int mn = 0;
    int mx = 0;

    for (int i = 0; i + 1 < k; ++i){
        int sl = dist[b[i + 1]];
        int mnn = 1e9;
        int v = b[i];
        for (int to : g[v]){
                mnn = min(mnn, dist[to]);
        }
        if (mnn != sl) ++mn, ++mx; else {
            int kol = 0;
            for (int to : g[v])
                if (dist[to] == sl) ++kol;
            if (kol > 1) ++mx;
        }
//        cout<<mn<<" "<<mx<<" "<<sl<<" "<<mnn<<endl;
    }

    cout << mn << " " << mx;

}
