#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/detail/standard_policies.hpp>

#define ll long long
#define pii pair <int , int>
#define fi first
#define se second
#define pb push_back
#define ld lond double


using namespace std;
using namespace __gnu_pbds;

template <typename T>
    using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

mt19937 gen(chrono::high_resolution_clock::now().time_since_epoch().count());
const int N = 1e6 + 5;
const int MXN = 1e5;
int b[N], a[N], c[N], d[N], t[N * 4], add[N * 4];

void push1(int v, int tl, int tr){
    if (tl != tr){
        int tm = (tl + tr) >> 1;
        add[v << 1] = add[v];
        add[v << 1 | 1] = add[v];
        t[v << 1] = add[v];
        t[v << 1 | 1] = add[v];
    }
    add[v] = 2e9;
}

void update(int v, int tl, int tr, int l, int r, int mx){
    if (add[v] != 2e9)
        push1(v, tl, tr);
    if (l > r) return;
    if (tl == l && tr == r){
        t[v] = -mx;
        add[v] = -mx;
        push1(v, tl, tr);
        return;
    }
    int tm = (tl + tr) >> 1;
    update(v << 1, tl, tm, l, min(tm, r), mx);
    update(v << 1 | 1, tm + 1, tr, max(tm + 1, l), r, mx);
    t[v] = max(t[v << 1], t[v << 1 | 1]);
}

void push2(int v, int tl, int tr){
    if (tl != tr){
        int tm = (tl + tr) >> 1;
        add[v << 1] += add[v];
        add[v << 1 | 1] += add[v];
        t[v << 1] += add[v];
        t[v << 1 | 1] += add[v];
    }
    add[v] = 0;
}

void ad(int v, int tl, int tr, int l, int r, int mx){
    if (add[v])
        push2(v, tl, tr);
    if (l > r) return;
    if (tl == l && tr == r){
        t[v] += mx;
        add[v] += mx;
        push2(v, tl, tr);
        return;
    }
    int tm = (tl + tr) >> 1;
    ad(v << 1, tl, tm, l, min(tm, r), mx);
    ad(v << 1 | 1, tm + 1, tr, max(tm + 1, l), r, mx);
    t[v] = max(t[v << 1], t[v << 1 | 1]);
//    if (tr - tl < 20)
//    cout<<t[v]<<" "<<tl<<" "<<tr<<endl;
}

void go(int v, int tl, int tr){
    if (add[v] != 2e9)
        push1(v, tl, tr);
    if (tl == tr) return;
    int tm = (tl + tr) >> 1;
    go(v << 1, tl, tm);
    go(v << 1 | 1, tm + 1, tr);
    t[v] = max(t[v << 1], t[v << 1 | 1]);
}


int main(){
    #ifdef Estb_probitie
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif

    int n, m, p;
    cin >> n >> m >> p;
    fill(b, b + N, 2e9);
    fill(d, d + N, 2e9);
    for (int i = 0; i < n; ++i){
        int x, y;
        cin >> x >> y;
        b[x] = min(b[x], y);
    }
    for (int i = 0; i < m; ++i){
        int x, y;
        cin >> x >> y;
        d[x] = min(d[x], y);
    }
    int mn = 2e9;
    update(1, 0, N - 1, 0, N - 1, 2e9 + 100);
    for (int i = N - 1; i >= 0; --i)
    if (mn > d[i]){
        mn = d[i];
        update(1, 0, N - 1, 0, i, mn);
    }
    go(1, 0, N - 1);
    int x[p], y[p], z[p];
    vector < pii > all;
    for (int i = 0; i < p; ++i){
        cin >> x[i] >> y[i] >> z[i];
        all.pb({x[i], i});
    }
    sort(all.begin(), all.end(), [&](pii a, pii b){
            return a < b;
         });

    int now = 0;
    mn = 2e9;
    fill(add, add + N * 4, 0);
    int ans = -2e9- 5500;
    for (int i = 0; i < N; ++i)
    if (mn != b[i]){
        while(now < p && all[now].fi < i){
            ad(1, 0, N - 1, y[all[now].se] + 1, N - 1, z[all[now].se]);
//            cout<<endl;
            ++now;
        }
//        cout<<i<<" "<<t[1]<<" "<<now<<endl;
        ans = max(ans, -b[i] + t[1]);
//        cout<<-b[i] + t[1]<<endl;
    }
    cout << ans;
}
