#include<bits/stdc++.h>

#define int long long
#define x first
#define y second
#define mp make_pair
#define pb push_back
#define all(v) v.begin(), v.end()
#define sz(v) (int) v.size()
#define TASK ""

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

signed main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
if (strlen(TASK) > 0)
	freopen(TASK".in", "r", stdin),
	freopen(TASK".out", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	
	const int inf = 1e9;
	
	int n, m;
	cin >> n >> m;
	vector<vector<int>> g(n), rg(n);
	for (int i = 0; i < m; ++i) {
		int v, u;
		cin >> v >> u;
		--v, --u;
		g[v].pb(u);
		rg[u].pb(v);
	}
	int k;
	cin >> k;
	vector<int> p(k);
	for (int i = 0; i < k; ++i) {
		cin >> p[i];
		--p[i];
	}
	vector<int> dist(n, inf);
	dist[p.back()] = 0;
	queue<int> Q;
	Q.push(p.back());
	while (!Q.empty()) {
		int v = Q.front();
		Q.pop();
		for (int &u : rg[v]) {
			if (dist[u] == inf) {
				dist[u] = dist[v] + 1;
				Q.push(u);
			}
		}
	}
	int ansmin = 0, ansmax = 0;
	for (int i = 0; i < k - 1; ++i) {
		int mn_dist = dist[p[i + 1]];
		for (int &u : g[p[i]]) {
			mn_dist = min(mn_dist, dist[u]);
		}
		if (mn_dist != dist[p[i + 1]]) {
			ansmin++;
		}
		int cnt = 0;
		for (int &u : g[p[i]]) {
			if (dist[u] == mn_dist) {
				++cnt;
			}
		}
		if (mn_dist != dist[p[i + 1]]) {
			ansmax++;
		} else if (cnt > 1) {
			ansmax++;
		}
	}
	cout << ansmin << " " << ansmax << "\n";
	
	return 0;
}
