#pragma GCC target("avx2")
#pragma GCC optimize("O3")

#include <x86intrin.h>
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;

template<typename T> using ordered_set = tree <T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
//mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

#define F first
#define S second
#define lb lower_bound
#define ub upper_bound
#define pb push_back
#define pf push_front
#define ppb pop_back
#define mp make_pair
#define bpp __builtin_popcountll
#define sqr(x) ((x) * (x))
#define all(x) x.begin (), x.end ()
#define sz(x) (int)x.size()
#define in insert
#define ppf pop_front
#define endl '\n'
#define int long long

typedef unsigned long long ull;
typedef long long ll;
typedef long double ld;
typedef pair <int, int> pii;

const int mod = (int)1e9 + 7;
const int N = (int)3e5 + 123;
const ll inf = (ll)1e18 + 123;
const int dx[] = {0, 0, 1, 0, -1};
const int dy[] = {0, 1, 0, -1, 0};

int n, m, k, p[N], d[N], x[N], y[N], mn, mx, can[N];
bool used[N];
vector <int> g[N], gr[N];
queue <int> q;

inline void boost () {
	ios_base :: sync_with_stdio (0);
	cin.tie (0), cout.tie (0);
}
        
inline void Solve () {
	cin >> n >> m;
	for (int i = 1; i <= m; i ++) {
		cin >> x[i] >> y[i];
		g[x[i]].pb (y[i]);
		gr[y[i]].pb (x[i]);
	}
	cin >> k;
	for (int i = 1; i <= k; i ++) cin >> p[i];
	memset (d, -1, sizeof d);
	d[p[k]] = 0;
	can[p[k]] = 1;
	q.push (p[k]);
	while (sz (q)) {
		int v = q.front ();
		q.pop ();
		for (auto to : gr[v]) {
			if (d[to] == -1) {
				d[to] = d[v] + 1;
				q.push (to);
			}
		}
	}
	q.push (p[k]);
	used[p[k]] = 1;
	while (sz (q)) {
		int v = q.front ();
		used[v] = 1;
		q.pop ();
		for (auto to : gr[v]) {
			if (d[to] - d[v] == 1) {
			   can[to] += can[v];
			   if (can[to] > mod) can[to] = mod;
			   
			}
			if (!used[to]) q.push (to);
		}
	}
	for (int i = 2; i <= k; i ++) {
		if (d[p[i - 1]] - d[p[i]] != 1) mn ++;
		if (can[p[i - 1]] > 1 || d[p[i - 1]] - d[p[i]] != 1) mx ++;	
	}
	cout << mn << ' ' << mx;
}

main () {
	boost ();
	int tt = 1;
	//cin >> tt;
	while (tt --) Solve ();
	return 0;

}