#pragma GCC target("avx2")
#pragma GCC optimize("O3")

#include <x86intrin.h>
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;

template<typename T> using ordered_set = tree <T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

#define F first
#define S second
#define lb lower_bound
#define ub upper_bound
#define pb push_back
#define pf push_front
#define ppb pop_back
#define mp make_pair
#define bpp __builtin_popcountll
#define sqr(x) ((x) * (x))
#define all(x) x.begin (), x.end ()
#define sz(x) (int)x.size()
#define in insert
#define ppf pop_front
#define endl '\n'
#define int long long

typedef unsigned long long ull;
typedef long long ll;
typedef long double ld;
typedef pair <int, int> pii;

const int mod = (int)1e9 + 7;
const int N = (int)3e5 + 123;
const int MAX_N = (int)1e6 + 123;
const ll inf = (ll)1e18 + 123;
const int dx[] = {0, 0, 1, 0, -1};
const int dy[] = {0, 1, 0, -1, 0};

int n, m, p, b[N], cb[N], t[4 * MAX_N], add[4 * MAX_N], ans = -inf, cnt[MAX_N];
pii a[N], ca[N];

struct L {
	int x, y, z;
}q[N];

bool cmp (L a, L b) {
	return (a.x < b.x);
}

inline void push (int v, int tl, int tr) {
	if (add[v] == 0) return;
	t[v] += add[v];
	if (tl != tr) add[v + v] += add[v], add[v + v + 1] += add[v];
	add[v] = 0;
}

void upd (int l, int r, int val, int v = 1, int tl = 1, int tr = MAX_N) {      
   push (v, tl, tr);
	if (tl > r || tr < l) return;
	if (l <= tl && tr <= r) {
		add[v] += val;
		push (v, tl, tr);
		return;
	} 
	int tm = tl + tr >> 1;
	upd (l, r, val, v + v, tl, tm);
	upd (l, r, val, v + v + 1, tm + 1, tr);
	t[v] = max (t[v + v], t[v + v + 1]);
}

int get (int l, int r, int v = 1, int tl = 1, int tr = MAX_N) {
	push (v, tl, tr);
	if (tl > r || tr < l) return -inf;
	if (l <= tl && tr <= r) return t[v];
	int tm = tl + tr >> 1;
	return max (get (l, r, v + v, tl, tm), get (l, r, v + v + 1, tm + 1, tr));
}

inline void boost () {
	ios_base :: sync_with_stdio (0);
	cin.tie (0), cout.tie (0);
}
        
inline void Solve () {
	cin >> n >> m >> p;
	for (int i = 1; i < 4 * N; i ++) t[i] = -inf;
	for (int i = 1; i <= n; i ++) cin >> a[i].F >> a[i].S;
	for (int i = 1; i < MAX_N; i ++) cnt[i] = inf;
	for (int i = 1; i <= m; i ++) {
	   cin >> b[i] >> cb[i];
	   cnt[b[i]] = min (cnt[b[i]], cb[i]);
	}
	for (int i = 1; i < MAX_N; i ++) {
	   if (cnt[i] != inf) upd (i, i, inf - cnt[i]);
	}
	for (int i = 1; i <= p; i ++) cin >> q[i].x >> q[i].y >> q[i].z;
	sort (q + 1, q + p + 1, &cmp);
	sort (a + 1, a + n + 1);
	int it = 0;
	for (int i = 1; i <= n; i ++) {
		while (it + 1 <= p && q[it + 1].x < a[i].F) it ++, upd (q[it].y + 1, MAX_N, q[it].z);
		ans = max (ans, t[1] - a[i].S);	
	}
	cout << ans;
}

main () {
	boost ();
	int tt = 1;
	//cin >> tt;
	while (tt --) Solve ();
	return 0;

}