//
// Created by DanGolov on 01.03.2020.
//
#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using pii = pair<int, int>;

const int MAXN = 2e5 + 13, INF = 1e9 + 7;

inline void io_optimize() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
}

int n, m, k;
vector<int> g[MAXN], rg[MAXN], p, come;
vector<set<int> > spt;

void bfs(int s) {
    queue<int> q;
    q.push(s);
    vector<int> dist (n, INF);
    dist[s] = 0;
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (int u: rg[v]) {
            if (dist[u] > dist[v] + 1) {
                dist[u] = dist[v] + 1;
                spt[u] = {v};
                q.push(u);
            } else if (dist[u] == dist[v] + 1) {
                spt[u].insert(v);
            }
            come[u]++;
        }
    }
}

signed main() {
    io_optimize();
    cin >> n >> m;
    spt.resize(n), come.assign(n, 0);
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        g[u].push_back(v);
        rg[v].push_back(u);
    }
    cin >> k;
    p.resize(k);
    for (int i = 0; i < k; i++) {cin >> p[i]; --p[i];}
    bfs(p.back());
    int mn = 0, mx = 0;
    for (int i = 0; i < k - 1; i++) {
        if (come[p[i]] <= 1) {
            continue;
        }
        if (spt[p[i]].size() == 1) {
            if (p[i + 1] == *spt[p[i]].begin()) {
                continue;
            } else {
                mn++, mx++;
            }
        } else {
            if (spt[p[i]].find(p[i + 1]) != spt[p[i]].end()) {
                mx++;
            } else {
                mn++, mx++;
            }
        }
    }
    cout << mn << ' ' << mx << '\n';
    return 0;
}