#include<bits/stdc++.h>
#define int long long
#define p pair<int, int>
#define endl '\n'

using namespace std;

const int INF = 1000000001;
vector<vector<int>> d, d1;

vector<int> BFS(int vertex){
    vector<bool> s(d.size(), true);
    vector<int> dist(d.size());
    queue<p> f;
    f.push({vertex, 0});
    s[vertex] = false;
    while (!f.empty()){
        p x = f.front();
        dist[x.first] = x.second;
        f.pop();
        for (int q: d1[x.first]){
            if (s[q]){
                s[q] = false;
                f.push({q, x.second+1});
            }
        }
    }
    return dist;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m, k;
    cin >> n >> m;
    d.assign(n, {});
    d1.assign(n, {});
    for (int q = 0; q < m; q++){
        int x, y;
        cin >> x >> y;
        d[x-1].push_back(y-1);
        d1[y-1].push_back(x-1);
    }
    cin >> k;
    vector<int> a(k);
    for (int q = 0; q < k; q++){
        cin >> a[q];
        a[q]--;
    }
    vector<int> dist = BFS(a.back());
    int min1 = 0, max1 = 0;
    for (int q = 0; q < k-1; q++){
        if (dist[a[q+1]] != dist[a[q]]-1){
            min1++;
        }
        for (int q1: d[a[q]]){
            if (q1 != a[q+1] && dist[q1] == dist[a[q]]-1){
                max1++;
                break;
            }
        }
    }
    cout << min1 << " " << max1 << endl;
    return 0;
}
