#include<bits/stdc++.h>
#define int long long
#define p pair<int, int>
#define endl '\n'

using namespace std;

const int INF = 2000000001;

struct DO{
    vector<int> do_arr, mod;
    int len;

    DO(vector<int> &a){
        int q1 = 1;
        while (q1 < a.size()){
            q1 *= 2;
        }
        len = q1;
        for (int q = 0; q < 2*q1; q++){
            do_arr.push_back(-INF);
            mod.push_back(0);
        }
        for (int q = q1; q < q1+a.size(); q++){
            do_arr[q] = a[q-q1];
        }
        for (int q = q1-1; q > 0; q--){
            do_arr[q] = max(do_arr[2*q], do_arr[2*q+1]);
        }
    }

    void push(int q){
        mod[2*q] += mod[q];
        do_arr[2*q] += mod[q];
        mod[2*q+1] += mod[q];
        do_arr[2*q+1] += mod[q];
        mod[q] = 0;
    }

    void update(int l, int r, int l1, int r1, int q, int x){
        if (l >= r1 || l1 >= r){
            return;
        }
        if (l1 <= l && r <= r1){
            mod[q] += x;
            do_arr[q] += x;
            return;
        }
        push(q);
        int m = (l+r)/2;
        update(l, m, l1, r1, 2*q, x);
        update(m, r, l1, r1, 2*q+1, x);
        do_arr[q] = max(do_arr[2*q], do_arr[2*q+1]);
    }

    int ans(int l, int r, int l1, int r1, int q){
        if (l >= r1 || l1 >= r){
            return INF;
        }
        if (l1 <= l && r <= r1){
            return do_arr[q];
        }
        push(q);
        int m = (l+r)/2;
        return min(ans(l, m, l1, r1, 2*q), ans(m, r, l1, r1, 2*q+1));
    }
};

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m, k;
    cin >> n >> m >> k;
    vector<p> a(n), s(m);
    for (int q = 0; q < n; q++){
        cin >> a[q].first >> a[q].second;
    }
    for (int q = 0; q < m; q++){
        cin >> s[q].first >> s[q].second;
    }
    vector<pair<p, int>> d(k);
    for (int q = 0; q < k; q++){
        cin >> d[q].first.first >> d[q].first.second >> d[q].second;
    }
    sort(a.begin(), a.end());
    sort(s.begin(), s.end());
    sort(d.begin(), d.end());
    vector<int> f;
    for (int q = 0; q < m; q++){
        f.push_back(-s[q].second);
    }
    DO do_arr = *(new DO(f));
    int ans1 = -INF, q1 = 0;
    for (int q = 0; q < n; q++){
        while (q1 < d.size() && d[q1].first.first < a[q].first){
            int l = -1, r = m-1;
            while (r-l > 1){
                int m1 = (l+r)/2;
                if (s[m1].first <= d[q1].first.second){
                    l = m1;
                }else{
                    r = m1;
                }
            }
            do_arr.update(0, do_arr.len, r, m, 1, d[q1++].second);
        }
        ans1 = max(ans1, do_arr.ans(0, do_arr.len, 0, do_arr.len, 1))-a[q].second;
    }
    cout << ans1 << endl;
    return 0;
}
