#include <iostream>
#include <vector>
#include <map>

using namespace std;

typedef long long ll;
#define forn(i0, n0) for (int i0 = 0; i0 < n0; ++i0)
typedef vector<int> vi;
typedef pair<int, int> pii;
#define F first
#define S second

void init(){
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
}

const int N = 4e5 + 1;

void solve(){
    int n;
    cin >> n;
    map<int, ll> sum;
    forn(i, n){
        ll x;
        cin >> x;
        sum[i - x] += x;
    }
    ll ans = 0;
    for (auto p : sum){
        ans = max(ans, p.S);
    }
    cout << ans << '\n';
}

bool multitest = false;

int main(){
    init();
    int t = 1;
    if (multitest) cin >> t;
    forn(i, t) solve();
    return 0;
}