/**
    The little demon has grown up, huh?
**/

#include <bits/stdc++.h>

#define fr first
#define sc second
#define mk make_pair
#define pb push_back
#define all(s) s.begin(), s.end()
#define int long long

using namespace std;

const int N = 4e5 + 5, inf = 1e18;

int n, m, p, k, t[N * 4], must[N * 4], ans = -inf, u[N];

pair <int, int> a[N], b[N];

struct st{
    int x, y, z, in;
};

st c[N];

vector <int> vec;

void push(int v, int tl, int tr) {
    t[v] += must[v];
    if (tl != tr) {
        must[v + v] += must[v];
        must[v + v + 1] += must[v];
    }
    must[v] = 0;
}

void update (int l, int r, int val, int v = 1, int tl = 0, int tr = k) {
    push(v, tl, tr);
    if (tl > r || l > tr || l > r)
        return;
    if (l <= tl && tr <= r) {
        must[v] += val;
        push(v, tl, tr);
        return;
    }
    int tm = (tl + tr) >> 1;
    update(l, r, val, v + v, tl, tm);
    update(l, r, val, v + v + 1, tm + 1, tr);
    t[v] = max(t[v + v], t[v + v + 1]);
}
bool cmp (st a, st b) {
    return a.x < b.x;
}
main(){
    cin >> n >> m >> p;
    for (int i = 1; i <= n; i++) {
        scanf("%I64d%I64d", &a[i].fr, &a[i].sc);
    }
    for (int i = 1; i <= m; i++) {
        scanf("%I64d%I64d", &b[i].fr, &b[i].sc);
        vec.pb(b[i].fr);
    }
    for (int i = 1; i <= p; i++) {
        scanf("%I64d%I64d%I64d", &c[i].x, &c[i].y, &c[i].z);
        vec.pb(c[i].y);
    }
    vec.pb(0);
    sort(all(vec));
    vec.resize(unique(all(vec)) - vec.begin());
    k = vec.size() - 1;
    for (int i = 0; i <= k; i++) {
        u[i] = inf;
    }

    for (int i = 1; i <= p; i++) {
        c[i].in = lower_bound(all(vec), c[i].y) - vec.begin();
    }
    for (int i = 1; i <= m; i++) {
        int pos = lower_bound(all(vec), b[i].fr) - vec.begin();
        u[pos] = min(u[pos], b[i].sc);
    }
    for (int i = 0; i <= k; i++) {
        update(i, i, -u[i]);
    }
    sort(c + 1, c + p + 1, cmp);
    sort(a + 1, a + n + 1);

    int j = 1;

    for (int i = 1; i <= n; i++) {
        while (j <= p && c[j].x < a[i].fr) {
            update(c[j].in + 1, k, c[j].z);
            j++;
        }
        ans = max(ans, t[1] - a[i].sc);
    }
    cout << ans << endl;
}
