#include <bits/stdc++.h>
#define fi first
#define se second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define out(t, a) copy(all(a), ostream_iterator<t>(cout, " ")); cout << "\n";
//#define DEBUG
#define int long long

using namespace std;

void set_program() {
	#ifdef DEBUG
		freopen("test.in", "r", stdin);
		freopen("test.out", "w", stdout);
	#endif // DEBUG
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
}

typedef long double ld;
typedef long long ll;

const int ALF = 26;
const int LOGN = 20;
const int MOD = 1e9 + 7;
const int MAXN = 2e5;
const int INF = 1e9 + 7;

void solve() {
    int n;
    cin >> n;
    vector <int> a(n);
    for (int& i : a) {
        cin >> i;
    }
    int ans = 0;
    unordered_map <int, int> max_dp;
    for (int i = 0; i < n; ++i) {
        int val = i - a[i];
        int res = a[i];
        if (max_dp.count(val)) {
            res += max_dp[val];
        }
        max_dp[val] = max(max_dp[val], res);
        ans = max(ans, max_dp[val]);
    }
    cout << ans << "\n";
}

main() {
	set_program();
	int t;
	#ifdef DEBUG
        t = 3;
    #else
        t = 1;
	#endif // DEBUG
	for (; t--; ) {
        solve();
        cout << "\n";
	}
	return 0;
}
