#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <stack>
#include <queue>
#include <deque>
#include <iomanip>
#include <numeric>
#include <string>

#define all(a) a.begin(), a.end()
#define z(a) fixed << setprecision(a)
#define nl '\n'

using namespace std;

#define int long long

const int MAXN = 1e9 + 10;
const int MOD = 1e9+7;

void IO() {
#ifndef ONLINE_JUDGE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
}

inline void solve(){
	int n;
	cin >> n;
	vector<int> a(n), b(n);
	for (int i=0; i<n; i++){
		cin >> a[i];
	}
	for (int i=0; i<n; i++){
		cin >> b[i];
	}
	int s1 = 0, s2 = 0;
	for (int i=0; i<n; i++){
		if (a[i] == 1 && b[i] == 0){
			s1++;
		}
		if (b[i] && !a[i]){
			s2++;
		}
	}
	int ans = 1;
	int q=s1;
	for (int i=0; i<100000000; i++){
		if (s1 > s2)
			break;
		ans++;
		s1 +=q;
		if (ans >= 10000000){
			cout << -1;
			return;
		}
	}
	cout << ans;
}

signed main() {
	IO();
	int t = 1;
	while (t--)
		solve();
	return 0;
}