#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <cstdio>
#include <cmath>
#include <set>
#include <map>

#define all(x) x.begin(), x.end()

using namespace std;

typedef long long ll;

const ll inf = ll(1e18) + 228;
const ll cst = 2e5 + 5;
const ll mod = 1e9 + 7;

vector<pair<ll, ll>> za, zb;
vector<pair<ll, ll>> a, b;

vector<pair<pair<ll, ll>, ll>> mon;

ll n, m, k;

ll ans = -inf;

int main(){
    cin >> n >> m >> k;
    for(int i = 0; i < n; i++){
        ll x, y;
        cin >> x >> y;
        za.push_back({x, y});
    }
    sort(all(za));
    for(int i = 0; i < m; i++){
        ll x, y;
        cin >> x >> y;
        zb.push_back({x, y});
    }
    sort(all(zb));
    for(int i = 0; i < n; i++){
        while(!a.empty() && a.back().second >= za[i].second) a.pop_back();
        a.push_back(za[i]);
    }
    for(int i = 0; i < m; i++){
        while(!b.empty() && b.back().second >= zb[i].second) b.pop_back();
        b.push_back(zb[i]);
    }
    for(int i = 0; i < k; i++){
        ll x, y, z;
        mon.push_back({{x, y}, z});
    }
    sort(all(mon));
    n = a.size();
    m = b.size();
    ll l = 0;
    ll r = 0;
    ll mp = -1;
    ll mpl = -1;
    ll sm = 0;
    ll mxy = 0;
    ll mpcc = -1;
    while(l < n){
        while(mp < k && mon[mp + 1].first.first <= a[l].first) {
                mp++;
                mxy = max(mxy, mon[mp].first.second);
        }
        if(mp == mpl){
            l++;
            continue;
        }
        while(r < m && mpcc <= mp){
            while(mpcc < mp && mon[mpcc + 1].first.second <= b[r].first){
                mpcc++;
                sm += mon[mpcc].second;
            }
            ans = max(ans, sm - a[l].second - b[r].second);
            r++;
        }
        l++;
        mpl = mp;
    }
    cout << ans;
    return 0;
}
