#include <bits/stdc++.h>

typedef int32_t i32;
typedef int64_t i64;

const i32 INF32 = 1000000000;
const i64 INF64 = 1000000000000000000;

using namespace std;

i32 main() {
  #ifdef DEBUG
  freopen("input.txt", "r", stdin);
  #endif
  ios_base::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);

  i32 count;
  cin >> count;

  i32 solve1[count];
  i32 solve2[count];

  for (i32 i = 0; i < count; i++) {
    cin >> solve1[i];
  }
  for (i32 i = 0; i < count; i++) {
    cin >> solve2[i];
  }

  i32 score1 = 0;
  i32 score2 = 0;

  i32 undef_count = 0;

  for (i32 i = 0; i < count; i++) {
    if (solve1[i] == 1 && solve2[i] == 0) {
      undef_count++;
    } else {
      score1 += solve1[i];
      score2 += solve2[i];
    }
  }

  if (score1 > score2) {
    cout << "1\n";
    return 0;
  }

  if (undef_count == 0) {
    cout << "-1\n";
    return 0;
  }

  cout << (score2 - score1) / undef_count + 1 << "\n";
  
  return 0;
}
