#include <bits/stdc++.h>

typedef int32_t i32;
typedef int64_t i64;

const i32 INF32 = 1000000000;
const i64 INF64 = 1000000000000000000;

using namespace std;

i32 main() {
  #ifdef DEBUG
  freopen("input.txt", "r", stdin);
  #endif
  ios_base::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);

  i32 count;
  cin >> count;

  string str;
  cin >> str;

  str.insert(0, 1, 'a');
  str.push_back('a');

  i32 start = 0;
  i32 ans = 0;
  for (i32 finish = 1; finish < (i32) str.size(); finish++) {
    if (str[finish] == 'a') {
      stack<i32> slopes;
      for (i32 i = start; i < finish; i++) {
	i32 slope = str[i + 1] - str[i];
	if (slope == 0) {
	  continue;
	}
	
	if (slope > 0) {
	  slopes.push(slope);
	} else if (slope < -1) {
	  while (slope < 0) {
	    if (slope < -1 && slopes.top() > 1) {
	      break;
	    }
	    
	    if (-slope > slopes.top()) {
	      slope += slopes.top();
	      slopes.pop();
	    } else {
	      slopes.top() += slope;
	      slope = 0;
	      if (slopes.top() == 0) {
		slopes.pop();
	      }
	    }
	  }
	} else {
	  slopes.top() += slope;
	  if (slopes.top() == 0) {
	    slopes.pop();
	  }
	}
      }

      ans += finish - start - 1 - (i32) slopes.size();

      // cout << "! ";
      // while (!slopes.empty()) {
      // 	cout << slopes.top() << " ";
      // 	slopes.pop();
      // }
      // cout << "\n";
      
      start = finish;
    }
  }

  cout << ans << "\n";

  return 0;
}
