#include <iostream>
#include <map>

using namespace std;

void solve();

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif
    solve();
    return 0;
}

#define int long long

const int maxN = 2e5 + 10, inf = 1e18;

int n, a[maxN];
map < int, int > ma;

void solve() {
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < n; i++) {
        ma[a[i] - i] += a[i];
    }
    int ans = 0;
    for (auto it = ma.begin(); it != ma.end(); it++) {
        ans = max(ans, (*it).second);
    }
    cout << ans;
}