#include <iostream>
#include <map>
#include <vector>

using namespace std;

void solve();

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif
    solve();
    return 0;
}

#define int long long

const int maxN = 2e5 + 10, inf = 1e18;

int n;
vector < int > a[26];
string s;

void solve() {
    cin >> n >> s;
    for (int i = 0; i < s.size(); i++) {
        a[s[i] - 'a'].push_back(i);
    }
    for (int i = 25; i >= 0; i--) {
        for (int j = 0; j < a[i].size(); j++) {
            int cur = a[i][j];
            //cout << cur << " " << s[cur] << endl;
            bool ok = false;
            for (int h = cur - 1; h >= 0; h--) {
                if (s[h] - 'a' + 1 == i || s[h] - 'a' - 1 == i) {
                    ok = true;
                }
                if (s[h] != ' ' && s[h] - 'a' != i) break;
            }
            for (int h = cur + 1; h < s.size(); h++) {
                if (s[h] - 'a' + 1 == i || s[h] - 'a' - 1 == i) {
                    ok = true;
                }
                if (s[h] != ' ' && s[h] - 'a' != i) break;
            }
            if (ok) s[cur] = ' ';
        }
    }
    int ans = 0;
    for (int i = 0; i < s.size(); i++) {
        if (s[i] == ' ') ans++;
    }
    cout << ans;
}