#include <iostream>
#include <vector>
#include <algorithm>
#include <assert.h>
#include <set>
#include <map>
using namespace std;

#define ll long long
#define vll vector<ll>
#define pll pair<ll, ll>
#define vpll vector<pll >
#define vii vector<int>
#define vbb vector<bool>
#define pii pair<int, int>
#define vpii vector<pii >
#define pb push_back

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    ll n;
    cin >> n;

    vll a(n);
    for(int i = 0; i < n; i++)
        cin >> a[i];
    vll b(n);
    for(int i = 0; i < n; i++)
        cin >> b[i];

    ll onlyA = 0;
    ll onlyB = 0;
    for(int i = 0; i < n; i++)
    {
        if(a[i] == 1 && b[i] == 0)
            onlyA++;
        if(b[i] == 1 && a[i] == 0)
            onlyB++;
    }
    if(onlyA == 0)
    {
        cout << -1 << endl;
        return 0;
    }

    for(int i = 1; i <= 1000; i++)
    {
        ll xDif = onlyA * i;
        ll yDif = onlyB;
        if(xDif > yDif)
        {
            cout << i << endl;
            return 0;
        }
    }
    assert(0);
    return 0;
}