#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;
using namespace std;

#define pii pair <int, int>
#define pll pair <long long, long long>
#define mp make_pair
#define f first
#define se second
#define ll long long
#define ull unsigned long long
#define cntbit(x) __builtin_popcount(x)
#define pb push_back
#define ppb pop_back
#define pf push_front
#define ld long double

template <typename T> Max(T &a, T b) {
	a = max(a, b);
}

template <typename T> Min(T &a, T b) {
	a = min(a, b);
}

ostream &operator << (ostream &cout, vector <int> &s) {
	cout << "{";
	for(auto &i : s)
		cout << i << ", ";
	cout << "}";
	return cout;
}

ostream &operator << (ostream &cout, set <int> &s) {
	cout << "{";
	for(auto &i : s)
		cout << i << ", ";
	cout << "}";
	return cout;
}

const ll inf = 2e15;
//mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
//uniform_int_distribution <int> range(0, inf);

struct pt {
	int x, y, w;
};

const int mod = 1e9 + 7;
const int N = 1e6 + 15;
int n, m, k;
pii a[N], b[N];

pt c[N];

ll add[N << 2];

ll ans[N << 2];

inline void push(int v) {
	if(v < (N << 1)) {
		ans[v << 1] += add[v];
		ans[v << 1 | 1] += add[v];
		add[v << 1] += add[v];
		add[v << 1 | 1] += add[v];
		add[v] = 0;
	}
}

void multiupdate(int v, int tl, int tr, int l, int r, ll val) {
	if(tl > r || tr < l)
		return;
	push(v);
	if(tl >= l && tr <= r) {
		ans[v] += val;
		add[v] += val;
		return;
	}
	int mid = tl + tr >> 1;
	multiupdate(v << 1, tl, mid, l, r, val);
	multiupdate(v << 1 | 1, mid + 1, tr, l, r, val);
	ans[v] = max(ans[v << 1], ans[v << 1 | 1]);
}

ll getans(int v, int tl, int tr, int l, int r) {
	if(tl > r || tr < l)
		return -inf;
	push(v);
	if(tl >= l && tr <= r)
		return ans[v];
	int mid = tl + tr >> 1;
	return max(getans(v << 1, tl, mid, l, r), getans(v << 1 | 1, mid + 1, tr, l, r));
}

ll anss = -inf;

int mn[N];

main() {
    ios_base::sync_with_stdio(0); cout.tie(0); cin.tie(0);
	cin >> n >> m >> k;
	for(int i = 1; i <= n; ++i)
		cin >> a[i].f >> a[i].se;
	sort(a + 1, a + 1 + n);
	for(int i = 1; i <= m; ++i)
		cin >> b[i].f >> b[i].se;
	sort(b + 1, b + 1 + m);
	fill(mn, mn + N, inf);
	mn[m] = b[m].se;
	for(int i = m - 1; i >= 1; --i) {
		mn[i] = min(mn[i+1], b[i].se);
	}
	for(int i = 0; i < N; ++i) {
		int l = 1, r = m, res = -1;
		while(l <= r) {
			int mid = l + r >> 1;
			if(b[mid].f > i)
				r = mid - 1, res = mid;
			else
				l = mid + 1;
		}
		if(res == -1)
			multiupdate(1, 0, N - 1, i, i, -inf);
		else
			multiupdate(1, 0, N - 1, i, i, -mn[res]);
	}
	for(int i = 1; i <= k; ++i)
		cin >> c[i].x >> c[i].y >> c[i].w;

	sort(c + 1, c + 1 + k, [&](pt &a, pt &b) {
		return a.x < b.x;
	});
	for(int i = 1, j = 1; i <= n; ++i) {
		while(j <= k && c[j].x < a[i].f) {
            multiupdate(1, 0, N - 1, c[j].y, N - 1, c[j].w);
			++j;
		}
		Max(anss, getans(1, 0, N - 1, 0, N - 1) - a[i].se);
	}
	for(int i = 1; i <= n; ++i)
		Max(anss, (ll)(-a[i].se - mn[1]));
	cout << anss << endl;
    return 0;
}
