#include <bits/stdc++.h>
#define fori(n) for (int i = 0; i < n; i++)
#define forj(n) for (int j = 0; j < n; j++)
#define ss second
#define ff first
#define pb push_back
#define all(v) v.begin(), v.end()
#pragma GCC optimize("Ofast", "unroll-loops", "no-stack-protector", "fast-math")
//#pragma GCC target("avx2")
using namespace std;
typedef long long ll;
struct segment_tree {
    vector < int > a;
    vector < int > t;
    vector < int > mn;
    int siz;
    void push(int v) {
        t[v * 2 + 1] += t[v];
        t[v * 2 + 2] += t[v];
        mn[v] += t[v];
        t[v] = 0;
    }
    void rebuild(int v, int l, int r) {
        if (l == r) {
            mn[v] = a[l];
            return ;
        }
        int m = (l + r) / 2;
        rebuild(v * 2 + 1, l, m);
        rebuild(v * 2 + 2, m + 1, r);
        mn[v] = max(mn[v * 2 + 1], mn[v * 2 + 2]);
    }
    void build(vector < int > aa) {
        a = aa;
        siz = a.size();
        t.resize(4 * siz);
        mn.resize(4 * siz);
        rebuild(0, 0, siz - 1);
    }
    int val;
    void reupd(int v, int l, int r, int tl, int tr) {
        if (tl == l && tr == r) {
            t[v] += val;
            if (l == r) {
                mn[v] += t[v];
                t[v] = 0;
            } else {
                push(v);
            }
            return ;
        }
        int m = (l + r) / 2;
        if (tl <= m)
            reupd(v * 2 + 1, l, m, tl, min(m, tr));
        if (tr >= m + 1)
            reupd(v * 2 + 2, m + 1, r, max(m + 1, tl), tr);
        push(v);
        mn[v] = max(mn[v * 2 + 1] + t[v * 2 + 1], mn[v * 2 + 2] + t[v * 2 + 2]);
        return ;
    }
    void upd(int l, int r, int vall) {
        val = vall;
        reupd(0, 0, siz - 1, l, r);
    }
    int ask() {
        push(0);
        return mn[0];
    }
};
void test() {
    srand(time(NULL));
    vector < int > a;
    int n = 10;
    a.resize(n);
    fori(n) a[i] = rand() % 100;
    int t = 1000000;
    segment_tree tr;
    tr.build(a);
    int cnt = 0;
    while (t--) {
        cnt++;
        int l = rand() % n;
        int r = rand() % n;
        int val = rand() % 100;
        if (l > r) swap(l, r);
        for (int i = l; i <= r; i++) a[i] += val;
        tr.upd(l, r, val);
        int mn = a[0];
        fori(n) mn = max(mn, a[i]);
        if (tr.ask() != mn) {
            cout << cnt << endl;
            fori(n) cout << a[i] << " ";
            cout << endl;
            cout << "cor ans = " << mn << endl;
            cout << "seg ans = " << tr.ask() << endl;
            return ;
        }
    }
}
int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, m, k;
    cin >> n >> m >> k;
    vector < pair < int, int > > a;
    vector < pair < int, int > > b;
    a.resize(n);
    b.resize(m);
    fori(n) cin >> a[i].ff >> a[i].ss;
    fori(m) cin >> b[i].ff >> b[i].ss;
    vector < pair < pair < int, int >, int > > z;
    z.resize(k);
    fori(k) cin >> z[i].ff.ff >> z[i].ff.ss >> z[i].ss;
    sort(all(a));
    sort(all(b));
    sort(all(z));
    vector < pair < int, int > > na;
    na.pb(a[0]);
    for (int i = 1; i < a.size(); i++) {
        if (a[i].ff != a[i - 1].ff) na.pb(a[i]);
    }
    a = na;
    na = {};
    na.pb(b[0]);
    for (int i = 1; i < b.size(); i++) {
        if (b[i].ff != b[i - 1].ff) na.pb(b[i]);
    }
    b = na;
    na = {};
    n = a.size();
    m = b.size();
    int ans = -a[0].ss -b[0].ss;
    fori(k) if (a[0].ff > z[i].ff.ff && b[0].ff > z[i].ff.ss) ans += z[i].ss;
    vector < int > kek;
    kek.resize(m);
    fori(m) kek[i] = -b[i].ss;
    segment_tree t;
    t.build(kek);
    /// для каждого меча считаем, каких он убьет монстров, которых не убивает предыдущий меч
    vector < vector < int > > kill;
    kill.resize(n);
    for (int i = 0; i < k; i++) {
        if (a[n - 1].ff <= z[i].ff.ff) continue;
        int l = 0, r = n - 1;
        int m;
        while (true) {
            if (l == r) break;
            m = (l + r) / 2;
            if (a[m].ff > z[i].ff.ff) r = m;
            else l = m + 1;
        }
        kill[l].pb(i);
    }
    vector < int > l;
    l.resize(k);
    /// для каждого монстра посчитаем минимальную броню, которая спасает от него
    fori(k) {
        if (b[m - 1].ff <= z[i].ff.ff) continue;
        int ll = 0, r = m - 1;
        int mid;
        while (true) {
            if (ll == r) break;
            mid = (ll + r) / 2;
            if (b[mid].ff > z[i].ff.ff) r = mid;
            else ll = mid + 1;
        }
        l[i] = ll;
    }
    for (int i = 0; i < n; i++) {
        for (auto in: kill[i]) {
            if (l[in] == -1) continue;
            t.upd(l[in], m - 1, z[in].ss);
        }
        ans = max(ans, t.ask() - a[i].ss);
    }
    cout << ans;
}
