#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <cmath>
#include <numeric>
#include <iomanip>
#include <utility>
#include <iterator>
#include <map>
#include <set>
#include <string>
#include <algorithm>
#include <climits>
#include <deque>
#include <queue>
#include <unordered_map>
#include <unordered_set>
using namespace std;
#define int long long
struct fenwick{
	int n;
	vector<int> f;
	fenwick(int a){
		n = a;
		f.assign(n,0);
	};
	void add(int val, int i){
		for (; i < n; i |= (i + 1))
			f[i] += val;
	}
	int getsum(int i){
		int sum = 0;
		for (; i >= 0; i &= (i + 1), --i)
			sum += f[i];
		return sum;
	}
	int get(int L, int R){
		return getsum(R) - getsum(L - 1);
	}
};
void solve(){
	int n;
	cin >> n;
	vector<int> a(n),b(n);
	for (int i = 0; i < n; ++i) cin >> a[i];
	for (int i = 0; i < n; ++i) cin >> b[i];
	vector<int> ans(n);
	for (int ma = 1; ma <= 1000; ++ma){
		int s1 = 0, s2 = 0;
		for (int i = 0; i < n; ++i){
			if (b[i]){
				s2++;
				if (a[i]) s1++;
				continue;
			}
			if (a[i]) s1 += ma;
		}
		if (s1 > s2){
			cout << ma;
			return;
		}
	}
	cout << -1;
	return;
}
signed main(){
#ifdef _DEBUG
	freopen("input.txt","r",stdin);
	freopen("output.txt","w",stdout);
#else
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#endif
	int t;
	t = 1;
	while(t--){
		solve();
	}
}