#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <cmath>
#include <numeric>
#include <iomanip>
#include <utility>
#include <iterator>
#include <map>
#include <set>
#include <string>
#include <algorithm>
#include <climits>
#include <deque>
#include <queue>
#include <unordered_map>
#include <unordered_set>
using namespace std;
#define int long long
struct fenwick{
	int n;
	vector<int> f;
	fenwick(int a){
		n = a;
		f.assign(n,0);
	};
	void add(int val, int i){
		for (; i < n; i |= (i + 1))
			f[i] += val;
	}
	int getsum(int i){
		int sum = 0;
		for (; i >= 0; i &= (i + 1), --i)
			sum += f[i];
		return sum;
	}
	int get(int L, int R){
		return getsum(R) - getsum(L - 1);
	}
};
void solve(){
	int m,n;
	cin >> m;
	string s;
	cin >> s;
	int f = true;
	while (f != -1){
		string sl;
		n = s.size();
		f = -1;
		vector<int> can(n,-1);
		for (int i = 0; i < n; ++i){
			if (i > 0 && s[i-1] == s[i] - 1) can[i] = i - 1;
			if (i < n - 1 && s[i + 1] == s[i] - 1) can[i] = i + 1;
		}
		int f1 = -1;
		for (int i = 0; i < n; ++i){
			if (i != n - 1 && can[i] != -1 && can[i + 1] == i){
				f1 = i + 1;
				continue;
			}
		}
		f = f1;
		for (int i = 0; i < n; ++i){
			if (f == i) continue;
			if (can[i]!= -1 && f == -1){
				f = i;
			}
			else sl.push_back(s[i]);
		}
		s = sl;
	}
	cout << m - n;
}
signed main(){
#ifdef _DEBUG
	freopen("input.txt","r",stdin);
	freopen("output.txt","w",stdout);
#else
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#endif
	int t;
	t = 1;
	while(t--){
		solve();
	}
}