#include <bits/stdc++.h>
#if ONLINE_JUDGE
#pragma GCC optimize("O3")
#pragma GCC target("avx2")
#endif
#define ll long long

using namespace std;

const int INF = 2e5 + 1;

int main() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> g(n + 1);
    int f, t;
    for (int i = 0; i < m; ++i) {
        cin >> f >> t;
        g[t].emplace_back(f);
    }

    int k;
    cin >> k;
    vector<int> path(k);
    for (auto &i : path) cin >> i;

    vector<int> d(n + 1, INF);
    priority_queue<tuple<int, int, int>> upd;
    vector<set<int>> prev(n + 1);
    d[path[k - 1]] = 0;
    for (int u : g[path[k - 1]]) {
        upd.emplace(1, u, path[k - 1]);
    }
    while (!upd.empty()) {
        auto [dcur, cur, from] = upd.top();
        d[cur] = dcur;
        prev[cur] = {from};
        for (int u : g[cur]) {
            if (d[u] > d[cur] + 1) {
                upd.emplace(d[cur] + 1, u, cur);
            } else if (d[u] == d[cur] + 1) {
                prev[u].emplace(cur);
            }
        }
        while (!upd.empty() && get<0>(upd.top()) >= d[get<1>(upd.top())]) {
            if (get<0>(upd.top()) == d[get<1>(upd.top())])
                prev[get<1>(upd.top())].emplace(get<2>(upd.top()));
            upd.pop();
        }
    }

    int mn = 0, mx = 0;
    for (int i = 0; i < k - 1; ++i) {
        if (prev[path[i]].count(path[i + 1]) == 0) {
            mn += 1;
            mx += 1;
        } else if (prev[path[i]].size() > 1)
            mx += 1;
    }

    cout << mn << ' ' << mx << endl;

    return 0;
}
