//#define _FORTIFY_SOURCE 0
//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("no-stack-protector")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("sse,sse2,sse3,sse4,popcnt,abm,mmx,avx,tune=native")
#include <bits/stdc++.h>

#define ll long long
#define pll pair<ll, ll>
#define ld long double
#define pb push_back
#define mp make_pair
#define all(x) x.begin(), x.end()


using namespace std;


mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());


ll rnd(ll l, ll r) {
    return uniform_int_distribution<ll>(l, r)(rng);
}


ld rnd_double(ld l, ld r) {
    return uniform_real_distribution<ld>(l, r)(rng);
}


template<class T>
istream& operator>>(istream &in, vector<T> &arr) {
    for (T &x : arr) {
        in >> x;
    }
    return in;
};


void solve() {
    ll n;
    cin >> n;
    map<ll, ll> keeper;
    for (int i = 1; i <= n; i++) {
        ll b;
        cin >> b;
        keeper[i - b] += b;
    }
    ll ans = 0;
    for (auto p : keeper) {
        ans = max(ans, p.second);
    }
    cout << ans;
}


int main() {
    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    #endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout.precision(30);
    solve();
    return 0;
}