#include <bits/stdc++.h>

typedef long long ll;
//#define int ll
#define x first
#define y second
#define pii pair<int, int>
using namespace std;

vector<int> d;
vector<vector<int>> tmp, g;
int n, m, k;
void bfs(int v){
    d.resize(n, INT_MAX);
    d[v] = 0;
    queue<int> q;
    q.push(v);
    while (!q.empty()){
        int u = q.front(); q.pop();
        for (int &t : g[u]){
            if (d[t] > d[u] + 1){
                d[t] = d[u]+1;
                q.push(t);
            }
        }
    }
    tmp.resize(n);
    for (int i = 0; i < n; ++i){
        tmp[d[i]].push_back(i);
    }
}
signed main() {
    ios_base::sync_with_stdio(false); cout.tie(0); cin.tie(0);
    cin >> n >> m;
    g.resize(n);
    int f, t;
    for (int i = 0; i< m; ++i){
        cin >> f >> t;
        f--; t--;
        g[t].push_back(f);
    }
    cin >> k;
    vector<int> path(k);
    for (int i = 0; i < k; ++i) {
        cin >> path[i];
        path[i]--;
    }
    bfs(path[k-1]);
    for (int i = 0; i < n; ++i){
        sort(tmp[i].begin(), tmp[i].end());
    }
    for (int i = 0; i< n; ++i){
        sort(g[i].begin(), g[i].end());
    }
    int mi = 0, ma = 0;
    for (int i = 1; i < k; ++i){
        int v = path[i-1], u = path[i], dist = d[v]-1;
        if (tmp[dist].empty()){
            mi++;
            ma++;
        }
        else if (tmp[dist].size() == 1){
            if (tmp[dist][0] != u){
                mi++;
                ma++;
            }
        }
        else {
            if (!binary_search(tmp[dist].begin(), tmp[dist].end(), u)){
                mi++;
            }
            for (int &j : tmp[dist]){
                if (j == u) continue;
                if (binary_search(g[j].begin(), g[j].end(), v)){
                    ma++;
                    break;
                }
            }
        }
    }
    cout << mi << ' ' << ma << '\n';
    return 0;
}
