#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <queue>

using namespace std;

#define re return
#define pb push_back

vector<vector<pair<int, int>>> g;

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	int n, m;
	cin >> n >> m;

	g.resize(n);

	for(int i = 0; i < m; ++i)
	{
		int a, b;
		cin >> a >> b;
		--a; -- b;

		g[a].pb(make_pair(b, 1));
		g[b].pb(make_pair(a, -1));
	}

	
	int k;
	cin >> k;
	vector<int> way(k);

	for(int i = 0; i < k; ++i)
	{
		cin >> way[i];
		--way[i];
	}

	queue<int> q;
	q.push(way[k - 1]);

	vector<int> d(n, 1e9 + 7);
	d[way[k - 1]] = 0;

	while(!q.empty())
	{
		int now = q.front();
		q.pop();

		for(int i = 0; i < g[now].size(); ++i)
		{
			if(d[now] + 1 < d[g[now][i].first] && g[now][i].second == -1)
			{
				d[g[now][i].first] = d[now] + 1;
				q.push(g[now][i].first);
			}
		}
	}

	int mn = 0, mx = 0;

	for(int i = 0; i < k - 1; ++i)
	{
		if(d[way[i]] != d[way[i + 1]] + 1)
		{
			mn++;
			mx++;
		}
		else
		{
			int cnt = 0;
			for(int j = 0; j < g[way[i]].size(); ++j)
			{
				if(d[g[way[i]][j].first] + 1 == d[way[i]] && g[way[i]][j].second == 1)
				{
					++cnt;
				} 
			}

			if(cnt != 1)
			{
				++mx;
			}
		}
	}

	cout << mn << " " << mx << endl;
}