#include <bits/stdc++.h>
#define x first
#define y second
using namespace std;
typedef long long ll;

const int N = 2e5 + 10;
const int mod = 1e9 + 7;
#define int long long
int n, m, p;
pair < int, int > a[N], b[N];

struct kek
{
    int x;
    int y;
    int z;
};

kek d[N];
vector < kek > v;

bool cmp(kek a, kek b)
{
    return a.x < b.x || (a.x == b.x && a.y < b.y);
}
int t[4 * N], g[4 * N];

void build(int v, int l, int r)
{
    if (l == r - 1)
    {
        t[v] = b[l].y;
        return;
    }
    int m = (l + r) / 2;
    build(v * 2, l, m);
    build(v * 2 + 1, m, r);
    t[v] = max(t[v * 2], t[v * 2 + 1]);
}

void push(int v)
{
    t[v] += g[v];
    if (v * 2 + 1 < 4 * N)
    {
        g[v * 2] += g[v];
        g[v * 2 + 1] += g[v];
    }
    g[v] = 0;
}

void upd(int v, int L, int R, int l, int r, int d)
{
    push(v);
    if (l <= L && R <= r)
    {
        g[v] += d;
        push(v);
        return;
    } else if (l >= R || L >= r) return;
    int m = (L + R) / 2;
    upd(v * 2, L, m, l, r, d);
    upd(v * 2 + 1, m, R, l, r, d);
    t[v] = max(t[v * 2], t[v * 2 + 1]);
    return;
}

main()
{
#ifdef HOME
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    cin >> n >> m >> p;

    for (int i = 1; i <= n; ++i)
    {
        cin >> a[i].x >> a[i].y;
        v.push_back({a[i].x, 0, a[i].y});
    }

    for (int i = 1; i <= m; ++i)
    {
        cin >> b[i].x >> b[i].y;
        b[i].y *= -1;
    }

    build(1, 1, m + 1);

    sort(b + 1, b + 1 + m);
    for (int i = 1; i <= p; ++i)
    {
        cin >> d[i].x >> d[i].y >> d[i].z;
        v.push_back(d[i]);
    }
    sort(v.begin(), v.end(), cmp);

    int ans = 0;
    for (auto f : v)
    {
        if (f.y  == 0)
        {
            ans = max(ans, t[1] - f.z);
        } else
        {
            pair < int, int > e = {f.x, 1e9};
            int u = upper_bound(b + 1, b + 1 + m, e) - b;
            if (u <= m) upd(1, 1, m + 1, u, m + 1, f.z);
        }
    }
    cout << ans;
    return 0;
}
