#include <bits/stdc++.h>
#define int long long
#define x first
#define y second
#define pii pair<int, int>

using namespace std;

const int N = 1e2 + 10;

int n;
string s;
string dp[N][N];

string construct(string s1, string s2)
{
    reverse(s2.begin(), s2.end());

    while(!s1.empty() && !s2.empty() && abs(s1.back() - s2.back()) == 1)
        if(s1.back() > s2.back())
            s1.pop_back();
        else
            s2.pop_back();

    reverse(s2.begin(), s2.end());

    return s1 + s2;
}

int32_t main()
{
    cin >> n >> s;

    for(int i = 0; i < n; ++i)
        dp[i][i] = string(1, s[i]);

    for(int k = 1; k < n; ++k)
        for(int l = 0; l + k < n; ++l)
            for(int j = l; j + 1 <= l + k; ++j)
            {
                string t = construct(dp[l][j], dp[j + 1][l + k]);

                if(t.size() < dp[l][l + k].size() || dp[l][l + k].empty())
                    dp[l][l + k] = t;
            }

    cout << (n - (int)dp[0][n - 1].size()) << endl;
}
