#include <bits/stdc++.h>

//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("unroll-loops")

typedef long long ll;
typedef long double ld;

using namespace std;

#define sz(x) (int ) (x).size()
#define sqr(x) (x) *(x)
#define fi first
#define se second
#define pll pair<ll,ll >
#define pb push_back
#define endln '\n'
#define all(x) (x).begin(), (x).end()
#define cont continue


const ll MaxN = 1e6+ 100;
const long long Inf = 2e18;

ll Sh[MaxN];
struct el{
    ll a, z;
    ll c;

} Mob[MaxN];


ll Tree[MaxN * 4];
ll Mn[MaxN * 4];

void Build(ll l, ll r, ll id){
    if(l == r){
        Tree[id] =-Sh[l];
    }else{
    ll mid = ( l + r)/2;
    Build(l, mid, id*2+1);
    Build(mid+1,r, id*2+2);
    Tree[id] = max(Tree[id*2+1], Tree[id*2+2]);

    }
}

void edit(ll l, ll r, ll x, ll y, ll a, ll id){
    if(l == x && y == r){
        Mn[id] += a;
        Tree[id] += a;
    }else{
        ll mid = (l + r)/2;
        if(y <= mid) edit(l, mid, x, y, a, id*2+1);
        else if(x >= mid+1)edit(mid+1,r,x,y,a, id*2+2);
        else {
            edit(l, mid, x, mid, a, id*2+1);
            edit(mid+1,r,mid+1,y,a, id*2+2);
        }
        Tree[id] = max(Tree[id*2+1], Tree[id*2+2]) + Mn[id];
    }
}
int main()
{

 #ifdef LOCAL
    ifstream cin("input.txt");
    ofstream cout("output.txt");
 #else

 #endif // LOCAL

    ios_base::sync_with_stdio(0),cin.tie(0), cout.tie(0);
    //cout<<fixed()<<setprecision(5);

    ll N, M, P;
    cin>>N>>M>>P;
    vector<pll > Sw(N);
    for(int i =0;i<N;i++){
        ll a, c;
        cin>>a>>c;
        Sw[i]=  {a,c};
    }
    fill(Sh, Sh + MaxN, Inf);

    for(int i =0;i<M;i++){
        ll a, c;
        cin>>a>>c;
        Sh[a] = min(Sh[a], c);
    }
    Build(0, MaxN-1,0);
    //fill(Sh, Sh + M, Inf);
    for(int i =0;i<P;i++){
        cin>>Mob[i].z >> Mob[i].a >> Mob[i].c;
    }
    sort(all(Sw));
    sort(Mob, Mob + P, [=](el a, el b){
         return a.z < b.z ||(a.z == b.z && a.a < b.a);
    });
    ll j =0;
    ll Ans = -Inf;
    for(int i =0;i<N;i++){
        while(j < P && Mob[j].z < Sw[i].fi){
            edit(0, MaxN-1,Mob[j].a+1,MaxN-1, Mob[j].c,0 );
           Ans = max(Ans, Tree[0] - Sw[i].se);
            j++;
        }
        Ans = max(Ans, Tree[0] - Sw[i].se);
    }
    cout<<Ans<<endln;




    return 0;
}
