#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <numeric>
#include <iomanip>
#include <stack>
#include <queue>
#include <deque>
#include <list>
#include <random>

using namespace std;
#pragma warning(disable : 4996)

#define nl '\n'
#define all(a) (a).begin(), (a).end()
#define allr(a) (a).rbegin(), (a).rend()
#define mineq(a, b) (a) = min(a, b)
#define maxeq(a, b) (a) = max(a, b)

typedef long long ll;
typedef double dl;

const int INF = numeric_limits<int>::max();
const ll LINF = numeric_limits<ll>::max();
const dl EPS = 1e-8;
mt19937 rnd(2345234);

void IO() {
#ifndef ONLINE_JUDGE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
	cout.setf(ios::fixed);
	cout.precision(10);
}

void solve() {
	int n;
	cin >> n;
	vector<int> a(n), b(n);
	for (int i =0 ; i < n; i++) 
		cin >> a[i];
	for (int i =0 ; i < n; i++) 
		cin >> b[i];

	ll cnt1 = 0, cnt2 = 0;
	for (int i = 0; i < n; i++) {
		cnt1 += a[i] == 1 && b[i] == 0;
		cnt2 += a[i] == 0 && b[i] == 1;
	}
	if (cnt1 == 0) {
		cout << -1 << nl;
		return;
	}
	if (cnt1 > cnt2) {
		cout << 1 << nl;
		return;
	}
	cout << (cnt2 + cnt1 - 1) / cnt1 + 1 << nl;
}

int main() {
	IO();
	//int t;
	//cin >> t;
	//while (t--)
	solve();
	return 0;
}
