#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <numeric>
#include <iomanip>
#include <stack>
#include <queue>
#include <deque>
#include <list>
#include <random>

using namespace std;
#pragma warning(disable : 4996)

#define nl '\n'
#define all(a) (a).begin(), (a).end()
#define allr(a) (a).rbegin(), (a).rend()
#define mineq(a, b) (a) = min(a, b)
#define maxeq(a, b) (a) = max(a, b)

typedef long long ll;
typedef double dl;

const int INF = numeric_limits<int>::max();
const ll LINF = numeric_limits<ll>::max();
const dl EPS = 1e-8;
mt19937 rnd(2345234);

void IO() {
#ifndef ONLINE_JUDGE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
	cout.setf(ios::fixed);
	cout.precision(10);
}

const int N = (int)2e5 + 10;


vector<int> g[N];
int cnt[N];
int dist[N];

void solve() {
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; i++) {
		int u, v;
		cin >> u >> v;
		g[v].push_back(u);
	}

	int k;
	cin >> k;
	vector<int> p(k);
	for (int i = 0; i < k; i++) 
		cin >> p[i];

	queue<int> q;
	vector<bool> used(n + 1, false);
	q.push(p.back());
	used[p.back()] = true;
	cnt[p.back()] = 1;
	while (!q.empty()) {
		int v = q.front();
		q.pop();
		for (int i = 0; i < (int)g[v].size(); i++) {
			int to = g[v][i];
			if (used[to] && dist[to] == dist[v] + 1)
				cnt[to]++;
			if (used[to])
				continue;
			used[to] = true;
			q.push(to);
			dist[to] = dist[v] + 1;
			cnt[to]++;
		}
	}
	int mn = 0, mx = 0;
	for (int i = 1; i < k; i++) {
		int to = p[i];
		int v = p[i - 1];
		if (dist[v] != dist[to] + 1) {
			mn++;
			mx++;
		}
		else {
			mx += cnt[v] > 1;
		}
	}
	cout << mn << " " << mx << nl;
}

int main() {
	IO();
	//int t;
	//cin >> t;
	//while (t--)
	solve();
	return 0;
}
