#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
using namespace std;

#define int long long
#define INF 1e9 + 7

signed main() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> lst, lstr;
    lst.assign(n, {});
    lstr.assign(n, {});
    for (int i = 0; i < m; i++){
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        lst[a].push_back(b);
        lstr[b].push_back(a);
    }
    int k;
    cin >> k;
    vector<int> put;
    for (int i =0 ; i < k; i++){
        int x;
        cin >> x;
        x--;
        put.push_back(x);
    }
    int s = put[0], t= put[put.size() - 1];

    vector<int> d;
    d.assign(n, INF);
    d[t] = 0;
    set<pair<int ,int>> q;
    q.insert({0, t});
    while (!q.empty()){
        //cerr << 1 << "\n";
        pair<int, int> c = *q.begin();
        q.erase(q.begin());
        int v =  c.second, ln = c.first;
        for (int i = 0; i < lstr[v].size(); i++){
            int to = lstr[v][i];

            if (ln + 1 < d[to]){
                if (d[to] != INF)
                    q.erase(q.find({d[to], to}));
                d[to] = ln + 1;
                q.insert({d[to], to});
            }
            //cerr << 23;
        }
    }
    int cnt1 = 0, cnt2 = 0;
    for (int i = 0; i < put.size() - 1; i++){
        int v = put[i];
        int mn = INF;
        for (int to:lst[v]){
            mn = min(mn, d[to]);
        }
        int bl1 = 0, bl2 = 0;
        for (int to:lst[v]){
            if (d[to] == mn && put[i + 1] == to) bl1 = 1;
            else if (d[to] == mn){
                bl2 = 1;
            }
        }
        cnt1 += bl1;
        cnt2 += bl2;
    }
    cout << put.size() - 1 - cnt1 << " " << cnt2;
    return 0;
}