#include <bits/stdc++.h>

using namespace std;

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    vector<vector<int> > adj(n), adj2(n);
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        --a;
        --b;
        adj[b].push_back(a);
        adj2[a].push_back(b);
    }
    int k;
    cin >> k;
    vector<int> root(k);
    for (int i = 0; i < k; ++i) {
        cin >> root[i];
        --root[i];
    }
    queue<int> q;
    q.push(root.back());
    vector<int> dist(n, 1e9 + 7);
    dist[root.back()] = 0;
    while (!q.empty()) {
        int curr = q.front();
        q.pop();
        for (auto nextt : adj[curr]) {
            if (dist[nextt] == 1e9 + 7) {
                dist[nextt] = dist[curr] + 1;
                q.push(nextt);
            }
        }
    }
    int min_ans = 0, max_ans = 0;
    for (int i = 0; i < k - 1; ++i) {
        if (dist[root[i + 1]] != k - i - 2) {
            min_ans += 1;
            max_ans += 1;
        }
        else {
            int c = 0;
            for (auto u : adj2[root[i]]) {
                if (dist[u] == k - i - 2) {
                    c += 1;
                }
            }
            if (c > 1) {
                max_ans += 1;
            }
        }
    }
    cout << min_ans << " " << max_ans;
    return 0;
}
