#include <bits/stdc++.h>

using namespace std;
#define int long long

int n, m, k;
vector<pair<int, int> > aa, bb;
vector<vector<int> > monst;

int f(int ai, int bi) {
    int ans = 0;
    for (auto i : monst) {
        if (i[0] < aa[ai].first && i[1] < bb[bi].first) {
            ans += i[2];
        }
    }
    return ans - aa[ai].second - bb[bi].second;
}

int val(int ai) {
    int lb = 0, rb = m;
    for (int i = 0; i < 18; ++i) {
        int m1 = (2 * lb + rb) / 3, m2 = (lb + 2 * rb) / 3;
        m1 = min(m1, m - 1);
        m2 = min(m2, m - 1);
        if (f(ai, m1) < f(ai, m2)) {
            lb = m1;
        }
        else {
            rb = m2;
        }
    }
    int ans = -1e18;
    for (int i = max((int)0, lb - (int)20); i < min(m, lb + (int)20); ++i) {
        ans = max(ans, f(ai, i));
    }
    return ans;
}

int32_t main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m >> k;
    vector<pair<int, int> > a(n), b(m);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].second >> a[i].first;
    }
    b.resize(m);
    for (int i = 0; i < m; ++i) {
        cin >> b[i].second >> b[i].first;
    }
    sort(a.begin(), a.end());
    sort(b.begin(), b.end());
    for (int i = 0; i < n; ++i) {
        swap(a[i].second, a[i].first);
    }
    for (int i = 0; i < m; ++i) {
        swap(b[i].second, b[i].first);
    }
    aa.push_back(a[0]);
    bb.push_back(b[0]);
    for (int i = 0; i < n; ++i) {
        if (a[i].first > aa.back().first) {
            aa.push_back(a[i]);
        }
    }
    for (int i = 0; i < m; ++i) {
        if (b[i].first > bb.back().first) {
            bb.push_back(b[i]);
        }
    }
    n = aa.size();
    m = bb.size();
    monst.resize(k, vector<int>(3));
    for (int i = 0; i < k; ++i) {
        cin >> monst[i][0] >> monst[i][1] >> monst[i][2];
    }
    int la = 0, ra = n;
    for (int i = 0; i < 18; ++i) {
        int m1 = (2 * la + ra) / 3, m2 = (la + 2 * ra) / 3;
        m1 = min(m1, n - 1);
        m2 = min(m2, n - 1);
        if (val(m1) < val(m2)) {
            la = m1;
        }
        else {
            ra = m2;
        }
    }
    int ans = -1e18;
    for (int i = max((int)0, la - 20); i < min(n, la + 20); ++i) {
        ans = max(ans, val(i));
    }
    cout << ans;
    return 0;
}
