#include <bits/stdc++.h>

using namespace std;
#define int long long

int n, m, k;
vector<pair<int, int> > aa, bb;
vector<vector<int> > monst;

int f(int ai, int bi) {
    int ans1 = 0;
    for (auto i : monst) {
        if (i[0] < aa[ai].first && i[1] < bb[bi].first) {
            ans1 += i[2];
        }
    }
    return ans1 - aa[ai].second - bb[bi].second;
}

int val(int ai) {
    int lb = 0, rb = m;
    for (int ii = 0; ii < 13; ++ii) {
        int m1 = (2 * lb + rb) / 3, m2 = (lb + 2 * rb) / 3;
        m1 = min(m1, m - 1);
        m2 = min(m2, m - 1);
        int ans1 = 0, ans2 = 0;
        for (auto i : monst) {
            if (i[0] < aa[ai].first && i[1] < bb[m1].first) {
                ans1 += i[2];
            }
            if (i[0] < aa[ai].first && i[1] < bb[m2].first) {
                ans2 += i[2];
            }
        }
        ans1 -= aa[ai].second - bb[m1].second;
        ans2 -= aa[ai].second - bb[m2].second;
        if (ans1 < ans2) {
            lb = m1;
        }
        else {
            rb = m2;
        }
    }
    int ans = -1e18;
    for (int i = max((int)0, (lb + rb) / 2 - (int)18); i < min(m, (lb + rb) / 2 + (int)18); ++i) {
        int ans1 = 0;
        for (auto ii : monst) {
            if (ii[0] < aa[ai].first && ii[1] < bb[i].first) {
                ans1 += i[2];
            }
        }
        ans1 -= aa[ai].second - bb[i].second;
        ans = max(ans, ans1);
    }
    return ans;
}

int32_t main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> n >> m >> k;
    <pair<int, int> > a[n], b[m];
    for (int i = 0; i < n; ++i) {
        cin >> a[i].second >> a[i].first;
    }
    b.resize(m);
    for (int i = 0; i < m; ++i) {
        cin >> b[i].second >> b[i].first;
    }
    sort(a.begin(), a.end());
    sort(b.begin(), b.end());
    aa.push_back(a[0]);
    bb.push_back(b[0]);
    swap(aa[0].second, aa[0].first);
    swap(bb[0].second, bb[0].first);
    for (int i = 0; i < n; ++i) {
        swap(a[i].second, a[i].first);
        if (a[i].first > aa.back().first) {
            aa.push_back(a[i]);
        }
    }
    for (int i = 0; i < m; ++i) {
        swap(b[i].second, b[i].first);
        if (b[i].first > bb.back().first) {
            bb.push_back(b[i]);
        }
    }
    n = aa.size();
    m = bb.size();
    monst.resize(k, vector<int>(3));
    for (int i = 0; i < k; ++i) {
        cin >> monst[i][0] >> monst[i][1] >> monst[i][2];
    }
    int la = 0, ra = n;
    for (int i = 0; i < 13; ++i) {
        int m1 = (2 * la + ra) / 3, m2 = (la + 2 * ra) / 3;
        m1 = min(m1, n - 1);
        m2 = min(m2, n - 1);
        if (val(m1) < val(m2)) {
            la = m1;
        }
        else {
            ra = m2;
        }
    }
    int ans = -1e18;
    for (int i = max((int)0, (la + ra) / 2 - 18); i < min(n, (la + ra) / 2 + 18); ++i) {
        ans = max(ans, val(i));
    }
    cout << ans;
    return 0;
}
