#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define x first
#define y second
#define mp make_pair
#define pb push_back
#define up_b upper_bound
#define low_b lower_bound
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

using namespace std;
using namespace __gnu_pbds;

template<typename T> using indexed_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

typedef long long ll;
typedef long double ld;
typedef unsigned int uint;
typedef unsigned long long ull;
typedef pair<int, int> pii;
typedef pair<int, ll> pil;
typedef pair<ll, int> pli;
typedef pair<ll, ll> pll;

const ll INF = 1e18 + 123;
const ld EPS = 1e-9;
const int inf = 1e9 + 123;
const int MOD = 1e9 + 7;
const int N = 2e5 + 123;
const int M = 1e6 + 123;
const int dx[] = {1, -1, 0, 0};
const int dy[] = {0, 0, -1, 1};

pii c[N];

vector<pii> v[M];

int mna[M], mnb[M];

ll t[M*4], tadd[M*4];

void push(int v, int len){
    t[v] += tadd[v];
    if (len > 1){
        tadd[v+v+1] += tadd[v];
        tadd[v+v+2] += tadd[v];
    }
    tadd[v] = 0;
}

void upd(int l, int r, int val, int v = 0, int tl = 0, int tr = M){
    push(v, tr-tl);
    if (l >= tr || tl >= r) return;
    if (l <= tl && tr <= r){
        tadd[v] += val;
        push(v, tr-tl);
      //  cout << v << " " << tl << " " << tr << " " << t[v] << endl;
        return;
    }
    int tm = tl + tr >> 1;
    upd(l, r, val, v+v+1, tl, tm);
    upd(l, r, val, v+v+2, tm, tr);
    t[v] = max(t[v+v+1], t[v+v+2]);
    //cout << v << " " << tl << " " << tr << " " << t[v] << endl;
}

int main(){
    memset(mna, 0x3f, sizeof mna);
    memset(mnb, 0x3f, sizeof mnb);
    fill(t, t+M*4, -inf);
    #ifdef KAZAKH
        freopen("input.txt", "r", stdin);
    #endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, m, p;
    cin >> n >> m >> p;
    for (int i = 1; i <= n; i++){
        int a, b;
        cin >> a >> b;
        mna[a] = min(mna[a], b);
    }
    for (int i = 1; i <= m; i++){
        int a, b;
        cin >> a >> b;
        mnb[a] = min(mnb[a], b);
    }
    for (int i = M-2; i; i--){
        mna[i] = min(mna[i], mna[i+1]);
        mnb[i] = min(mnb[i], mnb[i+1]);
        upd(i-1, i, -mnb[i]+inf);
    }
    for (int i = 1; i <= p; i++){
        int a, b, c;
        cin >> a >> b >> c;
        v[a].pb({b, c});
    }
    ll mx = 0;
    for (int i = 1; i < M; i++){
        push(0, 2);
        mx = max(mx, t[0] - mna[i]);
        for (pii p : v[i]){
            upd(p.x, M, p.y);
        }
    }
    cout << mx;
    return 0;
}

