import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Scanner;
import java.util.StringTokenizer;
import java.util.TreeSet;

public class D {
    static ArrayList[] adj;
    static ArrayList[] rev;
    static BufferedReader in;
    static StringTokenizer st;

    static class pr implements Comparable<pr> {
        int v;

        pr(int x) {
            v = x;
        }

        @Override
        public int compareTo(pr o) {
            if (o.v == v) return 0;
            if (d[o.v] < d[v]) return 1;
            return -1;
        }
    }

    static int d[];

    public static void main(String[] args) throws IOException {
        in = new BufferedReader(new InputStreamReader(System.in));
        fp();
        int n = nextInt();
        int m = nextInt();
        adj = new ArrayList[n];
        rev = new ArrayList[n];
        for (int i = 0; i < n; i++) {
            adj[i] = new ArrayList();
            rev[i] = new ArrayList();
        }
        for (int i = 0; i < m; i++) {
            fp();
            int a = nextInt() - 1;
            int b = nextInt() - 1;
            adj[a].add(b);
            rev[b].add(a);
        }
        fp();
        int k = nextInt();
        int ms[] = new int[k];
        fp();
        for (int i = 0; i < k; i++) {
            ms[i] = nextInt() - 1;
        }
        int fn = ms[k - 1];
        d = new int[n];
        int inf = 1000_000_000;
        for (int i = 0; i < n; i++) {
            d[i] = inf;
        }
        d[fn] = 0;
        TreeSet<pr> set = new TreeSet<pr>();
        set.add(new pr(fn));
        while (!set.isEmpty()) {
            pr tk = set.first();
            set.remove(tk);
            for (int i = 0; i < rev[tk.v].size(); i++) {
                int to = (int) rev[tk.v].get(i);
                if (d[to] > d[tk.v] + 1) {
                    set.remove(new pr(to));
                    d[to] = d[tk.v] + 1;
                    set.add(new pr(to));
                }
            }
        }
        int mn = 0;
        int mx = 0;
        for (int i = 0; i < k - 1; i++) {
            if (d[ms[i]] == d[ms[i + 1]] + 1) {
                for (int j = 0; j < adj[ms[i]].size(); j++) {
                    int to = (int) adj[ms[i]].get(j);
                    if (to != ms[i + 1]) {
                        if (d[to] + 1 == d[ms[i]]) {
                            mx++;
                            break;
                        }
                    }
                }
            } else {
                mn++;
                mx++;
            }
        }
        System.out.println(mn + " " + mx);
    }

    private static void fp() throws IOException {
        st = new StringTokenizer(in.readLine());
    }

    private static int nextInt() {
        return Integer.parseInt(st.nextToken());
    }
}
