import java.util.Arrays;
import java.util.Comparator;
import java.util.Scanner;

import static java.lang.Math.max;

public class E {
    static long inf = 1000_000_000_000_000_000l;

    public static void main(String[] args) {
        Scanner in = new Scanner(System.in);
        int n = in.nextInt();
        int m = in.nextInt();
        int p = in.nextInt();
        int a[][] = new int[n][2];
        int b[][] = new int[m][2];
        int x[][] = new int[p][3];
        for (int i = 0; i < n; i++) {
            a[i][0] = in.nextInt();
            a[i][1] = in.nextInt();
        }
        for (int i = 0; i < m; i++) {
            b[i][0] = in.nextInt();
            b[i][1] = in.nextInt();
        }
        for (int i = 0; i < p; i++) {
            x[i][0] = in.nextInt();
            x[i][1] = in.nextInt();
            x[i][2] = in.nextInt();
        }
        Arrays.sort(a, (o1, o2) -> {
            if (o1[0] > o2[0]) return 1;
            if (o1[0] < o2[0]) return -1;
            if (o1[1] > o2[1]) return 1;
            if (o1[1] < o2[1]) return -1;
            return 0;
        });
        Arrays.sort(b, (o1, o2) -> {
            if (o1[0] > o2[0]) return 1;
            if (o1[0] < o2[0]) return -1;
            if (o1[1] > o2[1]) return 1;
            if (o1[1] < o2[1]) return -1;
            return 0;
        });
        Arrays.sort(x, (o1, o2) -> {
            if (o1[0] > o2[0]) return 1;
            if (o1[0] < o2[0]) return -1;
            return 0;
        });
        tr = new long[m * 8];
        plus = new long[m * 8];
        for (int i = 0; i < tr.length; i++) {
            tr[i] = -inf;
        }
        for (int i = 0; i < m; i++) {
            add(i, i + 1, 0, m, 1, inf - b[i][1]);
        }
        int uk = 0;
        long ans = -inf;
        for (int i = 0; i < n; i++) {
            long tk = -a[i][1];
            while (uk < p && x[uk][0] < a[i][0]) {
                int l = -1;
                int r = m - 1;
                while (l + 1 < r) {
                    int mid = (l + r) >> 1;
                    if (b[mid][0] > x[uk][1]) {
                        r = mid;
                    } else l = mid;
                }
                if (b[r][0] > x[uk][1]) {
                    add(r, m, 0, m, 1, x[uk][2]);
                }
                uk++;
            }
            long fk = tk + tr[1];
            if (fk > ans) ans = fk;
        }
        System.out.println(ans);
    }

    private static void add(int x, int y, int l, int r, int v, long k) {
        if (y <= l || x >= r) return;
        push(v);
        if (l >= x && r <= y) {
            plus[v] += k;
            tr[v] += k;
            return;
        }
        int m = (l + r) >> 1;
        add(x, y, l, m, v * 2, k);
        add(x, y, m, r, v * 2 + 1, k);
        tr[v] = max(tr[v * 2], tr[v * 2 + 1]);
    }

    private static void push(int v) {
        plus[v * 2] += plus[v];
        tr[v * 2] += plus[v];
        plus[v * 2 + 1] += plus[v];
        tr[v * 2 + 1] += plus[v];
        plus[v] = 0;
    }

    static long tr[];
    static long plus[];
}
