#include <bits/stdc++.h>

using namespace std;

//#define int long long
#define endl '\n'

pair<int, int> t[4000000];

void build(vector<int> &arr, int v, int l, int r) {
    if (r - l == 1) {
        t[v].first = arr[l];
        t[v].second = 0;
    } else {
        int m = (l + r) / 2;
        build(arr, v * 2 + 1, l, m);
        build(arr, v * 2 + 2, m, r);
        t[v].first = max(t[v * 2 + 1].first, t[v * 2 + 2].first);
    }
}

void push(int v, int vl, int vr) {
    int val = t[v].second;
    t[v].first += val;
    t[v].second = 0;
    if (vr - vl > 1) {
        t[v * 2 + 1].second += val;
        t[v * 2 + 2].second += val;
    }
}

void update(int v, int l, int r, int vl, int vr, int val) {
    if (l >= r) {
        return;
    }
    push(v, vl, vr);
    if (l == vl && r == vr) {
        t[v].second += val;
        push(v, vl, vr);
        return;
    }

    int vm = (vl + vr) / 2;
    update(v * 2 + 1, l, min(r, vm), vl, vm, val);
    update(v * 2 + 2, max(vm, l), r, vm, vr, val);
    push(v, vl, vr);
    push(v * 2 + 1, vl, vm);
    push(v * 2 + 2, vm, vr);
    t[v].first = max(t[v * 2 + 1].first, t[v * 2 + 2].first);
}

void print(int v, int l, int r) {
    push(v, l, r);
    if (r - l == 1) {
        cout << t[v].first << " ";
    } else {
        int m = (l + r ) / 2;
        print(v * 2 + 1, l, m);
        print(v * 2 + 2, m, r);
    }
}

signed main() {
    ios_base::sync_with_stdio(NULL);
    cin.tie(NULL);
    int n, m, k;
    cin >> n >> m >> k;
    vector<pair<int, int>> a(n);

    for (int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
    }
    sort(a.begin(), a.end());

    vector<pair<int, int>> b(m);

    for (int i = 0; i < m; i++) {
        cin >> b[i].first >> b[i].second;
    }

    sort(b.begin(), b.end());

    vector<pair<int, int>> bn;

    bn.push_back(b[0]);

    for (int i = 1; i < m; i++) {
        if (b[i].first != b[i - 1].first) {
            bn.push_back(b[i]);
        }
    }

    b = bn;
    m = bn.size();

    vector<int> bb(m);
    vector<int> bc(m);

    vector<int> pr(m);


    for (int i = 0; i < m; i++) {
        bb[i] = b[i].first;
        if (i == 0) {
            pr[i] = b[i].second * -1;
            bc[i] = b[i].second * -1;
        } else {
            pr[i] = b[i].second * -1;
            bc[i] = b[i].second * -1 - pr[i - 1];
        }
        //cout << b[i].first << " " << b[i].second << endl;
    }


    build(pr, 0, 0, m);

    /*cout << "DO ";
    print(0, 0, m);
    cout << endl;

    cout << endl;
    for (int i = 0; i < m; i++) {
        cout << bb[i] << " " << bc[i] << endl;
    }

    cout << endl;*/

    vector<pair<int, pair<int, int>>> monsters(k);

    for (int i = 0; i < k; i++) {
        cin >> monsters[i].first >> monsters[i].second.first >> monsters[i].second.second;
    }

    sort(monsters.begin(), monsters.end());
    int ans = -1000000000;
    int ind = -1;
    //cout << endl << endl << endl;

    for (int i = 0; i < n; i++) {
        int now = a[i].second * -1;
        while (ind + 1 < k && monsters[ind + 1].first < a[i].first) {

            int now_b = monsters[ind + 1].second.first;
            int cost = monsters[ind + 1].second.second;

            if (bb.back() < now_b) {
                continue;
            }

            auto kek = lower_bound(bb.begin(), bb.end(), now_b + 1);


            int ind_b = (kek - bb.begin());

            //cout << "INDS " << now_b << " " << ind_b << " " << cost << endl;
            bc[ind_b] += cost;
            //cout << "START\n";cout << "DO ";
            //print(0, 0, m);
            //cout << endl;

            update(0, ind_b, m, 0, m, cost);

            ind++;//cout << "DO ";
            //print(0, 0, m);
            //cout << endl;

            //cout << "ENDL\n";
        }
        //cout << "DO ";
        //print(0, 0, m);
        //cout << endl;
        push(0, 0, m);

        //for (int j = 0; j < m; j++) {
            //cout << bc[j] << " ";
        //}
        //cout << endl;
        //cout << "MIN " << t[0].first << endl;
        ans = max(ans, t[0].first + now);
    }

    //cout << endl;

    //cout << ind + 1 << " " << k << endl;
    cout << ans;




    return 0;
}

