#include <bits/stdc++.h>

#define ll long long
#define ull unsigned long long

using namespace std;

inline void fast() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int ans = 0;
unordered_set <string> xxx;

struct el {
    char val;
    el *next, *prev;
};

void print(el *head) {
    while (head != nullptr) {
        cout << head -> val;
        head = head -> next;
    }
    cout << '\n';
}

string to_str(el *head) {
    string s = "";
    while (head != nullptr) {
        s.push_back(head -> val);
        head = head -> next;
    }
    return s;
}

el *head, *tail;

void del(el *now) {
    now -> prev -> next = now -> next;
    now -> next -> prev = now -> prev;
}

void reg(el *now) {
    now -> prev -> next = now;
    now -> next -> prev = now;
}

void func(int count) {
    //print(head);
    ans = max(ans, count);

    el *now;
    now = head -> next;

    string s;
    while (now != tail) {
        if (now -> val - now -> prev -> val == 1 || now -> val - now -> next -> val == 1) {
            del(now);
            s = to_str(head);
            if (xxx.find(s) == xxx.end()) {
                xxx.insert(s);
                func(count + 1);
            }
            reg(now);
        }
        now = now -> next;
    }
}

int main() {
    fast();

    //freopen("../input", "r", stdin);

    int n;
    cin >> n;

    head = tail = new el;
    head -> prev = nullptr;

    cin >> head -> val;
    tail -> next = new el;
    tail = tail -> next;
    tail -> val = head -> val;
    tail -> prev = head;

    for (int i = 1; i < n; ++i) {
        tail -> next = new el;
        tail -> next -> prev = tail;
        tail = tail -> next;
        //tail -> val = static_cast<char>(cin.get());
        cin >> tail -> val;
    }
    tail -> next = new el;
    tail -> next -> prev = tail;
    tail = tail -> next;
    tail -> next = nullptr;
    tail -> val = tail -> prev -> val;

    func(0);

    cout << ans;

    return 0;
}
