#include <iostream>
#include <vector>
#include <string>

using namespace std;

string a;


struct seg
{
    int len, left, right;
};


seg rec(int L, int R)
{
    int n = a.size();
    seg result = {0, R, L};
    if (L == R - 1) return result;
    result = {1000 * 1000 * 1000, -1, -1};
    for (int i(L + 1); i < R; ++i)
    {
        seg f = rec(L, i);
        seg t = rec(i, R);
        if (a[i] - a[f.right] == 1 || a[i] - a[t.left] == 1)
        {
            seg new_res;
            new_res.len = f.len + t.len;
            if (f.left == i) new_res.left = t.left;
            else new_res.left = f.left;
            if (t.right == i) new_res.right = f.right;
            else new_res.right = t.right;
            if (new_res.len < result.len) swap(result, new_res);
        }
        else
        {
            seg new_res;
            new_res.len = f.len + t.len + 1;
            new_res.left = f.left;
            new_res.right = t.right;
            if (new_res.len < result.len) swap(result, new_res);
        }
    }
    return result;
}


int main()
{
    int n;
    cin >> n;
    cin >> a;
    a = 'z' + a + 'z';
    cout << n - rec(0, n + 1).len << endl;
    return 0;
}
