#include <iostream>
#include <vector>
#define int long long

using namespace std;


struct edge
{
    int to;
    bool can_closest, not_can_closest;
};


int32_t main()
{
    int n, m;
    cin >> n >> m;
    vector<vector<edge>> g(n);
    vector<vector<edge>> gr(n);
    for (int i(0); i < m; ++i)
    {
        int f, t;
        cin >> f >> t;
        f--;
        t--;
        g[f].push_back({t, false, false});
        gr[t].push_back({f, false, false});
    }
    int k;
    cin >> k;
    vector<int> a(k);
    for (int i(0); i < k; ++i)
    {
        cin >> a[i];
        a[i]--;
    }
    vector<pair<int, int>> q;
    q.push_back({a[k - 1], 0});
    int qs = 1;
    int u = 0;
    vector<bool> used(n);
    used[a[k - 1]] = true;
    vector<int> ras(n);
    while (u != qs)
    {
        pair<int, int> top = q[u];
        u++;
        int v = top.first;
        int len = top.second;
        ras[v] = len;
        len++;
        for (edge i: gr[v])
        {
            if (!used[i.to])
            {
                used[i.to] = true;
                q.push_back({i.to, len});
                qs++;
            }
        }
    }
    int min_result = 0;
    int max_result = 0;
    for (int z(0); z < k - 1; ++z)
    {
        int v = a[z];
        int kp_to = -1;
        int kp_not_to = 1000 * 1000 * 1000;
        for (edge i: g[v])
        {
            if (i.to == a[z + 1]) kp_to = ras[i.to];
            else kp_not_to = min(kp_not_to, ras[i.to]);
        }
        if (kp_not_to != 1000 * 1000 * 1000)
        {
            if (kp_to == kp_not_to) max_result++;
            else if (kp_to > kp_not_to)
            {
                min_result++;
                max_result++;
            }
        }
    }
    cout << min_result << ' ' << max_result << endl;
    return 0;
}
