#include <iostream>
#include <vector>
#include <algorithm>
#define int long long

using namespace std;

int32_t main()
{
    int n, m, p;
    cin >> n >> m >> p;
    vector<int> attack(1000005, 1000 * 1000 * 1000);
    vector<int> defense(1000005, 1000 * 1000 * 1000);
    for (int i(0); i < n; ++i)
    {
        int a, ca;
        cin >> a >> ca;
        attack[a] = ca;
    }
    for (int i(0); i < m; ++i)
    {
        int b, cb;
        cin >> b >> cb;
        defense[b] = cb;
    }
    for (int i(1000003); i > -1; --i)
    {
        attack[i] = min(attack[i], attack[i + 1]);
        defense[i] = min(defense[i], defense[i + 1]);
    }
    vector<int> to_sort(p);
    for (int i(0); i < p; ++i)
    {
        int x, y, z;
        cin >> x >> y >> z;
        to_sort[i] = z - attack[x] - defense[y];
    }
    sort(to_sort.rbegin(), to_sort.rend());
    int result = 0;
    if (to_sort[0] < 0) cout << to_sort[0] << endl;
    else
    {
        for (int i(0); i < p; ++i)
        {
            if (to_sort[i] > 0) result += to_sort[i];
            else break;
        }
    }
    cout << result << endl;
    return 0;
}
