#include <bits/stdc++.h>
#define f  first
#define s second
#define pb push_back
#define mp make_pair
#define  all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

const ll INF = 1e9 + 7, MAXN = 1e5, pp = 32;
const ld EPS = 1e-9, PI = acos(-1);

using namespace std;

namespace in_out {
    template <typename T>
    istream & operator>> (istream & in, vector <T> & a) {
        for (auto & i : a)
            in >> i;
        return in;
    }

    template <typename T>
    ostream & operator<< (ostream & out, vector <T> & a) {
        for (auto & i : a)
            out << i << " ";
        return out;
    }

    template <typename T1, typename  T2>
    istream & operator>> (istream & in, pair <T1, T2> & a) {
        in >> a.f >> a.s;
        return in;
    }

    template <typename T1, typename  T2>
    ostream & operator<< (ostream & out, pair <T1, T2> & a) {
        out << a.f << ' ' << a.s << " ";
        return out;
    }
};

using namespace in_out;

/*vector <ll> zet(string & s) {
    ll n = s.size();
    vector <ll> z(n);
    ll l = 0, r = -1;
    for (ll i = 1; i < n; i++) {
        z[i] = max(0, min(z[i - l], r - i + 1));
        while (i + z[i] < n && s[i + z[i]] == s[z[i]])
            z[i]++;
        if (i + z[i] - 1 > r)
            r = i + z[i] - 1, l = i;
    }
    return z;
}*/

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    #ifdef DEBUG
        ifstream cin("in.txt");
        ofstream cout("out.txt");
    #endif

    ll n;
    cin >> n;
    vector <ll> a(n), b(n);
    cin >> a >> b;
    ll sum1 = 0, sum2 = 0;
    for (ll i = 0; i < n; i++) {
        if (a[i] == 1 && b[i] == 0)
            sum1++;
        else if (a[i] == 0 && b[i] == 1)
            sum2++;
    }

    if (sum1 == 0)
        return cout << -1, 0;

    ll l = 1, r = INF;
    while (r - l > 1) {
        ll m = (l + r) / 2;
        if (sum1 * m > sum2)
            r = m;
        else
            l = m;
    }
    cout << r;
    return 0;
}
