#include <bits/stdc++.h>
#define f  first
#define s second
#define pb push_back
#define mp make_pair
#define  all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

const ll INF = 1e9 + 7, MAXN = 1e5, pp = 32;
const ld EPS = 1e-9, PI = acos(-1);

using namespace std;

namespace in_out {
    template <typename T>
    istream & operator>> (istream & in, vector <T> & a) {
        for (auto & i : a)
            in >> i;
        return in;
    }

    template <typename T>
    ostream & operator<< (ostream & out, vector <T> & a) {
        for (auto & i : a)
            out << i << " ";
        return out;
    }

    template <typename T1, typename  T2>
    istream & operator>> (istream & in, pair <T1, T2> & a) {
        in >> a.f >> a.s;
        return in;
    }

    template <typename T1, typename  T2>
    ostream & operator<< (ostream & out, pair <T1, T2> & a) {
        out << a.f << ' ' << a.s << " ";
        return out;
    }
};

using namespace in_out;

/*vector <ll> zet(string & s) {
    ll n = s.size();
    vector <ll> z(n);
    ll l = 0, r = -1;
    for (ll i = 1; i < n; i++) {
        z[i] = max(0, min(z[i - l], r - i + 1));
        while (i + z[i] < n && s[i + z[i]] == s[z[i]])
            z[i]++;
        if (i + z[i] - 1 > r)
            r = i + z[i] - 1, l = i;
    }
    return z;
}*/

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    #ifdef DEBUG
        ifstream cin("in.txt");
        ofstream cout("out.txt");
    #endif

    int n;
    cin >> n;
    string s;
    cin >> s;

    vector <vector <string>> dp(n, vector <string> (n));
    for (int i = 0; i < n; i++)
        dp[i][i] = s[i];

    for (int len = 2; len <= n; len++) {
        for (int l = 0; l <= n - len; l++) {
            int r = l + len - 1;
            string tans; int sz = INF;
            for (int k = l; k <= r - 1; k++) {
                string s = dp[l][k];
                string t = dp[k + 1][r];
                reverse(all(t));

                while (t.size() && s.size() && abs(t.back() - s.back()) == 1)
                    if (t.back() > s.back())
                        t.pop_back();
                    else
                        s.pop_back();

                reverse(all(t));
                if (sz > s.size() + t.size())
                    sz = s.size(), tans = s + t;
            }
            dp[l][r] = tans;
        }
    }

    cout << s.size() - dp[0][n - 1].size();

    return 0;
}
