#include <bits/stdc++.h>
#define f  first
#define s second
#define pb push_back
#define mp make_pair
#define  all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

const ll INF = 1e9 + 7, MAXN = 1e5, pp = 32;
const ld EPS = 1e-9, PI = acos(-1);

using namespace std;

namespace in_out {
    template <typename T>
    istream & operator>> (istream & in, vector <T> & a) {
        for (auto & i : a)
            in >> i;
        return in;
    }

    template <typename T>
    ostream & operator<< (ostream & out, vector <T> & a) {
        for (auto & i : a)
            out << i << " ";
        return out;
    }

    template <typename T1, typename  T2>
    istream & operator>> (istream & in, pair <T1, T2> & a) {
        in >> a.f >> a.s;
        return in;
    }

    template <typename T1, typename  T2>
    ostream & operator<< (ostream & out, pair <T1, T2> & a) {
        out << a.f << ' ' << a.s << " ";
        return out;
    }
};

using namespace in_out;

/*vector <ll> zet(string & s) {
    ll n = s.size();
    vector <ll> z(n);
    ll l = 0, r = -1;
    for (ll i = 1; i < n; i++) {
        z[i] = max(0, min(z[i - l], r - i + 1));
        while (i + z[i] < n && s[i + z[i]] == s[z[i]])
            z[i]++;
        if (i + z[i] - 1 > r)
            r = i + z[i] - 1, l = i;
    }
    return z;
}*/

vector <vector <int>> g, gr;
vector <int> d;

void bfs(int st) {
    d[st] = 0;
    queue <int> q;
    q.push(st);
    while (q.size()) {
        int v = q.front();
        q.pop();

        for (auto & i : gr[v])
            if (d[i] > d[v] + 1) {
                d[i] = d[v] + 1;
                q.push(i);
            }
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    #ifdef DEBUG
        ifstream cin("in.txt");
        ofstream cout("out.txt");
    #endif

    int n, m;
    cin >> n >> m;

    g.resize(n);
    gr.resize(n);
    d.resize(n, INF);
    for (int i = 0; i < m; i++) {
        int v, u;
        cin >> v >> u;
        v--; u--;
        g[v].pb(u);
        gr[u].pb(v);
    }

    int k;
    cin >> k;
    vector <int> a(k);
    cin >> a;
    for (auto & i : a)
        i--;

    bfs(a.back());
    int ans1 = 0, ans2 = 0;
    for (int i = 0; i < a.size() - 1; i++) {
        bool f1 = 0, f2 = 0;
        for (auto & j : g[a[i]]) {
            f1 |= (j == a[i + 1] && d[a[i]] == d[j] + 1);
            f2 |= (j != a[i + 1] && d[a[i]] == d[j] + 1);
        }

        ans1 += !f1;
        ans2 += f2;
    }

    cout << ans1 << " " << ans2 << endl;
    return 0;
}
