#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES

#pragma GCC optimize("Ofast")

#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <iomanip>
#include <math.h>
#include <algorithm>
#include <bitset>
#include <bitset>
//#include <clock>
#include <random>
#include <unordered_set>
#include <unordered_map>
#include <deque>

#define pb push_back
#define mp make_pair
#define all(x) x.begin(), x.end()
#define nn '\n'
#define pp ' '

using namespace std;

typedef long long ll;
typedef long double ld;

template<typename T>
bool uax(T &a, T b){
	if (b > a){
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool uin(T &a, T b){
	if (b < a){
		a = b;
		return true;
	}
	return false;
}

template <typename T>
void debug(string name, T val){
	cout << name << " = " << val << nn;
}
#define value(x) debug(#x, x);

mt19937 rnd(1928);

const int N = 2e5 + 7;

int n, m, k;
int pt[N];
vector<int> g[N];
bool mng[N];
int st, fn;
bool used[N];
int d[N];

void bfs(int st){
	queue<int> q;
	used[st] = true;
	d[st] = 0;
	q.push(st);
	while (!q.empty()){
		int v = q.front();
		q.pop();
		for (int i = 0; i < g[v].size(); i++){
			int to = g[v][i];
			if (!used[to]){
				used[to] = true;
				d[to] = d[v] + 1;
				q.push(to);
			}
			else {
				if (d[to] == d[v] + 1) {
					mng[to] = true;
				}
			}
		}
	}
}

int main(){
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else 
	ios_base::sync_with_stdio(false);
	cin.tie(0);
#endif
	cout << fixed << setprecision(15);
	cin >> n >> m;
	int x, y;
	for (int i = 0; i < m; i++){
		cin >> x >> y;
		x--; y--;
		g[y].pb(x);
	}
	cin >> k;
	for (int i = 0; i < k; i++){
		cin >> pt[i];
		pt[i]--;
	}
	st = pt[0];
	fn = pt[k - 1];
	bfs(fn);
	int mn = 0, mx = 0;
	for (int i = 0; i < k - 1; i++){
		int fr = pt[i];
		int to = pt[i + 1];
		if (d[to] + 1 == d[fr]){
			if (mng[fr]){
				mx++;
			}
			else {
				/*mx++;
				mn++;*/
			}
		}
		else{
			mn++;
			mx++;
		}
	}
	cout << mn << pp << mx;
}