#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES

#pragma GCC optimize("Ofast")

#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <iomanip>
#include <math.h>
#include <algorithm>
#include <bitset>
#include <bitset>
//#include <clock>
#include <random>
#include <unordered_set>
#include <unordered_map>
#include <deque>

#define pb push_back
#define mp make_pair
#define all(x) x.begin(), x.end()
#define nn '\n'
#define pp ' '

using namespace std;

typedef long long ll;
typedef long double ld;

template<typename T>
bool uax(T &a, T b){
	if (b > a){
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool uin(T &a, T b){
	if (b < a){
		a = b;
		return true;
	}
	return false;
}

template <typename T>
void debug(string name, T val){
	cout << name << " = " << val << nn;
}
#define value(x) debug(#x, x);

mt19937 rnd(1928);

struct Mon{
	ll x, z, y;
	Mon(){};
	void in(){
		cin >> x >> y >> z;
	}
	bool operator<(Mon q) {
		return (x < q.x) || (x == q.x && y < q.y);
	}
};

const ll N = 2e5 + 7;
const ll INF = 1e18 + 7;

ll n, m, p;
pair<ll, ll> a[N], b[N];
Mon c[N];

ll t[4 * N];
ll upd[4 * N];

void push(ll v){
	if (upd[v] == 0) return;
	t[v] += upd[v];
	if (v * 2 + 1 < 4 * N) upd[v * 2 + 1] += upd[v];
	if (v * 2 + 2 < 4 * N) upd[v * 2 + 2] += upd[v];
	upd[v] = 0;
}

void build(ll v, ll tl, ll tr){
	if (tl == tr){
		t[v] = -b[tl].second;
		return;
	}
	ll m = (tl + tr) / 2;
	build(v * 2 + 1, tl, m);
	build(v * 2 + 2, m + 1, tr);
	t[v] = max(t[v * 2 + 1], t[v * 2 + 2]);
}

void upt(ll v, ll tl, ll tr, ll l, ll r, ll del){
	push(v);
	if (l > r) return;
	if (tl == l && tr == r){
		upd[v] += del;
		push(v);
		return;
	}
	ll m = (tl + tr) / 2;
	upt(v * 2 + 1, tl, m, l, min(m, r), del);
	upt(v * 2 + 2, m + 1, tr, max(l, m + 1), r, del);
	t[v] = max(t[v * 2 + 1], t[v * 2 +2]);
}

void addm(Mon r){
	ll ind = upper_bound(b, b + m, mp(r.y, INF)) - b;
	if (ind == m) return;
	upt(0, 0, m - 1, ind, m - 1, r.z);
}

int main(){
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else 
	ios_base::sync_with_stdio(false);
	cin.tie(0);
#endif
	cout << fixed << setprecision(15);
	cin >> n >> m >> p;
	for (ll i = 0; i < n; i++){
		cin >> a[i].first >> a[i].second;
	}
	for (ll i = 0; i < m; i++){
		cin >> b[i].first >> b[i].second;
	}
	for (ll i = 0; i < p; i++){
		c[i].in();
	}
	sort(a, a + n);
	sort(b, b + m);
	sort(c, c + p);
	build(0, 0,m - 1);
	ll ind  = 0;
	ll ans = -INF;
	for (ll i = 0; i < n; i++){
		while (ind < p && a[i].first > c[ind].x){
			addm(c[ind]);
			ind++;
		}
		push(0);
		uax(ans, ll(-a[i].second) + t[0]);
	}
	cout << ans;
}