#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

#define f first
#define s second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define len(x) ((int)x.size())

using namespace std;

namespace IOF {
    #define UNIT template <typename T>
    UNIT istream &operator >>(istream &inp, vector <T> &a) {
        for (auto &el : a)
            inp >> el;
        return inp;
    }
    UNIT ostream &operator <<(ostream &out, vector <T> &a) {
        for (auto &el : a)
            out << el << ' ';
        return out;
    }
}

using namespace IOF;

/**void my_file_in_out() {
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
}*/

signed main()
{
    ios::sync_with_stdio(0);
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int n;
    cin >> n;
    vector <int> a(n);
    vector <int> b(n);

    for (int i = 0; i < n; i++)
        cin >> a[i];
    for (int i = 0; i < n; i++)
        cin >> b[i];

    if (a == b)
        return cout << -1, 0;

    vector <int> p = a;
    vector <int> q = b;

    for (int i = 0; i < n; i++) {
        if (b[i] == 1)
            p[i] = 0;
        if (a[i] == 1)
            q[i] = 0;
    }

    int sum1 = 0;
    int sum2 = 0;
    for (int i = 0; i < n; i++) {
        sum1 += p[i];
        sum2 += q[i];
    }

    if (sum1 == 0)
        return cout << -1, 0;

    if (sum1 > sum2)
        return cout << 1, 0;

    int d = sum2 - sum1 + 1;

    cout << (d + 2 * sum1 - 1) / sum1;

    return 0;
}
