#include "bits/stdc++.h"

#define pb push_back
#define mp make_pair
#define mt make_tuple
#define le(v) ((int)v.size())
#define x first
#define y second

using namespace std;

template<class T>
istream &operator>>(istream &is, vector<T> &v) {
	for (T &x : v) is >> x;
	return is;
}

template<class A, class B>
istream &operator>>(istream &is, pair<A, B> &pp) {
	is >> pp.x >> pp.y;
	return is;
}

template<class T>
ostream &operator<<(ostream &os, const vector<T> &v) {
	for (const T &x : v) os << x << " ";
	os << "\n";
	return os;
}

template<class A, class B>
ostream &operator<<(ostream &os, const pair<A, B> &pp) {
	os << pp.x << " " << pp.y;
	return os;
}

typedef long long ll;
typedef pair<int, int> pii;
typedef long double ld;

string s;
int mem[120][120];
int dp(int l, int r) {
	if (mem[l][r] != -1) return mem[l][r];
	if (l == r) return 0;
	int rez = 0;
	if (l + 1 == r) {
		int k = l; int t = 0;
			if ((l - 1 >= 0 && s[l - 1] + 1 == s[k])
				|| (r < le(s) && s[r] + 1 == s[k]))
				t++;
		return t;
	} else {
		for (int k = l; k < r; k++) {
			int A = dp(l, k); int B = dp(k + 1, r);
			int t = A + B;

			if ((l - 1 >= 0 && s[l - 1] + 1 == s[k])
				|| (r < le(s) && s[r] + 1 == s[k]))
				if (A == k - l && B == r - k - 1)
					t++;
			rez = max(rez, t);
		}
	}
	return mem[l][r] = rez;
}

void run() {
	memset(mem, -1, sizeof mem);
	int n; cin >> n;
	cin >> s;
	cout << dp(0, le(s));
}

signed main() {
	ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
	// freopen("test.in", "r", stdin);
	run();
}