#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define ll long long
#define ull unsigned long long
#define fi first
#define se second
#define ld long double

template<class T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

const int MAXN = 200005;

ll tr[MAXN*4], psh[MAXN*4], dat[MAXN];

void Build(int l, int r, int v)
{
    psh[v] = 0;
    if(l == r)
    {
        tr[v] = dat[l];
        return;
    }
    int m = (l+r) / 2;
    Build(l, m, v*2);
    Build(m+1, r, v*2+1);
    tr[v] = max(tr[v*2], tr[v*2+1]);
}

void push(int v, int l, int r)
{
    if(!psh[v])
        return;
        tr[v] += psh[v];
    if(l != r)
    {
        psh[v*2] += psh[v];
        psh[v*2+1] += psh[v];
    }
    psh[v] = 0;
}

ll Max(int l, int r, int L, int R, int v)
{
    if(l >= L && r <= R)
    {
        push(v, l, r);
        return tr[v];
    }
    push(v, l, r);
    if(l > R || r < L)
        return -1e18;
        int m = (l+r) / 2;
    return max(Max(l, m, L, R, v*2), Max(m+1, r, L, R, v*2+1));
}

void Add(int l, int r, int L, int R, int v, ll x)
{
    if(l >= L && r <= R)
    {
        psh[v] += x;
        push(v, l, r);
        return;
    }
    push(v, l, r);
    if(l > R || r < L)
        return;
    int m = (l+r) / 2;
    Add(l, m, L, R, v*2, x);
    Add(m+1, r, L, R, v*2+1, x);
    tr[v] = max(tr[v*2], tr[v*2+1]);
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int n, m, p; cin >> n >> m >> p;
    vector<pair<ll, ll> > A, B;
    for(int i = 0; i < n; i++)
    {
        ll a, ca; cin >> a >> ca;
        A.push_back({a, ca});
    }
    for(int i = 0; i < m; i++)
    {
        ll b, cb; cin >> b >> cb;
        B.push_back({b, cb});
    }
    sort(A.begin(), A.end());
    sort(B.begin(), B.end());
    for(int i = 0; i < n; i++)
    {
        dat[i] = -A[i].se;
    }
    Build(0, n-1, 1);
    vector<pair<ll, pair<ll, ll> > > g;
    for(int i = 0; i < p; i++)
    {
        ll x, y, z; cin >> x >> y >> z;
        g.push_back({y, {x, z}});
    }
    sort(g.begin(), g.end());
    int ind = 0;
    ll ans = -1e18;
//    cout << Max(0, n-1, 0, n-1, 1) << '\n';
    for(int i = 0; i < p; i++)
    {
            while(ind < m && B[ind].fi <= g[i].fi)
            {
                ans = max(ans, Max(0, n-1, 0, n-1, 1) - B[ind].se);
                ind++;
            }
        int l = 0, r = n;
        while(l != r)
        {
            int mid = (l+r) / 2;
            if(A[mid].fi > g[i].se.fi)
            {
                r = mid;
            }
                else l = mid+1;
        }
        Add(0, n-1, l, n-1, 1, g[i].se.se);
//        cout << Max(0, n-1, 0, n-1, 1) << '\n';

    }
    while(ind < m)
    {
        ans = max(ans, Max(0, n-1, 0, n-1, 1) - B[ind].se);
        ind++;
    }
    cout << ans;

}




















/// Slava Ykraine
/// YA KAZINAK_1488 ETO KYC
