#include <bits/stdc++.h>

using namespace std;
#pragma GCC optimize("Ofast")
#define get(x) cout << #x << " : " << x << endl;
#define int long long
const int MAX = (int)4e5 + 10;
const int INF = (int)1e9 + 9;

void fast() {
    ios::sync_with_stdio(false);
    cin.tie(0);
}

const int MAXT = (int)1e5;
int t[8 * MAXT], b[MAXT];

void build(int v, int lv, int rv) {
    if (lv == rv) {
        t[v] = b[lv];
        return;
    }
    int m = (lv + rv) >> 1;
    build((v << 1) + 1, lv, m);
    build((v << 1) + 2, m + 1, rv);
    t[v] = t[(v << 1) + 1] + t[(v << 1) + 2];
}

int gcd(int a, int b) {
    return b ? gcd(b, a % b) : a;
}

int lcm(int a, int b) {
    return a / gcd(a, b) * b;
}

int f(int x) {
    return x;
}

int binSearch(int l, int r, int x) {
    while (l + 1 != r) {
        int m = r - ((r - l) >> 1);
        if (f(m) > x) l = m;
        else r = x;
    }
    return x;
}

int cnt[2 * MAX + 1];

signed main() {
    fast();
    int n;
    cin >> n;
    int ans = -INF;
    for (int i = 0; i < n; ++i) {
        int x;
        cin >> x;
        cnt[i - x + MAX] += x;
    }
    for (int i = 0; i <= 2 * MAX; ++i) {
        ans = max(ans, cnt[i]);
    }
    cout << ans;
    return 0;
}
