#include <bits/stdc++.h>

using namespace std;
#pragma GCC optimize("Ofast")
#define get(x) cout << #x << " : " << x << endl;
#define int long long
const int MAX = (int)1e3;
const int INF = (int)1e9 + 9;

void fast() {
    ios::sync_with_stdio(false);
    cin.tie(0);
}

struct data {
    int l, r;
    int sum;
    int maxpref, maxsuf;
    int pref, suf;
};

data t[4 * MAX + 100];
//int g[MAX + 100];
pair<int, int> b[MAX];

/*void build(int v, int lv, int rv) {
    t[v].r = lv;
    t[v].l = t[v].r + 1;
    t[v].sum = 0;
    if (lv == rv) {
        g[b[lv]] = -b[lv];
        return;
    }
    int m = (lv + rv) >> 1;
    build((v << 1) + 1, lv, m);
    build((v << 1) + 2, m + 1, rv);
}*/

void update(int v, int lv, int rv, int id, int nVal) {
    assert(lv <= rv);
    if (lv == rv) {
        assert(lv == id);
        t[v].l = t[v].r = lv;
        t[v].sum = t[v].maxpref = t[v].maxsuf = nVal;
        return;
    }
    int m = (lv + rv) >> 1;
    if (id <= m) update((v << 1) + 1, lv, m, id, nVal);
    else update((v << 1) + 2, m + 1, rv, id, nVal);
    int lid = (v << 1) + 1, rid = (v << 1) + 2;
    t[v] = t[lid];
    if (t[v].sum < t[lid].maxsuf + t[rid].maxpref) {
        t[v].sum = t[lid].maxsuf + t[rid].maxpref;
        t[v].l = t[lid].suf;
        t[v].r = t[rid].pref;
        t[v].maxpref = t[lid].maxpref + (t[lid].pref == m ? t[rid].pref : 0);
        t[v].maxsuf = t[rid].maxsuf + (t[rid].suf == m + 1 ? t[lid].suf : 0);
        t[v].pref = t[lid].pref;
        t[v].suf = t[rid].suf;
    }
    if (t[v].sum < t[rid].sum) t[v] = t[rid];
}


signed main() {
    fast();
    int n, m, p;
    cin >> n >> m >> p;
    pair<int, int> a[n];
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first >> a[i].second;
    }
    for (int i = 0; i < m; ++i) {
        cin >> b[i].first >> b[i].second;
        update(0, 0, MAX, b[i].first, -b[i].second);
    }
    pair<pair<int, int>, int> monster[p];
    for (int i = 0; i < p; ++i) {
        cin >> monster[i].first.first >> monster[i].first.second >> monster[i].second;
    }
    sort(monster, monster + p);
    int itMon = 0;
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        int am = a[i].first;
        int profit = -a[i].second;
        while (itMon < p && monster[itMon].first.first < am) {
            update(0, 0, MAX, monster[itMon].first.second, monster[itMon].second);
            ++itMon;
        }
        ans = max(ans, profit + t[0].sum);
    }
    cout << ans;
    return 0;
}
