#include <bits/stdc++.h>

#define ll long long
#define pii pair<int, int>

using namespace std;

const int N = 1e5 * 2 + 1;
const ll INF = 1e18 + 1;

vector<int> g[N];
vector<int> g1[N];
bool used[N];
pii best[N];

int main()
{

    cin.tie(0);
    ios::sync_with_stdio(false);

    fill(used, used + N, false);
    fill(best, best + N, make_pair(0, 0));
    for (int i = 0; i < N; ++i) {
        g[i].clear();
        g1[i].clear();
    }

    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        g[u-1].push_back(v-1);
        g1[v-1].push_back(u-1);
    }
    int k;
    cin >> k;
    vector<int> arr(k);
    for (int i = 0; i < k; ++i) {
        cin >> arr[i];
        arr[i]--;
    }
    int s = arr[0];
    int f = arr[k-1];

    queue<int> q;
    q.push(f);
    used[f] = true;
    best[f].second = 0;
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (int u : g1[v]) {
            if (!used[u]) {
                best[u].second = best[v].second + 1;
                best[u].first = 1;
                used[u] = true;
                q.push(u);
            }
            else if (best[u].second == best[v].second + 1) {
                best[u].first++;
            }
        }
    }
    int mn = 0;
    int mx = 0;
    for (int i = 0; i < k - 1; ++i) {
        int v = arr[i];
        int l = best[v].second;
        bool my = false;
        bool other = false;
        for (int u : g[v]) {
            if (best[u].second == l - 1) {
                if (u == arr[i + 1]) {
                    my = true;
                }
                else {
                    other = true;
                }
            }
        }
        if (my && other) {
            ++mx;
        }
        else if (!my && other) {
            mn++;
            mx++;
        }
    }

    cout << mn << " " << mx << endl;

    return 0;
}
