#include "bits/stdc++.h"
using namespace std;
#define ll long long
#define w while
#define elif else if
#define con continue
#define br break
#define ld long double
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define forn(a) for (ll i = 0; i < a; i++)
#define prec(a) fixed << setprecision(a)
#define INF 1000000000000000000
#define inf 1000000000
#define eps 1e-4
#define EPS 1e-8
#define MOD 1000000007

const ll hp1 = 359657;
const ll hm1 = 1000000007;
const ll hp2 = 307;
const ll hm2 = 1000000009;

pair <vector <ll>, vector <ll>> phash(const string &s, ll p, ll m) {
    vector <ll> ans(s.size() + 1, 0);
    vector <ll> ppow(s.size() + 1, 1);
    for (ll i = 0; i < s.size(); i++) {
        ans[i + 1] = (s[i] + ans[i] * p) % m;
        ppow[i + 1] = (ppow[i] * p) % m;
    }
    return {ans , ppow};
}

ll substrhash(pair <vector <ll>, vector <ll>> hash, ll fi, ll la, ll m) {
    return (hash.first[la + 1] - hash.first[fi] * hash.second[la - fi] + m * m) % m;
}

vector <ll> zfu(const string &s) {
    vector <ll> z(s.size(), 0);
    ll l = 0, r = 0;
    for (ll i = 1; i < s.size(); i++) {
        z[i] = max(0ll, min(r - i, z[i - l]));
        w(i + z[i] < s.size() && s[z[i]] == s[z[i] + i])
            z[i]++;
        if (i + z[i] > r) {
            l = i;
            r = i + z[i];
        }
    }
    z[0] = s.size();
    return z;
}

ll binpow(ll a, ll n, ll m) {
    if (n == 0)
        return 1;
    if (n % 2) {
        return (binpow(a, n - 1, m) * a) % m;
    } else {
        ll b = binpow(a, n / 2, m);
        return (b * b) % m;
    }
}

ll binpow(ll a, ll n) {
    if (n == 0)
        return 1;
    if (n % 2) {
        return (binpow(a, n - 1) * a);
    } else {
        ll b = binpow(a, n / 2);
        return (b * b);
    }
}

ll gcd(ll a, ll b) {
    return a ? gcd(b % a, a) : b;
}

bool in(set <ll> aaa, set <ll> bbb) {
    for (auto i : aaa) {
        if (bbb.find(i) == bbb.end())
            return 0;
    }
    return 1;
}

ll delta(set <ll> aaa, set <ll> bbb) {
    ll su = 0;
    for (auto i : aaa) {
        if (bbb.find(i) == bbb.end()) {
            su++;
        }
    }
    return su;
}

signed main() {
    ll n, aa = 0, bb = 0;
    cin >> n;
    vector <ll> a(n), b(n);
    set <ll> aaa, bbb;
    forn(n) {
        cin >> a[i];
        if (a[i]) {
            aa++;
            aaa.insert(i);
        }
    }
    forn(n) {
        cin >> b[i];
        if (b[i]) {
            bb++;
            bbb.insert(i);
        }
    }
    if (in(aaa, bbb)) {
        cout << -1;
    } else {
        ll d = delta(aaa, bbb);
        if (delta == 0 || aa > bb) {
            cout << 1;
        } else {
            cout << (bb - aa + 1) / d + (ll)(bool)((bb - aa + 1) % d) + 1;
        }
    }
    return 0;
}
