#include "bits/stdc++.h"
using namespace std;
#define ll long long
#define w while
#define elif else if
#define con continue
#define br break
#define ld long double
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define forn(a) for (ll i = 0; i < a; i++)
#define prec(a) fixed << setprecision(a)
#define INF 1000000000000000000
#define inf 1000000000
#define eps 1e-4
#define EPS 1e-8
#define MOD 1000000007

const ll hp1 = 359657;
const ll hm1 = 1000000007;
const ll hp2 = 307;
const ll hm2 = 1000000009;

pair <vector <ll>, vector <ll>> phash(const string &s, ll p, ll m) {
    vector <ll> ans(s.size() + 1, 0);
    vector <ll> ppow(s.size() + 1, 1);
    for (ll i = 0; i < s.size(); i++) {
        ans[i + 1] = (s[i] + ans[i] * p) % m;
        ppow[i + 1] = (ppow[i] * p) % m;
    }
    return {ans , ppow};
}

ll substrhash(pair <vector <ll>, vector <ll>> hash, ll fi, ll la, ll m) {
    return (hash.first[la + 1] - hash.first[fi] * hash.second[la - fi] + m * m) % m;
}

vector <ll> zfu(const string &s) {
    vector <ll> z(s.size(), 0);
    ll l = 0, r = 0;
    for (ll i = 1; i < s.size(); i++) {
        z[i] = max(0ll, min(r - i, z[i - l]));
        w(i + z[i] < s.size() && s[z[i]] == s[z[i] + i])
            z[i]++;
        if (i + z[i] > r) {
            l = i;
            r = i + z[i];
        }
    }
    z[0] = s.size();
    return z;
}

ll binpow(ll a, ll n, ll m) {
    if (n == 0)
        return 1;
    if (n % 2) {
        return (binpow(a, n - 1, m) * a) % m;
    } else {
        ll b = binpow(a, n / 2, m);
        return (b * b) % m;
    }
}

ll binpow(ll a, ll n) {
    if (n == 0)
        return 1;
    if (n % 2) {
        return (binpow(a, n - 1) * a);
    } else {
        ll b = binpow(a, n / 2);
        return (b * b);
    }
}

ll gcd(ll a, ll b) {
    return a ? gcd(b % a, a) : b;
}

bool in(set <ll> aaa, set <ll> bbb) {
    for (auto i : aaa) {
        if (bbb.find(i) == bbb.end())
            return 0;
    }
    return 1;
}

ll delta(set <ll> aaa, set <ll> bbb) {
    ll su = 0;
    for (auto i : aaa) {
        if (bbb.find(i) == bbb.end()) {
            su++;
        }
    }
    return su;
}

string deleter(string a, ll m) {
    string neww;
    for (ll i = 0; i < m; i++) {
        neww += a[i];
    }
    for (ll i = m + 1; i < a.size(); i++) {
        neww += a[i];
    }
    return neww;
}

vector <vector <ll>> g, gr;
vector <pair <bool, bool>> expaths;
vector <ll> pa;
vector <ll> dpth;

signed main() {
    ll n, m, a, b, k;
    cin >> n >> m;
    dpth.resize(n + 1, inf);
    expaths.resize(n + 1);
    g.resize(n + 1);
    gr.resize(n + 1);
    forn(m) {
        cin >> a >> b;
        gr[b].push_back(a);
        g[a].push_back(b);
    }
    cin >> k;
    pa.resize(k);
    vector <ll> nxt(n + 1);
    nxt[pa[0]] = -1;
    forn(k) {
        cin >> pa[i];
        if (i != 0) {
            nxt[pa[i - 1]] = pa[i];
            nxt[pa[i]] = -1;
        }
    }
    nxt[0] = pa[0];

    queue <pair <pair <ll, ll>, ll>> bfs;
    ll d;
    bfs.push({{pa.back(), 0}, 0});
    w(bfs.size()) {
        pair <ll, ll> v = bfs.front().first;
        ll d = bfs.front().second;
        bfs.pop();
        if (dpth[v.first] < d)
            con;
        elif(dpth[v.first] > d) {
            dpth[v.first] = d;
            expaths[v.first] = {0, 0};
            if (v.second == nxt[v.first])
                expaths[v.first].first = 1;
            else
                expaths[v.first].second = 1;
        } else {
                if (v.second == nxt[v.first])
                    expaths[v.first].first = 1;
                else
                    expaths[v.first].second = 1;
        }
        for (auto ii : gr[v.first]) {
            bfs.push({{ii, v.first}, d + 1});
        }
    }
    ll mx = 0, mn = 0;
    for (ll i = 0; i < pa.size() - 1; i++) {
        if (!expaths[pa[i]].first)
            mn++;
        if (expaths[pa[i]].second)
            mx++;
    }
    cout << mn << " " << mx;
    return 0;
}
