#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <deque>
#include <random>

using namespace std;

const int INF = 1e9+1;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    //freopen("input.txt","r",stdin);
    //freopen("output.txt","w",stdout);
    long long n;
    cin >> n;
    vector<long long>b(n);
    for(long long i = 0;i<n;++i){
        cin >> b[i];
    }
    vector <long long> razn(n);
    for(long long i = 0;i<n;++i){
        razn[i] = i+1-b[i];
    }
    map<long long,long long> mp;
    for(long long i = 0;i<n;++i){
        mp[razn[i]]+=b[i];
    }
    long long max_ans = 0;
    long long ans = 0;
    for(auto el:mp){
        //cout << el.first << " " << el.second << endl;
        if(el.second>max_ans){
            max_ans = el.second;
            ans = el.first;
        }
    }
    cout << max_ans << endl;
    /*int res = 0;
    for(int i = 0;i<n;++i){
        if(razn[i]==ans){
            res += b[i];
        }
    }
    cout << res << endl;*/
    return 0;
}
