#pragma GCC optimize("Ofast")

#include <bits/stdc++.h>

#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/detail/standard_policies.hpp>

#define F first
#define S second
#define pb push_back
#define lll long long
#define lld long double


using namespace std;

using namespace __gnu_pbds;

template < typename T >

using ordered_set = tree < T, null_type, less < T >, rb_tree_tag, tree_order_statistics_node_update>;

mt19937 gen(chrono::system_clock::now().time_since_epoch().count());

const int N = 3e5 + 232;
const int M = 1e9 + 7;
const int mod = 998244353;
const int rx[4] = {0, 0, -1, 1};
const int ry[4] = {-1, 1, 0, 0};
const lld eps = 1e-11;
const lld pi = acos(-1.0);

int n, m;

vector < int > g[N], rg[N];

int a[N];

int r[N];

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin >> n >> m;
    int x, y;
    for (int i = 0; i < m; ++i) {
        cin >> x >> y;
        --x;
        --y;
        g[x].pb(y);
        rg[y].pb(x);
    }
    int m;
    cin >> m;
    for (int i = 0; i < m; ++i) {
        cin >> a[i];
        --a[i];
    }
    for (int i = 0; i < n; ++i) {
        r[i] = 1e9;
    }
    r[a[m - 1]] = 0;
    queue < int > q;
    q.push(a[m - 1]);
    while (!q.empty()) {
        x = q.front();
        q.pop();
        for (auto to : rg[x]) {
            if (r[to] > r[x] + 1) {
                r[to] = r[x] + 1;
                q.push(to);
            }
        }
    }
    int ans = 0, add = 0;
    x = a[0];
    pair < int, int > best;
    bool f;
    for (int i = 0; i + 1 < m; ++i) {
        x = a[i];
        best = {1e9, 0};
        for (auto to : g[x]) {
            if (r[to] == best.F) {
                ++best.S;
            }
            if (r[to] < best.F) {
                best = {r[to], 1};
            }
        }
        f = 0;
        for (auto to : g[x]) {
            if (r[to] == best.F && to == a[i + 1]) {
                f = 1;
            }
        }
        if (!f) {
            ++ans;
        } else {
            if (best.S > 1) {
                ++add;
            }
        }
    }
    cout << ans << ' ' << ans + add;
    return 0;
}
