#pragma GCC optimize("Ofast")

#include <bits/stdc++.h>

#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/detail/standard_policies.hpp>

#define F first
#define S second
#define pb push_back
#define lll long long
#define lld long double


using namespace std;

using namespace __gnu_pbds;

template < typename T >

using ordered_set = tree < T, null_type, less < T >, rb_tree_tag, tree_order_statistics_node_update>;

mt19937 gen(chrono::system_clock::now().time_since_epoch().count());

const int N = 2e5 + 232;
const int M = 1e9 + 7;
const int mod = 998244353;
const int rx[4] = {0, 0, -1, 1};
const int ry[4] = {-1, 1, 0, 0};
const lld eps = 1e-11;
const lld pi = acos(-1.0);

pair < int, int > a[N];

pair < int, int > b[N];

pair < pair < int, int >, int > c[N];

vector < int > d, lazy;

void push(int v) {
    d[v * 2] += lazy[v];
    d[v * 2 + 1] += lazy[v];
    lazy[v * 2] += lazy[v];
    lazy[v * 2 + 1] += lazy[v];
    lazy[v] = 0;
}

void upd(int v, int l, int r, int cl, int cr, int x) {
    if (cl >= r || cr <= l) {
        return;
    }
    if (cl >= l && cr <= r) {
        d[v] += x;
        lazy[v] += x;
        return;
    }
    push(v);
    int mid = (cl + cr) / 2;
    upd(v * 2, l, r, cl, mid, x);
    upd(v * 2 + 1, l, r, mid, cr, x);
    d[v] = max(d[v * 2], d[v * 2 + 1]);
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n, m, k;
    cin >> n >> m >> k;
    for (int i = 0; i < n; ++i) {
        cin >> a[i].F >> a[i].S;
    }
    for (int i = 0; i < m; ++i) {
        cin >> b[i].F >> b[i].S;
    }
    for (int i = 0; i < k; ++i) {
        cin >> c[i].F.F >> c[i].F.S >> c[i].S;
    }
    sort(a, a + n);
    sort(b, b + m);
    sort(c, c + k);
    int st = 0;
    int sz = (int)(1e6) + 30;
    while ((1 << st) < sz) {
        ++st;
    }
    d.resize(1 << (st + 1), -1e9);
    lazy.resize(1 << (st + 1));
    for (int i = 0; i < m; ++i) {
        d[(1 << st) + b[i].F] = max(d[(1 << st) + b[i].F], -1 * b[i].S);
    }
    for (int i = (1 << st) - 1; i; --i) {
        d[i] = max(d[i * 2], d[i * 2 + 1]);
    }
    int ans = -2e9;
    int uk = 0;
    for (int i = 0; i < n; ++i) {
        while (uk < n && c[uk].F.F < a[i].F) {
            upd(1, c[uk].F.S + 1, sz, 0, 1 << st, c[uk].S);
            ++uk;
        }
        ans = max(ans, d[1] - a[i].S);
    }
    cout << ans;
    return 0;
}
