#include<bits/stdc++.h>

using namespace std;
#define f(n) for(int i = 0; i < n; i++)
#define fj(n) for(int j = 0; j < n; j++)
#define fk(n) for(int k = 0; k < n; k++)
#define pb push_back
#define eb emplace_back
#define all(a) a.begin(), a.end()
#define pri(a, n) for(int i = 0; i < n; i++) cout << a[i] << ' '; cout << '\n';
#define ic(n) int n; cin >> n;
#define con cout << '\n';

struct wp
{
    int v, c;
    wp(int _v = 0, int _c = 0) : v(_v), c(_c) {}
};
struct mns
{
    int x, y, z;
    mns(int _x = 0, int _y = 0, int _z = 0) : x(_x), y(_y), z(_z) {}
};
bool cmp(wp a, wp b)
{
    return a.v < b.v;
}
bool cmp2(mns a, mns b)
{
    return a.x < b.x;
}
const int maxn = 1000000, inf = 2e9;
class Tree
{
    int tree[4 * maxn], mod[4 * maxn];
public:
    void build(int a[], int v, int vl, int vr)
    {
        if(vr - vl == 1)
        {
            tree[v] = a[vl];
            mod[v] = 0;
            return;
        }
        int m = (vl + vr) >> 1;
        build(a, 2 * v + 1, vl, m);
        build(a, 2 * v + 2, m, vr);
        tree[v] = max(tree[2 * v + 1], tree[2 * v + 2]);
    }
    void push(int v)
    {
        mod[2 * v + 1] += mod[v];
        mod[2 * v + 2] += mod[v];
        tree[v] += mod[v];
        mod[v] = 0;
    }
    void upd(int v, int vl, int vr, int l, int r, int x)
    {
        push(v);
        if(vl >= l && vr <= r)
        {
            mod[v] += x;
            push(v);
            return;
        }
        if(vl >= r || vr <= l) return;
        int m = (vl + vr) >> 1;
        upd(2 * v + 1, vl, m, l, r, x);
        upd(2 * v + 2, m, vr, l, r, x);
        tree[v] = max(tree[2 * v + 1], tree[2 * v + 2]);
    }
    int get()
    {
        push(0);
        return tree[0];
    }
};
int main()
{
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    int n, m, k;
    cin >> n >> m >> k;
    wp ws[n];
    f(n) cin >> ws[i].v >> ws[i].c;
    Tree tr;
    int df[maxn];
    f(maxn) df[i] = -inf;
    f(m)
    {
        int v, c;
        cin >> v >> c;
        df[v - 1] = max(df[v - 1], -c);
    }
    tr.build(df, 0, 0, maxn);
    mns a[k];
    f(k)
    {
        cin >> a[i].x >> a[i].y >> a[i].z;
    }
    sort(ws, ws + n, cmp);
    sort(a, a + k, cmp2);
    int ans = -inf;
    int lm = -1;
    f(n)
    {
        while(lm + 1 < k && a[lm + 1].x < ws[i].v)
        {
            tr.upd(0, 0, maxn, a[lm + 1].y, maxn, a[lm + 1].z);
            lm++;
        }
        ans = max(ans, -ws[i].c + tr.get());
    }
    cout << ans;
}
