#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<vector>
#include<string>
#include<cmath>
#include<algorithm>
#include<time.h>
#include<set>
#include<map>
#include<iomanip>
#include<queue>
using namespace std;
typedef long long ll;
vector<vector<int>>rev;
vector<int>used, sz, col;
vector<int>nex;
void bfs(int t){
	queue<int>q;q.push(t);
	sz[t]=0;
	col[t] = 1;
	while(!q.empty()){
		int u = q.front(); q.pop();
		for(int i=0;i<rev[u].size();i++){
			int v = rev[u][i];
			if(sz[v]==-1){
				sz[v] = sz[u]+1;
				col[v] = 0;
				if(nex[v]==u){
					col[v]|=1;
				}
				else{
					col[v]|=2;
				}
				q.push(v);
			}else if(sz[v]==sz[u]+1){
				if(nex[v]==u){
					col[v]|=1;
				}
				else{
					col[v]|=2;
				}
			}
		}
	}
}

void solve(){
	int n, m; cin>>n>>m;	
	rev.resize(n);
	used.resize(n);
	sz.resize(n, -1);
	col.resize(n);
	for(int i=0;i<m;i++){
		int u, v; cin>>u>>v;u--;v--;		
		rev[v].push_back(u);
	}
	int k; cin>>k;
	vector<int>path(k);
	for(int i=0;i<k;i++){
		cin>>path[i]; path[i]--;
	}
	nex.resize(n, -1);
	for(int i=0;i<k-1;i++){
		nex[path[i]] = path[i+1];
	}
	bfs(path[k-1]);
	int mi = 0, ma = 0;
	for(int i=0;i<k - 1;i++){
		if((col[path[i]]&1)==0){
			mi++;ma++;
		}else if((col[path[i]]&2)==2){
			ma++;
		}

	}
	cout<<mi<<' '<<ma;
}

int main(){
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	solve();
}
