#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<vector>
#include<string>
#include<cmath>
#include<algorithm>
#include<time.h>
#include<set>
#include<map>
#include<iomanip>
#include<queue>
using namespace std;
typedef long long ll;
bool cmp(pair<ll, ll>a, pair<ll, ll>b){
	if(a.first==b.first)
		return a.second>b.second;
	return a.first<b.first;
}
vector<ll>tree;
void add(int x, int L, int R, int pos, ll w){
	if(L==R-1){
		tree[x]+=w;
		return;
	}
	int m = (L+R)/2;
	if(pos<m)
		add(2*x+1, L, m, pos, w);
	else
		add(2*x+2, m, R, pos, w);
}

ll get_sum(int x, int L, int R, int LL, int RR){
	if(LL>=RR)return 0;
	if(L==LL && R==RR)return tree[x];
	int m = (L+R)/2;
	return get_sum(2*x+1, L, m, LL, min(m, RR)) +
		get_sum(2*x+2, m, R, max(m, LL), RR);
}
bool cmp1(vector<ll>a, vector<ll>b){
	if(a[0]==b[0])
		return a[1]<b[1];
	return a[0]<b[0];
}

void solve(){
	int n, m, p ; cin>>n>>m>>p;
	vector<pair<ll, ll>>a(n), b(m);
	for(int i=0;i<n;i++){
		cin>>a[i].first>>a[i].second;
	}
	for(int i=0;i<m;i++){
		cin>>b[i].first>>b[i].second;
	}
	vector<vector<ll>>mas(p);
	for(int i=0;i<p;i++){
		mas[i].resize(3);
		cin>>mas[i][0]>>mas[i][1]>>mas[i][2];
	}
	sort(a.begin(), a.end(), cmp);
	sort(b.begin(), b.end(), cmp);
	for(int i=n-2;i>=0;i--){
		a[i].second = min(a[i].second, a[i+1].second);
	}
	for(int i=m-2;i>=0;i--){
		b[i].second = min(b[i].second, b[i+1].second);
	}
	tree.resize(4000000);
	sort(mas.begin(), mas.end(), cmp1);
	ll ans = -a[0].second - b[0].second;
	for(int i=0;i<p;i++){
		add(0, 0, 1000000, mas[i][1]-1, mas[i][2]);
		auto it1 = lower_bound(a.begin(), a.end(), make_pair(mas[i][0], -1ll));		
		auto it2 = lower_bound(b.begin(), b.end(), make_pair(mas[i][1], -1ll));
		if(it1==a.end() || it2==b.end())continue;
		ll u = -it1->second - it2->second + get_sum(0, 0, 1000000, 0, mas[i][1]);
		ans = max(ans, u);
	}
	cout<<ans;
}

int main(){
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	solve();
}
