#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<vector>
#include<string>
#include<cmath>
#include<algorithm>
#include<time.h>
#include<set>
#include<map>
#include<iomanip>
#include<queue>
using namespace std;
typedef long long ll;
bool cmp(pair<ll, ll>a, pair<ll, ll>b){
	if(a.first==b.first)
		return a.second>b.second;
	return a.first<b.first;
}
vector<pair<ll, ll>>tree;
void add(int x, int L, int R, int LL, int RR, ll w){
	if(LL>=RR)return;
	if(LL==L && RR==R){
		tree[x].first+=w;
		tree[x].second+=w;
		return;
	}
	int m = (L+R)/2;
	tree[2*x+1].second+=tree[x].second;
	tree[2*x+2].second+=tree[x].second;	
	tree[2*x+1].first+=tree[x].second;
	tree[2*x+2].first+=tree[x].second;
	tree[x].second=0;
	add(2*x+1, L, m, LL, min(RR, m), w);	
	add(2*x+2, m, R, max(LL, m), RR, w);	
	tree[x].first = max(tree[2*x+1].first, tree[2*x+2].first);
}

ll get_max(int x, int L, int R, int LL, int RR){
	if(LL>=RR)return -1000000000000000ll;
	if(L==LL && R==RR)return tree[x].first;
	int m = (L+R)/2;
	tree[2*x+1].second+=tree[x].second;
	tree[2*x+2].second+=tree[x].second;	
	tree[2*x+1].first+=tree[x].second;
	tree[2*x+2].first+=tree[x].second;
	tree[x].second=0;
	return max(get_max(2*x+1, L, m, LL, min(m, RR)),
		get_max(2*x+2, m, R, max(m, LL), RR));
}
bool cmp1(vector<ll>a, vector<ll>b){
	if(a[0]==b[0])
		return a[1]<b[1];
	return a[0]<b[0];
}

void solve(){
	int n, m, p; cin>>n>>m>>p;
	vector<pair<ll, ll>>a(n), b(m);
	for(int i=0;i<n;i++){
		cin>>a[i].first>>a[i].second;
	}
	for(int i=0;i<m;i++){
		cin>>b[i].first>>b[i].second;
	}
	vector<vector<ll>>mas(p);
	for(int i=0;i<p;i++){
		mas[i].resize(3);
		cin>>mas[i][0]>>mas[i][1]>>mas[i][2];
	}
	sort(a.begin(), a.end(), cmp);
	sort(b.begin(), b.end(), cmp);
	for(int i=n-2;i>=0;i--){
		a[i].second = min(a[i].second, a[i+1].second);
	}
	tree.resize(4000000, make_pair(-1000000000000000ll, 0));
	for(int i=0;i<m;i++){
		add(0, 0, 1000000, b[i].first-1, b[i].first, 1000000000000000ll-b[i].second);
	}	
	sort(mas.begin(), mas.end(), cmp1);
	ll ans = -a[0].second - b[0].second;
	for(int i=0;i<p;i++){		
		auto it1 = lower_bound(a.begin(), a.end(), make_pair(mas[i][0] + 1, -1ll));		
		auto it2 = lower_bound(b.begin(), b.end(), make_pair(mas[i][1] +1, -1ll));
		if(it1==a.end() || it2==b.end())continue;
		add(0, 0, 1000000, (it2->first) - 1, 1000000, mas[i][2]);
		ll u = -(it1->second) + get_max(0, 0, 1000000, 0, 1000000);
		
		ans = max(ans, u);
	}
	cout<<ans;
}

int main(){
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	solve();
}
