#include <bits/stdc++.h>

using namespace std;

vector<int> bfs(vector<vector<int> >& g, int s) {
    int n = (int)g.size();
    vector<int> dist(n, 1e9);
    dist[s] = 0;
    vector<int> q;
    q.push_back(s);
    for (int i = 0; i < (int)q.size(); i++) {
        int u = q[i];
        for (int v: g[u]) {
            if (dist[v] > dist[u] + 1) {
                dist[v] = dist[u] + 1;
                q.push_back(v);
            }
        }
    }
    return dist;
}

int main() {
    int n, m;
    cin >> n >> m;
    vector<vector<int> > g(n), g1(n);
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        g[u - 1].push_back(v - 1);
        g1[v - 1].push_back(u - 1);
    }
    int k;
    cin >> k;
    vector<int> a(k);
    for (int i = 0; i < k; i++) cin >> a[i], a[i]--;
    int t = a.back();
    auto dist = bfs(g1, t);
    vector<int> seq(k);
    for (int i = 0; i < k; i++) seq[i] = dist[a[i]];
    int mn = 0;
    for (int i = k - 2; i >= 0; i--) {
        if (dist[a[i]] != dist[a[i + 1]] + 1) mn++;
    }
    int mx = 0;
    for (int i = k - 2; i >= 0; i--) {
        if (dist[a[i]] != dist[a[i + 1]] + 1) mx++;
        else {
            bool found = 0;
            for (int j: g[a[i]]) {
                if (j == a[i + 1]) continue;
                if (dist[j] + 1 == dist[a[i]]) {
                    found = 1;
                    break;
                }
            }
            if (found) mx++;
        }
    }
    cout << mn << ' ' << mx << endl;
    return 0;
}
