#include <bits/stdc++.h>

#define ll long long
#define ld long double
#define all(v) v.begin(), v.end()
#define trace(x) cout << #x"=" << x << endl

using namespace std;

const ll inf = 1e9 + 9;
const ll mod = 1e9 + 7;
const ll e = 1e-9;

#define int long long


const int maxn = 2e5 + 10;
const int maxb = 1e6 + 10;


struct node {
    int max_pref_len, max_pref_sum, len, sum;
};

node combine(const node &l, const node &r) {
    pair<int, int> left = {l.max_pref_sum, -l.max_pref_len};
    pair<int, int> right = {l.sum + r.max_pref_sum, -(l.len + r.max_pref_len)};
    auto first = max(left, right);
    return {-first.second, first.first, l.len + r.len, l.sum + r.sum};
}

node t[maxb * 4];


int straf[maxb];


void build(int v = 1, int tl = 0, int tr = maxn) {
    if (tr - tl == 1) {
        t[v] = {0, -straf[tl - 1], 1, 0};
        return;
    }
    int m = (tl + tr) / 2;
    build(v * 2, tl, m);
    build(v * 2 + 1, m, tr);
    t[v] = combine(t[v * 2], t[v * 2 + 1]);
}

void update(int i, int val, int v = 1, int tl = 0, int tr = maxn) {
    if (tr - tl == 1) {
        t[v].sum += val;
        if (t[v].sum > straf[i]) {
            t[v].max_pref_len = 1;
            t[v].max_pref_sum = t[v].sum - straf[i];
        }
        return;
    }
    int m = (tl + tr) / 2;
    if (i < m) {
        update(i, val, v * 2, tl, m);
    } else {
        update(i, val, v * 2 + 1, m, tr);
    }
    t[v] = combine(t[v * 2], t[v * 2 + 1]);
}

struct monster {
    int x, y, z;
};

bool operator<(const monster &lhs, const monster &rhs) {
    return lhs.x < rhs.x;
}


signed main() {
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    int n;
    cin >> n;
    map<int, int> sum;
    for (int i = 0; i < n; ++i) {
        int b;
        cin >> b;
        int shift = b - i;
        sum[shift] += b;
    }
    int mx = 0;
    for (auto p: sum) {
        mx = max(mx, p.second);
    }
    cout << mx;
}
