#include <iostream>
#include <string>
#include <vector>
#include <map>

using namespace std;

typedef long long ll;
typedef vector<ll> lvec;
typedef pair<ll, ll> lpair;

#ifdef LOCAL
#define TEST "B"
#endif

#pragma GCC optimize("-Ofast")
#pragma GCC optimize("unroll-loops")
const ll INF = 1e9;

int main() {
#ifdef LOCAL
    if (!freopen(TEST ".in", "r", stdin)) cerr << "Test opening error";
    freopen("Out", "w", stdout);
#endif
    cin.tie(0);
    cout.tie(0);
    ios::sync_with_stdio(false);
    ll n;
    cin >> n;
    map<ll, ll> type;
    for(ll i = 0; i < n ; i ++) {
        ll b;
        cin >> b;
        type[b - i] += b;
    }
    ll ans = 0;
    for(auto el :type) ans = max(ans, el.second);
    cout << ans;
    return 0;
}
