#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <queue>

using namespace std;

typedef long long ll;
typedef vector<ll> lvec;
typedef pair<ll, ll> lpair;

#ifdef LOCAL
#define TEST "C"
#endif
#ifndef LOCAL
#pragma GCC optimize("-Ofast")
#pragma GCC optimize("unroll-loops")
#endif
const ll INF = 1e9;

inline string chump_left(string s, char c) {
    ll i = 0;
    for (; i < s.size() && s[i] == c; i++);
    s.erase(s.begin(), s.begin() + i);
    return s;
}

inline string chump_right(string s, char c) {
    ll i = s.size() - 1;
    for (; i > -1 && s[i] == c; i--);
    s.erase(s.begin() + i + 1, s.end());
    return s;
}

inline string chump(string s, char a) {
    return chump_left(chump_right(s, a), a);
}

string del(string s, char a) {
    cout.flush();
    if (s.empty()) {
        return "";
    }
    //cout << s << " " << a << "\n";
    lvec pos;
    for (ll i = 0; i < s.size(); i++)
        if (s[i] == a) pos.push_back(i);
    if (pos.empty()) return del(s, a + 1);
    string ans = "";
    ans += chump_right(del(s.substr(0, pos[0]), a + 1), a + 1);
    for (ll i = 0; i < pos.size() - 1; i++) {
        ans += s[pos[i]];
        ans += chump(del(s.substr(pos[i] + 1, pos[i + 1] - pos[i] - 1), a + 1), a + 1);
    }
    ans += s[pos.back()];
    ans += chump_left(del(s.substr(pos.back() + 1), a + 1), a + 1);
    return ans;
}

int main() {
#ifdef LOCAL
    if (!freopen(TEST ".in", "r", stdin)) cerr << "Test opening error";
    //freopen("Out", "w", stdout);
#endif
    cin.tie(0);
    cout.tie(0);
    ios::sync_with_stdio(false);
    string s;
    ll n;
    cin >> n >> s;
    cout << n - del(s, 'a').size();
    return 0;
}
