#include <bits/stdc++.h>
#define int long long
#define endl '\n'
#define forn (i, n) for (int (i) = 0; (i) < (n); ++(i))
#define all(a) (a).begin(), (a).end()
#define len(a) (int) (a).size()
using namespace std;
void solve();
signed main(){
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    solve();
    return 0;
}

struct edge{
    int to, id;
};

vector<vector<edge>> g;
const int inf = (int) 1e9 + 7;
void solve(){
    int n, m; cin >> n >> m;
    g.resize(n);
    map<pair<int, int>, int> mpid;
    for (int qwe = 0; qwe < m; ++qwe){
        int v, u; cin >> v >> u; v--; u--;
        g[u].push_back({v, qwe});
        mpid[{v, u}] = qwe;
    }
    int k; cin >> k; vector<int> vs(k); for (int i = 0; i < k; ++i) cin >> vs[i]; for (int i = 0; i < k; ++i) vs[i]--;
    int s = vs[0], f = vs.back();

    vector<int> d(n, inf); d[f] = 0;
    queue<int> q; q.push(f);
    while (!q.empty()){
        int v = q.front(); q.pop();
        for (auto u : g[v]){
            if (d[u.to] > d[v] + 1){
                d[u.to] = d[v] + 1;
                q.push(u.to);
            }
        }
    }

    vector<int> cnt(n);

    for (int v = 0; v < n; ++v){
        for (auto u : g[v]){
            if (d[u.to] == d[v] + 1)
                cnt[u.to]++;
        }
    }

    int maxcorr = 0;
    int mincorr = 0;
    for (int i = 0; i < k - 1; ++i){
        int v = vs[i], u = vs[i + 1];
        if (d[u] + 1 == d[v]) {
            ++maxcorr;
            if (cnt[v] == 1)
                ++mincorr;
        }

    }
    cout << k - maxcorr - 1 << ' ' << k - mincorr - 1 << endl;
}