#include <bits/stdc++.h>

#define sq(x) ((x)*(x))
#define err(x) cerr << "["#x"]  " << (x) << "\n";
#define errv(x) {cerr << "["#x"]  [";for (const auto& iii : (x)) cerr << (iii) << ", "; cerr << "]\n";}
#define errvn(x, n) {cerr << "["#x"]  [";for (int iii = 0; iii < (n); ++iii) cerr << ((x)[iii]) << ", "; cerr << "]\n";}
#define errf() cerr << "\n\n";

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

mt19937 rng(chrono::steady_clock().now().time_since_epoch().count());

int getrnd(int a, int b) {
    return uniform_int_distribution<int>(a, b)(rng);
}

template<typename T1, typename T2>
bool relax(T1& a, const T2& b) {
    if (a > b) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T1, typename T2>
bool strain(T1& a, const T2& b) {
    if (a < b) {
        a = b;
        return 1;
    }
    return 0;
}

///////////////////////////////////////////////

void solve() {
    int n;
    cin >> n;

    vector<int> a(n), b(n);
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    for (int i = 0; i < n; ++i)
        cin >> b[i];

    if (a == b) {
        cout << "-1\n";
        return;
    }

    vector<int> ans(n, 1);
    int r = 0, c = 0;
    for (int i = 0; i < n; ++i) {
        if (a[i]) ++r;
        if (b[i]) ++c;
    }

    if (r > c) {
        cout << "1\n";
        return;
    }
    else {
        int d = c - r + 1;
        for (int i = 0; i < d; ++i) {
            int mn = 0;
            for (int j = 0; j < n; ++j) {
                if (!b[j] && a[j] && ans[mn] > ans[j])
                    mn = j;
            }
            ++ans[mn];
        }

        int mx = 0;
        for (int i : ans)
            strain(mx, i);
        cout << mx << "\n";
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(nullptr); cout.tie(nullptr);

    int t = 1;
    //cin >> t;
    while (t--)
        solve();

    return 0;
}
