#include <bits/stdc++.h>

#define sq(x) ((x)*(x))
#define err(x) cerr << "["#x"]  " << (x) << "\n";
#define errv(x) {cerr << "["#x"]  [";for (const auto& iii : (x)) cerr << (iii) << ", "; cerr << "]\n";}
#define errvn(x, n) {cerr << "["#x"]  [";for (int iii = 0; iii < (n); ++iii) cerr << ((x)[iii]) << ", "; cerr << "]\n";}
#define errf() cerr << "\n\n";

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

mt19937 rng(chrono::steady_clock().now().time_since_epoch().count());

int getrnd(int a, int b) {
    return uniform_int_distribution<int>(a, b)(rng);
}

template<typename T1, typename T2>
bool relax(T1& a, const T2& b) {
    if (a > b) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T1, typename T2>
bool strain(T1& a, const T2& b) {
    if (a < b) {
        a = b;
        return 1;
    }
    return 0;
}

///////////////////////////////////////////////

void solve() {
    int n;
    cin >> n;

    string s;
    cin >> s;

    int ans = 0;
    for (int i = 0; i < n; ++i) {
        int mx = -1;
        /// not n but s.size()
        for (int j = 0; j < s.size(); ++j) {
            if ((j > 0 && s[j - 1] + 1 == s[j]) || (j < s.size() && s[j + 1] + 1 == s[j])) {
                if (mx == -1 || s[j] > s[mx])
                    mx = j;
            }
        }
        if (mx == -1) break;

        string t = "";
        for (int j = 0; j < s.size(); ++j)
            if (j != mx) t += s[j];
        ++ans;
        s = t;
    }
    cout << ans << '\n';
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(nullptr); cout.tie(nullptr);

    int t = 1;
    //cin >> t;
    while (t--)
        solve();

    return 0;
}
