#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define pb emplace_back
#define mp make_pair
#define fi first
#define se second
#define em emplace
#define all(x) (x).begin(), (x).end()
#define in(x); { for (auto &i : x) cin >> i; }
#define out(x); { for (auto &i : x) cout << i << ' '; cout << endl; }
#define pack(x); { sort(all(x)); (x).resize(unique(all(x)) - (x).begin()); }
//#define int long long

using namespace std;
using namespace __gnu_cxx;
using namespace __gnu_pbds;

typedef tree <int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const int INF = 2e9;
const long long INFll = 2e18;
const int MAXN = 1e6;

vector <int> g[300000];
vector <int> g2[300000];
int d[300000];

void solve() {
    int n, m; cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int u, v; cin >> u >> v;
        g[v].pb(u);
        g2[u].pb(v);
    }

    int k; cin >> k;
    vector <int> p(k); in(p);

    fill(d, d + 300000, INF);
    d[p[k - 1]] = 0;
    queue <int> q;
    q.push(p[k - 1]);
    while (!q.empty()) {
        int from = q.front();
        for (int to : g[from]) {
            if (d[to] > d[from] + 1) {
                d[to] = d[from] + 1;
                q.push(to);
            }
        }
        q.pop();
    }

    int mn = 0, mx = 0;
    for (int i = 0; i < k - 1; i++) {
        int cl = 0;
        for (int j : g2[p[i]]) {
            if (j != p[i + 1] && d[j] < d[cl])
                cl = j;
        }
        if (d[cl] == d[p[i + 1]]) {
            mx++;
        } else if (d[cl] < d[p[i + 1]]){
            mx++;
            mn++;
        }
        //cout << p[i] << ' ' << cl << ' ' << d[cl] << ' ' << d[p[i + 1]] << endl;
    }

    cout << mn << ' ' << mx;
}

signed main() {
#ifdef FOREST
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
#endif // FOREST
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    solve();
}
