#include <iostream>
#include <vector>
#include <string>
#include <iomanip>
#include <set>
#include <map>
#include <stack>
#include <queue>
#include <cmath>

using namespace std;

typedef long long ll;
typedef vector <int> vi;
typedef long double ld;
typedef pair <int, int> pii;

#define pb push_back
#define f first
#define s second

const int MAXN = 1e6 + 10;
const ll INF = 1e9 + 10;
const ll MOD = 1e9 + 7;

void fastIO(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int n, a[MAXN], b[MAXN];

int main() {
    fastIO();
    cin >> n;
    for (int i = 0; i < n; i++)
        cin >> a[i];
    for (int i = 0; i < n; i++)
        cin >> b[i];
    int cnt_good = 0, cnt_bad = 0;
    for (int i = 0; i < n; i++) {
        if (a[i] == 1 && b[i] == 0)
            cnt_good++;
        if (a[i] == 0 && b[i] == 1)
            cnt_bad++;
    }
    if (cnt_good == 0)
        cout << -1;
    else
        cout << cnt_bad / cnt_good + 1;


    return 0;
}
