#include <iostream>
#include <vector>
#include <string>
#include <iomanip>
#include <set>
#include <map>
#include <stack>
#include <queue>
#include <cmath>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef vector <int> vi;
typedef long double ld;
typedef pair <int, int> pii;

#define pb push_back
#define f first
#define s second

const int MAXN = 1e6 + 10;
const ll INF = 1e9 + 10;
const ll MOD = 1e9 + 7;

void fastIO(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int n;
ll a[MAXN];
vector <pair <ll, int> > b;

int main() {
    fastIO();
    cin >> n;
    b.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        b[i] = {a[i] - i, a[i]};
    }
    sort(b.begin(), b.end());
    ll ans = 0, cur = b[0].s;
    for (int i = 1; i < n; i++) {
        if (b[i].f == b[i - 1].f)
            cur += b[i].s;
        else {
            ans = max(ans, cur);
            cur = b[i].s;
        }
    }
    ans = max(ans, cur);
    cout << ans;
    return 0;
}
