#include <iostream>
#include <vector>
#include <string>
#include <iomanip>
#include <set>
#include <map>
#include <stack>
#include <queue>
#include <cmath>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef vector <int> vi;
typedef long double ld;
typedef pair <int, int> pii;

#define pb push_back
#define f first
#define s second

const int MAXN = 1e6 + 10;
const ll INF = 1e9 + 10;
const ll MOD = 1e9 + 7;

void fastIO(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int n;
string s;

int find_pos() {
    pii res = {-1, -1};
    for (int i = 0; i < s.size(); i++) {
        if (i != 0 && s[i - 1] == ('a' + (s[i] - 'a' - 1)))
            res = max(res, {s[i] - 'a', i});
        if (i != s.size() - 1 && s[i + 1] == ('a' + (s[i] - 'a' - 1)))
            res = max(res, {s[i] - 'a', i});
    }
    return res.s;
}

int main() {
    fastIO();
    cin >> n >> s;
    while (true) {
        int pos = find_pos();
        if (pos == -1)
            break;
        string t;
        for (int i = 0; i < s.size(); i++) {
            if (i != pos)
                t.pb(s[i]);
        }
        s = t;
    }
    cout << n - s.size();



    return 0;
}
