#include<iostream>
#include<string>
#include<algorithm>
#include<map>
#include<vector>
#include<queue>
using namespace std;
#define ll long long
#define mp make_pair
vector<int> arr[200000], path, revArr[200000];
int dist[200000];
queue<pair<int, int>> q;
bool used[200000];
int main()
{
	int n, m;
	cin >> n >> m;
	int v, u;
	for (int i = 0; i < m; i++)
	{
		cin >> v >> u;
		arr[v - 1].push_back(u - 1);
		revArr[u - 1].push_back(v - 1);
	}
	int k;
	cin >> k;
	for (int i = 0; i < k; i++)
	{
		cin >> v;
		v--;
		path.push_back(v);
	}
	q.push(mp(v, 0));
	used[v] = true;
	for (int i = 0; i < n; i++)
		dist[i] = 2 * 1e9;
	while (!q.empty())
	{
		auto p = q.front();
		q.pop();
		dist[p.first] = p.second;
		v = p.first;
		for (int i = 0; i < revArr[v].size(); i++)
		{
			if (!used[revArr[v][i]])
			{
				used[revArr[v][i]] = true;
				q.push(mp(revArr[v][i], p.second + 1));
			}
		}
	}
	int ansMin = 0, ansMax = 0;
	for (int i = 0; i < path.size() - 1; i++)
	{
		v = path[i];
		int curMin = 1e9, minCnt = 0;
		for (int j = 0; j < arr[v].size(); j++)
		{
			if (curMin == dist[arr[v][j]])
				minCnt++;
			if (curMin > dist[arr[v][j]])
			{
				minCnt = 1;
				curMin = dist[arr[v][j]];
			}
		}
		if (dist[path[i + 1]] > curMin)
		{
			ansMin++;
			ansMax++;
			continue;
		}
		if (minCnt > 1)
		{
			ansMax++;
		}
	}
	cout << ansMin << ' ' << ansMax;
}