#include <bits/stdc++.h>

#define ll long long
#define X first
#define Y second
#define MP make_pair

using namespace std;

const int N = 2e5 + 123;

int n, m, p;
pair<int, ll> a[N], b[N];
pair< pair<int, int>, ll > c[N];

ll t[N * 4], tt[N * 4];

void build(int v, int tl, int tr){
	if(tl == tr){
		t[v] = -b[tl].Y;
		return;
	}
	int tm = (tl + tr) / 2;
	build(v * 2, tl, tm);
	build(v * 2 + 1, tm + 1, tr);
	t[v] = max(t[v * 2], t[v * 2 + 1]);
}

void push(int v){
	if(tt[v] == 0)
		return;
	t[v * 2] += tt[v], t[v * 2 + 1] += tt[v];
	tt[v * 2] += tt[v], tt[v * 2 + 1] += tt[v];
	tt[v] = 0;
}

void upd(int v, int tl, int tr, int l, int r, ll val){
	if(l > tr || tl > r)
		return;
	if(tl >= l && tr <= r){
		t[v] += val;
		tt[v] += val;
		return;
	}
	push(v);
	int tm = (tl + tr) / 2;
	upd(v * 2, tl, tm, l, r, val);
	upd(v * 2 + 1, tm + 1, tr, l, r, val);
	t[v] = max(t[v * 2], t[v * 2 + 1]);
}

int main () {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cin >> n >> m >> p;
	for(int i = 1;i <= n;i++){
		cin >> a[i].X >> a[i].Y;
	}
	for(int i = 1;i <= m;i++){
		cin >> b[i].X >> b[i].Y;
	}
	for(int i = 1;i <= p;i++){
		cin >> c[i].X.X >> c[i].X.Y >> c[i].Y;
	}
	
	sort(a + 1, a + n + 1);
	sort(b + 1, b + m + 1);
	sort(c + 1, c + p + 1);

	build(1, 1, m);
	int tx = 0;
	ll res = 0;
	for(int i = 1;i <= n;i++){
		while(tx + 1 <= p && a[i].X > c[tx + 1].X.X){
			int tl = 1, tr = m, tp = m + 1;
			while(tl <= tr){
				int tm = (tl + tr) / 2;
				if(c[tx + 1].X.Y < b[tm].X){
					tr = tm - 1;
					tp = tm;
				}
				else{
					tl = tm + 1;
				}
			}
			if(tp != m + 1){
				upd(1, 1, m, tp, m, c[tx + 1].Y);
			}
			tx += 1;
		}
		ll need = t[1] - a[i].Y;
		if(i == 1)
			res = need;
		res = max(res, need);
	}
	cout << res;
}