#define _CRT_SECURE_NO_WARNINGS

#include<iostream>
#include<vector>
#include<algorithm>
#include<set>
#include<vector>
#include<map>
#include<string>
#include<ctime>
#include<queue>
#include<random>
#include<unordered_map>
using namespace std;
typedef int ll;
mt19937 rnd(238);
ll tree[(ll)4e6], push[(ll)4e6];
void pu(ll v) {
	if (v * 2 < 4e6)
		push[v * 2] += push[v];
	if (v * 2 + 1 < 4e6)
		push[v * 2 + 1] += push[v];
	tree[v] += push[v];
	push[v] = 0;
}
void build(ll v, ll l, ll r, ll tl, ll val) {
	//pu(v);
	if (l == r) {
		tree[v] = max(val, tree[v]);
		//pu(v);
		return;
	}
	ll m = (l + r) / 2;
	if (m >= tl)
		build(v * 2, l, m, tl, val);
	else
		build(v * 2 + 1, m + 1, r, tl, val);
	//pu(v);
	tree[v] = max(tree[v * 2], tree[v * 2 + 1]);

}
void upd(ll v, ll l, ll r, ll tl, ll tr, ll val) {
	pu(v);
	if (tl > tr)
		return;
	if (tl == l && tr == r) {
		push[v] += val;
		pu(v);
		return;
	}
	ll m = (l + r) / 2;
	upd(v * 2, l, m, tl, min(tr, m), val);
	upd(v * 2 + 1, m + 1, r, max(tl,m + 1), tr, val);
	pu(v);
	tree[v] = max(tree[v * 2], tree[v * 2 + 1]);

}
int main() {
	ll n, m, k;
	scanf("%d%d%d", &n, &m, &k);
	for (int i = 0; i < 4e6; i++)
		tree[i] = -1e9;
	vector<pair<ll, ll>> a(n), b(m);
	for (int i = 0; i < n; i++)
		scanf("%d%d", &a[i].first, &a[i].second);
	sort(a.begin(), a.end());
	for (int i = 0; i < m; i++)
		scanf("%d%d", &b[i].first,&b[i].second);
	sort(b.begin(), b.end());
	vector<ll>suf(m);
	suf[m - 1] = b.back().second;
	for (int i = m - 2; i >= 0; i--)
		suf[i] = min(suf[i + 1], b[i].second);
	vector<pair<pair<ll, ll>, ll>> v(k);
	for (int i = 0; i < k; i++)
		scanf("%d%d%d", &v[i].first.first, &v[i].first.second ,&v[i].second);
	sort(v.begin(), v.end());
	for (int i = 0; i < m; i++)
		build(1, 0, 1e6, b[i].first - 1, -suf[i]);
	ll ind = 0;
	ll ans = -1e9;
	for (int i = 0; i < n; i++) {
		while (ind != k && v[ind].first.first < a[i].first)
			upd(1, 0, 1e6, v[ind].first.second, 1e6, v[ind].second), ind++;
		ans = max(ans, tree[1] - a[i].second);
	}
	printf("%d", ans);
	return 0;
}
