#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <cassert>
#include <queue>
#include <map>
#include <unordered_map>
#include <unordered_set>

#define int long long int

using namespace std;

int n, m;
vector<vector<int>> cg, g;
vector<int> dist;

signed main(){
    cin >> n >> m;
    g.resize(n);
    cg.resize(n);
    dist.resize(n, 1e15);
    for(int i = 0; i < m; i++){
        int a, b; cin >> a >> b; a--; b--;
        g[a].push_back(b);
        cg[b].push_back(a);
    }
    int w; cin >> w;
    vector<int> p(w);
    for(int i = 0; i < w; i++){
        cin >> p[i]; p[i]--;
    }
    queue<int> q; q.push(p.back());
    dist[p.back()] = 0;
    while(!q.empty()){
        int v = q.front(); q.pop();
        for(auto to : cg[v]){
            if(dist[to] > dist[v] + 1){
                dist[to] = dist[v] + 1;
                q.push(to);
            }
        }
    }
    int ans1 = 0, ans2 = 0;
    for(int i = 0; i < w - 1; i++){
        int v = p[i];
        int minAns = 1e15, cntMin = 0, minInd = -1;
        for(auto to : g[v]){
            if(dist[to] < minAns){
                minAns = dist[to];
                cntMin = 1;
                minInd = to;
            }else if(dist[to] == minAns){
                cntMin++;
            }
        }
        if(cntMin == 1){
            if(minInd != p[i + 1]){
                ans1++;
                ans2++;
            }
        }else{
            ans2++;
            if(dist[p[i + 1]] != minAns)ans1++;
        }
    }
    cout << ans1 << " " << ans2 << "\n";
    return 0;
}
