#include <bits/stdc++.h>
using namespace std;

#define ll long long

const int N = 2e5 + 5;
vector<int> rg[N], g[N];
int p[N], d[N];

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

	int n, m;
	cin >> n >> m;

	for (int i = 0; i < m; i++) {
		int x, y;
		cin >> x >> y;
		x--;
		y--;
		g[x].push_back(y);
		rg[y].push_back(x);
	}

	int k;
	cin >> k;

	for (int i = 0; i < k; i++) {
		cin >> p[i];
		p[i]--;
	}

	fill(d, d + n, -1);
	d[p[n - 1]] = 0;

	queue<int> q;
	q.push(p[n - 1]);

	while (!q.empty()) {
		int node = q.front();
		q.pop();

		for (int to : rg[node]) {
			if (d[to] == -1) {
				d[to] = d[node] + 1;
				q.push(to);
			}
		}
	}

	int mn = 0, mx = 0;

	for (int i = 0; i < k - 1; i++) {
		if (d[p[i + 1]] != d[p[i]] - 1) {
			mn++;
		}
	}

	for (int i = 0; i < k - 1; i++) {
		if (d[p[i + 1]] != d[p[i]] - 1) {
			mx++;
			// cout << p[i] + 1 << "\n";
		}
		else {
			for (int to : g[p[i]]) {
				if (to != p[i + 1] && d[to] == d[p[i]] - 1) {
					mx++;
					break;
				}
			}
		}
	}

	cout << mn << " " << mx << "\n";
	
	return 0;
}