#include <bits/stdc++.h>
using namespace std;

#define ll long long 
#define all(aaa) aaa.begin(), aaa.end()

const int N = 2e5 + 5;

struct Node {
	int len = 0, l = 0, r = 0, ct = 0, cc[2] = {0, 0};
} t[N * 4];

string s;
int n;

Node operator + (Node a, Node b) {
	if (a.len == 0)
		return b;
	if (b.len == 0)
		return a;

	Node c;
	c.ct = a.ct + b.ct;
	c.len = a.len + b.len;
	c.cc[0] = a.cc[0] + b.cc[0];
	c.cc[1] = a.cc[1] + b.cc[1];
	
	if (a.len != a.r && b.len != b.l) {
		c.ct += (a.r + b.l) % 2;
		c.l = a.l;
		c.r = b.r;
	}
	else {
		if (a.len == a.l) {
			c.l = a.l + b.l;
		}
		else {
			c.l = a.l;
		}

		if (b.len == b.r) {
			c.r = b.r + a.r;
		}
		else {
			c.r = b.r;
		}
	}

	return c;
}

void build(int v, int L, int R) {
	if (L == R) {
		t[v].len = 1;
		t[v].cc[s[L] - '0'] = 1;
		t[v].r = t[v].l = t[v].cc[1];
	}
	else {
		int m = (L + R) >> 1;
		build(v * 2, L, m);
		build(v * 2 + 1, m + 1, R);
		t[v] = t[v * 2] + t[v * 2 + 1];
	}
}

Node que(int l, int r, int v, int L, int R) {
	if (l > r)
		return Node();
	if (l == L && r == R)
		return t[v];
	int m = (L + R) >> 1;
	return que(l, min(m, r), v * 2, L, m) +
		que(max(m + 1, l), r, v * 2 + 1, m + 1, R);
}

Node get_substr(int l, int r) {
	Node res = que(l, r, 1, 0, n - 1);

	if (res.l % 2)
		res.ct++;
	if (res.r % 2 && res.r != res.len)
		res.ct++;
	return res;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

	cin >> n >> s;

	build(1, 0, n - 1);


	// Node gg = get_substr(0, 2);
	// cout << gg.l << " " << gg.r << " " << gg.ct << "\n";
	// return 0;

	int q;
	cin >> q;

	for (int i = 0; i < q; i++) {
		int l1, l2, len;
		cin >> l1 >> l2 >> len;

		l1--;
		l2--;

		if (len < 3) {
			bool ok = true;
			for (int i = 0; i < len; i++) {
				if (s[l1 + i] != s[l2 + i])
					ok = false;
			}
			cout << (ok ? "Yes\n" : "No\n");
		}
		else {
			Node node1 = get_substr(l1, l1 + len - 1),
				node2 = get_substr(l2, l2 + len - 1);

			if (node1.ct == node2.ct 
				&& node1.cc[0] == node2.cc[0] 
				&& node1.cc[1] == node2.cc[1]) {
				cout << "Yes\n";
			}
			else {
				cout << "No\n";
			}
		}
	}

	return 0;
}