#include <bits/stdc++.h>
using namespace std;
#define fir first
#define sec second
#define len(v) ((int)v.size())
typedef long long llint;

int n, m;
const int N = (int)2e5;
vector<int> g[N];
vector<int> gr[N];
int dist[N];
int k;
int b[N];

int main() {
#ifdef LOCAL
    freopen("input.txt", "rt", stdin); freopen("output.txt", "wt", stdout);
#endif // LOCAL
    ios_base::sync_with_stdio(false); cin.tie(nullptr);
    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        g[u].push_back(v);
        gr[v].push_back(u);
    }
    cin >> k;
    for (int i = 0; i < k; i++) {
        cin >> b[i];
        b[i]--;
    }

    queue<int> q;
    q.push(b[k-1]);
    dist[b[k-1]] = 1;
    while (!q.empty()) {
        int u = q.front(); q.pop();
        for (auto v: gr[u]) {
            if (dist[v] == 0) {
                dist[v] = dist[u]+1;
                q.push(v);
            }
        }
    }

    int minc = 0;
    int maxc = 0;
    for (int i = 0; i < k-1; i++) {
        int mn_d = n;
        for (auto v: g[b[i]])
            mn_d = min(mn_d, dist[v]);
        bool fmn = true;
        bool fmx = false;
        for (auto v: g[b[i]]) {
            if (mn_d == dist[v]) {
                if (v == b[i+1])
                    fmn = false;
                else
                    fmx = true;
            }
        }
        minc += fmn;
        maxc += fmx;
    }
    cout << minc << " " << maxc << "\n";
    return 0;
}
