#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef pair <ll, ll> pll;
//#define endl '\n';

const ll N = 2e5 + 8;

ll n, q;
string s;

struct item {
    ll sum;
    item() {
        sum = 0;
    }
    item(ll val) {
        sum = val;
    }
};

struct ST {
    ll n;
    vector <item> t;
    ST(string s) {
        n = s.size();
        t.resize(n << 2);
        build(0, 0, n, s);
    }
    item comb(item &a, item &b) {
        item res(a.sum + b.sum);
        return res;
    }
    void build(ll v, ll tl, ll tr, string &s) {
        if (tl + 1 == tr) {
            t[v] = item(s[tl]);
            return;
        }
        ll tm = (tl + tr) >> 1;
        build(2 * v + 1, tl, tm, s);
        build(2 * v + 2, tm, tr, s);
        t[v] = comb(t[2 * v + 1], t[2 * v + 2]);
    }
    ll sum(ll v, ll tl, ll tr, ll l, ll r) {
        if (r <= tl || tr <= l) {
            return 0;
        }
        if (l <= tl && tr <= r) {
            return t[v].sum;
        }
        ll tm = (tl + tr) >> 1;
        return sum(2 * v + 1, tl, tm, l, r) + sum(2 * v + 2, tm, tr, l, r);
    }
    void upd(ll v, ll tl, ll tr, ll pos, ll val) {
        if (tl + 1 == tr && pos == tl) {
            t[v] = item(val);
            return;
        }
        ll tm = (tl + tr) >> 1;
        if (pos < tm) {
            upd(2 * v + 1, tl, tm, pos, val);
        }  else {
            upd(2 * v + 2, tm, tr, pos, val);
        }
        t[v] = comb(t[2 * v + 1], t[2 * v + 2]);
    }
    void viv() {
        for (ll i = 0; i < n; ++i) {
            cout << sum(0, 0, n, i, i + 1) << ' ';
        }
        cout << endl;
    }
};

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    cin >> n;
    cin >> s;
    for (ll i = 0; i < n; ++i) {
        s[i] -= '0';
    }
    ST T(s);
    //T.viv();
    for (ll i = 1; i < n - 1; ++i) {
        //cout << i << ' ' << s[i - 1] + s[i + 1] << endl;
        if (s[i] == 1 && (s[i - 1] + s[i + 1]) == 1) {
            T.upd(0, 0, n, i, 0);
        }
    }
    //T.viv();
    cin >> q;
    while (q--) {
        ll l1, l2, len;
        cin >> l1 >> l2 >> len;
        --l1, --l2;
        if (T.sum(0, 0, n, l1, l1 + len) == T.sum(0, 0, n, l2, l2 + len)) {
            cout << "YES" << '\n';
        } else {
            cout << "NO" << '\n';
        }
    }
    return 0;
}

/**


**/
