#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

#define FOR(i,n) for (int i=0;i<(n);++i)
#define FORT(i,a,b) for (int i=(a);i<=(b);++i)
#define FORD(i,n) for (int i=(n)-1;i>=0;--i)
#define FORTD(i,a,b) for (int i=(a);i>=(b);--i)
#define trav(to,v) for (auto to : v)
#define fr first
#define sc second
#define pir pair<int,int>
#define mpr make_pair
#define ad push_back
#define all(v) v.begin(),v.end()
#define fastio ios_base::sync_with_stdio(false);cin.tie(0)
#define srng mt19937 rng(chrono::steady_clock::now().time_since_epoch().count())


const int N=1e6+6;
ll sg[4*N],lz[4*N];
void build(int v,int tl,int tr){
    //cout<<v<<" "<<tl<<" "<<tr<<endl;
    if (tl==tr){
        sg[v]=LLONG_MIN;
        return;
    }
    int tm=(tl+tr)/2;
    build(v+v,tl,tm);
    build(v+v+1,tm+1,tr);
    sg[v]=max(sg[v+v],sg[v+v+1]);
}


void update2(int v,int tl,int tr,int ind,ll val){
    if (tl==tr){
        sg[v]=max(val,sg[v]);
        return;
    }
    int tm=(tl+tr)/2;
    if (ind<=tm)update2(v+v,tl,tm,ind,val);
    else update2(v+v+1,tm+1,tr,ind,val);
    sg[v]=max(sg[v+v],sg[v+v+1]);
}

void update(int v,int tl,int tr,int l,int r,ll val){
    if (l>r)return;
    if (tl==l && tr==r){
        sg[v]+=val;
        lz[v]+=val;
        return;
    }
    int tm=(tl+tr)/2;
    update(v+v,tl,tm,l,min(tm,r),val);
    update(v+v+1,tm+1,tr,max(l,tm+1),r,val);
    sg[v]=max(sg[v+v],sg[v+v+1])+lz[v];
}


pair<int,ll> a[N],b[N];
pair<pir,ll> c[N];



int main(){
    srng;
    fastio;
    int n,m,p;
    cin>>n>>m>>p;

    FOR(i,n){
        cin>>a[i].fr>>a[i].sc;
    }
    build(1,0,N-1);
    FOR(i,m){
        cin>>b[i].fr>>b[i].sc;
        update2(1,0,N-1,b[i].fr,-b[i].sc);
    }
    FOR(i,p){
        cin>>c[i].fr.fr>>c[i].fr.sc>>c[i].sc;
    }
    sort(a,a+n);
    sort(c,c+p);
    int j=0;
    ll mx=LLONG_MIN;
    FOR(i,n){
        while(j<p && c[j].fr.fr<a[i].fr){
            //cout<<c[j].fr.sc+1<<" "<<N-1<<" "<<c[j].sc<<endl;
            update(1,0,N-1,c[j].fr.sc+1,N-1,c[j].sc);
            j++;
        }
        mx=max(mx,-a[i].second+sg[1]);
        //cout<<sg[1]<<" "<<a[i].second<<" "<<a[i].fr<<" "<<mx<<endl;
    }
    cout<<mx<<endl;
    return 0; 
}

/*
2 3 1
2 3
4 7
2 4
3 2
5 11
4 4 1000
*/

/*
vector<int> prfunc(string s){
    int n=(s.length());
    vector<int> pi(n);
    FORT(i,1,n-1){
        int j=pi[i-1];
        while(j>0 && s[j]!=s[i]){
            j=pi[j-1];
        }
        if (s[i]==s[j])j++;
        pi[i]=j;
    }
    return pi;
}



*/