#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair <ll, ll> pll;
typedef pair <int, int> pii;

#define pb push_back
#define eb emplace_back
#define print(a) { for (auto xxxxxx : (a)) cout << xxxxxx << ' '; cout << '\n'; }
#define fi first
#define se second
#define all(x) (x).begin() , (x).end()
#define mp make_pair

const ll inf = 2e18 , mod = 1e9 + 7;
const int intf = 2e9 , maxn = 2e5 + 2;

struct st{
    int x , y;
    ll delta;
};

int n , m , p , M = 1;
ll x[maxn] , y[maxn] , z[maxn] , tree[4*maxn] , add[4*maxn];
pll a[maxn] , b[maxn];

void build(){
    while(M < m) M *= 2;
    for (int i = 1; i < M*2; i ++) {
        add[i] = tree[i] = 0;
    }
    for (int i = 0; i < m; i ++){
        tree[i + M] = -b[i].se;
    }
    for (int i = M - 1; i > 0; i --){
        tree[i] = max(tree[i*2] , tree[i*2 + 1]);
    }
}

void push(int i){
    tree[i] += add[i];
    if (i*2 + 1 < 2*M){
        add[i*2] += add[i];
        add[i*2 + 1] += add[i];
    }
    add[i] = 0;
}

void upd(int i){
    if (i*2 + 1 >= 2*M) return;
    tree[i] = max(tree[i*2] + add[i*2] , tree[i*2 + 1] + add[i*2 + 1]);
}

void increase(int L , int R , int l , int r , int i , ll x){
    if (r < L || R < l) return;

    if (L <= l && r <= R){
        add[i] += x;
        return;
    }

    push(i);
    int m = (l + r) / 2;
    increase(L , R , l , m , i*2 , x);
    increase(L , R , m + 1 , r , i*2 + 1 , x);
    upd(i);
}

ll get_max(int L , int R , int l , int r , int i){
    if (r < L || R < l) return -inf;

    if (L <= l && r <= R){
        return tree[i] + add[i];
    }
    push(i);
    int m = (l + r) / 2;
    ll cur = max(get_max(L , R , l , m , i*2) , get_max(L , R , m + 1 , r , i*2 + 1));
    upd(i);
    return cur;
}

void solve(){
    cin >> n >> m >> p;
    for (int i = 0; i < n; i ++){
        cin >> a[i].fi >> a[i].se;
    }
    sort(a , a + n);
    for (int i = 0; i < m; i ++){
        cin >> b[i].fi >> b[i].se;
    }
    sort(b , b + m);
    for (int i = 0; i < p; i ++){
        cin >> x[i] >> y[i] >> z[i];
    }

    vector <st> q(p);

    for (int i = 0; i < p; i ++){
        int ida = upper_bound(a , a + n , mp(x[i] , inf)) - a;
        int idb = upper_bound(b , b + m , mp(y[i] , inf)) - b;

        q[i] = {ida , idb , z[i]};
    }
    sort(all(q) , [](const st &a , const st &b){
        return a.x < b.x;
    });

    build();

    ll ans = -inf;
    for (int X = 0 , i = 0; X < n; X ++){
        while(i < p && q[i].x == X){
            increase(q[i].y , m - 1 , 0 , M - 1 , 1 , q[i].delta);
            i++;
        }
        ans = max(ans , tree[1] + add[1] - a[X].se);
    }
    cout << ans;
}


int main(){
	ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0); cout.precision(20);

	int t = 1;
	//cin >> t;
	while(t-->0){
        solve();
	}

	return 0;
}
/*


*/
