#include <iostream>
#include <iomanip>
#include <cmath>
#include <cstdio>
#include <cstring>
#include <set>
#include <string>
#include <vector>
#include <map>
#include <queue>
#include <algorithm>
#define ll long long
#define mp make_pair
#define f first
#define s second
#define pb push_back

using namespace std;

const int inf = 1e9 + 7;
const int maxn = 2e5 + 123;

int n;
map < string, int > dp;

int rec(string s){
    if (dp[s] != 0)
        return (dp[s] == -1 ? 0 : dp[s]);
    int cnt = 0;
    bool ok = 0;
        for (int i = (int)s.size() - 1; i >= 0; i--){
            int cur = 0;
            if (s[i] == '#')
                continue;
            for (int j = i - 1; j >= 0; j--){
                if (s[j] == '#')
                    cur++;
                if (s[j] != '#' && s[i] - s[j] == 1 && i - j - 1 == cur){
                    cnt++;
                    ok = 1;
                    s[i] = '#';
                    break;
                }
            }
            if (s[i] == '#'){
                break;
            }
            cur = 0;
            for (int j = i + 1; j < s.size(); j++){
                if (s[j] == '#')
                    cur++;
                if (s[j] != '#' && s[i] - s[j] == 1 && j - i - 1 == cur){
                    cnt++;
                    ok = 1;
                    s[i] = '#';
                    break;
                }
            }
            if (s[i] == '#')
                break;
        }

    string d = s;
    reverse(d.begin(), d.end());
    if (ok){
        if (!dp[s])    
            dp[s] = rec(s) + cnt;
        if (!dp[d])
            dp[d] = rec(d) + cnt;
        //cout << s << ' ' << dp[s] << endl;
        return max(dp[s], dp[d]);
    } else {
        dp[s] = dp[d] = -1;
        return 0;
    }
}

int main(){
    ios_base::sync_with_stdio(NULL);
    cin.tie(0);
    cout.tie(0);
    string s;
    cin >> n >> s;
    int y = rec(s);
    reverse(s.begin(), s.end());
    cout << max(y, rec(s));
    return 0;
}