#include <iostream>
#include <iomanip>
#include <cmath>
#include <cstdio>
#include <cstring>
#include <set>
#include <string>
#include <vector>
#include <map>
#include <queue>
#include <algorithm>
#define ll long long
#define mp make_pair
#define f first
#define s second
#define pb push_back

using namespace std;

const int inf = 1e9 + 7;
const int maxn = 2e5 + 123;

int n, m, k, a[maxn], start, fin, dist[maxn];
vector < int > g[maxn], gr[maxn];
bool used[maxn];
int mn, mx;

void bfs(int srt){
    queue < int > q;
    q.push(srt);
    dist[srt] = 0;
    while (!q.empty()){
        int v = q.front();
        q.pop();
        for (int hh = 0; hh < gr[v].size(); hh++){
            int to = gr[v][hh];
            if (dist[to] > dist[v] + 1){
                dist[to] = dist[v] + 1;
                q.push(to);
            }
        }
    }
}

void dfs(int v, int number){
    if (v == fin || used[v])
        return;
    used[v] = 1;
    int cur = inf, cnt = 0;
    for (int hh = 0; hh < g[v].size(); hh++){
        int to = g[v][hh];
        cur = min(cur, dist[to]);
    }
    for (int hh = 0; hh < g[v].size(); hh++){
        int to = g[v][hh];
        if (dist[to] == cur)
            cnt++;
    }
    if (cur < dist[a[number + 1]]){
        mn++, mx++;
        dfs(a[number + 1], number + 1);
    } else {
        if (cnt > 1)
            mx++;
        dfs(a[number + 1], number + 1);
    }
}

int main(){
    ios_base::sync_with_stdio(NULL);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m;
    for (int i = 1; i <= m; i++){
        int v, u;
        cin >> v >> u;
        g[v].pb(u);
        gr[u].pb(v);
    }
    for (int i = 1; i <= n; i++)
        dist[i] = inf;
    cin >> k;
    for (int i = 1; i <= k; i++){
        cin >> a[i];
    }
    start = a[1];
    fin = a[k];
    bfs(fin);
    dfs(start, 1);
    cout << mn << ' ' << mx;
    return 0;
}