#include <bits/stdc++.h>

//#define Deb

#define f first
#define s second
#define all(a) a.begin(),a.end()
#define rall(a) a.rbegin(),a.rend()
#define push push_back
#define out cout << fixed << setprecision(15)
#define sort stable_sort

using namespace std;

typedef long long ll;
typedef long double ld;

mt19937 rnd(1234567);

const int MAXN = 2e5 + 1, INF = 1e9;

vector <int> g[MAXN], path, dist(MAXN, INF), _g[MAXN];

void bfs() {
    int v = path.back();
    vector <int> q {v};
    dist[v] = 0;
    for (int i = 0; i < q.size(); ++i) {
        v = q[i];
        for (int u: _g[v]) {
            if (dist[u] > dist[v] + 1) {
                dist[u] = dist[v] + 1;
                q.push(u);
            }
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    #ifdef Deb
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    #endif
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        g[a].push(b);
        _g[b].push(a);
    }
    int k;
    cin >> k;
    path.resize(k);
    for (int &i: path) {
        cin >> i;
    }
    bfs();
    int mn = 0, mx = 0;
    for (int i = 1; i < k; ++i) {
        if (dist[path[i]] + 1 != dist[path[i - 1]]) {
            ++mn;
            ++mx;
        } else {
            int f = 0;
            for (int u: g[path[i - 1]]) {
                f |= (u != path[i] && dist[u] == dist[path[i]]);
            }
            mx += f;
        }
    }
    cout << mn << ' ' << mx;
    return 0;
}
