#include <bits/stdc++.h>

//#define Deb

#define int ll
#define f first
#define s second
#define all(a) a.begin(),a.end()
#define rall(a) a.rbegin(),a.rend()
#define push push_back
#define out cout << fixed << setprecision(15)
#define sort stable_sort

using namespace std;

typedef long long ll;
typedef long double ld;

mt19937 rnd(1234567);

const int MAXN = 3e5 + 1, MAXX = 1e6 + 1337, INF = 1e14;

vector <pair <int, int>> v[MAXX];

int t[MAXX * 2], p[MAXX * 2];

void push(int i, int l, int r) {
    if (l == r - 1) {
        return;
    }
    int m = (r + l) / 2;
    t[i + 1] += p[i];
    t[i + 2 * (m - l)] += p[i];
    p[i + 1] += p[i];
    p[i + 2 * (m - l)] += p[i];
    p[i] = 0;
}

void add(int i, int l, int r, int L, int R, int x) {
    push(i, l, r);
    if (l >= R || r <= L) {
        return;
    }
    if (l >= L && r <= R) {
        t[i] += x;
        p[i] += x;
        return;
    }
    int m = (r + l) / 2;
    add(i + 1, l, m, L, R, x);
    add(i + 2 * (m - l), m, r, L, R, x);
    t[i] = max(t[i + 1], t[i + 2 * (m - l)]);
}

int get(int i, int l, int r, int L, int R) {
    push(i, l, r);
    if (l >= R || r <= L) {
        return -INF;
    }
    if (l >= L && r <= R) {
        return t[i];
    }
    int m = (r + l) / 2;
    return max(get(i + 1, l, m, L, R), get(i + 2 * (m - l), m, r, L, R));
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    #ifdef Deb
    freopen("in.txt", "r", stdin);
//    freopen("out.txt", "w", stdout);
    #endif
    int n, m, p;
    cin >> n >> m >> p;
    vector <pair <int, int>> a(n + 2), b(m + 2);
    for (int i = 1; i <= n; ++i) {
        cin >> a[i].f >> a[i].s;
    }
    for (int i = 1; i <= m; ++i) {
        cin >> b[i].f >> b[i].s;
    }
    a[n + 1] = {INF, INF};
    b[n + 1] = {INF, INF};
    sort(all(a));
    sort(all(b));
//    cout << "KEK" << endl;
    for (int i = n; i; --i) {
        a[i].s = min(a[i].s, a[i + 1].s);
    }
    for (int i = m; i; --i) {
        b[i].s = min(b[i].s, b[i + 1].s);
        if (b[i].f != b[i + 1].f) {
            add(1, 1, MAXX, b[i].f, b[i].f + 1, -b[i].s);
        } else {
            add(1, 1, MAXX, b[i].f, b[i].f + 1, -b[i].s + b[i + 1].s);
        }
    }
    for (int i = 0; i < p; ++i) {
        int x, y, k;
        cin >> x >> y >> k;
        v[x].push({y, k});
    }
    ll ans = -INF;
    for (int i = 0; i < MAXX; ++i) {
        sort(all(v[i]));
        ll cst = -upper_bound(all(a), make_pair(i + 1, ll(-1)))->s;
        for (int j = 0; j < (int)v[i].size(); ++j) {
            add(1, 1, MAXX, v[i][j].f, MAXX, v[i][j].s);
        }
        ll tmp = cst + get(1, 1, MAXX, 1, b[m].f);
        ans = max(ans, tmp);
    }
    cout << ans;
    return 0;
}
