#include <algorithm>
#include <iostream>
#include <vector>
#include <cmath>
#include <ctime>
#include <queue>
#include <set>
#include <map>
using namespace std;

vector<vector<int> > g;

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    g.resize(n);
    for(int i = 0; i<m; i++){
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        g[b].push_back(a);
    }
    vector<pair<int, int> > d(n, {1'000'000'000, 1});
    int k;
    cin >> k;
    vector<int> p(k);
    for(int i = 0; i<k; i++){
        cin >> p[i];
        p[i]--;
    }
    int s = p[0], t = p[k-1];
    d[t] = {0, 1};
    vector<char> u(n, false);
    queue<int> q;
    q.push(t);
    while(!q.empty()){
        int v = q.front();
        q.pop();
        for(int i = 0; i<g[v].size(); i++){
            int to = g[v][i];
            if(d[to].first>d[v].first+1){
                d[to] = d[v];
                d[to].first++;
                if(!u[to]){
                    q.push(to);
                    u[to] = true;
                }
            }
            else if(d[to].first==d[v].first+1)
                d[to].second += d[v].second;
        }
    }
    int mn = 0, mx = 0;
    for(int i = 0; i<k-1; i++){
        //cout << d[p[i]].first << ':' << d[p[i]].second << endl;
        if(d[p[i]].first-1!=d[p[i+1]].first){
            mn++;
            mx++;
        }
        else if(d[p[i]].second!=1)
            mx++;
    }
    cout << mn << ' ' << mx;

    return 0;
}
