#include <bits/stdc++.h>

#define SWS ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define ft first
#define sd second
#define pb push_back
#define ppb pop_back

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

const int Z = (int)1e3 + 228;
const int N = (int)2e5 + 228;
const int INF = (int)1e9 + 228;
const int MOD = (int)1e9 + 7;
const ll LLINF = (ll)1e18 + 228;

vector<int> g[N][2];
int path[N];
int n, m;

vector<int> bfs(int x, int f) {
    vector<bool> used(n + 1, false);
    queue<int> q;
    q.push(x);
    used[x] = true;
    vector<int> dist(n + 1, 0);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (int to : g[v][f]) {
            if (!used[to]) {
                used[to] = true;
                dist[to] = dist[v] + 1;
                q.push(to);
            }
        }
    }
    return dist;
}

int main() {
    SWS;
    cin >> n >> m;
    for (int i = 1; i <= m; i++) {
        int x, y;
        cin >> x >> y;
        g[x][0].pb(y);
        g[y][1].pb(x);
    }
    int k;
    cin >> k;
    for (int i = 1; i <= k; i++) {
        cin >> path[i];
    }
    int s = path[0], t = path[k];
    vector<int> dist1 = bfs(s, 0);
    vector<int> dist2 = bfs(t, 1);
    int ans_min = 0, ans_max = 0;
    for (int i = 1; i < k; i++) {
        int v = path[i], nxt = path[i + 1];
        int mn = INF, cnt = 0;
        for (int to : g[path[i]][0]) {
            if (i - 1 + dist2[to] + 1 < mn) {
                mn = i - 1 + dist2[to] + 1;
                cnt = 1;
            }
            else if (i - 1 + dist2[to] + 1 == mn) {
                cnt++;
            }
        }
//        cout << "DEBUG : " << i << ' ' << mn << ' ' << cnt << endl;
        if (i + dist2[nxt] > mn) {
            ans_min++;
            ans_max++;
        }
        else {
            if (cnt != 1) ans_max++;
        }
    }
    cout << ans_min << ' ' << ans_max;
    return 0;
}
