#include <bits/stdc++.h>

using namespace std;
//typedef long long ll;typedef long long LL;typedef unsigned long long ull;typedef unsigned long long uLL;typedef unsigned int uint;

//#define all(x) (x).begin(), (x).end()
//#define rall(x) (x).end(), (x).begin()

void go(vector< vector<int> > &rgraph, vector<long long> &path_count, vector<long long> &path_values, int now, vector<bool> &visited, long long cur_length) {
    ++cur_length;

    if (cur_length < path_values[now]) {
        path_values[now] = cur_length;
        path_count[now] = 1;
    } else if (cur_length == path_values[now]) {
        ++path_count[now];
    } else {
        return;
    }

    visited[now] = true;
    for (int i = 0; i < rgraph[now].size(); ++i) {
        if (!visited[rgraph[now][i]]) {
            go(rgraph, path_count, path_values, rgraph[now][i], visited, cur_length);
        }
    }
    visited[now] = false;
}

int main() {
    ios_base::sync_with_stdio(false);cin.tie(NULL);cout.tie(NULL);

    int tmp_int, n, m, u, v, k;
    cin >> n >> m;
    vector<int> tmp_v_int;
    vector< vector<int> > rgraph(n, tmp_v_int);
    vector<int> p;
    for (int i = 0; i < m; ++i) {
        cin >> u >> v;

        tmp_v_int = rgraph[v - 1];
        tmp_v_int.push_back(u - 1);
        rgraph[v - 1] = tmp_v_int;
    }
    cin >> k;
    for (int i = 0; i < k; ++i) {
        cin >> tmp_int;
        p.push_back(tmp_int - 1);
    }

    vector<long long> path_count(n, 0);
    vector<long long> path_values(n, INT_MAX);
    vector<bool> visited(n, false);
    go(rgraph, path_count, path_values, p[k - 1], visited, 0);

    //for (int i = 0; i < n; ++i) {
    //    cout << path_count[i] << ' ';
    //}
    //cout << endl;

    long long ans_min = 0, ans_max = 0;

    for (int step = 1; step < k; ++step) {
        if (path_values[p[step]] + 1 == path_values[p[step - 1]]) {
            if (path_count[p[step - 1]] != 1) {
                ++ans_max;
            }
        } else {
            ++ans_min;
            ++ans_max;
        }
    }

    cout << ans_min << ' ' << ans_max << endl;
}
