#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

//#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("Ofast")
//#pragma GCC optimize "-O3"

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (ll)(x).size()

void faster(){
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int main() {
    ll n, m;
    cin >> n >> m;
    vector <vector <ll> > g(n + 1);
    vector <vector <ll> > g1(n + 1);
    for (int i = 0; i < m; i++)
    {
        ll a, b;
        cin >> a >> b;
        g[b].push_back(a);
        g1[a].push_back(b);
    }
    ll q;
    cin >> q;
    vector <ll> t(q);
    map <pair <ll, ll>, bool> nuse;
    for (int i = 0; i < q; i++)
    {
        cin >> t[i];
        if (i != 0)
            nuse[{t[i - 1], t[i]}] = true;
    }
    ll from = t[q - 1];
    vector <ll> dist(n + 1, 1e9);
    dist[from] = 0;
    queue <int> lol;
    lol.push(from);
    while (!lol.empty())
    {
        int now = lol.front();
        lol.pop();
        for (auto to : g[now])
        {
            if (dist[to] > dist[now] + 1)
            {
                dist[to] = dist[now] + 1;
                lol.push(to);
            }
        }
    }
    ll max = 0, min = 0;
    for (int i = 0; i < q - 1; i++)
    {
        ll j = t[i];
        if (dist[j] != dist[t[i + 1]] + 1)
        {
            max++;
            min++;
        }
        else
            for (auto to : g1[j])
            {
                if (dist[to] + 1 == dist[j] && to != t[i + 1])
                {
                    max++;
                    break;
                }
            }
    }
    cout << min << " " << max << endl;
    return 0;
}
