#include <bits/stdc++.h>

//#define int long long
#define endl "\n"
#define pii pair<int, int>
#define B begin
#define E end
#define F first
#define S second

using namespace std;

typedef long long ll;

const int INF = 1e9 + 1;
const ll P = 1e9 + 7;


void hello()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    freopen("input.txt", "r", stdin);
}

void show(vector <int>& arr)
{
    for (auto i : arr)
        cout << i << " ";
    cout << endl;
}

void show(vector <vector <int>>& arr)
{
    for (auto i : arr)
        show(i);
    cout << endl;
}



signed main()
{
    hello();

    int n, m;
    cin >> n >> m;
    vector <vector <int>> graph(n);
    for (int i = 0; i < m; ++i)
    {
        int x, y;
        cin >> x >> y;
        graph[y - 1].push_back(x - 1);
    }

    int k;
    cin >> k;
    vector <int> seq(k);
    for (int i = 0; i < k; ++i)
    {
        cin >> seq[i];
        --seq[i];
    }
    vector <int> dist(n, INF);
    vector <int> check(n);
    dist[seq.back()] = 0;
    queue <int> q;
    q.push(seq.back());

    while (q.size())
    {
        int v = q.front();
        q.pop();
        for (auto to : graph[v])
            if (dist[to] == INF)
            {
                dist[to] = dist[v] + 1;
                q.push(to);
            }
            else if (dist[to] == dist[v] + 1)
                check[to] = 1;
    }

    int rmin = 0, rmax = 0;
    for (int i = 0; i < k - 1; ++i)
    {
        if (dist[seq[i + 1]] + 1 != dist[seq[i]])
        {
            ++rmin;
            ++rmax;
        }
        else if (check[seq[i]])
        {
            ++rmax;
        }
    }
    cout << rmin << " " << rmax << endl;
}
