#include <bits/stdc++.h>
#define FOR(i, n) for (int i = 0; i < n; ++i)
#define pb push_back
#define mp make_pair
#define debug(x) std::cout << #x << ": " << x << '\n';
typedef long long ll;
const int N = 2e5 + 100;
std::vector<int> g[N], gr[N];
int d[N];
void bfs(int T) {
	memset(d, -1, sizeof(d));
	std::queue<int> q;
	q.push(T);
	d[T] = 0;
	while (!q.empty()) {
		int v = q.front();
		q.pop();
		for (auto e : gr[v]) {
			if (d[e] == -1) {
				d[e] = d[v] + 1;
				q.push(e);
			}
		}
	}
}
int main() {
	std::ios::sync_with_stdio(false); std::cin.tie(0); std::cout.tie(0);
	int n, m;
	std::cin >> n >> m;
	FOR(i, m) {
		int a, b;
		std::cin >> a >> b;
		--a; --b;
		g[a].pb(b);
		gr[b].pb(a);
	}
	int k;
	std::cin >> k;
	std::vector<int> p(k);
	FOR(i, k) {
		std::cin >> p[i];
		--p[i];
	}
	bfs(p.back());
	int min = 0, max = 0;
	FOR(i, k - 1) {
		int nowMinPath = 1e9, cntMin = 0;
		int v = p[i], to = p[i + 1];
		for (auto e : g[v]) {
			nowMinPath = std::min(nowMinPath, d[e]);
			// debug(e << ' ' << d[e])
		}
		for (auto e : g[v]) {
			if (d[e] == nowMinPath) {
				cntMin++;
			}
		}
		// debug(nowMinPath << ' ' << cntMin)
		for (auto e : g[v]) {
			if (e == to && d[e] == nowMinPath) {
				if (cntMin >= 2) {
					max++;
				}
			}
			else if (e == to) {
				min++, max++;
				break;
			}
		}
	}
	std::cout << min << ' ' << max;
}