#include<iostream>
#include<vector>
#include<algorithm>
#include<string>
#include<cmath>
#include<math.h>
#include<map>
#include<unordered_map>
#include<set>
#include<unordered_set>
#define int long long

using namespace std;

vector<vector<int>> gr, rgr, p;
vector<int> d;

void bfs(int v, int dist){
	for(int i = 0; i < rgr[v].size(); ++i){
		int u = rgr[v][i];
		if(d[u] == -1 || d[u] > dist + 1){
			p[u].clear();
			p[u].push_back(v);
			d[u] = dist + 1;
			bfs(u, dist + 1);
		}
		else{
			if(d[u] == dist + 1)
				p[u].push_back(v);
		}
	}
}

signed main(){
	cin.tie(0);
	ios_base::sync_with_stdio(0);

	int n, m;
	cin >> n >> m;
	gr.resize(n);
	rgr.resize(n);
	p.resize(n);
	d.resize(n, -1);
	for(int i = 0; i < m; ++i){
		int v, u;
		cin >> v >> u;
		gr[--v].push_back(--u);
		rgr[u].push_back(v);
	}
	int a;
	cin >> a;
	vector<int> path(a);
	for(int i = 0; i < a; ++i){
		cin >> path[i];
		--path[i];
	}
	bfs(path.back(), 0);
	int min = 0, max = 0;
	for(int i = 1; i < a; ++i){
		if(find(p[path[i - 1]].begin(), p[path[i - 1]].end(), path[i]) == p[path[i - 1]].end()){
			++min;
			++max;
		}
		else{
			if(p[path[i - 1]].size() > 1)
				++max;
		}
	}
	cout << min << ' ' << max;
	return 0;
}