#include <iostream>
#include <vector>
#include <cmath>
#include <set>
#include <map>
#include <queue>
#include <bitset>
#include <algorithm>

using namespace std;

#define X first
#define Y second
#define vi vector<int>
#define vvi vector<vi>
#define vb vector<char>
#define pii pair<int, int>
#define vpii vector<pii>
#define len(V) (int)V.size()
#define all(V) V.begin(), V.end()
#define pb push_back
#define mp make_pair

//#define int ll
#define ever ;;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

const int inf = 1e9 + 7, mod = 1e9 + 7;
const ll INF = 1e18 +7;

vvi G0, V;
vb U;
vi Dist, P;
int ans0 = 0, ans1 = 0;

void BFS(int v0) {
    queue<int> Q;
    int v;
    Q.push(v0);
    while (len(Q)) {
        v = Q.front();
        Q.pop();
        for (auto u : G0[v]) {
            if (Dist[u]) {
                if (Dist[v] + 1 > Dist[u])
                    continue;
                V[u].pb(v);
                continue;
            }
            Q.push(u);
            Dist[u] = Dist[v] + 1;
            V[u].pb(v);
        }
    }
}

void DFS(int v, bool f) {
    if (v == len(P) - 1)
        return;
    bool fl = true;
    for (auto u : V[P[v]]) {
        if (u == P[v + 1]) {
            fl = false;
            DFS(v + 1, f);
            if (len(V[P[v]]) > 1)
                ++ans1;
            break;
        }
    }
    if (fl) {
        ++ans0;
        ++ans1;
        DFS(v + 1, false);
    }
}

void run() {
    int n, m, a, b;
    cin >> n >> m;
    G0.resize(n);
    V.resize(n);
    U.resize(n);
    Dist.resize(n);
    for (int i = 0; i < m; ++i) {
        cin >> a >> b;
        G0[--b].pb(--a);
    }
    cin >> b;
    P.resize(b);
    for (auto &it : P) {
        cin >> it;
        --it;
    }
    BFS(P.back());
    /*
    for (int i = 0; i < n; ++i) {
        cout << i + 1 << '\n';
        for (auto u : V[i])
            cout << u + 1 << ' ';
        cout << '\n';
    }
     //*/
    DFS(0, true);
    cout << ans0 << ' ' << ans1;
}

int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);

    int t = 1;
    //cin >> t;
    for (int i = 0; i < t; ++i) {
        run();
        cout << '\n';
    }
    return 0;
}