#include <iostream>
#include <time.h>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <vector>
#include <string>
#include <algorithm>
#include <ostream>
#include <istream>
#include <iomanip>
#include <random>
#include <stack>
#include <queue>
#include <deque>

using namespace std;

#define int long long
#define ld long double
#define pb push_back
#define all(a) (a).begin(), (a).end()

ostream& operator<<(ostream& a, vector<int>& b) {
    for (auto k : b) cout << k << " ";
    return a;
}

#ifdef LOCAL
    #define dbg(x) cout << #x << " : " << x << "\n";
#else
    #define dbg(x)
#endif

const int INF = 1e9;

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    vector<int> b(n);
    for (int i = 0; i < n; i++) cin >> b[i];
    int cnt01 = 0, cnt10 = 0, cnt11 = 0;
    for (int i = 0; i < n; i++) {
        if (a[i] && b[i]) cnt11++;
        else if (a[i]) cnt10++;
        else if (b[i]) cnt01++;
    }
//    cout << (cnt01 + cnt10 - 1) / cnt10;
    int l = 1, r = INF, mid;
    while (r - l > 1) {
        mid = (l + r) / 2;
        if (mid * cnt10 + cnt11 > cnt11 + cnt01) r = mid;
        else l  = mid;
    }
    if (cnt11 + cnt10 > cnt11 + cnt01) {
        cout << 1;
        return;
    }
    dbg(l);
    dbg(r);
    if (r * cnt10 + cnt11 <= cnt11 + cnt01) {
        cout << -1;
        return;
    }else cout << r;

}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int q = 1;
//    cin >> q;
    while (q--) solve();
}

/*

*/
