#include <iostream>
#include <time.h>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <vector>
#include <string>
#include <algorithm>
#include <ostream>
#include <istream>
#include <iomanip>
#include <random>
#include <stack>
#include <queue>
#include <deque>

using namespace std;

#define int long long
#define ld long double
#define pb push_back
#define all(a) (a).begin(), (a).end()

ostream& operator<<(ostream& a, vector<int>& b) {
    for (auto k : b) cout << k << " ";
    return a;
}

#ifdef LOCAL
    #define dbg(x) cout << #x << " : " << x << "\n";
#else
    #define dbg(x)
#endif

const int INF = 1e9;

string del(string a, int pos) {
    string kek = "";
    int as = a.size();
    for (int i = 0; i < as; i++) {
        if (i != pos) kek += a[i];
    }
    return kek;
}

bool can(string s, int pos) {
    if (s[pos] == 'a' || s.size() == 1) return 0;
    if (pos == 0) {
        if (s[pos + 1] == char(s[pos] - 1)) return 1;
        return 0;
    } else if (pos == s.size() - 1) {
        if (s[pos - 1] == char(s[pos] - 1)) return 1;
        return 0;
    }
    if (s[pos - 1] == char(s[pos] - 1)) return 1;
    if (s[pos + 1] == char(s[pos] - 1)) return 1;
    return 0;
}


void solve() {
    int n;
    cin >> n;
    string s;
    cin >> s;
    for (char i = 'z'; i >= 'a'; i--) {
        for (int j = 0; j < s.size(); j++) {
            while (j < s.size() && s[j] == i && can(s, j)) {
                s = del(s, j);
                j = 0;
            }
        }
    }
    cout << n - s.size();
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int q = 1;
//    cin >> q;
    while (q--) solve();
}

/*

*/
