#include <bits/stdc++.h>
using namespace std;

#define ll long long
#define ld long double
#define pb push_back
#define mp make_pair
#define all(x) x.begin(), x.end()
#define lb lower_bound
#define ub upper_bound
#define boost cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0)
#define pii pair <int, int>
#define pll pair <ll, ll>

const int N = 2e5 + 144, inf = 1e9 + 7, mod = 1e9 + 7;
const ll INF = 1e18;
const double pi = acos(-1.0);
int n, m, k, a[N], d[N];
vector <int> g[N], ug[N];

ll bp(int x, int y){
    if(y == 0) return 1;
    if(y & 1) return (bp(x, y - 1) * x) % mod;
    ll z = bp(x, y / 2);
    return (z * z) % mod;
}


int main(){
    boost;
    cin >> n >> m;
    for(int i = 1; i <= m; i++){
        int x, y;
        cin >> x >> y;
        g[x].pb(y);
        ug[y].pb(x);
    }
    cin >> k;
    if(k == 2){
        cout << "0 0";
        return 0;
    }
    for(int i = 1; i <= k; i++){
        cin >> a[i];
    }
    queue <int> q;
    q.push(a[k]);
    for(int i = 1; i <= n; i++)
        d[i] = inf;
    d[a[k]] = 0;
    while(!q.empty()){
        int v = q.front();
        q.pop();
        for(auto to: ug[v]){
            if(d[v] + 1 < d[to]){
                d[to] = d[v] + 1;
                q.push(to);
            }
        }
    }
    int ans = 0, t = 0;
    for(int i = 1; i < k; i++){
        if(d[a[i]] <= d[a[i + 1]]){
            ans++;
            t++;
            continue;
        }
        for(auto to: g[a[i]]){
            if(to != a[i + 1] && d[to] <= d[a[i + 1]]){
                ans++;
                break;
            }
        }
    }
    cout << t << " " << ans;
    return 0;
}
