#include <bits/stdc++.h>
using namespace std;

#define ll long long
#define ld long double
#define pb push_back
#define mp make_pair
#define f first
#define se second
#define all(x) x.begin(), x.end()
#define lb lower_bound
#define ub upper_bound
#define boost cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0)
#define pii pair <int, int>
#define pll pair <ll, ll>

const int N = 1e6 + 144, inf = 1e9 + 7, mod = 1e9 + 7;
const ll INF = 1e18;
const double pi = acos(-1.0);
ll n, m, p, d[N], f[N], mx, t[4 * N], cc[4 * N];
pair <pll, ll> c[N];

ll bp(int x, int y){
    if(y == 0) return 1;
    if(y & 1) return (bp(x, y - 1) * x) % mod;
    ll z = bp(x, y / 2);
    return (z * z) % mod;
}

void build(int v, int tl, int tr){
    if(tl == tr){
        t[v] = f[tl];
        return;
    }
    int tm = (tl + tr) >> 1;
    build(v + v, tl, tm);
    build(v + v + 1, tm + 1, tr);
    t[v] = min(t[v + v], t[v + v + 1]);
}

void upd(int v, int tl, int tr, int l, int r, int val){
    if(l > r) return;
    if(l > tr || r < tl) return;
    if(l <= tl && tr <= r){
        t[v] -= val;
        cc[v] += val;
        return;
    }
    int tm = (tl + tr) >> 1;
    t[v + v] -= cc[v];
    t[v + v + 1] -= cc[v];
    cc[v + v] += cc[v];
    cc[v + v + 1] += cc[v];
    cc[v] = 0;
    upd(v + v, tl, tm, l, r, val);
    upd(v + v + 1, tm + 1, tr, l, r, val);
    t[v] = min(t[v + v], t[v + v + 1]);
}

int main(){
    boost;
    cin >> n >> m >> p;
    for(int i = 1; i <= 1e6 + 100; i++)
        d[i] = INF;
    for(int i = 1; i <= n; i++){
        ll a, ca;
        cin >> a >> ca;
        d[a] = min(ca, d[a]);
    }
    for(int i = 1e6; i >= 1; i--)
        d[i] = min(d[i + 1], d[i]);
    for(int i = 1; i <= 1e6 + 100; i++)
        f[i] = INF;
    for(int i = 1; i <= m; i++){
        ll a, ca;
        cin >> a >> ca;
        mx = max(mx, a);
        f[a] = min(ca, f[a]);
    }
    for(int i = 1e6; i >= 1; i--)
        f[i] = min(f[i + 1], f[i]);
    for(int i = 0; i < p; i++){
        cin >> c[i].f.f >> c[i].f.se >> c[i].se;
    }
    sort(c, c + p);
    build(1, 1, mx);
    ll ans = -d[1] - f[1];
    for(int i = 0; i < p; i++){
        if(d[c[i].f.f + 1] == INF) break;
        upd(1, 1, mx, c[i].f.se + 1, mx, c[i].se);
        ans = max(ans, -(d[c[i].f.f + 1] + t[1]));
    }
    cout << ans;
    return 0;
}
