#include <bits/stdc++.h>

using namespace std;

#define int long long

const int big = 1e18;

void solve() {
    int n, m;
    cin>> n >> m;
    vector <int> g[n];
    vector <int> g1[n];
    for (int i = 0; i < m; ++i) {
        int v, u;
        cin >> v >> u;
        --v;
        --u;
        g[u].push_back(v);
        g1[v].push_back(u);
    }
    int k;
    cin >> k;
    int p[k];
    for (int i = 0; i < k; ++i) cin >> p[i];
    int t = p[k - 1] - 1;
    vector <pair <int, int> > dist(n, {big, 0});
    queue <int> q;
    q.push(t);
    dist[t] = {0, 1};
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (auto u : g[v]) {
            if (dist[u].first > dist[v].first + 1) {
                dist[u] = {dist[v].first + 1, 1};
                q.push(u);
            }
            else if (dist[u].first == dist[v].first + 1) {
                ++dist[u].second;
            }
        }
    }
    //for (int i = 0; i < n; ++i) cout << i << ' ' << dist[i].first << endl;
    int mi = 0, ma = 0;
    for (int i = 1; i < k; ++i) {
        int v = p[i - 1] - 1, u = p[i] - 1;
        if (dist[v].first - 1 != dist[u].first) {
            ++mi;
            ++ma;
        }
        else {
            for (auto tu : g1[v]) {
                if (tu != u && dist[tu].first == dist[u].first) {
                    ++ma;
                    break;
                }
            }
        }
    }
    cout << mi << ' ' << ma << endl;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    /*freopen("input.in", "r", stdin);
    freopen("output.out", "w", stdout);*/
    solve();
    return 0;
}
