#include <bits/stdc++.h>

using namespace std;

#define int long long

const int maxn = 2e5, big = 1e18;
int t[4 * maxn + 5], sum[4 * maxn + 5];
vector <pair <int, int> > a;

void build(int v, int l, int r) {
    sum[v] = 0;
    if (l == r - 1) {
        t[v] = -a[l].second;
        return;
    }
    int m = (l + r) / 2;
    build(2 * v, l, m);
    build(2 * v + 1, m, r);
    t[v] = max(t[2 * v], t[2 * v + 1]);
}

int get(int v, int l, int r, int tl, int tr) {
    if (l >= tr || tl >= r) return -big;
    if (l <= tl && r >= tr) return t[v] + sum[v];
    int tm = (tl + tr) / 2;
    return max(get(2 * v, l, r, tl, tm) + sum[2 * v], get(2 * v + 1, l, r, tm, tr) + sum[2 * v + 1]);
}

void upd(int v, int l, int r, int tl, int tr, int c) {
    if (l >= tr || tl >= r) return;
    if (l <= tl && r >= tr) {
        sum[v] += c;
        return;
    }
    int tm = (tl + tr) / 2;
    upd(2 * v, l, r, tl, tm, c);
    upd(2 * v + 1, l, r, tm, tr, c);
    t[v] = max(t[2 * v] + sum[2 * v], t[2 * v + 1] + sum[2 * v + 1]);
}

void solve() {
    int n, m, p;
    cin >> n >> m >> p;
    a.resize(n);
    for (int i = 0; i < n; ++i) cin >> a[i].first >> a[i].second;
    sort(a.begin(), a.end());
    vector <pair <int, int> > br(m);
    for (int i = 0; i < m; ++i) cin >> br[i].first >> br[i].second;
    sort(br.begin(), br.end());
    int idb = 0;
    vector <pair <int, pair <int, int> > > mnstr(p);
    for (int i = 0; i < p; ++i) cin >> mnstr[i].second.first >> mnstr[i].first >> mnstr[i].second.second;
    sort(mnstr.begin(), mnstr.end());
    build(1, 0, n);
    int idm = 0;
    int pr[m + 1];
    pr[0] = big;
    for (int i = 0; i < m; ++i) pr[i + 1] = min(pr[i], br[m - i - 1].second);
    int ans = t[1] + sum[1] - pr[m];
    /*for (int i =  0; i <= m; ++i) cout << pr[i] << ' ';
    cout << endl;*/
    while (idb < m) {
        int mi = pr[m - idb];
        while (idm < p && mnstr[idm].first < br[idb].first) {
            int l = -1, r = n;
            while (l < r - 1) {
                int tm = (l + r) / 2;
                if (a[tm].first > mnstr[idm].second.first) r = tm;
                else l = tm;
            }
            upd(1, r, n, 0, n, mnstr[idm].second.second);
            ans = max(ans, t[1] + sum[1] - mi);
            //cout << idb << ' ' << idm << ' ' << mi << ' ' << r << ' ' << ans << endl;
            ++idm;
        }
        ++idb;
    }
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    /*freopen("input.in", "r", stdin);
    freopen("output.out", "w", stdout);*/
    solve();
    return 0;
}
