//#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

#define all(a) a.begin(), a.end()
#define rall(a) a.end(), a.begin()

#define yes "YES"
#define no "NO"

#define INTMX (int)1e8
#define LLMX (ll)1e18

#define INF (ll)1e8
#define MOD 1000000000 + 7

#define pb push_back
#define eb emplace_back

using namespace std;

const int TREE_SIZE = 8 * 100000;

#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")

//struct segment_tree{
//    ll tree[TREE_SIZE];
//    vector <ll> q;
//    segment_tree(vector <ll> a){
//        q = a;
//    }
//
//    void build(ll node, ll l, ll r, ll tl, ll tr){
//        if(tl == tr){
//            tree[node] = q[l];
//            return;
//        }
//
//        ll mid = (tl + tr) / 2;
//
//        build(node * 2, l, )
//    }
//};


//                 ________
//    | |         /        \  | |
//    | |         |        |  | |
//    | |         |        |  | |
//    | |         |        |  | |
//    | |         |        |  | |
//    | |         |        |  | |
//    | |_______  |        |  | |_______
//    \_________| \________/  \_________|


void solve(){
    ll n;
    cin >> n;
    vector < ll > a(n, 0);
    for(int i = 0; i < n; ++i)
        cin >> a[i];

    vector <ll> b(n, -1);
    set < ll > c;
    unordered_map <ll, vector <ll> > q;
    for(int i = 0; i < n; ++i){
        c.insert(a[i]);
        q[a[i]].pb(i);
    }

    for(int i = 0; i < n; ++i){
        ll x = a[i];
        auto it = c.find(a[i]);

        ++it;
        bool g = true;
        for(; it != c.end() and g; ++it){
            for(auto to : q[*it]){
                if(to <= i) continue;
                if(to - i == *it - x){
                    b[i] = to;
                    g = 0;
                    break;
                }
            }
        }
    }

    ll sm = -INF;
    vector <bool> used(n, 0);
    for(int i = 0; i < n; ++i){
        if(used[i]) continue;
        ll sm2 = 0;
        ll p = i;
        while(p != -1){
            used[p] = 1;
            sm2 += a[p];
            p = b[p];
        }
        sm = max(sm, sm2);
    }
    cout << sm;
}


int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll t = 1;
//    cin >> t;
    while(t--)
        solve();
    return 0;
}