#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define ll long long
#define ld long double
#define pii pair<int, int>
#define fs first
#define sc second
#define pb push_back
#define mp make_pair
#define fast_io ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define endl '\n'

typedef tree<int,null_type,less<int>,rb_tree_tag,tree_order_statistics_node_update> ordered_set;

const int N = 200000 + 50;

vector<int> g[N], gr[N];
int dist_s[N], dist[N], p[N], s, k, t, n, m;
bool vis[N];
queue<int> q;

signed main()
{
    fast_io;

    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        g[u].pb(v);
        gr[v].pb(u);
    }
    cin >> k;
    for (int i = 0; i < k; i++) {
        cin >> p[i];
        p[i]--;
    }
    s = p[0], t = p[k - 1];

    q.push(t);
    vis[t] = true;
    while(!q.empty()) {
        int v = q.front();
        q.pop();

        for (int i = 0; i < gr[v].size(); i++) {
            int to = gr[v][i];
            if (!vis[to]) {
                q.push(to);
                dist[to] = dist[v] + 1;
                vis[to] = true;
            }
        }
    }

    int mn = 0, mx = 0;
    for (int i = 0; i < k - 1; i++) {
        int dst = dist[p[i]];
        if (dist[p[i + 1]] != dist[p[i]] - 1) {
            mx++, mn++;
            continue;
        }
        bool only = true;
        for (int j = 0; j < g[p[i]].size(); j++) {
            int to = g[p[i]][j];
            if (to == p[i + 1])
                continue;
            if (dist[to] == dist[p[i]] - 1)
                only = false;
        }
        if (!only)
            mx++;
    }

    cout << mn << " " << mx;


    return 0;
}
