#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define ll long long
#define ld long double
#define pii pair<int, int>
#define fs first
#define sc second
#define pb push_back
#define mp make_pair
#define fast_io ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define endl '\n'

typedef tree<int,null_type,less<int>,rb_tree_tag,tree_order_statistics_node_update> ordered_set;

const int N = 200000 + 50, INF = 2000000000 + 7;

int t[4 * N], pt[4 * N], n, m, p, a[N], b[N], ca[N], cb[N], order_a[N], order_b[N], enem[N], x[N], y[N], z[N];

bool compA(int x, int y) {
    return a[x] < a[y];
}
bool compB(int x, int y) {
    return b[x] < b[y];
}
bool compE(int aa, int bb) {
    return x[aa] < x[bb];
}

void init() {
    for (int i = 0; i < 4 * N; i++) {
        t[i] = -INF;
    }
}

inline int getMore(int x) {
    if (b[order_b[m - 1]] <= x)
        return m;
    int l = 0, r = m - 1;
    while(l != r) {
        int mid = (l + r) / 2;
        if (b[order_b[mid]] <= x)
            l = mid + 1;
        else
            r = mid;
    }
    return l;
}

void update(int v, int tl, int tr, int pos, int val) {
    if (pos < tl || pos > tr)
        return;
    t[v] = max(t[v], val);
    if (tl == tr)
        return;

    int tm = (tl + tr) / 2;
    update(v * 2, tl, tm, pos, val);
    update(v * 2 + 1, tm + 1, tr, pos, val);
}

inline void push(int v, int tl, int tr) {
    t[v] += pt[v];
    if (tl != tr) {
        pt[v * 2] += pt[v];
        pt[v * 2 + 1] += pt[v];
    }
    pt[v] = 0;
}

void inc(int v, int tl, int tr, int l, int r, int val) {
    if (r < l)
        return;
    push(v, tl, tr);

    if (l > tr || r < tl)
        return;
    if (tl >= l && tr <= r) {
        pt[v] += val;
        push(v, tl, tr);
        return;
    }

    int tm = (tl + tr) / 2;
    inc(v * 2, tl, tm, l, r, val);
    inc(v * 2 + 1, tm + 1, tr, l, r, val);

    t[v] = max(t[v * 2], t[v * 2 + 1]);
}

signed main()
{
    fast_io;

    init();

    cin >> n >> m >> p;
    for (int i = 0; i < n; i++) {
        cin >> a[i] >> ca[i];
        order_a[i] = i;
    }
    for (int i = 0; i < m; i++) {
        cin >> b[i] >> cb[i];
        order_b[i] = i;
    }

    sort(order_a, order_a + n, compA);
    sort(order_b, order_b + m, compB);

    for (int i = 0; i < p; i++) {
        cin >> x[i] >> y[i] >> z[i];
        enem[i] = i;
    }

    sort(enem, enem + p, compE);

    int pointer = 0;

    for (int i = 0; i < m; i++) {
        update(1, 0, m - 1, i, -cb[order_b[i]]);
    }

    int ans = 0;
    for (int i = 0; i < n; i++) {
        while(pointer < p && x[enem[pointer]] < a[order_a[i]]) {
            inc(1, 0, m - 1, getMore(y[enem[pointer]]), m - 1, z[enem[pointer]]);
            pointer++;
        }
        ans = max(ans, -ca[order_a[i]] + t[1]);
    }
    cout << ans;

    return 0;
}
