#include <iostream>
#include <string>
#include <vector>
#include <cmath>
#include <iomanip>
#include <set>
#include <map>
#include <algorithm>

using namespace std;

int n, Max = -1, Max2 = -1;
vector<bool> used, used2;
vector<vector<int> > g;
vector<pair<int, int> > arr;

bool comp(pair<int, int> &a, pair<int, int> &b){
    return a.second < b.second;
}

void dfs(int v, int curr = 0) {
    curr += arr[v].first;
    Max2 = max(curr, Max2);
    used[v] = 1;
    used2[v] = 1;
    for(int to = 0; to < g[v].size(); to++) {
        if(!used[g[v][to]])
            dfs(g[v][to], curr);
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    used2.resize(n, 0);
    arr.resize(n);
    for(int i = 0; i < n; i++) {
        cin >> arr[i].first;
        arr[i].second = i - arr[i].first;
        Max = max(Max, arr[i].first);
    }
    g.resize(n);
    sort(arr.begin(), arr.end(), comp);
    int i = 0;

    while(i < n) {
        while(i < n && arr[i].second == arr[i + 1].second) {
            if(arr[i + 1].second + arr[i + 1].first > arr[i].second + arr[i].first) {
                g[i].push_back(i + 1);
            }
            i++;
        }
        i++;
    }


    for(int i = 0; i < n; i++) {
        used.clear();
        used.resize(n, 0);
        if(!used2[i])
            dfs(i);
    }
    if(Max > Max2)
        cout << Max;
    else
        cout << Max2;
    return 0;
}
