#include <iostream>
#include <string>
#include <vector>
#include <cmath>
#include <iomanip>
#include <set>
#include <map>
#include <algorithm>

using namespace std;

long long n, Max = -1, Max2 = -1;


bool comp(pair<long long, long long> &a, pair<long long, long long> &b){
    return a.second < b.second;
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    vector<pair<long long, long long> > arr(n);
    for(long long i = 0; i < n; i++) {
        cin >> arr[i].first;
        arr[i].second = arr[i].first - i;
        Max = max(Max, arr[i].first);
    }

    sort(arr.begin(), arr.end(), comp);
    long long c = 0;

    while(c < n) {
        long long curr = 0;
        bool ind = 0;
        curr += arr[c].first;
        while(c < n - 1 && arr[c].second == arr[c + 1].second) {
            curr += arr[c + 1].first;
            c++;
            ind = 1;
        }
        if(!ind)
            c++;
        Max = max(Max, curr);

    }
    cout << Max;
    return 0;
}
