#include <bits/stdc++.h>
#define int long long 

#define ff first 
#define ss second

#define pb push_back 
#define eb emplace_back 

#define mp make_pair 

#define all(x) (x).begin(), (x).end()

#define pii pair<int, int>

#define debug(x) cout << #x << ": " << x << endl; 
#define TIME clock() / (ld)CLOCKS_PER_SEC

using namespace std; 
mt19937 rnd(time(0)); 
typedef long long ll;
typedef long double ld; 
const int maxn = 2e5 + 7, mod = 1e9 + 7, MAXN = 1e6 + 7;
const ll inf = 1e18; 
int n, m, p; 

struct state {
    int x, y, z;
};

struct hunt {
    int a, ca; 
    hunt(int a, int ca) : a(a), ca(ca) {}
    hunt() : a(0), ca(0) {} 
};  

bool operator<(hunt aa, hunt bb) {
    return aa.a < bb.a; 
}



vector<hunt> a;
vector<hunt> b; 
vector<state> have; 

bool cmp(state a, state b) {
    return a.x < b.x; 
}

struct node {
    int push, mx; 
}; 

node tree[4 * maxn]; 

void build() {
    for (int i = 0; i < 4 * maxn; ++i) tree[i] = {0, 0}; 
}

void push(int rt, int l, int r) {
    int push = tree[rt].push; 
    tree[rt].push = 0;  
    if (push == 0) return; 
    tree[rt].mx += push; 
    if (l != r) {
        tree[rt * 2 + 1].push += push; 
        tree[rt * 2 + 2].push += push;  
    }
}

int get(int l, int r, int l1, int r1, int rt) {
    push(rt, l, r);
    if (l >= l1 && r <= r1) return tree[rt].mx; 
    if (max(l, l1) > min(r, r1)) return -inf; 
    int t = (l + r) / 2; 
    int L = get(l, t, l1, r1, rt * 2 + 1);
    int R = get(t + 1, r, l1, r1, rt * 2 + 2); 
    tree[rt].mx = max(tree[rt * 2 + 1].mx, tree[rt * 2 + 2].mx);
    return max(L, R);
}                 

void upd(int l, int r, int l1, int r1, int rt, int x) {
    push(rt, l, r); 
    if (l >= l1 && r <= r1) {
        tree[rt].push += x;
        push(rt, l, r);
        return;                     
    }
    if (max(l, l1) > min(r, r1)) return; 
    int t = (l + r) / 2; 
    upd(l, t, l1, r1, rt * 2 + 1, x); 
    upd(t + 1, r, l1, r1, rt * 2 + 2, x); 
    tree[rt].mx = max(tree[rt * 2 + 1].mx, tree[rt * 2 + 2].mx); 
}

int get() {
    return get(0, m - 1, 0, m - 1, 0);        
}

void upd(int l, int r, int add) {
    upd(0, m - 1, l, r, 0, add); 
}

void solve() {
    build(); 
    cin >> n >> m >> p;
    for (int i = 0; i < n; ++i) {
        int aa, ca; cin >> aa >> ca;
        a.pb({aa, ca}); 
    }
    sort(all(a)); 
    for (int i = 0; i < m; ++i) {
        int aa, ca; cin >> aa >> ca;
        b.pb({aa, ca}); 
    }
    sort(all(b)); 
    for (int i = 0; i < m; ++i) {
        upd(i, i, -b[i].ca); 
    }
    for (int i = 0; i < p; ++i) {
        int x, y, z; cin >> x >> y >> z; 
        have.pb({x, y, z}); 
    }                 
    sort(all(have), cmp);
    /*
    for (int i = 0; i < n; ++i) cout << a[i].a << " " << a[i].ca << endl;
    cout << endl;
    for (int i = 0; i < m; ++i) cout << b[i].a << " " << b[i].ca << endl; 
    cout << endl; 
    for (int i = 0; i < p; ++i) cout << have[i].x << " " << have[i].y << " " << have[i].z << endl; 
    cout << endl; 
    */
    int ptr = 0; 
    int ans = -inf;
    for (int i = 0; i < n; ++i) {
        while (ptr < (int)have.size() && have[ptr].x < a[i].a) {
            int t = have[ptr].y;
            int add = have[ptr].z;
//            debug(add); 
            int id = upper_bound(all(b), hunt(t, -1)) - b.begin();                     
//            cout << "add: " << t << " " << id << endl; 
            if (id < m && id >= 0) { 
                upd(id, m - 1, add); 
            }                
            ++ptr;
        }
//        cout << i << " " << ptr << endl; 
        ans = max(ans, -a[i].ca + get());
    }
    cout << ans; 
}

signed main() {
#ifdef LOCAL
  freopen("TASK.in", "r", stdin);
  freopen("TASK.out", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t = 1;
    for (int i = 0; i < t; ++i) solve();
    return 0;     
}