#include <bits/stdc++.h>
#define int long long 

#define ff first 
#define ss second

#define pb push_back 
#define eb emplace_back 

#define mp make_pair 

#define all(x) (x).begin(), (x).end()

#define pii pair<int, int>

#define debug(x) cout << #x << ": " << x << endl; 
#define TIME clock() / (ld)CLOCKS_PER_SEC

using namespace std; 
mt19937 rnd(time(0)); 
typedef long long ll;
typedef long double ld; 
const int maxn = 3e5 + 7, mod = 1e9 + 7, MAXN = 1e6 + 7;
const ll inf = 1e18; 
int n; 
string s;
const int L = 2;
vector<int> MOD = {(int)1e9 + 7, (int)1e9 + 9}; 
vector<int> pww = {228, 31}; 
int pw[maxn][L];

int pref0[maxn]; 

int getnull(int l, int r) {
    return pref0[r + 1] - pref0[l];
}

int getright(int l, int r) { 
    if (getnull(l, r) == 0) return -1; 
    int l1 = l - 1;         
    int m; 
    int r1 = r;
    while (l1 + 1 < r1) {
        m = (l1 + r1) / 2; 
        if (getnull(l, m) < getnull(l, r)) l1 = m;
        else r1 = m;             
    } 
    return r1;  
}

int getleft(int l, int r) { 
    if (getnull(l, r) == 0) return -1; 
    int l1 = l - 1;         
    int m; 
    int r1 = r;
    while (l1 + 1 < r1) {
        m = (l1 + r1) / 2; 
        if (getnull(l, m) == 0) l1 = m;
        else r1 = m;             
    } 
    return r1;  
}

int hsh[maxn][L];
int hshinv[maxn][L]; 

int gethsh(int l, int r, int i) {
    int cnt = getnull(l, r); 
    return (hsh[r + 1][i] - hsh[l][i] * pw[cnt][i] % MOD[i] + MOD[i]) % MOD[i]; 
}


int getinvhsh(int l, int r, int i) {
    int cnt = getnull(l, r); 
    return (hshinv[r + 1][i] - hshinv[l][i] * pw[cnt][i] % MOD[i] + MOD[i]) % MOD[i]; 
}

 

bool solve(int l, int r, int l1, int r1) {
    bool ok = true; 
    for (int i = 0; i < L; ++i) {   
        if (r % 2 != l % 2) {
            ok &= gethsh(l, r, i) == getinvhsh(l1, r1, i); 
        } else {
            ok &= (gethsh(l, r, i) == gethsh(l1, r1, i));        
        }
    }    
    return ok; 
}

void solve() {
    for (int i = 0; i < L; ++i) {
        pw[0][i] = 1;
        for (int j = 1; j < maxn; ++j) {
            pw[j][i] = pw[j - 1][i] * pww[i]; 
            pw[j][i] %= MOD[i]; 
        }
    }
    cin >> n;
    cin >> s;
    for (int i = 0; i < n; ++i) {
        pref0[i + 1] = pref0[i] + (s[i] == '0'); 
    }
    for (int l = 0; l < L; ++l) { 
        for (int i = 0; i < n; ++i) {            
            if (s[i] == '1') {
                hsh[i + 1][l] = hsh[i][l];         
                hshinv[i + 1][l] = hshinv[i][l]; 
            } else {
                int t = i % 2 + 1;
                hsh[i + 1][l] = hsh[i][l] * pww[l];
                hsh[i + 1][l] += t;
                hsh[i + 1][l] %= MOD[l];                
                t = !(i % 2) + 1;
                hshinv[i + 1][l] = hshinv[i][l] * pww[l];
                hshinv[i + 1][l] += t;
                hshinv[i + 1][l] %= MOD[l];                
            }
        }
    }
    int q; cin >> q;
    for (int test = 0; test < q; ++test) {
        int l, l1, len, r, r1; 
        cin >> l >> l1 >> len, --l, --l1;
        r = l + len - 1;
        r1 = l1 + len - 1;
        if (getnull(l, r) != getnull(l1, r1)) {
            cout << "No\n"; 
            continue; 
        }
        if (getnull(l, r) == 0) {
            cout << "Yes\n"; 
            continue; 
        }        
        bool ok = false; 
        int id = getright(l, r);
        int id1 = getright(l1, r1); 
        if ((r - id) % 2 == (r1 - id) % 2) {
            ok |= solve(l, r, l1, r1); 
        }
        id = getleft(l, r);
        id1 = getleft(l1, r1); 
        if ((id - l) % 2 == (id1 - l1) % 2) {
            ok |= solve(l, r, l1, r1); 
        }
        cout << (ok ? "Yes\n" : "No\n"); 
    }                 
}

signed main() {
#ifdef LOCAL
  freopen("TASK.in", "r", stdin);
  freopen("TASK.out", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t = 1;
    for (int i = 0; i < t; ++i) solve();
    return 0;     
}