#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>
#include <stack>
#include <queue>
#include <set>
#include <map>

#define speed ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

using namespace std;

struct node {
	int val;
	node* next;
	node* prev; 
};
int main() {
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	int ans = 0;
    int n;
	cin >> n;
	if (n == 1)
		return cout << 0, 0;
	vector <node> v(n);
	node *beg, *end;
	int cnt = 0;
	for (int i = 0; i < n; i++)
	{
		char a;
		cin >> a;
		v[i].val = a;
		if (i == 0)
		{
			v[i].prev = NULL;
			beg = &v[i];
		}
		else
			v[i].prev = &v[i - 1];

		if (i == n - 1)
		{
			v[i].next = NULL;
			end = &v[i];
		}
		if (i != 0)
			v[i - 1].next = &v[i];
	}
	bool f = true;
	while (f == true)
	{
		f = false;
		node *i = beg;
		int m = 0;
		while (i != NULL)
		{
			int cur = (*i).val;
			int prev = 0;
			if ((*i).prev != NULL)
				prev = (*(*i).prev).val;
			int next = 0;
			if ((*i).next != NULL)
				next = (*(*i).next).val;
			if ((prev != 0 && prev == cur - 1) || (next != 0 && next == cur - 1))
				m = max(m, cur);
			i = (*i).next;
		}
		i = beg;
		while (i!= NULL && f == false)
		{
			int cur = (*i).val;
			int prev = 0;
			if ((*i).prev != NULL)
				prev = (*(*i).prev).val;
			int next = 0;
			if ((*i).next != NULL)
				next = (*(*i).next).val;
			if (m == cur && ((prev != 0 && prev == cur - 1) || (next != 0 && next == cur - 1)))
			{
				f = true;
				if ((*i).prev == NULL)
					{
						(*(*i).next).prev = NULL;
						beg = (*i).next;
					}
				else
				{
					if ((*i).next == NULL)
						{
							(*(*i).prev).next = NULL;
							end = (*i).prev;
							break;
						}
					else
						{
							(*(*i).prev).next = (*i).next;
							(*(*i).next).prev = (*i).prev;	
						}
				}
			}
			i = (*i).next;
		}
		if (f)
			ans++;
	}
	cout << ans;
    return 0;
}