//#pragma GCC optimize("O3")
//#pragma GCC target("avx2")
#include <bits/stdc++.h>
using namespace std;

#define int long long
#define double long double
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define endl '\n'

int n, m, k;
const int N = 2e5;
vector<int> g[N], rg[N];
vector<int> a;

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
    cout << fixed << setprecision(20);
#ifdef _DEBUG
    freopen("input.cpp", "r", stdin);
    freopen("output.cpp", "w", stdout);
#endif
    cin >> n >> m;
    for(int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        g[u].push_back(v);
        rg[v].push_back(u);
    }
    cin >> k;
    a.resize(k);
    for(auto& i : a) cin >> i;
    for(auto& i : a) --i;

    queue<int> q;
    vector<int> used(n, 0), d(n, 1e18), dp(n, 1);
    q.push(a.back());
    used[a.back()] = 1;
    d[a.back()] = 0;
    while(!q.empty()) {
        int u = q.front();
        q.pop();
        for(auto& to : rg[u]) {
            if(!used[to]) q.push(to);
            used[to] = 1;
            if(d[to] == d[u] + 1) ++dp[to];
            else if(d[to] > d[u] + 1) dp[to] = 1;
            d[to] = min(d[to], d[u] + 1);
        }
    }

    int mn = 0, mx = 0;
    for(int i = 0; i + 1 < a.size(); ++i) {
        if(d[a[i]] == d[a[i + 1]] + 1) {
            mn += 0, mx += (dp[a[i]] > 1);
        }
        else mn += 1, mx += 1;
    }
    cout << mn << ' ' << mx;
}

