#pragma GCC optimize("O3")
#pragma GCC target("avx2")
#include <bits/stdc++.h>
using namespace std;

#define int long long
#define double long double
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define endl '\n'

struct enemy{
    int x, y, z;
    enemy(int X = 0, int Y = 0, int Z = 0) {
        x = X, y = Y, z = Z;
    }
};

int n, m, k;
vector<pair<int, int> > a, b;
vector<enemy> c;
const int N = 1e6 + 2;
int f[N];

int add(int r, int val) {
    for(; r < N; r = (r | (r + 1))) f[r] += val;
}

int get(int r) {
    int ans = 0;
    for(; r >= 0; r = (r & (r + 1)) - 1) ans += f[r];
    return ans;
}

int get(int l, int r) {
    return get(r) - get(l - 1);
}

int func(int mid) {
    return get(b[mid].first - 1) - b[mid].second;
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
    cout << fixed << setprecision(20);
#ifdef _DEBUG
    freopen("input.cpp", "r", stdin);
    freopen("output.cpp", "w", stdout);
#endif
    cin >> n >> m >> k;
    a.resize(n);
    b.resize(m);
    c.resize(k);
    for(auto& i : a) cin >> i.first >> i.second;
    for(auto& i : b) cin >> i.first >> i.second;
    for(auto& i : c) cin >> i.x >> i.y >> i.z;
    sort(all(a)), sort(all(b));
    sort(all(c), [](enemy i, enemy j) {
         return i.y < j.y;
    });
    for(int i = n - 2; i >= 0; --i) {
        a[i].second = min(a[i].second, a[i + 1].second);
    }
    for(int i = m - 2; i >= 0; --i) {
        b[i].second = min(b[i].second, b[i + 1].second);
    }

    int ans = 0, j = 0;
    for(auto& i : a) {
        while(j < k && c[j].y < i.first) add(c[j].x, c[j].z), ++j;
        int l = 0, r = m;
        while(r - l >= 3) {
            int m1 = l + (r - l) / 3;
            int m2 = r - (r - l) / 3;
            if(func(m1) < func(m2)) r = m2;
            else l = m1;
        }
        for(int k = l; k < r; ++k) ans = max(ans, func(k) - i.second);
    }
    cout << ans;
}
