#include <bits/stdc++.h>


using namespace std;


#define int long long


const int INF = 2e9;


void warp()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(false);
}


const int maxn = 4e5 + 3;
int tree[maxn * 4];
int buff[maxn * 4];


void push(int v, int tl, int tr)
{
    tree[v] += buff[v];
    if (tl != tr)
    {
        buff[v * 2 + 1] += buff[v];
        buff[v * 2 + 2] += buff[v];
    }
    buff[v] = 0;
}


void build(int v, int tl, int tr, vector<int> &a)
{
    if (tl == tr) tree[v] = a[tl];
    else
    {
        int tm = (tl + tr) / 2;
        build(v * 2 + 1, tl, tm, a);
        build(v * 2 + 2, tm + 1, tr, a);
        tree[v] = max(tree[v * 2 + 1], tree[v * 2 + 2]);
    }
}


void upd(int v, int tl, int tr, int l, int r, int val)
{
    push(v, tl, tr);
    if (l == tl && r == tr)
    {
        buff[v] += val;
        push(v, tl, tr);
        return;
    }
    int tm = (tl + tr) / 2;
    if (r <= tm) upd(v * 2 + 1, tl, tm, l, r, val);
    else if (l > tm) upd(v * 2 + 2, tm + 1, tr, l, r, val);
    else
    {
        upd(v * 2 + 1, tl, tm, l, tm, val);
        upd(v * 2 + 2, tm + 1, tr, tm + 1, r, val);
    }
    push(v * 2 + 1, tl, tm);
    push(v * 2 + 2, tm + 1, tr);
    tree[v] = max(tree[v * 2 + 1], tree[v * 2 + 2]);
}


signed main()
{
    warp();
    for (int i = 0; i < maxn * 4; i++) tree[i] = 0;
    for (int i = 0; i < maxn * 4; i++) buff[i] = 0;
    int n, m, p;
    cin >> n >> m >> p;
    vector<int> attack(n);
    vector<int> attackPrice(n);
    vector<int> block(m);
    vector<int> blockPrice(m);
    for (int i = 0; i < n; i++) cin >> attack[i] >> attackPrice[i];
    for (int i = 0; i < m; i++) cin >> block[i] >> blockPrice[i];
    vector<int> x(p);
    vector<int> y(p);
    vector<int> z(p);
    vector<pair<int, int> > order(p);
    for (int i = 0; i < p; i++)
    {
        cin >> x[i] >> y[i] >> z[i];
        order[i] = make_pair(y[i], i);
    }
    sort(order.begin(), order.end());
    vector<pair<int, int> > armor(m);
    for (int i = 0; i < m; i++) armor[i] = make_pair(block[i], blockPrice[i]);
    sort(armor.begin(), armor.end());
    /*
    vector<int> minCostArmor(m);
    minCostArmor[m - 1] = armor.back().second;
    for (int i = m - 2; i > -1; i--)
    {
        minCostArmor[i] = min(minCostArmor[i + 1], armor[i].second);
    }
    */
    vector<pair<int, int> > stats;
    for (int i = 0; i < p; i++) stats.push_back(make_pair(x[i], i));
    for (int i = 0; i < n; i++) stats.push_back(make_pair(attack[i] - 1, i + p));
    sort(stats.begin(), stats.end());
    vector<int> temp(stats.size());
    vector<int> pos(p);
    for (int i = 0; i < stats.size(); i++)
    {
        int numb = stats[i].second;
        if (numb < p)
        {
            temp[i] = -INF;
            pos[numb] = i;
        }
        else
        {
            numb -= p;
            temp[i] = -attackPrice[numb];
        }
    }
    build(0, 0, (int)temp.size() - 1, temp);
    int cur = 0;
    int ans = -INF;
    for (int i = 0; i < m; i++)
    {
        int curDef = armor[i].first, cand = -armor[i].second;
        while (cur < order.size() && order[cur].first < curDef)
        {
            int monster = order[cur].second;
            upd(0, 0, (int)temp.size() - 1, pos[monster], (int)temp.size() - 1, z[monster]);
            cur++;
        }
        ans = max(ans, cand + tree[0]);
    }
    cout << ans << endl;
    return 0;
}
