#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <string>
#include <queue>

#define pr pair
#define pii pair<int, int>
#define mp make_pair
#define ft first
#define sd second
#define ll long long

using namespace std;

const int INF = 1000000000;

int main() {
	cin.tie(NULL);
	cout.tie(NULL);
	ios_base::sync_with_stdio(false);
	int n, m;
	cin >> n >> m;
	vector<vector<int>> gr(n, vector<int>(0)), grr(n, vector<int>(0));
	for (int i = 0; i < m; i++) {
		int x, y;
		cin >> x >> y;
		x--, y--;
		gr[x].push_back(y);
		grr[y].push_back(x);
	}
	int k;
	cin >> k;
	vector<int> path(k);
	for (int i = 0; i < k; i++) {
		cin >> path[i];
		path[i]--;
	}

	vector<int> disttot(n, INF);
	queue<int> bfs;
	disttot[path[k - 1]] = 0;
	bfs.push(path[k - 1]);
	while (bfs.size() != 0) {
		int v = bfs.front();
		bfs.pop();
		for (int i = 0; i < grr[v].size(); i++) {
			if (disttot[grr[v][i]] == INF) {
				disttot[grr[v][i]] = disttot[v] + 1;
				bfs.push(grr[v][i]);
			}
		}
	}
	vector<int> opcnt(n, 0);
	for (int i = 0; i < n; i++)
		for (int j = 0; j < gr[i].size(); j++) {
			if (disttot[gr[i][j]] == disttot[i] - 1)
				opcnt[i]++;
		}
	int minn = 0;
	int maxx = 0;
	for (int i = 0; i < k - 1; i++) {
		if (disttot[path[i + 1]] >= disttot[path[i]]) {
			minn++;
			maxx++;
		}
		else {
			if (opcnt[path[i]] > 1)
				maxx++;
		}
	}
	cout << minn << ' ' << maxx;
	int zero = 0;
}