#include <bits/stdc++.h>

#define int long long
#define ll long long
#define ld long double
#define pb push_back
#define pf push_front
#define ppf pop_front
#define ppb pop_back
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define pii pair<int, int>
#define ff first
#define ss second

#define dist dist228
#define left left228
#define right right228
#define prev prev228

using namespace std;

mt19937 rnd(time(nullptr));

const long long INF = 1e18, N = 2e5 + 10;
const long double EPS = 1e-9;
vector<int> g[N], g_r[N];
int check[N], cnt[N], dist[N], used[N];
vector<int> path;

void dfs(int v) {
    used[v] = 1;
    for (int u : g_r[v]) {
        if (!used[u]) {
            dfs(u);
        }
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int v, u;
        cin >> v >> u;
        v--;
        u--;
        g[v].pb(u);
        g_r[u].pb(v);

    }
    int k;
    cin >> k;
    for (int i = 0; i < k; i++) {
        int x;
        cin >> x;
        x--;
        path.pb(x);
    }
    deque<int> q = {path[k - 1]};
    for (int i = 0; i < n; i++) {
        dist[i] = INF;
    }
    dist[path[k - 1]] = 0;
    while (!q.empty()) {
        int v = q.front();
        q.ppf();
        for (int u : g_r[v]) {
            if (dist[u] > dist[v] + 1) {
                dist[u] = dist[v] + 1;
                //cnt[v]++;
                q.pb(u);
            }
        }
    }

    dfs(path[k - 1]);
    /*deque<int> q2 = {path[k - 1]};
    vector<int> dist2(n, INF);
    dist2[path[k - 1]] = 0;
    while (!q2.empty()) {
        int v = q2.front();
        q2.ppf();
        for (int u : g_r[v]) {
            if (dist2[u] > dist2[v] + 1) {
                dist2[u] = dist2[v] + 1;
                //cnt[v]++;
                q2.pb(u);
            }
        }
    }*/
    /*for (int i = 0; i < n; i++) {
        cout << "{" << dist[i] << ' ' << used[i] << "}\n";
    }*/
    for (int v = 0; v < n; v++) {
        for (int u : g[v]) {
            if (dist[v] == dist[u] + 1) {
                cnt[v]++;
            }
        }
    }
    int mn = 0, mx = 0;
    for (int i = 0; i < k - 1; i++) {
        int v = path[i], u = path[i + 1];
        int fl = (dist[v] == dist[u] + 1) ;
        //cout << fl << ' ';
        if (!fl) {
            mn++;
            mx++;
        }
        if (cnt[v] > 1) {
            mx++;
        }
    }
    //cout << "\n";
    cout << mn << ' ' << mx;
    return 0;
}
