#include <bits/stdc++.h>

#define int long long
#define ll long long
#define ld long double
#define pb push_back
#define pf push_front
#define ppf pop_front
#define ppb pop_back
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define pii pair<int, int>
#define ff first
#define ss second

#define dist dist228
#define left left228
#define right right228
#define prev prev228

using namespace std;

mt19937 rnd(time(nullptr));

const long long INF = 1e18, N = 2e5 + 10;
const long double EPS = 1e-9;
vector<int> g[N], g_r[N];
int cnt[N], dist[N];
int path[N];


int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int v, u;
        cin >> v >> u;
        v--;
        u--;
        g[v].pb(u);
        g_r[u].pb(v);

    }
    int k;
    cin >> k;
    for (int i = 0; i < k; i++) {
        int x;
        cin >> x;
        x--;
        path[i] = x;
    }
    deque<int> q = {path[k - 1]};
    for (int i = 0; i < n; i++) {
        dist[i] = INF;
    }
    dist[path[k - 1]] = 0;
    while (!q.empty()) {
        int v = q.front();
        q.ppf();
        for (int u : g_r[v]) {
            if (dist[u] == INF) {
                dist[u] = dist[v] + 1;
                //cnt[v]++;
                q.pb(u);
            }
        }
    }
    for (int v = 0; v < n; v++) {
        for (int u : g[v]) {
            if (dist[v] != INF && dist[u] != INF && dist[v] == dist[u] + 1) {
                cnt[v]++;
            }
        }
    }
    int mn = 0, mx = 0;
    for (int i = 0; i < k - 1; i++) {
        int v = path[i], u = path[i + 1];
        int fl = (dist[v] != INF && dist[u] != INF && dist[v] == dist[u] + 1) ;
        if (!fl) {
            mn++;
        } else if (cnt[v] > 1) {
            mx++;
        }
    }
    cout << mn << ' ' << mx + mn;
    return 0;
}
