#include <bits/stdc++.h>

#define int long long
#define ll long long
#define ld long double
#define pb push_back
#define pf push_front
#define ppf pop_front
#define ppb pop_back
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define pii pair<int, int>
#define ff first
#define ss second

#define dist dist228
#define left left228
#define right right228
#define prev prev228

using namespace std;

mt19937 rnd(time(nullptr));

const long long INF = 1e18, N = 1e6 + 10, N2 = 2e5 + 10;
const long double EPS = 1e-9;
vector<pii> all_p;
int rmq[N * 4];
map<pii, int> sum_p, c_p;

void upd(int t, int l, int r, int x, int vl) {
    if (x < l || r <= x) {
        return;
    }
    if (l + 1 == r) {
        rmq[t] += vl;
        return;
    }
    int m = (l + r) / 2;
    upd(t * 2 + 1, l, m, x, vl);
    upd(t * 2 + 2, m, r, x, vl);
    rmq[t] = rmq[t * 2 + 1] + rmq[t * 2 + 2];
}

int get_sum(int t, int l, int r, int x, int y) {
    if (y <= l || r <= x) {
        return 0;
    }
    if (x <= l && r <= y) {
        return rmq[t];
    }
    int m = (l + r) / 2;
    return get_sum(t * 2 + 1, l, m, x, y) + get_sum(t * 2 + 2, m, r, x, y);
}

void solve(vector<pii> a) {
    if (a.size() <= 1) {
        return;
    }
    int m = a.size() / 2, xm = a[m].ff;
    vector<int> y;
    for (pii elem : a) {
        y.pb(elem.ss);
    }
    for (int elem : y) {
        all_p.pb({xm, elem});
    }
    vector<pii> q1, q2;
    for (int i = 0; i < m; i++) {
        q1.pb(a[i]);
    }
    for (int i = m + 1; i < a.size(); i++) {
        q2.pb(a[i]);
    }
    solve(q1);
    solve(q2);
}

bool cmp(pii a, pii b) {
    if (a.ff == b.ff) {
        return a.ss > b.ss;
    }
    return a.ff < b.ff;
}

vector<pii> opt(vector<pii> a) {
    sort(all(a), cmp);
    vector<pii> ans;
    int n = a.size();
    int mn = INF;
    for (int i = n - 1; i > -1; i--) {
        if (a[i].ss < mn) {
            ans.pb(a[i]);
            mn = a[i].ss;
        }
    }
    return ans;
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, m, p;
    cin >> n >> m >> p;
    vector<pii> a(n), b(m);
    vector<pair<pii, int> > c(p);
    for (int i = 0; i < n; i++) {
        cin >> a[i].ff >> a[i].ss;
    }
    for (int i = 0; i < m; i++) {
        cin >> b[i].ff >> b[i].ss;
    }
    vector<pii> d;
    for (int i = 0; i < p; i++) {
        cin >> c[i].ff.ff >> c[i].ff.ss >> c[i].ss;
        c_p[{c[i].ff.ff, c[i].ff.ss}] = c[i].ss;
        d.pb({c[i].ff.ff, c[i].ff.ss});
    }
    all_p = d;
    solve(d);
    a = opt(a);
    b = opt(b);
    sort(all(a));
    sort(all(b));
    vector<int> sum_x(N), sum_y(N);
    for (auto elem : c) {
        sum_x[elem.ff.ff] += elem.ss;
        sum_y[elem.ff.ss] += elem.ss;
    }
    for (int i = N - 1; i > -1; i--) {
        sum_x[i] += sum_x[i + 1];
        sum_y[i] += sum_y[i + 1];
    }
    int ans = -INF;
    sort(all(all_p));
    for (pii elem : all_p) {
        int x = elem.ff, y = elem.ss;

        int i = -1, j = -1;
        pii q = {y + 1, -1};
        auto it = lower_bound(all(a), q);
        if (it == a.end()) {
            continue;
        } else {
            i = it - a.begin();
        }

        q = {x + 1, -1};
        it = lower_bound(all(b), q);
        if (it == b.end()) {
            continue;
        } else {
            j = it - b.begin();
        }

        //cout << elem.ff << ' ' << elem.ss << ":\n";
        //cout << i << ' ' << j << "\n";

        int cur_ans = -a[i].ss - b[j].ss;
        int cost_m = c_p[{x, y}];
        if (cost_m > 0) {
            upd(0, 0, N, y, cost_m);
        }
        int sum_m = get_sum(0, 0, N, 0, y + 1);
        cur_ans += sum_m;
        //cout <<  cur_ans << ' ' << sum_m << "\n";
        ans = max(ans, cur_ans);
    }
    cout << ans;
    return 0;
}
