#include <bits/stdc++.h>

#define int long long
#define ll long long
#define ld long double
#define pb push_back
#define pf push_front
#define ppf pop_front
#define ppb pop_back
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define pii pair<int, int>
#define ff first
#define ss second

#define dist dist228
#define left left228
#define right right228
#define prev prev228

using namespace std;

mt19937 rnd(time(nullptr));

const long long INF = 1e18, N = 1e6 + 10, N2 = 2e5 + 10;
const long double EPS = 1e-9;
//vector<pii> all_p;
int rmq[N2 * 4], mod[N2 * 4];
unordered_map<int, unordered_map<int, int>> c_p;

void push(int t, int l, int r) {
    rmq[t] += mod[t];
    if (l + 1 != r) {
        mod[t * 2 + 1] += mod[t];
        mod[t * 2 + 2] += mod[t];
    }
    mod[t] = 0;
}

void upd(int t, int l, int r, int x, int y, int vl) {
    push(t, l, r);
    if (r <= x || y <= l) {
        return;
    }
    if (x <= l && r <= y) {
        mod[t] += vl;
        push(t, l, r);
        return;
    }
    int m = (l + r) / 2;
    upd(t * 2 + 1, l, m, x, y, vl);
    upd(t * 2 + 2, m, r, x, y, vl);
    rmq[t] = max(rmq[t * 2 + 1], rmq[t * 2 + 2]);
}

int get_max(int t, int l, int r, int x, int y) {
    if (y <= l || r <= x) {
        return -INF;
    }
    if (x <= l && r <= y) {
        return rmq[t];
    }
    int m = (l + r) / 2;
    return max(get_max(t * 2 + 1, l, m, x, y), get_max(t * 2 + 2, m, r, x, y));
}

/*void solve(vector<pii> a) {
    if (a.size() <= 1) {
        for (pii elem : a) {
            all_p.pb(elem);
        }
        return;
    }
    int m = a.size() / 2, xm = a[m].ff;
    vector<int> y;
    for (pii elem : a) {
        y.pb(elem.ss);
    }
    for (int elem : y) {
        all_p.pb({xm, elem});
    }
    vector<pii> q1, q2;
    for (int i = 0; i < m; i++) {
        q1.pb(a[i]);
    }
    for (int i = m; i < a.size(); i++) {
        q2.pb(a[i]);
    }
    solve(q1);
    solve(q2);
}*/

bool cmp(pii a, pii b) {
    if (a.ff == b.ff) {
        return a.ss > b.ss;
    }
    return a.ff < b.ff;
}

vector<pii> opt(vector<pii> a) {
    sort(all(a), cmp);
    vector<pii> ans;
    int n = a.size();
    int mn = INF;
    for (int i = n - 1; i > -1; i--) {
        if (a[i].ss < mn) {
            ans.pb(a[i]);
            mn = a[i].ss;
        }
    }
    return ans;
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, m, p;
    cin >> n >> m >> p;
    vector<pii> a(n), b(m);
    vector<pair<pii, int> > c(p);
    for (int i = 0; i < n; i++) {
        cin >> a[i].ff >> a[i].ss;
    }
    for (int i = 0; i < m; i++) {
        cin >> b[i].ff >> b[i].ss;
    }
    vector<pii> d;
    for (int i = 0; i < p; i++) {
        cin >> c[i].ff.ff >> c[i].ff.ss >> c[i].ss;
        c_p[c[i].ff.ff][c[i].ff.ss] = c[i].ss;
        //d.pb({c[i].ff.ff, c[i].ff.ss});
    }
    //solve(d);
    a = opt(a);
    b = opt(b);
    sort(all(a));
    sort(all(b));
    m = b.size();
    n = a.size();
    for (int i = 0; i < m; i++) {
        upd(0, 0, m, i, i + 1, -b[i].ss);
    }
    int ans = -INF;
    vector<vector<pii>> ev(N);
    for (int i = 0; i < n; i++) {
        ev[a[i].ff].pb({-1, a[i].ss});
    }
    for (int i = 0; i < p; i++) {
        int x = c[i].ff.ff, y = c[i].ff.ss;
        ev[x].pb({y, c_p[x][y]});
    }
    for (int i = 0; i < N; i++) {
        sort(all(ev[i]));
    }
    for (int i = 0; i < N; i++) {
        for (pii elem : ev[i]) {
            if (elem.ff == -1) {
                //cout << rmq[0] << ' '
                int cur_ans = -elem.ss + rmq[0];
                ans = max(ans, cur_ans);
            } else {
                int y = elem.ff, cost_m = elem.ss;
                int j;
                pii q = {y + 1, -1};
                auto it = lower_bound(all(b), q);
                if (it == b.end()) {
                    continue;
                } else {
                    j = it - b.begin();
                }
                upd(0, 0, m, j, m, cost_m);
            }
        }
/*        int x = elem.ff, y = elem.ss;

        int i = -1, j = -1;
        pii q = {x + 1, -1};
        auto it = lower_bound(all(a), q);
        if (it == a.end()) {
            continue;
        } else {
            i = it - a.begin();
        }

        q = {y + 1, -1};
        it = lower_bound(all(b), q);
        if (it == b.end()) {
            continue;
        } else {
            j = it - b.begin();
        }

        //cout << elem.ff << ' ' << elem.ss << ":\n";
        //cout << i << ' ' << j << "\n";

        int cur_ans = -a[i].ss - b[j].ss;
        int cost_m = c_p[x][y];
        if (cost_m > 0) {
            upd(0, 0, N, y, cost_m);
        }
        int sum_m = get_sum(0, 0, N, 0, y + 1);
        cur_ans += sum_m;
        //cout <<  cur_ans << ' ' << sum_m << "\n";
        ans = max(ans, cur_ans);*/
    }
    cout << ans;
    return 0;
}
