#include <bits/stdc++.h>

#define endl '\n'
#define int long long
using namespace std;


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m, k;
    cin >> n >> m;
    vector<vector<int>> g(n + 1), rg(n + 1);
    int u1, v1;
    for (int i = 0; i < m; i++) {
        cin >> u1 >> v1;
        g[u1].push_back(v1);
        rg[v1].push_back(u1);
    }
    cin >> k;
    vector<int> p(k);
    for (auto &x : p) {
        cin >> x;
    }
    int t = p.back();
    int INF = (int) 1e15;
    vector<int> d(n + 1, INF);
    deque<int> q = {t};
    d[t] = 0;
    while (!q.empty()) {
        int v = q.front();
        q.pop_front();
        for (int u : rg[v]) {
            if (d[u] == INF) {
                q.push_back(u);
                d[u] = d[v] + 1;
            }
        }
    }
    int mn = 0, mx = 0;
    for (int i = 1; i < k; i++) {
        int v = p[i - 1];
        int best = INF;
        for (int u : g[v]) {
            best = min(best, d[u]);
        }
        int cnt = 0;
        for (int u : g[v]) {
            if (d[u] == best) {
                cnt++;
            }
        }
        if (best < d[p[i]]) {
            mn++;
            mx++;
        } else if (cnt > 1) {
            mx++;
        }
    }
    cout << mn << " " << mx << endl;
}