#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

#define x first
#define y second
#define pb push_back
#define mp make_pair
#define up_b upper_bound
#define low_b lower_bound
#define sz(v) (int)v.size()
#define all(v) v.begin(),v.end()

using namespace std;
using namespace __gnu_pbds;

typedef tree<int,null_type,less<int>,rb_tree_tag,tree_order_statistics_node_update>ordered_set;

typedef long long ll;
typedef long double ld;
typedef pair<int,int> pii;
typedef pair<ll,int> pli;
typedef pair<int,ll> pil;
typedef pair<ll,ll> pll;

const int N=1e5+11;
const int M=1e6+11;
const int inf=1e9;
const ll INF=1e18;

pair<int,pair<int,int>>ms[N];
pair<int,ll>a[N],b[N];
ll def[N],att[N],ma[N],mb[N];
ll t[4*M],z[4*M];
ll val[M];

void push(int v,int tl,int tr){
  if(z[v]!=0){
    if(tl!=tr){
      z[v*2]+=z[v];
      z[v*2+1]+=z[v];
    }
    t[v]+=z[v];
    z[v]=0;
  }
}

void build(int v,int tl,int tr){
  if(tl==tr){
    t[v]=val[tl];
    return;
  }
  int tm=(tl+tr)/2;
  build(v*2,tl,tm);
  build(v*2+1,tm+1,tr);
  t[v]=max(t[v*2],t[v*2+1]);
}

void upd(int v,int tl,int tr,int l,int r,int val){
  push(v,tl,tr);
  if(tl>r||l>tr)return;
  if(l<=tl&&tr<=r){
    z[v]+=val;
    push(v,tl,tr);
    return ;
  }
  int tm=(tl+tr)/2;
  upd(v*2,tl,tm,l,r,val);
  upd(v*2+1,tm+1,tr,l,r,val);
  t[v]=max(t[v*2],t[v*2+1]);
}

ll get(int v,int tl,int tr,int l,int r){
  push(v,tl,tr);
  if(tl>r||l>tr)return -INF;
  if(l<=tl&&tr<=r)return t[v];
  int tm=(tl+tr)/2;
  return max(get(v*2,tl,tm,l,r),get(v*2+1,tm+1,tr,l,r));
}

int main(){
  ios_base::sync_with_stdio(0);
  cin.tie(0),cout.tie(0);
  int n,m,p;
  cin>>n>>m>>p;
  for(int i=1;i<=n;i++){
    cin>>a[i].x>>a[i].y;
  }
  for(int i=1;i<=m;i++){
    cin>>b[i].x>>b[i].y;
  }
  sort(a+1,a+n+1);
  sort(b+1,b+m+1);
  ma[n+1]=INF;
  for(int i=n;i>=1;i--){
    ma[i]=min(ma[i+1],a[i].y);
    att[i]=a[i].x;
  }
  mb[m+1]=INF;
  for(int i=m;i>=1;i--){
    mb[i]=min(mb[i+1],b[i].y);
    def[i]=b[i].x;
  }
  for(int i=1;i<=p;i++){
    cin>>ms[i].x>>ms[i].y.x>>ms[i].y.y;
  }
  for(int i=1;i<=1000000;i++){
    int j=low_b(def+1,def+m+1,i)-def;
    val[i]=-mb[j];
  }
  build(1,1,1000000);
  sort(ms+1,ms+p+1);
  ll ans=-INF;
  for(int i=1;i<=p;i++){
    upd(1,1,1000000,ms[i].y.x+1,1000000,ms[i].y.y)
    int j=up_b(att+1,att+n+1,ms[i].x)-att;
    ll res=-ma[j];
    res+=get(1,1,1000000,1,1000000);
    ans=max(ans,res);
  }
  cout<<ans;
}
