#include <bits/stdc++.h>

using namespace std;

/*int gcd(int a, int b, int& x, int& y) {
    if (a == 0) {
        x = 0;
        y = 1;
        return b;
    }

    int x1, y1;
    int g = gcd(b % a, a, x1, y1);

    y = x1;
    x = -(b / a) * x1 + y1;

    return g;
}

const int NN = 23;

int rev(int a) {
    int x, y;
    int g = gcd(a, NN, x, y);

    x = (x + NN) % NN;
    return x;
}

map<string, int> m;

int dfs(string& s) {
    if (m.find(s) != m.end())
        return m[s];

    int ans = 0;
    if (int(s[0] - 'a') == int(s[1] - 'a') + 1)
        ans = max(ans, dfs(s.substr(1, s.size() - 1)) + 1);
    if (int(s[s.size() - 1] - 'a') == int(s[s.size() - 2] - 'a') + 1)
        ans = max(ans, dfs(s.substr(0, s.size() - 1)) + 1);

    for (int i = 1; i < s.size() - 1; ++i) {
        if (s[i] - 'a' == s[i - 1] - 'a' + 1 || s[i] - 'a' == s[i + 1] - 'a' + 1)
            ans = max(ans, dfs(s.substr(0, i) + s.substr(i + 1, s.size() - i - 1)) + 1);
    }


    m[s] = ans;

    return ans;
}
 */

 const int NN = 2 * 1e5 + 3;
 vector<vector<int> > g(NN);
 vector<vector<int> > rev(NN);

 vector<set<int> > nxt(NN);
 vector<int> dist(NN, NN + 2);

 void bfs(int v) {
    queue<int> q;
    q.push(v);
    dist[v] = 0;

    while (!q.empty()) {
        int cur = q.front();
        q.pop();

        for (int to : rev[cur])
            if (dist[to] > dist[cur] + 1) {
                dist[to] = dist[cur] + 1;
                nxt[to].insert(cur);
                q.push(to);
            } else if (dist[to] == dist[cur] + 1)
                nxt[to].insert(cur);
    }
    return;
 }

 struct P {
    long long x;
    long long y;
    long long z;
 };

 bool operator< (const P& a, const P& b) {
    if (a.x == b.x && a.y == b.y)
        return a.z < b.z;
    if (a.x == b.x)
        return a.y < b.y;
    return a.x < b.x;
 }

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, m, p;
    cin >> n >> m >> p;

    set<pair<long long, long long>> a;
    for (int i = 0; i < n; ++i) {
        long long x, y;
        cin >> x >> y;
        a.insert({x, y});
    }

    set<pair<long long, long long>> b;
    for (int i = 0; i < m; ++i) {
        long long x, y;
        cin >> x >> y;
        b.insert({x, y});
    }

    vector<P> q(p);
    for (int i = 0; i < p; ++i)
        cin >> q[i].x >> q[i].y >> q[i].z;

    sort(q.begin(), q.end());

    //for (int i = 0; i < p; ++i)
    //    cout << q[i].x << ' ' << q[i].y << ' ' << q[i].z << endl;

    vector<int> pr(p, 0);
    pr[0] = q[0].z;

    pair<long long, long long> aa, bb;

    for (pair<long long, long long> cur : a) {
        //cout << cur.first << ' ' << cur.second << endl;
        aa = cur;
    }

    for (pair<long long, long long> cur : b) {
        //cout << cur.first << ' ' << cur.second << endl;
        bb = cur;
    }

    for (int i = 1; i < p; ++i)
        pr[i] = pr[i - 1] + q[i].z;

    //for (int i = 0; i < p; ++i)
    //    cout << pr[i] << endl;

    long long ans = - 2 * 1e18;
    for (int i = 0; i < p; ++i) {
        long long x = q[i].x, y = q[i].y, z = pr[i];

        pair<long long, long long> ida, idb;
        if (a.upper_bound({x, 0}) == a.end())
            ida = aa;
        else
            ida = *(a.upper_bound({x, 0}));

        if (b.upper_bound({y, 0}) == b.end())
            idb = bb;
        else
            idb = *(b.upper_bound({y, 0}));

        ans = max(ans, z - ida.second - idb.second);

    }

    cout << ans << endl;


    return 0;
}