#define _CRT_SECURE_NO_WARNINGS
#include <cassert>
#include <iostream>
#include <vector>
#include <bitset>
#include <unordered_map>
#include <unordered_set>
#include <map>
#include <set>
#include <algorithm>
#include <string>
#include <cmath>
#include <iomanip>

using namespace std;

#define mp make_pair
#define mt make_tuple
#define size(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define rall(x) x.begin(), x.rend()

typedef long long LL;
typedef long double LD;

template <typename T>
bool uin(T &a, const T &b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template <typename T> 
bool uax(T &a, const T &b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

const LL LINF = 1e15;
const int N = (int)2e5 + 7;
const int INF = (int)1e9 + 7;
const int MOD = (int)1e9 + 7;
const int MAXN = (int)1e6 + 7;

/////////////////////////////////////////////////////////////////////////

int n, a[N], b[N];

int main() {
	cout << fixed << setprecision(20);
#ifdef _DEBUG 
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	cin.tie(0), cout.tie(0);
	ios_base::sync_with_stdio(0);
#endif 
	cin >> n;
	map <int, LL> cnt;
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		b[i] = i - a[i];
		cnt[b[i]] += a[i];
	}
	LL ans = 0;
	for (auto it = cnt.begin(); it != cnt.end(); it++) 
		uax(ans, (*it).second);
	cout << ans;
}