#define _CRT_SECURE_NO_WARNINGS
#include <cassert>
#include <iostream>
#include <vector>
#include <bitset>
#include <unordered_map>
#include <unordered_set>
#include <map>
#include <set>
#include <algorithm>
#include <string>
#include <cmath>
#include <iomanip>

using namespace std;

#define mp make_pair
#define mt make_tuple
#define size(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define rall(x) x.begin(), x.rend()

typedef long long LL;
typedef long double LD;

template <typename T>
bool uin(T &a, const T &b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template <typename T> 
bool uax(T &a, const T &b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

const LL LINF = 1e15;
const int N = (int)2e5 + 7;
const int INF = (int)1e9 + 7;
const int MOD = (int)1e9 + 7;
const int MAXN = (int)1e6 + 7;

/////////////////////////////////////////////////////////////////////////

int n;
string s;
vector <vector<int>> d1[100], d2[100];

int main() {
	cout << fixed << setprecision(20);
#ifdef _DEBUG 
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	cin.tie(0), cout.tie(0);
	ios_base::sync_with_stdio(0);
#endif 
	cin >> n >> s;
	for (int i = 0; i < n; i++) {
		d1[i].resize(n, vector <int>(n, -1));
		d2[i].resize(n, vector <int>(n, -1));
	}
	for (int l = n - 1; l >= 0; l--) {
		d1[l][l][l] = 0;
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) 
				fill(all(d2[i][j]), -1);
		}
		for (int r = l; r < n; r++) {
			for (int x1 = l; x1 <= r; x1++) {
				for (int x2 = x1; x2 <= r; x2++) {
					if (d1[r][x1][x2] == -1) 
						continue;
					if (l > 0) {
						uax(d2[r][l - 1][x2], d1[r][x1][x2]);
						if (s[l - 1] == s[x1] + 1) {
							uax(d2[r][x1][x2], d1[r][x1][x2] + 1);
						}
						if (s[l - 1] + 1 == s[x1]) {
							if (x1 == x2) 
								uax(d2[r][l - 1][l - 1], d1[r][x1][x2] + 1);
							else 
								uax(d2[r][l - 1][x2], d1[r][x1][x2] + 1);
						}
					}
					if (r < n - 1) {
						uax(d1[r + 1][x1][r + 1], d1[r][x1][x2]);
						if (s[x2] == s[r + 1] + 1) {
							if (x1 == x2) 
								uax(d1[r + 1][r + 1][r + 1], d1[r][x1][x2] + 1);
							else 
								uax(d1[r + 1][x1][r + 1], d1[r][x1][x2] + 1);
						}
						if (s[x2] + 1 == s[r + 1]) 
							uax(d1[r + 1][x1][x2], d1[r][x1][x2] + 1);
					}
				}
			}	
		}
		if (l == 0) 
			break;
		for (int i = 0; i < n; i++) 
			d1[i].swap(d2[i]);
	}
	int ans = 0;
	for (int i = 0; i < n; i++) {
		for (int j = i; j < n; j++) {
			uax(ans, d1[n - 1][i][j]);
		}
	}
	cout << ans;
}