#include <bits/stdc++.h>

#define int long long
#define fi first
#define se second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define vec vector
#define pb push_back
#define fast_io ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0)
using namespace std;
typedef pair<long long, long long> PII;
typedef long double ld;
struct ver{
    int z1 = 0;
    int z2 = 0;
    int o1 = 0;
    int o2 = 0;
    int len = 0;
};
vec < ver > tree;
vec < int > q;
ver un(ver a, ver b){
    a.len += b.len;
    a.o1 += b.o1;
    a.o2 += b.o2;
    a.z1 += b.z1;
    a.z2 += b.z2;
    return a;
}
void build(int v, int tl, int tr){
    if(tl == tr){
        tree[v].len = 1;
        if(q[tl] == 1) tree[v].o1 = 1;
        else tree[v].z1 = 1;
        return;
    }
    int t = (tl+tr)/2;
    build(2*v, tl, t);
    build(2*v+1, t+1, tr);
    if(tree[2*v].len%2 == 1) swap(tree[2*v+1].o1, tree[2*v+1].o2),
                             swap(tree[2*v+1].z1, tree[2*v+1].z2);
    tree[v] = un(tree[2*v], tree[2*v+1]);
}
ver get(int v, int tl, int tr, int l, int r){
    if(l <= tl && tr <= r) return tree[v];
    int t = (tl+tr)/2;
    ver one;
    ver two;
    if((l <= tl && tl <= r) || (l <= t && t <= r) || (tl <= l && r <= t))
        one = get(2*v, tl, t, l, r);
    if((l <= t+1 && t+1 <= r) || (l <= tr && tr <= r) || (t+1 <= l && r <= tr))
        two = get(2*v+1, t+1, tr, l, r);
    if(one.len%2 == 1) swap(two.o1, two.o2),
                       swap(two.z1, two.z2);
    return un(one, two);
}
signed main()
{
    fast_io;
    int n;
    cin >> n;
    string s;
    cin >> s;
    tree.resize(4*n);
    for(int i = 0; i < n; ++i) q.pb(s[i]-'0');
    build(1, 0, n-1);
    int m;
    cin >> m;
    int a, b, l;
    while(m--){
        cin >> a >> b >> l;
        a--, b--;
        ver one = get(1, 0, n-1, a, a+l-1);
        ver two = get(1, 0, n-1, b, b+l-1);
        if(one.o1 != two.o1 || one.o2 != two.o2 ||
           one.z1 != two.z1 || one.z2 != two.z2) cout << "No\n";
        else cout << "Yes\n";
    }
    return 0;
}
