#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <queue>
#include <deque>
#include <stack>
#include <string>
#include <bitset>
#include <unordered_map>
#include <unordered_set>

using namespace std;

//#define int ll
#define en '\n'
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

typedef pair<int, int> pii;
typedef long long ll;
typedef double db;
typedef long double ld;

const int INF = 1e9 + 7;
const ll LINF = 1e18;
const db EPS = 1e-9;

void solve() {
	int n, cnt_r = 0, cnt_b = 0;
	cin >> n;
	vector<int> r(n), b(n);
	for (int i = 0; i < n; ++i){
		cin >> r[i];
		if (r[i]) ++cnt_r;
	}
	for (int i = 0; i < n; ++i){
		cin >> b[i];
		if (b[i]) ++cnt_b;
	}
	if (cnt_r == 0) {
		cout << -1;
		return;
	}
	int dif_r = 0, dif_b = 0;
	for (int i = 0; i < n; ++i) {
		if (r[i] && !b[i]) ++dif_r;
		else if (!r[i] && b[i]) ++dif_b;
	}
	if (!dif_r) {
		cout << -1;
		return;
	}
	if (dif_r > dif_b || cnt_r > cnt_b) {
		cout << 1;
		return;
	}
	int p = dif_b + 1;
	p = (p - 1) / dif_r + 1;
	cout << p;	
}

signed main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
#endif
	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}