#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <queue>
#include <deque>
#include <stack>
#include <string>
#include <bitset>
#include <unordered_map>
#include <unordered_set>

using namespace std;

#define en '\n'
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

typedef long long ll;

#define int ll

typedef pair<int, int> pii;
typedef double db;
typedef long double ld;

const int INF = 1e9 + 7;
const ll LINF = 1e18;
const db EPS = 1e-9;

void solve() {
	int n;
	cin >> n;
	vector<int> a(n);
	map<int, pair<int, vector<int>>> s;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		s[a[i] - 1 - i].first += 1;
		s[a[i] - 1 - i].second.push_back(i + 1);
	}
	int mx = -LINF;
	auto it = s.begin();
	while (it != s.end()) {
		int x = it->first;
		pair<int, vector<int>> y = it->second;
		int c = x * y.first;
		for (int i = 0; i < y.second.size(); ++i) {
			c += y.second[i];
		}
		mx = max(mx, c);
		++it;
	}
	cout << mx;
}

signed main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
#endif
	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}