/*
#pragma GCC optimize("Ofast,no-stack-protector,fast-math,unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4.1,sse4.2,avx,avx2,popcnt,abm,mmx,tune=native")
*/
#include <bits/stdc++.h>
#include <immintrin.h>
using namespace std;
#define x first
#define y second
#define int long long
/*
int ptr = 0;
const int MAX_MEM = 1e8;
char mem[MAX_MEM];
void* operator new(size_t n) {
	ptr += n;
	return mem + ptr - n;
}
void operator delete(void*) {}
void operator delete(void*, std::size_t) {}
*/
/*
template<int MAXN>
struct fenwick {
	int f[MAXN];
	void add(int p, int x) {
		for (; p < MAXN; p = p | (p + 1))
			f[p] += x;
	}
	int get(int p) {
		int ans = 0;
		for (; p >= 0; p = (p & (p + 1)) - 1)
			ans += f[p];
		return ans;
	}
	fenwick() {
		fill(f, f + MAXN, 0);
	}
};
*/
const int MAXN = 2e5 + 6, INF = 1e9;
vector<int> g[MAXN];
vector<int> gt[MAXN];
int p[MAXN], d[MAXN], dt[MAXN], ok[MAXN];
void solve() {
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; ++i) {
		int a, b;
		cin >> a >> b;
		--a, --b;
		g[a].push_back(b);
		gt[b].push_back(a);
	}
	int k;
	cin >> k;
	for (int i = 0; i < k; ++i) {
		cin >> p[i];
		--p[i];
	}
	fill(d, d + n, INF);
	fill(dt, dt + n, INF);
	
	d[p[0]] = 0;
	queue<int> q;
	q.push(p[0]);
	while (q.size()) {
		int v = q.front();
		q.pop();
		for (int u : g[v])
			if (d[u] > d[v] + 1)
				d[u] = d[v] + 1, q.push(u);
	}

	dt[p[k - 1]] = 0;
	q.push(p[k - 1]);
	while (q.size()) {
		int v = q.front();
		q.pop();
		for (int u : gt[v])
			if (dt[u] > dt[v] + 1)
				dt[u] = dt[v] + 1, q.push(u);
	}
	int ans1 = 0;
	int ans2 = 0;
	//for (int i = 0; i < n; ++i)
	//	ok[i] = ;
	for (int i = 0; i < k - 1; ++i) {
		int v = p[i];
		int u = p[i + 1];
		bool ok = 1;
		for (int u2 : g[v])
			if (u2 != u && dt[u2] < dt[u])
				ok = 0;
		if (!ok)
			++ans1;
	}	
	for (int i = 0; i < k - 1; ++i) {
		int v = p[i];
		int u = p[i + 1];
		bool ok = 0;
		for (int u2 : g[v])
			if (u2 != u && dt[u2] <= dt[u])
				ok = 1;
		if (ok)
			++ans2;
	}
	cout << ans1 << " " << ans2 << endl;
	return;
}
signed main() {
	//freopen("D.in", "r", stdin);
	ios_base::sync_with_stdio(false);

	solve();

	return 0;
}
