/*
#pragma GCC optimize("Ofast,no-stack-protector,fast-math,unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4.1,sse4.2,avx,avx2,popcnt,abm,mmx,tune=native")
*/
#include <bits/stdc++.h>
#include <immintrin.h>
using namespace std;
#define x first
#define y second
#define int long long
/*
int ptr = 0;
const int MAX_MEM = 1e8;
char mem[MAX_MEM];
void* operator new(size_t n) {
	ptr += n;
	return mem + ptr - n;
}
void operator delete(void*) {}
void operator delete(void*, std::size_t) {}
*/
/*
template<int MAXN>
struct fenwick {
	int f[MAXN];
	void add(int p, int x) {
		for (; p < MAXN; p = p | (p + 1))
			f[p] += x;
	}
	int get(int p) {
		int ans = 0;
		for (; p >= 0; p = (p & (p + 1)) - 1)
			ans += f[p];
		return ans;
	}
	fenwick() {
		fill(f, f + MAXN, 0);
	}
};
*/
const int MAXN = 2e5 + 7;
int sum[2][2][MAXN];
int get(int l, int r, int *a) {
	if (!l)
		return a[r];
	else
		return a[r] - a[l - 1];
}
int c[MAXN];
int nxt[MAXN];
int Q[4] = {1791791791, (int)1e9 + 7, (int)1e9 + 9, 1791791791};
int P[4] = {179, 17, 19, 5};
int p[4][MAXN];
int hsh[4][MAXN];
int a[MAXN];
int b[MAXN];
int ps[MAXN];
vector<int> get(int l, int r) {
	if (l > r)
		return vector<int>{-1, -1, -1, -1};
	else if (!l)
		return {hsh[0][r], hsh[1][r], hsh[2][r], hsh[3][r]};
	else
		return {(hsh[0][r] - hsh[0][l - 1] * p[0][r - l + 1] % Q[0] + Q[0]) % Q[0], 
				(hsh[1][r] - hsh[1][l - 1] * p[1][r - l + 1] % Q[1] + Q[1]) % Q[1],
				(hsh[2][r] - hsh[2][l - 1] * p[2][r - l + 1] % Q[2] + Q[2]) % Q[2],
				(hsh[3][r] - hsh[3][l - 1] * p[3][r - l + 1] % Q[3] + Q[3]) % Q[3]};
}
void solve() {
	p[0][0] = p[1][0] = p[2][0] = p[3][0] = 1;
	for (int k = 0; k < 4; ++k)
		for (int i = 1; i < MAXN; ++i)
			p[k][i] = p[k][i - 1] * P[k] % Q[k];
	int n;
	cin >> n;
	for (int i = 0; i < n; ++i) {
		char x;
		cin >> x;
		a[i] = x - '0';
		if (i)
			for (int k1 = 0; k1 < 2; ++k1)
				for (int k2 = 0; k2 < 2; ++k2)
					sum[k1][k2][i] = sum[k1][k2][i - 1];
		sum[i % 2][a[i]][i]++;
	}
	for (int i = n - 1; i >= 0; --i)
		if (!a[i])
			c[i] = 0;
		else
			c[i] = (c[i + 1] + a[i]) % 2;
	nxt[n - 1] = (!a[n - 1] ? n - 1 : n);
	for (int i = n - 2; i >= 0; --i)
		if (!a[i])
			nxt[i] = i;
		else
			nxt[i] = nxt[i + 1];
	int ptr = 0;
	for (int i = 0; i < n; ++i) {
		if (ptr && b[ptr - 1] == 1 && a[i] == 1)
			--ptr;
		ps[i] = ptr;
	}
	for (int k = 0; k < 4; ++k) {
		hsh[k][0] = b[0] + 1;
		for (int i = 1; i < ptr; ++i)
			hsh[k][i] = (hsh[k][i - 1] * P[k] + b[i] + 1) % Q[k];
 	}
	int q;
	cin >> q;
	for (int i = 0; i < q; ++i) {
		int l1, l2, len;
		cin >> l1 >> l2 >> len;
		--l1, --l2;
		int r1 = l1 + len - 1;
		int r2 = l2 + len - 1;
		bool ok = c[l1] == c[l2];
		for (int k1 = 0; k1 < 2; ++k1)
			for (int k2 = 0; k2 < 2; ++k2)
				if (get(l1, r1, sum[k1][k2]) != get(l2, r2, sum[k1][k2]))
					ok = 0;
		if (!ok) {
			cout << "No\n";
			continue;
		}
		l1 = nxt[l1];
		l2 = nxt[l2];
		int l1x = ps[l1];
		int r1x = ps[r1];
		int l2x = ps[l2];
		int r2x = ps[r2]; 
		if (get(l1x, r1x) == get(l2x, r2x)) 
			cout << "Yes\n";
		else
			cout << "No\n";
	}
	return;
}
signed main() {
	//freopen("H.in", "r", stdin);
	ios_base::sync_with_stdio(false);

	solve();

	return 0;
}
