#include <algorithm>
#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
#include <map>
using namespace std;
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    long long n;
    cin >> n;
    map <long long, long long> fdp;
    vector<long long> a(n), dp(n);
    for(int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    dp[0] = a[0];
    fdp[a[0]] = 1;
    for(int i = 1; i < n; ++i) {
        if(fdp[a[i] - i] == 0)
            dp[i] = a[i];
        else {
            dp[i] = a[i] + dp[fdp[a[i] - i] - 1];
        }
        fdp[a[i] - i] = i + 1;
    }
    long long ans = 0;
    for(int i = 0; i < n; ++i) {
        ans = max(ans, dp[i]);
    }
    cout << ans;
    return 0;
}
