#include<bits/stdc++.h>

using namespace std;

#define sz(a) a.size()
#define endl "\n"
#define pb(a) push_back(a)
#define all(a) a.begin(), a.end()
#define F0R(i, n) for(int i = 0; i < n; ++i)
#define FOR(i, a, b) for(int i = a; i < b; ++i)
#define F0Rd(i, n) for(int i = n - 1; i >= 0; --i)
#define FORd(i, a, b) for(int i = a - 1; i >= b; --i)

typedef long long ll;
typedef pair<int, int> pii;
typedef vector<pii> vpii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<ll> vll;
typedef vector<vll> vvll;
typedef map<int, int> mii;


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n, m;
    cin >> n >> m;
    vvi g(n);
    F0R(i, m) {
        int u, v;
        cin >> u >> v;
        g[v - 1].pb(u - 1);
    }

    int k;
    cin >> k;
    vi p(k);
    F0R(i, k) cin >> p[i];

    vi dist(n, 1e9);
    dist[p[k - 1] - 1] = 0;
    queue<int> q;
    q.push(p[k - 1] - 1);
    vector<mii> prev(n);
    vi cnt(n, 0);
    while (sz(q)) {
        int u = q.front();
        q.pop();
        for (int v : g[u])
            if (dist[v] == 1e9) {
                dist[v] = dist[u] + 1;
                q.push(v);
                prev[v][u] = 1;
                cnt[v] = 1;
            }
            else if (dist[v] == dist[u] + 1) {
                prev[v][u] = 1;
                ++cnt[v];
            }
    }

    int cnt1 = k - 1;
    int cnt2 = 0;
    F0R(i, k - 1) {
        cnt1 -= prev[p[i] - 1][p[i + 1] - 1];
        cnt2 += (cnt[p[i] - 1] > 1 || !prev[p[i] - 1][p[i + 1] - 1]);
    }

    cout << cnt1 << " " << cnt2 << "\n";

    return 0;
}
