/*
	cCreated by Kazalika for Technocup 2020
*/

#define _CRT_SECURE_NO_WARNINGS
#include <vector>
#include <string>
#include <iostream>
#include <algorithm>
#include <math.h>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <queue>
#include <deque>
using namespace std;
typedef long long ll;
typedef double db;
typedef long double ldb;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef vector<int> vint;
typedef vector<ll> vll;
#define forn(a, i, n) for (int i = a; i < n; ++i)
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define sz(x) int(x.size())
const int N = 1e6;
const int inf = 1e7;
const ll base = 257, MOD = 1e9 + 7;

ll sq(ll a) {return a * a;}
ll gcd(ll a, ll b) { 
	if (a < b) swap(a, b);
	if (a % b == 0) return b;
	return gcd(b, a % b);
}
ll lcm(ll a, ll b) { return a / gcd(a, b) * b; }


vector <int> g[N], grev[N];
int dist[N];


int main() {
	ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0); 
	//calcPowers();
#ifdef _DEBUG
	freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
	int n, m;
	cin >> n >> m;
	fill(dist, dist + n, inf);
	forn(0, i, m) {
		int v, u;
		cin >> v >> u;
		v--; u--;
		g[v].push_back(u);
		grev[u].push_back(v);
	}

	int k;
	cin >> k;
	vint v(k);
	forn(0, i, k) { cin >> v[i]; v[i]--; }
	int s = v[0], t = v.back();
	dist[t] = 0;
	queue <int> q;
	q.push(t);
	while (!q.empty()) {
		int vl = q.front();
		q.pop();
		for (int i = 0; i < grev[vl].size(); ++i) {
			int to = grev[vl][i];
			if (dist[to] > dist[vl] + 1) {
				q.push(to);
				dist[to] = dist[vl] + 1;
			}
		}
	}
	int minv = 0, maxv = 0;
	for (int i = k - 2; i >= 0; --i) {
		int dd = 0;
		for (int j = 0; j < g[v[i]].size(); ++j) {
			int to = g[v[i]][j];
			if (to == v[i + 1]) dd = dist[v[i + 1]];
		}
		for (int j = 0; j < g[v[i]].size(); ++j) {
			int to = g[v[i]][j];
			if (to != v[i + 1]) {
				if (dist[to] < dd) minv++;
				if (dist[to] <= dd) maxv++;
			}
		}
	}
	cout << minv << ' ' << maxv;

	return 0;
}