#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define ft first
#define sd second
#define pii pair<int, int>
#define pil pair<int, ll>
#define pli pair<ll, int>
#define pll pair<ll, ll>
#define pdd pair<ld, ld>
#define all(x) x.begin(),x.end()
#define sz(x) ((int)x.size())
#define MP make_pair
#define PB push_back
using namespace std;
using namespace __gnu_pbds;
typedef long long ll;
typedef long double ld;
template <class T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
const int N = 200100;
const int M = 200100;
const int P = 200100;
const int oo = 2e9;
pii a[N], b[M];
int ans = -oo, x[P], y[P], z[P], nm[P], st[4 * M], psh[4 * M], n, m, p;

bool cmp(int _x, int _y){
    return x[_x] < x[_y];
}

void build(int v, int l, int r){

    psh[v] = 0;

    if (l == r){
        st[v] = -b[l].sd;
        return;
    }

    int md = (l + r) >> 1;

    build(v + v, l, md);
    build(v + v + 1, md + 1, r);

    st[v] = max(st[v + v], st[v + v + 1]);
}

void push(int v){
    if (psh[v] != 0){

        st[v] += psh[v];

        if (v + v + 1 < 4 * M){

            psh[v + v] += psh[v];
            psh[v + v + 1] += psh[v];
        }

        psh[v] = 0;
    }
}

void update(int v, int tl, int tr, int l, int r, int vl){
    push(v);

    if (l > r) return;

    if (tl == l && tr == r){

        psh[v] += vl;

        push(v);

        return;
    }

    int md = (tl + tr) >> 1;

    update(v + v, tl, md, l, min(r, md), vl);
    update(v + v + 1, md + 1, tr, max(md + 1, l), r, vl);

    st[v] = max(st[v + v], st[v + v + 1]);
}

int main(){

#ifdef _LOCAL
    freopen("in.txt","r",stdin);
#else
    ios_base::sync_with_stdio(0); cin.tie(0);
#endif

    cin >> n >> m >> p;

    for (int i = 0; i < n; i++)
        cin >> a[i].ft >> a[i].sd;

    sort(a, a + n);

    for (int i = 0; i < m; i++)
        cin >> b[i].ft >> b[i].sd;

    sort(b, b + m);

    for (int i = 0; i < p; i++) {
        cin >> x[i] >> y[i] >> z[i];
        nm[i] = i;
    }

    sort(nm, nm + p, cmp);

    int it = 0;

    build(1, 0, m - 1);

    for (int i = 0; i < n; i++){

        while (it < p && x[nm[it]] < a[i].ft){

            int pos = upper_bound(b, b + m, MP(y[nm[it]], -oo)) - b;

            update(1, 0, m - 1, pos, m - 1, +z[nm[it]]);

            it++;
        }

        ans = max(ans, -a[i].sd + st[1]);
    }

    cout << ans;

    return 0;
}
