#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define ft first
#define sd second
#define pii pair<int, int>
#define pil pair<int, ll>
#define pli pair<ll, int>
#define pll pair<ll, ll>
#define pdd pair<ld, ld>
#define all(x) x.begin(),x.end()
#define sz(x) ((int)x.size())
#define MP make_pair
#define PB push_back
using namespace std;
using namespace __gnu_pbds;
typedef long long ll;
typedef long double ld;
template <class T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
const int N = 200100;
const int M = 200100;
const int P = 200100;
//const int oo = 2e9;
const int oo = 1e9;
const ll OO = 1e18;
const ll big_md = 999999999999999989;
const int md = 998244353;
const int PW = 20;
set<pii> ST;
vector<int> g[N], vc, gr[N];
int tin[N], tout[N], h[N], up[N][PW], st[N], vn[N], vv[N], mrk[N], ans[N], n, k, m, tt = 0, obr[N], pr[N];

void dfs(int v, int p){

    tin[v] = tt++;

    up[v][0] = p;

    for (int po = 1; po < PW; po++)
        up[v][po] = up[up[v][po - 1]][po - 1];

    for (int u : g[v]){
        if (u == p) continue;

        h[u] = h[v] + 1;

        dfs(u, v);
    }

    tout[v] = tt++;
}

bool upper(int a, int b){
    return (tin[a] <= tin[b] && tout[a] >= tout[b]);
}

int lca(int a, int b){

    if (upper(a, b)) return a;
    if (upper(b, a)) return b;

    for (int po = PW - 1; po >= 0; po--)
        if (!upper(up[a][po], b))
            a = up[a][po];

    return up[a][0];
}

int dist(int a, int b){
    return h[a] + h[b] - 2 * h[lca(a, b)];
}

bool cmp(int a, int b){
    return tin[a] < tin[b];
}

bool cmp1(int a, int b){
    return (tout[a] - tin[a]) > (tout[b] - tin[b]);
}

void DFS(int v, int up_col){

    if (mrk[v] >= 0)
        up_col = mrk[v];

    if (up_col >= 0)
        ans[v] = up_col;

    for (int u : gr[v]){

        DFS(u, up_col);

        if (ans[u] >= 0){

            if (ans[v] < 0)
                ans[v] = ans[u];
            else {

                int len1 = dist(obr[ans[v]], v);
                int len2 = dist(obr[ans[u]], v);

                len1 = (len1 + vv[ans[v]] - 1) / vv[ans[v]];
                len2 = (len2 + vv[ans[u]] - 1) / vv[ans[u]];

                if (len2 < len1 || (len2 == len1 && ans[u] < ans[v]))
                    ans[v] = ans[u];
            }
        }
    }
}

void ODFS(int v){

    if (pr[v] >= 0){

        int u = pr[v];

        if (ans[u] >= 0){

            if (ans[v] < 0)
                ans[v] = ans[u];
            else {

                int len1 = dist(obr[ans[v]], v);
                int len2 = dist(obr[ans[u]], v);

                len1 = (len1 + vv[ans[v]] - 1) / vv[ans[v]];
                len2 = (len2 + vv[ans[u]] - 1) / vv[ans[u]];

                if (len2 < len1 || (len2 == len1 && ans[u] < ans[v]))
                    ans[v] = ans[u];
            }
        }
    }

    for (int u : gr[v]){

        ODFS(u);

        if (ans[u] >= 0){

            if (ans[v] < 0)
                ans[v] = ans[u];
            else {

                int len1 = dist(obr[ans[v]], v);
                int len2 = dist(obr[ans[u]], v);

                len1 = (len1 + vv[ans[v]] - 1) / vv[ans[v]];
                len2 = (len2 + vv[ans[u]] - 1) / vv[ans[u]];

                if (len2 < len1 || (len2 == len1 && ans[u] < ans[v]))
                    ans[v] = ans[u];
            }
        }
    }
}

int main(){

#ifdef _LOCAL
    freopen("in.txt","r",stdin);
#else
    ios_base::sync_with_stdio(0); cin.tie(0);
#endif

    cin >> n;

    for (int i = 1; i < n; i++){

        int x, y; cin >> x >> y;

        x--; y--;

        g[x].PB(y);
        g[y].PB(x);
    }

    dfs(0, -1);

    fill(mrk, mrk + n, -1);
    fill(ans, ans + n, -1);

    int qq; cin >> qq;

    for (; qq; qq--){

        cin >> k >> m;

        vc.clear();

        for (int i = 0; i < k; i++){

            cin >> st[i] >> vv[i]; st[i]--;

            mrk[st[i]] = i;
            obr[i] = st[i];

            vc.PB(st[i]);
        }

        for (int i = 0; i < m; i++){

            cin >> vn[i]; vn[i]--;

            vc.PB(vn[i]);
        }

        sort(all(vc));

        vc.resize(unique(all(vc)) - vc.begin());

        sort(all(vc), cmp);

        int mem = sz(vc);

        for (int it = 1; it < mem; it++)
            vc.PB(lca(vc[it], vc[it - 1]));

        sort(all(vc));

        vc.resize(unique(all(vc)) - vc.begin());

        sort(all(vc), cmp1);

        pr[vc[0]] = -1;

//        for (int cr : vc)
//            cout << cr << '\n';

        ST.clear();

        ST.insert(MP(tin[vc[0]], vc[0]));

        for (int it = 1; it < sz(vc); ){

            int j = it;

            while (j < sz(vc) && (tout[vc[j]] - tin[vc[j]]) == (tout[vc[it]] - tin[vc[it]]))
                j++;

            for (int i = it; i < j; i++){

                pii anc = (*(--ST.upper_bound(MP(tin[vc[i]], vc[i]))));

                pr[vc[i]] = anc.sd;

                gr[anc.sd].PB(vc[i]);
            }

            for (int i = it; i < j; i++)
                ST.insert(MP(tin[vc[i]], vc[i]));

            it = j;
        }

        DFS(vc[0], -1);

        ODFS(vc[0]); // another DFS

//      clear

        for (int i = 0; i < k; i++)
            mrk[st[i]] = -1;

        for (int i = 0; i < m; i++)
            cout << ans[vn[i]] + 1 << " ";

        for (int cr : vc) {
            ans[cr] = -1;
            gr[cr].clear();
        }

        cout << '\n';

    }

    return 0;
}
