#include <bits/stdc++.h>
#define f first
#define s second
#define mk make_tuple
#define int long long

using namespace std;

struct node
{
    int a, s, y, maxi, add;
    node * left, * right;
    node(int val, int c)
    {
        a = val;
        s = -c;
        y = rand();
        maxi = -c;
        add = 0;
        left = right = nullptr;
    }
};

int get_max(node * root)
{
    if (!root)
        return -1e18;
    return root -> maxi;
}

void push(node * root)
{
    if (!root)
        return;
    if (root -> left)
        root -> left -> add += root -> add;
    if (root -> right)
        root -> right -> add += root -> add;
    root -> s += root -> add;
    root -> add = 0;
}

void update(node * root)
{
    if (!root)
        return;
    root -> maxi = max({get_max(root -> left), get_max(root -> right), root -> s}) + root -> add;
}

pair <node *, node *> split(node * root, int val)
{
    if (!root)
        return {nullptr, nullptr};
    push(root);
    pair <node *, node *> res;
    if (root -> a <= val)
    {
        res = split(root -> right, val);
        root -> right = res.f;
        update(root);
        return {root, res.s};
    }
    else
    {
        res = split(root -> left, val);
        root -> left = res.s;
        update(root);
        return {res.f, root};
    }
}

node * merg(node * root1, node * root2)
{
    if (!root1)
        return root2;
    if (!root2)
        return root1;
    if (root1 -> y < root2 -> y)
    {
        push(root1);
        root1 -> right = merg(root1 -> right, root2);
        update(root1);
        return root1;
    }
    else
    {
        push(root2);
        root2 -> left = merg(root1, root2 -> left);
        update(root2);
        return root2;
    }
}

int n, m, p, a, b, c, x, y, k, ans = -1e18;
node * root = nullptr;
pair <node *, node *> res;
vector <pair <int, int>> armor;
deque <tuple <int, int, int>> monster;

void dfs(node * root)
{
    if (!root)
        return;
    push(root);
    dfs(root -> left);
    ///cerr << "(" << root -> a << " " << root -> s << ") ";
    dfs(root -> right);
    update(root);
}

signed main()
{
    iostream::sync_with_stdio(0); cin.tie(0);
    cin >> n >> m >> p;
    for (int i = 0 ; i < n ; i++)
    {
        cin >> a >> c;
        res = split(root, a);
        root = merg(merg(res.f, new node(a, c)), res.s);
    }
    for (int i = 0 ; i < m ; i++)
        cin >> b >> c, armor.push_back({b, c});
    sort(armor.begin(), armor.end());
    for (int i = 0 ; i < p ; i++)
        cin >> x >> y >> k, monster.push_back(mk(y, x, k));
    sort(monster.begin(), monster.end());
    for (pair <int, int> g: armor)
    {
        tie(b, c) = g;
        while (monster.size() > 0)
        {
            tie(y, x, k) = monster[0];
            if (b <= y)
                break;
            monster.pop_front();
            res = split(root, x);
            if (res.s)
                res.s -> add += k, res.s -> maxi += k;
            root = merg(res.f, res.s);
            dfs(root);
            ///cerr << "\n";
        }
        ///cerr << get_max(root) << "\n";
        ans = max(ans, get_max(root) - c);
    }
    cout << ans;
    return 0;
}
