#include <bits/stdc++.h>
#define fastIO ios_base::sync_with_stdio(0); cin.tie(0);
#pragma GCC optimize("Ofast")
#pragma GCC optimize("-O3")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,tune=native")
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define forn(i,a,b) for (int i = (a); i < (b); i++)
#define rsz resize
#define ll long long
#define re return
#define mp make_pair
#define fi first
#define se second
#define endl "\n"
#define DEB(x) cout << #x << " is " << x << "\n";
#define INF (int)1000000000
#define INFL 1000000000000000000
using namespace std;

int n,m,p;

struct weapon{
    int x,y,z;
    weapon (int x = 0, int y = 0, int z = 0) {
        this->x = x;
        this->y = y;
        this->z = z;
    }
};

bool cmp(const weapon & a, const weapon & b) {
    return a.x < b.x || (a.x == b.x && a.y < b.y);
}

vector <pair <int, int> > a,b;
vector <weapon> pp;

void in() {
    cin >> n >> m >> p;
    a.rsz(n);
    b.rsz(m);
    forn(i, 0, n) {
        cin >> a[i].first >> a[i].second;
    }
    forn(i, 0, m) {
        cin >> b[i].fi >> b[i].se;
    }
    pp.rsz(p);
    forn(i, 0, p) {
        cin >> pp[i].x >> pp[i].y >> pp[i].z;
    }
}

void solve() {
    sort(all(pp), cmp);
    ll ans = -INFL;
    sort(all(a));
    sort(all(b));
    vector <int> minna(n+1, INF);
    vector <int> minnb(m+1, INF);
    vector <int> maxxy(p, 0);
    maxxy[0] = pp[0].y;
    for (int i = 1; i < p; i++) {
        maxxy[i] = max(maxxy[i-1], pp[i].y);
    }
    for (int i = n-1; i >= 0; i--) {
        minna[i] = min(minna[i+1], a[i].second);
    }
    for (int i = m-1; i >= 0; i--) {
        minnb[i] = min(minnb[i+1], b[i].second);
    }
    ll summ = 0;
    for (int i = 0; i < p; i++) {
        int j = upper_bound(all(a), mp(pp[i].x,INF)) - a.begin();
        if (j == n) {
            break;
        }
        int costa = minna[j];
        j = upper_bound(all(b), mp(maxxy[i],INF)) - b.begin();
        if (j == m) {
            break;
        }
        int costb = minnb[j];
        summ += pp[i].z;
       // DEB(ans);

        ans = max(ans, summ - costa - costb);
    }
    if (ans == -INFL) {
        cout << -(minna[0] + minnb[0]) << "\n";
    } else {
        cout << ans << "\n";
    }
}

int main() {
	fastIO;
	in();
	solve();
	return 0;
}
