#include <bits/stdc++.h>

using namespace std;

void solve()
{
    int n, m;
    cin >> n >> m;
    vector <vector <int> > g(n+1);
    vector <vector <int> > b(n+1);
    for (int i = 0; i < m; i++) {
        int t1, t2;
        cin >> t1 >> t2;
        g[t1].push_back(t2);
        b[t2].push_back(t1);
    }
    int k;
    cin >> k;
    vector <int> p(k);
    for (int i = 0; i < k; i++) {
        cin >> p[i];
    }
    int s = p[0];
    reverse(p.begin(), p.end());
    int f = p[0];
    vector <int> d(n+1, -1);
    vector <bool> used(n+1);
    queue <int> q;
    q.push(f);
    d[f] = 0;
    while(!q.empty()) {
        int v = q.front();
        q.pop();
        for (int i = 0; i < b[v].size(); i++) {
            int next = b[v][i];
            if (used[next] == false) {
                used[next] = true;
                d[next] = d[v] + 1;
                q.push(next);
            }
        }
    }
    int min_res = 0, max_res = 0;
    for (int i = 2; i < k; i++) {
        int v = p[i];
        bool f1 = false, f2 = false;
        if (d[v] <= d[p[i-1]]) {
            min_res++;
        }
        for (int j = 0; j < g[v].size(); j++) {
            int next = g[v][j];
            if (d[v] == d[next] + 1 && next != p[i-1] && f2 == false) {
                max_res++;
                break;
            }
        }
    }
    cout << min_res << " " << max_res << "\n";
}

int main()
{
    //freopen("input.txt","r",stdin);
    //freopen("output.txt","w",stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int q = 1;
    //cin >> q;
    while(q--) {
        solve();
        cout.flush();
    }
}
