#include <bits/stdc++.h>

using namespace std;

long long n, m, p;
vector <pair <long long, long long> > a;
vector <pair <long long, long long> > b;
vector <pair <long long, long long> > z;
vector <long long> c;

long long check2(long long x, long long y)
{
    long long result = 0;
    for (int i = 0; i < p; i++) {
        long long xx = z[i].first, yy = z[i].second;
        if (xx < x && yy < y) {
            result += c[i];
        }
    }
    long long cur = LLONG_MAX;
    for (int i = 0; i < m; i++){
        if (b[i].first >= y) {
            cur = min(cur, b[i].second);
        }
    }
    return result - cur;
}

long long check1(long long x)
{
    long long result = 0;
    long long cur = LLONG_MAX;
    for (int i = 0; i < n; i++) {
        if (a[i].first >= x) {
            cur = min(cur, a[i].second);
        }
    }
    result -= cur;
    long long l = 0, r = 1000000;
    cur = 0;
    while(r - l > 2) {
        long long m2 = r - (r - l) / 3;
        long long m1 = l + (r - l) / 3;
        long long d1 = check2(x, m1);
        long long d2 = check2(x, m2);
        if (d1 < d2) {
            l = m1;
        } else {
            r = m2;
        }
    }
    long long y = l;
    long long MAX = check2(x, l);
    for (long long i = l+1; i <= r; i++) {
        long long d = check2(x, i);
        if (d > MAX) {
            MAX = d;
            y = i;
        }
    }
    result += MAX;
    return result;
}

void solve()
{
    cin >> n >> m >> p;
    c.resize(p);
    for (int i = 0; i < n; i++) {
        int t1, t2;
        cin >> t1 >> t2;
        a.push_back({t1, t2});
    }
    for (int i = 0; i < m; i++) {
        int t1, t2;
        cin >> t1 >> t2;
        b.push_back({t1, t2});
    }
    for (int i = 0; i < p; i++) {
        int t1, t2;
        cin >> t1 >> t2 >> c[i];
        z.push_back({t1, t2});
    }
    long long l = 0, r = 1000000;
    while(r - l > 2) {
        long long m2 = r - (r - l) / 3;
        long long m1 = l + (r - l) / 3;
        long long d1 = check1(m1);
        long long d2 = check1(m2);
        if (d1 < d2) {
            l = m1;
        } else {
            r = m2;
        }
    }
    long long MAX = 0;
    for (long long i = l; i <= r; i++) {
        MAX = max(MAX, check1(i));
    }
    cout << MAX << "\n";
}

int main()
{
    //freopen("input.txt","r",stdin);
    //freopen("output.txt","w",stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int q = 1;
    //cin >> q;
    while(q--) {
        solve();
        cout.flush();
    }
}
