#include<iostream>
#include<vector>
#include<algorithm>
#include<cmath>
#include<queue>
#include<map>

using namespace std;

#define int long long

int d1[200000+5], d2[200000+5], e[200000+5];

int st[200000+5];

int p[200000+5];

const int md1=1e9+7;

int n,k;

string s;

int get_hash(int l, int siz)
{
    int l0=l;
    int r=l+siz-1;
    int h=0;
    int cnt=0;
    int pos=l;
    while (pos%k!=1)
    {
        if (s[pos]=='0')
        {
            int y=st[cnt];
            if (pos%2!=0) y=st[cnt]*2;
            if (l0%2!=0)
            {
                if (pos%2==0) y=st[cnt]*2;
                else y=st[cnt];
            }
            h+=y;
            h%=md1;
            cnt++;
        }
        pos++;
    }
    l=pos;
    for (int i=1; i<=n; i++)
    {
        int lb=(i-1)*k+1;
        int rb=i*k;
        if (!(lb>=l&&rb<=r)) continue;
        if (l0%2==0) h+=d1[i]*st[cnt];
        else h+=d2[i]*st[cnt];
        h%=md1;
        cnt+=e[i];
    }
    int u=(r-1)/k+1;
    pos=(u-1)*k+1;
    while (pos<=r)
    {
        if (s[pos]=='0')
        {
            int y=st[cnt];
            if (pos%2!=0) y=st[cnt]*2;
            if (l0%2!=0)
            {
                if (pos%2==0) y=st[cnt]*2;
                else y=st[cnt];
            }
            h+=y;
            h%=md1;
            cnt++;
        }
        pos++;
    }
    return h;
}

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin>>n;
    cin>>s;
    s="!"+s;
    st[0]=1;
    for (int i=1; i<=n; i++)
    {
        st[i]=st[i-1]*3;
        st[i]%=md1;
    }
    for (int i=1; i<=n; i++)
    {
        p[i]=p[i-1];
        if (s[i]=='0') p[i]++;
    }
    k=sqrt(n);
    for (int i=1; i<=n; i+=k)
    {
        int num=(i-1+k)/k;
        int cnt=0;
        for (int j=i; j<=min(n,i+k-1); j++)
        {
            if (s[j]=='0')
            {
                e[num]++;
                if (j%2==0)
                {
                    d1[num]+=st[e[num]-1];
                }
                else
                {
                    d1[num]+=st[e[num]-1]*2;
                }
                d1[num]%=md1;
                if (j%2==0)
                {
                    d2[num]+=st[e[num]-1]*2;
                }
                else
                {
                    d2[num]+=st[e[num]-1];
                }
                d2[num]%=md1;
                cnt++;
            }
        }
    }
    int q;
    cin>>q;
    for (int o=0; o<q; o++)
    {
        int l,r,t;
        cin>>l>>r>>t;
        if (p[l+t-1]-p[l-1]!=p[r+t-1]-p[r-1])
        {
            cout<<"No"<<'\n';
            continue;
        }
        int h1=get_hash(l,t);
        int h2=get_hash(r,t);
        if (h1!=h2)
        {
            cout<<"No"<<'\n';
        }
        else
        {
            cout<<"Yes"<<'\n';
        }
    }
}
