#include <bits/stdc++.h>

using namespace std;

void QuickStart(){
    ios_base::sync_with_stdio(0); cin.tie(0);
}

typedef long long ll;

vector<vector<int> >g;
vector<vector<int> >g1;
vector<int>d;
vector<int>c;

void bfs(int s){
    queue<int>q;
    d[s] = 0;
    q.push(s);
    while(!q.empty()){
        int v = q.front();
        q.pop();
        for(int i = 0; i < g1[v].size(); i++){
            if(d[g1[v][i]] == 1e9){
                d[g1[v][i]] = d[v] + 1;
                q.push(g1[v][i]);
            }
        }
    }
}

void solve(){
    int n, m;
    cin >> n >> m;
    g.resize(n); g1.resize(n); c.resize(n);
    d.resize(n, 1e9);
    for(int i = 0; i < m; i++){
        int a, b;
        cin >> a >> b;
        g1[b - 1].push_back(a - 1);
        g[a - 1].push_back(b - 1);
    }
    int k; cin >> k;
    vector<int>p(k);
    for(int i = 0; i < k; i++){
        cin >> p[i];
        p[i]--;
    }
    bfs(p[k - 1]);
    for(int i = 0; i < n; i++){
        for(int j = 0; j < g[i].size(); j++){
            if(d[i] == d[g[i][j]] + 1){
                c[i]++;
            }
        }
    }
    int ans1 = 0, ans2 = 0;
    for(int i = 0; i < k - 1; i++){
        if(d[p[i]] < k - i - 1){
            ans1++, ans2++;
        }
        else if(d[p[i]] == k - i - 1 && c[p[i]] > 1){
            ans2++;
        }
    }
    cout << ans1 << ' ' << ans2;
}

int main()
{
    QuickStart();
    solve();
    return 0;
}
