#define CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <cmath>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <assert.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
const ll INF = 1e18;
const double PI = acos(-1.0);



int main()
{
	ios::sync_with_stdio(false);

	int n;
	string s;
	cin >> n >> s;

	int res = 0;
	while (true)
	{
		int maxi = -1;
		int id = -1;
		for (int i=0; i<n; i++)
		{
			if (i > 0 && s[i] == s[i - 1] + 1 && s[i] - 'a' > maxi)
			{
				maxi = s[i] - 'a';
				id = i;
			}
			if (i < n - 1 && s[i] == s[i + 1] + 1 && s[i] - 'a' > maxi)
			{
				maxi = s[i] - 'a';
				id = i;
			}
		}

		if (maxi == -1)
			break;

		s = s.substr(0, id) + s.substr(id + 1, n - id - 1);
		n--;
		res++;
	}
	cout << res;

	//system("pause");
	return 0;
}