#include<bits/stdc++.h>

#define F first
#define S second
#define pb push_back
#define ll long long
#define ld long double
#define _ <<' '<<
#define endl '\n'

using namespace std;

const int N = 1e6 + 7;
const int M = 1e9 + 7;

int n, m, p, x, y, z, a, ca, b, cb;
vector<pair<int,int> > add[N];

struct segtree{
    int tn = 1;
    vector<ll> t;
    vector<ll> lazy;

    segtree(){
        while (tn <= N) tn <<= 1;
        t.resize(tn<<1|1);
        lazy.resize(tn<<1|1);
    }

    void push(int v){
        t[v<<1] += lazy[v];
        t[v<<1|1] += lazy[v];
        lazy[v<<1] += lazy[v];
        lazy[v<<1|1] += lazy[v];
        lazy[v] = 0;
    }

    void upd(int v, int tl, int tr, int l, int r, ll x){
        if (r <= tl || tr <= l) return;
        if (l <= tl && tr <= r){
            t[v] += x;
            lazy[v] += x;
            return;
        }
        push(v);
        int m = (tl + tr)>>1;
        upd(v<<1, tl, m, l, r, x);
        upd(v<<1|1, m, tr, l, r, x);
        t[v] = max(t[v<<1], t[v<<1|1]);
    }

    void upd(int l, int r, ll x){
        upd(1, 0, tn, l, r, x);
    }

    ll q(int v, int tl, int tr, int l, int r){
        if (r <= tl || tr <= l) return -1e18 - 7;
        if (l <= tl && tr <= r) return t[v];
        push(v);
        int m = (tl + tr)>>1;
        return max(q(v<<1, tl, m, l, r),
                   q(v<<1|1, m, tr, l, r));
    }

    ll q(int l, int r){
        return q(1, 0, tn, l, r);
    }
}t;

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    cin >> n >> m >> p;
    vector<ll> dela(N, 1e18 + 7);
    vector<ll> delb(N, 1e18 + 7);
    for (int i = 0; i < n; i++) cin >> a >> ca, dela[a] = min(dela[a], 1ll*ca);
    for (int i = 0; i < m; i++) cin >> b >> cb, delb[b] = min(delb[b], 1ll*cb);
    for (int i = 0; i < p; i++) cin >> y >> x >> z, add[x + 1].pb( {y, z} );
    for (int i = N - 1; i > 0; i--)
        dela[i - 1] = min(dela[i], dela[i - 1]);
    for (int i = N - 1; i > 0; i--){
        delb[i - 1] = min(delb[i], delb[i - 1]);
        t.upd(i, i + 1, -delb[i]);
    }
    ll res = -dela[0] - delb[0];
    for (int i = 0; i < N; i++){
        for (auto it : add[i]){
            t.upd(it.F + 1, N, it.S);
        }
//        cerr << i _ t.q(0, N) _ dela[i] _ delb[i] << endl;
        res = max(res, t.q(0, N) - dela[i]);
    }
    cout << res;
    return 0;
}
