#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;
typedef pair<ll,ll> pll;
typedef pair<pll,ll> plll;
typedef pair<pll,pll> ppll;

#define all(x) (x).begin(),(x).end()
#define rall(x) (x).rbegin(),(x).rend()
#define ins insert
#define pb push_back
#define fst first
#define snd second
///#define mp make_pair

template< class T>
using ordered_set = tree<T,null_type,less<T>,rb_tree_tag,tree_order_statistics_node_update>;
const ll N = 1e6 + 5;
const ll INF = 1e18 + 5;
ll t[4 * N],p[4 * N];
void push(ll v){
    t[2 * v] += p[v];
    t[2 * v + 1] += p[v];
    p[2 * v] += p[v];
    p[2 * v + 1] += p[v];
    p[v] = 0;
}
void upd(ll v,ll tl,ll tr,ll l,ll r,ll val){
    if(r < tl || tr < l)return;
    if(l <= tl && tr <= r){
        t[v] += val;
        p[v] += val;
        return;
    }
    push(v);
    ll tm = (tl + tr) >> 1;
    upd(2 * v,tl,tm,l,r,val);
    upd(2 * v + 1,tm + 1,tr,l,r,val);
    t[v] = max(t[2 * v],t[2 * v + 1]);
}
ll get(ll v,ll tl,ll tr,ll l,ll r){
    if(r < tl || tr < l)return 0;
    if(l <= tl && tr <= r){
        return t[v];
    }
    push(v);
    ll tm = (tl + tr) >> 1;
    return max(get(2 * v,tl,tm,l,r),get(2 * v + 1,tm + 1,tr,l,r));
}
ll ca[N],cb[N];
vector<pll> ev[N];
main(){
    ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
    ll n,m,p;
    cin >> n >> m >> p;
    memset(ca,0x63,sizeof(ca));
    memset(cb,0x63,sizeof(cb));
    for(ll i = 0;i < n; ++i){
        ll x,y;
        cin >> x >> y;
        ca[x] = min(ca[x],y);
    }
    for(ll i = 0;i < m; ++i){
        ll x,y;
        cin >> x >> y;
        cb[x] = min(cb[x],y);
    }
    for(ll i = N - 2;i >= 0; --i){
        ca[i] = min(ca[i],ca[i + 1]);
        cb[i] = min(cb[i],cb[i + 1]);
    }
    for(ll i = 0;i < p; ++i){
        ll x,y,z;
        cin >> x >> y >> z;
        ev[x + 1].pb({y,z});
    }
    for(ll i = 0;i < N; ++i){
        upd(1,0,N - 1,i,i,-cb[i]);
    }
    ll ans = -ca[0] - cb[0];
    for(ll i = 0;i < N; ++i){
        for(auto &it : ev[i]){
            upd(1,0,N - 1,it.fst + 1,N - 1,it.snd);
        }
        ans = max(ans,t[1] - ca[i]);
    }
    cout << ans;
    return 0;
}
