#include <bits/stdc++.h>

#define len(a) (int)(a.size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define endl '\n'
#define dbg(a) cout << #a << ' ' << a << '\n'

using namespace std;
typedef long long ll;
typedef long double ld;

const int MAX = (int)(2e5) + 7;
const int INF_INT = (int)(1e9) + 7;
const int MOD = (int)(1e9) + 7;
const ll INF_LL = (ll)(1e18) + 7;

void solve();
void boot_up() {
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // LOCAL
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios::sync_with_stdio(false);
}

template<typename T> inline void info(T & v) { for (const auto & it : v) { cout << it << ' '; } cout << endl; }

template<typename T1, typename T2> inline bool chkmin(T1 & a, T2 & b) { if (a > b) { a = b; return true; } return false; }

template<typename T1, typename T2> inline bool chkmax(T1 & a, T2 & b) { if (a < b) { a = b; return true; } return false; }

template<typename T> inline void init(vector<T> & v, size_t _size, T value = 0) { v.assign(_size, value); }



int n;
string s;

signed main() {
    boot_up();

    while (cin >> n >> s) {
        solve();
    }
}

void solve() {
    int start_len = n;
    bool can_del = true;

    while (can_del) {
        can_del = false;

        int pos_del = -1;

        for (int i = 0; i < len(s); ++i) {
            if (s[i] == 'a') {
                continue;
            }

            bool chto = false;

            if (i > 0) {
                if (s[i] - s[i - 1] == 1) {
                    chto = true;
                }
            }

            if (i + 1 < len(s)) {
                if (s[i] - s[i + 1] == 1) {
                    chto = true;
                }
            }

            if (chto) {
                can_del = true;
                if (pos_del == -1) {
                    pos_del = i;
                }
                else if (s[pos_del] < s[i]) {
                    pos_del = i;
                }
            }
        }

        if (pos_del == -1) {
            break;
        }

        string new_s = "";
        for (int i = 0; i < len(s); ++i) {
            if (i != pos_del) {
                new_s += s[i];
            }
        }

        s = new_s;
    }

    cout << n - len(s) << endl;
}
