#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

#define sc second
#define fs first
#define all(x) x.begin(), x.end()
#define pb push_back
#define rall(x) x.rbegin(). x.rend()
#define fast_io ios_base::sync_with_stdio(0); cin.tie(0);
#define int long long

struct mo{
    ll a, b, x, ind;
};

vector<ll> t(1e6, 0), p(1e6, 0);

void push(ll v){
    t[v*2] += p[v];
    t[v*2+1] += p[v];
    p[v*2] += p[v];
    p[v*2+1] += p[v];
    p[v] = 0;
}

void update(ll v, ll tl, ll tr, ll l, ll r, ll x){
    if(l > r){
        return;
    }
    if(tl == l && tr == r){
        t[v] += x;
        p[v] += x;
        return;
    }
    push(v);
    ll mid = (tl+tr)/2;
    update(v*2, tl, mid, l, min(r, mid), x);
    update(v*2+1, mid+1, tr, max(l, mid+1), r , x);
    t[v] = max(t[v*2], t[v*2+1]);
}

ll get(ll v, ll tl, ll tr, ll l, ll r){
    if(l > r){
        return -1e15;
    }
    if(tl == l && tr == r){
        return t[v];
    }
    ll mid = (tr+tl)/2;
    return max(get(v*2, tl, mid, l, min(r, mid)), get(v*2+1, mid+1, tr, max(l, mid+1), r));
}

bool comp1(mo a, mo b){
    return a.a < b.a;
}

bool comp2(mo a, mo b){
    return a.b < b.b;
}

signed main()
{
    fast_io
    ll n, m, k;
    cin >> n >> m >> k;
    vector<pair<ll, ll> > a1(n), b1(m), a2, b2;
    for(int i = 0; i < n; i++){
        cin >> a1[i].fs;
        cin >> a1[i].sc;
    }
    for(int i = 0; i < m; i++){
        cin >> b1[i].fs;
        cin >> b1[i].sc;
    }

    vector<mo> m1(k), m2;
    vector<ll>ind(k);

    for(int i = 0; i < k; i++){
        mo x;
        cin >> x.a >> x.b >> x.x;
        x.ind = i;
        m1[i] = x;
    }
    m2 = m1;

    sort(all(a1));
    sort(all(b1));

    a1.pb({1e18, 1e18});

    for(int i = 0; i <= n; i++){
        update(1, 0, n, i, i, -a1[i].sc);
    }

    sort(all(m2), comp1);
    sort(all(m1), comp2);

    ll l = 0;

    for(int i = 0; i < k; i++){
        while(m2[i].a >= a1[l].fs){
            l++;
        }
        ind[m2[i].ind] = l;
    }

    ll ans = -1e18;
    l = 0;
    for(int i = 0; i < m; i++){
        while(l < k && m1[l].b < b1[i].fs){
            update(1, 0, n, ind[m1[l].ind], n, m1[l].x);
            l++;
        }
        ll z = t[1] - b1[i].sc;
        ans = max(ans, z);
    }

    cout << ans;

}
