#include<bits/stdc++.h>

using namespace std;

const int INF = 1e9 + 239;

vector<int> bfs(int n, vector<vector<int>> &g, int st) {
    vector<int> d(n, INF);
    d[st] = 0;
    queue<int> q;
    q.push(st);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (auto t : g[v]) {
            if (d[t] > d[v] + 1) {
                d[t] = d[v] + 1;
                q.push(t);
            }
        }
    }
    return d;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    
    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    #endif

    int n, m;
    cin >> n >> m;
    vector<vector<int>> g(n);
    vector<vector<int>> ig(n);
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        g[u].push_back(v);
        ig[v].push_back(u);
    }   
    int k;
    cin >> k;
    vector<int> p(k);
    for (auto &t : p) {
        cin >> t;
        t--;
    }
    auto sd = bfs(n, g, p.front());
    auto ed = bfs(n, ig, p.back());
    int mn = 0;
    for (int i = 0; i + 1 < k; i++) {
        int u = p[i];
        int v = p[i + 1];
        if (ed[v] + 1 == ed[u]) {
            //
        } else {
            mn++;
        }
    }
    cout << mn << endl;
    int mx = 0;
    vector<int> c(n);
    for (int i = 0; i < n; i++) {
        for (auto j : g[i]) {
            if (ed[j] + 1 == ed[i]) c[i]++;
        }
    }
    for (int i = 0; i + 1 < k; i++) {
        int u = p[i];
        int v = p[i + 1];
        if (ed[v] + 1 == ed[u] && c[u] == 1) {
            //
        } else {
            mx++;
        }
    }
    cout << mx << endl;

}
