#include<bits/stdc++.h>

using namespace std;

#define int long long

vector<int> cnt(string s) {
    int n = (int)s.size();
    int c = 0;
    vector<int> a;
    for (int i = 0; i < n; i++) {
        if (i + 1 < n && s[i] == '1' && s[i + 1] == '1') {
            c++;
            i++;
        } else {
            a.push_back(i - 2 * c);
        }
    }
    return a;
}

int st(string s) {
    reverse(s.begin(), s.end());
    int ans = 0;
    for (auto t : s) {
        ans *= 2;
        ans += (t == '1');
    }
    return ans;
}

string rt(int x, int s) {
    string ans;
    for (int i = 0; i < s; i++) {
        ans.push_back(((x >> i) & 1) + '0');
    }
    return ans;
}

vector<int> nx(int x, int n) {
    string s = rt(x, n);
    vector<int> ans;
    for (int i = 1; i + 1 < n; i++) {
        if (s[i] == '1') {
            string t = s;
            swap(t[i - 1], t[i + 1]);
            ans.push_back(st(t));
        }
    }
    return ans;
}

int stupid(string s, string t) {
    int n = (int)s.size();
    vector<int> used(1 << n);
    int a = st(s);
    int b = st(t);

    used[a] = 1;
    queue<int> q;
    q.push(a);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        auto nv = nx(v, n);
        for (auto t : nv) {
            if (!used[t]) {
                used[t] = 1;
                q.push(t);
            }
        }
    }
    return used[b];
}

int my(string s, string t) {
   
   return cnt(s) == cnt(t);       
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    
    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    #endif

    int n;
    cin >> n;
    string s;
    cin >> s;
    int q;
    cin >> q;
    while (q--) {
        int i1, i2, len;
        cin >> i1 >> i2 >> len;
        i1--;
        i2--;
        string ka, kb;
        for (int i = 0; i < len; i++) {
            ka.push_back(s[i1 + i]);
            kb.push_back(s[i2 + i]);
        }            
        if (my(ka, kb)) cout << "Yes\n";
        else cout << "No\n";
    }

    /*int n = 5;
    while (true) {
        string a, b;
        for (int i = 0; i < n; i++) {
            a.push_back((rand() & 1) + '0');
            b.push_back((rand() & 1) + '0');
        }                 
        if (my(a, b) != stupid(a, b)) {
            cout << "WA " << a << ' ' << b << endl;
            exit(0); 
        }
    }*/
}
