//#define USE_PRAGMAS
#include<bits/stdc++.h>
#ifdef USE_PRAGMAS
#pragma GCC optimize("-Ofast, unroll-loops")
#pragma GCC target("sse4.2,avx,avx2,tune=native")
#endif
using namespace std;
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector<vector<int>> g(n);
    for (int i = 0; i < m; i++)
    {
        int u, v;
        cin >> u >> v;
        g[v - 1].push_back(u - 1);
    }
    int k;
    cin >> k;
    vector<int> p(k);
    for (int i = 0; i < k; i++)
    {
        cin >> p[i];
        p[i]--;
    }
    int s = p[0], t = p.back();

    vector<pair<int, int>> dtt(n, {INT_MAX, 0});
    vector<bool> used(n, false);
    dtt[t] = {0, 1};
    queue<int> bfs;
    bfs.push(t);
    while (!bfs.empty())
    {
        int curr = bfs.front();
        bfs.pop();
        if (used[curr])
            continue;
        used[curr] = true;
        for (int to : g[curr])
        {
            if (dtt[to].first < dtt[curr].first + 1)
                continue;
            if (dtt[to].first == dtt[curr].first + 1)
                dtt[to].second++;
            else
                dtt[to] = {dtt[curr].first + 1, 1}, bfs.push(to);
        }
    }

    int min = 0, max = 0;
    int prev = s;
    for (int i = 1; i < k; i++)
    {
        if (dtt[p[i]].first + 1 != dtt[prev].first)
        {
            min++;
            max++;
        }
        else if (dtt[prev].second > 1)
            max++;
        prev = p[i];
    }
    cout << min << " " << max;
}
