#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <functional>
#include <tuple>
#include <numeric>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef tree<ll, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> os_tree;

int main() {
    ll n;
    cin >> n;
    string s;
    cin >> s;
    vector<vector<bool>> dp1(n, vector<bool>(n, false));
    for (ll len = 2; len <= n; len++) {
        for (ll l = 0; l + len - 1 < n; l++) {
            ll r = l + len - 1;
            if (len >= 3 ? dp1[l + 1][r - 1] : true) {
                if ((ll) s[l] == (ll) s[r] + 1) {
                    dp1[l][r - 1] = true;
                }
                if ((ll) s[r] == (ll) s[l] + 1) {
                    dp1[l + 1][r] = true;
                }
            }
            for (ll x = l; x < r; x++) {
                if (dp1[l][x] && dp1[x + 1][r]) {
                    dp1[l][r] = true;
                }
            }
        }
    }
    vector<vector<ll>> dp2(n, vector<ll>(n, 0));
    for (ll len = 1; len <= n; len++) {
        for (ll l = 0; l + len - 1 < n; l++) {
            ll r = l + len - 1;
            if (dp1[l][r]) {
                dp2[l][r] = r - l + 1;
            }
            for (ll x = 0; x < len; x++) {
                dp2[l][r] = max(dp2[l][r], dp2[l + x][r]);
                dp2[l][r] = max(dp2[l][r], dp2[l][r - x]);
            }
            for (ll x = l + 1; x <= r - 1; x++) {
                dp2[l][r] = max(dp2[l][r], dp2[l][x - 1] + dp2[x + 1][r]);
            }
        }
    }
    cout << dp2[0][n - 1] << endl;
    return 0;
}
