#pragma GCC target("avx2")
#pragma GCC optimize("O3")

#include <bits/stdc++.h>

#define int long long
#define S second 
#define F first
#define pb push_back
#define sz(x) (int)(x.size())
#define ll long long
#define all(x) x.begin(), x.end()
#define make make_pair

typedef unsigned long long ull;

using namespace std;

const int N = (int)3e6 + 222;
const int MOD = (int)1e9 + 7;
const ll INF = (ll)1e18;
    
int n, m, k;
int a[N], b[N], ca[N], cb[N], used[N], used1[N], t[N * 4], p1[N * 4];
int x[N], y[N], z[N];
pair <int, pair <int, int> > p[N];

void build (int v, int l, int r) {
	if (l == r) {
		t[v] -= used1[l];
		return;
	}
	int mid = (l + r) / 2;
	build (v * 2, l, mid);
	build (v * 2 + 1, mid + 1, r);
	t[v] = max(t[v * 2], t[v * 2 + 1]);
}
void push (int v, int l, int r) {
	if (p1[v] != 0) {
		int mid = (l + r) / 2;
	 	p1[v * 2] += p1[v];
	 	p1[v * 2 + 1] += p1[v];
	 	t[v * 2] += p1[v];
	 	t[v * 2 + 1] += p1[v];
	 	p1[v] = 0; 
	}
}

void update (int v, int l, int r, int L, int R, int val) {
	if (l > R || L > r) return;
	push(v, l, r);
	if (L <= l && r <= R) {
		p1[v] += val; 
		t[v] += val;
		push(v, l, r);           		
		return;
	}
	push(v, l, r);
	int mid = (l + r) / 2;
	update(v * 2, l, mid, L, R, val);
	update(v * 2 + 1, mid + 1, r, L, R, val);
	t[v] = max(t[v * 2], t[v * 2 + 1]);
}
int get (int v, int l, int r, int L, int R) {
	if (l > R || L > r) return -INF;
	push(v, l, r);
	if (L <= l && r <= R) return t[v];
	int mid = (l + r) / 2;
	return max(get(v * 2, l, mid, L, R), get(v * 2 + 1, mid + 1, r, L, R));
}


    
inline void solve () {
	cin >> n >> m >> k;
	for (int i = 1; i <= (int)2e6; ++i) used[i] = INF;
	for (int i = 1; i <= n; ++i) {
		cin >> a[i] >> ca[i];
		used[a[i]] = min(used[a[i]], ca[i]);   
	}
	for (int i = (int)1e6 - 1; i >= 1; --i) {
		used[i] = min(used[i + 1], used[i]);
    }       
    for (int i = 1; i <= (int)2e6; ++i) used1[i] = INF;
    for (int i = 1; i <= m; ++i) {
    	cin >> b[i] >> cb[i];
    	used1[b[i]] = min(used1[b[i]], cb[i]);
    }
    for (int i = (int)1e6 - 1; i >= 1; --i) {
    	used1[i] = min(used1[i + 1], used1[i]);
    }

    build (1, 1, (int)1e6 + 222);
	for (int i = 1; i <= k; ++i) {
		cin >> x[i] >> y[i] >> z[i];
		p[i] = make(x[i], make(y[i], z[i]));
   	}
   	int mx = -INF;
   	sort(p + 1, p + 1 + k);
   	for (int i = 1; i <= k; ++i) {
   		x[i] = p[i].F;
   		y[i] = p[i].S.F;
   		z[i] = p[i].S.S;
   		update(1, 1, (int)1e6 + 222, y[i] + 1, (int)1e6 + 22, z[i]);
   		mx = max(get(1, 1, (int)1e6 + 222, 1, (int)1e6 + 22) - used[x[i] + 1], mx);
   	}
   	cout << mx;


}

main () {
	#ifdef Maga
		freopen("input.in", "r", stdin);
	#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int t = 1;
	while (t --) {
		solve();
	}
	
	return 0;
}