import java.io.*;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Locale;
import java.util.StringTokenizer;

public class A {
    static class Parser{
        private BufferedReader bf;
        private StringTokenizer st;


        Parser(){
            bf = new BufferedReader(new InputStreamReader(System.in));
        }

        Parser(int a) throws FileNotFoundException {
            bf = new BufferedReader(new FileReader("input.txt"));
        }

        String next() throws IOException {
            while(st == null || !st.hasMoreTokens()) st = new StringTokenizer(bf.readLine());
            return st.nextToken();
        }

        int nextInt() throws IOException {
            return Integer.parseInt(next());
        }

        long nextLong() throws IOException {
            return Long.parseLong(next());
        }
    }

    static Parser in;
    static PrintWriter out;

    static int n, m;

    static void solve() throws IOException {
        n = in.nextInt();
        String s = in.next();
        for (int ch = 'z'; ch >= 'a'; --ch) {
            ArrayList<Integer> arr = new ArrayList<>();
            for (int i = 0; i < s.length(); i++) {
                if(s.charAt(i) == ch){
                    if((i > 0 && s.charAt(i - 1) == ch - 1)
                            || (i + 1 < s.length() && s.charAt(i + 1) == ch - 1)) arr.add(i);
                }
            }
            if(arr.isEmpty()) continue;
            int newS_it = 0;
            char[] newS = new char[s.length() - arr.size()];
            int it = 0;
            for (int i = 0; i < s.length(); i++) {
                if(it < arr.size() && arr.get(it) == i){
                    ++it;
                    continue;
                }
                newS[newS_it++] = s.charAt(i);
            }
            s = new String(newS);
            if(!arr.isEmpty()) ++ch;
        }

        out.print(n - s.length());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        in = new Parser();
        out = new PrintWriter(System.out);

        solve();

        out.close();
    }
}
