#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>
#include <map>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <ext/pb_ds/assoc_container.hpp>

#define f first
#define s second
#define eb emplace_back
#define pb push_back
#define int long long
#define ld long double

using namespace std;
using namespace __gnu_pbds;

template < typename firstType = null_type, typename secondType = null_type, class compare = less < firstType > >
struct sett {
    typedef tree <
        firstType,
        secondType,
        compare,
        rb_tree_tag,
        tree_order_statistics_node_update
    > _ ;
};


const int INF = 1e18 + 7;
const int P = 32;


pair < int, int > a[200001], b[200001];
int a1[200001], b1[200001];
struct {
    int x, y, z;
}c[200001];
pair < pair < int, int >, int > ans[200001];
int t[1000000];
map < int, int > pr;


bool cmp (pair < pair < int, int >, int > x, pair < pair < int, int >, int > y){
    return x.f.f < y.f.f || x.f.f == y.f.f && x.f.s < y.f.s;
}

bool cmp1 (pair < pair < int, int >, int > x, pair < pair < int, int >, int > y){
    return x.f.s < y.f.s || x.f.s == y.f.s && x.f.f < y.f.f;
}

int sum (int ver, int tl, int tr, int l, int r){
    if (l > r)
        return 0;
    else if (l == tl && r == tr)
        return t[ver];
    else {
        int mm = (tl + tr) / 2;
        return sum(ver * 2 + 1, tl, mm, l, min(r, mm)) + sum(ver * 2 + 2, mm + 1, tr, max(mm + 1, l), r);
    }
}

void update (int ver, int tl, int tr, int pos, int val){
    if (tl == tr)
        t[ver] += val;
    else {
        int mm = (tl + tr) / 2;
        if (pos <= mm)
            update(ver * 2 + 1, tl, mm, pos, val);
        else
            update(ver * 2 + 2, mm + 1, tr, pos, val);
    }
}


signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, m, p;
    cin >> n >> m >> p;
    for (int i = 0; i < n; i++)
        cin >> a[i].f >> a[i].s;
    a1[n - 1] = a[n - 1].s;
    for (int i = n - 2; i >= 0; i--)
        a1[i] = min(a1[i + 1], a[i].s);

    for (int i = 0; i < m; i++)
        cin >> b[i].f >> b[i].s;
    b1[m - 1] = b[m - 1].s;
    for (int i = m - 2; i >= 0; i--)
        b1[i] = min(b1[i + 1], b[i].s);

    sort(a, a + n);
    sort(b, b + m);
    for (int i = 0; i < p; i++) {
        cin >> c[i].x >> c[i].y >> c[i].z;
        ans[i].s = i;
    }

    for (int i = 0; i < p; i++){
        int l = -1, r = n;
        for (; l < r - 1; ){
            int mm = (l + r) / 2;
            if (a[mm].f > c[i].y)
                r = mm;
            else
                l = mm;
        }
        if (r == n){
            ans[i].f.f = INF;
            ans[i].f.s = INF;
            continue;
        }
        else
            ans[i].f.f = a1[r];

        l = -1, r = m;
        for (; l < r - 1; ){
            int mm = (l + r) / 2;
            if (b[mm].f > c[i].x)
                r = mm;
            else
                l = mm;
        }
        if (r == m){
            ans[i].f.f = INF;
            ans[i].f.s = INF;
            continue;
        }
        else
            ans[i].f.s = b1[r];
    }
    sort(ans, ans + p, cmp);
    int top = 0;
    for (int i = 0; i < p; i++){
        if (i != 0 && ans[i].f.s != ans[i - 1].f.s)
            top++;
        pr[ans[i].f.s] = top;
    }

    int mx = -(a[0].s + b[0].s);
    for (int i = 0; i < p; i++){
        if (ans[i].f.f == INF)
            break;
        update(0, 0, m - 1, pr[ans[i].f.s], c[ans[i].s].z);
        int l = ans[i].f.s, r = INF;
        for (; l < r - 2; ){
            int mm1 = (r - l) / 3 + l;
            int mm2 = r - (r - l) / 3;
            int ans1 = -mm1 + sum(0, 0, m - 1, 0, pr[(*--pr.upper_bound(mm1)).f]);
            int ans2 = -mm2 + sum(0, 0, m - 1, 0, pr[(*--pr.upper_bound(mm2)).f]);
            if (ans1 >= ans2)
                r = mm2;
            else
                l = mm2;
        }
        for (int j = l; j < l + 3; j++){
            int answer = -(ans[i].f.f + j);
            answer += sum(0, 0, m - 1, 0, pr[(*--pr.upper_bound(j)).f]);
            mx = max(mx, answer);
        }
    }
    sort(ans, ans + p, cmp1);
    top = 0;
    pr.clear();
    for (int i = 0; i < p; i++){
        if (i != 0 && ans[i].f.f != ans[i - 1].f.f)
            top++;
        pr[ans[i].f.f] = top;
    }
    for (int i = 0; i < 1000000; i++)
        t[i] = 0;
    for (int i = 0; i < p; i++){
        if (ans[i].f.f == INF)
            break;
        update(0, 0, n - 1, pr[ans[i].f.f], c[ans[i].s].z);
        int l = ans[i].f.f, r = INF;
        for (; l < r - 2; ){
            int mm1 = (r - l) / 3 + l;
            int mm2 = r - (r - l) / 3;
            int ans1 = -mm1 + sum(0, 0, n - 1, 0, pr[(*--pr.upper_bound(mm1)).f]);
            int ans2 = -mm2 + sum(0, 0, n - 1, 0, pr[(*--pr.upper_bound(mm2)).f]);
            if (ans1 >= ans2)
                r = mm2;
            else
                l = mm2;
        }
        for (int j = l; j < l + 3; j++){
            int answer = -(ans[i].f.s + j);
            answer += sum(0, 0, n - 1, 0, pr[(*--pr.upper_bound(j)).f]);
            mx = max(mx, answer);
        }
    }
    cout << mx;
    return 0;
}
