#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define int long long
#define X first
#define Y second
#define sz(a) (int)a.size()
#define pb push_back

using namespace std;
using namespace __gnu_pbds;

typedef tree <
int,
null_type,
less <int>,
rb_tree_tag,
tree_order_statistics_node_update> orderedset;

mt19937
rng(chrono::steady_clock::now().time_since_epoch().count());

gp_hash_table <int, int> m;

struct node {
    int ata, zac, cost;
};

vector <pair <int, int>> ataca;
vector <pair <int, int>> zach;
node monstr[200010];

int mn[200010];
int indmn[200010];
int indmn2[200010];
int mn2[200010];
int pref[200010];

bool cmp(node aa, node bb) {
    if (aa.zac == bb.zac)
        return aa.ata < bb.ata;
    return aa.zac < bb.zac;
}

vector <pair <int, int>> rmq[800060];
vector <int> rmq2[800060];

void build(int t, int l, int r) {
    if (r - l == 1) {
        rmq[t] = {{monstr[l].ata, monstr[l].cost}};
        rmq2[t] = {0, monstr[l].cost};
        return;
    }
    int mid = (r + l) / 2;
    build(t * 2 + 1, l, mid);
    build(t * 2 + 2, mid, r);
    for (auto i : rmq[t * 2 + 1])
        rmq[t].pb(i);
    for (auto i : rmq[t * 2 + 2])
        rmq[t].pb(i);
    sort(rmq[t].begin(), rmq[t].end());
    rmq2[t].pb(0);
    for (int i = 0; i < sz(rmq[t]); i++)
        rmq2[t].pb(rmq2[t].back() + rmq[t][i].second);
}

int get(int t, int l, int r, int x, int y, int k) {
    if (r <= x || y <= l)
        return 0;
    if (x <= l && r <= y) {
        pair <int, int> pt = {k, -1};
        int uk = lower_bound(rmq[t].begin(), rmq[t].end(), pt) - rmq[t].begin();
        return rmq2[t][uk];
    }
    int mid = (r + l) / 2;
    return get(t * 2 + 1, l, mid, x, y, k) + get(t * 2 + 2, mid, r, x, y, k);
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, m, p, x, y;
    cin >> n >> m >> p;
    for (int i = 0; i < n; i++) {
        cin >> x >> y;
        ataca.pb({x, y});
    }
    sort(ataca.begin(), ataca.end());
    for (int i = 0; i < m; i++) {
        cin >> x >> y;
        zach.pb({x, y});
    }
    sort(zach.begin(), zach.end());
    mn[n] = 1e9 + 7;
    mn2[m] = 1e9 + 7;
    for (int i = n - 1; i >= 0; --i) {
        if (mn[i + 1] > ataca[i].Y) {
            mn[i] = ataca[i].Y;
            indmn[i] = i;
        } else {
            indmn[i] = indmn[i + 1];
            mn[i] = mn[i + 1];
        }
    }
    for (int i = m - 1; i >= 0; --i) {
        if (mn2[i + 1] > zach[i].Y) {
            mn2[i] = zach[i].Y;
            indmn2[i] = i;
        } else {
            indmn2[i] = indmn2[i + 1];
            mn2[i] = mn2[i + 1];
        }
    }
    for (int i = 0; i < p; i++) {
        cin >> monstr[i].zac;
        cin >> monstr[i].ata;
        cin >> monstr[i].cost;
    }
    sort(monstr, monstr + p, cmp);
    build(0, 0, p);
    int ans = 0 - mn[0] - mn2[0];
    int uk1 = 0, uk2 = 0, kok = -1;
    for (int i = 0; i < p; i++) {
        pair <int, int> pt = {monstr[i].zac, 1e9 + 7};
        uk1 = upper_bound(ataca.begin(), ataca.end(), pt) - ataca.begin();
        pt = {monstr[i].ata, 1e9 + 7};
        uk2 = upper_bound(zach.begin(), zach.end(), pt) - zach.begin();
        if (uk1 == n)
            break;
        if (uk2 == m)
            continue;
        uk1 = indmn[uk1];
        uk2 = indmn2[uk2];
        ans = max(ans, get(0, 0, p, 0, i + 1, zach[uk2].X) - mn[uk1] - mn2[uk2]);
    }
    cout << ans << endl;
    return 0;
}

