#include<iostream>
#include<vector>
#include<algorithm>
#include<set>
#include<map>
#include<istream>
#include<bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define pb push_back
#define sz(c) (int)(c).size()
#define all(c) (c).begin(), (c).end()

const int MAXN = 1e5;
const int INF = 1e9;

int n, m, k;
int s, t;

vector<int> way;
vector<vector<int>> g, g2;
vector<int> dist;

void build_dist() {
    dist.resize(n, INF);
    dist[t] = 0;
    set<pair<int, int>> st;
    st.insert({0, t});
    while (!st.empty()) {
        auto p = (*(st.begin()));
        st.erase(p);
        int v = p.second;
        for (auto u : g2[v]) {
            if (dist[u] > dist[v] + 1) {
                st.erase({dist[u], u});
                dist[u] = dist[v] + 1;
                st.insert({dist[u], u});
            }
        }
    }
}



int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    cin >> n >> m;
    g.resize(n);
    g2.resize(n);
    for (int i = 0; i < m; ++i) {
        int x, y;
        cin >> x >> y;
        x--; y--;
        g[x].pb(y);
        g2[y].pb(x);
    }
    //cout << "lol";
    cin >> k;
    cin >> s; s--;
    way.resize(k - 2);
    for (int i = 0; i < (k - 2); ++i) {
        cin >> way[i];
        way[i]--;
    }
    cin >> t; t--;
    int ans1 = 0;
    int ans2 = 0;
    //cout << "lol";
    build_dist();
    //cout << "dist\n";
    //for (int i = 0; i < n; ++i) {
      //  cout << i << " " << dist[i] << endl;
    //}


    int v = s;
    for (int i = 0; i < (k - 2); ++i) {
        if (dist[way[i]] >= dist[v]) {
            ans1++;
            ans2++;
        } else {
            int cnt = 0;
            for (auto u : g[v]) {
                cnt += (dist[u] == (dist[v] - 1));
            }
            if (cnt > 1) {
                ans2++;
            }

        }
        v = way[i];
    }


    cout << ans1 << " " << ans2;
    return 0;
}





