#include<bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

#define int long long
#define endl '\n'


struct gy{
    int x, y, z;
    int a, b;
    
    bool operator<(const gy &oth) const{
        if(a == oth.a) return b < oth.b;
        return a  < oth.a;
    } 

};

vector<int> tre;

void add(int v, int tl, int tr, int ind, int val){
    if(tl + 1 == tr){
        tre[v] += val;
        return ;
    }
    int tm = (tl + tr) / 2;
    if(ind >= tm) add(2 * v + 2, tm, tr, ind, val);
    else add(2 * v + 1, tl, tm, ind, val);
    tre[v] = tre[2 * v + 1] + tre[2 * v + 2];
}

int get(int v, int tl, int tr, int l, int r){
    if(l >= r) return 0;
    if(tl == l && tr == r) return tre[v];
    int tm = (tl + tr) / 2;
    return get(2 * v + 1, tl, tm, l, min(r, tm)) + get(2 * v + 2, tm, tr, max(l, tm), r);
}

signed main(){
    #ifdef _DEBUG
        freopen("input.txt", "r", stdin);
        //freopen("output.txt", "w", stdout);
    #endif
    int n, m, p;
    cin >> n >> m >> p;
    vector<pair<int, int> > a(n);
    vector<pair<int, int> > b(m);
    tre.resize(8e5);
    for(int i = 0; i < n; i++){
        cin >> a[i].second >> a[i].first;
    }
    sort(a.begin(), a.end());
    vector<int> ra, cra;
    for(int i = 0; i < n; i++)
        if(ra.size() == 0 || a[i].second > ra.back()){
            ra.push_back(a[i].second);
            cra.push_back(a[i].first);
        }
    for(int i = 0; i < m; i++){
        cin >> b[i].second >> b[i].first;
    }
    sort(b.begin(), b.end());
    vector<int> rb, crb;
    for(int i = 0; i < m; i++)
        if(rb.size() == 0 || b[i].second > rb.back()){
            rb.push_back(b[i].second);
            crb.push_back(b[i].first);
            
        }
    for(int i = 0; i < crb.size(); i++){
        add(0, 0, m, i, (i ? crb[i - 1] - crb[i] : -crb[i]));
    }
    //cout << rb.size() << endl;
    vector<gy> ms(p);
    for(int i = 0; i < p; i++){
        cin >> ms[i].x >> ms[i].y >> ms[i].z;
        auto it = upper_bound(ra.begin(), ra.end(), ms[i].x);
        if(it == ra.end()) ms[i].a = 1e16;
        else{
            int j = it - ra.begin();
            ms[i].a = j;
        }
        it = upper_bound(rb.begin(), rb.end(), ms[i].y);
        if(it == rb.end()) ms[i].b = 1e16;
        else {
            int j = it - rb.begin();
            ms[i].b = j;
        }
        //cout << ms[i].x << ' ' << ms[i].y << ' ' << ms[i].nd << endl;
    }
    sort(ms.begin(), ms.end());
    //if(ms[0].a >= 1e16 || ms[0].b >= 1e16) return cout << -cra[0] - crb[0] << endl, 0;
    int sum = 0, res = -cra[0] - crb[0];
    for(int i = 0; i < p; i++){
        if(ms[i].a >= 1e16 || ms[i].b >= 1e16) continue;
        add(0, 0, m, ms[i].b, ms[i].z);
        res = max(res, get(0, 0, m, 0, ms[i].b + 1) - cra[ms[i].a]);
    }
    cout << res << endl;
}