#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define pb push_back
#define ll long long


using namespace std;
using namespace __gnu_cxx;
using namespace __gnu_pbds;
typedef tree <int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> indexed_set;
///*X.find_by_order
///X.order_of_key()

const int MOD = 1e9 + 7;
const int MAXN = 1e6 +77;
int d[MAXN];
int a[MAXN];
int used[MAXN];
vector<int> g[MAXN];
vector<int> gr[MAXN];

int n,m;

void dijkstra(int s) {
    queue<int> Q;
    for (int i = 1; i <= n; i++) {
        d[i] = MOD;
        used[i] = 0;
    }
    d[s] = 0;
    Q.push(s);    
    while(!Q.empty()) {
        int v = (Q.front());
        Q.pop();
        if (used[v]) continue;
        used[v] = 1;
        
        for (int i : gr[v]) {
            if(d[i] > d[v] + 1) {
                d[i] = d[v] + 1;
                Q.push(i);
            }
        }
    }
}

int main() {
    #ifdef IZI_KATKA
    assert(freopen("input.txt", "r", stdin));
    assert(freopen("output.txt", "w", stdout));
    #endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m;
    for (int i = 1; i <=m; i++) {
        int u, v;
        cin >> u>> v;
        g[u].pb(v);
        gr[v].pb(u);
    }
    int q;
    cin >> q;
    for (int i = 1; i <= q; i++) {
        cin >> a[i];
    }
    dijkstra(a[q]);
    int cur = a[1];
    int mn = 0;
    int mx = 0;
    for (int i = 1; i < q; i++) {
        if (d[cur] - 1 != d[a[i + 1]]) {
            mn++;
        }
        int ok = 0;
        for (int j : g[cur]) {
            if (j == a[i + 1]) continue;
            if (d[cur] - 1 == d[j]) ok = 1;
        }    
        mx += ok;
        cur = a[i+1];
    }
    cout << mn << ' ' << mx << endl;
    return 0; 
}