#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

const int INF = 1e9 + 10;
const int N  = 5e5 + 10;

vector<int> graph[N];
vector<int> invg[N];
bool visited[N];
queue<int> q;
int mar[N];
int d[N];
int how[N];

void bfs(int n){
    q.push(n);
    d[n] = 0;
    while (!q.empty()){
        int s = q.front(); q.pop();;
        visited[s] = 1;
        for (auto i : invg[s]){
            if (d[s] + 1 == d[i]) how[i]++;
            if (!visited[i]){
                d[i] = d[s] + 1;
                q.push(i);
                visited[i] = 1;
            }
        }
    }
}

int main()
{
    int n, m; cin >> n >> m;
    for (int i = 0;  i <= n; i++) how[i] = 1;
    for (int i = 0; i < m; i++){
        int x, y; cin >> x >> y;
        graph[x].push_back(y);
        invg[y].push_back(x);
    }
    int k; cin >> k;
    for (int i = 0 ; i < k; i++){
        cin >> mar[i];
    }
    int arr1 = 0, arr2 = 0;
    bfs(mar[k - 1]);;
    for (int i = 1; i < k; i++){;
        if (d[mar[i]] != d[mar[i - 1]] - 1){
            arr1++;
        }
    }
    for (int i = 1; i < k; i++){
        if (how[mar[i - 1]] > 1 || d[mar[i]] != d[mar[i - 1]] - 1) arr2++;
    }
    cout << arr1 << ' '<< arr2;
}
