#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define pb push_back
#define fr first
#define sc second

const int inf = (int)1e9 + 7;
const ll linf = (ll)1e18 + 7;

const int N = (int)2e5 + 7;

int n, m, p;

struct T {
	int tree[4 * N];
	int add[4 * N];
	T() {
		memset(tree, 0, sizeof tree);
		memset(add,0, sizeof add);
	}
	void push(int v, int l, int r) {
		if (l != r) {
			add[v + v] += add[v];
			add[v + v + 1] += add[v];
		}
		tree[v] += add[v];
		add[v] = 0;
	}
	void upd(int l, int r, int val, int v = 1, int tl = 0, int tr = m - 1) {
		push(v, tl, tr);
		if (tl > r || tr < l) 
			return ;
		if (l <= tl && tr <= r) {
			add[v] += val;
			push(v, tl, tr);
			return ;
		}
		int mid = (tl + tr) >> 1;
		upd(l, r, val, v + v, tl, mid);
		upd(l, r, val, v + v + 1, mid + 1, tr);
		tree[v] = max(tree[v + v], tree[v + v + 1]);
	}
};
T tr;

int a[N], ca[N];
int b[N], cb[N];
int x[N], y[N], z[N];
vector<pair<int, int>> vecb, veca;

main() {
	scanf("%d %d %d", &n, &m, &p);
	for (int i = 1; i <= n; i++) {
		scanf("%d %d", &a[i], &ca[i]);
		veca.push_back({i, 0}); // query
	}
	for (int i = 1; i <= m; i++) {
		scanf("%d %d", &b[i], &cb[i]);
		vecb.push_back({b[i], cb[i]}); // upd
	}
	for (int i = 1; i <= p; i++) {
		scanf("%d %d %d", &x[i], &y[i], &z[i]);
		veca.push_back({i, 1});
	}
	sort(vecb.begin(), vecb.end());
	for (int i = 0; i < vecb.size(); i++) {
		tr.upd(i, i, -vecb[i].sc);
	}
	sort(veca.begin(), veca.end(), [&](const auto &A, const auto &B) {
		int aa, bb;
		if (A.sc == 1) aa = x[A.fr];
		else aa = a[A.fr];
		if (B.sc == 1) bb = x[B.fr];
		else bb = a[B.fr];
		if (aa == bb) 
			return A.sc < B.sc;
		return aa < bb;
	});
	int ans = -(inf + inf);
	for (int i = 0; i < veca.size(); i++) {
		int ind, tp;
		ind = veca[i].fr;
		tp = veca[i].sc;
		if (tp == 0) {
			int res = -ca[ind] + tr.tree[1];
			ans = max(ans, res);
		} else {
			int pos = lower_bound(vecb.begin(), vecb.end(), make_pair(y[ind] + 1, 0)) - vecb.begin();
			tr.upd(pos, m - 1, z[ind]);
		}
	}
	cout << ans;
}
