#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define pb push_back
#define fr first
#define sc second

const int inf = (int)1e9 + 7;
const ll linf = (ll)1e18 + 7;

const int N = (int)2e5 + 7;

int n;
string s;
unsigned ll h[2][N];
unsigned ll pw[N];
int pref[N];

int get1(int l, int r) {
	if (l > r) return 0;
	if (l == 0) return pref[r];
	return pref[r] - pref[l - 1];
}

unsigned ll get(int id, int l, int r) {
	if (l == 0) return h[id][r];
	return h[id][r] - h[id][l - 1] * pw[get1(l, r)];
}

bool check(int l1, int l2, int len) {
	if (get1(l1, l1 + len - 1) != get1(l2, l2 + len - 1)) return 0;
	return get(pref[l1] & 1, l1, l1 + len - 1) == get(pref[l2] & 1, l2, l2 + len - 1);
}

main() {
	scanf("%d", &n);
	cin >> s;
	pw[0] = 1;
	for (int i = 0; i < n; i++) {
		if (i) {
			h[0][i] = h[0][i - 1];
			h[1][i] = h[1][i - 1];
			pw[i] = pw[i - 1] * 2;
			pref[i] = pref[i - 1];
		}
		if (s[i] == '1') continue;
		pref[i]++;
		h[0][i] *= 2;
		h[1][i] *= 2;
		h[0][i] += (i & 1);
		h[1][i] += (i & 1 ^ 1);
	}
	pw[n] = pw[n - 1] * 2;
	int q;
	scanf("%d", &q);
	while (q--) {
		int l1, l2, len;
		scanf("%d %d %d", &l1, &l2, &len);
		l1--; l2--;
		if (l1 > l2) swap(l1, l2);
		if (check(l1, l2, len)) {
			puts("Yes");
		} else {
			puts("No");
		}
	}
}
