#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <string>
#include <iomanip>

using namespace std;

#define FOR(i, l, r) for(int i = l; i < r; i++)
#define DFOR(i, r, l) for(int i = r; i > l; i--)
#define ASKS(t) for(cin >> t; t; t--)
#define fi first
#define se second

typedef long long ll;
typedef long double ld;
typedef vector<int> vi;
typedef vector<ll> vll;
typedef set<int> si;
typedef set<ll> sll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

struct segtree{
    int mn;
    int lb, rb;
    segtree *l = 0, *r = 0;

    segtree(int lq, int rq){
        lb = lq;
        rb = rq;
        if(rb - lb > 1){
            int t = (lb + rb) / 2;
            l = new segtree(lb, t);
            r = new segtree(t, rb);
        }
        else{
            // TODO
        }
    }

    int get(int lq, int rq){
        if(lq <= lb && rb <= rq)
            return mn;
        else if(max(lb, lq) >= min(rb, rq))
            return 1000000000;
        else
            return min(l->get(lq, rq), r->get(lq, rq));
    }

    void set(int p, int x){
        if(l){
            if(p < l->rb)
                l->set(p, x);
            else
                r->set(p, x);
            mn = min(l->mn, r->mn);
        }
        else
            mn = x;
    }
};


int main()
{
    cin.tie(0); cout.tie(0); ios::sync_with_stdio(0);

    int n;
    string s;
    cin >> n >> s;
    vector<pii> v(0);
    v.push_back({s[0] - 'a', 1});
    FOR(i, 1, n){
        if(s[i] - 'a' == v.back().fi)
            v.back().se++;
        else
            v.push_back({s[i] - 'a', 1});
    }
    int p = v.size();
    DFOR(i, 25, 0){
        if(p >= 2 && v[p-1].fi == i && v[p-2].fi == i - 1){
            v.erase(v.end() - 1);
            p--;
        }
        for(int j = p-2; j > 0; j--){
            if(p >= 3 && v[j].fi == i && (v[j-1].fi == i - 1 || v[j+1].fi == i - 1)){
                v.erase(v.begin() + j);
                p--;
            }
        }
        if(p >= 2 && v[0].fi == i && v[1].fi == i - 1){
            v.erase(v.begin());
            p--;
        }
    }
    int sum = 0;
    FOR(i, 0, p){
        sum += v[i].se;
        // << v[i].fi << ' ' << v[i].se << endl;
    }
    cout << n - sum;

    return 0;
}




















