#include <bits/stdc++.h>

#define ll long long
#define pb push_back
#define ft first
#define sd second

using namespace std;

const ll inf = (ll)1e18;

vector <ll> sum(6000000),psum(6000000);
ll mx;

void add (ll ind, ll val, ll v = 1, ll l = 1, ll r = mx) {

    if (ind < l || r < ind)
        return;

    if (l == r) {
        sum[v] += val;
        psum[v] = sum[v];
        return;
    }

    ll m = (l + r) / 2;

    add(ind,val,2*v,l,m);
    add(ind,val,2*v+1,m+1,r);

    psum[v] = max(psum[2*v],max(sum[2*v],sum[2*v] + psum[2*v+1]));
}

int main()
{

    ios::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);

    ll n , m , p;

    cin >> n >> m >> p;
    vector <pair<ll,ll> > a(n),b(m);
    vector <pair<pair<ll,ll>,ll> > c(p);

    for (ll i = 0; i < n; i++) {
        cin >> a[i].ft >> a[i].sd;
    }

    for (ll i = 0; i < m; i++) {
        cin >> b[i].ft >> b[i].sd;
        mx = max(mx,b[i].ft);
    }

    for (ll i = 0; i < p; i++) {
        cin >> c[i].ft.ft >> c[i].ft.sd >> c[i].sd;
    }

    sort(a.begin(),a.end());
    sort(b.begin(),b.end());
    sort(c.begin(),c.end());

    add(1,-b[0].sd);

    for (ll i = 0; i < m-1; i++) {
        add(b[i].ft,b[i].sd-b[i+1].sd);
    }
    ll lst = 0;
    ll ans = -inf;

    for (ll i = 0; i < n; i++) {
        while (lst < p && c[lst].ft.ft < a[i].ft) {
            if (c[lst].ft.sd < mx)
                add(c[lst].ft.sd,c[lst].sd);
            lst++;
        }

        ans = max(ans,psum[1]-a[i].sd);
    }

    cout << ans;
    return 0;
}
