#include <bits/stdc++.h>

using namespace std;

#define loop(i, n) for(int i = 0; i < n; ++i)
#define vec vector
#define FOR(i, a, n) for(int i = a; i < n; ++i)
#define pb push_back
#define SZ(x) (int) x.size()
#define all(x) x.begin(), x.end()

#define int long long

const int MAXN = 3e5 + 47, inf = 1e9 + 47;

int n, m, k;
vec<int> way;
vec<set<int> > nw(MAXN);
vec<vec<int> > graf(MAXN), nor(MAXN);

void solve() {
    cin >> n >> m;
    loop(i, m) {
        int a, b;
        cin >> a >> b;
        --a, --b;
        graf[b].pb(a);
        nor[a].pb(b);
    }
    cin >> k;
    way.resize(k);
    loop(i, k) {
        int a;
        cin >> a;
        way[i] = a - 1;
    }
    vec<int> d(MAXN, inf);
    int s = way[0], f = way.back();
    d[f] = 0;
    queue<int> q;
    q.push(f);
    while(SZ(q) > 0) {
        int p1 = q.front();
        q.pop();
        //cout << p1 << endl;
        for(int p2 : nor[p1]) {
            if(d[p1] == d[p2] + 1) nw[p1].insert(p2);
        }

        for(int p2 : graf[p1]) {
            if(d[p2] > d[p1] + 1) {
                d[p2] = d[p1] + 1;
                q.push(p2);
            }
        }
    }/*
    loop(i, n) {
        cout << i << ": ";
        for(int p2 : nw[i]) cout << p2 << " " ;
        cout << endl;
    }*/
    int x = 0, y = 0;
    loop(i, k - 1) {
        if(nw[way[i]].find(way[i + 1]) == nw[way[i]].end()) x++;
    }
    loop(i, k - 1) {
        if(nw[way[i]].find(way[i + 1]) == nw[way[i]].end()) y++;
        else if(SZ(nw[way[i]]) > 1) y++;
    }
    cout << x << " " << y << endl;
}


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    #ifdef COFFEE_MACHIN
        freopen("input.cpp", "r", stdin);
        freopen("output.cpp", "w", stdout);
    #endif

    int t = 1;
    //cin >> t;
    while(t--) {
        solve();
    }
}

