#include <bits/stdc++.h>

#pragma GCC optimize("-O3")

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;

#define int long long
#define double long double
#define For(i,z) for(int i=0;i<(z);i++)
#define _ <<' '<<
#define sqr(a) ((a)*(a))

template<typename T> using orset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<typename T, typename K> using ormap = tree<T, K, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<typename T, typename K> inline void umin(T &a, const K b) {a = min(a, (T)b);}
template<typename T, typename K> inline void umax(T &a, const K b) {a = max(a, (T)b);}

const int N = 2e5+10;
const double EPS = 1e-7;
const int64_t INF = 1e15;
const pair<int64_t,int64_t> PINF = make_pair(INF, INF);
const int64_t MOD = 1e9+123;
const int64_t AMOD = 99194853094755497;


int32_t main()
{
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int n; cin >> n;
    vector <int> a(n), b(n);
    for (int &i : a) cin >> i;
    for (int &i : b) cin >> i;

    int ot = 0;
    For (i, n)
        if (a[i] > b[i])
            ot++;
    if (ot == 0) {
        cout << "-1\n"; return 0;
    }
    int gr = 0;
    vector <int> sc(n, 1);
    For (i, n)
        if (b[i] > a[i])
            gr++;

    cout << gr / ot + 1 << endl;
}
