#include <bits/stdc++.h>

#pragma GCC optimize("-O3")

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;

#define int long long
#define double long double
#define For(i,z) for(int i=0;i<(z);i++)
#define _ <<' '<<
#define sqr(a) ((a)*(a))

template<typename T> using orset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<typename T, typename K> using ormap = tree<T, K, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<typename T, typename K> inline void umin(T &a, const K b) {a = min(a, (T)b);}
template<typename T, typename K> inline void umax(T &a, const K b) {a = max(a, (T)b);}

const int N = 5e5+10;
const double EPS = 1e-7;
const int64_t INF = 1e15;
const pair<int64_t,int64_t> PINF = make_pair(INF, INF);
const int64_t MOD = 1e9+123;
const int64_t AMOD = 99194853094755497;

int32_t main()
{
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int n; cin >> n;
    string s; cin >> s;
    int ans = 0;

    for (char c = 'z'; c > 'a'; c--) {
        For (kek, 100) {
            vector <bool> bad(s.size());
            For (i, s.size()) {
                if (s[i] != c) continue;
                if (i && s[i] == s[i-1]+1) bad[i] = true;
                if (i != s.size()-1 && s[i] == s[i+1]+1) bad[i] = true;
            }
            string ns; ns.reserve(s.size());
            For (i, s.size())
                if (bad[i] == false)
                    ns += s[i];
            s = ns;
        }
    }

    cout << n - s.size() << endl;
}
