#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <numeric>
#include <cmath>

#define debug(x) std::cerr << #x << ": " << x << std::endl;
#define read(x) for(auto &now : x) std::cin >> now;
#define print(x) for(auto &now : x) std::cout << now << " ";std::cout << "\n"
using namespace std;
typedef long long ll;
typedef long double ld;


int main(){
    int n;
    cin >> n;
    vector<int> v(n);
    read(v);

    for(int i = 0; i < n; i++){
        v[i] -= i + 1;
    }
    map<int, ll> mp;
    for(int i = 0; i < n; i++){
        mp[v[i]] += v[i] + i + 1;
    }
    ll mx = 0;
    for(auto now : mp){
        mx = max(mx, now.second);
    }
    cout << mx;
    return 0;
}
