#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <set>
#include <algorithm>
#include <map>
#include <deque>

using namespace std;

#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")

void files()
{
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
}

int main()
{
	files();
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int n, m;
	cin >> n >> m;
	vector<vector<int> > g = vector<vector<int> >(n, vector<int>());
	for (int i = 0; i < m; ++i)
	{
		int a, b;
		cin >> a  >> b;
		a--,b--;
		g[b].push_back(a);
	}
	int k;
	cin >> k;
	vector<int> ar;
	for (int i = 0; i < k; ++i)
	{
		int a;
		cin >> a;
		a--;
		ar.push_back(a);
	}
	int s = ar[k - 1];
	deque<int> que;
	vector<pair<int, int> > dist(n, {1e9, 1e9});
	dist[s].first = 0;
	dist[s].second = 1;
	que.push_back(s);
	while (!que.empty())
	{
		int v = que[0];
		que.pop_front();
		for (int i = 0; i < g[v].size(); ++i)
		{
			int u = g[v][i];
			if (dist[u].first == 1e9)
			{
				dist[u].first = dist[v].first + 1;
				dist[u].second = dist[v].second;
				que.push_back(u);
			}
			else
			{
				if (dist[u].first == dist[v].first + 1)
				{
					dist[u].second += dist[v].second;
				}
			}
		}
	}
	int ans1 = 0, ans2 = 0;
	for (int i = 0; i < k; ++i)
	{
		if (dist[ar[i]].first == k - 1 - i)
		{
			if (dist[ar[i]].second > 1)
				ans2++;
		}
		else
		{
			ans1 += 1;
			ans2 += 1;
		}
	}
	cout << ans1 << " " << ans2 << endl;
}