#include<bits/stdc++.h>
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
using namespace std;


int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    vector<vector<int> > g(n), gr(n);
    vector<int> used(n);
    for(int i = 0; i < m; i++){
        int from, to;
        cin >> from >> to;
        from--; to--;
        g[from].push_back((to));
        gr[to].push_back(from);
    }
    int l;
    cin >> l;
    vector<int> a(l);
    for(int i = 0; i < l; i++){
            cin >> a[i];
            a[i]--;
    }
    int last = a[l - 1];
    vector<int> dist(n);
    queue<int> q;
    q.push(last);
    while(!q.empty()){
        int cur = q.front();
        q.pop();
        used[cur] = 1;
        for(int i = 0; i < gr[cur].size(); i++){
            int u = gr[cur][i];
            if(!used[u]){
                dist[u] = dist[cur] + 1;
                used[u] = 1;
                q.push(u);
            }
        }
    }
    int ma = 0, mi = 0;
    for(int i = 0; i < l - 1; i++){
        int mindist = 1e9;
        for(int j = 0; j < g[a[i]].size(); j++){
            int u = g[a[i]][j];
            mindist = min(mindist, dist[u]);
        }
        if(mindist != dist[a[i + 1]]){
            mi++;
            ma++;
        }
        else{
            for(int j = 0; j < g[a[i]].size(); j++){
                int u = g[a[i]][j];
                if(u != a[i + 1] && dist[u] == mindist){
                    ma++;
                    break;
                }
            }
        }
    }
    cout << mi << " " << ma;
}
