#include <iostream>
#include <vector>
#include <algorithm>
#include <utility>
#include <string>
#include <cmath>
#include <set>
#include <map>
#include <stack>
#include <iomanip>
#include <queue>
#define pb push_back
#define mp make_pair
#define all(a) (a).begin(), (a).end()

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int,int> pii;
typedef pair<ll,ll> pll;
const ll mod = 1e9+7;
const ll biginf = 1e18;
const int inf = 2e9;
const ld pi = acosl(-1);
const ld eps = 1e-9;

void solve()
{
	int n;
	cin >> n;
	vector<int> a(n), b(n);
	for(int i = 0; i < n; i++)
		cin >> a[i];
	for(int i = 0; i < n; i++)
		cin >> b[i];
	int maxp = -1, ap = 0, bp = 0;
	for(int i = 0; i < n; i++)
	{
		if(a[i] ^ b[i] == 0)
			continue;
		if(a[i] == 1)
			ap++;
		else
			bp++;
	}
	if(ap == 0)
	{
		cout << -1;
		return;
	}
	if(ap > bp)
	{
		cout << 1;
		return;
	}
	cout << 1 + ceil((ld)(bp - ap + 1) / (ld)ap);
}

void multisolve()
{
	int t;
	cin >> t;
	while(t--)
		solve();
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	solve();
	//multisolve();
}