#include <iostream>
#include <vector>
#include <algorithm>
#include <utility>
#include <string>
#include <cmath>
#include <set>
#include <map>
#include <stack>
#include <iomanip>
#include <queue>
#define pb push_back
#define mp make_pair
#define all(a) (a).begin(), (a).end()

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int,int> pii;
typedef pair<ll,ll> pll;
const ll mod = 1e9+7;
const ll biginf = 1e18;
const int inf = 2e9;
const ld pi = acosl(-1);
const ld eps = 1e-9;

void solve()
{
	ll n;
	cin >> n;
	vector<ll> b(n), dif(n);
	map<ll, ll> m;
	for(int i = 0; i < n; i++)
	{
		cin >> b[i];
		dif[i] = b[i] - i;
		m[dif[i]] += b[i];
	}
	ll maxx = 0;
	for(map<ll,ll>::iterator it = m.begin(); it != m.end(); it++)
		maxx = max(maxx, it->second);
	cout << maxx;
}

void multisolve()
{
	int t;
	cin >> t;
	while(t--)
		solve();
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	solve();
	//multisolve();
}