#include <iostream>
#include <vector>
#include <algorithm>
#include <utility>
#include <string>
#include <cmath>
#include <set>
#include <map>
#include <stack>
#include <iomanip>
#include <queue>
#define pb push_back
#define mp make_pair
#define all(a) (a).begin(), (a).end()

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int,int> pii;
typedef pair<ll,ll> pll;
const ll mod = 1e9+7;
const ll biginf = 1e18;
const int inf = 2e9;
const ld pi = acosl(-1);
const ld eps = 1e-9;

void solve()
{
	int n;
	cin >> n;
	string s;
	cin >> s;
	if(n == 1)
	{
		cout << 0;
		return;
	}
	vector<vector<int> > dp(n, vector<int>(n, 0));
	dp[0][0] = (s[1] + 1 == s[0]);
	dp.back().back() = (s[n-2] + 1 == s[n-1]);
	for(int i = 1; i < n-1; i++)
	{
		if(s[i-1] + 1 == s[i] || s[i] == s[i+1]+1)
			dp[i][i] = 1;
	}
	for(int sz = 2; sz <= n; sz++)
	{
		for(int l = 0; l <= n - sz; l++)
		{
			int r = l + sz - 1;
			bool pos = false;
			if(l == 0)
			{
				if(dp[l+1][r] == 1 && r + 1 < n && s[l] == s[r+1] + 1)
					pos = true;
			}
			if(r == n-1)
			{
				if(dp[l][r-1] == 1 && l - 1 >= 0 && s[r] == s[l-1] + 1)
					pos = true;
			}
			if(l != 0 && r != n-1)
			{
				if(   (dp[l+1][r] == 1 && ((s[l] == s[r+1] + 1) || (s[l] == s[l-1] + 1))) || (dp[l][r-1] == 1 && ((s[r] == s[l-1] + 1) || (s[r] == s[r+1] + 1)))    )
					pos = true;
			}
			if(pos)
				dp[l][r] = 1;
		}
	}
	vector<int> dpl(n, 0);
	dpl[0] = dp[0][0];
	for(int i = 1; i < n; i++)
	{
		dpl[i] = max(dpl[i], dpl[i-1]);
		for(int j = 0; j <= i; j++)
		{
			if(dp[j][i])
				dpl[i] = max(dpl[i], ((j == 0) ? 0 : dpl[j - 1]) + i - j + 1);
		}
	}
	cout << dpl.back();
}

void multisolve()
{
	int t;
	cin >> t;
	while(t--)
		solve();
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	solve();
	//multisolve();
}