#include <iostream>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <limits>
#include <map>
#include <vector>
#include <set>
#include <string>
#include <cstdio>
#include <cstring>
#include <cassert>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
#define rep(i, n) for (int i = 0; i < (n); ++i)
#define all(x) (x).begin(), (x).end()
#define f first
#define s second
#define FAST_IO() ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

namespace __gnu_pbds {
    template<typename T>
    using pbds_tree = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
}
template<typename T>
using pbds_tree = __gnu_pbds::pbds_tree<T>;
// order_of_key
// find_by_order

const int MAXN = 105;
int n;
int a[MAXN];
int b[MAXN];

int main() {
    FAST_IO();
    cin >> n;
    rep(i, n) {
        cin >> a[i];
    }
    rep(i, n) {
        cin >> b[i];
    }

    int mx = 1, c1 = 0, c2 = 0;
    rep(i, n) {
        if (a[i] == 1 && b[i] == 0) {
            c1++;
        } else if (a[i] == 0 && b[i] == 1) {
            c2++;
        }
    }

    if (c1 == 0) {
        cout << -1 << endl;
        return 0;
    }

    mx = max(mx, (c2 + 1 + c1 - 1) / c1);

    cout << mx << endl;
}

