#include <iostream>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <limits>
#include <map>
#include <vector>
#include <set>
#include <string>
#include <cstdio>
#include <cstring>
#include <cassert>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
#define rep(i, n) for (int i = 0; i < (n); ++i)
#define all(x) (x).begin(), (x).end()
#define f first
#define s second
#define FAST_IO() ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

namespace __gnu_pbds {
    template<typename T>
    using pbds_tree = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
}
template<typename T>
using pbds_tree = __gnu_pbds::pbds_tree<T>;
// order_of_key
// find_by_order

const int MAXN = 105;
int n;
string s;
int mem[MAXN][MAXN];
int dp[MAXN];

int solve(int l, int r) {
    if (r < l) return true;
    if (mem[l][r] != -1) {
        return mem[l][r];
    }
    
    mem[l][r] = false;

    for (int last = l; last <= r; ++last) {
        //cout << r << ' ' << n << ' ' << last << ' ' << s[last] << ' ' << s[r + 1] << ' ' << s[r + 1] + 1 << endl;
        //cout << (r + 1 < n && s[last] == s[r + 1] + 1) << endl;
        //cout << solve(l, last - 1) << ' ' << solve(last + 1, r) << endl;
        if ((l - 1 >= 0 && s[last] == s[l - 1] + 1) || (r + 1 < n && s[last] == s[r + 1] + 1)) {
            //cout << " : " << l << ' ' << r << endl;
            if (solve(l, last - 1) && solve(last + 1, r)) {
                mem[l][r] = true;
                break;
            }
        }
    }
    return mem[l][r];
}

int main() {
    FAST_IO();
    cin >> n;
    cin >> s;

    int res = 0;
    while (s.size() > 1) {
        int pos = -1;
        int mx = -1;
        for (int i = 0; i < s.size(); ++i) {
            if ((i != 0 && s[i - 1] + 1 == s[i]) || (i + 1 != s.size() && s[i + 1] + 1 == s[i])) {
                if (s[i] > mx) {
                    mx = s[i];
                    pos = i;
                }
            }
        }
        if (mx == -1) break;
        s.erase(s.begin() + pos);
        res++;
    }

    cout << res << endl;

    /*rep(i, MAXN) {
        rep(j, MAXN) {
            mem[i][j] = -1;
        }
    }

    //cout << solve(0, 0) << ":" << endl;

    for (int i = 0; i < n; ++i) {
        for (int j = i; j < n; ++j) {
            cout << i << ' ' << j << ' ' << solve(i, j) << endl;
        }
    }

    for (int i = 0; i < n; ++i) {
        for (int j = i; j >= 0; --j) {
            int best = 0;
            for (int k = j - 2; k >= 0; --k) {
                best = max(best, dp[k]);
            }
            if (solve(j, i)) dp[i] = max(dp[i], best + (i - j));
        }
    }

    cout << *max_element(dp, dp + n) << endl;*/
}
