#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC target("sse,sse2,sse3,sse4,avx,avx2")
#include <iostream>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <limits>
#include <map>
#include <vector>
#include <set>
#include <string>
#include <cstdio>
#include <cstring>
#include <cassert>
#include <queue>
#include <bitset>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
#define rep(i, n) for (int i = 0; i < (n); ++i)
#define all(x) (x).begin(), (x).end()
#define f first
#define s second
#define FAST_IO() ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

namespace __gnu_pbds {
    template<typename T>
    using pbds_tree = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
}
template<typename T>
using pbds_tree = __gnu_pbds::pbds_tree<T>;
// order_of_key
// find_by_order

const int MAXN = 2e5 + 5;
int n;
string s;
vector<pii> a;
bitset<MAXN> bs;
bitset<MAXN> b1, b2, bt;

pii get_seg(int l, int r) {
    l = lower_bound(a.begin(), a.end(), make_pair(l, -1)) - a.begin();
    r = upper_bound(a.begin(), a.end(), make_pair(r, 10000)) - a.begin() - 1;
    return {l, r};
}

void pr(bitset<MAXN> &s) {
    rep(i, 10) {
        cout << s[i];
    }
    cout << endl;
}

bool solve(int origl1, int l1, int r1, int origl2, int l2, int r2) {
    // cout << "solve " << origl1 << ' ' << l1 << ' ' << r1 << ' ' << origl2 << ' ' << l2 << ' ' << r2 << endl;
    if (r2 - l2 != r1 - l1) return false;
    //return cmp(l1, r1, l2, r2);
    if (r1 < l1) return true;
    //cout << (((origl1 - a[l1].f) & 1) ? "ah" : "bh") << ' ' << (((origl2 - a[l2].f) & 1) ? "ah" : "bh") << endl;
    b1 = bs;
    if ((origl1 - a[l1].f) & 1) {
        b1.flip();
    }
    b2 = bs;
    if ((origl2 - a[l2].f) & 1) {
        b2.flip();
    }

    // pr(b1);
    // pr(b2);

    bt = ((b1 >> l1) ^ (b2 >> l2));
    return ((bt << (MAXN - (r1 - l1 + 1)))).none();
}

int main() {
    FAST_IO();
    cin >> n;
    cin >> s;
    rep(i, n) {
        if (s[i] == '1') continue;
        bs[a.size()] = i % 2;
        a.push_back({i, i % 2});
    }


    int m;
    cin >> m;
    rep(i, m) {
        int l1, l2, len;
        cin >> l1 >> l2 >> len;
        l1--; l2--;
        auto seg1 = get_seg(l1, l1 + len - 1);
        auto seg2 = get_seg(l2, l2 + len - 1);
        if (solve(l1, seg1.f, seg1.s, l2, seg2.f, seg2.s)) {
            cout << "Yes" << '\n';
        } else {
            cout << "No" << '\n';
        }
        //cout << endl;
    }
}
