#include <bits/stdc++.h>
#pragma GCCoptimize("Ofast")
#define  ll long long

using namespace std;


void bfs(int u, vector<vector<int>> &gr, vector<pair<unordered_set<int>, int>> &graph){
    queue<int> que;
    que.push(u);
    graph[u].second = 0;

    while(!que.empty()){
        int u = que.front();
        que.pop();

        for (int to : gr[u]){
            if (graph[to].second == -1){
                graph[to].second = graph[u].second + 1;
                graph[to].first.insert(u);
                que.push(to);
            }
            else if (graph[to].second == graph[u].second + 1){
                graph[to].first.insert(u);
            }
        }
    }
}


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, m;
    cin >> n >> m;
    vector<pair<unordered_set<int>, int>> graph(n, {unordered_set<int>(), -1});
    vector<vector<int>> gr_r(n);
    for (int i = 0; i < m; ++i){
        int a, b;
        cin >> a >> b;
        --a;
        --b;
        gr_r[b].push_back(a);
    }
    int k;
    cin >> k;
    vector<int> vec(k);
    for (int i = 0; i < k; ++i){
        cin >> vec[i];
        --vec[i];
    }
    bfs(vec.back(), gr_r, graph);

    int ans = 0;
    int ansd = 0;
    for (int i = 1; i < k; ++i){
        if (graph[vec[i - 1]].first.find(vec[i]) == graph[vec[i - 1]].first.end()){
            ++ans;
        }
        else{
            if (graph[vec[i - 1]].first.size() > 1){
                ++ansd;
            }
        }
    }
    cout << ans << ' ' << ans + ansd;
    return 0;
}