#include <bits/stdc++.h>
#pragma GCCoptimize("Ofast")
#define  ll long long

using namespace std;
int n, m, p;


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    cin >> n >> m >> p;
    vector<pair<int, int>> weap(n);
    vector<pair<int, int>> arm(m);
    for (int i = 0; i < n; ++i){
        cin >> weap[i].first >> weap[i].second;
    }
    for (int i = 0; i < m; ++i){
        cin >> arm[i].first >> arm[i].second;
    }
    sort(weap.begin(), weap.end());
    sort(arm.begin(), arm.end());

    int res = weap[n - 1].second;
    for (int i = n - 1; i >= 0; --i){
        weap[i].second = min(res, weap[i].second);
        res = min(res, weap[i].second);
    }

    res = arm[n - 1].second;
    for (int i = m - 1; i >= 0; --i){
        arm[i].second = min(res, arm[i].second);
        res = min(res, arm[i].second);
    }

    map<pair<int, int>, int> ans;
    int tra = -(weap[0].second + arm[0].second);
    for (int i = 0; i < p; ++i){
        int atk, hp, gold;
        cin >> atk >> hp >> gold;
        if (atk > arm.back().first || hp > weap.back().first){
            continue;
        }
        int lw = -1;
        int rw = n - 1;
        while (lw - rw > 1){
            int mw = (lw + rw) / 2;
            if (weap[mw].first <= hp){
                lw = mw;
            }
            else{
                rw = mw;
            }
        }

        int la = -1;
        int ra = m;
        while(ra - la > 1){
            int ma = (la + ra) / 2;
            if (arm[ma].first <= atk){
                la = ma;
            }
            else{
                ra = ma;
            }
        }

        ans.insert({{rw, ra}, -(weap[rw].second + arm[ra].second)});
        ans[{rw, ra}] += gold;
        tra = max(tra, ans[{rw, ra}]);
    }
    cout << tra;
    return 0;
}