#include <iostream>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <deque>
#include <algorithm>
#include <iomanip>
#include <string>

using namespace std;
typedef long long ll;
typedef long double ld;
ll n, m;
vector <ll> g[200010];
vector <ll> g_[200010];
ll dist[200010];
ll k;
ll p[200010];
deque <ll> queue;

bool shortest[200010];
bool can_change[200010];

ll ans_min, ans_max;

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);

    cin >> n >> m;

    for (ll i = 1; i <= m; ++i)
    {
        ll u, v;
        cin >> u >> v;
        g[u].push_back(v);
        g_[v].push_back(u);
    }

    cin >> k;
    for (ll i = 1; i <= k; ++i) cin >> p[i];

    for (ll i = 1; i <= n; ++i) dist[i] = 1000000000;
    dist[p[k]] = 0;
    queue.push_back(p[k]);

    while (queue.size())
    {
        auto i = queue[0];
        queue.pop_front();

        for (auto v : g_[i])
        {
            if (dist[i] + 1 < dist[v])
            {
                dist[v] = dist[i] + 1;
                queue.push_back(v);
            }
        }
    }

    shortest[1] = true;

    for (ll i = 1; i < k; ++i) {
        ll mini = 1000000000;

        for (auto v : g[p[i]])
        {
            mini = min(mini, dist[v]);
        }

        for (auto v : g[p[i]])
        {
            if (v != p[i + 1] && dist[v] == mini)
            {
                can_change[i + 1] = true;
            }
        }


        if (dist[p[i + 1]] == mini)
        {
            shortest[i + 1] = true;
        }

        ans_min += !shortest[i + 1];
        ans_max += can_change[i + 1];
    }

    cout << ans_min << ' ' << ans_max;
    return 0;
}