#include <bits\stdc++.h>

using namespace std;
#define pb push_back
#define all(X) X.begin(), X.end()
#define forn(i, n) for(int i = 0; i < int(n); ++i)
#define forab(i, a, b) for(int i = int(a); i < int(b); ++i)
#define sz(X) (int) (X.size())
#define fornr(i, n) for(int i = int(n)-1; i>=0; --i)

typedef long long ll;
typedef vector<int> vi;
typedef pair<int, int> pii;

const int N = 2e5;

vi g[N], tr[N];
int d[N], p[N], cntanc[N];

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    int u, v;
    forn(i, m) {
        cin >> u >> v;
        u--, v--;
        g[v].pb(u);
        tr[u].pb(v);
    }
    int k;
    cin >> k;
    vi path(k);
    forn(i, k) cin >> path[i], path[i]--;
    int t = path.back();
    queue<int> q;
    d[t] = 1;
    p[t] = -1;
    q.push(t);
    while (!q.empty()) {
        int u = q.front();
        q.pop();
        for (int v : g[u]) {
            if (d[v]) continue;
            d[v] = d[u] + 1;
            p[v] = u;
            q.push(v);
        }
    }
    forn(v, n) {
        for (int u : tr[v]) {
            if (d[v] == d[u] + 1) cntanc[v]++;
        }
    }
    int cnt1 = 0, cnt2 = 0;
    forn(i, k - 1) {
        if (d[p[path[i]]] != d[path[i + 1]]) {
            cnt1++, cnt2++;
            continue;
        }
        if (cntanc[path[i]] > 1) cnt2++;
    }
    cout << cnt1 << " " << cnt2 << "\n";
    return 0;
}