#include <bits/stdc++.h>
#define int long long
using namespace std;
int gcd (int a, int b) {
if (a>b) swap(a,b);
if (a==0) return b;
return gcd(b%a,a);
}
int powmod(int a, int b, int mod) {
if (b==0) return 1;
int k=powmod(a,b/2,mod);
if (b%2) return (((k*k)%mod)*a)%mod;
else return (k*k)%mod;
}

int inv (int a, int b) {
return powmod(a,b-2,b);
}

int prime (int p) {
if (p==1) return 0;
for (int i=2;i*i<=p;i++) if (p%i==0) return i;
return 1;
}

void solve() {
/* --------- */

int a,b;
cin>>a>>b;
vector <vector<int> > g(a);
for (int i=0;i<b;i++) {
int x,y; cin>>x>>y; x--; y--; g[y].push_back(x); }
bool used[a];
for (int i=0;i<a;i++) used[i]=false;
int k; cin>>k;
int m[k];
for (int i=0;i<k;i++) {cin>>m[i]; m[i]--; }
int dist[a];
queue <int> q;
q.push(m[k-1]);
used[m[k-1]]=true;
dist[m[k-1]]=0;
while (!q.empty()) {
int c=q.front(); q.pop();
for (int j=0;j<g[c].size();j++) if (!used[g[c][j]]) {
used[g[c][j]]=true; dist[g[c][j]]=dist[c]+1; q.push(g[c][j]); }


}
int min_ans=k-1;
for (int i=1;i<k;i++) if (dist[m[i]]-dist[m[i-1]]==-1) min_ans--;
cout<<min_ans<<" ";
int max_ans=0;
vector <vector<int> > g1(a);
for (int i=0;i<a;i++) {
for (int j=0;j<g[i].size();j++) {
g1[g[i][j]].push_back(i);
}

}
for (int i=0;i<k-1;i++) {
int check=0;
for (int j=0;j<g1[m[i]].size();j++) if (dist[m[i]]-dist[g1[m[i]][j]]==1 && g1[m[i]][j]!=m[i+1]) check=1;
max_ans+=check;
}
cout<<max_ans;
/* --------- */
}


signed main() {
ios_base::sync_with_stdio(0);
cin.tie(0);
cout.tie(0);

int q=1;
//cin>>q;
for (int i=0;i<q;i++) solve();
}
