#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
#define pb push_back
#define pll pair<ll, ll>

const ll inf = ll(1e9) + 5;

ll gcd(ll x, ll y) {
    while(y) {
        ll tmp = x % y;
        x = y;
        y = tmp;
    }
    return x;
}

void solve() {
    ll n;
    vector<ll> a, b;
    cin >> n;
    for(ll i = 0; i < n; i++) {
        ll cur;
        cin >> cur;
        a.pb(cur);
    }
    for(ll i = 0; i < n; i++) {
        ll cur;
        cin >> cur;
        b.pb(cur);
    }
    ll need = 0;
    for(ll i = 0; i < n; i++) {
        if(a[i] == 0 && b[i] == 1) {
            need++;
        }
    }

    ll has = 0;
    for(ll i = 0; i < n; i++) {
        if(a[i] == 1 && b[i] == 0) {
            has++;
        }
    }

    if(has == 0) {
        cout << -1 << endl;
        return;
    }

    ll ans = ll(ceil(ld(1.0) * (need + 1) / has));
    cout << ans << endl;
}

int main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    ios::sync_with_stdio();
    cin.tie(0);
    cout.tie(0);

    solve();

    return 0;
}
