#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
#define pb push_back
#define pll pair<ll, ll>

const ll inf = ll(1e9) + 5;

ll gcd(ll x, ll y) {
    while(y) {
        ll tmp = x % y;
        x = y;
        y = tmp;
    }
    return x;
}

bool check(char i, char j, char k) {
    if(char(i + 1) == j || char(k + 1) == j) {
        return true;
    }
    return false;
}

void solve() {
    ll n;
    cin >> n;
    string s;
    cin >> s;
    set<pll> can;
    s = "#" + s + "#";
    n += 2;
    for(ll i = 0; i < n - 1; i++) {
        can.insert({i, i + 1});
    }
    for(ll len = 2; len < n - 1; len++) {
        for(ll i = 0; i < n - len; i++) {
            for(ll j = i + 1; j < i + len; j++) {
                if(can.find({i, j}) != can.end() && can.find({j, i + len}) != can.end()) {
                    if(check(s[i], s[j], s[i + len])) {
                        can.insert({i, i + len});
                    }
                }
            }
        }
    }

    vector<ll> dp(n, 0);
    ll ans = 0;
    for(ll i = 1; i < n; i++) {
        for(ll j = i - 1; j >= 0; j--) {
            if(can.find({j, i}) != can.end()) {
                dp[i] = max(dp[i], dp[j] + (i - j - 1));
                ans = max(ans, dp[i]);
            }
        }
    }
    cout << ans << endl;
}

int main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    ios::sync_with_stdio();
    cin.tie(0);
    cout.tie(0);

    solve();

    return 0;
}
