#include <bits/stdc++.h>
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define len(x) (int)(x).size()
#define F first
#define S second
#define int long long
using namespace std;
const int maxn = 2e5 + 5;
string s;
struct kek {
    int bl = 0, cnt = 0, pref = 0, suf = 0, sz = 0;
};
kek t[4 * maxn];
kek merge(kek l, kek r) {
    kek ret;
    ret.cnt = l.cnt + r.cnt;
    ret.sz = l.sz + r.sz;
    if (!l.cnt) {
        if (l.sz == 0) return r;
        ret.bl = l.bl + r.bl;
        ret.pref = 0;
        ret.suf = r.suf;
        return ret;
    }
    if (!r.cnt) {
        if (r.sz == 0) return l;
        ret.bl = l.bl + r.bl;
        ret.pref = l.pref;
        ret.suf = 0;
        return ret;
    }
    if (l.sz == l.cnt) {
        if (r.sz == r.cnt) {
            ret.pref = ret.suf = ret.sz;
            if (ret.sz & 1) ret.bl = 1;
            return ret;
        }
        else {
            ret.bl = r.bl;
            if (r.pref & 1) ret.bl--;
            ret.suf = r.suf;
            ret.pref = r.pref + l.sz;
            if (ret.pref & 1) ret.bl++;
            return ret;
        }
    }
    else if (r.sz == r.cnt) {
        ret.bl = l.bl;
        if (l.suf & 1) ret.bl--;
        ret.pref = l.pref;
        ret.suf = l.suf + r.sz;
        if (ret.suf & 1) ret.bl++;
        return ret;
    }
    else {
        ret.bl = l.bl + r.bl;
        if (l.suf & 1) ret.bl--;
        if (r.pref & 1) ret.bl--;
        int tt = l.suf + r.pref;
        if (tt & 1) ret.bl++;
        ret.pref = l.pref;
        ret.suf = r.suf;
        return ret;
    }
}
void build(int v, int tl, int tr) {
    if (tl == tr) {
        int p = (int)s[tl] - '0';
        if (p) {
            t[v] = {1, 1, 1, 1};
        }
        else t[v] = {0, 0, 0, 0};
        t[v].sz = 1;
    }
    else {
        int tm = tl + tr >> 1;
        build(v << 1, tl, tm);
        build(v << 1 | 1, tm + 1, tr);
        t[v] = merge(t[v << 1], t[v << 1 | 1]);
    }
}
kek get(int v, int tl, int tr, int l, int r) {
    if (r < tl || tr < l) return {0, 0, 0, 0, 0};
    if (l <= tl && tr <= r) return t[v];
    int tm = tl + tr >> 1;
    return merge(get(v << 1, tl, tm, l, r), get(v << 1 | 1, tm + 1, tr, l, r));
}
signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    cin >> s;
    build(1, 0, n - 1);
    int q;
    cin >> q;
    while (q--) {
        int l, r, d;
        cin >> l >> r >> d;
        l--, r--;
        if (d <= 2) {
            string aa, bb;
            for (int i = 0; i < d; i++) aa += s[l + i], bb += s[r + i];
            if (aa == bb) cout << "Yes\n";
            else cout << "No\n";
            continue;
        }
        kek a1 = get(1, 0, n - 1, l, l + d - 1);
        kek a2 = get(1, 0, n - 1, r, r + d - 1);
        cout << ((a1.cnt == a2.cnt && a1.bl == a2.bl) ? "Yes\n" : "No\n");
    }
    return 0;
}
