#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <map>

using namespace std;
typedef long long ll;
#define fi first
#define se second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin, x.rend()
#define range(i, n) for(int i = 0; i < n; ++i)


ll mod(ll a, ll b) {
    a = a % b;
    if (a < 0) {
        return b - a;
    } else {
        return a;
    }
}

ll bin_pow(ll base, ll a){
    if (a == 1){
        return base;
    } else if (a & 1){
        return base * bin_pow(base, a - 1);
    } else{
        ll x = bin_pow(base, a / 2);
        return x * x;
    }
}

template< class RandomAccessIterator >
void pri( RandomAccessIterator first, RandomAccessIterator last ){
    for (; first != last; ++first){
        cout << *first << ' ';
    }
    cout << '\n';
}


int main() {
    cin.tie(0);
    cout.tie(0);
    ll n; cin >> n;
    map<ll, vector<ll>> br;
    vector<vector<ll>> g(n);
    vector<ll> b(n);
    range(i, n){
        ll bx; cin >> bx;
        ll xbr = i - bx;
        b[i] = bx;
        for (auto el: br[xbr]){
            g[i].push_back(el);
        }
        br[xbr].push_back(i);
    }
    ll max_s = b[0];
    vector<ll> ans(n, 0);
    ans[0] = b[0];
    for (int i = 1; i < n; ++i) {
        ll now_max = 0;
        for (auto el: g[i]){
            now_max = max(now_max, ans[el]);
        }
        ans[i] = now_max + b[i];
        max_s = max(max_s, ans[i]);
    }
    cout << max_s;
    return 0;
}