#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <map>

using namespace std;
typedef int ll;
#define fi first
#define se second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin, x.rend()
#define range(i, n) for(int i = 0; i < n; ++i)


ll mod(ll a, ll b) {
    a = a % b;
    if (a < 0) {
        return b - a;
    } else {
        return a;
    }
}

ll bin_pow(ll base, ll a){
    if (a == 1){
        return base;
    } else if (a & 1){
        return base * bin_pow(base, a - 1);
    } else{
        ll x = bin_pow(base, a / 2);
        return x * x;
    }
}

template< class RandomAccessIterator >
void pri( RandomAccessIterator first, RandomAccessIterator last ){
    for (; first != last; ++first){
        cout << *first << ' ';
    }
    cout << '\n';
}

const ll MAXN = 2e5 + 10;
ll b[MAXN];
int main() {
    cin.tie(0);
    cout.tie(0);
    ll n; scanf("%d", &n);
    map<ll, vector<ll>> br;
    range(i, n){
        ll bx; scanf("%d", &bx);
        b[i] = bx;
        br[i - bx].push_back(i);
    }
    ll max_s = b[0];
    for (int i = 1; i < n; ++i) {
        ll now_max = 0;
        for (auto el: br[i - b[i]]){
            if (!(el ^ i)){ break;}
            now_max = max(now_max, b[el]);
        }
        b[i] = now_max + b[i];
        max_s = max(max_s, b[i]);
    }
    printf("%d", max_s);
    return 0;
}