#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <map>
#include <list>

using namespace std;
typedef long long ll;
#define fi first
#define int long long
#define se second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin, x.rend()
#define range(i, n) for(int i = 0; i < n; ++i)


ll mod(ll a, ll b) {
    a = a % b;
    if (a < 0) {
        return b - a;
    } else {
        return a;
    }
}

ll bin_pow(ll base, ll a){
    if (a == 1){
        return base;
    } else if (a & 1){
        return base * bin_pow(base, a - 1);
    } else{
        ll x = bin_pow(base, a / 2);
        return x * x;
    }
}

template< class RandomAccessIterator >
void pri( RandomAccessIterator first, RandomAccessIterator last ){
    for (; first != last; ++first){
        cout << *first << ' ';
    }
    cout << '\n';
}

const ll MAXN = 101;

int how_much(string s){
    if (s.size() < 2){ return 0;}
    int max_i = 0;
    for (int i = 1; i < s.size(); ++i) {
        if (s[i] > s[max_i]) {max_i = i;}
        else if ((s[i] == s[max_i]) && (((s[i] - s[i - 1]) == 1) || ((i < (s.size() - 1)) && ((s[i] - s[i + 1]) == 1)))){
            max_i = i;
        }
    }
    if (((max_i > 0) && ((s[max_i] - s[max_i - 1]) == 1)) || ((max_i < (s.size() - 1)) && ((s[max_i] - s[max_i + 1]) == 1))){
        s.erase(max_i, 1);
        return 1 + how_much(s);
    }
    else {
        int cnt = 0;
        if (max_i > 0){
            cnt += how_much(s.substr(0, max_i));
        }
        if (max_i < (s.size() - 1)){
            cnt += how_much(s.substr(max_i + 1, 101));
        }
        return cnt;
    }
}

signed main() {
    cin.tie(0);
    cout.tie(0);
    ll n; cin >> n;
    string s; cin >> s;
    cout << how_much(s);
    return 0;
}