#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <map>
#include <list>
#include <queue>

using namespace std;
typedef long long ll;
#define fi first
#define se second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin, x.rend()
#define range(i, n) for(int i = 0; i < n; ++i)


ll mod(ll a, ll b) {
    a = a % b;
    if (a < 0) {
        return b - a;
    } else {
        return a;
    }
}

ll bin_pow(ll base, ll a){
    if (a == 1){
        return base;
    } else if (a & 1){
        return base * bin_pow(base, a - 1);
    } else{
        ll x = bin_pow(base, a / 2);
        return x * x;
    }
}

template< class RandomAccessIterator >
void pri( RandomAccessIterator first, RandomAccessIterator last ){
    for (; first != last; ++first){
        cout << *first << ' ';
    }
    cout << '\n';
}


const int MAXN = 2e5 + 10;
vector<int> g[MAXN];
vector<int> g1[MAXN];
int ans[MAXN];
int way[MAXN];

int main() {
    cin.tie(0);
    cout.tie(0);
    ll n; cin >> n;
    ll m; cin >> m;
    for (int i = 0; i < m; ++i) {
        int a, b; cin >> a >> b;
        g[a].push_back(b);
        g1[b].push_back(a);
    }
    int k; cin >> k;
    range(i, k){
        cin >> way[i];
    }
    queue<int> q;
    range(i, n + 1){
        ans[i] = INT32_MAX;
    }
    ans[way[k-1]] = 0;
    q.push(way[k - 1]);
    while (!q.empty()){
        int now = q.front(); q.pop();
        for (auto to: g1[now]){
            if (ans[to] > ans[now] + 1){
                ans[to] = ans[now] + 1;
                q.push(to);
            }
        }
    }
    int last = way[0];
    int min_p = 0, max_p = 0;
    for (int i = 1; i < k; ++i) {
        int now = way[i];
        if (ans[now] != ans[last] - 1){
            ++min_p; ++max_p;
        } else {
            for (auto to: g[last]){
                if (to == now){ continue;}
                if (ans[to] == ans[last] - 1){
                    ++max_p;
                    break;
                }
            }
        }
        last = now;
    }
    cout << min_p << ' ' << max_p;
    return 0;
}