#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <stdio.h>
#include <string>
#include <cmath>
#include <algorithm>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <tuple>

#define forn(i, n) for(int i=0; i<n; i++)
#define pii pair<int,int>
#define mp make_pair
#define ld long double
#define ll long long

#pragma GCC optimize("Ofast,inline,unroll-loops,no-stack-protector")

using namespace std;

const int N = 4e5+100;
ll ans[2*N];

struct node{
	int x, id;
	node*l, *n;
	node():l(NULL), n(NULL), id(-1), x(-100){};
	node(int x, int id):l(NULL), n(NULL), x(x), id(id){};
};

int safe(node*n){
	return n == NULL ? -100 : n->x;
}

void add_node(node*t, node*n){
	t->n = n;
	n->l = t;
}

bool check_node(node*n){
	if(safe(n->l) == n->x-1)return 1;
	if(safe(n->n) == n->x-1)return 1;
	return 0;
}

void del(node*n){
	n->n->l = n->l;
	n->l->n = n->n;
}

int main(){
//	freopen("input.txt", "r", stdin);
//	freopen("output.txt", "w", stdout);
	ios_base::sync_with_stdio(0);

	int n;
	cin>>n;
	string str;
	cin>>str;
	node*s = new node();
	vector<node*>v(n);
	vector<int>ch[26];
	forn(i, n){
		int x = str[i] - 'a';
		v[i] = new node(x, i);
		ch[x].push_back(i);
		add_node(s, v[i]);
		s = v[i];
	}
	node*t = new node();
	add_node(s, t);
	int ans = 0;
	for(int i = 25;i>0;i--){
		queue<int>q;
		vector<char>used(n, 0);
		for(int j = 0; j < ch[i].size(); j++){
			int id= ch[i][j];
			if(check_node(v[id])){
				q.push(id);
				used[id] = 1;
			}
		}
		while(q.size()){
			int a = q.front();
			q.pop();
			ans++;
			if(v[a]->n->x == i){
				int id = v[a]->n->id;
				if(!used[id]){
					used[id] = 1;
					q.push(id);
				}
			}
			if(v[a]->l->x == i){
				int id = v[a]->l->id;
				if(!used[id]){
					used[id] = 1;
					q.push(id);
				}
			}
			del(v[a]);
		}
	}
	cout<<ans;
}