#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <stdio.h>
#include <string>
#include <cmath>
#include <algorithm>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <tuple>

#define forn(i, n) for(int i=0; i<n; i++)
#define pii pair<int,int>
#define mp make_pair
#define ld long double
#define ll long long

#pragma GCC optimize("Ofast,inline,unroll-loops,no-stack-protector")

using namespace std;

const int P = 3, MOD = 1e9+7, N = 3e5;
int deg[N];

void pre_build(){
	deg[0] = 1;
	forn(i, N)if(i>0)deg[i] = ((ll)deg[i] * P)%MOD; 
}

int main(){
//	freopen("input.txt", "r", stdin);
//	freopen("output.txt", "w", stdout);
	ios_base::sync_with_stdio(0);

	int n;
	cin>>n;
	string s;
	cin>>s;
	vector<int>pref(n+1,0), last(n + 1,0), next(n + 1, 0), odd(n+1, 0);
	vector<pii>v;
	forn(i, n){
		pref[i+1] = pref[i] + s[i]-'0';
		int c = 0;
		if(s[i] == '1')last[i + 1] = last[i] + 1;
		else{
			if(i>0 && last[i]%2 == 1){
				c=1;
				v.push_back(mp(i, 1));
			}
			v.push_back(mp(i, 0));
		}
		odd[i+1] = odd[i]+c;
	}
	for(int i=n-1;i>=0;i--){
		if(s[i] == '0')next[i] = 0;
		else next[i] = next[i+1] + 1;
	}
	vector<ll>hs(v.size()+1, 0);
	forn(i, v.size()){
		hs[i+1] = (hs[i]*P + v[i].second)%MOD;
	}
	int q;
	cin>>q;
	forn(i, q){
		int l1, l2, len;
		cin>>l1>>l2>>len;
		l1--;
		l2--;
		if(pref[l1+len]-pref[l1] != pref[l2+len]-pref[l2]){
			cout<<"No\n";
			continue;
		}
		int cnt1 = odd[len+l1] - odd[l1], cnt2 = odd[len+l2] - odd[l2];
		cnt1-=(last[l1]+next[l1])%2;
		cnt2-=(last[l2]+next[l2])%2;
		if(cnt1!=cnt2){
			cout<<"No\n";
			continue;
		}
		if(last[len+l1]%2!=last[len+l2]%2 || next[l1]%2 !=next[l2]%2){
			cout<<"No\n";
			continue;
		}
		int x1 = lower_bound(v.begin(),v.end(),mp(l1 + next[l1], -1)) - v.begin();
		int x2 = lower_bound(v.begin(),v.end(),mp(l2 + next[l2], -1)) - v.begin();
		int y1 = lower_bound(v.begin(),v.end(),mp(l1 + len - last[l1 + len], 3)) - v.begin();
		int y2 = lower_bound(v.begin(),v.end(),mp(l2 + len - last[l2 + len], 3)) - v.begin();
		if(y1-x1!=y2-x2){
			cout<<"No\n";
			continue;
		}
		ll h1 = ((hs[y1] - hs[x1] * deg[y1-x1])%MOD + MOD)%MOD;
		ll h2 = ((hs[y2] - hs[x2] * deg[y2-x2])%MOD + MOD)%MOD;
		if(h1 == h2){
			cout<<"Yes\n";
		}
		else cout<<"No\n";
	}
}