#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <fstream>
#include <string>
#include <algorithm>
#include <vector>
#include <iomanip>
#include <math.h>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>

using namespace std;

typedef long long ll;
typedef long double ld;

const int N = 500010;

vector < int > g[N], rev_g[N];

int p[N];

int d[N];

queue < int > q;

bool used[N];

int s, t;

int st[N];

int nxt[N];

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
#ifdef _DEBUG
	freopen("Test.txt", "r", stdin);
#endif
	int n, m;
	cin >> n >> m;
	for (int i = 1; i <= m; ++i) {
		int v, to;
		cin >> v >> to;
		g[v].push_back(to);
		rev_g[to].push_back(v);
	}
	int k;
	cin >> k;
	for (int i = 1; i <= k; ++i) {
		cin >> p[i];
	}
	s = p[1], t = p[k];
	q.push(t);
	d[t] = 0;
	used[t] = true;
	while (!q.empty()) {
		int v = q.front();
		q.pop();
		for (int to : rev_g[v]) {
			if (used[to])
				continue;
			used[to] = true;
			d[to] = d[v] + 1;
			q.push(to);
		}
	}
	//fill(used, used + (n + 1), false);
	for (int i = 1; i <= n; ++i) {
		for (int to : g[i]) {
			if (d[i] == d[to] + 1)
				++st[i], nxt[i] = to;
		}
	}
	int min_ans = 0, max_ans = 0;
	for (int i = 2; i <= k; ++i) {
		if (d[p[i]] + 1 != d[p[i - 1]])
			++min_ans;
		else
			continue;
	}
	for (int i = 1; i < k; ++i) {
		if (st[p[i]] >= 2 || nxt[p[i]] != p[i + 1])
			++max_ans;
		else
			continue;
	}
	cout << min_ans << ' ' << max_ans;
}