#ifndef LOCAL
#pragma GCC optimize("Ofast,fast-math,unroll-loops,no-stack-protector,inline")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4.1,sse4.2,sse4a,avx,avx2,abm,mmx,popcnt")
#endif

#include <bits/stdc++.h>

//#define int long long

using namespace std;

//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>
//
//
//typedef __gnu_pbds::tree<int, __gnu_pbds::null_type, std::less<>,
//                         __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>
//    ordered_set; // order_of_key   find_by_order

struct Node {
  char c;
  int l = -1, r = -1;
  bool d = false;
};

vector<Node> nodes;

bool cmp(int a, int b) {
  return nodes[a].c < nodes[b].c;
}

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.tie(nullptr);
  int n;
  cin >> n;
  if (n == 1) {
    cout << 0;
    return 0;
  }
  nodes.resize(n);
  for (int i = 0; i < n; ++i) {
    cin >> nodes[i].c;
    if (i > 0)
      nodes[i].l = i - 1;
    if (i + 1 < n)
      nodes[i].r = i + 1;
  }
  vector<int> indexes(n);
  iota(indexes.begin(), indexes.end(), 0);
  sort(indexes.rbegin(), indexes.rend(), cmp);
  char cc = 'z' + 1;
  int i = 0;
  int ans = 0;
  while (cc > 'a' && i < n) {
    cc--;
    queue<int> Q;
    while (i < n && nodes[indexes[i]].c == cc) {
      Q.push(indexes[i++]);
    }
    while (!Q.empty()) {
      int ind = Q.front();
      Q.pop();
      if (nodes[ind].d)
        continue;
      if (nodes[ind].l != -1 && nodes[nodes[ind].l].c + 1 == nodes[ind].c)
        nodes[ind].d = true;
      if (nodes[ind].r != -1 && nodes[nodes[ind].r].c + 1 == nodes[ind].c)
        nodes[ind].d = true;
      if (!nodes[ind].d)
        continue;
      ans++;
      if (nodes[ind].l != -1) {
        nodes[nodes[ind].l].r = nodes[ind].r;
        Q.push(nodes[ind].l);
      }
      if (nodes[ind].r != -1) {
        nodes[nodes[ind].r].l = nodes[ind].l;
        Q.push(nodes[ind].r);
      }
    }
  }
  cout << ans;
  return 0;
}