#ifndef LOCAL
#pragma GCC optimize("Ofast,fast-math,unroll-loops,no-stack-protector,inline")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4.1,sse4.2,sse4a,avx,avx2,abm,mmx,popcnt")
#endif

#include <bits/stdc++.h>

using namespace std;

#define int long long

//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>
//
//
//typedef __gnu_pbds::tree<int, __gnu_pbds::null_type, std::less<>,
//                         __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>
//    ordered_set; // order_of_key   find_by_order

const int MAXN = 200000;
int n, m, k;
vector<int> graph[MAXN], rgraph[MAXN];
int way[MAXN];
int dist[MAXN];

void bfs(int t) {
  fill(dist, dist + n, INT_MAX);
  dist[t] = 0;
  queue<int> Q;
  Q.push(t);
  while (!Q.empty()) {
    int v = Q.front();
    Q.pop();
    for (int u : rgraph[v]) {
      if (dist[u] > dist[v] + 1) {
        dist[u] = dist[v] + 1;
        Q.push(u);
      }
    }
  }
}

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.tie(nullptr);
  cin >> n >> m;
  for (int i = 0; i < m; ++i) {
    int v, u;
    cin >> v >> u;
    v--, u--;
    graph[v].push_back(u);
    rgraph[u].push_back(v);
  }
  cin >> k;
  for (int i = 0; i < k; ++i) {
    cin >> way[i];
    way[i]--;
  }
  bfs(way[k - 1]);
  int ansmin = 0, ansmax = 0;
  for (int i = 0; i < k - 1; ++i) {
    int v = way[i];
    int u = way[i + 1];
    bool isu = false, iselse = false;
    int d = dist[v];
    for (int w : graph[v]) {
      if (dist[w] != d - 1)
        continue;
      if (w == u)
        isu = true;
      else
        iselse = true;
    }
    ansmin += !isu;
    ansmax += iselse;
  }
  cout << ansmin << ' ' << ansmax;
  return 0;
}