#include <bits/stdc++.h>
#define ll long long
#define all(v) v.begin(), v.end()

using namespace std;

bool IS_LOCAL = false;

int n, m;
vector<vector<int>> graph, r_graph;
int k;
vector<int> path;

vector<int> dist;
void bfs(int from) {
    dist.resize(n, -1);
    dist[from] = 0;
    queue<int> q;
    q.push(from);
    while (!q.empty()) {
        int now = q.front();
        q.pop();
        for (int v : r_graph[now]) {
            if (dist[v] == -1) {
                dist[v] = dist[now] + 1;
                q.push(v);
            }
        }
    }
    if (IS_LOCAL) {
        for (int e : dist) {
            cout << e << ' ';
        }
        cout << '\n';
    }
}

pair<int, int> solve() {
    bfs(path[path.size() - 1]);
    int min_changes = 0, max_changes = 0;
    for (int i = 0; i < k - 1; ++i) {
        int v = path[i];
        int now_d = dist[v];
        int u = path[i + 1];
        if (dist[u] != dist[v] - 1) {
            min_changes++;
        }
        for (int us : graph[v]) {
            if (dist[us] == dist[v] - 1 && us != u) {
                max_changes++;
                break;
            }
        }
    }
    if (IS_LOCAL) {
        cout << "Solved!\n";
    }
    return {min_changes, max_changes};
}

void stupid() {

}

bool check() {
    return true;
}

int gen() {
    return 0;
}

bool iterate() {
    return true;
}

void read() {
    cin >> n >> m;
    graph.resize(n);
    r_graph.resize(n);
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        a--; b--;
        graph[a].emplace_back(b);
        r_graph[b].emplace_back(a);
    }
    cin >> k;
    path.resize(k);
    for (int i = 0; i < k; ++i) {
        int a;
        cin >> a;
        path[i] = a - 1;
    }
    if (IS_LOCAL) {
        cout << "Read!\n";
    }
}

int main()
{
    if (!IS_LOCAL) {
        cin.tie(0);
        cout.tie(0);
        iostream::sync_with_stdio(false);
    }
    read();
    auto answer = solve();
    cout << answer.first << ' ' << answer.second << '\n';
}
