//#pragma GCC optimize("Ofast,unroll-loops,fast-math,no-stack-protector")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,abm,mmx,avx,avx2,popcnt,tune=native")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

//#define int long long

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef pair<ld, ld> pld;

template<typename T>
using kawaii_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define all(x) (x).begin(), (x).end()

void FAST_IO() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	//cout.setf(ios::fixed);
	//cout.precision(20);
	#ifndef _offline
		//freopen("input.txt", "r", stdin);
		//freopen("output.txt", "w", stdout);
	#endif
}

const int MAXN = 105;
int r[MAXN], b[MAXN];

signed main() {
	FAST_IO();
	int n;
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> r[i];
	}
	for (int i = 0; i < n; ++i) {
		cin >> b[i];
	}
	int s = 0, cnt = 0;
	for (int i = 0; i < n; ++i) {
		if (r[i] == 0 && b[i] == 1) {
			s++;
		}
		else if (r[i] == 1 && b[i] == 0) {
			cnt++;
		}
	}
	if (cnt == 0) {
		cout << -1 << '\n';
	}
	else {
		for (int x = 1; ; ++x) {
			if (x * cnt > s) {
				cout << x << '\n';
				return 0;
			}
		}
	}
}