#include <bits/stdc++.h>

#define ll long long
#define dou long double
#define fi first
#define se second

#define allv(v) v.begin(), v.end()
#define pb push_back
#define ppb pop_back
#define pf push_front
#define ppf pop_front
#define si size()

#define deb if(debug)
#define ccc cout << "H";

int debug = 0;

using namespace std;

vector <ll> tr;

void add(int p, int L, int R, int a, int b, ll val){
	if(L >= b || R <= a)
		return;
	if(a <= L && R <= b){
		tr[p] += val;
		return;
	}

	int M = (L+R)>>1;
	add(p+p+1, L, M, a, b, val);
	add(p+p+2, M, R, a, b, val);
}

ll get(int p, int L, int R, int ind){
	if(R <= ind || L > ind)
		return 0;
	if(L+1==R)
		return tr[p];
	int M = (L+R)>>1;
	return get(p+p+1, L, M, ind) + get(p+p+2, M, R, ind) + tr[p];
}

int main(){
	if(!debug) ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

	ll n, m, p;
	cin >> n >> m >> p;
	vector <pair <ll, ll>> v1(n), v2(m);
	vector <pair <pair <ll, ll>, ll>> v3(p);

	vector <ll> mn1((int)1e6+4, (ll)1e18), mn2((int)1e6+4, (ll)1e18);
	multiset <ll> mnn1, mnn2;

	for(int i = 0; i < n; ++i){
		cin >> v1[i].fi >> v1[i].se;
		mn1[v1[i].fi] = min(mn1[v1[i].fi], v1[i].se);
	}
	for(int i = 0; i < m; ++i){
		cin >> v2[i].fi >> v2[i].se;
		mn2[v2[i].fi] = min(mn2[v2[i].fi], v2[i].se);
	}
	for(int i = 0; i < p; ++i)
		cin >> v3[i].fi.se >> v3[i].fi.fi >> v3[i].se;


	sort(allv(v3));
	for(int i = 0; i < (int)1e6+4; ++i)
		if(mn1[i] != (ll)1e18)
			mnn1.insert(mn1[i]);
	for(int i = 0; i < (int)1e6+4; ++i){
		if(mn1[i] != (ll)1e18)
			mnn1.erase(mnn1.find(mn1[i]));
		if(mnn1.si)
			mn1[i] = *mnn1.begin();
	}

	for(int i = 0; i < (int)1e6+4; ++i)
		if(mn2[i] != (ll)1e18)
			mnn2.insert(mn2[i]);
	for(int i = 0; i < (int)1e6+4; ++i){
		if(mn2[i] != (ll)1e18)
			mnn2.erase(mnn2.find(mn2[i]));
		if(mnn2.si)
			mn2[i] = *mnn2.begin();
	}

	ll ans = -mn1[0] - mn2[0], nowa = 0;
	tr.resize((int)(1e6+4)*4);
	for(int i = 0; i < p; ++i){
		ll now = -mn1[v3[i].fi.fi];
		add(0, 0, (int)1e6+4, v3[i].fi.se, (int)1e6+4, v3[i].se);
		if(get(0, 0, (int)1e6+4, nowa) - mn2[nowa] < get(0, 0, (int)1e6+4, v3[i].fi.se) - mn2[v3[i].fi.se])
			nowa = v3[i].fi.se;
		now += get(0, 0, (int)1e6+4, nowa) - mn2[nowa];
		ans = max(ans, now);
	}

	cout << ans;


	return 0;
}
/*
4 4 3
1 1
2 2
3 3
4 4
1 1
2 2
3 3
4 4
1 3 5
2 2 5
3 1 0
*/
