#include <bits/stdc++.h>
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
#define int long long

using namespace std;

mt19937 rnd(time(nullptr));

const int INF = 1e18;

int32_t main() {
    srand(time(nullptr));
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector <vector <int> > graph(n), rev_graph(n);
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        graph[a].push_back(b);
        rev_graph[b].push_back(a);
    }
    int k;
    cin >> k;
    vector <int> num(k);
    for (int i = 0; i < k; i++) {
        cin >> num[i];
        num[i]--;
    }
    int s = num[0], t = num.back();
    queue <int> q;
    q.push(t);
    vector <int> dist(n, INF);
    dist[t] = 0;
    while (!q.empty()) {
        int x = q.front();
        q.pop();
        for (int to : rev_graph[x]) {
            if (dist[to] == INF) {
                dist[to] = dist[x] + 1;
                q.push(to);
            }
        }
    }
    int x = 0, y = 0;
    for (int i = 0; i < k - 1; i++) {
        if (dist[num[i + 1]] != dist[num[i]] - 1) {
            x++;
            y++;
        }
        else {
            int kek = 0;
            for (int to : graph[num[i]]) {
                if (dist[to] == dist[num[i]] - 1)
                    kek++;
            }
            if (kek > 1)
                y++;
        }
    }
    cout << x << " " << y << "\n";
    return 0;
}
