#include <bits/stdc++.h>

using namespace std;

#define int long long

typedef long long ll;
typedef pair<int, int> pii;


struct mon{
    int a;
    int b;
    int z;
};

vector<mon> str;

bool operator<(mon a, mon b) {
    if (a.a == b.a) {
        return a.b < b.b;
    }
    return a.a < b.a;
}

vector<int> tree, push;

void up(int v, int l, int r) {
    if (r - l == 1) {
        return;
    }
    tree[2 * v] += push[v];
    tree[2 * v + 1] += push[v];
    push[2 * v] += push[v];
    tree[2 * v + 1] += push[v];
    push[v] = 0;
}

void add(int v, int l, int r, int nl, int nr, int s) {
    up(v, l, r);
    if (r <= nl || nr <= l) {
        return;
    }
    if (nl <= l && r <= nr) {
        tree[v] += s;
        push[v] += s;
        return;
    }
    int m = l + (r - l) / 2;
    add(2 * v, l, m, nl, nr, s);
    add(2 * v + 1, m, r, nl, nr, s);
    tree[v] = max(tree[2 * v], tree[2 * v + 1]);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, m, p;
    cin >> n >> m >> p;
    vector<pii> a, b;
    a.resize(n);
    b.resize(m);
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        a[i] = {x, y};
    }
    for (int i = 0; i < m; i++) {
        int x, y;
        cin >> x >> y;
        b[i] = {x, y};
    }
    str.resize(p);
    vector<int> arm;
    for (int i = 0; i < p; i++) {
        int x, y, z;
        cin >> x >> y >> z;
        str[i] = {x, y, z};
        arm.push_back(y);
    }
    map<int, int> sec, rev;
    int c = 0;
    sort(arm.begin(), arm.end());
    c = 1;
    sec[arm[0]] = 0;
    rev[0] = arm[0];
    for (int j = 0; j < p; j++) {
        if (arm[j] == arm[0]) {
            continue;
        }
        if (sec[arm[j]] == 0) {
            sec[arm[j]] = c;
            rev[c] = arm[j];
            c++;
        }
    }

    //sec[1] = 0;
    //sec[2] = 1;
    //sec[4] = 2;

    tree.resize(4 * c + 10);
    push.resize(4 * c + 10);

    sort(str.begin(), str.end());
    vector<mon> str2 = str;
    for (int i = 0; i < p; i++) {
        str[i].b = sec[str[i].b];
    }
    sort(a.begin(), a.end());
    sort(b.begin(), b.end());
    vector<pii> a1;
    pii last = a[n - 1];
    a1.push_back(last);
    for (int i = n - 2; i >= 0; i--) {
        if (a[i].second > last.second) {
            continue;
        } else {
            last = a[i];
            a1.push_back(last);
        }
    }
    vector<pii> b1;
    last = b[m - 1];
    b1.push_back(last);
    for (int i = m - 2; i >= 0; i--) {
        if (b[i].second > last.second) {
            continue;
        } else {
            last = b[i];
            b1.push_back(last);
        }
    }
    sort(a1.begin(), a1.end());
    sort(b1.begin(), b1.end());

    for (int i = 0; i < c; i++) {
        pii wer = make_pair(rev[i] + 1, 0);
        int res2 = lower_bound(b1.begin(), b1.end(), wer) - b1.begin();
        if (res2 < b1.size()) {
                //cout << rev[i] << " - " << -b1[res2].second << "\n";
            add(1, 0, c, i, i + 1, -b1[res2].second);
        }
    }

    vector<int> ans(p);
    for (int i = 0; i < p; i++) {
        mon now = str[i];
        add(1, 0, c, 0, now.b, now.z);
        ans[i] = tree[1];
        //cout << ans[i] << " ";
    }

    int answer = 0;
    for (int i = 0; i < p; i++) {
        pii wer = make_pair(str2[i].a + 1, 0);
        int res = lower_bound(a1.begin(), a1.end(), wer) - a1.begin();
        if (res < a1.size()) {
            ans[i] -= a1[res].second;
        }
        /*
        wer = make_pair(str2[i].b + 1, 0);
        int res2 = lower_bound(b1.begin(), b1.end(), wer) - b1.begin();
        if (res2 < b1.size()) {
            ans[i] -= b1[res2].second;
        }
        */
        //cout << ans[i] << " ";
        answer = max(ans[i], answer);
    }

    cout << answer;






    return 0;
}
