#include <bits/stdc++.h>

#define ll long long
#define pb push_back
#define ld long double
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define mp make_pair

using namespace std;

const int maxn = 2e5 + 100;
const ll maxv = 1e6;
const int inf = 1e9;

void init(){
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

ll a[maxn];
ll sum[maxv];

int main(){
    init();


    int n, m;
    cin >> n >> m;

    vector<vector<int > > g(n);
    vector<vector<int > > revg(n);

    for (int i = 0 ; i < m;i++){
        int u, v;
        cin >> u >> v;
        u--, v--;
        g[u].pb(v);
        revg[v].pb(u);
    }

    vector<int> way;
    int k;
    cin >> k;
    for (int i = 0 ;i <k; i++){
        int x;
        cin >> x;
        x--;
        way.pb(x);
    }

    queue<int> q;
    vector<int> d(n, inf);
    d[way[0]] = 0;
    vector<bool> used(n, false);
    used[way[0]] = true;
    q.push(way[0]);

    while(!q.empty()){
        int cur = q.front();
        q.pop();
        for (int i = 0;i < g[cur].size(); i++){
            int next = g[cur][i];
            if (used[next])
                continue;
            used[next] = true;
            d[next] = d[cur] + 1;
            q.push(next);
        }
    }

    fill(all(used), false);
    vector<int> dfinish(n, inf);
    dfinish[way.back()] = 0;
    used[way.back()] = true;
    q.push(way.back());

    while(!q.empty()){
        int cur = q.front();
        q.pop();
        for (int i = 0; i< revg[cur].size(); i++){
            int next = revg[cur][i];
            if (used[next])
                continue;
            used[next] = true;
            dfinish[next] = dfinish[cur] + 1;
            q.push(next);
        }
    }

    int minans = 0;
    int maxans = 0;

    int mindist = d[way.back()];

    for (int i = 0; i < n; i++){
        //cout << dfinish[i] << " ";
    }
    cout << endl;

    for (int i = 0; i < way.size() - 1; i++){
        int cur = way[i];
        int next = way[i + 1];
        bool was = false;
        bool wasne = false;

        for (int j = 0;j < g[cur].size(); j++){
            int step = g[cur][j];
            if (!(dfinish[cur] == dfinish[step] + 1))
                continue;
            if (step == next)
                was = true;
            else
                wasne = true;
        }
        if (!was){
            minans++;
            maxans++;
        }
        else if (wasne){
            maxans++;
            //cout << cur << endl;
        }
    }
    cout << minans << " " << maxans << endl;
    //system("pause");

    return 0;
}

