#include <bits/stdc++.h>
using namespace std;

#define int long long
#define double long double
#define endl "\n"
#define vec vector
#define pii pair<int, int>

void solve(); signed main() {
	// freopen("input.txt", "r", stdin); cout << "не забудь закомментировать freopen" << endl << endl;
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	srand(time(0));
	cout.setf(ios::fixed); cout.precision(10);
	solve();
	return 0;
}

const int INF = 1e9, MAXN = 2e5 + 10;
int n, m;
vec<int> g[MAXN], rg[MAXN];

void solve() {	
	cin >> n >> m;
	for (int i = 0; i < m; ++i) {
		int u, v;
		cin >> u >> v;
		g[u].push_back(v);
		rg[v].push_back(u);
	}

	vec<int> dist(n + 1, INF);
	int k;
	cin >> k;
	vec<int> p(k + 1);
	for (int i = 0; i < k; ++i) {
		cin >> p[i];
	}

	deque<int> q;
	dist[p[k - 1]] = 0;
	q.push_back(p[k - 1]);

	while (!q.empty()) {
		int v = q.front();
		q.pop_front();
		for (int i = 0; i < rg[v].size(); ++i) {
			int u = rg[v][i];
			if (dist[u] == INF) {
				dist[u] = dist[v] + 1;
				q.push_back(u);
			}
		}
	}

	vec<int> a(k);
	for (int i = 0; i < k; ++i) {
		a[i] = dist[p[i]];
	}
	vec<int> b(k);
	for (int i = 0; i < k; ++i) {
		int v = p[i];
		for (int j = 0; j < g[v].size(); ++j){
			int u = g[v][j];
			if (i == 0) {
				if (p[i + 1] != u) {
					if (dist[v] == dist[u] + 1) {
						b[i] = 1;
						break;
					}
				}
			}
			else {
				if (p[i + 1] != u && p[i - 1] != u) {
					if (dist[v] == dist[u] + 1) {
						b[i] = 1;
						break;
					}
				}
			}
		}
	}

	int ans1 = 0, ans2 = 0;
	for (int i = 0; i < k; ++i) {
		if (b[i]) {
			ans2++;
		}
	}
	int i = 0;
	while (i < k) {
		while (i < k - 1 && a[i] == a[i + 1] + 1) {
			i++;
		}
		i++;
		ans1++;
	}

	cout << ans1 - 1 << " " << ans2 << endl;
}