#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

#define int long long

const int N = 2e5 + 7;
const int inf = 1e9 + 7;

vector <int> g[N];
vector <int> rg[N];
int d[N], cnt[N];
bool used[N];

void bfs(int s) {
  for (int i = 0; i < N; i++) {
    d[i] = inf;
  }
  d[s] = 0;
  cnt[s] = 1;
  queue <int> q;
  q.push(s);
  while (!q.empty()) {
    int v = q.front();
    q.pop();
    if (used[v]) continue;
    used[v] = true;
    for (auto to : rg[v]) {
      if (d[to] > d[v] + 1) {
        d[to] = d[v] + 1;
        q.push(to);
      }
      if (d[to] == d[v] + 1) {
        cnt[to] += cnt[v];
        cnt[to] = min(cnt[to], 2ll);
      }
    }
  }
}

int32_t main() {
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
#endif
  ios::sync_with_stdio(0);
  cin.tie(0);
  int n, m;
  cin >> n >> m;
  for (int i = 0; i < m; i++) {
    int a, b;
    cin >> a >> b;
    g[a].push_back(b);
    rg[b].push_back(a);
  }
  int k;
  cin >> k;
  vector <int> p(k);
  for (int i = 0; i < k; i++) {
    cin >> p[i];
  }
  int src = p.back();
  bfs(src);
  int mn = 0, mx = 0;
  for (int i = 0; i < k - 2; i++) {
    int a = p[i], b = p[i + 1];
    int dist_a = k - i - 1;
    int dist_b = k - i - 2;
    if (d[b] + 1 != d[a]) {
      mn++;
    }
    if (cnt[b] == 2 || d[b] + 1 != d[a] || cnt[a] == 2) {
      mx++;
    }
  }
  cout << mn << ' ' << mx << endl;
  return 0;
}
