#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <iomanip>
#include <string>
#include <algorithm>
#include <cmath>
#include <cassert>


using namespace std;


#define FAST_IO ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define ff first
#define ss second
#define int long long


typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;


const int MAXN = 2e5 + 5;
const ll INF = 1e18;
const ll MOD = 1e9 + 7;


vector<int> b;


signed main() {
    int n;
    cin >> n;
    b.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> b[i];
    }
    vector<int> kek(n);
    for (int i = 0; i < n; i++) {
        kek[i] = b[i];
    }
    map<int, int> diff;
    for (int i = 1; i < n; i++) {
        if (diff.find(i + 1 - b[i]) != diff.end()) {
            int tt = i + 1 - b[i];
            int j = diff[tt];
            kek[i] = max(kek[i], kek[j] + b[i]);
            diff[i + 1 - b[i]] = i;
        } else {
            diff[i + 1 - b[i]] = i;
        }

    }
    int ans = 0;
    for (int i = 0; i < n; i++) {
        ans = max(ans, kek[i]);
    }
    cout << ans << "\n";
    return 0;
}
