//#pragma GCC optimize("-Ofast")
//#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define ll long long
#define ld long double
#define pb push_back
#define F first
#define S second
#define sqr(x) (x) * (x)

using namespace std;
using namespace __gnu_pbds;

mt19937 gen(time(0));

typedef tree<
int,
null_type,
less<int>,
rb_tree_tag,
tree_order_statistics_node_update>
ordered_set;

//const int maxn = 7e5 + 555;

const int inf = 2e9 + 66666;
const int maxm = (1 << 20);

struct segtree
{
    int T[maxm * 2 + 5];
    int lazy[maxm * 2 + 5];
    bool used[maxm * 2 + 5];
    void push(int v, int tl, int tr)
    {
        if (used[v])
        {
            lazy[v << 1] += lazy[v];
            lazy[v << 1 | 1] += lazy[v];
            int tm = (tl + tr) >> 1;
            T[v << 1] += lazy[v] * (tm - tl + 1);
            T[v << 1 | 1] += lazy[v] * (tr - tm);
            used[v << 1] = true;
            used[v << 1 | 1] = true;
            used[v] = false;
            lazy[v] = 0;
        }
    }
    int query(int v, int tl, int tr, int l, int r)
    {
        if(tl > r || tr < l) return 0;
        if (tl != tr) push(v, tl, tr);
        if (tl >= l && tr <= r) return T[v];
        int tm = (tl + tr) >> 1;
        return max(query(v << 1, tl, tm, l, r),
               query(v << 1 | 1, tm + 1, tr, l, r));
    }

    void update(int v, int tl, int tr, int l, int r, int x)
    {
        if (tl > r || tr < l) return;
        if (tl >= l && tr <= r)
        {
            lazy[v] += x;
            T[v] += x * (tr - tl + 1);
            used[v] = true;
            return;
        }
        push(v, tl, tr);
        int tm = (tl + tr) >> 1;
        update(v << 1, tl, tm, l, r, x);
        update(v << 1 | 1, tm + 1, tr, l, r, x);
        T[v] = max(T[v << 1], T[v << 1 | 1]);
        return;
    }
};

segtree st;

const int maxn = 2e5 + 4;

pair <int, int> a[maxn];
int sufa[maxn];
pair <int, int> b[maxn];
int sufb[maxn];
pair <pair <int, int>, int> mon[maxn];

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    int n, m, p;
    cin >> n >> m >> p;
    for(int i = 0; i < n; ++i)
        cin >> a[i].F >> a[i].S;
    for(int i = 0; i < m; ++i)
        cin >> b[i].F >> b[i].S;
    for(int i = 0; i < p; ++i)
    {
        cin >> mon[i].F.F >> mon[i].F.S >> mon[i].S;
    }
    sort(a, a + n);
    sort(b, b + m);
    sort(mon, mon + p);
    int pr = 0;
    for(int i = 0; i < m; ++i)
    {
        if (pr <= b[i].F)
            st.update(1, 0, maxm - 1, pr, b[i].F, -b[i].S);
        pr = b[i].F + 1;
    }
    sufa[n - 1] = a[n - 1].S;
    for(int i = n - 2; i >= 0; --i)
        sufa[i] = min(sufa[i + 1], a[i].S);
    sufb[m - 1] = b[m - 1].S;
    for(int i = m - 2; i >= 0; --i)
        sufb[i] = min(sufb[i + 1], b[i].S);
    int ans = -sufa[0] - sufb[0];
    int uk = 0;
    for(int i = 0; i < n; ++i)
    {
        while(uk < p && mon[uk].F.F < a[i].F)
        {
            st.update(1, 0, maxm - 1, 0, mon[uk].F.S, mon[uk].S);
            ++uk;
        }
        ans = max(ans, st.query(1, 0, maxm - 1, 0, maxm - 1) - a[i].S);
    }
    cout << ans;
    return 0;
}

//1003067
