//#pragma GCC optimize("Ofast")
#include <iostream>
#include<vector>
#include<string>
#include<algorithm>
#include<cmath>
#include<map>
#include<set>
#include<unordered_map>
#include<unordered_set>
#include<queue>
#include<ext/rope>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>
#include <vector>
//using namespace __gnu_pbds;
using namespace std;
#define ll long long
#define ld long double
#define int long long
int pr1[1000006], pr2[1000006];
const int N=1<<20;
struct node
{
    int val, l, r;
    node():val(0), l(-1), r(-1){}
    node(int val, int l, int r):val(val), l(l), r(r){}
    node operator+(const node & Node) const {
        return node(val+Node.val, l,Node.r);
    }
};
node tree[2*N];;
void build()
{
    for(int i=0;i<N;++i)
        tree[i+N]=node(0, i ,i);
    for(int i=N-1;i>=1;--i)
        tree[i]=tree[i*2]+tree[i*2+1];
}
node get(int v, int l, int r) {
    if (l > tree[v].r || tree[v].l > r)
        return node();
    if(l<=tree[v].l&&tree[v].r<=r)
        return tree[v];
    return get(v*2, l, r)+get(v*2+1, l, r);
}
void upd(int pos, int d) {
    pos += N;
    tree[pos].val += d;
    pos /= 2;
    while (pos) {
        tree[pos] = tree[pos * 2] + tree[pos * 2 + 1];
        pos /= 2;
    }
}
signed main() {
    std::ios_base::sync_with_stdio(0), cin.tie(0);
    int n, m, p;
    int inf = 1e9;
    cin >> n >> m >> p;
    vector<pair<int, int>> a(n);
    vector<pair<int, int>> b(m);
    for (int i = 0; i < n; ++i)
        cin >> a[i].first >> a[i].second;
    for (int i = 0; i < m; ++i)
        cin >> b[i].first >> b[i].second;
    build();
    sort(a.rbegin(), a.rend());
    sort(b.rbegin(), b.rend());
    for (int i = 1; i < 1000006; ++i)
        pr1[i] = pr2[i] = inf;
    int j = 0;
    for (int i = 1000004; i >= 1; --i) {
        pr1[i] = min(pr1[i], pr1[i + 1]);
        while (j < n && a[j].first >= i)
            pr1[i] = min(pr1[i], a[j].second), j++;
    }
    j = 0;
    for (int i = 1000004; i >= 1; --i) {
        pr2[i] = min(pr2[i], pr2[i + 1]);
        while (j < m && b[j].first >= i)
            pr2[i] = min(pr2[i], b[j].second), j++;
    }
    ll ans = -pr1[1];
    ans -= pr2[1];
    vector<pair<pair<int, int>, int>> dr(p);
    for (int i = 0; i < p; ++i) {
        cin >> dr[i].first.first >> dr[i].first.second >> dr[i].second;
        dr[i].first.first++;
        dr[i].first.second++;
    }
    sort(dr.begin(), dr.end());
    int ls = -1;
    for (int i = 0; i < p; ++i) {
        ll cur = 0;
        cur -= pr1[dr[i].first.first];
        if (ls == -1) {
            cur += dr[i].second;
            cur -= pr2[dr[i].first.second];
            ls = dr[i].first.second;
        } else {
            if (dr[i].first.second <= ls) {
                if (cur + get(1, 1, dr[i].first.second).val - pr2[dr[i].first.second] >
                    cur + get(1, 1, ls).val - pr2[ls]) {
                    cur = cur + get(1, 1, dr[i].first.second).val - pr2[dr[i].first.second] + dr[i].second;
                    ls = dr[i].first.second;
                } else {
                    cur = cur + get(1, 1, ls).val - pr2[ls] + dr[i].second;
                }
            } else {
                if (cur + get(1, 1, dr[i].first.second).val - pr2[dr[i].first.second] + dr[i].second >
                    cur + get(1, 1, ls).val - pr2[ls]) {
                    cur = cur + get(1, 1, dr[i].first.second).val - pr2[dr[i].first.second] + dr[i].second;
                    ls = dr[i].first.second;
                } else {
                    cur = cur + get(1, 1, ls).val - pr2[ls];
                }
            }
        }

        ans = max(ans, cur);
        upd(dr[i].first.second, dr[i].second);
    }
    cout << ans;
    return 0;
}