#include <bits/stdc++.h>

#define ll long long
#define pb push_back
#define mp make_pair
#define F first
#define S second
#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()

using namespace std;

const int inf = 1e9 + 7;
const int MAXN = 2e5 + 5;

int n, m;
vector<int> g[MAXN];
int p[MAXN];
int dist[MAXN];
int par[MAXN];
bool f[MAXN];
bool used[MAXN];

bool cmp(int &a, int &b) {
    return f[a] <= f[b];
}

void bfs(int t) {
    for (int i = 1; i <= n; i++) {
        used[i] = 0;
    }

    queue<int> q;

    q.push(t);
    used[t] = 1;

    while (!q.empty()) {
        int v = q.front();

        q.pop();

        for (int to : g[v]) {
            if (used[to] == 0) {
                used[to] = 1;
                dist[to] = dist[v] + 1;
                q.push(to);
                par[to] = v;
            }
        }
    }
}

void solve() {
    cin >> n >> m;

    for (int i = 1; i <= m; i++) {
        int a, b;

        cin >> a >> b;

        g[b].pb(a);
    }

    int k;

    cin >> k;

    for (int i = 1; i <= k; i++) {
        cin >> p[i];
        f[p[i]] = 1;
    }


    for (int i = 1; i <= n; i++) {
        sort (all(g[i]), cmp);
    }

    bfs(p[k]);

    int mx = 0;

    for (int i = 2; i <= k; i++) {
        if (par[p[i - 1]] != p[i]) mx++;
    }

    for (int i = 1; i <= n; i++) {
        reverse(all(g[i]));
    }

    bfs(p[k]);

    int mn = 0;

    for (int i = 1; i <= k; i++) {
        if (par[p[i - 1]] != p[i]) mn++;
    }

    cout << max(0, mn - 1) << ' ' << mx;

}


int main() {

    ios_base :: sync_with_stdio(NULL);
    cin.tie(NULL);
    cout.tie(NULL);

    int tt = 1;
    // cin >> tt;
    while (tt--) {
        solve();
    }

	return 0;
}
