#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <string>


using namespace std;

#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define inf 1000000000ll;
#define x first
#define y second
#define ll long long

vector<ll> zfunc(string s)
{
	int n = s.length();
	vector<ll> z(n);
	z[0] = 0;
	ll l = 0, r = 0;
	for(int i = 1; i < n; i++)
	{
		if(i <= r)
		{
			z[i] = min(r - i + 1, z[l - i]);
		}
		while(i + z[i] < n && s[z[i]] == s[i + z[i]]) z[i]++;
	}
	return z;
}

int main()
{
	//---------------------------------------------
	#define int long long
	cin.tie(NULL);
	cout.tie(NULL);
	ios::sync_with_stdio(false);
	//---------------------------------------------
	
	int n;
	cin >> n;
	vector<int> r(n), b(n);
	for(int i = 0; i < n; i++) cin >> r[i];
	for(int i = 0; i < n; i++) cin >> b[i];
	int b1 = 0, b2 = 0;
	for(int i = 0; i < n; i++)
	{
		if(r[i] == 1 && b[i] == 0) b1++;
		if(r[i] == 0 && b[i] == 1) b2++;
	}
	if(b1 == 0)
	{
		cout << -1;
		return 0;
	}
	cout << b2 / b1 + 1;
#ifdef _DEBUG
	system("pause");
#endif
	return 0;
}