//{
#ifndef _LOCAL
#pragma GCC optimize("-O3")
#endif // _LOCAL
#include <bits/stdc++.h>
using namespace std;
#define fr(i, n) for(int i = 0; i < n; ++i)
#define fo(n) fr(i, n)
#define re return
#define ef else if
#define hlt exit(0)
#define clr(x, y) memset(x, y, sizeof(x))
#define ifn(x) if(!(x))
#define pb push_back
#define eb emplace_back

#define sz(x) int((x).size())
#define ip2(x) (1 << (x))
#define lp2(x) (1ll << (x))
#define bnd(x) (x).begin(), (x).end()

#define ve vector
#define ft first
#define sd second

typedef ve<int> vi;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

inline ll time() {re chrono :: system_clock().now().time_since_epoch().count();}
mt19937 rnd(time());
mt19937_64 llrnd(time());

template<typename t> inline void umin(t &a, t b) {a = min(a, b);}
template<typename t> inline void umax(t &a, t b) {a = max(a, b);}
//}

const int N = 2e5 + 5;
const int oo = 1e9;
const int md = 998244353;
const int A = 26;
const int M = 1e6;

int n, m, p;
pii a[N];
int c[M + 5];

struct tree {
    tree *l, *r;
    int v, p;
    tree(int tl = 1, int tr = M): l(r = 0), v(c[tl]), p(0) {
        if(tl < tr) {
            int tm = (tl + tr) >> 1;
            l = new tree(tl, tm);
            r = new tree(tm + 1, tr);
            v = max(l -> v, r -> v);
        }
    }
    void push() {
        ifn(p) re;
        if(l) l -> p += p, r -> p += p;
        v += p;
        p = 0;
    }
    void add(int ql, int qr, int c, int tl = 1, int tr = M) {
        if(ql > qr) {push(); re;}
        if(ql == tl && qr == tr) {p += c; push(); re;}
        push();
        int tm = (tl + tr) >> 1;
        l -> add(ql, min(qr, tm), c, tl, tm);
        r -> add(max(tm + 1, ql), qr, c, tm + 1, tr);
        v = max(l -> v, r -> v);
    }
};

struct monster {
    int atc, def, cst;
    monster() {
        cin >> def >> atc >> cst;
    }
    inline bool operator< (const monster &f) const {re def < f.def;}
};

ve<monster> z;

void solve() {
    cin >> n >> m >> p;
    fo(n) cin >> a[i].ft >> a[i].sd;
    fo(M) c[i + 1] = -2 * oo;
    fo(m) {
        int v, C;
        cin >> v >> C;
        umax(c[v - 1], -C);
    }
    for(int i = M - 1; ~i; --i) umax(c[i], c[i + 1]);
    z.clear();
    fo(p) z.pb(*new monster());
    sort(bnd(z));
    sort(a, a + n);
    ve<monster> :: iterator it = z.begin();
    int ans = -oo * 2;
    tree *t = new tree();
    fo(n) {
        ll f = -a[i].sd;
        for(; it != z.end() && it -> def < a[i].ft; ++it)
            t -> add(it -> atc, M, it -> cst);
        f += t -> v;
        if(f > ans) ans = f;
    }
    cout << ans << endl;
}

int main() {
#ifdef _LOCAL
    freopen("in.txt", "r", stdin);
    int tt; cin >> tt;
    for(int i = 1; i <= tt; ++i) {
        cerr << "test #" << i << endl;
        solve();
    }
#else
    ios_base :: sync_with_stdio(0); cin.tie(0); cout.tie(0);
    solve();
#endif
}
