#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <random>
#include <queue>

using namespace std;

#define int long long
#define ld long double
#define pt pair<int, int>
#define x first
#define y second
#define endl '\n'
#define ok cerr << "ok" << endl;

const int N = 2e5 + 5;

vector<int> g[N], gr[N];
int p[N], d[N];
bool used[N];
int n, m, s, f, l;
int a = 0, b = 0;

void bfs()
{
	for (int i = 0; i < N; ++i)
	{
		used[i] = 0;
		d[i] = 1e9;
	}

	queue<int> q;
	q.push(f);
	d[f] = 0;
	while (q.size() > 0)
	{
		int v = q.front();
		q.pop();
		for (int i = 0; i < gr[v].size(); ++i)
		{
			int to = gr[v][i];
			if (!used[to])
			{
				used[to] = 1;
				if (to != s) q.push(to);
				d[to] = d[v] + 1;
			}
		}
	}
}

void dfs(int cnt = 0)
{
	int v = p[cnt++];
	if (v == f) return;

	int best = 1e9, next = d[p[cnt]];
	for (int i = 0; i < g[v].size(); ++i)
	{
		int to = g[v][i];
		if (to != p[cnt]) best = min(best, d[to]);
	}

	if (g[v].size() == 1)
	{
		dfs(cnt);
		return;
	}

	if (best < next)
	{
		++a;
		++b;
	}

	if (best == next) ++b;
	dfs(cnt);
}

signed main()
{
	cin.tie(0), cout.tie(0), ios::sync_with_stdio(0);

	cin >> n >> m;
	for (int i = 0, x, y; i < m; ++i)
	{
		cin >> x >> y;
		--x, --y;
		g[x].push_back(y);
		gr[y].push_back(x);
	}

	cin >> l;
	for (int i = 0; i < l; ++i)
	{
		cin >> p[i];
		--p[i];
	}

	s = p[0];
	f = p[l - 1];

	bfs();
	dfs();
	cout << a << " " << b << endl;
	//system("pause");

	return 0;
}