#include <bits/stdc++.h>

using namespace std;

#define int long long
#define left left228
#define right right228
#define next next228
#define y1 y1228
#define y2 y2228

template<typename T> void uin(T &a, T b) {
	if (b < a) a = b;
}
template<typename T> void uax(T &a, T b) {
	if (b > a) a = b;
}

const int N = 228228;
const int INF = 1e17 + 3;

int a[N], b[N], ca[N], cb[N], x[N], y[N], z[N];
vector<int> order;

struct node
{
	int mx, mod;
	int l, r;
	node() {
		mx = mod = l = r = 0;
	}
};
vector< node > d;
void build(int l, int r, int v = 1) {
	d[v].l = l;
	d[v].r = r;
	if (l == r) {
		d[v].mx = -ca[order[l - 1]];
		return ;
	}
	int m = (l + r) >> 1;
	build(l, m, v << 1);
	build(m + 1, r, v << 1 | 1);
	d[v].mx = max(d[v << 1].mx, d[v << 1 | 1].mx);
}
int gets(int v) {
	return d[v].mx + d[v].mod;
}
void push(int v) {
	d[v << 1].mod += d[v].mod;
	d[v << 1 | 1].mod += d[v].mod;
	d[v].mod = 0;
	d[v].mx = max(gets(v << 1), gets(v << 1 | 1));
}
void update(int l, int r, int x, int v = 1) {
	if (l > r || d[v].l > r || d[v].r < l) return;
	if (l <= d[v].l && d[v].r <= r) {
		d[v].mx += x;
		return;
	}
	push(v);
	update(l, r, x, v << 1);
	update(l, r, x, v << 1 | 1);
	d[v].mx = max(gets(v << 1), gets(v << 1 | 1));
}
int get(int l, int r, int v = 1) {
	if (l > r || d[v].l > r || d[v].r < l) return -INF;
	if (l <= d[v].l && d[v].r <= r) return gets(v);
	push(v);
	return max(get(l, r, v << 1), get(l, r, v << 1 | 1));
}
void init(int _n) {
	int ss = 1;
	while (ss < _n) ss <<= 1;
	ss <<= 1;
	d.resize(ss + 3, node());
	build(1, _n);
}
signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int n, m, p;
	cin >> n >> m >> p;
	for (int i = 1; i <= n; ++i) {
		cin >> a[i] >> ca[i];
		order.push_back(i);
	}
	vector<int> br;
	for (int i = 1; i <= m; ++i) {
		cin >> b[i] >> cb[i];
		br.push_back(i);
	}
	sort(br.begin(), br.end(), [&] (int i, int j) {
		return b[i] < b[j];
	});
	vector<int> kek;
	for (int i = 1; i <= p; ++i) {
		cin >> x[i] >> y[i] >> z[i];
		kek.emplace_back(i);
	}
	sort(kek.begin(), kek.end(), [&] (int i, int j) {
		return y[i] < y[j];
	});
	sort(order.begin(), order.end(), [&] (int i, int j) {
		return a[i] < a[j];
	});
	init(n);
	int ptr = -1;
	int res = -INF;
	for (int bron : br) {
		while (ptr + 1 < p && y[kek[ptr + 1]] < b[bron]) {
			++ptr;
			int l = -1, r = n - 1;
			while (r - l > 1) {
				int mid = (l + r) >> 1;
				if (x[kek[ptr]] < a[order[mid]]) r = mid;
				else l = mid;
			}
			if (x[kek[ptr]] < a[order[r]]) {
				update(r + 1, n, z[kek[ptr]]);
			}
		}
		uax(res, -cb[bron] + get(1, n));
	}
	cout << res << endl;
	return 0;
}