#include <bits/stdc++.h>

using namespace std;

#define int long long
#define left left228
#define right right228
#define next next228
#define y1 y1228
#define y2 y2228

template<typename T> void uin(T &a, T b) {
	if (b < a) a = b;
}
template<typename T> void uax(T &a, T b) {
	if (b > a) a = b;
}

const int N = 228228;
const int BASE = 141, MOD = 2286661337;

int n, m;
int t[N], pref[N];
int gor[N];
int gol[N];
int pf[N];
int h[N], base[N];
vector<int> blocks;

int get(int l, int r) {
	int cnt = 0;
	if (t[l]) {
		if ((gor[l] - l) & 1) ++cnt;
		l = gor[l];
	}
	if (t[r]) {
		if ((r - gol[r]) & 1) ++cnt;
		r = gol[r];
	}
	cnt += upper_bound(blocks.begin(), blocks.end(), r) - lower_bound(blocks.begin(), blocks.end(), l);
	return cnt;
}

int more(int l, int r) {
	return pf[r - 1] - pf[l - 1];
}

int mod(int x) {
	x %= MOD;
	if (x < 0) x += MOD;
	return x;
}

int get_hash(int l, int r) {
	return mod(h[r] - h[l - 1] * base[r - l + 1]);
}

void pre() {
	base[0] = 1;
	for (int i = 1; i <= n; ++i) {
		base[i] = (base[i - 1] * BASE) % MOD;
	}
	for (int i = 1; i <= n; ++i) {
		h[i] = (h[i - 1] * BASE + t[i] + 1);
	}
	int i = 1;
	while (i <= n) {
		if (t[i] == 0) {
			++i;
			continue;
		}
		int j = i;
		while (j <= n && t[j + 1]) ++j;
		if ((j - i + 1) & 1) blocks.push_back(i);
		i = j + 1;
	}
	for (int i = 1; i <= n; ++i) {
		if (t[i] == 0) gol[i] = i;
		else gol[i] = gol[i - 1];
	}
	gor[n + 1] = n + 1;
	for (int i = n; i; --i) {
		if (t[i] == 0) gor[i] = i;
		else gor[i] = gor[i + 1];
	}
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> n;
	for (int i = 1; i <= n; ++i) {
		char C;
		cin >> C;
		t[i] = C - '0';
		pref[i] = pref[i - 1] + t[i];
	}
	for (int i = 1; i < n; ++i) {
		pf[i] = pf[i - 1];
		if (t[i] && t[i + 1]) pf[i]++;
	}
	pre();
	cin >> m;
	while(m--) {
		int l1, l2, len;
		cin >> l1 >> l2 >> len;
		int r1 = l1 + len - 1;
		int r2 = l2 + len - 1;
		if (get_hash(l1, r1) == get_hash(l2, r2)) {
			cout << "Yes\n";
			continue;
		}
		if (pref[r1] - pref[l1 - 1] == pref[r2] - pref[l2 - 1]) {
			if (get(l1, r1) == get(l2, r2) && more(l1, r1) && more(l2, r2)) {
				cout << "Yes\n";
				continue;
			}
		}
		cout << "No\n";
	}
	return 0;
}