// #pragma GCC optimize("O3", "fast-math", "unroll-loops")
// #pragma GCC target("sse", "sse2", "avx", "avx2", "popcnt")
#include<bits/stdc++.h>


using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

#define int long long
#define F first
#define S second
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

#define endl '\n'

const int inf = 1e18;
const ull K = 47;
const int mod = 1e9 + 7;
const int N = 2e5 + 5;

void accell() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
}
int t[4 * N];
int add[4 * N];

vector<pair<int, int> > a, b;

vector<pair<int, int> >mon[5 * N];
vector<int>pr[5 * N];


void build(int v, int tl, int tr) {
    if (tl == tr) {
        t[v] = -b[tl].S;
        return;
    }
    int tm = tl + tr >> 1;
    build(2 * v, tl, tm);
    build(2 * v + 1, tm + 1, tr);
    t[v] = max(t[2 * v], t[2 * v + 1]);
}
void push(int v) {
    t[2 * v] += add[v];
    t[2 * v + 1] += add[v];
    add[2 * v] += add[v];
    add[2 * v + 1] += add[v];
    add[v] = 0;
}
void modify(int v, int tl, int tr, int l, int r, int val) {
    if (tl > r || tr < l)
        return;
    if (l <= tl && tr <= r) {
        add[v] += val;
        t[v] += val;
        return;
    }
    push(v);
    int tm = tl + tr >> 1;
    modify(2 * v, tl, tm, l, r, val);
    modify(2 * v + 1, tm + 1, tr, l, r, val);
    t[v] = max(t[2 * v], t[2 * v + 1]);
}
void out(int v, int tl, int tr) {
    if (tl == tr)
        cout << t[v] << ' ';
    else {
        int tm = tl + tr >> 1;
        push(v);
        out(2 * v, tl, tm); out(2 * v + 1, tm + 1, tr);
    }
}


signed main() {
    accell();
    int n, m, p;
    cin >> n >> m >> p;
    a.resize(n), b.resize(m);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first >> a[i].second;
        pr[a[i].F].push_back(a[i].S);
    }
    for (int i = 0; i < m; ++i)
        cin >> b[i].first >> b[i].second;
    sort(all(a));
    sort(all(b));
    build(1, 0, m - 1);
    int ans = -inf;
    for (int i = 0; i < p; ++i) {
        int x, y, z;
        cin >> x >> y >> z;
        mon[x].push_back({y, z});
    }
    for (int i = 0; i < 5 * N; ++i) {
        for (auto it : pr[i]) {
            int cur = it;
            // cout << cur << ' ' << t[1] << ' ' << i << endl;
            ans = max(ans, t[1] - cur);
        }
        for (auto it : mon[i]) {
            int yy = it.F;
            pair<int, int>ff{yy, 1e18};
            int id = upper_bound(all(b), ff) - b.begin();
            // cout << id << ' ' << yy << endl;
            modify(1, 0, m - 1, id, m - 1, it.S);
        }
    }
    cout << ans;
    return 0;
}
/*



*/

