#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
using namespace std;
typedef long long ll;
typedef long double ld;
#define X first
#define Y second
#define pb push_back
#define sz(a) (int)a.size()
using ord = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

void solve();

signed main() {
#ifdef ONPC
    freopen("in.txt", "r", stdin);
#endif // ONPC
    ios_base::sync_with_stdio(0), cin.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) solve();
    return 0;
}

#define int ll
const int N = 2e5 + 5;
int n, m, p, pref[N], d[5 * N], ans, psh[5 * N];
pair<int, int> a[N], b[N];

void build(int rt, int l, int r) {
    if (l == r - 1) {
        d[rt] = -b[l].Y;
        return;
    }
    build(rt + rt, l, (l + r) / 2);
    build(rt + rt + 1, (l + r) / 2, r);
    d[rt] = max(d[rt + rt], d[rt + rt + 1]);
}

void push(int rt) {
    d[rt] += psh[rt];
    psh[rt + rt] += psh[rt];
    psh[rt + rt + 1] += psh[rt];
    psh[rt] = 0;
}

void upd(int rt, int l, int r, int lq, int rq, int add) {
    push(rt);
    if (rq <= l || lq >= r) return;
    if (lq <= l && r <= rq) {
        psh[rt] += add;
        push(rt);
        return;
    }
    upd(rt + rt, l, (l + r) / 2, lq, rq, add);
    upd(rt + rt + 1, (l + r) / 2, r, lq, rq, add);
    d[rt] = max(d[rt + rt], d[rt + rt + 1]);
}

void solve() {
    cin >> n >> m >> p;
    ans = -1e18;
    int mnx = 1e18;
    int mny = 1e18;
    for (int i = 1; i <= n; ++i) {
        cin >> a[i].X >> a[i].Y;
        mnx = min(mnx, a[i].Y);
    }
    for (int i = 1; i <= m; ++i) {
        cin >> b[i].X >> b[i].Y;
        mny = min(mny, b[i].Y);
    }
    ans = -(mnx + mny);
    build(1, 1, m + 1);
    sort(a + 1, a + n + 1);
    pref[n] = a[n].Y;
    for (int i = n - 1; i >= 1; --i) {
        pref[i] = min(pref[i + 1], a[i].Y);
    }
    sort(b + 1, b + m + 1);
    vector<pair<int, pair<int, int>>> v;
    for (int i = 1; i <= p; ++i) {
        int x, y, z;
        cin >> x >> y >> z;
        v.pb({x, {y, z}});
    }
    sort(v.begin(), v.end());
    int uk = 1;
    for (auto dd : v) {
        while (uk <= n && a[uk].X  <= dd.X) ++uk;
        if (uk == n + 1) break;
        int lef = 0, rig = m + 1;
        while (rig - lef > 1) {
            int mid = (lef + rig) / 2;
            if (b[mid].X <= dd.Y.X) {
                lef = mid;
            } else {
                rig = mid;
            }
        }
        if (rig == m + 1) {
            continue;
        }
        upd(1, 1, m + 1, rig, m + 1, dd.Y.Y);
//        cout << dd.X << ' ' << dd.Y.X << ' ' << dd.Y.Y << ' ' << pref[uk] << ' ' << d[1] - pref[uk] << '\n';
        ans = max(ans, d[1] - pref[uk]);
    }
    cout << ans;
}
//order_of_key
//find_by_order
//chrono::system_clock::now().time_since_epoch().count()
