#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
using namespace std;
typedef long long ll;
typedef long double ld;
#define X first
#define Y second
#define pb push_back
#define sz(a) (int)a.size()
using ord = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

void solve();

signed main() {
#ifdef ONPC
    freopen("in.txt", "r", stdin);
#endif // ONPC
    ios_base::sync_with_stdio(0), cin.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) solve();
    return 0;
}

const int N = 2e5 + 5;
const ll mod = 1e9 + 7;
const ll p = 31;
int a[N], pref[N], n, pref2[N];
ll pw[N], hsh[N];

ll get(int l, int r) {
    return (hsh[r] - hsh[l - 1] + mod) % mod;
}

void solve() {
    cin >> n;
    for (int i = 1; i <= n; ++i) {
        char c;
        cin >> c;
        a[i] = c - '0';
        pref[i] = pref[i - 1] + a[i];
        pref2[i] = pref2[i - 1] + (a[i] && a[i] == a[i - 1]);
    }
    pw[0] = 1;
    for (int i = 1; i < N; ++i) {
        pw[i] = pw[i - 1] * p % mod;
    }
    for (int i = 1; i <= n; ++i) {
        hsh[i] = (hsh[i - 1] + (a[i] + 1) * pw[i - 1] % mod) % mod;
    }
    int q;
    cin >> q;
    for (int i = 1; i <= q; ++i) {
        int l1, l2, len;
        cin >> l1 >> l2 >> len;
        int r1 = l1 + len - 1, r2 = l2 + len - 1;
        if (pref[r1] - pref[l1 - 1] != pref[r2] - pref[l2 - 1]) {
            cout << "No\n";
            continue;
        }
        if (get(l1, r1) * pw[l2] % mod == get(l2, r2) * pw[l1] % mod) {
            cout << "Yes\n";
            continue;
        }
        if (pref2[r1] - pref2[l1] == 0) {
            cout << "No\n";
            continue;
        }
        if (pref2[r2] - pref2[l2] == 0) {
            cout << "No\n";
            continue;
        }
/*        if (pref2[r1] - pref2[l1] != pref2[r2] - pref2[l2]) {
            cout << "No\n";

            continue;
        }*/
        int zer = len - (pref[r1] - pref[l1 - 1]);
        if (abs(pref2[r1] - pref2[l1] - (pref2[r2] - pref2[l2])) > zer) {
            cout << "No\n";
            continue;
        }
        cout << "Yes\n";
    }
}
//order_of_key
//find_by_order
//chrono::system_clock::now().time_since_epoch().count()

