#include <bits/stdc++.h>

#define int long long

using namespace std;


#define file(s) freopen(s".in", "r", stdin); freopen(s".out", "w", stdout);
#define all(x) x.begin(), x.end()
#define sz(s) (int)s.size()
#define pb push_back
#define ppb pop_back
#define mp make_pair
#define s second
#define f first


typedef long long ll;
typedef vector < int > vi;
typedef pair < int, int > pii;
typedef vector < pair < int, int > > vpii;


const int N = 1e6 + 11, inf = 1e9, mod = 1e9 + 7;
const ll INF = 1e18;


int n, m, p, t[N << 2], add[N << 2];
pair < pii, int > c[N];
pii a[N], b[N];

void push (int v) {
	if (add[v]) {
		add[v << 1] += add[v];
		add[v << 1 | 1] += add[v];
		t[v << 1] += add[v];
		t[v << 1 | 1] += add[v];
		add[v] = 0;
	}	
}

void update (int l, int r, int x, int v = 1, int tl = 1, int tr = N - 1) {
    if (l > r || tl > r || l > tr)
    	return;
	if (l <= tl && tr <= r) {
		t[v] += x;
		add[v] += x;
		return;      
	}	

	int tm = (tl + tr) >> 1;
	push(v);

	update(l, r, x, v << 1, tl, tm);
	update(l, r, x, v << 1 | 1, tm + 1, tr);

	t[v] = max(t[v << 1], t[v << 1 | 1]);		
}

int get (int l, int r, int v =  1, int tl = 1, int tr = N - 1) {
	if (l > r || l > tr || tl > r)
		return -INF;
	if (l <= tl && tr <= r)
		return t[v];

	push(v);
	int tm = (tl + tr) >> 1;
	return max(get(l, r, v << 1, tl, tm), get(l, r, v << 1 | 1, tm + 1, tr));
}




main () {	
	scanf("%lld%lld%lld", &n, &m, &p);	
	for (int i = 1; i <= n; ++i) 
		scanf("%lld%lld", &a[i].f, &a[i].s);

	for (int j = 1; j <= m; ++j) 	
		scanf("%lld%lld", &b[j].f, &b[j].s);

	sort(a + 1, a + 1 + n);
	sort(b + 1, b + 1 + m);	
	
	for (int i = m; i > 0;) {
		int j = i, mn = i == m ? INF : b[i + 1].s;
		while (j > 0 && b[j].f == b[i].f) {
			mn = min(mn, b[j].s);
			--j;
		}

		for (int x = j + 1; x <= i; ++x)
			b[x].s = mn;

		i = j;
	}

	for (int i = 1; i <= p; ++i)
		scanf("%lld%lld%lld", &c[i].f.f, &c[i].f.s, &c[i].s);	

	sort(c + 1, c + 1 + p);

	int ans = 0, j = 1;
	
	for (int i = 1; i <= m; ++i)	
		update(b[i - 1].f + 1, b[i].f, -b[i].s);  

	update(b[m].f + 1, N - 1, -INF);

	for (int i = 1; i <= n; ++i) {
		while (j <= p && c[j].f.f < a[i].f) {
			update(c[j].f.s + 1, N - 1, c[j].s);
			++j;
		}	

		ans = max(ans, t[1] - a[i].s);
	}
	cout << ans << endl;
}