#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
//#define int ll

const int N = 2e5 + 5;
const int Inf = 1e9 + 7;

void io()
{
	ios_base::sync_with_stdio(0);
	cin.tie(NULL);
	cout.tie(NULL);
	cerr.tie(NULL);
}

int n, m, k, s, t, dist[N];
vector<int> g[N], gr[N];
int ans = 0, ans2 = 0, a[N];
bool best[N];

void fld()
{
	dist[t] = 0;
	set<pair<int, int>> s;
	for (int i = 0; i < n; ++i)
	{
		if (i != t)
		s.insert({Inf, i});
	}
	s.insert({0, t});
	while (s.size())
	{
		auto para = *s.begin();
		s.erase(s.begin());
		int v = para.second;
		for (int to: gr[v])
		{
			if (dist[to] > dist[v] + 1)
			{
				s.erase({dist[to], to});
				dist[to] = dist[v] + 1;
				s.insert({dist[to], to});
			}
		}
	}
	for (int i = 0; i < n; ++i)
	{
		if (i == t)
			continue;
		int mn1 = Inf, mn2 = Inf;
		for (int to: g[i])
		{
			if (dist[to] < mn1)
			{
				mn2 = mn1;
				mn1 = dist[to];
			}
			else if (dist[to] < mn2)
			{
				mn2 = dist[to];
			}
		}
		if (mn1 == mn2 && mn1 != Inf)
		{
			best[i] = 1;
		}
	}
}

signed main()
{
	io();
	cin >> n >> m;
	for (int i = 0; i < n; ++i)
		dist[i] = Inf;
	for (int i = 0; i < m; ++i)
	{
		int x, y;
		cin >> x >> y;
		--x; --y;
		g[x].push_back(y);
		gr[y].push_back(x);
	}
	cin >> k;
	for (int i = 0; i < k; ++i)
	{
		cin >> a[i];
		--a[i];
	}
	s = a[0];
	t = a[k - 1];
	fld();
	for (int i = 0; i < k - 1; ++i)
	{
		if (best[a[i]] || dist[a[i]] <= dist[a[i + 1]])
			++ans;
		if (dist[a[i + 1]] >= dist[a[i]])
			++ans2;
	}
	cout << ans2 << ' ' << ans;
}
