#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <fstream>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <random>
#include <ctime>
#include <list>
#include <queue>
#include <stack>
#include <string>

using namespace std;

typedef long long ll;

mt19937 ran(time(0));

ll mod = 1000012121;
ll inf = 2e18;

int n, m;
int k;
vector<int>p;
vector<vector<int>>g;
vector<ll>dist;
vector<bool>used;
queue<pair<int, int>>q;
vector<int>how;

int main(){
	cin.tie(0);
	cout.tie(0);
	ios_base::sync_with_stdio(0);
	cin>>n>>m;
	g.resize(n);
	used.resize(n, false);
	int u, v;
	dist.resize(n, -1);
	how.resize(n);
	for(int i = 0; i < m ;i++){
		cin>>u>>v;
		u--;
		v--;
		g[v].push_back(u);
	}
	cin>>k;
	p.resize(k);
	for(int i = 0; i < k; i++){
		cin>>p[i];
		p[i]--;
	}
	q.push(make_pair(p[k-1], 0));
	used[p[k-1]] = 1;
	int cur, d;
	dist[p[k-1]] = 0;
	while(!q.empty()){
		cur = q.front().first;
		d = q.front().second;
		q.pop();
		for(int i = 0; i < g[cur].size(); i++){
			v = g[cur][i];
			if(!used[v] || dist[v] == d + 1){
				how[v]++;
			}
			if(!used[v]){
				used[v] = true;
				dist[v] = d + 1;
				q.push(make_pair(v, d + 1));
			}
		}
	}
	ll ma = 0, mi = 0;
	how[p[k-1]] = 1;
	for(int i = 1; i < k; i++){
		if(dist[p[i]] == dist[p[i-1]]){
			mi++;
			ma++;
		}
		else if (dist[p[i]] < dist[p[i-1]] && how[p[i-1]] > 1){
			ma++;
		}
		else if (dist[p[i]] > dist[p[i-1]] && 1 < how[p[i]]){
			ma++;
		}
	}
	cout<<mi<<" "<<ma;
	//system("pause>nul");
	return 0;
}