#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

const int MAXN = 105;
const ll INF = 1e18;

int n;
string s;

int dp[MAXN][MAXN][26][26];

void fill() {
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			for (int q = 0; q < 26; ++q) {
				for (int k = 0; k < 26; ++k) {
					dp[i][j][q][k] = -1;
				}
			}
		}
	}
}

void solve() {
	fill();
	for (int i = 0; i < n; ++i) {
		dp[i][i][s[i] - 'a'][s[i] - 'a'] = 0;
		if (i < n - 1) {
			dp[i][i + 1][s[i] - 'a'][s[i + 1] - 'a'] = 0;
			if (s[i] - s[i + 1] == 1) {
				dp[i][i + 1][s[i] - 'a'][s[i] - 'a'] = 1;
			} 
			if (s[i + 1] - s[i] == 1) {
				dp[i][i + 1][s[i + 1] - 'a'][s[i + 1] - 'a'] = 1;
			}	
		}
	}
	for (int len = 3; len <= n; ++len) {
		for (int l = 0; l + len - 1 < n; ++l) {
			int r = l + len - 1;
			int num1 = s[l] - 'a';
			int num2 = s[r] - 'a';
			dp[l][r][num1][num2] = 0;
			for (int a = 0; a < 26; ++a) {
				for (int b = 0; b < 26; ++b) {
					if (dp[l + 1][r - 1][a][b] == -1) continue;
					dp[l][r][num1][num2] = max(dp[l][r][num1][num2], dp[l + 1][r - 1][a][b]);
					cout << "ab: " << a << ' ' << b << endl;
					cout << "L: " << l << ' ' << r << ' ' << dp[l][r][num1][num2] << endl;
					int left = num1, right = num2;
					int adding = 0;
					if (left + 1 == a) ++adding;
					if (a + 1 == left) {
						left = a;
						++adding;
					}
					if (r - l - 1 - dp[l + 1][r - 1][a][b] != 1 || left == a) {
						if (right + 1 == b) ++adding;
						if (b + 1 == right) {
							++adding;
							right = b;
						}
					}
					dp[l][r][left][right] = max(dp[l][r][left][right], dp[l + 1][r - 1][a][b] + adding); 
					cout << "lr: " << l << ' ' << r << ' ' << left << ' ' << right << ' ' << dp[l][r][left][right] << endl; 
				}
			}
		}
	}
	int ans = 0;
	for (int a = 0; a < 26; ++a) {
		for (int b = 0; b < 26; ++b) {
			ans = max(ans, dp[0][n - 1][a][b]);
		}
	}
	cout << ans << endl;
}

void solve1() {
	string curs = s;
	while (true) {
		int maxnum = -1;
		int pos = -1;
		if (curs.size() == 1) break;
		if (curs[1] - curs[0] == -1) {
			maxnum = curs[0] - 'a';
			pos = 0;
		}
		if (curs[curs.size() - 2] - curs.back() == -1) {
			if (maxnum < curs.back() - 'a') {
				maxnum = curs.back() - 'a';
				pos = curs.size() - 1;
			}
		}
		for (int i = 1; i < curs.size() - 1; ++i) {
			if (curs[i - 1] - curs[i] == -1 || curs[i + 1] - curs[i] == -1) {
				if (maxnum < curs[i] - 'a') {
					maxnum = curs[i] - 'a';
					pos = i;
				}
			}
		}
		if (pos == -1) break;
		string news = "";
		//cout << "deL: " << pos << endl;
		for (int i = 0; i < curs.size(); ++i) {
			if (pos == i) continue;
			news += curs[i];
		}
		curs = news;
		//cout << "news: " << curs << endl;
	}
	//cout << curs << endl;
	cout << n - int(curs.size()) << endl;
}

int main() {
	cin >> n;
	cin >> s;
	solve1();
	return 0;
}
