#include <bits/stdc++.h>

using namespace std;

const int NN = 1024 * 1024 * 2;

const int N = NN / 4;

vector<int> st(NN, 0);
vector<int> plus_st(NN, 0);

void st_add(int v, int pos) {
    pos += N;
    while (pos > 0) {
        st[pos] += v;
    }
}



void push(int node) {
    plus_st[node * 2] += plus_st[node];
    plus_st[node * 2 + 1] += plus_st[node];
    plus_st[node] = 0;
}

int st_get_(int node, int l, int r, int tl, int tr) {
    if (tl >= r || l >= tr || tl >= tr) {
        return 0;
    }

    if (tl <= l && r <= tr) {
        return st[node] + plus_st[node];
    }
    int m = (tl + tr) / 2;
    push(node);
    return max(st_get_(node * 2, l, r, tl, m), st_get_(node * 2 + 1, l, r, m, tr));
}

int st_get(int l, int r) {
    return st_get_(1, l, r, 0, N);
}


int st_add_seg_(int node, int l, int r, int tl, int tr, int add) {
    if (tl >= r || l >= tr || tl >= tr) {
        return 0;
    }

    if (tl <= l && r <= tr) {
        return plus_st[node] += add;
    }
    int m = (tl + tr) / 2;
    return max(st_add_seg_(node * 2, l, r, tl, m, add), st_add_seg_(node * 2 + 1, l, r, m, tr, add));
}

signed main()
{
    int n, m, p;
    cin >> n >> m >> p;

    vector<pair<int, int> > wep_raw;
    vector<pair<int, int> > wep;

    for (int i = 0; i < n; ++i) {
        int a, ca;
        cin >>a >> ca;
        wep_raw.push_back(make_pair(a, ca));
    }

    sort(wep_raw.begin(), wep_raw.end());

    for (int i = 0; i < n; ++i) {
        while (!wep.empty() && wep[wep.size() - 1].second >= wep_raw[i].second) {
            wep.pop_back();
        }
        wep.push_back(wep_raw[i]);
    }

    vector<pair<int, int> > arm_raw;
    vector<pair<int, int> > arm;

    for (int i = 0; i < m; ++i) {
        int b, cb;
        cin >>b >> cb;
        wep_raw.push_back(make_pair(b, cb));
    }

    sort(arm_raw.begin(), arm_raw.end());

    for (int i = 0; i < m; ++i) {
        while (!arm.empty() && arm[arm.size() - 1].second >= arm_raw[i].second) {
            arm.pop_back();
        }
        arm.push_back(arm_raw[i]);
        if (i == 0) {
            st_add_seg_(1, arm.size() - 1, N, 0, N, -arm[arm.size() - 1].first);
        } else {
            st_add_seg_(1, arm.size() - 1, N, 0, N, arm[arm.size() - 2].first-arm[arm.size() - 1].first);
        }
    }
    n = wep.size();
    m = arm.size();
    vector<pair<pair<int, int>, int> > monst;

    for (int i = 0; i < p; ++i) {
        int x, y, z;
        cin >> x  >> y >> z;
        monst.push_back(make_pair(make_pair(x, y), z));
    }
    sort(monst.begin(), monst.end());

    int monst_h = 0;
    int res = -2000000000;
    for (int cur_weapon = 0; cur_weapon < n; ++cur_weapon) {
        while (monst_h < p && monst[monst_h].first.first < wep[cur_weapon].first) {
            int need_def = monst[monst_h].first.second;
            int l = 0;
            int r = m;
            while (r - l > 1) {
                int midd = (l + r) / 2;
                if (arm[midd].first > need_def) {
                    r = midd;
                } else {
                    l = midd;
                }
            }

            st_add_seg_(1, r, m, 0, N, monst[monst_h].second);
            monst_h++;
        }

        res = max(res, st_get(0, N));
    }
    cout << res;

    return 0;
}
