#include <bits/stdc++.h>
#pragma GCC target "avx,avx2"

using namespace std;

const int MAX_N = 2 * 1e5 + 42;
vector < int > gr[MAX_N];
vector < int > rev_gr[MAX_N];
int p[MAX_N];
int dist[MAX_N];
const int INF = 1e6 + 42;

void bfs(int start) {
    dist[start] = 0;
    queue < int > q;
    q.push(start);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (auto u : rev_gr[v]) {
            if (dist[u] < dist[v] + 1) {
                continue;
            }
            dist[u] = dist[v] + 1;
            q.push(u);
        }
    }
}

signed main() {
    //freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int v, u;
        cin >> v >> u;
        v--;
        u--;
        gr[v].push_back(u);
        rev_gr[u].push_back(v);
    }
    int k;
    cin >> k;
    for (int i = 0; i < k; i++) {
        cin >> p[i];
        p[i]--;
    }
    fill(dist, dist + n, INF);
    bfs(p[k - 1]);
    int mn = 0;
    for (int i = 0; i < k - 1; i++) {
        int v = p[i];
        int u = p[i + 1];
        if (dist[v] != dist[u] + 1) {
            mn++;
        }
    }
    int mx = 0;
    for (int i = 0; i < k - 1; i++) {
        int v = p[i];
        int u = p[i + 1];
        int c = -1;
        for (auto x : gr[v]) {
            if (x == u) {
                continue;
            }
            if (dist[x] != dist[v] - 1) {
                continue;
            }
            c = x;
        }
        if (c != -1) {
            mx++;
        }
    }
    cout << mn << " " << mx;
    return 0;
}
