import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.StringTokenizer;
import java.util.TreeMap;

import static java.lang.Math.*;

public class Main {
    void run() throws IOException {
        int n = nextInt();
        char[] b = next().toCharArray();
        int[] a = new int[n];
        for (int i = 0; i < a.length; i++) {
            a[i] = b[i] - 'a' + 1;
        }
        int ans = 0;
        for (int i = 26; i > 0; i--) {
            for (int j = 0; j < a.length; j++) {
                if (a[j] == i) {
                    int pos_left = j - 1;
                    int pos_right = j + 1;
                    while (pos_left >= 0 && (a[pos_left] == -1 || a[pos_left] == i)) pos_left--;
                    while (pos_right < a.length && (a[pos_right] == -1 || a[pos_right] == i)) pos_right++;
                    if (pos_left >= 0 && a[pos_left] == i - 1) {
                        ans++;
                        a[j] = -1;
                    } else if (pos_right < a.length && a[pos_right] == i - 1) {
                        ans++;
                        a[j] = -1;
                    }
                }
            }
        }
        pw.print(ans);
        pw.close();
    }

    static BufferedReader br;
    static StringTokenizer st = new StringTokenizer("");
    static PrintWriter pw;

    public static String next() throws IOException {
        while (!st.hasMoreTokens()) st = new StringTokenizer(br.readLine());
        return st.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(next());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(next());
    }

    public static void main(String[] args) throws IOException {
        br = new BufferedReader(new InputStreamReader(System.in));
        pw = new PrintWriter(System.out);
        new Main().run();
    }

}
