#include <bits/stdc++.h>

using namespace std;
#define int long long
struct fenwick {
    int* arr;
    int n;
    fenwick(int n): arr(new int[n + 1]), n(n) {
        for (int i = 0; i <= n; i++) {
            arr[i] = 0;
        }
    }
    void upd(int x,int y) {
        for(int i = x; i <=n; i += (i & (-i))) {
            arr[i] += y;
        }
    }

    int get(int x) {
        int res = 0;
        for(int i = x; i > 0; i -= (i & (-i))) {
            res += arr[i];
        }
        return res;
    }
};

#define INF 2000000000
signed main() {
#ifdef ONLINE_JUDGE
#else
    freopen("input", "r", stdin);
    //freopen("output", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector<int> a(n);
    vector<int> b(n);
    for(int I = 0; I < n;I++){
        cin >> a[I];
    }
    for(int i = 0; i < n;i++){
        cin >> b[i];
    }
    vector<int> ans(n);
    bool flag = false;
    bool has = false;
    int balance = 0;
    for(int i = 0; i < n;i++){
        if(a[i]==b[i]){
            continue;
        }
        flag = 1;
        if(a[i]>b[i]){
            has = true;
            balance++;
        }else{
            balance--;
        }
    }
    if(!flag || !has){
        cout << -1;
    }else{
        if(balance>0){
            cout << 1;
        }else{
            cout <<-balance+2;
        }
    }

}
