#include <bits/stdc++.h>

using namespace std;
#define int long long
#define MAXN 200005

#define INF 2000000000
int t[MAXN * 4];
int p[MAXN * 4];

void push(int v,int l,int r){
    if(p[v]==0){
        return;
    }
    t[v]+=p[v];
    if(r-l==1){
        p[v] = 0;
        return;
    }
    p[v * 2] += p[v];
    p[v * 2 + 1] += p[v];
    p[v] = 0;
}
void build(int v,int l,int r,int* a){
    if(r - 1 == l){
        t[v] = a[l];
        return;
    }
    int m = (r + l) / 2;
    build(v * 2, l, m, a);
    build(v * 2 + 1, m, r, a);
    t[v] = max(t[v * 2], t[v * 2 +1]);
}
int calc(int v,int l, int r,int al,int ar){
    push(v,l,r);
    if(ar <= l || al >= r){
        return -INF;
    }
    if(al <= l && r <= ar){
        return t[v];
    }
    int m = (r + l) / 2;
    return max(
        calc(v * 2, l, m, al, ar),
        calc(v * 2 + 1, m, r, al, ar)
               );
}
void update(int v,int l, int r,int al,int ar,int x){
    push(v, l, r);
    if(ar <= l || al >= r){
        return;
    }
    if(al <= l && r <= ar){
        p[v] += x;
        push(v,l,r);
        return;
    }
    int m = (r + l) / 2;
    update(v * 2, l, m, al, ar,x);
    update(v * 2 + 1, m, r, al, ar,x);
    t[v] = max(t[v * 2], t[v * 2 +1]);
}

struct monstr{

    int x,y,z;
    monstr(int x=0,int y=0,int z=0):x(x),y(y),z(z){
    }

    const bool operator<(const monstr& rhs){
        return x < rhs.x;
    }
};

bool cmp(monstr a,monstr b){
    return a.x<b.x;
}

int* pse;
void build(int l,int r,int*a){
    pse = new int[r];
    for(int i = l; i < r; i++){
        pse[i] = a[i];
        //printf("%d ",a[i]);
    }
    //printf("\n");
}
void update(int l,int r,int al,int ar,int x){
    for(int i = al;i< ar;i++){
        pse[i] += x;
    }
}
int calc(int l,int r,int al,int ar){
    int ans = -INF;
    for(int i = al; i < ar; i++){
        ans = max(ans,pse[i]);
    }
    return ans;
}


signed main() {
#ifdef ONLINE_JUDGE
#else
    freopen("input", "r", stdin);
    //freopen("output", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector<int> a(n);
    for(int i = 0; i < n; i++){
        cin >> a[i];
    }
    vector<int> b(n);
    for(int i = 0; i <n;i++){
        cin >> b[i];
    }
    bool flag = false;
    int ans1 = 0;
    int ans2 =0;
    for(int i = 0; i < n; i++){
        if(a[i]==b[i]){
            continue;
        }
        if(a[i]>b[i]){
            flag = true;
            ans1++;
        }else{
            ans2++;
        }
    }
    if(!flag)
    {
        cout << -1;
        return 0;
    }
    cout << (ans2+1+ans1-1)/ans1;
}
