#include <bits/stdc++.h>

using namespace std;
#define int long long
struct fenwick {
    int* arr;
    int n;
    fenwick(int n): arr(new int[n + 1]), n(n) {
        for (int i = 0; i <= n; i++) {
            arr[i] = 0;
        }
    }
    void upd(int x,int y) {
        for(int i = x; i <=n; i += (i & (-i))) {
            arr[i] += y;
        }
    }

    int get(int x) {
        int res = 0;
        for(int i = x; i > 0; i -= (i & (-i))) {
            res += arr[i];
        }
        return res;
    }
};

#define INF 2000000000
signed main() {
#ifdef ONLINE_JUDGE
#else
    freopen("input", "r", stdin);
    //freopen("output", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    map<int, long long> mp;
    for(int i = 0; i <n;i++){
        int x;
        cin >> x;
        mp[x - i]+=x;
    }
    long long ans = 0;
    for(map<int,long long>::iterator it = mp.begin(); it!=mp.end(); it++){
        ans = max(ans, it->second);
    }
    cout << ans;

}
