#include <bits/stdc++.h>

using namespace std;
#define int long long
struct fenwick {
    int* arr;
    int n;
    fenwick(int n): arr(new int[n + 1]), n(n) {
        for (int i = 0; i <= n; i++) {
            arr[i] = 0;
        }
    }
    void upd(int x,int y) {
        for(int i = x; i <=n; i += (i & (-i))) {
            arr[i] += y;
        }
    }

    int get(int x) {
        int res = 0;
        for(int i = x; i > 0; i -= (i & (-i))) {
            res += arr[i];
        }
        return res;
    }
};

#define INF 2000000000
signed main() {
#ifdef ONLINE_JUDGE
#else
    freopen("input", "r", stdin);
    //freopen("output", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector<int> g[n];
    vector<int> gr[n];
    int m;
    cin >> m;
    for (int i= 0; i < m; i++){
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        g[a].push_back(b);
        gr[b].push_back(a);
    }
    int k;
    cin >> k;
    int go[k];
    for (int i = 0; i < k; i++) {
        cin >> go[i];
        go[i]--;
    }

    queue<int> q;
    q.push(go[k - 1]);
    int dist[n];
    memset(dist, 255, sizeof(dist));
    dist[go[k - 1]] = 0;
    while(!q.empty()){
        int top = q.front();
        q.pop();
        for(int j = 0; j < gr[top].size(); j++){
            int u = gr[top][j];
            if(dist[u] == -1){
                dist[u] = dist[top] + 1;
                q.push(u);
            }
        }
    }
    int ans_min = 0;
    int ans_max = 0;
    for (int i = 0; i < k - 1; i++){
        int v = go[i];
        int cnt = 0;
        for(int j = 0; j < g[v].size(); j++){
            int u = g[v][j];
            if(dist[u] == dist[v] - 1){
                cnt++;
            }
        }
        ans_max++;
        if(dist[go[i]] != dist[go[i + 1]] + 1){

            ans_min++;
        }else{
            if(cnt == 1){
                ans_max--;
            }
        }
    }
    cout << ans_min<<" "<<ans_max;
}