#include <bits/stdc++.h>

using namespace std;
#define int long long
#define MAXN 200005

#define INF 2000000000
int t[MAXN * 4];
int p[MAXN * 4];

void push(int v,int l,int r){
    if(p[v]==0){
        return;
    }
    t[v]+=p[v];
    if(r-l==1){
        p[v] = 0;
        return;
    }
    p[v * 2] += p[v];
    p[v * 2 + 1] += p[v];
    p[v] = 0;
}
void build(int v,int l,int r,int* a){
    if(r - 1 == l){
        t[v] = a[l];
        return;
    }
    int m = (r + l) / 2;
    build(v * 2, l, m, a);
    build(v * 2 + 1, m, r, a);
    t[v] = max(t[v * 2], t[v * 2 +1]);
}
int calc(int v,int l, int r,int al,int ar){
    push(v,l,r);
    if(ar <= l || al >= r){
        return -INF;
    }
    if(al <= l && r <= ar){
        return t[v];
    }
    int m = (r + l) / 2;
    return max(
        calc(v * 2, l, m, al, ar),
        calc(v * 2 + 1, m, r, al, ar)
               );
}
void update(int v,int l, int r,int al,int ar,int x){
    push(v, l, r);
    if(ar <= l || al >= r){
        return;
    }
    if(al <= l && r <= ar){
        p[v] += x;
        push(v,l,r);
        return;
    }
    int m = (r + l) / 2;
    update(v * 2, l, m, al, ar,x);
    update(v * 2 + 1, m, r, al, ar,x);
    t[v] = max(t[v * 2], t[v * 2 +1]);
}

struct monstr{

    int x,y,z;
    monstr(int x=0,int y=0,int z=0):x(x),y(y),z(z){
    }

    const bool operator<(const monstr& rhs){
        return x < rhs.x;
    }
};

bool cmp(monstr a,monstr b){
    return a.x<b.x;
}
signed main() {
#ifdef ONLINE_JUDGE
#else
    freopen("input", "r", stdin);
    //freopen("output", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    memset(p,0,sizeof(p));
    int n,m,k;
    cin >> n >> m >> k;
    pair<int,int> weapons[n];
    for(int i =0; i < n; i++){
        cin >> weapons[i].first >> weapons[i].second;
    }
    pair<int,int>armors[m];
    for(int i =0; i < m; i++){
        cin >> armors[i].first >> armors[i].second;
    }
    monstr monstrs[k];
    for(int i =0; i < k; i++){
        int x, y, k;
        cin >> x >> y >> k;
        monstrs[i] = {y, x, k};
    }
    sort(weapons, weapons + n);
    sort(armors, armors + m);
    sort(monstrs, monstrs + k,cmp);


    int tmp[n];
    for(int i = 0; i < n; i++){
        tmp[i] = -weapons[i].second;
    }
    build(1,0,n,tmp);

    int ans = -INF;
    int l =0;
    for(int i =0; i < m; i++){
        //printf("%d %d\n",calc(1, 0, n, 0, 1),calc(1, 0, n, 1, 2));
        while(l < k && monstrs[l].x < armors[i].first){
            pair<int,int> val = make_pair(monstrs[i].y+1, 0);
            int from = lower_bound(weapons, weapons + n, val) - weapons;
            update(1,0,n,from,n,monstrs[l].z);
            //printf("+ %d %d %d\n",from,n,monstrs[l].z);
            l++;
        }
        //printf("%d\n",calc(1, 0, n, 0, n));
        ans = max(ans, calc(1, 0, n, 0, n) - armors[i].second);
    }
    cout << ans;
}