#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ld long double

ll INF = (ll) 1e20;
ll iINF = (int) 1e20;
ll mod = (ll) 1e9 + 7;

#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("no-stack-protector")

struct st {
    vector <ll> t;
    vector <ll> psh;
    st() { }
    st(vector <ll> &a) {
        t.resize(4 * a.size());
        psh.resize(4 * a.size());
        build(1, 0, a.size() - 1, a);
    }
    void build(ll v, ll l, ll r, vector <ll> &a) {
        t[v] = 0;
        if(l == r) {
            t[v] = a[l];
            return;
        }
        ll m = (l + r) / 2;
        build(v * 2, l, m, a);
        build(v * 2 + 1, m + 1, r, a);
        t[v] = min(t[v * 2], t[v * 2 + 1]);
    }
    void push(ll v, ll l, ll r) {
        t[v] += psh[v];
        if(l == r) {
            psh[v] = 0;
            return;
        }
        psh[v * 2] += psh[v];
        psh[v * 2 + 1] += psh[v];
        psh[v] = 0;
    }
    void add(ll v, ll l, ll r, ll ql, ll qr, ll x) {
        push(v,l , r);
        if(l > qr || r < ql)
            return;
        if(l >= ql && r <= qr) {
            psh[v] += x;
            push(v, l, r);
            return;
        }
        ll m = (l + r ) / 2;
        add(v * 2, l, m, ql, qr, x);
        add(v * 2  + 1, m + 1, r, ql, qr, x);
        t[v] = min(t[v * 2], t[v * 2 + 1]);
    }
    ll get(ll v, ll l, ll r) {
        push(v, l, r);
        return t[v];
    }
    void print(ll v, ll l, ll r) {
        push(v, l, r);
        if(l == r) {
            cout << t[v] << ' ';
            return;
        }
        ll m = (l + r) / 2;
        print(v * 2, l, m);
        print(v * 2 + 1, m + 1, r);
    }
};

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie();
    cout.tie();
    ll n, m, p;
    cin >> n >> m >> p;
    vector <pair <ll, ll>> a(n);
    for(int i = 0; i <n; ++i) {
        cin >> a[i].first >> a[i].second;
    }
    vector <pair <ll, ll>> b(m);
    for(int i = 0; i <m; ++i) {
        cin >> b[i].first >> b[i].second;
    }
    vector <pair <pair <ll, ll>, ll>> v(p);
    for(int i = 0; i < p; ++i) {
        cin >> v[i].first.first >> v[i].first.second >> v[i].second;
    }
    sort(b.begin(), b.end());
    vector <ll> costs(m);
    for(int i = 0; i <m; ++i) {
        costs[i] = b[i].second;
    }
    st dosh = st(costs);
    sort(a.begin(), a.end());
    sort(v.begin(), v.end());
    vector <ll> can(p, 0);
    ll id = 0;
    ll ans = INF;
 //   dosh.print(1, 0, m - 1);
    //cout << '\n';
    for(int i = 0; i < n; ++i) {
        while(id < p) {
            if(v[id].first.first < a[i].first) {
                ll l = 0, r = m - 1, kek = INF;
                while(l <= r) {
                    ll mid = (l + r) / 2;
                    if(b[mid].first > v[id].first.second) {
                        r = mid - 1;
                        kek = min(kek, mid);
                    }
                    else {
                        l = mid + 1;
                    }
                }if(kek == INF) { }
                else {
                 //   cout << kek << ' ' << m - 1 << ' ' << id << ' ' << -v[id].second << '\n';
                    dosh.add(1, 0, m - 1, kek, m - 1, -v[id].second);
                }
                ++id;
            }
            else
                break;
        }
        //dosh.print(1, 0, m - 1);
      //  cout << '\n';
      //  cout << id << ' ' << dosh.get(1, 0, m - 1) << '\n';
        ans = min(ans, a[i].second + dosh.get(1, 0, m - 1));
    }
    cout << -ans;
}
