#include <bits/stdc++.h>

using namespace std;

#define out(x) for(auto i: x) cout << i << ' '; cout << '\n';

int n, m;
vector <vector <int> > g, gt;
vector <int> d, path;

int main()
{
    cin >> n >> m;
    g.resize(n);
    gt.resize(n);
    d.resize(n, 1e9);
    for(int i = 0; i < m; i++){
        int f, t;
        cin >> f >> t;
        f--; t--;
        g[f].push_back(t);
        gt[t].push_back(f);
    }
    int k;
    cin >> k;
    path.resize(k);
    for(int i = 0; i < k; i++){
        cin >> path[i];
        path[i]--;
    }

    queue <int> q;
    d[path.back()] = 0;
    q.push(path.back());
    while(q.size()){
        int from = q.front();
        q.pop();
        for(int to: gt[from]){
            if(d[from] + 1 < d[to]){
                d[to] = d[from] + 1;
                q.push(to);
            }
        }
    }

    int minans = 0;
    for(int i = 0; i < k; i++){
        if(d[path[i]] == k - i - 1)
            k = k;
        else
            minans++;
    }

    int maxans = 0;
    for(int i = 0; i < k - 1; i++){
        int now = path[i];
        for(auto to: g[now]){
            if(to == path[i + 1])
                continue;
            if(d[to] <= d[now])
                maxans++;
        }
    }
    cout << minans << ' ' << maxans;
}
