#include <bits/stdc++.h>

using namespace std;

#define out(x) for(auto i: x) cout << i << ' '; cout << '\n';

int n, m;
vector <vector <int> > g, gt;
vector <int> d, path;

int main()
{
    cin >> n >> m;
    g.resize(n);
    gt.resize(n);
    d.resize(n, 1e9);
    for(int i = 0; i < m; i++){
        int f, t;
        cin >> f >> t;
        f--; t--;
        g[f].push_back(t);
        gt[t].push_back(f);
    }
    int k;
    cin >> k;
    path.resize(k);
    for(int i = 0; i < k; i++){
        cin >> path[i];
        path[i]--;
    }

    queue <int> q;
    d[path.back()] = 0;
    q.push(path.back());
    while(q.size()){
        int from = q.front();
        q.pop();
        for(int to: gt[from]){
            if(d[from] + 1 < d[to]){
                d[to] = d[from] + 1;
                q.push(to);
            }
        }
    }

    int minans = 0;
    for(int i = 0; i < k - 1; i++){
        int mi = 0;
        int now = path[i];
        for(int j = 1; j < g[now].size(); j++){
            if(d[g[now][mi]] > d[g[now][j]])
                mi = j;
        }
        if(d[path[i + 1]] != d[g[now][mi]])
            minans++;
    }

    int maxans = 0;
    for(int i = 0; i < k - 1; i++){
        int now = path[i];
        for(auto to: g[now]){
            if(to == path[i + 1])
                continue;
            if(d[to] <= d[path[i + 1]])
                maxans++;
        }
    }
    cout << minans << ' ' << maxans;
}

/**
5 5
1 2
2 5
2 3
5 3
3 4
5
1 2 5 3 4
**/
