

#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <map>
#include <string>

using namespace std;
using ull = unsigned long long;
using ll = long long;

const ll INF = 1e9 + 7;

signed main()
{
    ll n, m;
    cin >> n >> m;

    vector<vector<ll>> g(n);
    int x, y;

    for (int i = 0; i < m; i++)
    {
        cin >> x >> y;
        x--; y--;

        g[y].push_back(x);
    }

    int k;
    cin >> k;
    vector<int> p(k);

    for (int i = 0; i < k; i++)
    {
        cin >> p[i];
        p[i]--;
    }

    int f = p[k - 1];

    vector<int> d(n, INF);
    vector<int> c(n, 0);
    vector<int> used(n, 0);

    set<pair<int, int>> q;

    d[f] = 0;
    c[f] = 1;

    q.insert({0, f});

    while (!q.empty())
    {
        auto tp = *q.begin();
        q.erase(q.begin());

        int w = tp.first;
        int v = tp.second;

        used[v] = 1;

        for (int i = 0; i < g[v].size(); i++)
        {
            int u = g[v][i];
            if (used[u])
                continue;
            if (w + 1 < d[u])
            {
                auto p1 = q.find({d[u], u});
                if (p1 != q.end())
                {
                    q.erase(p1);
                }
                d[u] = w + 1;
                q.insert({d[u], u});
                c[u] = c[v];
            }
            else if (w + 1 == d[u])
            {
                c[u] += c[v];
            }
        }
    }

    int mn = 0;
    int mx = 0;

    for (int i = 0; i < k - 1; i++)
    {
        int v = p[i];
        int u = p[i + 1];
        if (d[v] == d[u] + 1 && c[v] > 1)
        {
            mx++;
        }
        if (d[v] != d[u] + 1)
        {
            mx++;
            mn++;
        }
    }

    cout << mn << ' ' << mx << endl;

    cin >> n;
    return 0;
}
