#include <bits/stdc++.h>

using namespace std;

int n, m, k;
vector<vector<int> > g;
vector<pair<int, int> > v;
vector<int> p;

void bfs(int t){
    queue<int> q; q.push(t);
    v[t].second = 1;
    v[t].first = 0;
    while(!q.empty()){
        int w = q.front(); q.pop();
        for(int i = 0; i < g[w].size(); ++i){
            int u = g[w][i];
            if(v[u].first >= v[w].first + 1){
                v[u].first = v[w].first + 1, v[u].second += v[w].second;
                q.push(u);
            }
        }
    }
}

int main()
{
    cin >> n >> m;
    g.resize(n);
    v.resize(n, {1e9, 0});
    for(int i = 0; i < m; ++i){
        int a, b; cin >> a >> b; --a, --b;
        g[b].push_back(a);
    }
    cin >> k;
    p.resize(k);
    for(int i = 0; i < k; ++i){
        cin >> p[i];
        --p[i];
    }
    bfs(p[k - 1]);
    int cnt1 = 0, cnt2 = 0;
    for(int i = 0; i < k - 1; ++i){
        int u = p[i], w = p[i + 1];
        if(v[u].first < v[w].first + 1)
            ++cnt1, ++cnt2;
        if(v[u].first > v[w].first + 1 || v[u].first == v[w].first + 1 && v[u].second > 1)
            ++cnt2;
    }
    cout << cnt1 << ' ' << cnt2 << '\n';
    return 0;
}
