#include <bits/stdc++.h>

using namespace std;

vector<pair<int, int> > v;
vector<vector<int> > g;
vector<bool> used;
int n, m, k;
vector<int> p;

void bfs(){
    queue<int> q; q.push(p[k - 1]);
    v[p[k - 1]].first = 0, v[p[k - 1]].second = 1;
    used[p[k - 1]] = 1;
    while(!q.empty()){
        int w = q.front(); q.pop();
        //cout << w << '\n';
        for(int i = 0; i < g[w].size(); ++i){
            int u = g[w][i];
            //cout << 'A' << ' ';
            if(v[u].first <= v[w].first)
                continue;
            v[u].second = min(v[u].second + v[w].second, 10);
            v[u].first = v[w].first + 1;
            if(!used[u])
                q.push(u), used[u] = 1;
        }
    }
}

int main()
{
    cin >> n >> m;
    g.resize(n);
    v.resize(n, {m + 1, 0});
    used.resize(n);
    for(int i = 0; i < m; ++i){
        int a, b; cin >> a >> b; --a, --b;
        g[b].push_back(a);
    }
    cin >> k;
    p.resize(k);
    for(int i = 0; i < k; ++i){
        cin >> p[i];
        --p[i];
    }
    bfs();
    int cnt1 = 0, cnt2 = 0;
    for(int i = 0; i < k - 1; ++i){
        int u = p[i], w = p[i + 1];
        if(v[u].first <= v[w].first)
            cnt1++;
        if(v[u].first <= v[w].first || v[u].first > v[w].first && v[u].second > 1)
            ++cnt2;
    }
    cout << cnt1 << ' ' << cnt2 << '\n';
    return 0;
}
