#include <bits/stdc++.h>
#define pb push_back
#define fst first
#define snd second
#define int long long
using namespace std; typedef long long ll; typedef long double ld;

const int N = 1e6 + 10;
int t[4 * N];
int upd[4 * N];
const int inf = 1e18 + 7;

void push(int v, int l, int r){
    t[v] += upd[v];
    if (l != r - 1){
        upd[2 * v + 1] += upd[v];
        upd[2 * v + 2] += upd[v];
    }
    upd[v] = 0;
}

void update(int v, int l, int r, int tl, int tr, int val){
    push(v, l, r);
    if (tl <= l && tr >= r){
        upd[v] = val;
        push(v, l, r);
        return;
    }
    if (tl >= r || tr <= l)
        return;
    int mid = (r + l) / 2;
    update(2 * v + 1, l, mid, tl, tr, val);
    update(2 * v + 2, mid, r, tl, tr, val);
    t[v] = max(t[2 * v + 1], t[2 * v + 2]);
}

int get(int v, int l, int r, int tl, int tr){
    push(v, l, r);
    if (tl <= l && tr >= r){
        return t[v];
    }
    if (tl >= r || tr <= l)
        return -inf;
    int mid = (r + l) / 2;
    return max(get(2 * v + 1, l, mid, tl, tr),
    get(2 * v + 2, mid, r, tl, tr));
}

bool comp(pair<int, int> a, pair<int, int> b){
    if (a.fst == b.fst){
        return a.snd > b.snd;
    }
    return a.fst < b.fst;
}

struct ms{
    int x, y, z;
};

bool comp2(ms a, ms b){
    return a.x < b.x;
}

void solve(){
    int n, m, p;
    cin >> n >> m >> p;
    vector<pair<int, int>> na(n);
    vector<pair<int, int>> nb(m);
    for (int i = 0; i < n; i++){
        cin >> na[i].fst >> na[i].snd;
    }
    for (int i = 0; i < m; i++){
        cin >> nb[i].fst >> nb[i].snd;
    }
    sort(na.begin(), na.end(), comp);
    sort(nb.begin(), nb.end(), comp);
    vector<pair<int, int>> a; vector<pair<int, int>> b;
    vector<ms> monster (p);
    for (int i = 0; i < p; i++)
        cin >> monster[i].x >> monster[i].y >> monster[i].z;
    sort(monster.begin(), monster.end(), comp2);
    int mn = inf;
    for (int i = n - 1; i >= 0; i--){
        if (na[i].snd < mn)
            a.pb(na[i]);
        mn = min(mn, na[i].snd);
    }
    mn = inf;
    for (int i = m - 1; i >= 0; i--){
        if (nb[i].snd < mn)
            b.pb(nb[i]);
        mn = min(mn, nb[i].snd);
    }
    reverse(a.begin(), a.end());
    reverse(b.begin(), b.end());
    n = a.size(), m = b.size();
    for (int i = 0; i < m; i++){
        update(0, 0, N, b[i].fst, b[i].fst + 1, -b[i].snd);
    }
    for (int j = 0; j < N; j++){
        if (get(0, 0, N, j, j + 1) == 0)
            update(0, 0, N, j, j + 1, -inf);
    }
    int mx = -inf;
    int it = 0;
    for (int i = 0; i < n; i++){
        while(it < p && monster[it].x < a[i].fst){
            update(0, 0, N, monster[it].y + 1, N, monster[i].z);
            it++;
        }
        mx = max(mx, get(0, 0, N, 0, N) - a[i].snd);
    }
    cout << mx << endl;
}

signed main(){
    ios_base::sync_with_stdio(0); cin.tie(0);
    int t = 1;
    //cin >> t;
    while(t--){
        solve();
    }
    return 0;
}
