#include <bits/stdc++.h>
#define pb push_back
#define fst first
#define snd second
#define int long long
using namespace std; typedef long long ll; typedef long double ld;

const int N = 1e6 + 10;
int t[4 * N];
int upd[4 * N];
int used[N];
const int inf = 1e18 + 7;

void push(int v, int l, int r){
    t[v] += upd[v];
    if (l != r - 1){
        upd[2 * v + 1] += upd[v];
        upd[2 * v + 2] += upd[v];
    }
    upd[v] = 0;
}

void build(int v, int l, int r){
    if (l == r - 1){
        if (t[v] == 0){
            t[v] = -inf;
        }
    }else{
        int mid = (r + l) / 2;
        build(2 * v + 1, l, mid);
        build(2 * v + 2, mid, r);
        t[v] = max(t[2 * v + 1], t[2 * v + 2]);
    }
}

void update(int v, int l, int r, int tl, int tr, int val){
    push(v, l, r);
    if (tl <= l && tr >= r){
        upd[v] = val;
        push(v, l, r);
        return;
    }
    if (tl >= r || tr <= l)
        return;
    int mid = (r + l) / 2;
    update(2 * v + 1, l, mid, tl, tr, val);
    update(2 * v + 2, mid, r, tl, tr, val);
    t[v] = max(t[2 * v + 1], t[2 * v + 2]);
}

bool comp(pair<int, int> a, pair<int, int> b){
    if (a.fst == b.fst){
        return a.snd > b.snd;
    }
    return a.fst < b.fst;
}

struct ms{
    int x, y, z;
};

bool comp2(ms a, ms b){
    return a.x < b.x;
}

void solve(){
    int n, m, p;
    cin >> n >> m >> p;
    vector<pair<int, int>> a(n);
    vector<pair<int, int>> b(m);
    for (int i = 0; i < n; i++){
        cin >> a[i].fst >> a[i].snd;
    }
    for (int i = 0; i < m; i++){
        cin >> b[i].fst >> b[i].snd;
    }
    vector<ms> monster (p);
    for (int i = 0; i < p; i++)
        cin >> monster[i].x >> monster[i].y >> monster[i].z;
    sort(monster.begin(), monster.end(), comp2);
    for (int i = 0; i < m; i++){
        if (used[b[i].fst] == 0)
            used[b[i].fst] = -b[i].snd;
        else
            used[b[i].fst] = max(used[b[i].fst], -b[i].snd);
    }
    for (int i = 0; i < N; i++){
        if (used[i])
            update(0, 0, N, i, i + 1, used[i]);
    }
    build(0, 0, N);
    int mx = -inf;
    int it = 0;
    for (int i = 0; i < n; i++){
        while(it < p && monster[it].x < a[i].fst){
            update(0, 0, N, monster[it].y + 1, N, monster[it].z);
            it++;
        }
        mx = max(mx, t[0] - a[i].snd);
    }
    cout << mx << endl;
}

signed main(){
    ios_base::sync_with_stdio(0); cin.tie(0);
    int t = 1;
    //cin >> t;
    while(t--){
        solve();
    }
    return 0;
}
