#include <bits/stdc++.h>
#define int long long
#pragma GCC optimize("O3,Ofast,no-stack-protector,fast-math,unroll-loops")
using namespace std;

// Посвящается Полине Каменецкой

const int INF = 1e9;
int n, m;
int best = 0;
int worst = 0;
vector<vector<int>> adj;
vector<vector<int>> rev;
vector<int> dist;
int sz;
vector<int> path;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m;
    adj.resize(n);
    rev.resize(n);
    dist.resize(n, INF);
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        adj[a].push_back(b);
        rev[b].push_back(a);
    }
    cin >> sz;
    path.resize(sz);
    for (int i = 0; i < sz; i++) {
        cin >> path[i];
        path[i]--;
    }
    queue<int> bfs;
    bfs.push(path[sz - 1]);
    dist[path[sz - 1]] = 0;
    while (!bfs.empty()) {
        int x = bfs.front();
        bfs.pop();
        for (int v : rev[x]) {
            if (dist[v] == INF) {
                dist[v] = dist[x] + 1;
                bfs.push(v);
            }
        }
    }
    int curr = 0;
    while (curr != sz - 1) {
        bool oth = false;
        bool eve = false;
        for (int v : adj[path[curr]]) {
            if (v == path[curr + 1] && dist[v] == dist[path[curr]] - 1) {
                eve = true;
            } else if (dist[v] == dist[path[curr]] - 1) {
                oth = true;
            }
        }
        if (!eve) {
            best++;
        }
        if (oth) {
            worst++;
        }
        curr++;
    }
    cout << best << ' ' << worst << '\n';
    fflush(stdout);
}
