#include <bits/stdc++.h>

using namespace std;

typedef vector<int> vi;
typedef vector<vi> vvi;
typedef pair<int, int> ii;
typedef vector<ii> vii;
#define fo(i, n) for (int j = i; j < n; j++)

vector<vector<int>> graph, gr;

signed main() {
    int n, m;
    cin >> n >> m;
    graph.resize(n);
    gr.resize(n);
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        graph[a].push_back(b);
        gr[b].push_back(a);
    }
    int k;
    cin >> k;
    vector<int> path(k);
    for (int i = 0; i < k; i++) cin >> path[i];
    for (int i = 0; i < k; i++) path[i]--;
    int s = path[0], t = path.back();
    vector<int> dis(n, 1e9);
    dis[t] = 0;
    queue<int> q;
    q.push(t);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (auto to: gr[v]) {
            if (dis[to] > dis[v] + 1) {
                dis[to] = dis[v] + 1;
                q.push(to);
            }
        }
    }
    int minn = 0;
    for (int i = 1; i < k; i++) {
        if (dis[path[i]] != dis[path[i - 1]] - 1)
            minn++;
    }
    cout << minn << ' ';
    int maxx = 0;
    for (int i = 1; i < k; i++) {
        if (dis[path[i]] != dis[path[i - 1]] - 1)
            maxx++;
        else {
            for (auto to: graph[path[i - 1]]) {
                if (to != path[i]) {
                    if (dis[to] == dis[path[i]]) {
                        maxx++;
                        break;
                    }
                }
            }
        }
    }
    cout << maxx;
    return 0;
}