#include<bits/stdc++.h>
#define int long long int
#define pb push_back
#define ft first
#define sc second
#define ld long double
#define all(v) v.begin(), v.end()
using namespace std;
const int maxn = 201010, inf = 1e16;
struct mns {
    int x, y, z;
    mns(int _x, int _y, int _z) {
        x = _x; y = _y; z = _z;
    }
};
bool cmp(mns a, mns b) {
    return a.x < b.x;
}
bool cmp1(mns a, mns b) {
    return a.y < b.y;
}
int pref[maxn];
int tree[4 * maxn];
int flag[4 * maxn];
void build(int tl, int tr, int num, vector<int> &best) {
    if (tl + 1 == tr) {
        tree[num] = best[tl];
        flag[num] = 0;
        return;
    }
    int m = (tl + tr) / 2;
    build(tl, m, 2 * num, best);
    build(m, tr, 2 * num + 1, best);
    tree[num] = max(tree[2 * num], tree[2 * num + 1]);
    flag[num] = 0;
}
void push(int tl, int tr, int num) {
    if (flag[num] == 0) return;
    if (tl + 1 == tr) {
        tree[num] += flag[num];
        flag[num] = 0;
        return;
    }
    tree[num] += flag[num];
    flag[2 * num] += flag[num];
    flag[2 * num + 1] += flag[num];
    flag[num] = 0;
}
void change(int tl, int tr, int l, int r, int ch, int num) {
    push(tl, tr, num);
    if (tl >= r || tr <= l) return;
    int m = (tl + tr) / 2;
    if (tl >= l && tr <= r) {
        flag[num] += ch;
        push(tl, tr, num);
        push(tl, m, 2 * num);
        push(m, tr, 2 * num + 1);
        return;
    }
    change(tl, m, l, r, ch, 2 * num);
    change(m, tr, l, r, ch, 2 * num + 1);
    tree[num] = max(tree[2 * num], tree[2 * num + 1]);
}
int get(int tl, int tr, int l, int r, int num) {
    push(tl, tr, num);
    if (tl >= r || tr <= l) return -inf;
    if (tl >= l && tr <= r) {
        return tree[num];
    }
    int m = (tl + tr) / 2;
    return max(get(tl, m, l, r, 2 * num), get(m, tr, l, r, 2 * num + 1));
}
signed main(){
    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(false);
    int n, m, p;
    cin >> n >> m >> p;
    vector<pair<int, int> > a;
    for (int d = 0; d < n; d++) {
        int a1, ca1;
        cin >> a1 >> ca1;
        a.pb({a1, ca1});
    }
    vector<pair<int, int> > b;
    for (int d = 0; d < m; d++) {
        int b1, cb1;
        cin >> b1 >> cb1;
        b.pb({b1, cb1});
    }
    vector<mns> mstr;
    for (int d = 0; d < p; d++) {
        int x, y, z;
        cin >> x >> y >> z;
        mns mn(x, y, z);
        mstr.pb(mn);
    }
    sort(all(a));
    sort(all(b));
    sort(all(mstr), cmp);
    while (mstr.size() > 0 && mstr.back().x >= a.back().ft) {
        mstr.pop_back();
    }
    vector<int> best(m, 0);
    for (int d = 0; d < m; d++) {
        best[d] -= b[d].sc;
    }
    sort(all(mstr), cmp1);
    pref[0] = 0;
    for (int d = 0; d < mstr.size(); d++) {
        pref[d + 1] = pref[d] + mstr[d].z;
    }
    int max1 = -inf;
    for (int d = 0; d < m; d++) {
        mns mn(0, b[d].ft, 0);
        auto it = upper_bound(mstr.begin(), mstr.end(), mn, cmp1);
        int id = (it - mstr.begin());
        best[d] += pref[id];
        max1 = max(max1, best[d]);
    }
    sort(all(mstr), cmp);
    int ans = max1 - a.back().sc;
    a.pop_back();
    int k = 1;
    while (k < m) {
        k *= 2;
    }
    build(0, k, 1, best);
    while (a.size() > 0) {
        while (mstr.size() > 0 && mstr.back().x >= a.back().ft) {
            pair<int, int> p1 = {mstr.back().y, 0ll};
            auto it = upper_bound(b.begin(), b.end(), p1);
            int id = (it - b.begin());
//            for (int i = id; i < b.size(); i++) {
//                best[i] -= mstr.back().z;
//            }
            change(0, k, id, m, -mstr.back().z, 1);
            mstr.pop_back();
        }
//        for (int d = 0; d < b.size(); d++) {
//            ans = max(ans, best[d] - a.back().sc);
//        }
        int max1 = get(0, k, 0, m, 1);
        ans = max(ans, max1 - a.back().sc);
        a.pop_back();
    }
    cout << ans;
}
