#include <bits/stdc++.h>
using namespace std;
//#pragma GCC optimize("Ofast")

typedef long long ll;

const int mud = 5e5;
const ll md1 = 1e9 + 7;
const ll md2 = 1e9 + 9;
const ll base1 = 23;
const ll base2 = 107;

ll pbase1[1000000];
ll pbase2[1000000];

/*int color[1000000];

void rec(int v, int c) {
	if (color[v] != 0) return ;
	color[v] = c;
	int x = 1;
    for (int i = 0; i < n-2; i++) {
        if (((x*7) & v) == x*3) rec(v+x*3, c);
        if (((x*7) & v) == x*6) rec(v-x*3, c);
        x *= 2;
    }
}

string bin(int x) {
    string a = "";
    for (int i = 0; i < n; i++) {
        a += char('0' + x%2);
        x /= 2;
    }
    reverse(a.begin(), a.end());
    return a;
}

int sm(int x) {
	int s = 0;
    while (x > 0) s++, x &= x-1;
    return s;
}

vector <int> lst[100];

bool check(int a, int b) {
    string A = bin(a), B = bin(b);
    string aa = "", bb = "";
    for (int i = 0; i < n; i++) {
        if (i+1 < n && A[i] == '1' && A[i+1] == '1') i++;
												else aa += A[i];
    }
    for (int i = 0; i < n; i++) {
        if (i+1 < n && B[i] == '1' && B[i+1] == '1') i++;
												else bb += B[i];
    }
    return aa == bb;
}*/

struct hesh {
public:
    ll x1, x2, st;

    void print() { cout << x1 << " " << x2 << " " << st << endl; }
	hesh() { x1 = 0; x2 = 0; st = 0; }

	void inc(int last, int st) {
		x1 += pbase1[st] * last + md1*md1; x1 %= md1;
		x2 += pbase2[st] * last + md2*md2; x2 %= md2;
	}

    void add(int x) {
    	x += 5;
    	inc(x, st); st++;
    }

    void operator -= (hesh a) {
        x1 = (x1 + md1 - a.x1) % md1;
        x2 = (x2 + md2 - a.x2) % md2;
    }

    bool operator == (hesh a) {
		return x1 == a.x1 && x2 == a.x2;
    }

    void domn() {
        x1 *= pbase1[mud - st]; x1 %= md1;
        x2 *= pbase2[mud - st]; x2 %= md2;
    }
} h[1000000], g[1000000];

int n;
string s;
int zero[1000000];

bool good(hesh a, hesh b) {
    a.domn();
    b.domn();
    return (a == b);
}

int main()
{
	ios_base :: sync_with_stdio(0);
	cin.tie();
	cout.tie();

    pbase1[0] = 1;
    pbase2[0] = 1;
    for (int i = 1; i <= mud; i++) {
		pbase1[i] = (base1 * pbase1[i-1]) % md1;
		pbase2[i] = (base2 * pbase2[i-1]) % md2;
    }

	cin >> n;
	cin >> s;

	zero[s.size()] = s.size();
    for (int i = n-1; i >= 0; i--) {
        if (s[i] == '0') zero[i] = i;
					else zero[i] = zero[i+1];
    }
    for (int i = 1; i <= n; i++) {
        h[i] = h[i-1];
        if (i-2 >= 0 && s[i-1] == '1' && s[i-2] == '1')  h[i] = h[i-2];
													else h[i].add(s[i-1] - '0');
    }
    for (int i = 1; i <= n; i++) {
        g[i] = g[i-1];
        g[i].add(s[i-1] - '0');
    }

    int q;
    for (cin >> q; q > 0; q--) {
        int x, y, len;
        cin >> x >> y >> len;

        hesh A = g[x+len-1]; A -= g[x-1];
        hesh B = g[y+len-1]; B -= g[y-1];
        if (good(A, B)) {
            cout << "Yes" << endl;
            continue;
        }

        hesh a = h[x+len-1]; a -= h[zero[x-1]];
        hesh b = h[y+len-1]; b -= h[zero[y-1]];
        cout << (good(a, b) ? "Yes" : "No") << endl;
    }

	return 0;

	/*n = 14;
	int o = 0;
    for (int i = 0; i < (1 << n); i++) if (color[i] == 0) rec(i, ++o);

    for (int i = 0; i < (1 << n); i++) {
        lst[sm(i)].push_back(i);
    }

    for (int i = 2; i <= n; i++) {
        for (auto x : lst[i]) {
			for (auto y : lst[i]) {
				if (check(x, y) == (color[x] == color[y])) continue;
                cout << "BAD" << endl << bin(x) << endl << bin(y) << endl;
                return 0;
			}
        }
    }


	return 0;*/
}
