#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <fstream>
using namespace std;

const int INF = 1e9+ 7;

int main() {
    freopen("in.in", "r", stdin);
    int n, m;
    cin >> n >> m;
    vector<vector<int> > g(n), rg(n);
    while (m--) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        g[a].push_back(b);
        rg[b].push_back(a);
    }
    int k;
    cin >> k;
    vector<int> path(k);
    for (int i = 0; i < k; i++) {
        cin >> path[i];
        path[i]--;
    }
    vector<int> pr(n, -1);
    vector<int> dist(n, INF);

    dist[path.back()] = 0;
    queue<int> q;
    q.push(path.back());

    while (!q.empty()) {
        int v = q.front();
        q.pop();
        //cout << "who??? " << v << endl;
        for (int i = 0; i < rg[v].size(); i++) {
            int u = rg[v][i];
           // cout << u << " " << u + 1 << endl;
            if (dist[u] == INF) {
                pr[u] = v;
                dist[u] = dist[v] + 1;
                q.push(u);
            }
        }
       // cout << "what??? " << endl;
    }
   // cout << "sadfsdfsdf" << endl;
   /* for (int i = 0; i < n; i++) {
        cout << pr[i] << " ";
    }
    cout << endl;*/
    int l = 0, r = 0;
    for (int i = 0; i < k - 1; i++) {
       // cout << "lmao " << path[i] << endl;
        if (dist[path[i + 1]] != dist[pr[path[i]]]) {
            l++, r++;
        } else {
            int cnt = 0;
            for (int j = 0; j < g[path[i]].size(); j++) {
                int u = g[path[i]][j];
                if (dist[u] == dist[pr[path[i]]]) {
                    cnt++;
                }
            }
            if (cnt > 1) {
                r++;
            }
        }
    }
    cout << l << " " << r << endl;
    return 0;
}
