#include <iostream>
#include <algorithm>
#include <vector>
#include <set>

int main(){
    int n;
    std::cin >> n;
    std::vector<int> b(n);
    for (int i = 0; i < n; i++){
        std::cin >> b[i];
    }
    std::vector<int> visit1 = b;
    std::vector<int> visit2(n, -1);
    std::vector<std::set<int>> can_visit(n);
    for (int i = 0; i < n; i++){
        for (int j = i + 1; j < n; j++){
            if (b[j] - b[i] == j - i){
                can_visit[i].insert(j);
            }
        }
    }
    int maxb = 0;
    while(true){
        int up = 0;
        for (int i = 0; i < n; i++){
            if (visit1[i] == -1){
                continue;
            }
            maxb = std::max(maxb, visit1[i]);
            for (auto& e : can_visit[i]){
                visit2[e] = std::max(visit2[e], visit1[i] + b[e]);
                up++;
            }
        }
        if (up == 0){
            break;
        }
        visit1 = visit2;
        visit2 = std::vector<int>(n, -1);
    }
    std::cout << maxb << std::endl;
    return 0;
}