#include <iostream>
#include <map>

std::map<std::string, std::string> cache;

std::string ml(std::string s){
    // std::cout << s << std::endl;
    if (cache.count(s) > 0){
        return cache[s];
    }
    std::string min_s = s;
    for (int i = 0; i < s.size(); i++){
        if ((i > 0 and s[i] - s[i - 1] == 1) or
            (i < s.size() - 1 and s[i] - s[i + 1] == 1)){
            std::string qs = s.substr(0, i) + s.substr(i + 1, s.size());
            std::string ns = ml(qs);
            if (ns.size() < min_s.size()){
                min_s = ns;
            }
        }

    }
    cache[s] = min_s;
    return min_s;
}

int main(){
    int n;
    std::string s;
    std::cin >> n >> s;
    std::cout << s.size() - ml(s).size() << std::endl;

    return 0;
}