#define _CRT_SECURE_NO_WARNINGS
#include <cctype>
#include <cerrno>
#include <cfloat>
#include <ciso646>
#include <climits>
#include <clocale>
#include <cmath>
#include <csetjmp>
#include <csignal>
#include <cstdarg>
#include <cstddef>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <ctime>
#include <algorithm>
#include <bitset>
#include <complex>
#include <deque>
#include <exception>
#include <fstream>
#include <functional>
#include <iomanip>
#include <ios>
#include <iosfwd>
#include <iostream>
#include <istream>
#include <iterator>
#include <limits>
#include <list>
#include <locale>
#include <map>
#include <memory>
#include <new>
#include <numeric>
#include <ostream>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <stdexcept>
#include <streambuf>
#include <string>
#include <typeinfo>
#include <utility>
#include <valarray>
#include <vector>
#include <array>
#include <forward_list>
#include <initializer_list>
#include <random>
#include <regex>
#include <system_error>
#include <tuple>
#include <typeindex>
#include <type_traits>
#include <unordered_map>
#include <unordered_set>
#include <ext/pb_ds/detail/standard_policies.hpp>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#ifndef _DEBUG
//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("avx2")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,tune=naitve")
#endif // _DEBUG

using namespace __gnu_pbds;
using namespace std;

#define ll long long
#define ld long double
#define itn int
#define x first
#define y second

#define endl '\n'

mt19937 gen(41);
mt19937_64 genl(41);
//chrono::system_clock::now().time_since_epoch().count()

#ifdef MY
template <typename T> using ordered_set = tree <T, null_type, less <T>, rb_tree_tag, tree_order_statistics_node_update>;
#endif // MY

int gcd(int a, int b) {
    while(b) {
        a %= b;
        swap(a, b);
    }
    return a;
}

ll gcdl(ll a, ll b) {
    while(b) {
        a %= b;
        swap(a, b);
    }
    return a;
}

bool uax(int &a, int &b) {
    if(a < b) {
        a = b;
        return true;
    }
    return false;
}

bool uin(int &a, int &b) {
    if(a > b) {
        a = b;
        return true;
    }
    return false;
}


vector<int> z_function(string &s) {
    int n = s.size();
    vector<int> z(n);
    for(int i = 1, l = 0, r = 0; i < n; i++) {
        if(i <= r)
            z[i] = min(r - i + 1, z[i - l]);
        while(i + z[i] < n && s[i + z[i]] == s[z[i]])
            z[i]++;
        if(i + z[i] > r) {
            r = i + z[i];
            l = i;
        }
    }
    return z;
}

const int N = 1e5;
const ld eps = 1e-7;
const ll INFl = 1e18;
const int INF = 1e9;

int n, m, k, q;
vector<int> a;
vector<ll> al;

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	ios_base::sync_with_stdio(false);
	cin.tie(0);
#endif // _DEBUG
cout << fixed << setprecision(10);
//---------------------------------------------------------//
    cin >> n;
    vector<int> r(n);
    for(int i = 0; i < n; i++)
        cin >> r[i];
    vector<int> b(n);
    for(int i = 0; i < n; i++)
        cin >> b[i];
    int cnt1 = 0, cnt2 = 0, cnt3 = 0;
    for(int i = 0; i < n; i++) {
        if(r[i] && b[i])
            cnt3++;
        if(r[i] && !b[i])
            cnt1++;
        if(!r[i] && b[i])
            cnt2++;
    }
    int delta = cnt2;
    if(cnt1 == 0) {
        cout << -1;
        return 0;
    }
    int res = (cnt2 + cnt1) / cnt1;
    cout << res;
//---------------------------------------------------------//
    return 0;
}
