#pragma GCC optimize("Ofast,O3,O2")
#pragma GCC target("sse,sse2,sse4,avx,avx2")

#include <iostream>
#include <algorithm>
#include <vector>
#include <stdlib.h>
#include <set>
#include <unordered_map>

using namespace std;

typedef long long ll;
const ll INF = 1e18;

void fastIO(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

int main() {
	fastIO();
	ll n;
	cin >> n;
	vector<ll> a(n);
	vector<ll> ans(n, 0);
	unordered_map<ll, ll> st;
	ll alpha = 0;
	
	for (ll i = 0; i < n; ++i) {
		cin >> a[i];
	}
	for (ll i = 0; i < n; ++i) {
		ans[i] = a[i];
		ll index = a[i] - i;
		ans[i] = max(ans[i], ans[i] + st[alpha + index]);
		st[alpha + index] = max(ans[i], st[alpha + index]);
	}
	ll answer = 0;
	for (ll i = 0; i < n; ++i) {
		answer = max(answer, ans[i]);
	}
	cout << answer << endl;
	char qwer;
	cin >> qwer;
    return 0;
}