#include <iostream>
#include <iomanip>
#include <string>
#include <map>
#include <set>
#include <vector>
#include <queue>
#include <cassert>
#include <cmath>
#include <algorithm>
#include <random>
#include <memory>
#include <chrono>

using namespace std;

random_device rd;
mt19937 rnd(rd());

//#pragma GCC optimize("O3")
//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx,avx2")

#define ll long long
#define ull unsigned long long
//#define int ll
#define F first
#define S second
const int inf = 2e9;
const int mod = 1e9 + 7;
const int SZ = 100 + 4;

int n;
bool a[SZ];
bool b[SZ];

void read() {
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 0 ;i < n; ++i) {
        cin >> b[i];
    }
}

void solve() {
    int ans = 0;
    bool z = true;
    for (int i = 0; i < n; ++i) {
        if (!a[i] && b[i]) {
            ++ans;
        } else if (a[i] && !b[i]) {
            z = false;
        }
    }
    if (z) {
        cout << -1 << "\n";
        return;
    }
    cout << ans + 1 << "\n";
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    read();
    solve();

    return 0;
}