#include <iostream>
#include <iomanip>
#include <string>
#include <map>
#include <set>
#include <vector>
#include <queue>
#include <cassert>
#include <cmath>
#include <algorithm>
#include <random>
#include <memory>
#include <chrono>

using namespace std;

random_device rd;
mt19937 rnd(rd());

//#pragma GCC optimize("O3")
//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx,avx2")

#define ll long long
#define ull unsigned long long
#define int ll
#define F first
#define S second
const int inf = 2e9;
const int mod = 1e9 + 7;
const int SZ = 2e5 + 4;

int n;
int b[SZ];

void read() {
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
    }
}

void solve() {
    set<int> x;
    for (int i = 0; i < n; ++i) {
        x.insert(i);
    }
    int res = -1;
    while (!x.empty()) {
        vector<int> del;
        int last = *x.begin();
        int ans = 0;
        for (int u : x) {
            if (u - last == b[u] - b[last]) {
                ans += b[u];
                del.push_back(u);
            }
        }
        res = max(res, ans);
        for (int u : del) {
            x.erase(u);
        }
    }
    cout << res;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    read();
    solve();

    return 0;
}