#include<bits/stdc++.h>

#define pb push_back
#define X first
#define Y second
#define endl '\n'
#define int long long

using namespace std;

const int INF = 1e9;

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    int n, m;
    cin >> n >> m;
    vector<vector<int>> g(n);
    vector<vector<int>> gt(n);
    for(int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        g[u - 1].pb(v - 1);
        gt[v - 1].pb(u - 1);
    }
    int k;
    cin >> k;
    vector<int> way(k);
    for(int i = 0; i < k; ++i) {
        cin >> way[i];
        way[i]--;
    }
    int s = way[0], t = way.back();
    vector<int> d(n, INF);
    d[t] = 0;
    queue<int> q;
    q.push(t);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for(auto to : gt[v]) {
            if (d[to] > d[v] + 1) {
                q.push(to);
                d[to] = d[v] + 1;
            }
        }
    }
    int ans_min = 0, ans_max = 0;
    int ind = 0;
    while (ind < k - 1) {
        int mn = INF;
        for(auto to : g[way[ind]]) {
            mn = min(mn, d[to]);
        }
        int kol = 0;
        for(auto to : g[way[ind]]) {
            kol += (d[to] == mn);
        }
        if (d[way[ind + 1]] != mn) {
            ans_min++;
            ans_max++;
        } else if (kol > 1) {
            ans_max++;
        }
        ind++;
    }
    cout << ans_min << ' ' << ans_max;
}
