#include <bits/stdc++.h>

using namespace std;

typedef pair <int, int> pii;
typedef long long ll;

#define pb push_back
#define mp make_pair
#define lb lower_bound
#define ub upper_bound
#define all(v) v.begin(),v.end();
#define rall(v) v.rbegin();v.rend();
#define eps 1e-9;
#define mod 1000000007
#define do_not_disturb ios::sync_with_stdio(0);cin.tie(0);cout.tie(0);

inline bool isvowel(char ch){
    return ch == 'a' || ch == 'e' || ch == 'i' || ch == 'o' || ch == 'u';
}

inline bool isprime(int n){
    if((n < 2) || (n%2 == 0 && n != 2))
        return false;
    for(int i = 3; i*i <= n; i += 2)
        if(n % i == 0)
            return false;
    return true;
}
/*
int main(){
    do_not_disturb

    int n, i, cnt = 0, id = 1;
    string s;
    cin >> n >> s;
    vector <char> fi(101), last(101), very(101);
    vector <int> saizu(101, 0);
    fi[1] = last[1] = very[1] = s[0];
    saizu[1] = 1;
    id++;
    for(i = 1; i < n; i++){
        if(fi[id-1]-1 == s[i]){
            fi[id-1] = last[id-1] = s[i];
            saizu[id-1]++;
        }
        else if((last[id-1]+1 == s[i] || last[id-1] == s[i] || last[id-1]-1 == s[i]) && fi[id-1] != s[i]){
            last[id-1] = s[i];
            saizu[id-1]++;
        }
        else{
            fi[id] = last[id] = very[id] = s[i];
            saizu[id]++;
            id++;
        }
        int q = id-2;
        while(q > 0){
            if(fi[q] ==  && very[id-1] == fi[q]){
               saizu[q] += saizu[id-1];
               saizu[id-1] = 0;
               fi[q] = fi[id-1];
               last[q] = last[id-1];
               very[q] = very[id-1];
               q--;
               id--;
            }
            else break;
        }
    }
    for(i = 1; i < id; i++){
        cnt += saizu[i]-1;
        cout << saizu[i] << ' ';
    }
    cout << cnt;

    return 0;
}*/

const int N = 2e5+7;
vector <vector <int> > graph(N), fromt(N);
int dist[N], order[N];

void bfs(int p){
    memset(dist, mod, sizeof(dist));
    dist[p] = 0;

    queue <int> K;
    K.push(p);
    while(K.size()){
        int v = K.front(); K.pop();
        for(int i = 0; i < fromt[v].size(); i++){
            int to = fromt[v][i];
            if(dist[to] > dist[v]+1){
                dist[to] = dist[v]+1;
                K.push(to);
            }
        }
    }
}

int main(){
    do_not_disturb

    int n, m, i, mn = 0, mx = 0;
    cin >> n >> m;
    for(i = 0; i < m; i++){
        int x, y;
        cin >> x >> y;

        graph[x].pb(y);
        fromt[y].pb(x);
    }

    int p;
    cin >> p;
    vector <int> path(p);
    for(i = 0; i < p; i++){
        cin >> path[i];
        order[path[i]] = i+1;
    }

    bfs(path[p-1]);

    for(i = 0; i < p-1; i++){
        int flag1 = 0, flag2 = 0;
        for(int j = 0; j < graph[path[i]].size(); j++){
            int to = graph[path[i]][j];
            if(dist[path[i]]-dist[to] == 1){
                if(to == path[i+1]) flag1++;
                else flag2++;
            }
        }
        if(flag1 && flag2){
            mx++;
        }
        else if(flag2){
            mn++; mx++;
        }
    }

    cout << mn << ' ' << mx;

    return 0;
}

