#include <bits/stdc++.h>
using namespace std;

#define ll long long
#define ld long double
#define F first
#define S second
#define pb push_back
#define TIME 1.0 * clock() / CLOCKS_PER_SEC

mt19937 gen(chrono::high_resolution_clock::now().time_since_epoch().count());

const int N = 2e5 + 7;
const int MOD = 1e9 + 7;
//const int p1 = 228, M1 = 1e9 + 37, p2 = 53, M2 = 1e17 + 47;
const int rx[4] = {-1, 0, 1, 0};
const int ry[4] = {0, 1, -1, 0};
const int dx[8] = {-1, -1, -1, 0, 1, 1, 1, 0};
const int dy[8] = {-1, 0, 1, 1, 1, 0, -1, -1};
const int hx[8] = {-2, -2, -1, 1, 2, 2, 1, -1};
const int hy[8] = {-1, 1, 2, 2, 1, -1, -2, -2};
const ld pi = acos(-1.0);
const int INF = 2e9;

vector <int> g[N], g2[N];

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; i ++) {
        int x, y;
        cin >> x >> y;
        x --;
        y --;
        g[x].pb(y);
        g2[y].pb(x);
    }
    int k;
    cin >> k;
    int p[k];
    for (int i = 0; i < k; i++) {
        cin >> p[i];
        p[i] --;
    }
    vector <bool> ok(n, false);
    vector <bool> used(n, false);
    vector <int> rast(n, INF);
    queue <int> q;
    q.push(p[k - 1]);
    used[p[k - 1]] = true;
    rast[p[k - 1]] = 0;
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (auto to : g2[v]) {
            if (!used[to]) {
                used[to] = true;
                rast[to] = rast[v] + 1;
                q.push(to);
            } else if (used[to]) {
                if (rast[to] == rast[v] + 1) {
                    ok[to] = true;
                }
            }
        }
    }
    int mn = 0, mx = 0;
    for (int i = 0; i < k - 1; i++) {
        if (rast[p[i + 1]] == rast[p[i]] - 1) {
            if (ok[p[i]]) {
                mx ++;
            }
        } else {
            mn ++;
            mx ++;
        }
    }
    cout << mn << " " << mx << endl;
    return 0;
}
