#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <set>
#include <map>
#include <cmath>
#include <cassert>
#include <string>
#define int long long

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pa;
typedef pair<ll, ll> pal;

const int N = 2e5, inf = 1e7;

vector<int> g[N];

signed main(){
	//freopen("txt.in", "r", stdin);
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; ++i){
		int u, v;
		cin>> u >> v;
		--u, --v;
		g[v].push_back(u);
	}
	int k;
	cin >> k;
	vector<int> a(k);
	for (int i = 0; i < k; ++i){
		cin >> a[i];
		--a[i];

	}
	queue<int> q;
	q.push(a[k - 1]);
	vector<int> d(n, inf);
	vector<int> two(n, 0);
	d[a.back()] = 0;
	while (q.size()){
		int v =q.front();
		q.pop();
		for (int toi = 0; toi < g[v].size(); ++toi){
			int to = g[v][toi];
			if (d[to] == inf){
				d[to] = d[v] + 1;
				//if (two[v]) two[to] = 1;
				q.push(to);
			} else if (d[to] == d[v] + 1){
				two[to] = 1;
			}
		}
	}
	int mn = 0, mx = 0, opt = k - 1;
	int so = 0;
	vector<int> ss(k, 2);
	for (int i = k - 2; i >= 0; --i){
		ss[i] = ss[i + 1];
		int v = a[i];
		if (ss[i] == 2 && two[v])
			ss[i] = 1;
		if (d[v] != k - i - 1)
			ss[i] = 0;
	}
	for (int i = 0; i < k; ++i){
		int v = a[i];
		int len = k - i - 1;
		so = ss[i];
		//cout << so << " " << two[v] << '\n';
		if (so == 0){
			if (opt != d[v])
				++mn, ++mx;
			else if (two[v])
				++mx;
			opt = d[v] - 1;
		} else if (so == 1){
			if (two[v])
				++mx;
		}
	}
    cout << mn << " " << mx;
	return 0;
}