#include <bits/stdc++.h>
#define int long long
#define pb push_back

using namespace std;

const int MOD = 1e9+7;
const int INF = 1e18;
const int MAXN = 3e5;

void fast_io(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

vector<int> g[MAXN];
vector<int> g2[MAXN];

signed main() {
    fast_io();
    int n, m;
    cin >> n >> m;
    for(int i=0; i<m; i++){
        int a, b;
        cin >> a >> b;
        a--; b--;
        g[b].pb(a);
        g2[a].pb(b);
    }
    int n2;
    cin >> n2;
    vector<int> path(n2);
    for(int &i:path) {
        cin >> i;
        i--;
    }
    queue<int> q;
    vector<bool> used(MAXN, false);
    q.push(path[n2-1]);
    vector<int> dist(MAXN, INF);
    dist[path[n2-1]] = 0;
    while(!q.empty()){
        int v = q.front();
        q.pop();
        if(used[v])
            continue;
        used[v] = true;
        for(int i:g[v]){
            dist[i] = min(dist[v]+1, dist[i]);
            q.push(i);
        }
    }
//    for(int i=0; i<n; i++)
//        cout << dist[i] << " ";
//    cout << endl;
    int minim = 0;
    int maxim = 0;
    for(int i=0; i<n2-1; i++){
        int kek = INF;
//        cout << path[i+1] << " ";
        for(int j:g2[path[i]]){
            if(j!=path[i+1]){
                kek = min(dist[j], kek);
            }
        }
//        cout << kek << endl;
        if(kek==dist[path[i+1]]){
            maxim++;
        } else if(kek<dist[path[i+1]]){
            maxim++;
            minim++;
        }
    }
    cout << minim << " " << maxim << endl;
    return 0;
}

/*
8 9
1 2
2 3
3 4
4 5
5 6
6 7
7 8
2 4
5 7
8
1 2 3 4 5 6 7 8
 */