#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

int m;
vector<ll> segm_tr, delta;

void build(vector<pair<int, int>> &v, int l = 0, int r = m, int cv = 1) {
    if (l + 1 == r) {
        segm_tr[cv] = -v[l].second;
    } else {
        int mid = (l + r) / 2;
        build(v, l, mid, cv * 2);
        build(v, mid, r, cv * 2 + 1);
        segm_tr[cv] = max(segm_tr[cv * 2], segm_tr[cv * 2 + 1]);
    }
}

void push(int cv) {
    segm_tr[cv] += delta[cv];
    if (cv * 2 + 1 < 4 * m) {
        delta[cv * 2] += delta[cv];
        delta[cv * 2 + 1] += delta[cv];
    }
    delta[cv] = 0;
}

void add(ll x, int ql, int qr, int l = 0, int r = m, int cv = 1) {
    push(cv);
    if (ql >= qr) {
        return;
    }
    if (ql == l && qr == r) {
        delta[cv] += x;
        push(cv);
        return;
    }
    int mid = (l + r) / 2;
    add(x, ql, min(qr, mid), l, mid, cv * 2);
    add(x, max(ql, mid), qr, mid, r, cv * 2 + 1);
    segm_tr[cv] = max(segm_tr[cv * 2], segm_tr[cv * 2 + 1]);
}

//vector<pair<int, int>> norm(vector<pair<int, int>> &vb, int &m) {
//
//}

vector<int> get_ind(vector<vector<int>> &monst, int p, vector<pair<int, int>> &vb, int m) {
    vector<pair<int, int>> v(p);
    for (int i = 0; i < p; ++i) {
        v[i].first = monst[i][1];
        v[i].second = i;
    }
    sort(v.begin(), v.end());

    vector<int> ind(p);
    int arm = 0;
    for (int i = 0; i < p; ++i) {
        while (arm < m && vb[arm].first <= v[i].first) {
            arm++;
        }
        ind[v[i].second] = arm;
    }
    return ind;
}

int main() {
    int n, p;
    cin >> n >> m >> p;
    vector<pair<int, int>> va(n);
    for (int i = 0; i < n; ++i) {
        cin >> va[i].first >> va[i].second;
    }
    sort(va.begin(), va.end());
    vector<pair<int, int>> vb(m);
    for (int i = 0; i < m; ++i) {
        cin >> vb[i].first >> vb[i].second;
    }
    sort(vb.begin(), vb.end());

    //vb.norm(vb, m);
    vector<pair<int, int>> res;
    res.push_back(vb[0]);
    for (int i = 1; i < m; ++i) {
        if (vb[i].first != vb[i - 1].first) {
            res.push_back(vb[i]);
        }
    }
    m = res.size();
    for (int i = 0; i < m; ++i) {
        vb[i] = res[i];
    }
    //endfunc

    vector<vector<int>> monst(p, vector<int>(3));
    for (int i = 0; i < p; ++i) {
        cin >> monst[i][0] >> monst[i][1] >> monst[i][2];
    }
    sort(monst.begin(), monst.end());

    auto ind = get_ind(monst, p, vb, m);

    int cur_monst = 0;
    ll ans = -3e9;
    segm_tr.resize(4 * m);
    delta.resize(4 * m);
    build(vb);
    for (int i = 0; i < n; ++i) {
        while (cur_monst < p && va[i].first > monst[cur_monst][0]) {
            add(monst[cur_monst][2], ind[cur_monst], m);
            cur_monst++;
        }
        ans = max(ans, segm_tr[1] - va[i].second);
    }
    cout << ans << endl;
}