#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

#define int ll
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define ff first
#define ss second

constexpr int MAXN = 2e5 + 228;
constexpr int INF = 1'000'000'000'000'000'000;

vector<int> g[MAXN], gr[MAXN];

void run() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int u, v, c;
        cin >> u >> v;
        u--; v--;
        g[u].emplace_back(v);
        gr[v].emplace_back(u);
    }
    int k;
    cin >> k;
    vector<int> w(k);
    for (auto &el : w) {
        cin >> el;
        el--;
    }
    queue<int> q;
    q.push(w.back());
    vector<int> d(n, INF), usd(n), cnt(n);
    d[w.back()] = 0;
    usd[w.back()] = 1;
    cnt[w.back()] = 1;
    while (q.size()) {
        int v = q.front();
        q.pop();
        for (auto u : gr[v]) {
            if (!usd[u]) {
                usd[u] = 1;
                d[u] = d[v] + 1;
                q.push(u);
            }
            if (d[u] == d[v] + 1) {
                cnt[u] += cnt[v];
            }
        }
    }
    int lb = 0;
    int rb = 0;
    int cway = w.size() - 1;
    for (int i = 1; i < k; i++) {
        if (cway - 1 == d[w[i]] && cway == d[w[i - 1]] && cnt[w[i - 1]] > 1) {
            rb++;
        } else if (!(cway - 1 == d[w[i]] && cway == d[w[i - 1]])) {
            lb++;
            rb++;
        }
        cway--;
    }
    cout << lb << ' ' << rb << '\n';
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int t = 1;
    //cin >> t;
    while (t--) {
        run();
    }
    return 0;
}