#include <bits/stdc++.h>
#define FAST_READ ios::sync_with_stdio(0);cin.tie(0);cout.tie(0);
#define F first
#define S second
#define intt long long

using namespace std;

const int maxx = 1000001;
const long long inf = 1000000000000000000;
int n, m, p;

long long tree[maxx << 2] , lazy[maxx << 2] , mx[maxx << 2];

void build(int v,int l,int r) {
    tree[v] = -inf;
    mx[v] = -inf;
    if (l == r)return;
    int mid = (l + r) >> 1;
    build(v << 1,l,mid);
    build(v << 1 | 1,mid + 1,r);
}

void relax(int v,int l,int r) {
    tree[v] = max(tree[v] , mx[v]);
    tree[v] += lazy[v];
    if (l != r) {
        lazy[v << 1] += lazy[v];
        mx[v << 1] = max(mx[v << 1] , mx[v]);
        lazy[v << 1 | 1] += lazy[v];
        mx[v << 1 | 1] = max(mx[v << 1 | 1] , mx[v]);
    }
    lazy[v] = 0;
    mx[v] = -inf;
}

void update(int v,int l,int r,int le,int ri,long long val,int ty) {
    relax(v , l , r);
    if (l > ri || r < le)return;
    if (l >= le && r <= ri) {
        if (ty == 0)lazy[v] += val;
        else mx[v] = max(mx[v] , val);
        relax(v , l , r);
        return;
    }
    int mid = (l + r) >> 1;
    update(v << 1,l,mid,le,ri,val,ty);
    update(v << 1 | 1,mid + 1,r,le,ri,val,ty);
    tree[v] = max(tree[v << 1] , tree[v << 1 | 1]);
}

long long get(int v,int l,int r,int le,int ri) {
    relax(v , l , r);
    if (l > ri || r < le)return -inf;
    if (l >= le && r <= ri) return tree[v];
    int mid = (l + r) >> 1;
    return max(get(v << 1,l,mid,le,ri) , get(v << 1 | 1,mid + 1,r,le,ri));
}

vector< pair<int,long long> >att;
vector< pair< pair<int,int> , long long > >mon;

int main() {
    FAST_READ;
    build(1 ,1 , 1000000);
    cin>>n>>m>>p;
    att.resize(n);
    for (int i = 0;i<n;i++)cin>>att[i].F>>att[i].S;
    sort(att.begin(),att.end());
    for (int i = 0;i<m;i++) {
        int x,y;
        cin>>x>>y;
        if (x != 1)update(1 , 1 , 1000000 , 1 , x - 1 , -y , 1);
    }
    mon.resize(p);
    for (int i = 0;i<p;i++)cin>>mon[i].F.F>>mon[i].F.S>>mon[i].S;
    sort(mon.begin(),mon.end());
    int moni = 0;
    long long res = -inf;
    for (int i = 0;i<n;i++) {
        while (moni < p && mon[moni].F.F < att[i].F) {
            update(1 , 1 , 1000000 , mon[moni].F.S , 1000000 , mon[moni].S , 0);
            moni++;
        }
        res = max(res , get(1 , 1 , 1000000 ,1 , 1000000) - att[i].S);
    }
    cout<<res<<endl;
}
