#include <bits/stdc++.h>
#define ios ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
#define rall(v) v.rbegin(),v.rend()
#define all(v) v.begin(),v.end()
#define pb push_back
#define sz size()
#define fi first
#define se second
#define forn(i,a,b) for(int (i)=int(a);i<=int(b);++i)
#define form(i,a,b) for(int (i)=int(a);i>=int(b);--i)
#define dep(x) cout<<"{"<<x.fi<<", "<<x.se<<"} ";
using namespace std;
const int N = 1e6 + 66;
const int LG = 24;
const int M = 3e3 + 33;
const int mod = 1e9 + 7;
const int inf = 2e9;
const long long INF = 2e17;

long long t[N * 4], val[N], p[N * 4];

void build (int l = 0, int r = N, int v = 0) {
    if (r - l == 1) {
        t[v] = val[l];
        return;
    }
    int m = (l + r) / 2;
    build (l, m, v + v + 1), build (m, r, v + v + 2);
    t[v] = max (t[v + v + 1], t[v + v + 2]);
}
void push (int v, int l, int r) {
    t[v] += p[v];
    if (r - l == 1) {
        p[v] = 0;
        return;
    }
    p[v + v + 1] += p[v];
    p[v + v + 2] += p[v];
    p[v] = 0;
}
long long get (int L, int R, int l = 0, int r = N, int v = 0) {
    push (v, l, r);
    if (L <= l && r <= R) {
        return t[v];
    }
    if (r <= L || R <= l) {
        return -INF;
    }
    int m = (l + r) / 2;
    return max(get (L, R, l, m, v + v + 1), get (L, R, m, r, v + v + 2));
}
void upd (int L, int R, long long val, int l = 0, int r = N, int v = 0) {
    if (L <= l && r <= R) {
        p[v] += val;
        push (v, l, r);
        return;
    }
    if (r <= L || R <= l) {
            return;
    }
    int m = (l + r) / 2;
    upd (L, R, val, l, m, v + v + 1), upd (L, R, val, m, r, v + v + 2);
    t[v] = max (t[v + v + 1], t[v + v + 2]);
}

long long mn[N], mx[N], x[N], y[N], z[N];

pair <long long, long long> a[N], b[N];

vector <pair <long long, long long>> add[N];

int main () {
   ios;
    int n, m, p;
    cin >> n >> m >> p;
    set <int> xs;
    for (int i = 0 ; i < N ; ++ i) {
        mn[i] = INF;
        mx[i] = -INF;
    }
    for (int i = 1 ; i <= n ; ++ i) {
        cin >> a[i].fi >> a[i].se;
        mn[a[i].fi] = min (mn[a[i].fi], a[i].se);
        xs.insert (a[i].fi);
    }
    sort (a + 1, a + 1 + n);
    for (int i = 1 ; i <= m ; ++ i) {
        cin >> b[i].fi >> b[i].se;
    }
    sort (b + 1, b + 1 + m);
    for (int i = 1 ; i <= m ; ++ i) {
        val[i] = -b[i].se;
    }
    build ();
    for (int i = 1 ; i <= p ; ++ i) {
        cin >> x[i] >> y[i] >> z[i];
        xs.insert (x[i]);
        add[x[i]].pb ({y[i], z[i]});
    }
    long long res = -INF;
    for (auto x : xs) {
        long long cost = mn[x];
        res = max (res, get (1, m + 1) - cost);
        for (auto p : add[x]) {
            pair <long long, long long> izd = {p.first + 1, -INF};
            int st = lower_bound (b + 1, b + 1 + m, izd) - b;
            upd (st, N, p.second);
        }
    }
    cout << res;
}






