#include <bits/stdc++.h>

using namespace std;

#define endl '\n'
#define debug(x) cerr<<#x<<"="<<(x)<<'\n'
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define print(x, T) copy(all(x), ostream_iterator<T>(cout, " ")); cout << endl
#define mp make_pair
#define mt make_tuple
#define pb push_back
#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define for1(i, n) for (int i = 1; i <= (int)(n); ++i)
#define ford(i, n) for (int i = (int)(n); i >= 0; --i)
#define fore(i, a, b) for (int i = (int)(a); i <= (int)(b); ++i)

typedef pair<int, int> pii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<pii> vpi;
typedef long long ll;
typedef long double ld;
typedef vector<ll> vll;

template<class T> bool smin(T &a, T b) { return a > b ? (a = b, true) : false; }
template<class T> bool smax(T &a, T b) { return a < b ? (a = b, true) : false; }

int n;
int ans;
string s;

void del(int i, vector<pair<char, char>> &b) {
    if (i > 0) b[i - 1].second = b[i].second;
    if (i < n - 1) b[i + 1].first = b[i].first;
}

void solve(set<int> pos, vector<pair<char, char>> b) {
    smax(ans, n - (int)pos.size());
    for (int p : pos) {
        char prev = s[p] - 1;
        if (b[p].first == prev || b[p].second == prev) {
            set<int> tmp = pos;
            tmp.erase(p);
            auto tmp1 = b;
            del(p, tmp1);
            solve(tmp, tmp1);
        }
    }
}

int main()
{
    ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cout.precision(10);
	cout << fixed;
#ifndef ONLINE_JUDGE
	freopen("input.txt", "rt", stdin);
#endif

    cin >> n;
    cin >> s;

    vector<pair<char, char>> b(n, {-1, -1});
    forn(i, n) {
        if (i > 0) b[i].first = s[i - 1];
        if (i < n - 1) b[i].second = s[i + 1];
    }
    set<int> start;
    forn(i, n) start.insert(i);
    solve(start, b);
    cout << ans << endl;


#ifndef ONLINE_JUDGE;
	cerr << "Time elapsed: " << 1.0 * clock() / CLOCKS_PER_SEC << " s.\n";
#endif
    return 0;
}
