#include <bits/stdc++.h>

typedef long long ll;

#define fr first
#define sc second
#define pii pair <int, int>
#define eb emplace_back

using namespace std;

bool comp1(vector <int> a, vector <int> b) {
    return a[0] < b[0];
}

bool comp2(vector <int> a, vector <int> b) {
    return a[1] < b[1];
}

bool comp3(vector <int> a, vector <int> b) {
    return a[3] < b[3];
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int n, m, k;
    cin >> n >> m >> k;
    vector <pii> a(n), b(m);
    vector <vector <int>> c(k, vector <int> (4));
    for (int i = 0; i < n; i++) cin >> a[i].fr >> a[i].sc;
    for (int i = 0; i < m; i++) cin >> b[i].fr >> b[i].sc;
    for (int i = 0; i < k; i++) {
        for (int j = 0; j < 3; j++) cin >> c[i][j];
        c[i][3] = i;
    }
    sort(a.begin(), a.end());
    sort(b.begin(), b.end());
    vector <set <int>> get1(n), get2(m);
    sort(c.begin(), c.end(), comp1);
    int go = 0;
    for (int i = 0; i < n; i++) {
        if (i > 0) get1[i] = get1[i - 1];
        while (go < k && c[go][0] < a[i].fr)  get1[i].insert(c[go][3]), go++;
    }
    sort(c.begin(), c.end(), comp2);
    go = 0;
    for (int i = 0; i < m; i++) {
        if (i > 0) get2[i] = get2[i - 1];
        while (go < k && c[go][1] < b[i].fr)  get2[i].insert(c[go][3]), go++;
    }
    sort(c.begin(), c.end(), comp3);
    ll ans = -1e9;
    for (int i = 0; i < n; i++) {
        int l = 0, r = m;
        while (r - l > 1) {
            int mm = (r + l) / 2;
            int cst = 0;
            for (auto now : get1[i]) if (get2[mm].find(now) != get2[mm].end()) cst += c[now][2];
            if (cst - b[mm].sc - a[i].sc > ans) l = mm;
            else r = mm;
            ans = max(ans, 1ll * cst - b[mm].sc - a[i].sc);
        }
    }
    cout << ans;
    return 0;
}
