
/*
Буду очень признателен за взлом :)
*/

#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <assert.h>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <stack>
#include <cmath>

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define pb push_back
#define int long long

const int INF = 2e10;
const int MOD = 1e9 + 7;

using namespace std;

struct SegmentTree{
	vector<int> t, lazy;
	int n;
	SegmentTree(int x, vector<int>& a){
		n = x;
		t.resize(n << 2);
		lazy.resize(n << 2);
		build(1, 0, n, a);
	}

	void build(int v, int l, int r, vector<int>& a){
		if(l + 1 == r){
			t[v] = a[l];
			return;
		}

		int m = (l + r) >> 1;
		int vl = v << 1;
		int vr = vl + 1;

		build(vl, l, m, a);
		build(vr, m, r, a);

		t[v] = max(t[vl], t[vr]);
		int x =0 ;
	}

	void push(int v, int vl, int vr){
		lazy[vl] += lazy[v];
		lazy[vr] += lazy[v];
		lazy[v] = 0;
	}

	int get(int v){
		return t[v] + lazy[v];
	}

	int start, end, value;

	void update(int l, int r, int v){
		start = l;
		end = r + 1;
		value = v;
		updateSeg(1, 0, n);
	}

	void updateSeg(int v, int l, int r){
		if(start <= l && r <= end){	
			lazy[v] += value;
			return;
		}

		int m = (l + r) >> 1;
		int vl = v << 1;
		int vr = vl + 1;

		push(v, vl, vr);

		if(start < m) updateSeg(vl, l, m);
		if(m < end) updateSeg(vr, m, r);

		t[v] = max(get(vl), get(vr));
	}

	int getMax(){
		return get(1);
	}
};

int bs(int w, int m, vector<pair<int, int>>& b){
	int l = -1;
	int r = m;
	while(r - l > 1){
		int mid = (l + r) >> 1;
		if(b[mid].first > w) r = mid;
		else l = mid;
	}
	return r;
}

void solve(){
	int n, m, p;
	cin >> n >> m >> p;
	vector<pair<int, int>> a(n);
	vector<pair<int ,int>> b(m);
	vector<pair<pair<int, int>, int>> c(p);
	for(int i =0;i<n;i++){
		cin >> a[i].first >> a[i].second;
	}
	for(int i = 0;i<m;i++){
		cin >> b[i].first >> b[i].second;
	}
	for(int i = 0;i<p;i++){
		cin >> c[i].first.first >> c[i].first.second >> c[i].second;
	}

	sort(all(a));
	sort(all(b));
	sort(all(c));

	vector<int> help(m);
	for(int i = 0;i<m;i++){
		help[i] = -b[i].second;
	}

	SegmentTree tree(m, help);

	int ans = -INF;
	int id = 0;
	for(int i = 0;i<n;i++){
		int cost = a[i].second;
		while(id < p && c[id].first.first < a[i].first){
			int w = c[id].first.second;
			int cost1 = c[id].second;
			int id1 = bs(w, m, b);
			if(id1 != m) tree.update(id1, m - 1, cost1);
			id++;
		}
		ans = max(ans, tree.getMax() - cost);
	}
	cout << ans;
}

signed main(){
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	solve();
}

/*
Не забываем про претесты!!!
Рассматриваем все частные случаи!!!
Получаем призера!!!
*/