#include <bits/stdc++.h>
using namespace std;
#define int long long
const int INF = 100000000;

void solve() {
    int n, m;
    cin >> n >> m;
    vector <vector <int>> w(n);
    vector <vector <int>> wr(n);
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        w[u].push_back(v);
        wr[v].push_back(u);
    }
    int k;
    cin >> k;
    vector <int> path(k);
    for (auto& i : path) cin >> i, --i;
    vector <int> d1(n, INF), d2(n, INF);
    deque <int> st;
    d1[path[0]] = 0, d2[path.back()] = 0;
    st.push_back(path[0]);
    while (!st.empty()) {
        int u = st.front();
        st.pop_front();
        for (auto& v : w[u]) {
            if (d1[v] > d1[u] + 1) {
                d1[v] = d1[u] + 1;
                st.push_back(v);
            }
        }
    }
    st.push_back(path.back());
    while (!st.empty()) {
        int u = st.front();
        st.pop_front();
        for (auto& v : wr[u]) {
            if (d2[v] > d2[u] + 1) {
                d2[v] = d2[u] + 1;
                st.push_back(v);
            }
        }
    }
    int from = path[0], len = 1;
    int mn = 0;
    for (auto& u : path) {
        if (u == path[0]) continue;
        if (d2[u] + len > d2[from]) {
            from = u;
            len = 1;
            ++mn;
        } else {
            ++len;
        }
    }
    cout << mn << " ";
    int mx = 0;
    for (int i = 0; i + 1 < path.size(); ++i) {
        int u = path[i], v = path[i + 1];
        int fl = 0;
        for (auto& V : w[u]) if (V != v && d2[V] <= d2[v]) fl = 1;
        mx += fl;
    }
    cout << mx;
}

int32_t main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#ifdef _LOCAL
    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
#endif
    int test = 1;
//    cin >> t;
    while (test--) {
        solve();
    }
}