#include <bits/stdc++.h>
using namespace std;
#define int long long
const int INF = 100000000;

struct npc {
    int a, b;
    int price;
};

void reduce(vector<pair <int, int>>& a) {
    vector <pair <int, int>> ans;
    sort(a.begin(), a.end());
    for (auto& i : a) {
        while (!ans.empty() && i.second < ans.back().second) {
            ans.pop_back();
        }
        ans.push_back(i);
    }
    a = ans;
}

int ans = -1000000000;
vector <pair <int, int>> a, b;
vector <npc> c;

int get_price(int i, int j) {
    int price = -a[i].second - b[j].second;
    for (auto& u : c) {
        if (a[i].first >= u.a && b[j].first >= u.b) {
            price += u.price;
        }
    }
    return price;
}

void solve(int l, int r, int _l, int _r) {
    int mid = (l + r) / 2;
    int kopt = _l, kans = -1000000000;
    for (int k = _l; k <= _r; ++k) {
        int to = get_price(mid, k);
        if (to > kans) {
            kans = to;
            kopt = k;
        }
    }
    ans = max(ans, kans);
    if (l < mid) solve(l, mid - 1, _l, kopt);
    if (mid < r) solve(mid + 1, r, kopt, _r);
}

void solve() {
    int n, m, p;
    cin >> n >> m >> p;
    a.resize(n);
    b.resize(m);
    c.resize(p);
    for (auto& i : a) cin >> i.first >> i.second;
    for (auto& i : b) cin >> i.first >> i.second;
    for (auto& i : c) {
        cin >> i.a >> i.b >> i.price;
        ++i.a;
        ++i.b;
    }
    reduce(a);
    reduce(b);
    solve(0, n - 1, 0, m - 1);
    cout << ans;
}

int32_t main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#ifdef _LOCAL
    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
#endif
    int test = 1;
//    cin >> t;
    while (test--) {
        solve();
    }
}